VERSION 5.00
Object = "{F9043C88-F6F2-101A-A3C9-08002B2F49FB}#1.2#0"; "Comdlg32.ocx"
Begin VB.Form FileDialog2 
   BorderStyle     =   3  'Fixed Dialog
   Caption         =   "FileDialog"
   ClientHeight    =   3195
   ClientLeft      =   2760
   ClientTop       =   3750
   ClientWidth     =   6030
   LinkTopic       =   "Form1"
   MaxButton       =   0   'False
   MinButton       =   0   'False
   ScaleHeight     =   3195
   ScaleWidth      =   6030
   ShowInTaskbar   =   0   'False
   Begin MSComDlg.CommonDialog CommonDialog1 
      Left            =   480
      Top             =   360
      _ExtentX        =   847
      _ExtentY        =   847
      _Version        =   393216
   End
   Begin VB.CommandButton CancelButton 
      Caption         =   "Cancel"
      Height          =   375
      Left            =   4680
      TabIndex        =   1
      Top             =   960
      Width           =   1215
   End
   Begin VB.CommandButton OKButton 
      Caption         =   "OK"
      Height          =   375
      Left            =   4680
      TabIndex        =   0
      Top             =   480
      Width           =   1215
   End
   Begin VB.Label SDMLogo 
      Alignment       =   2  'Center
      Appearance      =   0  'Flat
      BackColor       =   &H0000C000&
      BorderStyle     =   1  'Fixed Single
      Caption         =   "ArcSDM3"
      BeginProperty Font 
         Name            =   "Roman"
         Size            =   14.25
         Charset         =   255
         Weight          =   700
         Underline       =   0   'False
         Italic          =   -1  'True
         Strikethrough   =   0   'False
      EndProperty
      ForeColor       =   &H0080FFFF&
      Height          =   375
      Left            =   4440
      TabIndex        =   2
      Top             =   0
      Width           =   1335
   End
End
Attribute VB_Name = "FileDialog2"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False

Option Explicit
Const c_sModuleFileName As String = "C:\MyJava\ARC-SDM\Dialogs\FileDialog2.frm"


Public Function GetSaveFileName(tTitle As String, prjDir As String, tabFilename As String) As Variant
  On Error GoTo ErrorHandler

        Dim fileDlg As CommonDialog
10:     Set fileDlg = Me.CommonDialog1
11:     fileDlg.DialogTitle = tTitle
12:     fileDlg.initDir = prjDir
13:     fileDlg.fileName = tabFilename
        Dim fileExt As String
        Dim fs As Object
16:     Set fs = CreateObject("Scripting.FileSystemObject")
17:     fileExt = fs.GetExtensionName(tabFilename)
18:     fileDlg.DefaultExt = fileExt
        Select Case fileExt
        Case "dbf"
21:             fileDlg.Filter = "Database (*." & fileExt & ")|*." & fileExt
        Case "txt"
23:              fileDlg.Filter = "Text (*." & fileExt & ")|*." & fileExt
        Case "dta"
25:              fileDlg.Filter = "Neural Network (*." & fileExt & ")|*." & fileExt
        Case "tba", "out", "dat"
27:              fileDlg.Filter = "Logistic Regression (*." & fileExt & ")|*." & fileExt
        Case Else
29:              If Len(fileExt) = 0 Then
30:                 fileDlg.Filter = "Any (*.*)|*.*"
31:              Else
32:                 fileDlg.Filter = "? (*." & fileExt & ")|*." & fileExt
33:              End If
34:     End Select
35:     fileDlg.CancelError = True
36:     fileDlg.Flags = cdlOFNFileMustExist & cdlOFNOverwritePrompt
37:     fileDlg.ShowSave 'Display file dialog
38:     If Len(fileDlg.fileName) = 0 Then
39:             GetSaveFileName = Empty
                Exit Function
41:     End If

        Dim saveFilename As String
44:     saveFilename = fs.GetFileName(fileDlg.fileName)
        Dim outputDir As String
46:     outputDir = fs.getParentFolderName(fileDlg.fileName)
        Dim baseName As String
48:     baseName = fs.GetBaseName(fileDlg.fileName)
49:     If fs.FileExists(fileDlg.fileName) Then
            Dim pApp As IApplication
51:         Set pApp = New AppRef
            Dim pMxDoc As IMxDocument
53:         Set pMxDoc = pApp.Document
            Dim pMap As IMap
55:         Set pMap = pMxDoc.FocusMap
            Dim saTblColl As IStandaloneTableCollection
57:         Set saTblColl = pMap
            Dim saTable As IStandaloneTable
59:         Set saTable = WOETableUtils.FindStandAloneTableByName(baseName, pMap)
60:         If saTable Is Nothing Then
                'Not a standalone table
62:                 fs.DeleteFile fileDlg.fileName, True
63:             Else
                'Is a standalone table
                Dim saDataSet As IDataset
66:             Set saDataSet = saTable
                ' ++ Get the Display table from the layer
                Dim pTable As ITable
                Dim pDisplayTable As IDisplayTable
70:                 Set pDisplayTable = saTable
71:                 Set pTable = pDisplayTable.DisplayTable
72:                 If pTable Is Nothing Then
                    'Not joined
74:                 Else
                    'Is Joined!
76:                     If saDataSet.Workspace.PathName = outputDir Then _
                        WOETableUtils.UnJoinAll saTable
78:                 End If
79:             If saDataSet.Workspace.PathName = outputDir Then
80:                     fs.DeleteFile fileDlg.fileName, True
81:                 Else
82:                     MsgBox saTable.Name & " is not in same folder!"
83:                 End If
84:         End If
85:     End If
86:     Set fs = Nothing
87:     GetSaveFileName = Array(saveFilename, outputDir, False)

        Exit Function
ErrorHandler:
91:     If Err.Number = cdlCancel Then
92:         GetSaveFileName = Empty
        Exit Function
94:     End If
  HandleError True, "getSaveFileName " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), Err.Number, Err.Source, Err.Description, 4
96:   GetSaveFileName = Empty
End Function
Public Function GetReadFileName(tTitle As String, prjDir As String, tabFilename As String) As Variant
  On Error GoTo ErrorHandler

    Dim fileDlg As CommonDialog
102:     Set fileDlg = Me.CommonDialog1
103:     fileDlg.DialogTitle = tTitle
104:     fileDlg.initDir = prjDir
        Dim fileExt As String
106:     fileExt = FileDialog.GetFileExtension(tabFilename)
107:     fileDlg.DefaultExt = fileExt
108:     fileDlg.Filter = "Database (*." & fileExt & ")|*." & fileExt
109:     fileDlg.CancelError = True
110:     fileDlg.Flags = cdlOFNFileMustExist Or cdlOFNReadOnly
111:     fileDlg.fileName = tabFilename
112:     fileDlg.ShowOpen
113:     If Len(fileDlg.fileName) = 0 Then
114:         GetReadFileName = Empty
            Exit Function
116:     End If
        Dim fs As Object
118:     Set fs = CreateObject("Scripting.FileSystemObject")
119:         If Not FileDialog.ExistsFilename(fileDlg.fileName) Then
120:         GetReadFileName = Empty
            Exit Function
122:         End If
        Dim openFilename As String
124:     openFilename = fs.GetFileName(fileDlg.fileName)
        Dim inputDir As String
126:     inputDir = fs.getParentFolderName(fileDlg.fileName)
        Dim baseName As String
128:     baseName = fs.GetBaseName(fileDlg.fileName)
129:     Set fs = Nothing
130:     GetReadFileName = Array(openFilename, inputDir)

  Exit Function
ErrorHandler:
134:     If Err.Number = cdlCancel Then
135:         GetReadFileName = Empty
        Exit Function
137:     End If
  HandleError True, "getSaveDirForFileName " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), Err.Number, Err.Source, Err.Description, 4
139:   GetReadFileName = Empty
End Function
