VERSION 5.00
Begin VB.Form NNRetrain 
   BorderStyle     =   3  'Fixed Dialog
   Caption         =   "Neural Network Retraining"
   ClientHeight    =   4710
   ClientLeft      =   2760
   ClientTop       =   3750
   ClientWidth     =   8610
   LinkTopic       =   "Form1"
   MaxButton       =   0   'False
   MinButton       =   0   'False
   ScaleHeight     =   4710
   ScaleWidth      =   8610
   ShowInTaskbar   =   0   'False
   Begin VB.ComboBox cbx_dtp 
      Height          =   315
      Left            =   2280
      TabIndex        =   14
      Text            =   "<None>"
      ToolTipText     =   "Select a deposits training point layer"
      Top             =   720
      Width           =   3975
   End
   Begin VB.ComboBox cbx_NDTPFlds 
      Height          =   315
      Left            =   2280
      TabIndex        =   11
      Text            =   "<None>"
      ToolTipText     =   "Select a non-deposits fuzzy membership field, if any"
      Top             =   2160
      Width           =   3975
   End
   Begin VB.ComboBox cbx_DTPFlds 
      Height          =   315
      Left            =   2280
      TabIndex        =   10
      Text            =   "<None>"
      ToolTipText     =   "Select a deposits fuzzy membership field, if any"
      Top             =   1200
      Width           =   3975
   End
   Begin VB.Frame Frame1 
      Caption         =   "Explanation"
      Height          =   1215
      Left            =   120
      TabIndex        =   6
      Top             =   2760
      Width           =   6375
      Begin VB.TextBox Text1 
         Appearance      =   0  'Flat
         BorderStyle     =   0  'None
         Enabled         =   0   'False
         ForeColor       =   &H8000000D&
         Height          =   855
         Left            =   120
         MultiLine       =   -1  'True
         TabIndex        =   7
         Text            =   "NNRetrain.frx":0000
         Top             =   240
         Width           =   6135
      End
   End
   Begin VB.ComboBox cbx_ndtp 
      Height          =   315
      Left            =   2280
      TabIndex        =   3
      Text            =   "<None>"
      ToolTipText     =   "Select a non-deposits training points layer"
      Top             =   1680
      Width           =   3975
   End
   Begin VB.ComboBox cbx_UCs 
      Height          =   315
      Left            =   2280
      TabIndex        =   2
      Text            =   "<None>"
      ToolTipText     =   "Select an input unique conditions raster"
      Top             =   240
      Width           =   3975
   End
   Begin VB.CommandButton btn_Can 
      Caption         =   "Cancel"
      Height          =   375
      Left            =   3000
      TabIndex        =   1
      ToolTipText     =   "Do not continue processing"
      Top             =   4200
      Width           =   1215
   End
   Begin VB.CommandButton btn_OK 
      Caption         =   "OK"
      Height          =   375
      Left            =   1080
      TabIndex        =   0
      ToolTipText     =   "Continue with processing"
      Top             =   4200
      Width           =   1215
   End
   Begin VB.Label Label2 
      Alignment       =   1  'Right Justify
      Caption         =   "Deposits Training Points"
      Height          =   255
      Left            =   -360
      TabIndex        =   16
      ToolTipText     =   "Select a deposits training points layer"
      Top             =   720
      Width           =   2535
   End
   Begin VB.Label lbl_TPSel 
      Caption         =   "Label4"
      Height          =   255
      Left            =   6360
      TabIndex        =   15
      Top             =   720
      Width           =   2175
   End
   Begin VB.Label Label5 
      Alignment       =   1  'Right Justify
      Caption         =   "Fuzzy Membership Field"
      Height          =   255
      Left            =   120
      TabIndex        =   13
      Top             =   1200
      Width           =   2055
   End
   Begin VB.Label Label4 
      Alignment       =   1  'Right Justify
      Caption         =   "Fuzzy Membership Field"
      Height          =   255
      Left            =   120
      TabIndex        =   12
      Top             =   2160
      Width           =   2055
   End
   Begin VB.Label lbl_NTPSel 
      Caption         =   "Label4"
      Height          =   255
      Left            =   6360
      TabIndex        =   9
      Top             =   1680
      Width           =   2175
   End
   Begin VB.Label SDMLogo 
      Alignment       =   2  'Center
      Appearance      =   0  'Flat
      BackColor       =   &H0000C000&
      BorderStyle     =   1  'Fixed Single
      Caption         =   "ArcSDM3"
      BeginProperty Font 
         Name            =   "Roman"
         Size            =   14.25
         Charset         =   255
         Weight          =   700
         Underline       =   0   'False
         Italic          =   -1  'True
         Strikethrough   =   0   'False
      EndProperty
      ForeColor       =   &H0080FFFF&
      Height          =   375
      Left            =   5160
      TabIndex        =   8
      Top             =   4200
      Width           =   1335
   End
   Begin VB.Label Label3 
      Alignment       =   1  'Right Justify
      Caption         =   "Non-deposits Training Points"
      Height          =   255
      Left            =   -360
      TabIndex        =   5
      Top             =   1680
      Width           =   2535
   End
   Begin VB.Label Label1 
      Alignment       =   1  'Right Justify
      Caption         =   "Unique Conditions Raster"
      Height          =   255
      Left            =   -360
      TabIndex        =   4
      Top             =   240
      Width           =   2535
   End
End
Attribute VB_Name = "NNRetrain"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False

Option Explicit

Private pContinue As Boolean
' Variables used by the Error handler function - DO NOT REMOVE
Const c_sModuleFileName As String = "NNRetrain.frm"

Public Property Get Continue() As Boolean
9:     Continue = pContinue
End Property

Private Sub btn_Can_Click()
13:     pContinue = False
14:     Me.Visible = False
End Sub

Private Sub btn_OK_Click()
    'Continue processing
19:     pContinue = Not (Me.cbx_UCs.Text = "<None>" Or Me.cbx_dtp.Text = "<None>" Or Me.cbx_ndtp = "<None>")
20:     Me.Visible = False
End Sub

Private Sub cbx_dtp_Click()
        Dim TPlyr As IFeatureLayer
25:     Set TPlyr = WOETableUtils.FindLayerByName(Me.cbx_dtp)
        Dim featSel As IFeatureSelection
27:     Set featSel = TPlyr
28:     Me.lbl_TPSel.Caption = featSel.SelectionSet.Count & " selected"
29:     load_DTPFlds
30:     load_NDTPs
End Sub

Private Sub cbx_ndtp_Click()
        Dim NTPlyr As IFeatureLayer
35:     Set NTPlyr = WOETableUtils.FindLayerByName(Me.cbx_ndtp)
        Dim featSel As IFeatureSelection
37:     Set featSel = NTPlyr
38:     Me.lbl_NTPSel.Caption = featSel.SelectionSet.Count & " selected"
39:     load_NDTPFlds
End Sub


Private Sub Form_Initialize()
44:     pContinue = False
End Sub

Private Sub Form_Load()
48:     Me.Text1.Text = "- Select unique conditions raster (response raster)" & vbCrLf & _
                        "  and both types of training points to create new Neural Network input files." & vbCrLf & _
                        "- Pre-Set training point selections in the Analysis Parameters command." & vbCrLf & _
                        "- Verify selections in the Selection tab of the table of contents."
52:     load_UCs
53:     load_DTPs
54:     load_NDTPs
End Sub
Private Sub load_UCs()
        Dim getUCs As gSDI_GetUCThms
58:     Set getUCs = New gSDI_GetUCThms
        Dim ucThemes As SDMUtilities.SDMList
60:     If SDMGlobals.SDMMap Is Nothing Then SDMGlobals.SetGlobals
61:     Set ucThemes = getUCs.gSDI_GetUCThms(SDMGlobals.SDMMap)
62:     If Not ucThemes.IsEmpty Then
63:        Me.cbx_UCs.Clear
           Dim UC
65:        For Each UC In ucThemes.list
                Dim vTabUC As ITable
67:             Set vTabUC = WOETableUtils.FindLayerByName(CStr(UC))
                Dim saTbl As IStandaloneTable
69:             Set saTbl = WOETableUtils.FindStandAloneTableByName(UC & "_Tbl")
70:             If Not saTbl Is Nothing Then
71:                 If saTbl.Table.RowCount(Nothing) = vTabUC.RowCount(Nothing) Then
72:                     If saTbl.Table.FindField("TrngPoints") <> -1 Then
73:                         Me.cbx_UCs.AddItem UC
74:                     End If
75:                 End If
76:             End If
77:        Next UC
78:     Else
79:         Me.cbx_UCs.Text = "<None>"
80:     End If
81:     If Me.cbx_UCs.ListCount = 0 Then Me.cbx_UCs.Text = "<None>"
82:     Me.cbx_UCs.ListIndex = 0

End Sub
Private Sub load_DTPs()
  On Error GoTo ErrorHandler

         Dim pMap As IMap
89:     Set pMap = SDMGlobals.SDMMap
         Dim pUID As New UID
91:     pUID = "{E156D7E5-22AF-11D3-9F99-00C04F6BC78E}" 'geofeaturelayers
         Dim pLayers As IEnumLayer
93:     Set pLayers = pMap.layers(pUID, True)
         Dim flyr As IFeatureLayer
95:     Set flyr = pLayers.Next
         Dim flyrlist As New SDMUtilities.SDMList
97:     While Not flyr Is Nothing
98:         If flyr.FeatureClass.GetFeature(0).Shape.GeometryType = esriGeometryPoint Then flyrlist.Add (flyr.Name)
99:         Set flyr = pLayers.Next
100:     Wend
101:     If Not flyrlist.IsEmpty Then
102:        Me.cbx_dtp.Clear
            Dim fc
104:        For Each fc In flyrlist.list
105:            Me.cbx_dtp.AddItem fc
106:        Next fc
107:        Me.cbx_dtp.ListIndex = 0
108:     End If

  Exit Sub
ErrorHandler:
  HandleError False, "load_DTPs " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), Err.Number, Err.Source, Err.Description, 4
End Sub

Private Sub load_NDTPs()
  On Error GoTo ErrorHandler

         Dim pMap As IMap
119:     Set pMap = SDMGlobals.SDMMap
         Dim pUID As New UID
121:     pUID = "{E156D7E5-22AF-11D3-9F99-00C04F6BC78E}" 'geofeaturelayers
         Dim pLayers As IEnumLayer
123:     Set pLayers = pMap.layers(pUID, True)
         Dim flyr As IFeatureLayer
125:     Set flyr = pLayers.Next
         Dim flyrlist As New SDMUtilities.SDMList
127:     While Not flyr Is Nothing
128:         If flyr.FeatureClass.GetFeature(0).Shape.GeometryType = esriGeometryPoint Then
129:                 If flyr.Name <> Me.cbx_dtp.Text Then flyrlist.Add flyr.Name
130:         End If
131:         Set flyr = pLayers.Next
132:     Wend
133:     If Not flyrlist.IsEmpty Then
134:        Me.cbx_ndtp.Clear
            Dim fc
136:        For Each fc In flyrlist.list
137:            Me.cbx_ndtp.AddItem fc
138:        Next fc
139:        Me.cbx_ndtp.ListIndex = 0
140:     End If

  Exit Sub
ErrorHandler:
  HandleError False, "load_NDTPs " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), Err.Number, Err.Source, Err.Description, 4
End Sub

Private Sub load_DTPFlds()
  On Error GoTo ErrorHandler

     If Me.cbx_dtp.ListCount = 0 Then Exit Sub
     Dim flyr As IFeatureLayer
152: Set flyr = WOETableUtils.FindLayerByName(Me.cbx_dtp.Text)
     Dim flyrlist As New SDMUtilities.SDMList
154: Set flyrlist = getFieldsNamesByType(flyr, esriFieldTypeDouble, esriFieldTypeSingle)
155: Me.cbx_DTPFlds.Clear
156: flyrlist.Insert ("<None>")
     Dim fld
158: For Each fld In flyrlist.list
159:    Me.cbx_DTPFlds.AddItem fld
160: Next fld
161: If Me.cbx_dtp.ListCount > 0 Then Me.cbx_DTPFlds.ListIndex = 0
  Exit Sub
ErrorHandler:
  HandleError False, "load_DTPFlds " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), Err.Number, Err.Source, Err.Description, 4
End Sub

Private Sub load_NDTPFlds()
  On Error GoTo ErrorHandler
     
     If Me.cbx_ndtp.ListCount = 0 Then Exit Sub
     Dim flyr As IFeatureLayer
172: Set flyr = WOETableUtils.FindLayerByName(Me.cbx_ndtp.Text)
     Dim flyrlist As New SDMUtilities.SDMList
174: Set flyrlist = getFieldsNamesByType(flyr, esriFieldTypeDouble, esriFieldTypeSingle)
175: Me.cbx_NDTPFlds.Clear
176: flyrlist.Insert ("<None>")
     Dim fld
178: For Each fld In flyrlist.list
179:    Me.cbx_NDTPFlds.AddItem fld
180: Next fld
181: If Me.cbx_ndtp.ListCount > 0 Then Me.cbx_NDTPFlds.ListIndex = 0
  Exit Sub
ErrorHandler:
  HandleError False, "load_NDTPFlds " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), Err.Number, Err.Source, Err.Description, 4
End Sub

Private Function getFieldsNamesByType(ByRef tbl As ITable, fldType1 As esriFieldType, fldtype2 As esriFieldType) As SDMList
  On Error GoTo ErrorHandler

190:     Set getFieldsNamesByType = New SDMList
         Dim nf As Long
192:     For nf = 0 To tbl.Fields.FieldCount - 1
193:         If tbl.Fields.Field(nf).Type = fldType1 Or tbl.Fields.Field(nf).Type = fldtype2 Then _
                getFieldsNamesByType.Add tbl.Fields.Field(nf).Name
195:     Next nf
  Exit Function
ErrorHandler:
  HandleError True, "getStringFieldsNamesbyType " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), Err.Number, Err.Source, Err.Description, 4
End Function


