VERSION 5.00
Begin VB.Form QryPopup 
   Caption         =   "Query"
   ClientHeight    =   3135
   ClientLeft      =   165
   ClientTop       =   855
   ClientWidth     =   4680
   KeyPreview      =   -1  'True
   LinkTopic       =   "Form1"
   ScaleHeight     =   3135
   ScaleWidth      =   4680
   StartUpPosition =   3  'Windows Default
   Begin VB.Menu QryDefMenu 
      Caption         =   "Query Definition"
      WindowList      =   -1  'True
      Begin VB.Menu Fldnames 
         Caption         =   "Evidence field names"
      End
      Begin VB.Menu Qryops 
         Caption         =   "Query operators"
      End
      Begin VB.Menu Fldvals 
         Caption         =   "Evidence field values"
      End
   End
End
Attribute VB_Name = "QryPopup"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit
' Variables used by the Error handler function - DO NOT REMOVE
Const c_sModuleFileName As String = "QryPopup.frm"
Dim etTbl As ITable
Dim etFldName As String

Private Sub fldnames_Click()
  On Error GoTo ErrorHandler

        Dim lstdlg As IListDialog
11:     Set lstdlg = New ListDialog
12:     setETTbl
        Dim etFlds As IFields
14:     Set etFlds = etTbl.Fields
        Dim names() As Variant
        ReDim names(etFlds.FieldCount - 1)
        Dim i As Integer
18:     For i = 0 To etFlds.FieldCount - 1
19:         names(i) = etFlds.Field(i).Name
20:     Next i
        Dim op As Variant
22:     For Each op In names
23:         lstdlg.AddString op
24:     Next op
25:     If lstdlg.DoModal("Evidence field names", 0, 0) Then
26:         If gGrp.tbx_Qst.Text <> "" Then
27:             gGrp.tbx_Qst.Text = gGrp.tbx_Qst.Text & " """ & names(lstdlg.Choice) & """"
28:         Else
29:             gGrp.tbx_Qst.Text = """" & names(lstdlg.Choice) & """"
30:         End If
31:     End If
32:     etFldName = names(lstdlg.Choice)
33:     gGrp.ZOrder 0
    Exit Sub
ErrorHandler:
    HandleError False, "fldnames_Click " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), Err.Number, Err.Source, Err.Description, 4
    End Sub
    
    Private Sub fldvals_Click()
40:     setETTbl
        Dim fldIdx As Long
42:     fldIdx = etTbl.FindField(etFldName)
        Dim curs As ICursor
44:     Set curs = etTbl.Search(Nothing, True)
        Dim rw As IRow
46:     Set rw = curs.NextRow
        Dim ValList As New SDMList
48:     While Not rw Is Nothing
49:         ValList.Add rw.Value(fldIdx)
50:         Set rw = curs.NextRow
51:     Wend
52:     Set ValList = ValList.RemoveDuplicates
53:     Set ValList = ValList.Sort(True)
        Dim lstdlg As IListDialog
55:     Set lstdlg = New ListDialog
        Dim val As Variant
57:     For Each val In ValList.list
58:         lstdlg.AddString val
59:     Next val
60:     If lstdlg.DoModal("Values", 0, 0) Then _
        gGrp.tbx_Qst.Text = gGrp.tbx_Qst.Text & " " & ValList.GetVal(lstdlg.Choice)
62:     gGrp.ZOrder 0

End Sub

Private Sub Qryops_Click()
    Dim lstdlg As IListDialog
68: Set lstdlg = New ListDialog
    Dim ops As Variant
    Dim op As Variant
71: ops = Array("NOT", "(", ")", "=", "<", "<=", ">", ">=", "<>", "LIKE", "IS")
72: For Each op In ops
73:         lstdlg.AddString op
74: Next op
75: If lstdlg.DoModal("Operators", 0, 0) Then _
    gGrp.tbx_Qst.Text = gGrp.tbx_Qst.Text & " " & ops(lstdlg.Choice)
77:     gGrp.ZOrder 0

End Sub

Private Sub setETTbl()
        Dim etName As String
83:     etName = gGrp.txt_Evt.Caption
        Dim eTheme As IRasterLayer
85:     Set eTheme = SDMGlobals.SDMUtil.FindLayerByName(etName)
        Dim dispTbl As IDisplayTable
87:         Set dispTbl = eTheme
88:     Set etTbl = dispTbl.DisplayTable
End Sub

