VERSION 5.00
Begin VB.Form gCht 
   Caption         =   "Create chart...."
   ClientHeight    =   6750
   ClientLeft      =   0
   ClientTop       =   0
   ClientWidth     =   4155
   LinkTopic       =   "gCht1"
   ScaleHeight     =   6750
   ScaleWidth      =   4155
   StartUpPosition =   2  'CenterScreen
   WhatsThisButton =   -1  'True
   WhatsThisHelp   =   -1  'True
   Begin VB.CommandButton lbt_Mke 
      Caption         =   "Make Chart"
      Height          =   405
      Left            =   120
      TabIndex        =   8
      ToolTipText     =   "Generates chart. (Shift-click for help.)"
      Top             =   6240
      Width           =   1215
   End
   Begin VB.CommandButton lbt_Can 
      Caption         =   "Cancel"
      Height          =   405
      Left            =   1440
      TabIndex        =   9
      Top             =   6240
      Width           =   1215
   End
   Begin VB.Frame aControlPanel10 
      Caption         =   "What to Chart"
      Height          =   2505
      Left            =   240
      TabIndex        =   4
      Top             =   3480
      Width           =   3510
      Begin VB.ListBox lbx_Wtc 
         Height          =   1815
         Left            =   360
         MultiSelect     =   2  'Extended
         TabIndex        =   5
         ToolTipText     =   "Select the numeric field(s) with values you want to chart."
         Top             =   360
         Width           =   2775
      End
   End
   Begin VB.Frame aControlPanel1 
      Caption         =   "Chart Title"
      Height          =   765
      Left            =   240
      TabIndex        =   6
      Top             =   1200
      Width           =   3510
      Begin VB.TextBox txl_Tle 
         Height          =   300
         Left            =   120
         TabIndex        =   7
         ToolTipText     =   "Enter a title for the new chart document (optional)."
         Top             =   240
         Width           =   3285
      End
   End
   Begin VB.Frame aControlPanel17 
      Caption         =   "Table/Class Field"
      Height          =   1050
      Left            =   240
      TabIndex        =   0
      Top             =   0
      Width           =   3495
      Begin VB.ComboBox cbx_Cfd 
         Height          =   315
         Left            =   120
         Style           =   2  'Dropdown List
         TabIndex        =   2
         ToolTipText     =   "Select the field containing classes to chart."
         Top             =   600
         Width           =   3255
      End
      Begin VB.ComboBox cbx_Tab 
         Height          =   315
         Left            =   120
         Sorted          =   -1  'True
         Style           =   2  'Dropdown List
         TabIndex        =   1
         ToolTipText     =   "Select table on which to base the chart."
         Top             =   240
         Width           =   3255
      End
   End
   Begin VB.Frame aControlPanel7 
      Caption         =   "Chart Type"
      Height          =   1365
      Left            =   240
      TabIndex        =   3
      Top             =   2040
      Width           =   3510
      Begin VB.Frame Frame1 
         Height          =   975
         Left            =   120
         TabIndex        =   11
         Top             =   240
         Width           =   1095
         Begin VB.OptionButton rbt_Bar 
            Caption         =   "Bar"
            Height          =   420
            Left            =   240
            TabIndex        =   13
            ToolTipText     =   "Specifies a bar style chart."
            Top             =   480
            Width           =   825
         End
         Begin VB.OptionButton rbt_Lin 
            Caption         =   "Line"
            Height          =   420
            Left            =   240
            TabIndex        =   12
            ToolTipText     =   "Specifies a line style chart."
            Top             =   120
            Width           =   825
         End
      End
      Begin VB.Frame Frame2 
         Height          =   975
         Left            =   1320
         TabIndex        =   10
         Top             =   240
         Width           =   1935
         Begin VB.OptionButton rad_Mpl 
            Caption         =   "Multiple Themes"
            Height          =   420
            Left            =   120
            TabIndex        =   15
            ToolTipText     =   "Generates chart based on weights of evidence multi-theme weights table. (Shift-click for help.)"
            Top             =   465
            Width           =   1605
         End
         Begin VB.OptionButton rad_One 
            Caption         =   "Single Theme"
            Height          =   420
            Left            =   120
            TabIndex        =   14
            ToolTipText     =   "Specifies plotting variables for a single theme."
            Top             =   120
            Width           =   1635
         End
      End
   End
   Begin VB.Label SDMLogo 
      Alignment       =   2  'Center
      Appearance      =   0  'Flat
      BackColor       =   &H0000C000&
      BorderStyle     =   1  'Fixed Single
      Caption         =   "ArcSDM3"
      BeginProperty Font 
         Name            =   "Roman"
         Size            =   14.25
         Charset         =   255
         Weight          =   700
         Underline       =   0   'False
         Italic          =   -1  'True
         Strikethrough   =   0   'False
      EndProperty
      ForeColor       =   &H0080FFFF&
      Height          =   375
      Left            =   2760
      TabIndex        =   16
      Top             =   6240
      Width           =   1335
   End
End
Attribute VB_Name = "gCht"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit

Private Listeners As SDMListeners
Private WithEvents aCtl As SDMListeners
Attribute aCtl.VB_VarHelpID = -1
Const c_sModuleFileName As String = "gCht.frm"
Private gParamfrm As Variant
Private shiftDown As Boolean

Public Property Get isShiftdown() As Boolean
  On Error GoTo ErrorHandler
11:     isShiftdown = shiftDown
12:     shiftDown = False
  Exit Property
ErrorHandler:
  HandleError True, "isShiftdown " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), Err.Number, Err.Source, Err.Description, 4
End Property

Public Property Get gParam() As Variant
19:    Set gParam = gParamfrm
End Property

Public Property Get getEars() As SDMListeners
  On Error GoTo ErrorHandler
24:     Set getEars = Listeners
  Exit Property
ErrorHandler:
  HandleError True, "getEars " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), Err.Number, Err.Source, Err.Description, 4
End Property

Private Sub Form_KeyDown(KeyCode As Integer, Shift As Integer)
  On Error GoTo ErrorHandler
32:     shiftDown = (Shift And vbShiftMask) > 0
  Exit Sub
ErrorHandler:
  HandleError True, "Form_KeyDown " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), Err.Number, Err.Source, Err.Description, 4
End Sub

Private Sub cbx_Tab_Click()
'gCht.cbx_Tab.Select
40:     Me.getEars.BroadcastUpdate Me.cbx_Tab
End Sub

Private Sub Form_KeyUp(KeyCode As Integer, Shift As Integer)
44:     shiftDown = False
End Sub

Private Sub Form_Load()
  On Error GoTo ErrorHandler

50:     Set Listeners = New SDMListeners
51:     Set aCtl = Listeners
52:    If SDMGlobals.SDMApp Is Nothing Then Set SDMGlobals.SDMApp = New AppRef
53:    If SDMGlobals.SDMDoc Is Nothing Then Set SDMGlobals.SDMDoc = SDMGlobals.SDMApp.Document
54:    If SDMGlobals.SDMUtil Is Nothing Then Set SDMGlobals.SDMUtil = New SDMUtilities.SDMUtils
55:    If SDMGlobals.SDMStatusBar Is Nothing Then Set SDMGlobals.SDMStatusBar = SDMGlobals.SDMApp.StatusBar
56:     If SDMGlobals.SDMHelp Is Nothing Then Set SDMGlobals.SDMHelp = New gSDI_Help
57:     If SDMGlobals.SDMWorkspace Is Nothing Then _
            Set SDMGlobals.SDMWorkspace = SDMGlobals.SDMUtil.openShapeFileWorkspace( _
            GetSetting("SDMExtension", "AnalysisParameters", "WorkSpace", Environ("TEMP")))
60:     shiftDown = False
    Dim gChtOpen As gCht_Open
62:     Set gChtOpen = New gCht_Open
63:     gChtOpen.gCht_Open
64:     Set gChtOpen = Nothing
  Exit Sub
ErrorHandler:
  HandleError True, "Form_Load " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), Err.Number, Err.Source, Err.Description, 4
End Sub

Private Sub lbx_Wtc_Click()
71:     Me.getEars.BroadcastUpdate Me.lbx_Wtc
End Sub

Private Sub rad_Mpl_Click()
 'gCht.rad_Mpl.Click
76:  If (isShiftdown) Then
    Dim docURL As String
78:     docURL = "sdmchart.htm#Type"
79:     SDMGlobals.SDMHelp.gSDI_Help docURL
    Exit Sub
81:  End If
82:  Me.rbt_Bar.Value = True
End Sub
Private Sub lbt_Mke_Click()
 'gSDI.MakeLineChart
 Dim gSDIMakeLineChart As gSDI_MakeLineChart
87:  Set gSDIMakeLineChart = New gSDI_MakeLineChart
88:  gSDIMakeLineChart.gSDI_MakeLineChart
89:  Set gSDIMakeLineChart = Nothing
End Sub

Private Sub lbt_Can_Click()
  On Error GoTo ErrorHandler

'Grph.lbt_Can.Click
96: If (isShiftdown) Then
    Dim docURL As String
98:     docURL = "sdmchart.htm"
99:         SDMGlobals.SDMHelp.gSDI_Help docURL
    Exit Sub
101: End If

103: Me.cbx_Tab.Clear
104: Me.cbx_Cfd.Clear
'me.cbx_Fld.clear

107: Unload Me

  Exit Sub
ErrorHandler:
  HandleError True, "lbt_Can_Click " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), Err.Number, Err.Source, Err.Description, 4
End Sub

Public Sub aCtl_UpdateEvt(ByRef ctl As Object)
    On Error GoTo ErrorHandler
    Select Case (ctl.Name)
    Case Me.cbx_Cfd.Name
        If (Me.cbx_Tab.Text = "Select one") Then Exit Sub
119:         If (Me.cbx_Tab.Enabled) Then
120:             Me.cbx_Cfd.Clear
            Dim tabname As String
122:             tabname = Me.cbx_Tab.Text
            Dim theTbl As IStandaloneTable
124:             Set theTbl = SDMUtil.FindStandAloneTableByName(tabname)
            Dim fldIdx As Long
126:             For fldIdx = 0 To theTbl.Table.Fields.FieldCount - 1
                    Dim fld As IField
128:                     Set fld = theTbl.Table.Fields.Field(fldIdx)
129:                     If (fld.Type <> esriFieldTypeString And _
                        fld.Type <> esriFieldTypeOID) Then _
                            Me.cbx_Cfd.AddItem fld.AliasName
132:             Next fldIdx
133:             Me.cbx_Cfd.Enabled = True
134:                  Me.cbx_Cfd.ListIndex = 0
135:         Else
136:             Me.cbx_Cfd.Enabled = False
137:         End If
    Case Me.cbx_Tab.Name
        'gCht.cbx_Tab.Update
            Dim gChtCbxTabUpdate As gCht_cbx_Tab_Update
141:             Set gChtCbxTabUpdate = New gCht_cbx_Tab_Update
142:             gChtCbxTabUpdate.gCht_cbx_Tab_Update
143:             Set gChtCbxTabUpdate = Nothing
    Case Me.lbt_Mke.Name
        'gCht.lbt_Mke.update
        If (Me.cbx_Tab.Text = "Select one") Then
            Me.lbt_Mke.Enabled = False
        Else
            Me.lbt_Mke.Enabled = (Me.lbx_Wtc.SelCount > 0)
        End If
    Case Me.lbx_Wtc.Name
        'gcht.lbx_Wtc.Update
            If (Me.cbx_Tab.Text = "Select one") Then Exit Sub
151:        If (Me.cbx_Tab.Enabled) Then
152:             Me.lbx_Wtc.Clear
            'Dim tabName As String
154:             tabname = Me.cbx_Tab.Text
            'Dim theTbl As IStandaloneTable
156:             Set theTbl = SDMUtil.FindStandAloneTableByName(tabname)
            'Dim fldidx As Long
158:             For fldIdx = 0 To theTbl.Table.Fields.FieldCount - 1
                    'Dim fld As IField
160:                     Set fld = theTbl.Table.Fields.Field(fldIdx)
161:                     If (fld.Type <> esriFieldTypeString And _
                        fld.Type <> esriFieldTypeOID) Then _
                            Me.lbx_Wtc.AddItem fld.AliasName
164:             Next fldIdx
165:             Me.lbx_Wtc.Enabled = True
166:         Else
167:             Me.lbx_Wtc.Enabled = False
168:         End If
    Case Me.rad_Mpl.Name
'        'gCht.rad_Mpl.Update
'        'Dim tabname As String
'        tabname = Me.cbx_Tab.Text
'        Dim tbVTab As ITable
'        Set tbVTab = SDMUtil.FindStandAloneTableByName(tabname).Table
'        Dim eMapFld As Long
'        eMapFld = tbVTab.FindField("Evidenct_T")
'        If (eMapFld = -1) Then
'            Me.rad_Mpl.Enabled = False
'            Exit Sub
'        End If
'        Dim fieldFld As Long
'        fieldFld = tbVTab.FindField("Class_Fiel")
'        If (fieldFld = -1) Then
'            Me.rad_Mpl.Enabled = False
'            Exit Sub
'        End If
'        Dim cField As Long
'        cField = tbVTab.FindField("Contrast_")
'        If (cField = -1) Then
'            Me.rad_Mpl.Enabled = False
'            Exit Sub
'        End If
193:         Me.rad_Mpl.Enabled = False
'        Me.rad_Mpl.Value = True
    Case Me.rbt_Bar.Name
        'gCht.rad_Bar.Update
197:         If (Me.rad_Mpl.Value) Then
198:             Me.rbt_Bar.Value = True
            Exit Sub
200:         End If
        Dim tb As String
202:         tb = Me.cbx_Tab.Text
203:         If ((Right(tb, 2) = "ct") Or (Right(tb, 6) = "ct.dbf")) Then
204:             Me.rbt_Bar.Value = True
205:         Else
206:             Me.rbt_Lin.Value = True
207:         End If
    Case Me.txl_Tle.Name
209:         If Me.cbx_Tab.Text <> "" Then
210:             Me.txl_Tle.Text = "Graph of " & Me.cbx_Tab.Text
211:         Else
212:             Me.txl_Tle.Text = ""
213:         End If
    Case Default
215:     End Select
Exit Sub

ErrorHandler:
  HandleError True, "aCtl_UpdateEvt " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), Err.Number, Err.Source, Err.Description, 4
End Sub

