VERSION 5.00
Begin VB.Form gCmb 
   ClientHeight    =   2340
   ClientLeft      =   0
   ClientTop       =   0
   ClientWidth     =   7785
   KeyPreview      =   -1  'True
   LinkTopic       =   "gCmb1"
   ScaleHeight     =   117
   ScaleMode       =   2  'Point
   ScaleWidth      =   389.25
   StartUpPosition =   2  'CenterScreen
   Begin VB.VScrollBar VScroll1 
      Height          =   1935
      Left            =   7320
      TabIndex        =   11
      Top             =   120
      Width           =   255
   End
   Begin VB.ComboBox cbxDT 
      Height          =   315
      Index           =   0
      Left            =   5880
      TabIndex        =   5
      Top             =   720
      Width           =   1275
   End
   Begin VB.TextBox txlMD 
      Alignment       =   1  'Right Justify
      Height          =   285
      Index           =   0
      Left            =   4680
      TabIndex        =   4
      Text            =   " "
      Top             =   720
      Width           =   1095
   End
   Begin VB.ComboBox cbxGT 
      Height          =   315
      Index           =   0
      Left            =   2280
      TabIndex        =   3
      Top             =   720
      Width           =   2295
   End
   Begin VB.CommandButton lbt_Don 
      Caption         =   "Cancel"
      Height          =   585
      Left            =   4080
      TabIndex        =   0
      Top             =   1320
      Width           =   1305
   End
   Begin VB.CommandButton lbt_CI 
      Caption         =   "OK"
      Height          =   585
      Left            =   2040
      TabIndex        =   1
      ToolTipText     =   "Resume processing. (Shift-click for help.)"
      Top             =   1320
      Width           =   1305
   End
   Begin VB.Label SDMLogo 
      Alignment       =   2  'Center
      Appearance      =   0  'Flat
      BackColor       =   &H0000C000&
      BorderStyle     =   1  'Fixed Single
      Caption         =   "ArcSDM3"
      BeginProperty Font 
         Name            =   "Roman"
         Size            =   14.25
         Charset         =   255
         Weight          =   700
         Underline       =   0   'False
         Italic          =   -1  'True
         Strikethrough   =   0   'False
      EndProperty
      ForeColor       =   &H0080FFFF&
      Height          =   375
      Left            =   5760
      TabIndex        =   12
      Top             =   1440
      Width           =   1335
   End
   Begin VB.Label txt_em 
      Caption         =   "Evidential Themes:"
      Height          =   165
      Left            =   600
      TabIndex        =   10
      Top             =   480
      Width           =   1440
   End
   Begin VB.Label txt_cf 
      Caption         =   "Generalization Tables:"
      Height          =   165
      Left            =   2520
      TabIndex        =   9
      Top             =   480
      Width           =   1890
      WordWrap        =   -1  'True
   End
   Begin VB.Label txtLMD 
      Caption         =   "Missing Data:"
      Height          =   330
      Left            =   4800
      TabIndex        =   8
      Top             =   480
      Width           =   1125
   End
   Begin VB.Label txtLC 
      Caption         =   "Data Type:"
      Height          =   210
      Left            =   6000
      TabIndex        =   7
      Top             =   480
      Width           =   1080
   End
   Begin VB.Label lblET 
      Caption         =   "lblET"
      Height          =   255
      Index           =   0
      Left            =   480
      TabIndex        =   6
      Top             =   720
      Width           =   1575
   End
   Begin VB.Label txt_Ttl 
      Caption         =   "Select the generalization table for each evidence theme that contains the classes you want to analyze:"
      Height          =   480
      Left            =   240
      TabIndex        =   2
      Top             =   0
      Width           =   6495
      WordWrap        =   -1  'True
   End
End
Attribute VB_Name = "gCmb"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit
Private Listeners As SDMUtilities.SDMListeners
Private WithEvents aCtl As SDMUtilities.SDMListeners
Attribute aCtl.VB_VarHelpID = -1

Private ObjectTag As SDMUtilities.SDMList
Private shiftDown As Boolean
Private pnlht As Long
Private n As Long
Private pnlTop As Long
Const pnlVis As Long = 15
Const c_sModuleFileName As String = "gCmb.frm"

Public Property Set setObjectTag(anObject As SDMUtilities.SDMList)
  On Error GoTo ErrorHandler
15:     Set ObjectTag = anObject
  Exit Property
ErrorHandler:
  HandleError True, "setObjectTag " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), Err.Number, Err.Source, Err.Description, 4
End Property

Public Property Get getObjectTag() As SDMUtilities.SDMList
  On Error GoTo ErrorHandler

24:     If (ObjectTag Is Nothing) Then
25:         Set getObjectTag = New SDMUtilities.SDMList
26:     Else
27:         Set getObjectTag = ObjectTag
28:     End If
  Exit Property
ErrorHandler:
  HandleError True, "getObjectTag " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), Err.Number, Err.Source, Err.Description, 4
End Property

Public Property Get isShiftdown() As Boolean
  On Error GoTo ErrorHandler
36:     isShiftdown = shiftDown
37:     shiftDown = False
  Exit Property
ErrorHandler:
  HandleError True, "isShiftdown " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), Err.Number, Err.Source, Err.Description, 4
End Property

Public Property Get getEars() As SDMUtilities.SDMListeners
  On Error GoTo ErrorHandler
45:     Set getEars = Listeners
  Exit Property
ErrorHandler:
  HandleError True, "getEars " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), Err.Number, Err.Source, Err.Description, 4
End Property

'Include selections for all controls with an update method
'Method could be local or belong to an instantiated object
Private Sub aCtl_UpdateEvt(ByRef ctl As Object)
    On Error GoTo ErrorHandler
    Select Case (ctl.Name)
        Case Me.lbt_CI.Name
        'Cmb.lbt_CI.Update
'        lstTL = gC.FindByClass(TextLine)
'        For Each tl In lstTL
60:     Me.lbt_CI.Enabled = True
        Dim i As Long
62:     For i = 0 To gCmb.lblET.Count - 1
63:         If gCmb.lblET(i).Caption <> "" And _
               gCmb.cbxGT(i).ListCount > 0 And _
               gCmb.txlMD(i).Text <> "" And _
               gCmb.cbxDT(i).ListCount > 0 Then
67:         Else
68:           Me.lbt_CI.Enabled = False
69:           Exit For
70:         End If
71:     Next i
'          If (tl.GetText = "") Then
'            Self.SetEnabled (False)
'            return Nil
'          End
'        End
        Case Else
78:             MsgBox "Update not found: " & ctl.Parent.Name, vbCritical, "gCmb.aCtl.Update"
79:     End Select
    Exit Sub
ErrorHandler:
  HandleError True, "getEars " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), Err.Number, Err.Source, Err.Description, 4
End Sub

Private Sub cbxDT_Change(Index As Integer)
86:     Me.getEars.BroadcastUpdate Me.cbxDT(Index)
End Sub

Private Sub Form_Initialize()
90:     KeyPreview = True
End Sub

Private Sub Form_KeyDown(KeyCode As Integer, Shift As Integer)
  On Error GoTo ErrorHandler
95:     shiftDown = (Shift And vbShiftMask) > 0
  Exit Sub
ErrorHandler:
  HandleError True, "Form_KeyDown " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), Err.Number, Err.Source, Err.Description, 4
End Sub
Private Sub Form_KeyUp(KeyCode As Integer, Shift As Integer)
  On Error GoTo ErrorHandler
102:     shiftDown = False
  Exit Sub
ErrorHandler:
  HandleError True, "Form_KeyUp " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), Err.Number, Err.Source, Err.Description, 4
End Sub

Private Sub Form_Load()
 'gCmb.Open
110:     Me.Caption = "Calculate Response Theme"
111:     Set Listeners = New SDMUtilities.SDMListeners
112:     Set aCtl = Listeners
113:     Set SDMGlobals.SDMdataDict = New SDMUtilities.SDMDictionary
114:     Set SDMGlobals.SDMdataMD = New SDMUtilities.SDMDictionary
    End Sub

Private Sub lbt_Don_Click()
 'gCmb.lbt_Don.Click
119:     If isShiftdown Then
120:         SDMGlobals.SDMHelp.gSDI_Help "sdmrspns.htm#Classes"
             Exit Sub
122:     End If
        
124:     Unload Me
125:     If (Not gL.Visible) Then gL.Visible = True
End Sub
Private Sub lbt_CI_Click()
128:     If isShiftdown Then
129:         SDMGlobals.SDMHelp.gSDI_Help ("sdmrspns.htm#Classes")
             Exit Sub
131:     End If
132:     gL.GenTblDict.Clear
         Dim i As Long
134:     For i = 0 To Me.lblET.Count - 1
135:         gL.GenTblDict.Add Me.lblET(i).Caption, Me.cbxGT(i).Text
136:     Next i
 'gCmb.lbt_OK.Click
      Dim gCmblbtOKClick As gCmb_lbt_OK_Click
139:  Set gCmblbtOKClick = New gCmb_lbt_OK_Click
140:  gCmblbtOKClick.gCmb_lbt_OK_Click
141:  Set gCmblbtOKClick = Nothing
End Sub

Sub Addpanels(n0 As Long)
145:     n = n0 - 1
146:     Me.VScroll1.Min = 0
147:     Me.VScroll1.Max = n
148:     pnlht = 3 * Me.lblET(0).Height / 2
149:     pnlTop = Me.lblET(0).Top
    
         Dim m As Long
152:     m = n
153:     If n > pnlVis Then m = pnlVis
154:     Me.Height = Me.Height + (m * pnlht * 20)
155:     Me.lbt_Don.Top = Me.lbt_Don.Top + (m * pnlht)
156:     Me.lbt_CI.Top = Me.lbt_CI.Top + (m * pnlht)
157:     Me.SDMLogo.Top = Me.SDMLogo.Top + (m * pnlht)
158:     Me.VScroll1.Enabled = True
159:     Me.VScroll1.Top = Me.lblET(0).Top - 12
160:     If n > pnlVis Then
161:         Me.VScroll1.Height = ((m + 1) * pnlht) + 22
162:         Me.VScroll1.Visible = True
163:     Else
164:         Me.VScroll1.Visible = False
165:     End If
         Dim i As Long
167:     For i = 1 To n
168:         Load Me.lblET(i)
169:         Me.lblET(i).Top = Me.lblET(0).Top + (i * pnlht)
170:         Me.lblET(i).Caption = "Label" & i
171:         If i <= pnlVis Then Me.lblET(i).Visible = True
172:         Load Me.cbxGT(i)
173:         Me.cbxGT(i).Top = Me.cbxGT(0).Top + (i * pnlht)
174:         If i <= pnlVis Then Me.cbxGT(i).Visible = True
175:         Load Me.txlMD(i)
176:         Me.txlMD(i).Top = Me.txlMD(0).Top + (i * pnlht)
177:         If i <= pnlVis Then Me.txlMD(i).Visible = True
178:         Load Me.cbxDT(i)
179:         Me.cbxDT(i).Top = Me.cbxDT(0).Top + (i * pnlht)
180:         If i <= pnlVis Then Me.cbxDT(i).Visible = True
181:     Next i
End Sub

Private Sub txlMD_Change(Index As Integer)
185:     Me.getEars.BroadcastUpdate Me.txlMD(Index)
End Sub

Private Sub VScroll1_Change()
     Dim scrVal As Double
190: scrVal = Me.VScroll1.Value
     Dim scrValMax As Long
192: scrValMax = n
     Dim i As Long
     Dim J As Long
195: J = 0
196: For i = scrVal To scrValMax
197:         Me.lblET(i).Top = pnlTop + J * pnlht
198:         Me.lblET(i).Visible = True
199:         Me.cbxGT(i).Top = pnlTop + J * pnlht
200:         Me.cbxGT(i).Visible = True
201:         Me.txlMD(i).Top = pnlTop + J * pnlht
202:         Me.txlMD(i).Visible = True
203:         Me.cbxDT(i).Top = pnlTop + J * pnlht
204:         Me.cbxDT(i).Visible = True
205:         J = J + 1
206:         If J > pnlVis Then Exit For
207:     Next i
End Sub
    

