VERSION 5.00
Begin VB.Form gExt 
   Caption         =   "Extract Contacts..."
   ClientHeight    =   3315
   ClientLeft      =   0
   ClientTop       =   0
   ClientWidth     =   5250
   KeyPreview      =   -1  'True
   LinkTopic       =   "gExt1"
   ScaleHeight     =   3315
   ScaleWidth      =   5250
   StartUpPosition =   2  'CenterScreen
   Begin VB.CommandButton btn_Help 
      Caption         =   "Help"
      Height          =   375
      Left            =   3240
      TabIndex        =   10
      ToolTipText     =   "Help for extracting contacts"
      Top             =   2640
      Width           =   1215
   End
   Begin VB.TextBox lbl_Sel2 
      Height          =   495
      Left            =   1920
      MultiLine       =   -1  'True
      TabIndex        =   9
      Text            =   "gExt.frx":0000
      Top             =   1920
      Width           =   3015
   End
   Begin VB.TextBox lbl_Sel1 
      Height          =   525
      Left            =   1920
      MultiLine       =   -1  'True
      TabIndex        =   8
      Text            =   "gExt.frx":0007
      Top             =   1320
      Width           =   3015
   End
   Begin VB.ComboBox cbx_Ftr 
      Height          =   315
      Left            =   240
      Sorted          =   -1  'True
      TabIndex        =   6
      ToolTipText     =   "Select theme with contacts."
      Top             =   480
      Width           =   2880
   End
   Begin VB.CommandButton lbt_OK 
      Caption         =   "Extract"
      Height          =   375
      Left            =   720
      TabIndex        =   1
      ToolTipText     =   "Extracts contacts between the two selected sets of attributes."
      Top             =   2640
      Width           =   1080
   End
   Begin VB.CommandButton lbt_Can 
      Caption         =   "Close"
      Height          =   375
      Left            =   1995
      TabIndex        =   2
      ToolTipText     =   "Cancel contact extraction."
      Top             =   2640
      Width           =   1080
   End
   Begin VB.CommandButton lbt_Q1 
      Caption         =   "Select Set 1"
      Height          =   450
      Left            =   240
      TabIndex        =   3
      ToolTipText     =   "Opens query dialog to select a set of attributes."
      Top             =   1320
      Width           =   1485
   End
   Begin VB.CommandButton lbt_Q2 
      Caption         =   "Select Set 2"
      Height          =   450
      Left            =   240
      TabIndex        =   4
      ToolTipText     =   "Opens query dialog to select a second set of attributes."
      Top             =   1920
      Width           =   1485
   End
   Begin VB.Label Label1 
      Alignment       =   2  'Center
      Appearance      =   0  'Flat
      BackColor       =   &H0000C000&
      BorderStyle     =   1  'Fixed Single
      Caption         =   "ArcSDM3"
      BeginProperty Font 
         Name            =   "Roman"
         Size            =   14.25
         Charset         =   255
         Weight          =   700
         Underline       =   0   'False
         Italic          =   -1  'True
         Strikethrough   =   0   'False
      EndProperty
      ForeColor       =   &H0080FFFF&
      Height          =   375
      Left            =   3600
      TabIndex        =   7
      Top             =   480
      Width           =   1335
   End
   Begin VB.Label txt_Ftr 
      Caption         =   "Select theme from which to extract contacts:"
      Height          =   330
      Left            =   210
      TabIndex        =   0
      Top             =   180
      Width           =   3210
   End
   Begin VB.Label txt_Selq 
      Caption         =   "Select two sets of polygon or raster attributes:"
      Height          =   225
      Left            =   210
      TabIndex        =   5
      Top             =   960
      Width           =   3285
   End
End
Attribute VB_Name = "gExt"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit
Const c_sModuleFileName As String = "gExt_frm"
Const c_sDLLFileName As String = "SDMAccessories"       ' Constant reflect file module name
Private Listeners As SDMUtilities.SDMListeners
Private WithEvents aCtl As SDMUtilities.SDMListeners
Attribute aCtl.VB_VarHelpID = -1

Private shiftDown As Boolean

Private ObjectTag As SDMUtilities.SDMList
Public Function isShiftdown() As Boolean
11:     isShiftdown = shiftDown
12:     shiftDown = False
End Function

Public Property Set setObjectTag(ByRef anObject As SDMUtilities.SDMList)
  On Error GoTo ErrorHandler
17:     Set ObjectTag = anObject
  Exit Property
ErrorHandler:
  HandleError True, "setObjectTag " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), Err.Number, Err.Source, Err.Description, 4
End Property

Public Property Get getObjectTag() As SDMUtilities.SDMList
  On Error GoTo ErrorHandler

26:     If (ObjectTag Is Nothing) Then
27:         Set getObjectTag = New SDMUtilities.SDMList
28:     Else
29:         Set getObjectTag = ObjectTag
30:     End If
  Exit Property
ErrorHandler:
  HandleError True, "getObjectTag " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), Err.Number, Err.Source, Err.Description, 4
End Property


Private Sub cbx_Ftr_Click()
    Me.lbl_Sel1.Text = "Query1"
    Me.lbl_Sel2.Text = "Query2"
End Sub

Private Sub btn_Help_Click()
    MsgBox "Contacts are found between contiguous cells of selected attributes." & vbCrLf & _
                 "For complex queries, simplify by grouping cells of different attributes" & vbCrLf & _
                 "by reclassifying the layer of interest.", vbInformation, "Extracting Contacts"
End Sub

Private Sub Form_Initialize()
    KeyPreview = True

End Sub

Private Sub Form_KeyDown(KeyCode As Integer, Shift As Integer)
  On Error GoTo ErrorHandler
38:     shiftDown = (Shift And vbShiftMask) > 0
  Exit Sub
ErrorHandler:
  HandleError True, "Form_KeyDown " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), Err.Number, Err.Source, Err.Description, 4
End Sub
Private Sub Form_KeyUp(KeyCode As Integer, Shift As Integer)
  On Error GoTo ErrorHandler
45:     shiftDown = False
  Exit Sub
ErrorHandler:
  HandleError True, "Form_KeyUp " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), Err.Number, Err.Source, Err.Description, 4
End Sub

Public Property Get getEars() As SDMUtilities.SDMListeners
  On Error GoTo ErrorHandler
53:     Set getEars = Listeners
  Exit Property
ErrorHandler:
  HandleError True, "getEars " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), Err.Number, Err.Source, Err.Description, 4
End Property

'Include selections for all controls with an update method
'Method could be local or belong to an instantiated object
Private Sub aCtl_UpdateEvt(ByRef ctl As Object)
    On Error GoTo ErrorHandler
    Select Case (ctl.Name)
        Case Me.lbt_OK.Name
            'Ext.lbt_OK.Update
            'self.SetEnabled (False)
            'extDiag = self.GetDialog
            'themeList = extDiag.findByName("cbx_Ftr").GetList
            'q1 = extDiag.findByName("lbt_Q1").getObjectTag
            'q2 = extDiag.findByName("lbt_Q2").getObjectTag
            'self.SetEnabled ((q1 <> Nil) And (q2 <> Nil) And (themeList.IsEmpty.Not))
72:         Me.lbt_OK.Enabled = (Me.lbt_Q1.Tag <> "") And (Me.lbt_Q2.Tag <> "") And (Me.cbx_Ftr.ListCount > 0)
        Case Me.lbt_Q1.Name
        Case Me.lbt_Q2.Name
        Case Me.cbx_Ftr.Name
            Dim gExtcbxFtrUpdate As gExt_cbx_Ftr_Update
77:             Set gExtcbxFtrUpdate = New gExt_cbx_Ftr_Update
78:             gExtcbxFtrUpdate.gExt_cbx_Ftr_Update
79:             Set gExtcbxFtrUpdate = Nothing
        Case Else
81:             MsgBox "Update not found: " & ctl.Parent.Name, vbCritical, "gL.aCtl.Update"
82:     End Select
    Exit Sub
ErrorHandler:
  HandleError True, "getEars " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), Err.Number, Err.Source, Err.Description, 4
End Sub

Private Sub Form_Load()
    On Error GoTo ErrorHandler
        'MsgBox "loading gParam..."
92:     Set Listeners = New SDMUtilities.SDMListeners
93:     Set aCtl = Listeners
94:    If SDMGlobals.SDMApp Is Nothing Then Set SDMGlobals.SDMApp = New AppRef
95:    If SDMGlobals.SDMDoc Is Nothing Then Set SDMGlobals.SDMDoc = SDMGlobals.SDMApp.Document
96:     If SDMGlobals.SDMMap Is Nothing Then
            Dim pMxDoc As IMxDocument
98:         Set pMxDoc = SDMGlobals.SDMDoc
99:         Set SDMGlobals.SDMMap = pMxDoc.FocusMap
100:     End If
101:    If SDMGlobals.SDMUtil Is Nothing Then
102:             Set SDMGlobals.SDMUtil = New SDMUtilities.SDMUtils
103:             Set SDMGlobals.SDMUtil.setAPP = SDMGlobals.SDMApp
104:         End If
105:    If SDMGlobals.SDMStatusBar Is Nothing Then Set SDMGlobals.SDMStatusBar = SDMGlobals.SDMApp.StatusBar
106:    If SDMGlobals.SDMHelp Is Nothing Then Set SDMGlobals.SDMHelp = New SDMUtilities.gSDI_Help
107:    If SDMGlobals.SDMdataDict Is Nothing Then Set SDMGlobals.SDMdataDict = New SDMUtilities.SDMDictionary
108:    If SDMGlobals.SDMWorkspace Is Nothing Then
117:        Set SDMGlobals.SDMWorkspace = SDMGlobals.SDMUtil.openShapeFileWorkspace(WOETableUtils.getProjectDir)
'''''198:        If SDMGlobals.SDMRAEnvironment Is Nothing Then
'''''201:            Set SDMGlobals.SDMRAEnvironment = RasterAEUtils.getRasterAnalysisEnvironment
'''''214:        End If
121:    End If
122:    shiftDown = False
    Exit Sub
ErrorHandler:
  HandleError True, "gFM_Load " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), Err.Number, Err.Source, Err.Description, 4
End Sub


Private Sub lbt_OK_Click()
130:     If (isShiftdown) Then
131:         SDMHelp.gSDI_Help ("sdmextct.htm")
        Exit Sub
133:     End If
134:     If Not CBool(gExt.lbt_OK.Tag) Then
135:         MsgBox "Query expression not valid: Redo", vbCritical, "Extract Contacts"
             Exit Sub
137:     End If
 'gExt.lbt_OK.Click
         Dim gSDIFindContacts As gSDI_FindContacts
140:     Set gSDIFindContacts = New gSDI_FindContacts
141:     gSDIFindContacts.gSDI_FindContacts
142:     Set gSDIFindContacts = Nothing
143:     Me.ZOrder 0
End Sub
Private Sub lbt_Can_Click()
'gExt.lbt_Can.Click
'If (System.IsShiftKeyDown) Then
'  docURL = "sdmextct.htm"
'  If (docURL.Count > 0) Then
'    av.Run("gSDI.Help", {docURL})
'  End
'  return Nil
'End
153:     If isShiftdown Then
154:         SDMHelp.gSDI_Help "sdmextct.htm"
             Exit Sub
156:     End If
'self.GetDialog.Close
158:     Unload Me
End Sub
Private Sub lbt_Q1_Click()
161:     If isShiftdown Then
162:         SDMHelp.gSDI_Help "sdmextct.htm"
        Exit Sub
164:     End If
 'gExt.lbt_Q1.Click
166:     Me.Tag = "Query1"
         Dim gExtlbtQ1Click As gExt_lbt_Q1_Click
168:     Set gExtlbtQ1Click = New gExt_lbt_Q1_Click
169:     gExtlbtQ1Click.gExt_lbt_Q1_Click Me.lbt_Q1
170:     Set gExtlbtQ1Click = Nothing
171:     Me.lbt_Q2.SetFocus
End Sub
Private Sub lbt_Q2_Click()
 'gExt.lbt_Q1.Click
174:     Me.Tag = "Query2"
         Dim gExtlbtQ1Click As gExt_lbt_Q1_Click
176:     Set gExtlbtQ1Click = New gExt_lbt_Q1_Click
177:     gExtlbtQ1Click.gExt_lbt_Q1_Click Me.lbt_Q2
178:     Set gExtlbtQ1Click = Nothing
179:     Me.lbt_OK.SetFocus
End Sub
Private Sub lbt_Q1_KeyDown(KeyCode As Integer, Shift As Integer)
181:     shiftDown = Shift And vbShiftMask
End Sub

Private Sub lbt_Q1_KeyUp(KeyCode As Integer, Shift As Integer)
185:     shiftDown = False
End Sub
Private Sub lbt_OK_KeyDown(KeyCode As Integer, Shift As Integer)
188:     shiftDown = Shift And vbShiftMask
End Sub

Private Sub lbt_OK_KeyUp(KeyCode As Integer, Shift As Integer)
192:     shiftDown = False
End Sub

