VERSION 5.00
Begin VB.Form gFL 
   ClientHeight    =   4710
   ClientLeft      =   0
   ClientTop       =   0
   ClientWidth     =   6135
   LinkTopic       =   "gFL1"
   ScaleHeight     =   4710
   ScaleWidth      =   6135
   StartUpPosition =   2  'CenterScreen
   Begin VB.ListBox lbxTF 
      Height          =   3375
      Left            =   360
      MultiSelect     =   2  'Extended
      Sorted          =   -1  'True
      TabIndex        =   0
      ToolTipText     =   "List of grid themes with associated values in range 0 - 1."
      Top             =   480
      Width           =   2925
   End
   Begin VB.CommandButton btnClc 
      Caption         =   "Calculate"
      Height          =   450
      Left            =   3480
      TabIndex        =   1
      ToolTipText     =   "Process currently specified fuzzy logic operation."
      Top             =   2760
      Width           =   2190
   End
   Begin VB.CommandButton btnCls 
      Caption         =   "Close"
      Height          =   420
      Left            =   795
      TabIndex        =   3
      ToolTipText     =   "Close this dialog"
      Top             =   4080
      Width           =   1920
   End
   Begin VB.Frame cpFO 
      Caption         =   "Functions"
      Height          =   2115
      Left            =   3480
      TabIndex        =   4
      Top             =   480
      Width           =   2190
      Begin VB.OptionButton radAND 
         Caption         =   "AND"
         Height          =   420
         Left            =   435
         TabIndex        =   5
         Top             =   195
         Width           =   1635
      End
      Begin VB.OptionButton radOR 
         Caption         =   "OR"
         Height          =   420
         Left            =   435
         TabIndex        =   6
         Top             =   540
         Width           =   1650
      End
      Begin VB.OptionButton radSUM 
         Caption         =   "SUM"
         Height          =   435
         Left            =   435
         TabIndex        =   7
         Top             =   900
         Width           =   1635
      End
      Begin VB.OptionButton radPRD 
         Caption         =   "PRODUCT"
         Height          =   420
         Left            =   435
         TabIndex        =   8
         Top             =   1260
         Width           =   1650
      End
      Begin VB.OptionButton radGAM 
         Caption         =   "GAMMA"
         Height          =   420
         Left            =   435
         TabIndex        =   9
         Top             =   1620
         Width           =   1665
      End
   End
   Begin VB.CommandButton btnRMod 
      Caption         =   "Select Model File..."
      Height          =   420
      Left            =   3540
      TabIndex        =   10
      ToolTipText     =   "Select another fuzzy logic model file. (Shift-click for help.)"
      Top             =   3525
      Width           =   2190
   End
   Begin VB.CommandButton btnVMod 
      Caption         =   "View Model (Text)..."
      Height          =   420
      Left            =   3540
      TabIndex        =   11
      ToolTipText     =   "View contents of current fuzzy logic model file. (Shift-click for help.)"
      Top             =   4080
      Width           =   2190
   End
   Begin VB.Label SDMLogo 
      Alignment       =   2  'Center
      Appearance      =   0  'Flat
      BackColor       =   &H0000C000&
      BorderStyle     =   1  'Fixed Single
      Caption         =   "ArcSDM3"
      BeginProperty Font 
         Name            =   "Roman"
         Size            =   14.25
         Charset         =   255
         Weight          =   700
         Underline       =   0   'False
         Italic          =   -1  'True
         Strikethrough   =   0   'False
      EndProperty
      ForeColor       =   &H0080FFFF&
      Height          =   375
      Left            =   3960
      TabIndex        =   12
      Top             =   120
      Width           =   1335
   End
   Begin VB.Label lblSel 
      Caption         =   "Select two or more rasters:"
      Height          =   345
      Left            =   360
      TabIndex        =   2
      Top             =   120
      Width           =   2850
   End
End
Attribute VB_Name = "gFL"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit
Const c_sModuleFileName As String = "gFL.frm"
Const c_sDLLFileName As String = "CalculateFuzzyLogic"       ' Constant reflect file module name

Private Listeners As SDMUtilities.SDMListeners
Private WithEvents aCtl As SDMUtilities.SDMListeners
Attribute aCtl.VB_VarHelpID = -1

Private shiftDown As Boolean
Private FModelTable As IStandaloneTable
Private ObjectTag As SDMUtilities.SDMList
Public Property Set setFModel(ByRef saTbl As IStandaloneTable)
12:    Set FModelTable = saTbl
End Property
Public Property Get getFModel() As IStandaloneTable
15:    Set getFModel = FModelTable
End Property
Public Function isShiftdown() As Boolean
18:     isShiftdown = shiftDown
19:     shiftDown = False
End Function
Public Property Set setObjectTag(ByRef anObject As SDMUtilities.SDMList)
  On Error GoTo ErrorHandler
23:     Set ObjectTag = anObject
  Exit Property
ErrorHandler:
  HandleError True, "setObjectTag " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), Err.Number, Err.Source, Err.Description, 4
End Property

Public Property Get getObjectTag() As SDMUtilities.SDMList
  On Error GoTo ErrorHandler

32:     If (ObjectTag Is Nothing) Then
33:         Set getObjectTag = New SDMUtilities.SDMList
34:     Else
35:         Set getObjectTag = ObjectTag
36:     End If
  Exit Property
ErrorHandler:
  HandleError True, "getObjectTag " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), Err.Number, Err.Source, Err.Description, 4
End Property
Private Sub Form_KeyDown(KeyCode As Integer, Shift As Integer)
  On Error GoTo ErrorHandler
43:     shiftDown = (Shift And vbShiftMask) > 0
  Exit Sub
ErrorHandler:
  HandleError True, "Form_KeyDown " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), Err.Number, Err.Source, Err.Description, 4
End Sub
Private Sub Form_KeyUp(KeyCode As Integer, Shift As Integer)
  On Error GoTo ErrorHandler
50:     shiftDown = False
  Exit Sub
ErrorHandler:
  HandleError True, "Form_KeyUp " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), Err.Number, Err.Source, Err.Description, 4
End Sub

Public Property Get getEars() As SDMUtilities.SDMListeners
  On Error GoTo ErrorHandler
58:     Set getEars = Listeners
  Exit Property
ErrorHandler:
  HandleError True, "getEars " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), Err.Number, Err.Source, Err.Description, 4
End Property

'Include selections for all controls with an update method
'Method could be local or belong to an instantiated object
Private Sub aCtl_UpdateEvt(ByRef ctl As Object)
    On Error GoTo ErrorHandler
    Select Case (ctl.Name)
        Case Me.lbxTF.Name
            Dim enumLayer As IEnumLayer
71:         Set enumLayer = SDMGlobals.SDMMap.layers
                Dim layer As ILayer
73:             Set layer = enumLayer.Next
74:             While (Not layer Is Nothing)
75:                 If layer.Valid Then
76:                     If TypeOf layer Is IRasterLayer Then
                            Dim rLayer As IRasterLayer
78:                         Set rLayer = layer
                            Dim rasprops As IRasterProps
80:                         Set rasprops = rLayer.Raster
81:                         If rasprops.PixelType = PT_DOUBLE Or rasprops.PixelType = PT_FLOAT Then
                                Dim rasBandColl As IRasterBandCollection
83:                             Set rasBandColl = rLayer.Raster
                                Dim rasStats As IRasterStatistics
85:                             Set rasStats = rasBandColl.Item(0).Statistics
86:                             If rasStats.Maximum <= 1# And rasStats.Minimum >= 0# Then Me.lbxTF.AddItem layer.Name
87:                         End If
88:                     End If
89:                 End If
90:                 Set layer = enumLayer.Next
91:             Wend
92:             If Me.lbxTF.ListCount = 0 Then Me.lbxTF.AddItem "No Fuzzy Models"
93:             Me.lbxTF.ListIndex = 0
94:             Me.getEars.BroadcastUpdate Me.lbxTF
        Case Me.btnClc.Name
96:             Me.btnClc.Enabled = Me.lbxTF.SelCount > 1
        Case Else
98:             MsgBox "Update not found: " & ctl.Parent.Name, vbCritical, "gL.aCtl.Update"
99:     End Select
    Exit Sub
ErrorHandler:
  HandleError True, "getEars " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), Err.Number, Err.Source, Err.Description, 4
End Sub

Private Sub Form_Load()
    On Error GoTo ErrorHandler
        'MsgBox "loading gParam..."
108:     Me.Caption = "Fuzzy Logic"
109:     Set Listeners = New SDMUtilities.SDMListeners
110:     Set aCtl = Listeners
111:    If SDMGlobals.SDMApp Is Nothing Then Set SDMGlobals.SDMApp = New AppRef
112:    If SDMGlobals.SDMDoc Is Nothing Then Set SDMGlobals.SDMDoc = SDMGlobals.SDMApp.Document
113:    If SDMGlobals.SDMMap Is Nothing Then
            Dim pMxDoc As IMxDocument
115:        Set pMxDoc = SDMGlobals.SDMDoc
116:        Set SDMGlobals.SDMMap = pMxDoc.FocusMap
117:    End If
118:    If SDMGlobals.SDMUtil Is Nothing Then
119:             Set SDMGlobals.SDMUtil = New SDMUtilities.SDMUtils
120:             Set SDMGlobals.SDMUtil.setAPP = SDMGlobals.SDMApp
121:         End If
122:    If SDMGlobals.SDMStatusBar Is Nothing Then Set SDMGlobals.SDMStatusBar = SDMGlobals.SDMApp.StatusBar
123:    If SDMGlobals.SDMHelp Is Nothing Then Set SDMGlobals.SDMHelp = New SDMUtilities.gSDI_Help
124:    If SDMGlobals.SDMdataDict Is Nothing Then Set SDMGlobals.SDMdataDict = New SDMUtilities.SDMDictionary
125:    If SDMGlobals.SDMWorkspace Is Nothing Then
            Dim cwdPath As String
            Dim lyr As IDataset
128:        Set lyr = SDMGlobals.SDMMap.layers.Next
129:        If Not lyr Is Nothing Then
130:            cwdPath = lyr.Workspace.PathName
131:        Else
132:            cwdPath = Environ("TEMP")
133:        End If
134:        Set SDMGlobals.SDMWorkspace = SDMGlobals.SDMUtil.openShapeFileWorkspace(cwdPath)
        'If SDMGlobals.SDMRAEnvironment Is Nothing Then
        '    Set SDMGlobals.SDMRAEnvironment = RasterAEUtils.getRasterAnalysisEnvironment
        'End If
138:    End If
139:    shiftDown = False
    Exit Sub
ErrorHandler:
  HandleError True, "gFM_Load " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), Err.Number, Err.Source, Err.Description, 4
End Sub

Private Sub btnClc_Click()
146:     If (shiftDown) Then
147:         SDMHelp.gSDI_Help "sdmfl3.htm#Select"
            Exit Sub
149:     End If
 'gFL.btnClc.Click
        Dim gFLClick As gFL_btnClc_Click
152:     Set gFLClick = New gFL_btnClc_Click
153:     gFLClick.gFL_btnClc_Click
154:     Set gFLClick = Nothing
            Me.ZOrder 0
End Sub

Private Sub btnCls_Click()
 'gFL.btnCls.Click
159:     Unload Me
End Sub
Private Sub btnRMod_Click()
162:     If (shiftDown) Then
163:         SDMHelp.gSDI_Help "sdmfl3.htm#another"
        Exit Sub
165:     End If
 'gFL.btnRMod.Click
167:  Set Me.setFModel = FuzzyModelUtils.getFuzzyModel
        Me.ZOrder 0
End Sub
Private Sub btnVMod_Click()
  On Error GoTo ErrorHandler

172:     If (shiftDown) Then
173:         SDMHelp.gSDI_Help "sdmfl3.htm#view"
        Exit Sub
175:     End If
 'gFL.btnVMod.Click
         If FModelTable Is Nothing Then Exit Sub
         Dim tblView As ITableWindow2
179:     Set tblView = New TableWindow
180:     Set tblView.Application = New AppRef
181:     Set tblView.StandaloneTable = FModelTable
182:     tblView.Show True
            Me.ZOrder 0

  Exit Sub
ErrorHandler:
  HandleError True, "btnVMod_Click " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), Err.Number, Err.Source, Err.Description, 4
End Sub

Private Sub lbxTF_Click()
191:     Me.getEars.BroadcastUpdate Me.lbxTF
End Sub

