VERSION 5.00
Object = "{0ECD9B60-23AA-11D0-B351-00A0C9055D8E}#6.0#0"; "mshflxgd.ocx"
Begin VB.Form gFZ 
   BackColor       =   &H00E0E0E0&
   Caption         =   "Define Fuzzy Memberships"
   ClientHeight    =   9330
   ClientLeft      =   60
   ClientTop       =   405
   ClientWidth     =   11880
   LinkTopic       =   "Form1"
   ScaleHeight     =   9330
   ScaleWidth      =   11880
   StartUpPosition =   3  'Windows Default
   Begin VB.ComboBox cbx_SigFig 
      BackColor       =   &H00FFFFFF&
      Height          =   315
      Left            =   10800
      TabIndex        =   80
      Text            =   "1"
      ToolTipText     =   "No. of significant figures in fuzzy model output"
      Top             =   90
      Width           =   855
   End
   Begin VB.CommandButton lbt_Apply 
      BackColor       =   &H00FFFFFF&
      Caption         =   "Apply"
      Height          =   375
      Left            =   960
      MaskColor       =   &H00FFFFFF&
      TabIndex        =   0
      ToolTipText     =   "Open a table of fuzzified values"
      Top             =   5760
      Width           =   2175
   End
   Begin VB.CommandButton lbt_OK 
      Caption         =   "Create"
      Height          =   375
      Left            =   3120
      TabIndex        =   38
      ToolTipText     =   "Create a raster from the selected fuzzification function"
      Top             =   8520
      Width           =   1215
   End
   Begin VB.CommandButton lbt_Can 
      Caption         =   "Done"
      Height          =   375
      Left            =   9720
      TabIndex        =   37
      ToolTipText     =   "Done creating rasters from fuzzy membership"
      Top             =   8520
      Width           =   1215
   End
   Begin VB.Frame cpl_Edcell 
      BackColor       =   &H00E0E0E0&
      Caption         =   "Edit selected cell(s)"
      Height          =   3015
      Left            =   8640
      TabIndex        =   29
      Top             =   5400
      Width           =   2535
      Begin VB.TextBox txt_NewVal 
         Height          =   375
         Left            =   1080
         TabIndex        =   34
         ToolTipText     =   "Enter new value for selected cell"
         Top             =   360
         Width           =   1095
      End
      Begin VB.CommandButton lbt_SetVal 
         Caption         =   "Set value"
         Enabled         =   0   'False
         Height          =   375
         Left            =   480
         TabIndex        =   33
         ToolTipText     =   "Set cell value from new value"
         Top             =   960
         Width           =   1455
      End
      Begin VB.CommandButton lbt_NoData 
         Caption         =   "Set NoData"
         Enabled         =   0   'False
         Height          =   375
         Left            =   480
         TabIndex        =   32
         ToolTipText     =   "Set new values to NoData"
         Top             =   1440
         Width           =   1455
      End
      Begin VB.CommandButton lbt_Interp 
         Caption         =   "Interpolate"
         Height          =   375
         Left            =   480
         TabIndex        =   31
         ToolTipText     =   "Interpolate values among selected cells"
         Top             =   1920
         Width           =   1455
      End
      Begin VB.CommandButton lbt_Fuzz 
         Caption         =   "Fuzziify"
         Height          =   375
         Left            =   480
         TabIndex        =   30
         ToolTipText     =   "Apply fuzzificaton function"
         Top             =   2400
         Visible         =   0   'False
         Width           =   1455
      End
      Begin VB.Label Label1 
         BackColor       =   &H00E0E0E0&
         Caption         =   "New value"
         ForeColor       =   &H00FF0000&
         Height          =   255
         Index           =   1
         Left            =   240
         TabIndex        =   35
         Top             =   480
         Width           =   855
      End
   End
   Begin VB.ComboBox cbx_Att 
      Height          =   315
      Left            =   3720
      TabIndex        =   28
      ToolTipText     =   "Attribute fields of evidence layer"
      Top             =   7980
      Width           =   3495
   End
   Begin VB.CommandButton lbt_Prev 
      Caption         =   "Preview"
      Height          =   375
      Left            =   4560
      TabIndex        =   27
      ToolTipText     =   "View a chart of values vs fuzzy membership and save table"
      Top             =   8520
      Width           =   1215
   End
   Begin VB.CommandButton lbt_Sav 
      Caption         =   "Add table"
      Height          =   375
      Left            =   7440
      TabIndex        =   26
      ToolTipText     =   "Add the previewed Fuzzy Membership table to map"
      Top             =   8520
      Visible         =   0   'False
      Width           =   1215
   End
   Begin VB.CommandButton lbt_Ld 
      Caption         =   "Load table"
      Height          =   375
      Left            =   6000
      TabIndex        =   25
      ToolTipText     =   "Load the fuzzy membership assignment from a table"
      Top             =   8520
      Width           =   1215
   End
   Begin VB.ComboBox cbx_SelGrd 
      BackColor       =   &H00FFFFFF&
      Height          =   315
      Left            =   1560
      Sorted          =   -1  'True
      TabIndex        =   23
      Top             =   120
      Width           =   3135
   End
   Begin VB.Frame cpl_FzFnc 
      BackColor       =   &H00E0E0E0&
      Caption         =   "Ordered Data Fuzzification Functions"
      Height          =   4815
      Index           =   0
      Left            =   120
      TabIndex        =   4
      Top             =   480
      Width           =   5775
      Begin VB.Frame cpl_MSLarge 
         BackColor       =   &H00E0E0E0&
         Caption         =   "MS Large"
         Height          =   615
         Left            =   240
         TabIndex        =   76
         ToolTipText     =   "Select a fuzzification function"
         Top             =   2160
         Width           =   5295
         Begin VB.OptionButton rbt_MSVLrg 
            BackColor       =   &H00E0E0E0&
            Caption         =   "Very Large"
            ForeColor       =   &H00008000&
            Height          =   255
            Left            =   3120
            TabIndex        =   79
            Top             =   240
            Width           =   1335
         End
         Begin VB.OptionButton rbt_MSLrg 
            BackColor       =   &H00E0E0E0&
            Caption         =   "Large"
            ForeColor       =   &H00008000&
            Height          =   255
            Left            =   1920
            TabIndex        =   78
            Top             =   240
            Width           =   975
         End
         Begin VB.OptionButton rbt_MSSLrg 
            BackColor       =   &H00E0E0E0&
            Caption         =   "Somewhat Large"
            ForeColor       =   &H00008000&
            Height          =   255
            Left            =   240
            TabIndex        =   77
            Top             =   240
            Width           =   1575
         End
      End
      Begin VB.Frame cpl_MSSmall 
         BackColor       =   &H00E0E0E0&
         Caption         =   "MS Small"
         Height          =   615
         Left            =   240
         TabIndex        =   72
         ToolTipText     =   "Select a fuzzification function"
         Top             =   885
         Width           =   5295
         Begin VB.OptionButton rbt_MSVSm 
            BackColor       =   &H00E0E0E0&
            Caption         =   "Very Small"
            ForeColor       =   &H000040C0&
            Height          =   315
            Left            =   240
            TabIndex        =   75
            ToolTipText     =   "Square root of Small"
            Top             =   240
            Width           =   1215
         End
         Begin VB.OptionButton rbt_MSSm 
            BackColor       =   &H00E0E0E0&
            Caption         =   "Small"
            ForeColor       =   &H000040C0&
            Height          =   315
            Left            =   1920
            TabIndex        =   74
            Top             =   240
            Width           =   855
         End
         Begin VB.OptionButton rbt_MSSSm 
            BackColor       =   &H00E0E0E0&
            Caption         =   "Somewhat Small"
            ForeColor       =   &H000040C0&
            Height          =   315
            Left            =   3120
            TabIndex        =   73
            Top             =   240
            Width           =   1695
         End
      End
      Begin VB.Frame cpl_Small 
         BackColor       =   &H00E0E0E0&
         Height          =   615
         Left            =   240
         TabIndex        =   19
         ToolTipText     =   "Select a fuzzification function"
         Top             =   240
         Width           =   5295
         Begin VB.OptionButton rbt_SSm 
            BackColor       =   &H00E0E0E0&
            Caption         =   "Somewhat Small"
            ForeColor       =   &H00000080&
            Height          =   315
            Left            =   3120
            TabIndex        =   22
            ToolTipText     =   "Square root of Small"
            Top             =   240
            Width           =   1935
         End
         Begin VB.OptionButton rbt_Sm 
            BackColor       =   &H00E0E0E0&
            Caption         =   "Small"
            ForeColor       =   &H00000080&
            Height          =   315
            Left            =   1920
            TabIndex        =   21
            Top             =   240
            Width           =   855
         End
         Begin VB.OptionButton rbt_VSm 
            BackColor       =   &H00E0E0E0&
            Caption         =   "Very Small"
            ForeColor       =   &H00000080&
            Height          =   315
            Left            =   240
            TabIndex        =   20
            ToolTipText     =   "Square of Small"
            Top             =   240
            Width           =   1215
         End
      End
      Begin VB.Frame cpl_Large 
         BackColor       =   &H00E0E0E0&
         Height          =   615
         Left            =   240
         TabIndex        =   15
         ToolTipText     =   "Select a fuzzification function"
         Top             =   1515
         Width           =   5295
         Begin VB.OptionButton rbt_SLrg 
            BackColor       =   &H00E0E0E0&
            Caption         =   "Somewhat Large"
            ForeColor       =   &H00004040&
            Height          =   255
            Left            =   240
            TabIndex        =   18
            ToolTipText     =   "Square of Large"
            Top             =   240
            Width           =   1575
         End
         Begin VB.OptionButton rbt_Lrg 
            BackColor       =   &H00E0E0E0&
            Caption         =   "Large"
            ForeColor       =   &H00004040&
            Height          =   255
            Left            =   1920
            TabIndex        =   17
            Top             =   240
            Width           =   975
         End
         Begin VB.OptionButton rbt_VLrg 
            BackColor       =   &H00E0E0E0&
            Caption         =   "Very Large"
            ForeColor       =   &H00004040&
            Height          =   255
            Left            =   3120
            TabIndex        =   16
            ToolTipText     =   "Square root of Large"
            Top             =   240
            Width           =   1335
         End
      End
      Begin VB.Frame cpl_Near 
         BackColor       =   &H00E0E0E0&
         Height          =   615
         Left            =   240
         TabIndex        =   11
         ToolTipText     =   "Select a fuzzification function"
         Top             =   3435
         Width           =   5295
         Begin VB.OptionButton rbt_SNear 
            BackColor       =   &H00E0E0E0&
            Caption         =   "Somewhat Near"
            ForeColor       =   &H00C00000&
            Height          =   255
            Left            =   3120
            TabIndex        =   14
            ToolTipText     =   "Square root of Near"
            Top             =   240
            Width           =   1695
         End
         Begin VB.OptionButton rbt_Near 
            BackColor       =   &H00E0E0E0&
            Caption         =   "Near"
            ForeColor       =   &H00C00000&
            Height          =   255
            Left            =   1920
            TabIndex        =   13
            Top             =   240
            Width           =   975
         End
         Begin VB.OptionButton rbt_VNear 
            BackColor       =   &H00E0E0E0&
            Caption         =   "Very Near"
            ForeColor       =   &H00C00000&
            Height          =   255
            Left            =   240
            TabIndex        =   12
            ToolTipText     =   "Square of Near"
            Top             =   240
            Width           =   1335
         End
      End
      Begin VB.Frame cpl_Gauss 
         BackColor       =   &H00E0E0E0&
         Height          =   615
         Left            =   240
         TabIndex        =   7
         ToolTipText     =   "Select a fuzzification function"
         Top             =   4080
         Width           =   5295
         Begin VB.OptionButton rbt_SGauss 
            BackColor       =   &H00E0E0E0&
            Caption         =   "Somewhat Gaussian"
            ForeColor       =   &H00800080&
            Height          =   255
            Left            =   3120
            TabIndex        =   10
            ToolTipText     =   "Square root of Gaussian"
            Top             =   240
            Width           =   2055
         End
         Begin VB.OptionButton rbt_Gauss 
            BackColor       =   &H00E0E0E0&
            Caption         =   "Gaussian"
            ForeColor       =   &H00800080&
            Height          =   255
            Left            =   1920
            TabIndex        =   9
            Top             =   240
            Width           =   1095
         End
         Begin VB.OptionButton rbt_VGauss 
            BackColor       =   &H00E0E0E0&
            Caption         =   "Very Gaussian"
            ForeColor       =   &H00800080&
            Height          =   255
            Left            =   240
            TabIndex        =   8
            ToolTipText     =   "Square of Gaussian"
            Top             =   240
            Width           =   1575
         End
      End
      Begin VB.Frame cpl_Linear 
         BackColor       =   &H00E0E0E0&
         Height          =   615
         Left            =   240
         TabIndex        =   5
         ToolTipText     =   "Select a fuzzification function"
         Top             =   2805
         Width           =   5295
         Begin VB.OptionButton rbt_Lin 
            BackColor       =   &H00E0E0E0&
            Caption         =   "Linear"
            ForeColor       =   &H00808000&
            Height          =   255
            Left            =   1920
            TabIndex        =   6
            Top             =   240
            Width           =   1575
         End
      End
   End
   Begin VB.Frame Frame2 
      BackColor       =   &H00E0E0E0&
      Caption         =   "Parameters"
      Height          =   4815
      Left            =   6000
      TabIndex        =   3
      Top             =   480
      Width           =   5655
      Begin VB.CheckBox chk_LogMSSm 
         BackColor       =   &H00E0E0E0&
         Caption         =   "Log"
         ForeColor       =   &H000040C0&
         Height          =   255
         Left            =   120
         TabIndex        =   83
         ToolTipText     =   "Logarithmic data distribution"
         Top             =   1135
         Width           =   615
      End
      Begin VB.CheckBox chk_LogMSLrg 
         BackColor       =   &H00E0E0E0&
         Caption         =   "Log"
         ForeColor       =   &H00008000&
         Height          =   255
         Left            =   120
         TabIndex        =   82
         ToolTipText     =   "Logarithmic data distribution"
         Top             =   2415
         Width           =   615
      End
      Begin VB.TextBox txt_MPMSSm 
         Height          =   285
         Left            =   1320
         TabIndex        =   69
         Text            =   "1.0"
         Top             =   1120
         Width           =   1215
      End
      Begin VB.TextBox txt_SprdMSSm 
         Height          =   285
         Left            =   4200
         TabIndex        =   68
         Text            =   "1.0"
         Top             =   1120
         Width           =   1215
      End
      Begin VB.TextBox txt_SprdMSLrg 
         Height          =   285
         Left            =   4200
         TabIndex        =   67
         Text            =   "1.0"
         ToolTipText     =   "Multiplier for the input population standard deviation"
         Top             =   2400
         Width           =   1215
      End
      Begin VB.TextBox txt_MPMSLrg 
         Height          =   285
         Left            =   1320
         TabIndex        =   64
         Text            =   "1.0"
         ToolTipText     =   "Multiplier for the input population mean"
         Top             =   2400
         Width           =   1215
      End
      Begin VB.TextBox txt_MPGauss 
         Enabled         =   0   'False
         Height          =   285
         Left            =   1320
         TabIndex        =   60
         Text            =   "0.5"
         ToolTipText     =   "Value that will have a membership of 1 in the middle of the bell-shaped curve"
         Top             =   4320
         Width           =   1215
      End
      Begin VB.TextBox txt_MPNear 
         Enabled         =   0   'False
         Height          =   285
         Left            =   1320
         TabIndex        =   59
         Text            =   "0.5"
         ToolTipText     =   "Value that will have a membership of 1 in the middle of the bell-shaped curve"
         Top             =   3680
         Width           =   1215
      End
      Begin VB.TextBox txt_Mbr0Lin 
         Enabled         =   0   'False
         Height          =   285
         Left            =   1320
         TabIndex        =   58
         Text            =   "0"
         ToolTipText     =   "Value that will have a membership of 0"
         Top             =   3040
         Width           =   1215
      End
      Begin VB.TextBox txt_MPLrg 
         Enabled         =   0   'False
         Height          =   285
         Left            =   1320
         TabIndex        =   57
         Text            =   "0.5"
         ToolTipText     =   "The value that will have a membership of 0.5"
         Top             =   1760
         Width           =   1215
      End
      Begin VB.TextBox txt_MPSm 
         Enabled         =   0   'False
         Height          =   285
         Left            =   1320
         TabIndex        =   56
         Tag             =   "0.5"
         Text            =   "0.5"
         ToolTipText     =   "The value that will have a membership of 0.5"
         Top             =   480
         Width           =   1215
      End
      Begin VB.TextBox txt_SprdLrg 
         Enabled         =   0   'False
         Height          =   285
         Left            =   4200
         TabIndex        =   47
         Text            =   "5"
         ToolTipText     =   "Increasing value increases slope of curve"
         Top             =   1760
         Width           =   1215
      End
      Begin VB.TextBox txt_SprdSm 
         Enabled         =   0   'False
         Height          =   285
         Left            =   4200
         TabIndex        =   46
         Text            =   "5"
         ToolTipText     =   "Increasing number increases slope of curve"
         Top             =   480
         Width           =   1215
      End
      Begin VB.TextBox txt_Mbr1Lin 
         Enabled         =   0   'False
         Height          =   285
         Left            =   4200
         TabIndex        =   45
         Text            =   "1"
         ToolTipText     =   "Value that will have a membership of 1"
         Top             =   3040
         Width           =   1215
      End
      Begin VB.TextBox txt_SprdNear 
         Enabled         =   0   'False
         Height          =   285
         Left            =   4200
         TabIndex        =   44
         Text            =   "0.5"
         ToolTipText     =   "Increasing number makes the bell-shaped curve narrower"
         Top             =   3675
         Width           =   1215
      End
      Begin VB.TextBox txt_SprdGauss 
         Enabled         =   0   'False
         Height          =   285
         Left            =   4200
         TabIndex        =   43
         Text            =   "0.5"
         ToolTipText     =   "Increasing number makes the bell-shaped curve narrower"
         Top             =   4320
         Width           =   1215
      End
      Begin VB.Label Label14 
         Alignment       =   1  'Right Justify
         BackColor       =   &H00E0E0E0&
         Caption         =   "b [0-3]"
         ForeColor       =   &H000040C0&
         Height          =   255
         Left            =   3480
         TabIndex        =   71
         ToolTipText     =   "Std Deviation multiplier"
         Top             =   1140
         Width           =   615
      End
      Begin VB.Label Label13 
         Alignment       =   1  'Right Justify
         BackColor       =   &H00E0E0E0&
         Caption         =   "       a > 0"
         ForeColor       =   &H000040C0&
         Height          =   255
         Left            =   480
         TabIndex        =   70
         ToolTipText     =   "Mean multiplier"
         Top             =   1135
         Width           =   735
      End
      Begin VB.Label Label12 
         Alignment       =   1  'Right Justify
         BackColor       =   &H00E0E0E0&
         Caption         =   "b [0-3]"
         ForeColor       =   &H00008000&
         Height          =   255
         Left            =   3000
         TabIndex        =   66
         ToolTipText     =   "Std Deviation multiplier"
         Top             =   2415
         Width           =   1095
      End
      Begin VB.Label Label11 
         Alignment       =   1  'Right Justify
         BackColor       =   &H00E0E0E0&
         Caption         =   "     a > 0"
         ForeColor       =   &H00008000&
         Height          =   255
         Left            =   600
         TabIndex        =   65
         ToolTipText     =   "Mean multiplier"
         Top             =   2415
         Width           =   615
      End
      Begin VB.Label Label1 
         Alignment       =   1  'Right Justify
         BackColor       =   &H00E0E0E0&
         Caption         =   "Midpoint"
         ForeColor       =   &H00000080&
         Height          =   255
         Index           =   0
         Left            =   360
         TabIndex        =   54
         Top             =   480
         Width           =   855
      End
      Begin VB.Label Label2 
         Alignment       =   1  'Right Justify
         BackColor       =   &H00E0E0E0&
         Caption         =   "Midpoint"
         ForeColor       =   &H00004040&
         Height          =   255
         Left            =   120
         TabIndex        =   53
         Top             =   1800
         Width           =   1095
      End
      Begin VB.Label Label5 
         Alignment       =   1  'Right Justify
         BackColor       =   &H00E0E0E0&
         Caption         =   "Membership=0"
         ForeColor       =   &H00808000&
         Height          =   255
         Left            =   120
         TabIndex        =   52
         Top             =   3120
         Width           =   1095
      End
      Begin VB.Label Label6 
         Alignment       =   1  'Right Justify
         BackColor       =   &H00E0E0E0&
         Caption         =   "Membership=1"
         ForeColor       =   &H00808000&
         Height          =   255
         Left            =   2880
         TabIndex        =   51
         Top             =   3120
         Width           =   1215
      End
      Begin VB.Label Label7 
         Alignment       =   1  'Right Justify
         BackColor       =   &H00E0E0E0&
         Caption         =   "Spread [1-10]"
         ForeColor       =   &H00000080&
         Height          =   375
         Left            =   2640
         TabIndex        =   50
         Top             =   435
         Width           =   1455
      End
      Begin VB.Label Label8 
         Alignment       =   1  'Right Justify
         BackColor       =   &H00E0E0E0&
         Caption         =   "Spread [1-10]"
         ForeColor       =   &H00004040&
         Height          =   255
         Left            =   3000
         TabIndex        =   49
         Top             =   1800
         Width           =   1095
      End
      Begin VB.Label Label9 
         Alignment       =   1  'Right Justify
         BackColor       =   &H00E0E0E0&
         Caption         =   "Spread [0.001-1]"
         ForeColor       =   &H00C00000&
         Height          =   255
         Left            =   2640
         TabIndex        =   48
         Top             =   3690
         Width           =   1455
      End
      Begin VB.Label Label3 
         Alignment       =   1  'Right Justify
         BackColor       =   &H00E0E0E0&
         Caption         =   "Midpoint"
         ForeColor       =   &H00800080&
         Height          =   255
         Left            =   360
         TabIndex        =   42
         Top             =   4320
         Width           =   855
      End
      Begin VB.Label Label4 
         Alignment       =   1  'Right Justify
         BackColor       =   &H00E0E0E0&
         Caption         =   "Midpoint"
         ForeColor       =   &H00C00000&
         Height          =   255
         Left            =   120
         TabIndex        =   41
         Top             =   3720
         Width           =   1095
      End
      Begin VB.Label Label10 
         Alignment       =   1  'Right Justify
         BackColor       =   &H00E0E0E0&
         Caption         =   "Spread [0.001-1]"
         ForeColor       =   &H00800080&
         Height          =   255
         Left            =   2640
         TabIndex        =   40
         Top             =   4335
         Width           =   1455
      End
   End
   Begin VB.Frame Frame8 
      BackColor       =   &H00E0E0E0&
      Caption         =   "Free Data Fuzzification Functions"
      Height          =   855
      Left            =   600
      TabIndex        =   1
      Top             =   6600
      Width           =   2895
      Begin VB.CommandButton lbt_TblMtd 
         Caption         =   "Table Method"
         Height          =   375
         Left            =   360
         TabIndex        =   2
         Top             =   240
         Width           =   2175
      End
   End
   Begin MSHierarchicalFlexGridLib.MSHFlexGrid MSHFlexGrid1 
      Height          =   2415
      Left            =   3720
      TabIndex        =   36
      ToolTipText     =   "Mean multiplier"
      Top             =   5520
      Width           =   4005
      _ExtentX        =   7064
      _ExtentY        =   4260
      _Version        =   393216
      Cols            =   3
      FixedCols       =   0
      BackColorSel    =   16776960
      ForeColorSel    =   0
      FocusRect       =   2
      GridLinesFixed  =   1
      ScrollBars      =   2
      SelectionMode   =   1
      MousePointer    =   3
      _NumberOfBands  =   1
      _Band(0).Cols   =   3
   End
   Begin VB.Frame Frame1 
      BackColor       =   &H00E0E0E0&
      Caption         =   "Ordered Data Fuzzification Functions"
      Height          =   1095
      Left            =   600
      TabIndex        =   55
      Top             =   5400
      Width           =   2895
   End
   Begin VB.Frame Frame3 
      BackColor       =   &H00E0E0E0&
      Caption         =   "Table"
      Height          =   3135
      Left            =   3600
      TabIndex        =   61
      Top             =   5280
      Width           =   4815
   End
   Begin VB.Label lbl_msg 
      BackColor       =   &H00FFFFFF&
      ForeColor       =   &H00C00000&
      Height          =   255
      Left            =   240
      TabIndex        =   84
      Top             =   9000
      Width           =   11295
   End
   Begin VB.Label lbl_SigFig 
      BackColor       =   &H00E0E0E0&
      Caption         =   "No. of significant figures in fuzzy membership (1-7):"
      ForeColor       =   &H00C00000&
      Height          =   255
      Left            =   7080
      TabIndex        =   81
      Top             =   120
      Width           =   3735
   End
   Begin VB.Label lbl_Ld 
      Height          =   375
      Left            =   9360
      TabIndex        =   63
      ToolTipText     =   "Loaded table name"
      Top             =   8520
      Width           =   1815
   End
   Begin VB.Label SDMLogo 
      Alignment       =   2  'Center
      Appearance      =   0  'Flat
      BackColor       =   &H0000C000&
      BorderStyle     =   1  'Fixed Single
      Caption         =   "ArcSDM3"
      BeginProperty Font 
         Name            =   "Roman"
         Size            =   14.25
         Charset         =   255
         Weight          =   700
         Underline       =   0   'False
         Italic          =   -1  'True
         Strikethrough   =   0   'False
      EndProperty
      ForeColor       =   &H0080FFFF&
      Height          =   375
      Left            =   600
      TabIndex        =   62
      Top             =   7680
      Width           =   1335
   End
   Begin VB.Label lbl_Att 
      Caption         =   "Select attribute field:"
      Height          =   255
      Left            =   3720
      TabIndex        =   39
      Top             =   8040
      Width           =   1575
   End
   Begin VB.Label lbt_SelGrd 
      BackColor       =   &H00E0E0E0&
      Caption         =   "Select raster:"
      ForeColor       =   &H00C00000&
      Height          =   255
      Left            =   360
      TabIndex        =   24
      Top             =   120
      Width           =   1095
   End
End
Attribute VB_Name = "gFZ"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit
Const c_sModuleFileName As String = "C:\MyJava\ARC-SDM\Dialogs\gFz.frm"
Const c_sDLLFileName As String = "CalculateFuzzyLogic"       ' Constant reflect file module name

Private Listeners As SDMUtilities.SDMListeners
Private WithEvents aCtl As SDMUtilities.SDMListeners
Attribute aCtl.VB_VarHelpID = -1
Private WithEvents docEvents As DocumentEvents
Attribute docEvents.VB_VarHelpID = -1
Private WithEvents mapEvents As map
Attribute mapEvents.VB_VarHelpID = -1
Private saveTable As IStandaloneTable

Private shiftDown As Boolean

Private ObjectTag As SDMUtilities.SDMList
Public Function isShiftdown() As Boolean
  On Error GoTo ErrorHandler

17:     isShiftdown = shiftDown
18:     shiftDown = False
  Exit Function
ErrorHandler:
  HandleError True, "isShiftDown " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), Err.Number, Err.Source, Err.Description, 4
End Function
Public Property Set setObjectTag(ByRef anObject As SDMUtilities.SDMList)
  On Error GoTo ErrorHandler
25:     Set ObjectTag = anObject
  Exit Property
ErrorHandler:
  HandleError True, "setObjectTag " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), Err.Number, Err.Source, Err.Description, 4
End Property

Public Property Get getObjectTag() As SDMUtilities.SDMList
  On Error GoTo ErrorHandler

34:     If (ObjectTag Is Nothing) Then
35:         Set getObjectTag = New SDMUtilities.SDMList
36:     Else
37:         Set getObjectTag = ObjectTag
38:     End If
  Exit Property
ErrorHandler:
  HandleError True, "getObjectTag " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), Err.Number, Err.Source, Err.Description, 4
End Property

Private Sub cbx_SelGrd_Click()
    On Error GoTo ErrorHandler
46:     UpdateFreeOrderedTheme Me.cbx_SelGrd.Text
47:     ClearOtherOptionButtons Nothing
48:     EnableOptionButtons (SDMGlobals.SDMdataDict.Gett(Trim(Me.cbx_SelGrd.Text)) = "Ordered")
49:     Me.getEars.BroadcastUpdate Me.cbx_SelGrd
  Exit Sub
ErrorHandler:
  HandleError False, "cbx_SelGrd_Click " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), Err.Number, Err.Source, Err.Description, 4
End Sub

Private Sub chk_Log_Click()
56:     MsgBox "Not implemented.", vbExclamation, gFZ.Caption
End Sub

Private Sub docEvents_ActiveViewChanged()
60:     Unload Me
End Sub

Private Sub docEvents_CloseDocument()
64:     Unload Me

End Sub

Private Sub docEvents_MapsChanged()
69:     Unload Me

End Sub

Private Sub docEvents_NewDocument()
74:     Unload Me

End Sub

Private Sub docEvents_OnContextMenu(ByVal X As Long, ByVal Y As Long, handled As Boolean)
79:     Unload Me

End Sub

Private Sub Form_Initialize()
84:     Set saveTable = Nothing
End Sub

Private Sub Form_KeyDown(KeyCode As Integer, Shift As Integer)
  On Error GoTo ErrorHandler
89:     shiftDown = (Shift And vbShiftMask) > 0
  Exit Sub
ErrorHandler:
  HandleError True, "Form_KeyDown " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), Err.Number, Err.Source, Err.Description, 4
End Sub
Private Sub Form_KeyUp(KeyCode As Integer, Shift As Integer)
  On Error GoTo ErrorHandler
96:     shiftDown = False
  Exit Sub
ErrorHandler:
  HandleError True, "Form_KeyUp " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), Err.Number, Err.Source, Err.Description, 4
End Sub

Public Property Get getEars() As SDMUtilities.SDMListeners
  On Error GoTo ErrorHandler
104:     Set getEars = Listeners
  Exit Property
ErrorHandler:
  HandleError True, "getEars " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), Err.Number, Err.Source, Err.Description, 4
End Property

'Include selections for all controls with an update method
'Method could be local or belong to an instantiated object
Private Sub aCtl_UpdateEvt(ByRef ctl As Object)
    On Error GoTo ErrorHandler
    Select Case (ctl.Name)
        Case Me.cbx_SelGrd.Name
116:         Listeners.BroadcastUpdate Me.cbx_SelGrd
        Case Me.lbt_Apply.Name
118:             Me.lbt_Apply.Enabled = (Me.cbx_SelGrd.ListCount > 0) And _
                    (SDMGlobals.SDMdataDict.Gett(Trim(Me.cbx_SelGrd.Text)) = "Ordered") And _
                        (Me.rbt_Lin Or _
                        Me.rbt_MSLrg Or Me.rbt_MSVLrg Or Me.rbt_MSSLrg Or _
                        Me.rbt_MSSm Or Me.rbt_MSVSm Or Me.rbt_MSSm Or _
                        Me.rbt_Gauss Or Me.rbt_Lrg Or Me.rbt_Sm Or Me.rbt_Near Or _
                        Me.rbt_SGauss Or Me.rbt_SLrg Or Me.rbt_SSm Or Me.rbt_SNear Or _
                        Me.rbt_VGauss Or Me.rbt_VLrg Or Me.rbt_VSm Or Me.rbt_VNear)
        Case Me.lbt_Prev.Name
127:             Me.lbt_Prev.Enabled = (Me.cbx_SelGrd.ListCount > 0) And _
                       (Me.rbt_Lin Or Me.rbt_Gauss Or Me.rbt_Lrg Or Me.rbt_Sm Or Me.rbt_Near Or _
                        Me.rbt_MSLrg Or Me.rbt_MSVLrg Or Me.rbt_MSSLrg Or _
                        Me.rbt_MSSm Or Me.rbt_MSVSm Or Me.rbt_MSSm Or _
                        Me.rbt_SGauss Or Me.rbt_SLrg Or Me.rbt_SSm Or Me.rbt_SNear Or _
                        Me.rbt_VGauss Or Me.rbt_VLrg Or Me.rbt_VSm Or Me.rbt_VNear)
        Case Me.lbt_TblMtd.Name
134:            Me.lbt_TblMtd.Enabled = (Me.cbx_SelGrd.ListCount > 0) And _
                    (SDMGlobals.SDMdataDict.Gett(Trim((Me.cbx_SelGrd.Text))) = "Free")
        Case Me.cbx_Att.Name
                
        Case Else
139:             MsgBox "Update not found: " & ctl.Parent.Name, vbCritical, "gL.aCtl.Update"
140:     End Select
    Exit Sub
ErrorHandler:
  HandleError True, "getEars " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), Err.Number, Err.Source, Err.Description, 4
End Sub

Private Sub Form_Load()
         On Error GoTo ErrorHandler
148:     Me.Caption = "Define Fuzzy Memberships"
149:     Set Listeners = New SDMUtilities.SDMListeners
150:     Set aCtl = Listeners
151:    If SDMGlobals.SDMApp Is Nothing Then Set SDMGlobals.SDMApp = New AppRef
152:    If SDMGlobals.SDMDoc Is Nothing Then Set SDMGlobals.SDMDoc = SDMGlobals.SDMApp.Document
153:     If SDMGlobals.SDMMap Is Nothing Then
            Dim pMxDoc As IMxDocument
155:         Set pMxDoc = SDMGlobals.SDMDoc
156:         Set SDMGlobals.SDMMap = pMxDoc.FocusMap
157:     End If
158:    If SDMGlobals.SDMUtil Is Nothing Then
159:             Set SDMGlobals.SDMUtil = New SDMUtilities.SDMUtils
160:             Set SDMGlobals.SDMUtil.setAPP = SDMGlobals.SDMApp
161:         End If
162:    If SDMGlobals.SDMStatusBar Is Nothing Then Set SDMGlobals.SDMStatusBar = SDMGlobals.SDMApp.StatusBar
163:    If SDMGlobals.SDMHelp Is Nothing Then Set SDMGlobals.SDMHelp = New SDMUtilities.gSDI_Help
164:    If SDMGlobals.SDMdataDict Is Nothing Then Set SDMGlobals.SDMdataDict = New SDMUtilities.SDMDictionary
165:    If SDMGlobals.SDMWorkspace Is Nothing Then
            Dim cwdPath As String
            Dim lyr As IDataset
168:        Set lyr = SDMGlobals.SDMMap.layers.Next
169:        If Not lyr Is Nothing Then
170:            cwdPath = lyr.Workspace.PathName
171:        Else
172:            cwdPath = Environ("TEMP")
173:        End If
174:        Set SDMGlobals.SDMWorkspace = SDMGlobals.SDMUtil.openShapeFileWorkspace(cwdPath)
175:    End If
         
         Dim pRdDataTypes As gSDI_ReadDataTypes
178:     Set pRdDataTypes = New gSDI_ReadDataTypes
179:     pRdDataTypes.gSDI_ReadDataTypes

181:     shiftDown = False
    'Set the column parameters
183:     gFZ.MSHFlexGrid1.Cols = 3
184:     gFZ.MSHFlexGrid1.Rows = 10
185:     gFZ.MSHFlexGrid1.ColWidth(0) = 1000
186:     gFZ.MSHFlexGrid1.ColWidth(1) = 1500
187:     gFZ.MSHFlexGrid1.ColAlignmentFixed(0) = flexAlignCenterCenter
188:     gFZ.MSHFlexGrid1.ColAlignmentFixed(1) = flexAlignCenterCenter
189:     gFZ.MSHFlexGrid1.ColAlignment(0) = flexAlignCenterCenter
190:     gFZ.MSHFlexGrid1.ColAlignment(1) = flexAlignCenterCenter
191:     gFZ.MSHFlexGrid1.ColWidth(2) = 1500
192:     gFZ.MSHFlexGrid1.ColAlignmentFixed(2) = flexAlignCenterCenter
193:     gFZ.MSHFlexGrid1.ColAlignment(2) = flexAlignRightCenter
194:     gFZ.MSHFlexGrid1.TextMatrix(0, 2) = "Attribute"
195:     gFZ.MSHFlexGrid1.Width = 4300
    
    'Set column headers with field names
198:     gFZ.MSHFlexGrid1.TextMatrix(0, 0) = "Value"
199:     gFZ.MSHFlexGrid1.TextMatrix(0, 1) = "FMemShp"
200:     gFZ.MSHFlexGrid1.Visible = False

    'Set Significant figures
203:     Me.cbx_SigFig.Clear
204:     Me.cbx_SigFig.AddItem 1
205:     Me.cbx_SigFig.AddItem 2
206:     Me.cbx_SigFig.AddItem 3
207:     Me.cbx_SigFig.AddItem 4
208:     Me.cbx_SigFig.AddItem 5
209:     Me.cbx_SigFig.AddItem 6
210:     Me.cbx_SigFig.AddItem 7
211:     Me.cbx_SigFig.ListIndex = 0

213:     Me.getEars.SetListeners Me.cbx_SelGrd, Array(Me.lbt_Apply, Me.lbt_TblMtd, Me.lbt_Prev)
214:     Me.cbx_SelGrd_Update
215:     Me.getEars.BroadcastUpdate Me.cbx_SelGrd
216:     Me.lbt_Sav.Enabled = False
217:     Set saveTable = Nothing
218:     Me.cbx_Att.Visible = False
219:     Me.chk_LogMSLrg.Value = 0
220:     Me.chk_LogMSSm.Value = 0

         Exit Sub
ErrorHandler:
  HandleError True, "gFZ_Load " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), Err.Number, Err.Source, Err.Description, 4
End Sub

Function cbx_SelGrd_Update() As SDMUtilities.SDMList
  On Error GoTo ErrorHandler

         Dim lyrLst As New SDMUtilities.SDMList
         Dim enumLyr As IEnumLayer
232:     Set enumLyr = SDMGlobals.SDMMap.layers
         Dim aLyr As ILayer
234:     Set aLyr = enumLyr.Next
235:     Me.cbx_SelGrd.Clear
236:     While Not aLyr Is Nothing
237:        If TypeOf aLyr Is IRasterLayer Then
                Dim rlyr As IRasterLayer
239:            Set rlyr = aLyr
                Dim rasbands As IRasterBandCollection
241:            Set rasbands = rlyr.Raster
                Dim rasband As IRasterBand
243:            Set rasband = rasbands.item(0)
                Dim hasTbl As Boolean
245:            rasband.HasTable hasTbl
                Dim rasprops As IRasterProps
247:            Set rasprops = rlyr.Raster
248:            If Not hasTbl Or rasband.RasterDataset.Format <> "GRID" Then
249:                 ElseIf rasprops.IsInteger Then
250:                If Not UCase(rlyr.Name) Like "SDMUC*" Then
                        Dim rasStats As IRasterStatistics
252:                    Set rasStats = rasband.Statistics
253:                    If rasStats.Minimum >= 0 Then lyrLst.Add rlyr.Name
254:                End If
255:            End If
256:        End If
257:        Set aLyr = enumLyr.Next
258:     Wend
259:     lyrLst.Remove lyrLst.Count - 1
260:     Set lyrLst = lyrLst.Sort(True)
261:     RasterAEUtils.DefineFromList Me.cbx_SelGrd, lyrLst
262:     Me.cbx_SelGrd.ListIndex = 0

  Exit Function
ErrorHandler:
  HandleError True, "cbx_SelGrd_Update " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), Err.Number, Err.Source, Err.Description, 4
End Function


Private Sub lbt_Apply_Click()
  On Error GoTo ErrorHandler
272:     If Me.getSelectedFuzzification = "Unknown" Then
273:        MsgBox "Fuzzy function not selected.", vbExclamation, "Apply Fuzzy Function"
            Exit Sub
275:     End If
276:     Me.MSHFlexGrid1.Rows = 2
277:     gFzTbl_Open.gFzTbl_Open vbModeless, "Ordered"
278:     Me.MSHFlexGrid1.Visible = True
279:     Me.cbx_Att.Visible = True
280:     Me.lbt_OK.Tag = Me.getSelectedFuzzification & ", " & Me.cbx_SigFig.Text
281:     Me.lbl_msg = "Select an attribute and fuzzify:" & Me.lbt_OK.Tag
282:     lbt_Fuzz_Click
283:     Set saveTable = Nothing
284:     Me.lbt_Prev.Enabled = True
285:             Me.ZOrder 0
  Exit Sub
ErrorHandler:
  HandleError False, "lbt_Apply_Click " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), Err.Number, Err.Source, Err.Description, 4
End Sub

Private Sub lbt_Can_Click()
  On Error GoTo ErrorHandler

294:     Unload Me

  Exit Sub
ErrorHandler:
  HandleError False, "lbt_Can_Click " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), Err.Number, Err.Source, Err.Description, 4
End Sub

Private Sub DisableAll()
  On Error GoTo ErrorHandler

    Dim aCtl As Control
305:     For Each aCtl In Me.Controls
306:         If TypeOf aCtl Is TextBox Then
            Dim txtCtl As TextBox
308:             Set txtCtl = aCtl
309:             txtCtl.Enabled = False
310:         End If
311:     Next aCtl


  Exit Sub
ErrorHandler:
  HandleError False, "DisableAll " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), Err.Number, Err.Source, Err.Description, 4
End Sub
Private Sub EnableOptionButtons(State As Boolean)
    Dim ctl As Control
320:     For Each ctl In gFZ.Controls
321:         If TypeOf ctl Is OptionButton Then
                 Dim optBtn As OptionButton
323:             Set optBtn = ctl
324:             optBtn.Enabled = State
325:             optBtn.Value = False
326:         End If
327:     Next ctl
End Sub
Private Sub ClearOtherOptionButtons(ExceptArg As OptionButton)
  On Error GoTo ErrorHandler
    Dim Except As OptionButton
332:     If (Me.cbx_SelGrd.ListCount > 0) And _
                    (SDMGlobals.SDMdataDict.Gett(Trim(Me.cbx_SelGrd.Text)) = "Free") Then _
                    Set Except = Nothing Else Set Except = ExceptArg
         Dim aCtl As Control
336:     For Each aCtl In Me.Controls
337:         If TypeOf aCtl Is OptionButton Then
338:             If (Not aCtl Is Except) Or (Except Is Nothing) Then
                     Dim radCtl As OptionButton
340:                 Set radCtl = aCtl
341:                 If radCtl.Value Then radCtl.Value = False
342:                 If Right(radCtl.Name, Len("Gauss")) = "Gauss" Then
343:                     Me.txt_MPGauss.Enabled = False
344:                     Me.txt_SprdGauss.Enabled = False
345:                 ElseIf Right(radCtl.Name, Len("MSSm")) = "MSSm" Then
346:                     Me.txt_MPMSSm.Enabled = False
347:                     Me.txt_SprdMSSm.Enabled = False
348:                     Me.chk_LogMSSm.Enabled = False
349:                     Me.chk_LogMSSm.Value = 0
350:                 ElseIf Right(radCtl.Name, Len("Sm")) = "Sm" Then
351:                     Me.txt_MPSm.Enabled = False
352:                     Me.txt_SprdSm.Enabled = False
353:                 ElseIf Right(radCtl.Name, Len("MSLrg")) = "MSLrg" Then
354:                     Me.txt_MPMSLrg.Enabled = False
355:                     Me.txt_SprdMSLrg.Enabled = False
356:                     Me.chk_LogMSLrg.Enabled = False
357:                     Me.chk_LogMSLrg.Value = 0
358:                 ElseIf Right(radCtl.Name, Len("Lrg")) = "Lrg" Then
359:                     Me.txt_MPLrg.Enabled = False
360:                     Me.txt_SprdLrg.Enabled = False
361:                 ElseIf Right(radCtl.Name, Len("Near")) = "Near" Then
362:                     Me.txt_MPNear.Enabled = False
363:                     Me.txt_SprdNear.Enabled = False
364:                 ElseIf Right(radCtl.Name, Len("Lin")) = "Lin" Then
365:                     Me.txt_Mbr0Lin.Enabled = False
366:                     Me.txt_Mbr1Lin.Enabled = False
367:                 End If
368:             End If
369:         End If
370:     Next aCtl
371:     If Except Is Nothing Then Me.lbt_Apply.Enabled = False


  Exit Sub
ErrorHandler:
  HandleError False, "ClearOtherOptionButtons " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), Err.Number, Err.Source, Err.Description, 4
End Sub


Private Sub lbt_Ld_Click()
  On Error GoTo ErrorHandler
         Dim tmpDir As String
383:     tmpDir = WOETableUtils.getProjectDir
         Dim fName As Variant
385:     fName = FileDialog.GetReadFileName("Load Fuzzy Table", tmpDir, "FZ*.dbf")
386:          If IsEmpty(fName) Then
387:             Me.ZOrder 0
            Exit Sub
389:         End If
         Dim ldTbl As ITable
391:     Set ldTbl = WOETableUtils.OpenTable(CStr(fName(1)), CStr(fName(0)))
         Dim nrows As Long
393:     nrows = ldTbl.RowCount(Nothing)
394:     gFZ.MSHFlexGrid1.Rows = 2
    
         Dim valIdx As Long
397:     valIdx = ldTbl.FindField("Value")
         Dim fmIdx As Long
399:     fmIdx = ldTbl.FindField("FuzyMbrShp")
         Dim attIdx As Long
401:     attIdx = fmIdx + 1
         Dim attrName As String
403:     attrName = ldTbl.Fields.Field(attIdx).Name
404:     Me.MSHFlexGrid1.TextMatrix(0, 2) = attrName
         
         Dim tblrow As Long
407:     tblrow = 1
         Dim curs As ICursor
409:     Set curs = ldTbl.Search(Nothing, False)
         Dim row As IRow
411:     Set row = curs.NextRow
412:     While Not row Is Nothing
         Dim val As Long
414:         val = row.Value(valIdx)
             Dim fzmbr As Double
416:         fzmbr = row.Value(fmIdx)
             Dim attrib As Variant
418:         attrib = row.Value(attIdx)
419:         If tblrow > 1 Then
420:             gFZ.MSHFlexGrid1.AddItem CStr(val) & vbTab & CStr(fzmbr) & vbTab & CStr(attrib), tblrow
421:         Else
422:             gFZ.MSHFlexGrid1.TextMatrix(tblrow, 0) = CStr(val)
423:             gFZ.MSHFlexGrid1.TextMatrix(tblrow, 1) = CStr(fzmbr)
424:             gFZ.MSHFlexGrid1.TextMatrix(tblrow, 2) = CStr(attrib)
425:         End If
426:         If attIdx > -1 Then
                 Dim attr As String
428:             attr = row.Value(attIdx)
429:         End If
430:         tblrow = tblrow + 1
431:         Set row = curs.NextRow
432:     Wend
433:     Me.lbl_Att.Caption = CStr(fName(1))
434:     Me.MSHFlexGrid1.Visible = True
435:     Me.lbt_Prev.Enabled = True
436:     If Me.lbt_Prev.Tag = "" Then
437:       If (MsgBox("Ordered Members?", vbYesNo, "Loading Fuzzy Members") = vbYes) Then
438:           Me.lbt_Prev.Tag = "Ordered"
439:       Else
440:           Me.lbt_Prev.Tag = "Free"
441:       End If
442:     End If
443:     Me.lbt_Apply.Enabled = Me.lbt_Prev.Tag = "Ordered"
444:     Me.lbt_TblMtd.Enabled = Not Me.lbt_Apply.Enabled
445:         Me.ZOrder 0
         Exit Sub
ErrorHandler:
  HandleError False, "lbt_Ld_Click " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), Err.Number, Err.Source, Err.Description, 4
End Sub

Private Sub lbt_TblMtd_Click()
  On Error GoTo ErrorHandler

    If MsgBox("Enter membership values in the range 0-" & 10 ^ CDbl(Me.cbx_SigFig) & " for """ & Me.cbx_SelGrd.Text & """." & vbCrLf & "Continue?", vbOKCancel, "Table Method") = vbCancel Then Exit Sub
    'Unload gFzTbl
456:     Me.MSHFlexGrid1.Rows = 2
457:     gFzTbl_Open.gFzTbl_Open vbModeless, "Free"
458:     Me.MSHFlexGrid1.Visible = True
459:     Me.cbx_Att.Visible = True
460:     Me.lbt_OK.Tag = "Table: FM"
461:     Me.lbl_msg = "Enter membership values in the range 0-" & 10 ^ CDbl(Me.cbx_SigFig) & ":"
462:     Me.MSHFlexGrid1.TextMatrix(1, 1) = ""
463:     Set saveTable = Nothing
464:     Me.lbt_Prev.Enabled = True
465:         Me.ZOrder 0
  Exit Sub
ErrorHandler:
  HandleError False, "lbt_TblMtd_Click " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), Err.Number, Err.Source, Err.Description, 4
End Sub

Private Sub mapEvents_ContentsChanged()
472:     Me.getEars.Update Me.cbx_SelGrd
End Sub

Private Sub mapEvents_ContentsCleared()
476:     Me.getEars.Update Me.cbx_SelGrd

End Sub

Private Sub mapEvents_ItemAdded(ByVal item As Variant)
481:     Me.getEars.Update Me.cbx_SelGrd

End Sub

Private Sub mapEvents_ItemDeleted(ByVal item As Variant)
486:     Me.getEars.Update Me.cbx_SelGrd

End Sub

Private Sub mapEvents_ItemReordered(ByVal item As Variant, ByVal toIndex As Long)
491:     Me.getEars.Update Me.cbx_SelGrd

End Sub

Private Sub mapEvents_ViewRefreshed(ByVal View As esriCarto.IActiveView, ByVal phase As esriCarto.esriViewDrawPhase, ByVal data As Variant, ByVal Envelope As esriGeometry.IEnvelope)
496:     Me.getEars.Update Me.cbx_SelGrd

End Sub

Private Sub rbt_Lrg_Click()
  On Error GoTo ErrorHandler

503:     ClearOtherOptionButtons Me.rbt_Lrg
504:     Me.txt_MPLrg.Enabled = True
505:     Me.txt_SprdLrg.Enabled = True
506:     Me.lbt_Apply.Enabled = SDMGlobals.SDMdataDict.Gett(Trim(Me.cbx_SelGrd.Text)) = "Ordered"


  Exit Sub
ErrorHandler:
  HandleError False, "rbt_Lrg_Click " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), Err.Number, Err.Source, Err.Description, 4
End Sub

Private Sub rbt_MSLrg_Click()
  On Error GoTo ErrorHandler

517:     ClearOtherOptionButtons Me.rbt_MSLrg
518:     Me.txt_MPMSLrg.Enabled = True
519:     Me.txt_SprdMSLrg.Enabled = True
520:     Me.lbt_Apply.Enabled = SDMGlobals.SDMdataDict.Gett(Trim(Me.cbx_SelGrd.Text)) = "Ordered"
521:     Me.chk_LogMSLrg.Enabled = True

  Exit Sub
ErrorHandler:
  HandleError False, "rbt_MSLrg_Click " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), Err.Number, Err.Source, Err.Description, 4
End Sub

Private Sub rbt_MSSLrg_Click()
  On Error GoTo ErrorHandler
530:     ClearOtherOptionButtons Me.rbt_MSSLrg
531:     Me.txt_MPMSLrg.Enabled = True
532:     Me.txt_SprdMSLrg.Enabled = True
533:     Me.lbt_Apply.Enabled = SDMGlobals.SDMdataDict.Gett(Trim(Me.cbx_SelGrd.Text)) = "Ordered"
534:     Me.chk_LogMSLrg.Enabled = True

  Exit Sub
ErrorHandler:
  HandleError False, "rbt_MSSLrg_Click " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), Err.Number, Err.Source, Err.Description, 4
End Sub

Private Sub rbt_MSSm_Click()
  On Error GoTo ErrorHandler

544:     ClearOtherOptionButtons Me.rbt_MSSm
545:     Me.txt_MPMSSm.Enabled = True
546:     Me.txt_SprdMSSm.Enabled = True
547:     Me.lbt_Apply.Enabled = SDMGlobals.SDMdataDict.Gett(Trim(Me.cbx_SelGrd.Text)) = "Ordered"
548:     Me.chk_LogMSSm.Enabled = True



  Exit Sub
ErrorHandler:
  HandleError False, "rbt_MSSm_Click " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), Err.Number, Err.Source, Err.Description, 4
End Sub

Private Sub rbt_MSSSm_Click()
  On Error GoTo ErrorHandler

560:     ClearOtherOptionButtons Me.rbt_MSSSm
561:     Me.txt_MPMSSm.Enabled = True
562:     Me.txt_SprdMSSm.Enabled = True
563:          Me.chk_LogMSSm.Enabled = True
564:     Me.lbt_Apply.Enabled = SDMGlobals.SDMdataDict.Gett(Trim(Me.cbx_SelGrd.Text)) = "Ordered"



  Exit Sub
ErrorHandler:
  HandleError False, "rbt_MSSSm_Click " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), Err.Number, Err.Source, Err.Description, 4
End Sub

Private Sub rbt_MSVLrg_Click()
  On Error GoTo ErrorHandler

576:     ClearOtherOptionButtons Me.rbt_MSVLrg
577:     Me.txt_MPMSLrg.Enabled = True
578:     Me.txt_SprdMSLrg.Enabled = True
579:     Me.chk_LogMSLrg.Enabled = True
580:     Me.lbt_Apply.Enabled = SDMGlobals.SDMdataDict.Gett(Trim(Me.cbx_SelGrd.Text)) = "Ordered"



  Exit Sub
ErrorHandler:
  HandleError False, "rbt_MSVLrg_Click " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), Err.Number, Err.Source, Err.Description, 4
End Sub

Private Sub rbt_MSVSm_Click()
  On Error GoTo ErrorHandler

592:     ClearOtherOptionButtons Me.rbt_MSVSm
593:     Me.txt_MPMSSm.Enabled = True
594:     Me.txt_SprdMSSm.Enabled = True
595:     Me.chk_LogMSSm.Enabled = True
596:     Me.lbt_Apply.Enabled = SDMGlobals.SDMdataDict.Gett(Trim(Me.cbx_SelGrd.Text)) = "Ordered"



  Exit Sub
ErrorHandler:
  HandleError False, "rbt_MSVSm_Click " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), Err.Number, Err.Source, Err.Description, 4
End Sub

Private Sub rbt_sLrg_Click()
  On Error GoTo ErrorHandler

608:     ClearOtherOptionButtons Me.rbt_SLrg
609:     Me.txt_MPLrg.Enabled = True
610:     Me.txt_SprdLrg.Enabled = True
611:     Me.lbt_Apply.Enabled = SDMGlobals.SDMdataDict.Gett(Trim(Me.cbx_SelGrd.Text)) = "Ordered"


  Exit Sub
ErrorHandler:
  HandleError False, "rbt_sLrg_Click " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), Err.Number, Err.Source, Err.Description, 4
End Sub
Private Sub rbt_vLrg_Click()
  On Error GoTo ErrorHandler

621:     ClearOtherOptionButtons Me.rbt_VLrg
622:     Me.txt_MPLrg.Enabled = True
623:     Me.txt_SprdLrg.Enabled = True
624:     Me.lbt_Apply.Enabled = SDMGlobals.SDMdataDict.Gett(Trim(Me.cbx_SelGrd.Text)) = "Ordered"


  Exit Sub
ErrorHandler:
  HandleError False, "rbt_vLrg_Click " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), Err.Number, Err.Source, Err.Description, 4
End Sub

Private Sub rbt_Lin_Click()
  On Error GoTo ErrorHandler

635:     ClearOtherOptionButtons Me.rbt_Lin
636:     Me.txt_Mbr0Lin.Enabled = True
637:     Me.txt_Mbr1Lin.Enabled = True
638:     Me.lbt_Apply.Enabled = SDMGlobals.SDMdataDict.Gett(Trim(Me.cbx_SelGrd.Text)) = "Ordered"

  Exit Sub
ErrorHandler:
  HandleError False, "rbt_Lin_Click " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), Err.Number, Err.Source, Err.Description, 4
End Sub

Private Sub rbt_Sm_Click()
  On Error GoTo ErrorHandler

648:     ClearOtherOptionButtons Me.rbt_Sm
649:     Me.txt_MPSm.Enabled = True
650:     Me.txt_SprdSm.Enabled = True
651:     Me.lbt_Apply.Enabled = SDMGlobals.SDMdataDict.Gett(Trim(Me.cbx_SelGrd.Text)) = "Ordered"

  Exit Sub
ErrorHandler:
  HandleError False, "rbt_Sm_Click " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), Err.Number, Err.Source, Err.Description, 4
End Sub
Private Sub rbt_sSM_Click()
  On Error GoTo ErrorHandler

660:     ClearOtherOptionButtons Me.rbt_SSm

662:     Me.txt_MPSm.Enabled = True
663:     Me.txt_SprdSm.Enabled = True
664:     Me.lbt_Apply.Enabled = SDMGlobals.SDMdataDict.Gett(Trim(Me.cbx_SelGrd.Text)) = "Ordered"
  Exit Sub
ErrorHandler:
  HandleError False, "rbt_sSM_Click " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), Err.Number, Err.Source, Err.Description, 4
End Sub
Private Sub rbt_vSM_Click()
  On Error GoTo ErrorHandler

672:     ClearOtherOptionButtons Me.rbt_VSm
673:     Me.txt_MPSm.Enabled = True
674:     Me.txt_SprdSm.Enabled = True
675:     Me.lbt_Apply.Enabled = SDMGlobals.SDMdataDict.Gett(Trim(Me.cbx_SelGrd.Text)) = "Ordered"


  Exit Sub
ErrorHandler:
  HandleError False, "rbt_vSM_Click " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), Err.Number, Err.Source, Err.Description, 4
End Sub
Private Sub rbt_Near_Click()
  On Error GoTo ErrorHandler

685:     ClearOtherOptionButtons Me.rbt_Near
686:     Me.txt_MPNear.Enabled = True
687:     Me.txt_SprdNear.Enabled = True
688:     Me.lbt_Apply.Enabled = SDMGlobals.SDMdataDict.Gett(Trim(Me.cbx_SelGrd.Text)) = "Ordered"


  Exit Sub
ErrorHandler:
  HandleError False, "rbt_Near_Click " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), Err.Number, Err.Source, Err.Description, 4
End Sub
Private Sub rbt_sNear_Click()
  On Error GoTo ErrorHandler

698:     ClearOtherOptionButtons Me.rbt_SNear
699:     Me.txt_MPNear.Enabled = True
700:     Me.txt_SprdNear.Enabled = True
701:     Me.lbt_Apply.Enabled = SDMGlobals.SDMdataDict.Gett(Trim(Me.cbx_SelGrd.Text)) = "Ordered"


  Exit Sub
ErrorHandler:
  HandleError False, "rbt_sNear_Click " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), Err.Number, Err.Source, Err.Description, 4
End Sub
Private Sub rbt_vNear_Click()
  On Error GoTo ErrorHandler

711:     ClearOtherOptionButtons Me.rbt_VNear
712:     Me.txt_MPNear.Enabled = True
713:     Me.txt_SprdNear.Enabled = True
714:     Me.lbt_Apply.Enabled = SDMGlobals.SDMdataDict.Gett(Trim(Me.cbx_SelGrd.Text)) = "Ordered"


  Exit Sub
ErrorHandler:
  HandleError False, "rbt_vNear_Click " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), Err.Number, Err.Source, Err.Description, 4
End Sub
Private Sub rbt_Gauss_Click()
  On Error GoTo ErrorHandler

724:     ClearOtherOptionButtons Me.rbt_Gauss
725:     Me.txt_MPGauss.Enabled = True
726:     Me.txt_SprdGauss.Enabled = True
727:     Me.lbt_Apply.Enabled = SDMGlobals.SDMdataDict.Gett(Trim(Me.cbx_SelGrd.Text)) = "Ordered"



  Exit Sub
ErrorHandler:
  HandleError False, "rbt_Gauss_Click " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), Err.Number, Err.Source, Err.Description, 4
End Sub
Private Sub rbt_sGauss_Click()
  On Error GoTo ErrorHandler

738:     ClearOtherOptionButtons Me.rbt_SGauss
739:     Me.txt_MPGauss.Enabled = True
740:     Me.txt_SprdGauss.Enabled = True
741:     Me.lbt_Apply.Enabled = SDMGlobals.SDMdataDict.Gett(Trim(Me.cbx_SelGrd.Text)) = "Ordered"


  Exit Sub
ErrorHandler:
  HandleError False, "rbt_sGauss_Click " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), Err.Number, Err.Source, Err.Description, 4
End Sub
Private Sub rbt_vGauss_Click()
  On Error GoTo ErrorHandler

751:     ClearOtherOptionButtons Me.rbt_VGauss
752:     Me.txt_MPGauss.Enabled = True
753:     Me.txt_SprdGauss.Enabled = True
754:     Me.lbt_Apply.Enabled = SDMGlobals.SDMdataDict.Gett(Trim(Me.cbx_SelGrd.Text)) = "Ordered"


  Exit Sub
ErrorHandler:
  HandleError False, "rbt_vGauss_Click " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), Err.Number, Err.Source, Err.Description, 4
End Sub

Function getSelectedFuzzification() As String
  On Error GoTo ErrorHandler

765:     If Me.rbt_Gauss Then
766:         getSelectedFuzzification = "Gauss, " & Me.txt_MPGauss & ", " & Me.txt_SprdGauss
767:     ElseIf Me.rbt_SGauss Then
768:         getSelectedFuzzification = "S.Gauss, " & Me.txt_MPGauss & ", " & Me.txt_SprdGauss
769:     ElseIf Me.rbt_VGauss Then
770:         getSelectedFuzzification = "V.Gauss, " & Me.txt_MPGauss & ", " & Me.txt_SprdGauss
771:     ElseIf Me.rbt_Near Then
772:         getSelectedFuzzification = "Near, " & Me.txt_MPNear & ", " & Me.txt_SprdNear
773:     ElseIf Me.rbt_SNear Then
774:         getSelectedFuzzification = "S.Near, " & Me.txt_MPNear & ", " & Me.txt_SprdNear
775:     ElseIf Me.rbt_VNear Then
776:         getSelectedFuzzification = "V.Near, " & Me.txt_MPNear & ", " & Me.txt_SprdNear
777:     ElseIf Me.rbt_Sm Then
778:         getSelectedFuzzification = "Small, " & Me.txt_MPSm & ", " & Me.txt_SprdSm
779:     ElseIf Me.rbt_SSm Then
780:         getSelectedFuzzification = "S.Small, " & Me.txt_MPSm & ", " & Me.txt_SprdSm
781:     ElseIf Me.rbt_VSm Then
782:         getSelectedFuzzification = "V.Small, " & Me.txt_MPSm & ", " & Me.txt_SprdSm
783:     ElseIf Me.rbt_MSSm Then
784:         getSelectedFuzzification = lgSm & "MSSmall, " & Me.txt_MPMSSm & ", " & Me.txt_SprdMSSm
785:     ElseIf Me.rbt_MSSSm Then
786:         getSelectedFuzzification = lgSm & "S.MSSmall, " & Me.txt_MPMSSm & ", " & Me.txt_SprdMSSm
787:     ElseIf Me.rbt_MSVSm Then
788:         getSelectedFuzzification = lgSm & "V.MSSmall, " & Me.txt_MPMSSm & ", " & Me.txt_SprdMSSm
789:     ElseIf Me.rbt_Lrg Then
790:         getSelectedFuzzification = "Large, " & Me.txt_MPLrg & ", " & Me.txt_SprdLrg
791:     ElseIf Me.rbt_SLrg Then
792:         getSelectedFuzzification = "S.Large, " & Me.txt_MPLrg & ", " & Me.txt_SprdLrg
793:     ElseIf Me.rbt_VLrg Then
794:         getSelectedFuzzification = "V.Large, " & Me.txt_MPLrg & ", " & Me.txt_SprdLrg
795:     ElseIf Me.rbt_MSLrg Then
796:         getSelectedFuzzification = lgLrg & "MSLarge, " & Me.txt_MPMSLrg & ", " & Me.txt_SprdMSLrg
797:     ElseIf Me.rbt_MSSLrg Then
798:         getSelectedFuzzification = lgLrg & "S.MSLarge, " & Me.txt_MPMSLrg & ", " & Me.txt_SprdMSLrg
799:     ElseIf Me.rbt_MSVLrg Then
800:         getSelectedFuzzification = lgLrg & "V.MSLarge, " & Me.txt_MPMSLrg & ", " & Me.txt_SprdMSLrg
801:     ElseIf Me.rbt_Lin Then
802:         getSelectedFuzzification = "Linear, " & Me.txt_Mbr0Lin & ", " & Me.txt_Mbr1Lin
803:     Else
804:         getSelectedFuzzification = "Unknown"
805:     End If


  Exit Function
ErrorHandler:
  HandleError True, "getSelectedFuzzification " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), Err.Number, Err.Source, Err.Description, 4
End Function

Public Property Get getSaveTable() As IStandaloneTable
  On Error GoTo ErrorHandler
815:     Set getSaveTable = saveTable
  Exit Property
ErrorHandler:
  HandleError True, "getSaveTable " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), Err.Number, Err.Source, Err.Description, 4
End Property

Private Sub cbx_Att_click()
  On Error GoTo ErrorHandler

    Dim evLayer As IRasterLayer
825:     Set evLayer = WOETableUtils.FindLayerByName(Me.cbx_SelGrd)
        Dim evTbl As ITable
827:     Set evTbl = evLayer
        Dim fldIdx As Long
829:     fldIdx = evTbl.FindField(Me.cbx_Att.Text)
        If fldIdx = -1 Then Exit Sub
        Dim tokens As Variant
832:     tokens = Split(evTbl.Fields.Field(fldIdx).Name, ".")
833:     If UBound(tokens) = 1 Then
834:         Me.MSHFlexGrid1.TextMatrix(0, 2) = tokens(1)
835:     Else
836:         Me.MSHFlexGrid1.TextMatrix(0, 2) = tokens(0)
837:     End If
        Dim curs As ICursor
839:     Set curs = evTbl.Search(Nothing, False)
        Dim rw As IRow
841:     Set rw = curs.NextRow
        Dim i As Long
843:     i = 1
844:     While Not rw Is Nothing
845:         Me.MSHFlexGrid1.TextMatrix(i, 2) = rw.Value(fldIdx)
846:         Set rw = curs.NextRow
847:         i = i + 1
848:     Wend


  Exit Sub
ErrorHandler:
  HandleError False, "cbx_Att_click " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), Err.Number, Err.Source, Err.Description, 4
End Sub

'Private Sub lbt_Can_Click()
'37:     Unload Me
'End Sub

Private Sub lbt_Fuzz_Click()
  On Error GoTo ErrorHandler

    Dim fzVal As Double
    Dim X As Double
    Dim f1 As Double, f2 As Double
    Dim nRow As Long
    Dim nrows As Long
868: Const fmt As String = "0.00"
869: nrows = Me.MSHFlexGrid1.Rows
    Dim C As Double
871: C = 10# ^ CDbl(Me.cbx_SigFig.Text)
872:     If Me.rbt_Lin Then
873:         If Me.txt_Mbr0Lin = 0 And Me.txt_Mbr1Lin = 0 Then
874:             MsgBox "Member0 and Member1 not set", vbExclamation, c_sModuleFileName
                Exit Sub
876:         End If
            Dim mbr0 As Long, mbr1 As Long
878:         mbr0 = CLng(Me.txt_Mbr0Lin)
879:         mbr1 = CLng(Me.txt_Mbr1Lin)
            Dim val As Long
881:         If mbr0 <= mbr1 Then
882:             For nRow = 1 To nrows - 1
883:                 val = CLng(Me.MSHFlexGrid1.TextMatrix(nRow, 0))
884:                 If val <= mbr0 Then
885:                     fzVal = 0
886:                 ElseIf val >= mbr1 Then
887:                     fzVal = C
888:                 Else
889:                   If (mbr1 - mbr0) = 0 Then
890:                       MsgBox "Division by zero", vbExclamation, c_sModuleFileName, ""
                                Exit Sub
892:                   End If
893:                     fzVal = (val - mbr0) * C / (mbr1 - mbr0)
894:                 End If
895:                 Me.MSHFlexGrid1.TextMatrix(nRow, 1) = Format(fzVal, fmt)
896:             Next nRow
897:         Else
898:             For nRow = 1 To nrows - 1
899:                 val = CLng(Me.MSHFlexGrid1.TextMatrix(nRow, 0))
900:                 If val <= mbr1 Then
901:                     fzVal = C
902:                 ElseIf val >= mbr0 Then
903:                     fzVal = 0
904:                 Else
905:               If (mbr1 - mbr0) = 0 Then
906:                   MsgBox "Division by zero", vbExclamation, c_sModuleFileName, ""
                            Exit Sub
908:                End If
909:                     fzVal = (val - mbr0) * C / (mbr1 - mbr0)
910:                 End If
911:                 Me.MSHFlexGrid1.TextMatrix(nRow, 1) = Format(fzVal, fmt)
912:             Next nRow
913:         End If
914:     ElseIf Me.rbt_Gauss Or Me.rbt_SGauss Or Me.rbt_VGauss Then
915:         f2 = CDbl(Me.txt_MPGauss.Text)
916:         f1 = CDbl(Me.txt_SprdGauss.Text)
917:         For nRow = 1 To nrows - 1
918:             X = CDbl(Me.MSHFlexGrid1.TextMatrix(nRow, 0))
919:             fzVal = Exp(-f1 * ((X - f2) ^ 2))
920:             If Me.rbt_SGauss Then
921:                 If fzVal < 0 Then
922:                     MsgBox "Somewhat value < 0", vbExclamation, c_sModuleFileName
                        Exit Sub
924:                 End If
925:                 fzVal = Sqr(fzVal)
926:             ElseIf Me.rbt_VGauss Then
927:                 fzVal = fzVal ^ 2
928:             End If
929:             fzVal = fzVal * C
930:             Me.MSHFlexGrid1.TextMatrix(nRow, 1) = Format(fzVal, fmt)
931:         Next nRow
932:     ElseIf Me.rbt_Lrg Or Me.rbt_SLrg Or Me.rbt_VLrg Then
933:         f2 = CDbl(Me.txt_MPLrg.Text)
934:         f1 = CDbl(Me.txt_SprdLrg.Text)
                Dim f1WholeNum As Boolean
936:          If CLng(f1) = 0 Then
937:                   MsgBox "Division by zero", vbExclamation, c_sModuleFileName, ""
                            Exit Sub
939:          End If
940:         f1WholeNum = (f1 / CLng(f1)) <> 1
941:         For nRow = 1 To nrows - 1
942:             X = CDbl(Me.MSHFlexGrid1.TextMatrix(nRow, 0))
943:             If (X < 0) And (Not f1WholeNum) Then
944:                    MsgBox "Midpoint Value not a whole number!", vbExclamation, "Large Fuzzy Function"
                        Exit Sub
946:             ElseIf X = 0 Then
947:                fzVal = 0
948:             Else
949:               If f2 = 0 Then
950:                   MsgBox "Division by zero", vbExclamation, c_sModuleFileName, ""
                            Exit Sub
952:                End If
953:               If (1 + ((X / f2) ^ (-f1))) = 0 Then
954:                   MsgBox "Division by zero", vbExclamation, c_sModuleFileName, ""
                            Exit Sub
956:                End If
957:                fzVal = 1 / (1 + ((X / f2) ^ (-f1)))
958:             End If
959:             If Me.rbt_VLrg Then
960:                 If fzVal < 0 Then
961:                     MsgBox "Very Large value < 0!", vbExclamation, "Large Fuzzy Function"
                         Exit Sub
963:                 End If
964:                 fzVal = Sqr(fzVal)
965:             ElseIf Me.rbt_SLrg Then
966:                 fzVal = fzVal ^ 2
967:             End If
968:             fzVal = fzVal * C
969:             Me.MSHFlexGrid1.TextMatrix(nRow, 1) = Format(fzVal, fmt)
970:         Next nRow
971:     ElseIf Me.rbt_MSLrg Or Me.rbt_MSSLrg Or Me.rbt_MSVLrg Then
             Dim raslyr As IRasterLayer
973:         Set raslyr = WOETableUtils.FindLayerByName(Me.cbx_SelGrd)
974:         If raslyr Is Nothing Then
975:                 MsgBox Me.cbx_SelGrd & " layer not found.", vbCritical, "Fuzzy Function"
                     Exit Sub
977:         End If
             Dim m As Double, s As Double, logData As Boolean
979:         logData = Me.chk_LogMSLrg.Value = 1
980:         RasterStats logData, raslyr, m, s
             Dim a As Double, b As Double
982:         a = CDbl(Me.txt_MPMSLrg.Text)
983:         b = CDbl(Me.txt_SprdMSLrg.Text)
984:         For nRow = 1 To nrows - 1
985:             X = CDbl(Me.MSHFlexGrid1.TextMatrix(nRow, 0))
986:             If (Me.chk_LogMSLrg.Value = 1) Then X = Log(X) / Log(10#)
987:             If X > a * m Then
988:               If (X - a * m + b * s) = 0 Then
989:                   MsgBox "Division by zero", vbExclamation, c_sModuleFileName, ""
                            Exit Sub
991:                End If
992:                fzVal = 1 - (b * s) / (X - a * m + b * s)
993:             Else
994:                fzVal = 0
995:             End If
996:             If Me.rbt_MSVLrg Then
997:                 If fzVal < 0 Then
998:                     MsgBox "Somewhat value < 0", vbExclamation, c_sModuleFileName
                        Exit Sub
1000:                 End If
1001:                 fzVal = Sqr(fzVal)
1002:             ElseIf Me.rbt_MSSLrg Then
1003:                 fzVal = fzVal ^ 2
1004:             End If
1005:             fzVal = fzVal * C
1006:             Me.MSHFlexGrid1.TextMatrix(nRow, 1) = Format(fzVal, fmt)
1007:         Next nRow
1008:     ElseIf Me.rbt_Sm Or Me.rbt_SSm Or Me.rbt_VSm Then
1009:         f2 = CDbl(Me.txt_MPSm.Text)
1010:         f1 = CDbl(Me.txt_SprdSm.Text)
1011:         For nRow = 1 To nrows - 1
1012:             X = CDbl(Me.MSHFlexGrid1.TextMatrix(nRow, 0))
1013:               If f2 = 0 Then
1014:                   MsgBox "Division by zero", vbExclamation, c_sModuleFileName, ""
                            Exit Sub
1016:                End If
1017:               If (1 + ((X / f2) ^ f1)) = 0 Then
1018:                   MsgBox "Division by zero", vbExclamation, c_sModuleFileName, ""
                            Exit Sub
1020:                End If
1021:             fzVal = 1 / (1 + ((X / f2) ^ f1))
1022:             If Me.rbt_SSm Then
1023:                 If fzVal < 0 Then
1024:                     MsgBox "Somewhat value < 0", vbExclamation, c_sModuleFileName
                        Exit Sub
1026:                 End If
1027:                 fzVal = Sqr(fzVal)
1028:             ElseIf Me.rbt_VSm Then
1029:                 fzVal = fzVal ^ 2
1030:             End If
1031:             fzVal = fzVal * C
1032:             Me.MSHFlexGrid1.TextMatrix(nRow, 1) = Format(fzVal, fmt)
1033:         Next nRow
1034:     ElseIf Me.rbt_MSSm Or Me.rbt_MSSSm Or Me.rbt_MSVSm Then
             'Dim raslyr As IRasterLayer
1036:         Set raslyr = WOETableUtils.FindLayerByName(Me.cbx_SelGrd)
1037:         If raslyr Is Nothing Then
1038:                 MsgBox Me.cbx_SelGrd & " layer not found.", vbCritical, "Fuzzy Function"
                     Exit Sub
1040:         End If
             'Dim m As Double, s As Double
1042:         logData = Me.chk_LogMSSm.Value = 1
1043:         RasterStats logData, raslyr, m, s
1044:         a = CDbl(Me.txt_MPMSSm.Text)
1045:         b = CDbl(Me.txt_SprdMSSm.Text)
1046:         For nRow = 1 To nrows - 1
1047:             X = CDbl(Me.MSHFlexGrid1.TextMatrix(nRow, 0))
1048:             If (Me.chk_LogMSSm.Value = 1) Then X = Log(X) / Log(10#)
1049:             If X > a * m Then
1050:               If (X - a * m + b * s) = 0 Then
1051:                   MsgBox "Division by zero", vbExclamation, c_sModuleFileName, ""
                            Exit Sub
1053:                End If
1054:                fzVal = (b * s) / (X - a * m + b * s)
1055:             Else
1056:                fzVal = 1
1057:             End If
1058:             If Me.rbt_MSSSm Then
1059:                 If fzVal < 0 Then
1060:                     MsgBox "Somewhat value < 0", vbExclamation, c_sModuleFileName
                        Exit Sub
1062:                 End If
1063:                 fzVal = Sqr(fzVal)
1064:             ElseIf Me.rbt_MSVSm Then
1065:                 fzVal = fzVal ^ 2
1066:             End If
1067:             fzVal = fzVal * C
1068:             Me.MSHFlexGrid1.TextMatrix(nRow, 1) = Format(fzVal, fmt)
1069:         Next nRow
1070:     ElseIf Me.rbt_Near Or Me.rbt_SNear Or Me.rbt_VNear Then
1071:         f2 = CDbl(Me.txt_MPNear.Text)
1072:         f1 = CDbl(Me.txt_SprdNear.Text)
1073:         For nRow = 1 To nrows - 1
1074:             X = CDbl(Me.MSHFlexGrid1.TextMatrix(nRow, 0))
1075:             If (1 + f1 * ((X - f2) ^ 2)) = 0 Then
1076:               MsgBox "Division by zero", vbExclamation, c_sModuleFileName, ""
                        Exit Sub
1078:             End If
1079:             fzVal = 1 / (1 + f1 * ((X - f2) ^ 2))
1080:             If Me.rbt_SNear Then
1081:                If fzVal < 0 Then
1082:                    MsgBox "Somewhat value < 0", vbExclamation, c_sModuleFileName
                        Exit Sub
1084:                End If
1085:                 fzVal = Sqr(fzVal)
1086:             ElseIf Me.rbt_VNear Then
1087:                 fzVal = fzVal ^ 2
1088:             End If
1089:             fzVal = fzVal * C
1090:             Me.MSHFlexGrid1.TextMatrix(nRow, 1) = Format(fzVal, fmt)
1091:         Next nRow
1092:     End If
1093:     Me.lbl_msg = "Fuzzification Values for selected function:" & Me.getSelectedFuzzification & ", 0-" & 10 ^ CDbl(Me.cbx_SigFig.Text)
1094:             Me.ZOrder 0
  Exit Sub
ErrorHandler:
  HandleError False, "lbt_Fuzz_Click " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), Err.Number, Err.Source, Err.Description, 4
End Sub
Private Sub lbt_Interp_Click()
  On Error GoTo ErrorHandler
    
1102:     If Me.MSHFlexGrid1.row = Me.MSHFlexGrid1.RowSel Then
1103:         MsgBox "Cannot interpolate one row.", vbExclamation, "Fuzzy Table"
             Exit Sub
1105:     End If
    
        Dim row1 As Long, row2 As Long, row As Long
1108:    If Me.MSHFlexGrid1.RowSel > Me.MSHFlexGrid1.row Then
1109:         row1 = Me.MSHFlexGrid1.row
1110:         row2 = Me.MSHFlexGrid1.RowSel
1111:     Else
1112:         row1 = Me.MSHFlexGrid1.RowSel
1113:         row2 = Me.MSHFlexGrid1.row
1114:     End If
1115:     If (Not IsNumeric(Me.MSHFlexGrid1.TextMatrix(row1, 1))) Or (Not IsNumeric(Me.MSHFlexGrid1.TextMatrix(row2, 1))) Then
1116:         MsgBox "Cannot interpolate: top or bottom row not set.", vbExclamation, "Fuzzy Table"
             Exit Sub
1118:     End If
        Dim y1 As Double, y0 As Double
1120:         y1 = Me.MSHFlexGrid1.TextMatrix(row2, 1)
1121:         y0 = Me.MSHFlexGrid1.TextMatrix(row1, 1)
        Dim x1 As Double, x0 As Double
1123:         x1 = row2
1124:         x0 = row1
        Dim numInts As Double
        Dim m As Double
1127:         m = (y1 - y0) / (x1 - x0)
        Dim b As Double
1129:         b = y1 - m * x1
1130:     For row = row1 To row2
1131:         Me.MSHFlexGrid1.TextMatrix(row, 1) = CStr(Int(m * row + b + 0.5))
1132:     Next row
1133:             Me.ZOrder 0
  Exit Sub
ErrorHandler:
  HandleError False, "lbt_Interp_Click " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), Err.Number, Err.Source, Err.Description, 4
End Sub

Private Sub lbt_Prev_Click()
  On Error GoTo ErrorHandler

        Dim row As Long
1143:     For row = 1 To Me.MSHFlexGrid1.Rows - 1
1144:         If Me.MSHFlexGrid1.TextMatrix(row, 1) = "" Then
1145:             MsgBox "There are blank membership values", vbExclamation, Me.Caption
                 Exit Sub
1147:         End If
1148:     Next row
    'Create chart table
        Dim attrName As String
1151:    attrName = Me.MSHFlexGrid1.TextMatrix(0, 2)
        Dim tmpDir As String
1153:     tmpDir = WOETableUtils.getProjectDir
        Dim fldDesc As New Collection
1155:     fldDesc.Add Array("Value", esriFieldTypeInteger, 12, 0, "", False)
1156:     fldDesc.Add Array("FuzyMbrShp", esriFieldTypeInteger, 12, 0, "", False)
1157:     fldDesc.Add Array(attrName, esriFieldTypeString, 12, 0, "", False)
          Dim fnQualifier As String
1159:           fnQualifier = "_" & Replace(getSelectedFuzzification, ",", "_") & "_"
          Dim chtTblFN As IFileName
1161:     Set chtTblFN = WOETableUtils.MakeTmp(tmpDir, "FZ" & gFZ.cbx_SelGrd.Text & fnQualifier, "dbf")
          Dim fdTblFN As Variant
1163:     fdTblFN = FileDialog.GetSaveFileName("Fuzzy Table Name", FileDialog.getDir(chtTblFN.path), FileDialog.GetFileName(chtTblFN.path))
1164:     If IsEmpty(fdTblFN) Then
1165:      Me.ZOrder 0
              Exit Sub
1167:   End If
        Dim chtTbl As ITable
1169:   Set chtTbl = WOETableUtils.CreateTable(CStr(fdTblFN(0)), CStr(fdTblFN(1)), fldDesc, CBool(fdTblFN(2)))
1170:   If chtTbl Is Nothing Then
1171:       MsgBox "Chart table not created.", vbExclamation, "Fuzzy Membership"
            Exit Sub
1173:   End If
        Dim wrkSpcEdit As IWorkspaceEdit
1175:     Set wrkSpcEdit = FeatureUtils.startEditing(tmpDir)
        Dim nrows As Long
1177:     nrows = Me.MSHFlexGrid1.Rows
        Dim nRow As Long
1179:     For nRow = 1 To nrows - 1
        Dim rw As IRow
1181:         Set rw = chtTbl.CreateRow
1182:         rw.Value(rw.Fields.FindField("Value")) = CLng(Me.MSHFlexGrid1.TextMatrix(nRow, 0))
1183:         If Me.MSHFlexGrid1.TextMatrix(nRow, 1) = "NoData" Then
1184:         Else
1185:            rw.Value(rw.Fields.FindField("FuzyMbrShp")) = CLng(Me.MSHFlexGrid1.TextMatrix(nRow, 1))
1186:         End If
1187:         rw.Value(rw.Fields.FindField(attrName)) = CStr(Me.MSHFlexGrid1.TextMatrix(nRow, 2))
1188:         rw.Store
1189:     Next nRow
    
1191:     FeatureUtils.StopEditing wrkSpcEdit

         Dim pdataSet As IDataset
1194:     Set pdataSet = chtTbl
         Dim chtSAtbl As IStandaloneTable
1196:     Set chtSAtbl = WOETableUtils.CreateStandAloneTable(chtTbl, pdataSet.Name)
1197:     Set pdataSet = chtSAtbl
1198:     Set saveTable = chtSAtbl
    'Create chart
        Dim chart As IDataGraph
1201:     Set chart = New DataGraph
1202:     With chart
1203:        Set .Table = chtSAtbl
1204:        .FieldSet1 = "FuzyMbrShp"
1205:        .Name = pdataSet.Name
1206:        .SeriesByRecord = True
1207:     End With
          Dim dataGrphProps As IDataGraphProperties
1209:     Set dataGrphProps = chart
1210:     With dataGrphProps
1211:     If Me.lbt_Prev.Tag = "Ordered" Then
1212:         .GraphType = esriDataGraphTypeLine
1213:         .GraphSubtype = esriDataGraphSubtypeLine2DSimple
1214:         .XAxisLabelField = "Value"
1215:         .SubTitle = "Value"
1216:         .Title = "Fuzzy Membership of " & Me.cbx_SelGrd.Text & ":" & Me.getSelectedFuzzification & "," & Me.cbx_SigFig.Text
1217:     ElseIf Me.lbt_Prev.Tag = "Free" Then
1218:         .GraphType = esriDataGraphTypeColumn
1219:         .GraphSubtype = esriDataGraphSubtypeColumn2DSimple
1220:         .XAxisLabelField = attrName
1221:         .SubTitle = Me.cbx_Att.Text
1222:         .Title = "Fuzzy Membership of " & Me.cbx_SelGrd.Text & "," & Me.cbx_SigFig.Text
1223:     End If
1224:        .ShowXAxisLabels = True
1225:        .ShowDataLabels = True
1226:        .ShowLegend = True
1227:     End With
          Dim dataGrphAxis As IDataGraphAxis
1229:     Set dataGrphAxis = chart
    
    'chart.Draw
          Dim pMxDoc As IMxDocument
1233:     Set pMxDoc = SDMGlobals.SDMDoc
          Dim dataGx As IDataGraphs
1235:     Set dataGx = pMxDoc
1236:     dataGx.Add chart
          Dim i As Long
1238:     For i = 0 To dataGx.Count - 1
1239:        If dataGx.item(i).Name = chart.Name Then
                Dim dataGrphWin As IDataGraphWindow
1241:            Set dataGrphWin = New DataGraphWindow
1242:            Set dataGrphWin.DataGraph = dataGx.item(i)
1243:            Set dataGrphWin.Application = New AppRef
                Dim dataWin As IDataWindow
1245:            Set dataWin = dataGrphWin
1246:            dataGrphWin.Show True
1247:            Exit For
1248:         End If
1249:      Next i

1251:      Me.lbt_Sav.Enabled = True
1252:               Me.ZOrder 0
  Exit Sub
ErrorHandler:
  HandleError False, "lbt_Prev_Click " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), Err.Number, Err.Source, Err.Description, 4
End Sub

Private Sub lbt_Sav_Click()
  On Error GoTo ErrorHandler
1260:    If Me.getSaveTable Is Nothing Then
1261:         MsgBox "Only previewed tables can be saved.", vbExclamation, "Saving Fuzzy Table"
            Exit Sub
1263:    End If
         Dim pdataSet As IDataset
1265:    Set pdataSet = Me.getSaveTable
1266:    WOETableUtils.AddTable pdataSet.Workspace.PathName, pdataSet.Name, SDMGlobals.SDMApp
        
1268:    Me.lbt_Sav.Enabled = False
1269:    Set saveTable = Nothing
1270:             Me.ZOrder 0
  Exit Sub
ErrorHandler:
  HandleError False, "lbt_Sav_Click " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), Err.Number, Err.Source, Err.Description, 4
End Sub

Private Sub lbt_SetVal_Click()
  On Error GoTo ErrorHandler

         Dim row1 As Long, row2 As Long, row As Long
1280:     If Me.MSHFlexGrid1.RowSel >= Me.MSHFlexGrid1.row Then
1281:         row1 = Me.MSHFlexGrid1.row
1282:         row2 = Me.MSHFlexGrid1.RowSel
1283:     Else
1284:         row1 = Me.MSHFlexGrid1.RowSel
1285:         row2 = Me.MSHFlexGrid1.row
1286:     End If
1287:     For row = row1 To row2
1288:         Me.MSHFlexGrid1.TextMatrix(row, 1) = Me.txt_NewVal
1289:     Next row
1290:              Me.ZOrder 0

  Exit Sub
ErrorHandler:
  HandleError False, "lbt_SetVal_Click " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), Err.Number, Err.Source, Err.Description, 4
End Sub
Private Sub lbt_NoData_Click()
  On Error GoTo ErrorHandler

        Dim row1 As Long, row2 As Long, row As Long
1300:     If Me.MSHFlexGrid1.RowSel >= Me.MSHFlexGrid1.row Then
1301:         row1 = Me.MSHFlexGrid1.row
1302:         row2 = Me.MSHFlexGrid1.RowSel
1303:     Else
1304:         row1 = Me.MSHFlexGrid1.RowSel
1305:         row2 = Me.MSHFlexGrid1.row
1306:     End If
1307:     For row = row1 To row2
1308:         Me.MSHFlexGrid1.TextMatrix(row, 1) = "NoData"
1309:     Next row
1310:             Me.ZOrder 0
  Exit Sub
ErrorHandler:
  HandleError False, "lbt_NoData_Click " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), Err.Number, Err.Source, Err.Description, 4
End Sub

Private Sub lbt_OK_Click()
  On Error GoTo ErrorHandler

    Dim row As Long
1320:     For row = 1 To Me.MSHFlexGrid1.Rows - 1
1321:         If Me.MSHFlexGrid1.TextMatrix(row, 1) = "" Then
1322:             MsgBox "There are blank new values", vbExclamation, Me.Caption
            Exit Sub
1324:         End If
1325:     Next row
    
        Dim pRemap As IRemap
1328:     Set pRemap = New NumberRemap
        Dim pNRemap As INumberRemap
1330:     Set pNRemap = pRemap
1331:     pRemap.Clear
1332:     For row = 1 To Me.MSHFlexGrid1.Rows - 1
        Dim val As String
1334:         val = Me.MSHFlexGrid1.TextMatrix(row, 0)
        Dim outVal As String
1336:         outVal = Me.MSHFlexGrid1.TextMatrix(row, 1)
1337:         If outVal = "NoData" Then
1338:             pNRemap.MapValueToNoData CDbl(val)
1339:         Else
1340:             pNRemap.MapValue CDbl(val), CLng(outVal)
1341:         End If
1342:     Next row
    
        Dim bIsValid As Boolean
        Dim sErrorInfo As String
1346:     pRemap.Validate bIsValid, sErrorInfo
1347:     If Not bIsValid Then
1348:         MsgBox sErrorInfo, vbExclamation, "Remap table not valid"
            Exit Sub
1350:     End If
    ' Declare the input raster object
          Dim pInputDataset As IRasterLayer
1353:     Set pInputDataset = WOETableUtils.FindLayerByName(Me.cbx_SelGrd.Text)
    
    ' Calls the method with remap table just created
        Dim anlparms As AnalysisParameters.AnlParams
1357:     Set anlparms = New AnalysisParameters.AnlParams
          Dim gParam As Form
1359:     Set gParam = anlparms.gParamFrm
          Dim pStudyArea As IRasterLayer
1361:     Set pStudyArea = WOETableUtils.FindLayerByName(gParam.cbxSA.Text)
          Dim pRasProps As IRasterProps
1363:     Set pRasProps = pStudyArea.Raster
          Dim pGeodataSet As IGeoDataset
1365:     Set pGeodataSet = pStudyArea
          Dim pdataSet As IDataset
1367:     Set pdataSet = pStudyArea
    
          Dim pReclassOp As IReclassOp
1370:     Set pReclassOp = New RasterReclassOp
          Dim reclsopEnv As IRasterAnalysisEnvironment
1372:     Set reclsopEnv = pReclassOp
1373:     Set reclsopEnv.Mask = pStudyArea.Raster
1374:     reclsopEnv.SetCellSize esriRasterEnvMinOf
1375:     reclsopEnv.SetExtent esriRasterEnvValue, pGeodataSet.Extent
1376:     Set reclsopEnv.OutSpatialReference = pGeodataSet.SpatialReference
1377:     Set reclsopEnv.OutWorkspace = SDMGlobals.SDMWorkspace

          Dim newGrid As IRaster
1380:     Set newGrid = pReclassOp.ReclassByRemap(pInputDataset.Raster, pRemap, True)

' Create the RasterMathOps object
        Dim pMathOp As IMathOp
1384:    Set pMathOp = New RasterMathOps
' Calls the method
        Dim rasMaker As IRasterMakerOp
1387:    Set rasMaker = New RasterMakerOp
         Dim rasMakerRAE As IRasterAnalysisEnvironment
1389:   Set rasMakerRAE = rasMaker
1390:   Set rasMakerRAE.Mask = pStudyArea.Raster
1391:   rasMakerRAE.SetCellSize esriRasterEnvMinOf
1392:   rasMakerRAE.SetExtent esriRasterEnvValue, pGeodataSet.Extent
1393:   Set rasMakerRAE.OutSpatialReference = pGeodataSet.SpatialReference
1394:   Set rasMakerRAE.OutWorkspace = SDMGlobals.SDMWorkspace
1395:   rasMakerRAE.DefaultOutputRasterPrefix = "FMRaster"
     
        Dim C As Double
1398:    C = 10 ^ CDbl(Me.cbx_SigFig.Text)
        Dim FloatGrid As IRaster
1400:    Set FloatGrid = pMathOp.Divide(pMathOp.Float(newGrid), rasMaker.MakeConstant(C, False))
        Dim pRasBandColl As IRasterBandCollection
1402:         Set pRasBandColl = FloatGrid
        Dim pRasDS As IDataset
1404:         Set pRasDS = pRasBandColl.item(0)
        Dim pOutRasLayer As IRasterLayer
1406:    Set pOutRasLayer = New RasterLayer
1407:    pOutRasLayer.CreateFromRaster FloatGrid
1408:    pOutRasLayer.Name = "FM" & Me.cbx_SelGrd.Text & Mid(pRasDS.Name, 7)
1409:    SDMGlobals.SDMMap.AddLayer pOutRasLayer

Table:
        Dim fmSATbl As IStandaloneTable
1413:   Set fmSATbl = FuzzyModelUtils.getFuzzyModel
        If fmSATbl Is Nothing Then Exit Sub
    
1416: If Not Me.getSaveTable Is Nothing Then
1417:    If Me.lbt_Prev.Tag = "Free" Then Me.lbt_OK.Tag = "Table:" & Me.getSaveTable.Name & "," & Me.cbx_SigFig.Text
1418:    If Me.lbt_Prev.Tag = "Ordered" Then Me.lbt_OK.Tag = Me.getSelectedFuzzification & "," & Me.getSaveTable.Name & "," & Me.cbx_SigFig.Text
1419: Else
1420:     If Me.lbt_Prev.Tag = "Free" Then Me.lbt_OK.Tag = "Table:" & ", ," & Me.cbx_SigFig.Text
1421:     If Me.lbt_Prev.Tag = "Ordered" Then Me.lbt_OK.Tag = Me.getSelectedFuzzification & ", ," & Me.cbx_SigFig.Text
1422: End If
1423: FuzzyModelUtils.writeFuzzyModel fmSATbl.Table, Me.cbx_SelGrd.Text, Me.lbt_OK.Tag, pOutRasLayer.Name
1424:         Me.ZOrder 0
      Exit Sub
ErrorHandler:
  HandleError False, "lbt_OK_Click " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), Err.Number, Err.Source, Err.Description, 4
End Sub

Private Sub txt_NewVal_Change()
  On Error GoTo ErrorHandler

    Dim newval As String
1434:     newval = Me.txt_NewVal.Text
1435:     Me.lbt_SetVal.Enabled = IsNumeric(newval)
1436:          If Me.lbt_SetVal.Enabled Then Me.lbt_SetVal.Enabled = newval >= 0
1437:     If Me.lbt_SetVal.Enabled Then Me.lbt_SetVal.Enabled = (newval >= 0 And (newval <= 10 ^ Me.cbx_SigFig))


  Exit Sub
ErrorHandler:
  HandleError False, "txt_NewVal_Change " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), Err.Number, Err.Source, Err.Description, 4
End Sub

Private Sub RasterStats(ByRef log10 As Boolean, ByRef raslyr As IRasterLayer, ByRef Mean As Double, ByRef StDev As Double)
'Get mean and standard deviation of log10(raster)
1447:     If log10 Then
            Dim rasMath As IMathOp
1449:       Set rasMath = New RasterMathOps
            Dim logRas As IRaster
1451:       Set logRas = rasMath.log10(raslyr.Raster)
            Dim rasbndColl As IRasterBandCollection
1453:       Set rasbndColl = logRas
1454:     Else
1455:       Set rasbndColl = raslyr.Raster
1456:     End If
          Dim rasband As IRasterBand
1458:     Set rasband = rasbndColl.item(0)
          Dim rasStats As IRasterStatistics
1460:     Set rasStats = rasband.Statistics
1461:     Mean = rasStats.Mean
1462:     StDev = rasStats.StandardDeviation
End Sub

Private Function lgSm() As String
1466:     If Me.chk_LogMSSm.Value = 1 Then lgSm = "Lg" Else lgSm = ""
End Function
Private Function lgLrg() As String
1469:     If Me.chk_LogMSLrg.Value = 1 Then lgLrg = "Lg" Else lgLrg = ""
End Function

Sub UpdateFreeOrderedTheme(selectedName0 As String)
        'MsgBox "Checking data type.", , c_sModuleFileName
         Dim selectedName As String
1475:    selectedName = Trim(selectedName0)
         If LCase(selectedName) Like "raster*" Then Exit Sub
1477:    If Not SDMGlobals.SDMdataDict.Exists(selectedName) Then
                Dim msgdlg As IMessageDialog
1479:           Set msgdlg = New MessageDialog
1480:           If msgdlg.doModal("Fuzzification", "Is " & selectedName & " an Ordered data type (else Free) ?", "Ordered", "Free", 0) Then
                    Dim datVal As String
1482:               datVal = "Ordered"
1483:           Else
1484:               datVal = "Free"
1485:           End If
1486:       Set msgdlg = Nothing
1487:       Me.ZOrder 0
            Dim gSDIWrtDataTypes As gSDI_WriteDataTypes
1489:       Set gSDIWrtDataTypes = New gSDI_WriteDataTypes
1490:       gSDIWrtDataTypes.gSDI_WriteDataTypes Array(selectedName, datVal)
1491:       SDMGlobals.SDMdataDict.Add selectedName, datVal
1492:    End If
End Sub


