VERSION 5.00
Begin VB.Form gPUA 
   Caption         =   "Study Area Properties - Basic"
   ClientHeight    =   3435
   ClientLeft      =   0
   ClientTop       =   0
   ClientWidth     =   5865
   KeyPreview      =   -1  'True
   LinkTopic       =   "gPUA1"
   ScaleHeight     =   171.75
   ScaleMode       =   2  'Point
   ScaleWidth      =   293.25
   StartUpPosition =   2  'CenterScreen
   Begin VB.CommandButton btnOK 
      Caption         =   "OK"
      Height          =   495
      Left            =   1440
      TabIndex        =   3
      ToolTipText     =   "Accept the unit area value entered."
      Top             =   2880
      Width           =   1335
   End
   Begin VB.CommandButton btnHlp 
      Caption         =   "Help"
      Height          =   495
      Left            =   3000
      TabIndex        =   9
      Top             =   2880
      Width           =   1335
   End
   Begin VB.OptionButton radAsy 
      Caption         =   "Use Limiting Value of Weights"
      Height          =   420
      Left            =   600
      TabIndex        =   8
      Top             =   0
      Width           =   2790
   End
   Begin VB.OptionButton radUA 
      Caption         =   "User Defined Unit Area"
      Height          =   420
      Left            =   600
      TabIndex        =   7
      Top             =   360
      Width           =   2880
   End
   Begin VB.CommandButton btnAdv 
      Caption         =   "Advanced >>"
      Height          =   435
      Left            =   4200
      TabIndex        =   4
      ToolTipText     =   "Advanced/Basic options for defining unit area."
      Top             =   1560
      Visible         =   0   'False
      Width           =   1320
   End
   Begin VB.TextBox txtUA 
      Alignment       =   1  'Right Justify
      Height          =   300
      Left            =   2040
      TabIndex        =   0
      Text            =   "1"
      ToolTipText     =   "Unit area in square kilometres"
      Top             =   960
      Width           =   1125
   End
   Begin VB.TextBox txtSAU 
      Height          =   285
      Left            =   2400
      TabIndex        =   10
      Text            =   "1"
      Top             =   1440
      Width           =   1455
   End
   Begin VB.TextBox txtSAK 
      Height          =   285
      Left            =   2400
      TabIndex        =   11
      Text            =   "1"
      Top             =   1800
      Width           =   1455
   End
   Begin VB.TextBox txtSUG 
      Height          =   285
      Left            =   2400
      TabIndex        =   12
      Text            =   "N/A"
      Top             =   2160
      Width           =   3135
   End
   Begin VB.Frame ctl1 
      BorderStyle     =   0  'None
      Caption         =   "Frame1"
      Height          =   615
      Left            =   360
      TabIndex        =   13
      Top             =   120
      Visible         =   0   'False
      Width           =   2775
   End
   Begin VB.Label SDMLogo 
      Alignment       =   2  'Center
      Appearance      =   0  'Flat
      BackColor       =   &H0000C000&
      BorderStyle     =   1  'Fixed Single
      Caption         =   "ArcSDM3"
      BeginProperty Font 
         Name            =   "Roman"
         Size            =   14.25
         Charset         =   255
         Weight          =   700
         Underline       =   0   'False
         Italic          =   -1  'True
         Strikethrough   =   0   'False
      EndProperty
      ForeColor       =   &H0080FFFF&
      Height          =   375
      Left            =   4200
      TabIndex        =   14
      Top             =   120
      Width           =   1335
   End
   Begin VB.Label txtlSAK 
      Caption         =   "Total Study Area (sq. km):"
      Height          =   315
      Left            =   480
      TabIndex        =   5
      Top             =   1800
      Width           =   1965
   End
   Begin VB.Label txtlUA 
      Caption         =   "Unit Area (sq. km):"
      Height          =   360
      Left            =   480
      TabIndex        =   1
      Top             =   960
      Width           =   1545
   End
   Begin VB.Label txtlSug 
      Caption         =   "Suggested Unit Area:"
      Height          =   315
      Left            =   480
      TabIndex        =   2
      Top             =   2160
      Width           =   1605
   End
   Begin VB.Label txtlSAU 
      Caption         =   "Total Study Area (Units):"
      Height          =   315
      Left            =   480
      TabIndex        =   6
      Top             =   1440
      Width           =   1845
   End
End
Attribute VB_Name = "gPUA"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Dim shiftDown As Boolean
'Private Listeners As SDMListeners
'Private WithEvents aCtl As SDMListeners
Private ObjectTag As Object
Public Property Set setObjectTag(anObject As Object)
6:     Set ObjectTag = anObject
End Property
Public Property Get getObjectTag() As Object
9:     Set getObjectTag = ObjectTag
End Property

Private Sub Form_Initialize()
13:     Me.KeyPreview = True
End Sub

Private Sub Form_KeyDown(keycode As Integer, shift As Integer) 'MsgBox "shift: " & Shift
17:     shiftDown = (shift And vbShiftMask) > 0
End Sub

Private Sub Form_Load()
21:     shiftDown = False
    'Set Listeners = New SDMListeners
    'Set aCtl = Listeners
    'Set gPUAOpen = New gPUA_Open
    'gPUA dialog is incorrect
26:     Me.btnAdv.Caption = "Advanced>>"
27:     Me.Caption = "Study Area Parameters - Basic"
    'gPUAOpen.gPUA_Open
    Dim gPUAOpen As gPUA_Open
30:     Set gPUAOpen = New gPUA_Open
31:     gPUAOpen.gPUA_Open
    End Sub
Private Sub btnOK_Click()
 'gPUA.btnOK.Click
35:  gParam.txtUA.Text = gPUA.txtUA.Text
36:  gPUA.Hide
37:  Unload gPUA
End Sub
Private Sub btnAdv_Click()
    Dim gPUABtnAdvClick As gPUA_btnAdv_Click
41:     Set gPUABtnAdvClick = New gPUA_btnAdv_Click
42:     gPUABtnAdvClick.gPUA_btnAdv_Click
End Sub
Private Sub Picture1_Click()

End Sub

Private Sub radUA_Click()
 'gPUA.radUA.Click
51:  gParam.getEars.BroadcastUpdate radUA
End Sub
Private Sub radAsy_Click()
 'gPUA.radAsy.Click
55:  gParam.getEars.BroadcastUpdate radAsy
End Sub
Private Sub btnHlp_Click()
 'gPUA.btnHlp.Click
    MsgBox "Use the Analysis Parameters Unit Area Properties button to get help", vbInformation, "Unit Area Help"
    
 End Sub

Private Sub txtUA_Change()
63:     gParam.getEars.Update Me.btnOK
64:     gParam.getEars.BroadcastUpdate Me.txtUA
End Sub

'Include selections for all controls with an update method
'Method could be local or belong to an instantiated object
Public Sub aCtl_UpdateEvt(ByRef ctl As Object)
    'MsgBox "gPUA updater for " & ctl.Name
    On Error GoTo ErrorHandler
    Select Case (ctl.Name)
        Case Me.txtUA.Name
            Dim gPUAtxtUAUpdate As gPUA_txtUA_Update
75:             Set gPUAtxtUAUpdate = New gPUA_txtUA_Update
76:             gPUAtxtUAUpdate.gPUA_txtUA_Update
77:             Set gPUAtxtUAUpdate = Nothing
78:             Me.txtlUA.Enabled = Me.txtUA.Enabled
        Case Me.btnOK.Name
            Dim strUA As String
81:             strUA = gPUA.txtUA.Text
82:             If (IsNumeric(strUA)) Then
83:                 If (CDbl(strUA) > 0) Then
84:                     gPUA.btnOK.Enabled = True
                    Exit Sub
86:                 End If
87:             End If
88:             gPUA.btnOK.Enabled = False
        Case Me.txtlSAK.Name
            Dim gPUAradAsyUpdate As gPUA_radAsyUpdate
91:             Set gPUAradAsyUpdate = New gPUA_radAsyUpdate
92:             gPUAradAsyUpdate.gPUA_radAsyUpdate Array(Me.txtlSAK)
93:             Set gPUAradAsyUpdate = Nothing
94:             Me.txtSAK.Enabled = Me.txtlSAK.Enabled
        Case Me.txtlSAU.Name
            'Dim gPUAradAsyUpdate As gPUA_radAsyUpdate
97:             Set gPUAradAsyUpdate = New gPUA_radAsyUpdate
98:             gPUAradAsyUpdate.gPUA_radAsyUpdate Array(Me.txtlSAU)
99:             Set gPUAradAsyUpdate = Nothing
100:             Me.txtSAU.Enabled = Me.txtlSAU.Enabled
        Case Me.txtlSug.Name
            'Dim gPUAradAsyUpdate As gPUA_radAsyUpdate
103:             Set gPUAradAsyUpdate = New gPUA_radAsyUpdate
104:             gPUAradAsyUpdate.gPUA_radAsyUpdate Array(Me.txtlSug)
105:             Set gPUAradAsyUpdate = Nothing
106:             Me.txtSUG.Enabled = Me.txtlSug.Enabled
        Case Me.txtSAK.Name
            Dim gPUAtxtSAKUpdate As gPUA_txtSAK_Update
109:             Set gPUAtxtSAKUpdate = New gPUA_txtSAK_Update
110:             gPUAtxtSAKUpdate.gPUA_txtSAK_Update
111:             Set gPUAtxtSAKUpdate = Nothing
        Case Me.txtlUA.Name
'            'no update script
        Case Me.txtSAU.Name
            Dim gPUAtxtSAUUpdate As gPUA_txtSAU_Update
116:             Set gPUAtxtSAUUpdate = New gPUA_txtSAU_Update
117:             gPUAtxtSAUUpdate.gPUA_txtSAU_Update
118:             Set gPUAtxtSAUUpdate = Nothing
        Case Me.txtSUG.Name
            Dim gPUAtxtSugUpdate As gPUA_txtSUG_Update
121:             Set gPUAtxtSugUpdate = New gPUA_txtSUG_Update
122:             gPUAtxtSugUpdate.gPUA_txtSUG_Update
123:             Set gPUAtxtSugUpdate = Nothing
        Case Me.SDMLogo.Name
                    'No action
        Case Else
                Err.Raise vbObjectError + 999, ctl.Name, "No update method for this object gPUA." & ctl.Name & vbCrLf
126:     End Select
    Exit Sub
ErrorHandler:
129:         MsgBox Err.Source & ": " & Err.Description
    End Sub

Private Sub txtUA_KeyPress(KeyAscii As Integer)
    If IsNumeric(Chr(KeyAscii)) Then Exit Sub
    If (KeyAscii = Asc(".")) Then Exit Sub
135:     KeyAscii = 0
End Sub
