VERSION 5.00
Begin VB.Form gParam 
   Caption         =   "Set analysis parameters...."
   ClientHeight    =   5880
   ClientLeft      =   0
   ClientTop       =   0
   ClientWidth     =   6915
   KeyPreview      =   -1  'True
   LinkTopic       =   "gParam1"
   ScaleHeight     =   5880
   ScaleWidth      =   6915
   StartUpPosition =   2  'CenterScreen
   Begin VB.Frame cpTch 
      Caption         =   "Select analysis techniques"
      Height          =   1935
      Left            =   240
      TabIndex        =   19
      Top             =   150
      Width           =   6465
      Begin VB.CheckBox chkNNUns 
         Caption         =   "Fuzzy Clustering (Unsupervised)"
         Height          =   420
         Left            =   3600
         TabIndex        =   28
         Top             =   960
         Value           =   1  'Checked
         Width           =   2655
      End
      Begin VB.CheckBox chkNNSup 
         Caption         =   "RBFLN (Supervised)"
         Height          =   420
         Left            =   3600
         TabIndex        =   27
         Top             =   600
         Value           =   1  'Checked
         Width           =   1875
      End
      Begin VB.CheckBox chkWofE 
         Caption         =   "Weights of Evidence (WofE)"
         Height          =   390
         Left            =   135
         TabIndex        =   25
         Tag             =   "Weights of Evidence"
         Top             =   270
         Width           =   2595
      End
      Begin VB.CheckBox chkNN 
         Caption         =   "Neural Network Analysis (NN)"
         Height          =   195
         Left            =   3240
         TabIndex        =   24
         Top             =   360
         Width           =   2655
      End
      Begin VB.CheckBox chkLR 
         Caption         =   "Logistic Regression (LR)"
         Height          =   420
         Left            =   120
         TabIndex        =   23
         Tag             =   "Logistic Regression"
         Top             =   1320
         Width           =   2220
      End
      Begin VB.CheckBox chkFL 
         Caption         =   "Fuzzy Logic (FL)"
         Height          =   420
         Left            =   3240
         TabIndex        =   22
         Tag             =   "Fuzzy Logic"
         Top             =   1320
         Width           =   1800
      End
      Begin VB.OptionButton radWEDD 
         Caption         =   "Normal (Using training points)"
         Height          =   420
         Left            =   420
         TabIndex        =   21
         Top             =   600
         Value           =   -1  'True
         Width           =   2565
      End
      Begin VB.OptionButton radExpt 
         Caption         =   "Expert (No training points)"
         Height          =   420
         Left            =   420
         TabIndex        =   20
         Top             =   915
         Width           =   2295
      End
      Begin VB.Label SDMLogo 
         Alignment       =   2  'Center
         Appearance      =   0  'Flat
         BackColor       =   &H0000C000&
         BorderStyle     =   1  'Fixed Single
         Caption         =   "ArcSDM3"
         BeginProperty Font 
            Name            =   "Roman"
            Size            =   14.25
            Charset         =   255
            Weight          =   700
            Underline       =   0   'False
            Italic          =   -1  'True
            Strikethrough   =   0   'False
         EndProperty
         ForeColor       =   &H0080FFFF&
         Height          =   375
         Left            =   5040
         TabIndex        =   26
         Top             =   1440
         Width           =   1335
      End
   End
   Begin VB.Frame cplSetParms 
      Caption         =   "Set Parameters"
      Height          =   2925
      Left            =   240
      TabIndex        =   0
      Top             =   2070
      Width           =   6465
      Begin VB.CommandButton cmd_RAE 
         Caption         =   "Analysis Environment"
         Height          =   375
         Left            =   4680
         TabIndex        =   30
         ToolTipText     =   "Display/Modify Raster Analysis Environment for ArcSDM."
         Top             =   2400
         Width           =   1695
      End
      Begin VB.CommandButton btnUA 
         Caption         =   "Properties..."
         Height          =   375
         Left            =   4680
         TabIndex        =   18
         Tag             =   "Study Area Properties"
         ToolTipText     =   "Study Area Properties (Shift-Click for Help)"
         Top             =   720
         Width           =   1530
      End
      Begin VB.CommandButton btnTP 
         Caption         =   "Properties..."
         Height          =   375
         Left            =   4680
         TabIndex        =   17
         Tag             =   "Deposit Training Points Properties"
         ToolTipText     =   "Deposit Training Points Properties"
         Top             =   1320
         Width           =   1530
      End
      Begin VB.Frame cpTP 
         Caption         =   "Training Sites"
         Height          =   1215
         Left            =   240
         TabIndex        =   9
         Top             =   1080
         Width           =   6135
         Begin VB.ComboBox cbxTP 
            Height          =   315
            ItemData        =   "gParamX.frx":0000
            Left            =   840
            List            =   "gParamX.frx":0002
            Style           =   2  'Dropdown List
            TabIndex        =   12
            Top             =   240
            Width           =   3405
         End
         Begin VB.CommandButton btnNTP 
            Caption         =   "Properties..."
            Height          =   375
            Left            =   4440
            TabIndex        =   11
            Tag             =   "Non-deposit Training Points Properties"
            ToolTipText     =   "Non-deposit Training Points Properties"
            Top             =   720
            Width           =   1530
         End
         Begin VB.ComboBox cbxNTP 
            Height          =   315
            Left            =   1200
            Style           =   2  'Dropdown List
            TabIndex        =   10
            Top             =   720
            Width           =   3045
         End
         Begin VB.Label lblNtp 
            Caption         =   "Non-deposit:"
            Height          =   375
            Left            =   120
            TabIndex        =   16
            Top             =   720
            Width           =   975
         End
         Begin VB.Label lblTP 
            Caption         =   "Deposit:"
            Height          =   255
            Left            =   120
            TabIndex        =   15
            Top             =   240
            Width           =   855
         End
      End
      Begin VB.TextBox txtMD 
         Alignment       =   1  'Right Justify
         BeginProperty DataFormat 
            Type            =   1
            Format          =   "0"
            HaveTrueFalseNull=   0
            FirstDayOfWeek  =   0
            FirstWeekOfYear =   0
            LCID            =   1033
            SubFormatType   =   1
         EndProperty
         Height          =   300
         Left            =   3000
         TabIndex        =   7
         Text            =   "-99"
         Top             =   2400
         Width           =   1425
      End
      Begin VB.TextBox txtUA 
         Alignment       =   1  'Right Justify
         BeginProperty DataFormat 
            Type            =   1
            Format          =   "0.00"
            HaveTrueFalseNull=   0
            FirstDayOfWeek  =   0
            FirstWeekOfYear =   0
            LCID            =   1033
            SubFormatType   =   1
         EndProperty
         Height          =   300
         Left            =   1920
         TabIndex        =   6
         Text            =   "1"
         Top             =   720
         Width           =   2325
      End
      Begin VB.ComboBox cbxSA 
         Height          =   315
         ItemData        =   "gParamX.frx":0004
         Left            =   1920
         List            =   "gParamX.frx":0006
         Style           =   2  'Dropdown List
         TabIndex        =   1
         Top             =   240
         Width           =   4245
      End
      Begin VB.Label lblSA 
         Caption         =   "Study Area Grid:"
         Height          =   255
         Left            =   240
         TabIndex        =   14
         Top             =   360
         Width           =   1575
      End
      Begin VB.Label lbltxtUA 
         Caption         =   "Unit Area (Sq. km):"
         Height          =   240
         Left            =   240
         TabIndex        =   13
         Top             =   720
         Width           =   1440
      End
      Begin VB.Label lbltxtMD 
         Caption         =   "Default Integer Defining Missing Data:"
         Height          =   240
         Left            =   240
         TabIndex        =   8
         Top             =   2400
         Width           =   2760
      End
   End
   Begin VB.CommandButton btnOK 
      Caption         =   "OK"
      Enabled         =   0   'False
      Height          =   480
      Left            =   480
      TabIndex        =   2
      ToolTipText     =   "Save configuration to Parameters file and Close"
      Top             =   5175
      Width           =   1245
   End
   Begin VB.CommandButton btnCan 
      Caption         =   "Cancel"
      Height          =   480
      Left            =   2040
      TabIndex        =   3
      ToolTipText     =   "Close dialog without saving Parameters"
      Top             =   5175
      Width           =   1245
   End
   Begin VB.CommandButton btnError 
      BackColor       =   &H0080FFFF&
      Caption         =   "Error!!!"
      Height          =   480
      Left            =   3600
      MaskColor       =   &H00FFFFFF&
      Style           =   1  'Graphical
      TabIndex        =   4
      ToolTipText     =   "Click me for information."
      Top             =   5160
      Visible         =   0   'False
      Width           =   1245
   End
   Begin VB.CommandButton btnHlp 
      Caption         =   "Help..."
      Height          =   480
      Left            =   5160
      TabIndex        =   5
      ToolTipText     =   "Click for Parameters Help"
      Top             =   5175
      Width           =   1245
   End
   Begin VB.CommandButton btnTest 
      Caption         =   "Test"
      Enabled         =   0   'False
      Height          =   375
      Left            =   3600
      TabIndex        =   29
      Top             =   5280
      Visible         =   0   'False
      Width           =   1215
   End
End
Attribute VB_Name = "gParam"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit
Private gParamOpen As gParam_Open
Private Listeners As SDMUtilities.SDMListeners
Private WithEvents aCtl As SDMUtilities.SDMListeners
Attribute aCtl.VB_VarHelpID = -1
Private WithEvents docEvents As DocumentEvents
Attribute docEvents.VB_VarHelpID = -1
Private WithEvents mapEvents As mapEvents
Attribute mapEvents.VB_VarHelpID = -1
Private gParamError As Integer
Private myParams As SDMList
Private TPselIndex As Variant
Private NTPselIndex As Variant

Private ObjectTag As SDMUtilities.SDMList
Private RanDlgCaller As Form
Private shiftDown As Boolean
Const c_sModuleFileName As String = "gParamX.frm"
Const c_sDLLFileName As String = "AnalysisParameters"

Public Property Set setObjectTag(anObject As SDMUtilities.SDMList)
  On Error GoTo ErrorHandler
20:     Set ObjectTag = anObject
  Exit Property
ErrorHandler:
  HandleError True, "setObjectTag " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), Err.Number, Err.Source, Err.Description, 4
End Property

Public Property Get getObjectTag() As SDMUtilities.SDMList
  On Error GoTo ErrorHandler

29:     If (ObjectTag Is Nothing) Then
30:         Set getObjectTag = New SDMUtilities.SDMList
31:     Else
32:         Set getObjectTag = ObjectTag
33:     End If
  Exit Property
ErrorHandler:
  HandleError True, "getObjectTag " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), Err.Number, Err.Source, Err.Description, 4
End Property

Public Property Get isShiftdown() As Boolean
  On Error GoTo ErrorHandler

42:     isShiftdown = shiftDown
43:     shiftDown = False

  Exit Property
ErrorHandler:
  HandleError True, "isShiftdown " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), Err.Number, Err.Source, Err.Description, 4
End Property

Public Property Get getEars() As SDMUtilities.SDMListeners
  On Error GoTo ErrorHandler

53:     Set getEars = Listeners


  Exit Property
ErrorHandler:
  HandleError True, "getEars " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), Err.Number, Err.Source, Err.Description, 4
End Property

'Include selections for all controls with an update method
'Method could be local or belong to an instantiated object
Private Sub aCtl_UpdateEvt(ByRef ctl As Object)
    On Error GoTo ErrorHandler
    Select Case (ctl.Parent.Name)
        Case "gPUA"
67:             gPUA.aCtl_UpdateEvt ctl
        Case "gPTP"
69:             gPTP.aCtl_UpdateEvt ctl
        Case "gPNTP"
71:             gPNTP.aCtl_UpdateEvt ctl
'       Case "gTW"
'            gTW.aCtl_UpdateEvt ctl
        Case "gRnd"
75:         gRnd.aCtl_UpdateEvt ctl
        Case "gParam"
            'MsgBox "gParam updater for " & ctl.Parent.Name & "." & ctl.Name
            Select Case (ctl.Name)
                Case Me.cbxSA.Name
                    Dim cbxSAUpdate As gP_cbxSA_Update
81:                 Set cbxSAUpdate = New gP_cbxSA_Update
82:                 cbxSAUpdate.gP_cbxSA_Update
83:                 Set cbxSAUpdate = Nothing
                Case Me.cbxTP.Name
'                        Dim cbxTPUpdate As gP_cbxTP_Update
'84:                     Set cbxTPUpdate = New gP_cbxTP_Update
'85:                     cbxTPUpdate.gP_cbxTP_Update
'86:                     Set cbxTPUpdate = Nothing
                Case Me.cbxNTP.Name
90:                 If Me.cbxNTP.Text = Me.cbxTP.Text Then
91:                     Me.cbxNTP.ListIndex = (Me.cbxTP.ListIndex + 1) Mod Me.cbxTP.ListCount
92:                 End If
93:                 Me.cbxNTP.Enabled = (Me.cbxNTP.ListCount > 0) And (Me.cbxNTP.Text <> "<No themes found>") And _
                                                (Me.chkNN.Value = 1)
                Case Me.txtMD.Name
                Case Me.btnOK.Name
97:                 Me.btnOK.Enabled = _
                                        ( _
                                            ( _
                                             (Me.chkWofE.Enabled And Me.chkWofE.Value = 1) Or _
                                             (Me.chkLR.Enabled And Me.chkLR.Value = 1) _
                                            ) Xor _
                                            (Me.chkNN.Enabled And Me.chkNN.Value = 1) _
                                              Xor _
                                            (Me.chkFL.Enabled And Me.chkFL.Value = 1) _
                                        )
''                                        (((Me.chkNN.Value = 1) Xor _
''                                        (Me.chkFL.Enabled And Me.chkFL.Value = 1)) And _
''                                        ((Me.chkWofE.Enabled And Me.chkWofE.Value = 0) And _
''                                        (Me.chkLR.Enabled And Me.chkLR.Value = 0))) Or _
''                                        (False)
                Case Me.chkLR.Name
108:                     Me.chkLR.Enabled = (Me.cbxTP.ListCount > 0) And (Me.cbxTP.Text <> "<No themes found>") And (IsNumeric(Me.txtMD)) And IsNumeric(Me.txtUA)
                Case Me.chkFL.Name
110:                     Me.chkFL.Enabled = (Me.cbxTP.ListCount > 0) And (Me.cbxTP.Text <> "<No themes found>") And (IsNumeric(Me.txtMD)) And IsNumeric(Me.txtUA)
'112:                     Me.chkFL.Enabled = (IsNumeric(Me.txtMD)) And IsNumeric(Me.txtUA)
                Case Me.chkNN.Name
113:                     Me.chkNN.Enabled = ((Me.chkNNSup.Value = 1) Or (Me.chkNNUns.Value = 1)) And _
                                       ((Me.cbxNTP.ListCount > 0) And ((Me.cbxNTP.Text <> "<No themes found>")) And (Me.cbxNTP.Text <> "<None>")) And _
                                        (Me.cbxTP.ListCount > 0) And (Me.cbxTP.Text <> "<No themes found>") And (IsNumeric(Me.txtMD)) And IsNumeric(Me.txtUA)
116:                     Me.chkNN.Enabled = Me.chkNN.Enabled And (Me.cbxTP.Text <> Me.cbxNTP.Text)
117:                     If Me.chkNN.Enabled And (Me.chkNNSup.Value Or Me.chkNNUns.Value) Then Me.chkNN.Value = 1 Else Me.chkNN.Value = 0
                Case Me.chkWofE.Name
119:                     Me.chkWofE.Enabled = (Me.cbxTP.ListCount > 0) And (Me.cbxTP.Text <> "<No themes found>") And (IsNumeric(Me.txtMD)) And IsNumeric(Me.txtUA)
                Case Me.chkNNSup.Name
                Case Me.chkNNUns.Name
                Case Me.btnUA.Name
                Case Me.txtUA.Name
                Case Me.btnTP.Name
125:                     Me.btnTP.Enabled = (Me.cbxTP.ListCount > 0) And (Me.cbxTP.Text <> "<No themes found>")
                Case Me.btnNTP.Name
127:                     Me.btnNTP.Enabled = (Me.cbxNTP.ListCount > 0) And ((Me.cbxNTP.Text <> "<No themes found>") And _
                            (Me.cbxNTP.Text <> "<None>")) And (Me.chkNN.Value = 1)
                Case Me.radExpt.Name
                    'no original script
                Case Me.radWEDD.Name
                    'no original script
                Case Me.btnError.Name
133:                         Me.btnTP.Enabled = Not (Me.cbxTP.ListCount > 0) And (Me.cbxTP.Text <> "<No themes found>") And _
                                                Not (Me.cbxSA.ListCount > 0) And (Me.cbxSA.Text <> "<No themes found>")
                Case Else
                    'Err.Raise vbObjectError + 999, ctl.Name, "No update method for this object gParam." & ctl.Name & vbCrLf
137:             End Select
                Case Else
139:     End Select
    Exit Sub
ErrorHandler:
  HandleError True, "aCtl_UpdateEvt " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), Err.Number, Err.Source, Err.Description, 4
    End Sub
    
Private Sub btnError_Click()
  On Error GoTo ErrorHandler

    Select Case gParamError
        Case gParamError And 1:
150:          MsgBox "The active data frame of this document has insufficient layers." & vbCrLf & vbCrLf & _
               "The active data frame must have a minimum of three layers arranged as follows:" & vbCrLf & vbCrLf & _
               "The top layer must be the Training Point feature layer." & vbCrLf & _
               "One of the intermediate layers must be the Evidence raster layer." & vbCrLf & _
               "The bottom layer must be the Study Area raster layer.", vbCritical, "Analysis Parameters"
        Case gParamError And 2:
156:          MsgBox "ArcSDM documentation folder must exist!", vbCritical, "Analysis Parameters"
        Case gParamError And 4:
158:          MsgBox "The active data frame of this document does not have a spatial reference", vbCritical, "Analysis Parameters"
        Case Default
160:    End Select
161:    Unload Me


  Exit Sub
ErrorHandler:
  HandleError True, "btnError_Click " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), Err.Number, Err.Source, Err.Description, 4
End Sub

Private Sub btnTest_Click()
  On Error GoTo ErrorHandler
171:   MsgBox "Not implemented"
'167: frmAnlParms.Show vbModal
  Exit Sub
ErrorHandler:
  HandleError True, "btnTest_Click " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), Err.Number, Err.Source, Err.Description, 4
End Sub

Private Sub btnTP_Click()
  On Error GoTo ErrorHandler
 'gPTP.Run
181:     gPTP.Show vbModal 'That's all it does
  Exit Sub
ErrorHandler:
  HandleError True, "btnTP_Click " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), Err.Number, Err.Source, Err.Description, 4
End Sub
Private Sub btnNTP_Click()
  On Error GoTo ErrorHandler

 'gPNTP.Run
         Dim gPNTPRun As gPNTP_Run
191:     Set gPNTPRun = New gPNTP_Run
192:     gPNTPRun.gPNTP_Run

  Exit Sub
ErrorHandler:
  HandleError True, "btnNTP_Click " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), Err.Number, Err.Source, Err.Description, 4
End Sub
Private Sub btnUA_Click()
  On Error GoTo ErrorHandler
200:  If (gParam.isShiftdown) Then
         Dim gsdiHelp As gSDI_Help
202:     Set gsdiHelp = New gSDI_Help
203:     gsdiHelp.gSDI_Help ("sdmpram.htm#Area Units")
         Exit Sub
205:  End If

 'gPUA.Run
208: gPUA.Show vbModal 'That's all it does

  Exit Sub
ErrorHandler:
  HandleError True, "btnUA_Click " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), Err.Number, Err.Source, Err.Description, 4
End Sub

Private Sub cbxNTP_Change()
  On Error GoTo ErrorHandler
 'cbxNTP.Select
219:  Listeners.BroadcastUpdate cbxNTP ' thats all
  Exit Sub
ErrorHandler:
  HandleError True, "cbxNTP_Change " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), Err.Number, Err.Source, Err.Description, 4
End Sub

Private Sub cbxNTP_Click()
  On Error GoTo ErrorHandler

228:     Listeners.BroadcastUpdate cbxNTP


  Exit Sub
ErrorHandler:
  HandleError True, "cbxNTP_Click " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), Err.Number, Err.Source, Err.Description, 4
End Sub


Private Sub cbxTP_Change()
  On Error GoTo ErrorHandler

240:     Listeners.BroadcastUpdate cbxTP

  Exit Sub
ErrorHandler:
  HandleError True, "cbxTP_Change " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), Err.Number, Err.Source, Err.Description, 4
End Sub

Private Sub cbxTP_Click()
  On Error GoTo ErrorHandler
 'cbxTP.Select
250:     Listeners.BroadcastUpdate cbxTP 'thats all

  Exit Sub
ErrorHandler:
  HandleError True, "cbxTP_Click " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), Err.Number, Err.Source, Err.Description, 4

End Sub

Private Sub chkLR_Click()
  On Error GoTo ErrorHandler
 'gP.chkLR.Click
261:     Me.getEars.BroadcastUpdate Me.chkLR 'thats all
  Exit Sub
ErrorHandler:
  HandleError True, "chkLR_Click " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), Err.Number, Err.Source, Err.Description, 4
End Sub
Private Sub chkFL_Click()
  On Error GoTo ErrorHandler
 'gP.chkFL.Click
269:     Me.getEars.BroadcastUpdate Me.chkFL 'thats all
  Exit Sub
ErrorHandler:
  HandleError True, "chkFL_Click " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), Err.Number, Err.Source, Err.Description, 4
End Sub

Private Sub chkNN_Click()
  On Error GoTo ErrorHandler

278:     Me.getEars.BroadcastUpdate Me.chkNN


  Exit Sub
ErrorHandler:
  HandleError True, "chkNN_Click " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), Err.Number, Err.Source, Err.Description, 4
End Sub

Private Sub cmd_RAE_Click()
  On Error GoTo ErrorHandler

         Dim gSDIGetMask As AnalysisParameters.gSDI_GetMask
38:      Set gSDIGetMask = New AnalysisParameters.gSDI_GetMask
         Dim saLyr As IRasterLayer
43:      Set saLyr = gSDIGetMask.gSDI_GetMask
         Dim RAE As IRasterAnalysisEnvironment
290:     Set RAE = RasterAEUtils.getRasterAnalysisEnvironment
         Dim mskDataSet As IRasterBandCollection
292:     Set mskDataSet = RAE.Mask
         Dim s As String
294:     s = s & "Mask = " & mskDataSet.item(0).RasterDataset.CompleteName & "(" & saLyr.Name & ")" & vbCrLf
         Dim cellsize As Double
         Dim rasEnvVal As esriRasterEnvSettingEnum
297:     RAE.GetCellSize rasEnvVal, cellsize
            Select Case rasEnvVal
                Case esriRasterEnvMaxOf
300:             s = s & "Cell size = " & "maximum of inputs" & vbCrLf
                Case esriRasterEnvMinOf
302:             s = s & "Cell size = " & "minimum of inputs" & vbCrLf
                Case esriRasterEnvValue
304:             s = s & "Cell size = " & cellsize & vbCrLf
                Case Else
306:     End Select
            Dim extent As IEnvelope
308:     RAE.GetExtent rasEnvVal, extent
            Select Case rasEnvVal
                Case esriRasterEnvMaxOf
311:             s = s & "Extent = " & "maximum of inputs" & vbCrLf
                Case esriRasterEnvMinOf
313:             s = s & "Extent = " & "minimum of inputs" & vbCrLf
                Case esriRasterEnvValue
315:     s = s & "Extent = " & "Left=" & extent.XMin & ", Top=" & extent.YMax & vbCrLf & vbTab & ", Right=" & extent.XMax & ", Bottom=" & extent.YMin & vbCrLf
                Case Else
317:     End Select
    
319:     s = s & "Output Raster Workspace = " & RAE.OutWorkspace.pathname & vbCrLf
320:     s = s & "Output Raster Spatial Reference = " & RAE.OutSpatialReference.Name & vbCrLf
321:     s = s & "Output Raster Prefix = " & RAE.DefaultOutputRasterPrefix & vbCrLf
    
         Dim rasEnvVerType As esriRasterVerifyEnum
324:     rasEnvVerType = RAE.VerifyType
        Select Case rasEnvVerType
            Case esriRasterVerifyOff
327:             s = s & "Raster Verify = " & "Overwrite existing output" & vbCrLf
            Case esriRasterVerifyOn
329:             s = s & "Raster Verify = " & "Prompts user to override existing output" & vbCrLf
            Case esriRasterVerifyError
331:             s = s & "Raster Verify = " & "Produce error when the output already exists" & vbCrLf
            Case Else
333:    End Select
334:    s = s & "--------------------- Explanation ------------------------------------------------" & vbCrLf & _
                "The working directory is determined from the document location." & vbCrLf & _
                "The mask, extent, cellsize, and spatial reference are set from the study area raster layer." & vbCrLf & _
                "The Spatial Analyst/Options are not used by ArcSDM."
335:     MsgBox s, vbInformation, "Raster Analysis Environment for ArcSDM3"


  Exit Sub
ErrorHandler:
  HandleError False, "cmd_RAE_Click " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), Err.Number, Err.Source, Err.Description, 4
End Sub



Private Sub docEvents_ActiveViewChanged()
346:     Unload Me
End Sub

Private Sub Form_Initialize()
  On Error GoTo ErrorHandler

357:    gParam.KeyPreview = True
  Exit Sub
ErrorHandler:
  HandleError True, "Form_Initialize " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), Err.Number, Err.Source, Err.Description, 4
End Sub

Private Sub Form_KeyDown(keycode As Integer, shift As Integer)
  On Error GoTo ErrorHandler

366:     shiftDown = (shift And vbShiftMask) > 0

  Exit Sub
ErrorHandler:
  HandleError True, "Form_KeyDown " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), Err.Number, Err.Source, Err.Description, 4
End Sub

Private Sub Form_Load()
    On Error GoTo ErrorHandler
'Set the listener object
376:     Set Listeners = New SDMUtilities.SDMListeners
377:     Set aCtl = Listeners
'Set the globals
379:     If SDMGlobals.SDMApp Is Nothing Then Set SDMGlobals.SDMApp = New AppRef
380:     If SDMGlobals.SDMDoc Is Nothing Then Set SDMGlobals.SDMDoc = SDMGlobals.SDMApp.Document
381:     If SDMGlobals.SDMUtil Is Nothing Then Set SDMGlobals.SDMUtil = New SDMUtils
382:     If SDMGlobals.SDMStatusBar Is Nothing Then Set SDMGlobals.SDMStatusBar = SDMGlobals.SDMApp.StatusBar
383:     If SDMGlobals.SDMHelp Is Nothing Then Set SDMGlobals.SDMHelp = New gSDI_Help
384:     If SDMGlobals.SDMMap Is Nothing Then
385:          If SDMGlobals.SDMMxDoc Is Nothing Then
386:             Set SDMGlobals.SDMMxDoc = SDMGlobals.SDMApp.Document
387:          End If
388:          Set SDMGlobals.SDMMap = SDMMxDoc.FocusMap
389:     End If
390:     Set myParams = New SDMList
391:     Set mapEvents = SDMGlobals.SDMMap
392:     Set docEvents = SDMGlobals.SDMDoc

'Is Active Data Frame setup properly?
395:     gParamError = 0
396:     If Not CheckForValidSDMDocument(SDMGlobals.SDMMap) Then
397:        If Not (gParamError And 1) Then gParamError = gParamError Xor 1
398:     End If
'Is help folder saved to registry
400:     If GetSetting("SDMExtension", "Globals", "HelpFolder", "None") = "None" Then
401:         If Not (gParamError And 2) Then gParamError = gParamError Xor 2
402:     End If
'Does map have a spatial reference
404:     If SDMGlobals.SDMMap.SpatialReference Is Nothing Then
405:         If Not (gParamError And 4) Then gParamError = gParamError Xor 4
406:     End If
        'gParam.getEars.Update Me.btnError
        'If Me.btnError.Visible Then Exit Sub
409:     Me.btnError.Visible = gParamError > 0
403:     If Me.btnError.Visible Then Exit Sub
         
'Set the SDM workspace
413:     If SDMGlobals.SDMWorkspace Is Nothing Then
             Dim cwdPath As String
             Dim lyr As IDataset
416:         If SDMUtil.getMap.layerCount > 0 Then
417:             cwdPath = WOETableUtils.getProjectDir
418:         Else
419:             cwdPath = Environ("TEMP")
420:         End If
421:         Set SDMGlobals.SDMWorkspace = SDMGlobals.SDMUtil.openShapeFileWorkspace(cwdPath)
422:      End If
'Set the form caption
424:     gParam.Caption = gParam.Caption & "-" & SDMGlobals.SDMUtil.getMap.Name
'Set shift state
426:     shiftDown = False

'Set the analysis parameters study area from bottommost grid
429:     gParam.cbxSA.Clear
         Dim intgthms As gSDI_GetIntGThemes
431:     Set intgthms = New gSDI_GetIntGThemes
         Dim intgrids As SDMUtilities.SDMList
433:     Set intgrids = intgthms.gSDI_GetIntGThemes(SDMUtil.getMap)
         Dim intgrid As ILayer
         Dim thing As Variant
436:     For Each thing In intgrids.list
437:         Set intgrid = thing
             Dim lastname As String
439:         lastname = intgrid.Name
440:         gParam.cbxSA.AddItem lastname
441:     Next thing
442:     gParam.cbxSA.ListIndex = gParam.cbxSA.ListCount - 1
'Allow integer raster without an attribute table to be in combobox list
         Dim lastLayer As Long
445:     lastLayer = SDMGlobals.SDMMap.layerCount - 1
446:     If SDMGlobals.SDMMap.layer(lastLayer).Name <> gParam.cbxSA.Text Then
447:        gParam.cbxSA.AddItem SDMGlobals.SDMMap.layer(lastLayer).Name
448:        gParam.cbxSA.ListIndex = gParam.cbxSA.ListCount - 1
449:     End If
'Internal RasterAnalysisEnvironment is set from cbxSA, the study area
    'If SDMGlobals.SDMRAEnvironment Is Nothing Then
         'Set SDMGlobals.SDMRAEnvironment = RasterAEUtils.getRasterAnalysisEnvironment >>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>..
    'End If
   
'Open the form
456:     Set ObjectTag = New SDMUtilities.SDMList
457:     Set gParamOpen = New gParam_Open
458:     gParamOpen.gParam_Open
459:     Set gParamOpen = Nothing
460:     gParam.ZOrder 0
    
'Set document events to capture change of active view
           Dim pMxDoc As IMxDocument
464:     Set pMxDoc = SDMGlobals.SDMDoc
465:     Set mapEvents = SDMGlobals.SDMMap

    Exit Sub
ErrorHandler:
  HandleError True, "Form_Load " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), Err.Number, Err.Source, Err.Description, 4
End Sub

Private Sub Form_Unload(Cancel As Integer)
  On Error GoTo ErrorHandler

475:     Set gParamOpen = Nothing
476:     Set Listeners = Nothing
477:     Set ObjectTag = Nothing
         Dim gSDISaveParms As gSDI_SaveParams
479:     Set gSDISaveParms = New gSDI_SaveParams
'444:     gSDISaveParms.gSDI_SaveParameters
481:     Set gSDISaveParms = Nothing

  Exit Sub
ErrorHandler:
  HandleError True, "Form_Unload " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), Err.Number, Err.Source, Err.Description, 4
End Sub

Private Sub mapEvents_ItemAdded(ByVal item As Variant)
  On Error GoTo ErrorHandler
  
491:     TPInit
  
  Exit Sub
ErrorHandler:
  HandleError False, "mapEvents_ItemAdded " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), Err.Number, Err.Source, Err.Description, 4
End Sub
Private Sub mapEvents_ItemDeleted(ByVal item As Variant)
  On Error GoTo ErrorHandler

500:     TPInit

  Exit Sub
ErrorHandler:
  HandleError False, "mapEvents_ItemDeleted " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), Err.Number, Err.Source, Err.Description, 4
End Sub

Private Sub mapEvents_ItemReordered(ByVal item As Variant, ByVal toIndex As Long)
  On Error GoTo ErrorHandler

510:     TPInit

  Exit Sub
ErrorHandler:
  HandleError False, "mapEvents_ItemReordered " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), Err.Number, Err.Source, Err.Description, 4
End Sub


Private Sub radWEDD_Click()
  On Error GoTo ErrorHandler
 'gP.radWEDD.Click
521:  Listeners.BroadcastUpdate radWEDD ' thats all
  Exit Sub
ErrorHandler:
  HandleError True, "radWEDD_Click " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), Err.Number, Err.Source, Err.Description, 4
End Sub
Private Sub radExpt_Click()
  On Error GoTo ErrorHandler
 'gP.radExpt.Click
529:  Listeners.BroadcastUpdate radExpt 'thats all
  Exit Sub
ErrorHandler:
  HandleError True, "radExpt_Click " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), Err.Number, Err.Source, Err.Description, 4
End Sub
Private Sub chkWofE_Click()
  On Error GoTo ErrorHandler
 'gP.chkWofE.Click
537:  Me.getEars.BroadcastUpdate chkWofE 'thats all
    Exit Sub
ErrorHandler:
  HandleError True, "chkWofE_Click " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), Err.Number, Err.Source, Err.Description, 4
End Sub
Private Sub chkNNSup_Click()
  On Error GoTo ErrorHandler
 'gP.chkNNSup.Click
545:  Listeners.BroadcastUpdate chkNNSup 'thats all
  Exit Sub
ErrorHandler:
  HandleError True, "chkNNSup_Click " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), Err.Number, Err.Source, Err.Description, 4
End Sub
Private Sub chkNNUns_Click()
  On Error GoTo ErrorHandler
 'gP.chkNNUns.Click
553:  Listeners.BroadcastUpdate chkNNUns 'thats all
  Exit Sub
ErrorHandler:
  HandleError True, "chkNNUns_Click " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), Err.Number, Err.Source, Err.Description, 4
End Sub
Private Sub btnOK_Click()
  On Error GoTo ErrorHandler
 'gP.btnOK.Click
      Dim gPbtnOkClick As gP_btnOK_Click
562:  Set gPbtnOkClick = New gP_btnOK_Click
563:  gPbtnOkClick.gParam_btnOK_Click
  Exit Sub
ErrorHandler:
  HandleError True, "btnOK_Click " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), Err.Number, Err.Source, Err.Description, 4
End Sub
Private Sub btnCan_Click()
  On Error GoTo ErrorHandler
570:     Me.chkNNSup.Value = 0
571:     Me.chkNNUns.Value = 0
 'gP.btnCan.Click
Dim gPbtnCanClick As gP_btnCan_Click
574: Set gPbtnCanClick = New gP_btnCan_Click
'540: gPbtnCanClick.gP_btnCan_Click
576: Unload Me
  Exit Sub
ErrorHandler:
  HandleError True, "btnCan_Click " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), Err.Number, Err.Source, Err.Description, 4
End Sub
Private Sub btnSav_Click()
  On Error GoTo ErrorHandler
 'gSDI.WriteParameters
584:  MsgBox "Saving analysis parameters not implemented", vbOKOnly, "gParam"
  Exit Sub
ErrorHandler:
  HandleError True, "btnSav_Click " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), Err.Number, Err.Source, Err.Description, 4
End Sub
Private Sub btnLd_Click()
  On Error GoTo ErrorHandler

 'gSDI.ReadParameters
593:  MsgBox "Loading saved analysis parameters not implemented", vbOKOnly, "gParam"
  Exit Sub
ErrorHandler:
  HandleError True, "btnLd_Click " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), Err.Number, Err.Source, Err.Description, 4
End Sub
Private Sub btnHlp_Click()
  On Error GoTo ErrorHandler

  Dim gsdiHelp As New gSDI_Help
602:   gsdiHelp.gSDI_Help "sdmpram.htm"
  Exit Sub
ErrorHandler:
  HandleError True, "btnHlp_Click " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), Err.Number, Err.Source, Err.Description, 4
End Sub

Private Sub txtMD_Change()
  On Error GoTo ErrorHandler
610:      Listeners.BroadcastUpdate txtMD
  Exit Sub
ErrorHandler:
  HandleError True, "txtMD_Change " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), Err.Number, Err.Source, Err.Description, 4
End Sub

Public Sub CreateStudyAreaShapeFile()
  On Error GoTo ErrorHandler

   Dim studyAreaName As String
620:    studyAreaName = Me.cbxSA.Text
   Dim saLyr As ILayer
   Dim uid As New uid
623:    uid = "{E156D7E5-22AF-11D3-9F99-00C04F6BC78E}"
   Dim doclyrs As IEnumLayer
625:    Set doclyrs = SDMGlobals.SDMUtil.getMap.layers(uid, True)
626:    doclyrs.Reset
627:     Set saLyr = doclyrs.Next
628:     While Not saLyr Is Nothing
629:         If (LCase(saLyr.Name) = studyAreaName & "-Outline") Then
            Exit Sub
631:         End If
632:         Set saLyr = doclyrs.Next
633:     Wend
    Dim ans As Variant
635:     ans = MsgBox("Study area shapefile not found: " & studyAreaName & "-Outline" & vbCrLf & _
            "Create one from " & studyAreaName & "?", vbYesNo, c_sModuleFileName)
637:     If (ans = vbYes) Then
638:         MsgBox "Cannot make study area shapefile", vbCritical, c_sModuleFileName
639:     End If


  Exit Sub
ErrorHandler:
  HandleError True, "CreateStudyAreaShapeFile " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), Err.Number, Err.Source, Err.Description, 4
End Sub

Private Function CheckForValidSDMDocument(ByRef map As IMap) As Boolean
  On Error GoTo ErrorHandler

650:     If map.layerCount > 2 Then
             Dim pMap As IMap
652:         Set pMap = map
             Dim pEnumLayer As IEnumLayer
654:         Set pEnumLayer = pMap.layers
             Dim layerCount As Long
656:         layerCount = map.layerCount
        'Check first layer to be point featurelayer
             Dim layer As ILayer
659:         Set layer = pMap.layer(0)
660:         If layer.Valid Then
661:            If TypeOf layer Is IFeatureLayer Then
                    Dim pLayer As IFeatureLayer
663:                Set pLayer = layer
664:                CheckForValidSDMDocument = pLayer.FeatureClass.shapetype = esriGeometryPoint
                    If Not CheckForValidSDMDocument Then Exit Function
666:            End If
667:         Else
668:             CheckForValidSDMDocument = False
                 Exit Function
670:         End If
        'Check last layer to be rasterlayer
672:         Set layer = map.layer(layerCount - 1)
673:         If layer.Valid Then
674:            If (TypeOf layer Is IRasterLayer) Then
                    Dim rlayer As IRasterLayer
676:                Set rlayer = layer
                    Dim rProps As IRasterProps
678:                Set rProps = rlayer.Raster
679:                CheckForValidSDMDocument = rProps.IsInteger
                    If Not CheckForValidSDMDocument Then Exit Function
681:            Else
682:                CheckForValidSDMDocument = False
                    Exit Function
684:            End If
685:         Else
686:             CheckForValidSDMDocument = False
                 Exit Function
688:         End If
        'Check that at least other raster layer than last is integer
690:         CheckForValidSDMDocument = False
691:         pEnumLayer.Reset
692:         Set layer = pEnumLayer.Next
693:         Do While Not layer Is Nothing
694:           If Not layer Is pMap.layer(pMap.layerCount - 1) Then
695:             If layer.Valid Then
696:                If (TypeOf layer Is IRasterLayer) Then
697:                    Set rlayer = layer
698:                    Set rProps = rlayer.Raster
699:                    If rProps.IsInteger Then
700:                        CheckForValidSDMDocument = True
                            Exit Function
702:                    End If
703:                End If
704:             End If
705:           End If
706:           Set layer = pEnumLayer.Next
707:         Loop
708:     Else
709:         CheckForValidSDMDocument = False
710:     End If
               


  Exit Function
ErrorHandler:
  HandleError False, "CheckForValidSDMDocument " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), Err.Number, Err.Source, Err.Description, 4
End Function

Public Sub Ping()
  On Error GoTo ErrorHandler

'just to load gparam


  Exit Sub
ErrorHandler:
  HandleError True, "Ping " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), Err.Number, Err.Source, Err.Description, 4
End Sub

Private Sub txtUA_Change()
  On Error GoTo ErrorHandler

733:     Me.getEars.BroadcastUpdate Me.txtUA


  Exit Sub
ErrorHandler:
  HandleError True, "txtUA_Change " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), Err.Number, Err.Source, Err.Description, 4
End Sub

Private Sub txtUA_KeyPress(KeyAscii As Integer)
  On Error GoTo ErrorHandler

    If IsNumeric(Chr(KeyAscii)) Then Exit Sub
    If (KeyAscii = Asc(".")) Then Exit Sub
746:     KeyAscii = 0


  Exit Sub
ErrorHandler:
  HandleError True, "txtUA_KeyPress " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), Err.Number, Err.Source, Err.Description, 4
End Sub

Public Property Get RanCaller() As Form
  On Error GoTo ErrorHandler

757:     Set RanCaller = RanDlgCaller


  Exit Property
ErrorHandler:
  HandleError True, "RanCaller " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), Err.Number, Err.Source, Err.Description, 4
End Property

Public Property Set RanCaller(ByVal vNewValue As Form)
  On Error GoTo ErrorHandler

768:     Set RanDlgCaller = vNewValue


  Exit Property
ErrorHandler:
  HandleError True, "RanCaller " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), Err.Number, Err.Source, Err.Description, 4
End Property
Public Function TrainingPointsSelected() As Boolean
  On Error GoTo ErrorHandler


'Test for Training Point Selection
Dim pFeatureLayer As IFeatureLayer
Dim pSelectionSet As ISelectionSet
Dim pFeatureSelection As IFeatureSelection

784: TrainingPointsSelected = True
785: If Me.cbxTP.Enabled Then
786:     Set pFeatureLayer = WOETableUtils.FindLayerByName(gParam.cbxTP)
787:     Set pFeatureSelection = pFeatureLayer 'QI
788:     Set pSelectionSet = pFeatureSelection.SelectionSet
789:     If pSelectionSet.Count = 0 Then
790:         If MsgBox("Selected Training Points theme has no points selected. Continue?", vbYesNo, c_sModuleFileName) = vbNo Then
791:             TrainingPointsSelected = False
            Exit Function
793:         End If
794:     End If
795: End If
796: If Me.btnNTP.Enabled And Me.cbxNTP.Enabled Then
797:     If (Me.cbxNTP.Text <> "<None>") And (Me.cbxNTP.Text <> "<No themes found>") Then
798:        Set pFeatureLayer = WOETableUtils.FindLayerByName(gParam.cbxNTP)
799:        Set pFeatureSelection = pFeatureLayer 'QI
800:        Set pSelectionSet = pFeatureSelection.SelectionSet
801:        If pSelectionSet.Count = 0 Then
802:             If MsgBox("Selected Non-deposit Training Points theme has no points selected. Continue?", vbYesNo, c_sModuleFileName) = vbNo Then
803:                 TrainingPointsSelected = False
                     Exit Function
805:             End If
806:        End If
807:     End If
808: End If



  Exit Function
ErrorHandler:
  HandleError True, "TrainingPointsSelected " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), Err.Number, Err.Source, Err.Description, 4
End Function


Public Property Get Params() As SDMList
  On Error GoTo ErrorHandler

821:     Set Params = myParams


  Exit Property
ErrorHandler:
  HandleError True, "Params " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), Err.Number, Err.Source, Err.Description, 4
End Property

Public Property Set Params(newParams As SDMList)
  On Error GoTo ErrorHandler

832:     Set myParams = newParams


  Exit Property
ErrorHandler:
  HandleError True, "Params " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), Err.Number, Err.Source, Err.Description, 4
End Property

Private Sub TPInit()  'Initialize TP & NTP comboboxes
     Dim gSDIGetTPs As gSDI_GetTPTHemes
842: Set gSDIGetTPs = New gSDI_GetTPTHemes
     Dim TPList As New SDMUtilities.SDMList
844: Set TPList = gSDIGetTPs.gSDI_GetTPTHemes

     Dim TPSel As String, NTPSel As String
847: TPSel = Trim(Me.cbxTP.Text)
848: NTPSel = Trim(Me.cbxNTP.Text)
         
850: Me.cbxTP.Clear
851: Me.cbxNTP.Clear
     Dim tpVar As Variant
     Dim tp As IFeatureLayer
     Dim TPNameLst As New SDMUtilities.SDMList
855: For Each tpVar In TPList.list
856:     Set tp = tpVar
857:     TPNameLst.Add tp.Name
858:     gParam.cbxTP.AddItem tp.Name
859:     gParam.cbxNTP.AddItem tp.Name
860: Next tpVar
861: If gParam.cbxTP.ListCount = 0 Then
862:    gParam.cbxTP.AddItem "<No themes found>"
863:    gParam.cbxTP.ListIndex = 0
864:    gParam.cbxNTP.Clear
865:    gParam.cbxNTP.AddItem "<No themes found>"
866:    gParam.cbxNTP.ListIndex = 0
867: ElseIf gParam.cbxTP.ListCount = 1 Then
868:    gParam.cbxTP.ListIndex = 0
869:    gParam.cbxNTP.Clear
870:    gParam.cbxNTP.AddItem "<No themes found>"
871:    gParam.cbxNTP.ListIndex = 0
872:    gParam.cbxNTP.Enabled = False
873: ElseIf gParam.cbxTP.ListCount > 1 Then
874:    If TPNameLst.FindByValue(TPSel) > -1 Then
875:        gParam.cbxTP.ListIndex = TPNameLst.FindByValue(TPSel)
876:    Else
877:        gParam.cbxTP.ListIndex = 0
878:    End If
879:    gParam.cbxNTP.AddItem "<None>"
880:    If TPNameLst.FindByValue(NTPSel) > -1 Then
881:        gParam.cbxNTP.ListIndex = TPNameLst.FindByValue(NTPSel)
882:    Else
883:        gParam.cbxNTP.ListIndex = (gParam.cbxTP.ListIndex + 1) Mod (gParam.cbxNTP.ListCount - 1)
884:    End If
885:    gParam.cbxNTP.Enabled = True
886: End If


End Sub

