VERSION 5.00
Begin VB.Form gRP 
   ClientHeight    =   4020
   ClientLeft      =   0
   ClientTop       =   0
   ClientWidth     =   5340
   KeyPreview      =   -1  'True
   LinkTopic       =   "gRP1"
   ScaleHeight     =   4020
   ScaleWidth      =   5340
   StartUpPosition =   2  'CenterScreen
   Visible         =   0   'False
   Begin VB.ComboBox cbxCtf 
      Height          =   315
      Left            =   1320
      TabIndex        =   5
      Text            =   "Threshold:"
      Top             =   2160
      Width           =   2820
   End
   Begin VB.TextBox txtNP 
      Alignment       =   1  'Right Justify
      Height          =   300
      Left            =   2040
      TabIndex        =   4
      Text            =   "100"
      Top             =   2640
      Width           =   975
   End
   Begin VB.CommandButton btnCan 
      Caption         =   "Cancel"
      Height          =   540
      Left            =   2040
      TabIndex        =   2
      ToolTipText     =   "Abort generating training points"
      Top             =   3360
      Width           =   1035
   End
   Begin VB.CommandButton btnOK 
      Caption         =   "OK"
      Height          =   540
      Left            =   840
      TabIndex        =   3
      Tag             =   "False"
      ToolTipText     =   "Press shift-Click for Help"
      Top             =   3360
      Width           =   1035
   End
   Begin VB.Frame aControlPanel4 
      Height          =   3105
      Left            =   240
      TabIndex        =   0
      Top             =   120
      Width           =   4785
      Begin VB.CheckBox chkRand 
         Caption         =   "Randomize"
         Height          =   255
         Left            =   3000
         TabIndex        =   13
         ToolTipText     =   "Successive T.P. sets are different when checked."
         Top             =   2640
         Value           =   1  'Checked
         Width           =   1215
      End
      Begin VB.ComboBox cbxSrc 
         Height          =   315
         Left            =   840
         Sorted          =   -1  'True
         Style           =   2  'Dropdown List
         TabIndex        =   11
         ToolTipText     =   "Enter theme name"
         Top             =   735
         Width           =   3060
      End
      Begin VB.ComboBox cbxFld 
         Height          =   315
         Left            =   840
         Sorted          =   -1  'True
         TabIndex        =   10
         Text            =   "cbxFld"
         Top             =   1200
         Width           =   3060
      End
      Begin VB.Label Label3 
         Caption         =   "Range:"
         Height          =   255
         Left            =   240
         TabIndex        =   14
         Top             =   1680
         Width           =   615
      End
      Begin VB.Label lbltxtThrsh 
         Caption         =   "Threshold:"
         Height          =   255
         Left            =   240
         TabIndex        =   12
         Top             =   2040
         Width           =   735
      End
      Begin VB.Label Label2 
         Caption         =   "Field:"
         Height          =   255
         Left            =   240
         TabIndex        =   9
         Top             =   1200
         Width           =   1095
      End
      Begin VB.Label Label1 
         Caption         =   "Theme:"
         Height          =   255
         Left            =   240
         TabIndex        =   8
         Top             =   840
         Width           =   1095
      End
      Begin VB.Label lblRng 
         Caption         =   "(0 - 0.6)"
         Height          =   210
         Left            =   840
         TabIndex        =   7
         Top             =   1680
         Width           =   3045
      End
      Begin VB.Label lbltxtNP 
         Caption         =   "# of Training Points:"
         Height          =   345
         Left            =   240
         TabIndex        =   6
         Top             =   2640
         Width           =   1440
      End
      Begin VB.Label txtIns 
         Caption         =   "Specify the the source of probabilities for generating points of low probability:"
         Height          =   420
         Left            =   240
         TabIndex        =   1
         Top             =   240
         Width           =   3675
      End
   End
   Begin VB.Label SDMLogo 
      Alignment       =   2  'Center
      Appearance      =   0  'Flat
      BackColor       =   &H0000C000&
      BorderStyle     =   1  'Fixed Single
      Caption         =   "ArcSDM3"
      BeginProperty Font 
         Name            =   "Roman"
         Size            =   14.25
         Charset         =   255
         Weight          =   700
         Underline       =   0   'False
         Italic          =   -1  'True
         Strikethrough   =   0   'False
      EndProperty
      ForeColor       =   &H0080FFFF&
      Height          =   375
      Left            =   3240
      TabIndex        =   15
      Top             =   3360
      Width           =   1335
   End
End
Attribute VB_Name = "gRP"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit
Const c_sModuleFileName As String = "gRp.frm"
Private Listeners As SDMUtilities.SDMListeners
Public WithEvents aCtl As SDMUtilities.SDMListeners
Attribute aCtl.VB_VarHelpID = -1
Public AnlParms As AnalysisParameters.AnlParams

Private ObjectTag As SDMUtilities.SDMList
Private shiftDown As Boolean
Public Property Get isShiftDown() As Boolean
10:     isShiftDown = shiftDown
11:     shiftDown = False
End Property


Private Sub cbxCtf_Change()
16: gRP.aCtl.BroadcastUpdate Me.cbxCtf
End Sub

Private Sub cbxCtf_Click()
20: gRP.aCtl.BroadcastUpdate Me.cbxCtf
End Sub

Private Sub cbxFld_Click()
24:     gRP.aCtl.BroadcastUpdate Me.cbxFld
End Sub


Private Sub cbxSrc_Click()
29:     gRP.aCtl.BroadcastUpdate Me.cbxSrc
End Sub

Private Sub Form_Initialize()
33:     Set Listeners = New SDMUtilities.SDMListeners
34:     Set aCtl = Listeners
35:     Set AnlParms = New AnalysisParameters.AnlParams
36:     Me.btnCan.Tag = ""
End Sub

Private Sub btnCan_Click()
 'gRP.btnCan.Click
41:  If isShiftDown Then
42:     SDMHelp.gSDI_Help "sdmnn2.htm#Random"
43:  Else
44:     Me.Hide
45:     Unload Me
46:  End If
End Sub

Private Sub btnOK_Click()
 'gRP.btnOK.Click
51:  If isShiftDown Then
52:     SDMHelp.gSDI_Help "sdmnn2.htm#Random"
53:  Else
         Dim gRPSrcrun As New gRPSrc_Run
         If Not gRPSrcrun.gRPSrc_Run Then Exit Sub
56:  End If
57:  Me.ZOrder 0
End Sub

Private Sub Form_KeyDown(KeyCode As Integer, Shift As Integer)
61:     shiftDown = (Shift And vbShiftMask) > 0
End Sub

Private Sub Form_KeyUp(KeyCode As Integer, Shift As Integer)
65:     shiftDown = False
End Sub

Private Sub Form_Load()
    On Error GoTo ErrorHandler
70:     Me.Caption = "Generate Random Training Points"
71:    If SDMGlobals.SDMApp Is Nothing Then Set SDMGlobals.SDMApp = New AppRef
72:    If SDMGlobals.SDMDoc Is Nothing Then Set SDMGlobals.SDMDoc = SDMGlobals.SDMApp.Document
73:     If SDMGlobals.SDMMap Is Nothing Then
            Dim pMxDoc As IMxDocument
75:         Set pMxDoc = SDMGlobals.SDMDoc
76:         Set SDMGlobals.SDMMap = pMxDoc.FocusMap
77:     End If
78:    If SDMGlobals.SDMUtil Is Nothing Then
79:             Set SDMGlobals.SDMUtil = New SDMUtilities.SDMUtils
80:             Set SDMGlobals.SDMUtil.setAPP = SDMGlobals.SDMApp
81:         End If
82:    If SDMGlobals.SDMStatusBar Is Nothing Then Set SDMGlobals.SDMStatusBar = SDMGlobals.SDMApp.StatusBar
83:    If SDMGlobals.SDMHelp Is Nothing Then Set SDMGlobals.SDMHelp = New SDMUtilities.gSDI_Help
84:    If SDMGlobals.SDMdataDict Is Nothing Then Set SDMGlobals.SDMdataDict = New SDMUtilities.SDMDictionary
85:    If SDMGlobals.SDMWorkspace Is Nothing Then
            Dim cwdPath As String
            Dim lyr As IDataset
88:        Set lyr = SDMGlobals.SDMMap.layers.Next
89:        If Not lyr Is Nothing Then
90:            cwdPath = lyr.Workspace.PathName
91:        Else
92:            cwdPath = Environ("TEMP")
93:        End If
94:        Set SDMGlobals.SDMWorkspace = SDMGlobals.SDMUtil.openShapeFileWorkspace(cwdPath)
95:    End If
96:    shiftDown = False
        Dim gRPOpen As gRP_Open
98:    Set gRPOpen = New gRP_Open
99:    gRPOpen.gRP_Open
100:    Set gRPOpen = Nothing
  Exit Sub
ErrorHandler:
  HandleError True, "Form_Load " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), Err.Number, Err.Source, Err.Description, 4
End Sub

'Include selections for all controls with an update method
'Method could be local or belong to an instantiated object
Private Sub aCtl_UpdateEvt(ByRef ctl As Object)
    On Error GoTo ErrorHandler
    Select Case (ctl.Name)
        Case Me.cbxSrc.Name
112:         Me.cbxSrc.Clear
             Dim lstGThm As SDMUtilities.SDMList
             Dim gSDIGetIntGThemes As gSDI_GetIntGThemes
115:         Set gSDIGetIntGThemes = New gSDI_GetIntGThemes
116:         Set lstGThm = gSDIGetIntGThemes.gSDI_GetIntGThemes(SDMGlobals.SDMMap)
117:         lstGThm.Remove lstGThm.Count - 1
             Dim var As Variant
119:         For Each var In lstGThm.list
                Dim gThm As ILayer
121:            Set gThm = var
122:            Me.cbxSrc.AddItem gThm.Name
123:        Next var
124:        Me.cbxSrc.ListIndex = 0
        Case Me.cbxFld.Name
126:             Me.cbxFld.Clear
127:             Me.cbxFld.Enabled = True
                 Dim pDispTbl As IDisplayTable
129:             Set pDispTbl = WOETableUtils.FindLayerByName(Me.cbxSrc.Text)
                 Dim ucTbl As ITable
131:             Set ucTbl = pDispTbl.DisplayTable
                 Dim fldList As SDMUtilities.SDMList
133:             Set fldList = WOETableUtils.getFieldsNamesByType(ucTbl, esriFieldTypeDouble)
                 Dim nfld As Long
135:             For nfld = 1 To ucTbl.Fields.FieldCount - 1
                     Dim strFld As String
137:                 strFld = ucTbl.Fields.Field(nfld).Name
138:                 If strFld = "Count" Or strFld Like "Raster*" Or strFld Like "*.OID" Or strFld Like "*.ID" Or _
                                    strFld Like "*Area_sqm" Then
140:                 Else
141:                     If (strFld = "Value") Or (ucTbl.Fields.Field(nfld).Type = esriFieldTypeDouble) Then _
                                Me.cbxFld.AddItem strFld
143:                 End If
144:             Next nfld
145:             If Me.cbxFld.ListCount = 0 Then Me.btnOK.Enabled = False
146:              If Me.cbxFld.ListCount = 0 Then Me.cbxFld.AddItem "<None>"
147:             Me.cbxFld.ListIndex = 0
       Case Me.lblRng.Name
            'Self.SetLabel (lblRng)
            Dim min As String
151:        min = gRP.cbxCtf.list(0)
            Dim max As String
153:        max = gRP.cbxCtf.list(gRP.cbxCtf.ListCount - 1)
154:        gRP.lblRng.Caption = "(" & Format(min, "0.########E+#") & " - " & Format(max, "0.#########E+#") & ")"
        Case Me.cbxCtf.Name
156:        Me.cbxCtf.Clear
            Dim gRPcbxCtfUpdate As gRP_cbxCtf_Update
158:        Set gRPcbxCtfUpdate = New gRP_cbxCtf_Update
159:        gRPcbxCtfUpdate.gRP_cbxCtf_Update
160:        Set gRPcbxCtfUpdate = Nothing
161:        If Me.cbxCtf.ListCount > 0 Then Me.cbxCtf.ListIndex = 0
        Case Me.txtNP.Name
163:         If AnlParms.gParamFrm.chkwofe.Value = 1 Then
164:            Me.txtNP.Text = AnlParms.gPTPFrm.txtTPsSel.Caption
165:         Else
166:            Me.txtNP.Text = "100"
167:         End If
        Case Me.btnOK.Name
169:             If Me.txtNP.Text = "" Or Me.txtNP.Text = "0" Or (Not IsNumeric(Me.txtNP.Text)) Or Me.cbxSrc.ListCount = 0 Or Me.cbxFld.Text = "<None>" Then
170:                 Me.btnOK.Enabled = False
171:             Else
172:                 Me.btnOK.Enabled = True
173:             End If
        Case Else
175:             MsgBox "Update not found: " & ctl.Parent.Name, vbCritical, "gL.aCtl.Update"
176:     End Select
    Exit Sub
ErrorHandler:
  HandleError True, "aCtl_UpdateEvt " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), Err.Number, Err.Source, Err.Description, 4
End Sub


Private Sub txtNP_Change()
184:         Me.aCtl.BroadcastUpdate Me.txtNP
End Sub
