Attribute VB_Name = "SDMGlobals"
Option Explicit

'ESRI Globals
Public SDMApp As esriFramework.IApplication  'ArcMap application
Public SDMDoc As esriFramework.IDocument
Public SDMStatusBar As esriSystem.IStatusBar
Public SDMActiveView As esriCarto.IActiveView
Public SDMMap As esriCarto.IMap

'SDM Global Variables
Public SDMHome As String 'SDM Home Directory
Public SDMHelpDir As String 'SDM Help Directory
Public SDMdataMD As SDMUtilities.SDMDictionary 'gTW global dictionary
Public SDMdataDict As SDMUtilities.SDMDictionary 'gTW global collection
Public SDMWorkspace As esrigeodatabase.IWorkspace 'SDM Workspace
Public SDMUtil As SDMUtilities.SDMUtils
Public SDMHelp As SDMUtilities.gSDI_Help
Public SDMListener As SDMUtilities.SDMListeners
Public SDMStatFile As Object
Public SDMPrjDir As String
Public SDMTableUtils As SDMUtilities.SDMTableUtils
Public SDMRAEnvironment As IRasterAnalysisEnvironment

Sub SetGlobals()
25:    If SDMGlobals.SDMApp Is Nothing Then Set SDMGlobals.SDMApp = New AppRef
26:    If SDMGlobals.SDMDoc Is Nothing Then Set SDMGlobals.SDMDoc = SDMGlobals.SDMApp.Document
27:     If SDMGlobals.SDMMap Is Nothing Then
            Dim pMxDoc As IMxDocument
29:         Set pMxDoc = SDMGlobals.SDMDoc
30:         Set SDMGlobals.SDMMap = pMxDoc.FocusMap
31:     End If
32:    If SDMGlobals.SDMUtil Is Nothing Then
33:             Set SDMGlobals.SDMUtil = New SDMUtilities.SDMUtils
34:             Set SDMGlobals.SDMUtil.setAPP = SDMGlobals.SDMApp
35:         End If
36:    If SDMGlobals.SDMStatusBar Is Nothing Then Set SDMGlobals.SDMStatusBar = SDMGlobals.SDMApp.StatusBar
37:    If SDMGlobals.SDMHelp Is Nothing Then Set SDMGlobals.SDMHelp = New SDMUtilities.gSDI_Help
38:    If SDMGlobals.SDMdataDict Is Nothing Then Set SDMGlobals.SDMdataDict = New SDMUtilities.SDMDictionary
39:    If SDMGlobals.SDMWorkspace Is Nothing Then
40:        Set SDMGlobals.SDMWorkspace = SDMGlobals.SDMUtil.openShapeFileWorkspace(WOETableUtils.getProjectDir)
41:    End If

End Sub
