Attribute VB_Name = "UVSymbolizeRaster"
Option Explicit
' Variables used by the Error handler function - DO NOT REMOVE
Const c_sModuleFileName As String = "ChangeRenderToUVRenderer"

Function ChangeRendererToUVRenderer(ByRef pRasterLayer As IRasterLayer, fieldName As String) As IRasterUniqueValueRenderer
  On Error GoTo ErrorHandler
  ' Create a default Unique Value Renderer and set it to the layer
  Dim pUVRenderer As IRasterUniqueValueRenderer
  Dim pRasterRendereer As IRasterRenderer
  
11:   Set pUVRenderer = New RasterUniqueValueRenderer
12:   Set pRasterRendereer = pUVRenderer
13:   If pRasterRendereer.CanRender(pRasterLayer.Raster) Then
14:     Set pRasterRendereer.Raster = pRasterLayer.Raster
15:     pUVRenderer.Field = fieldName
16:     Set pRasterLayer.Renderer = pUVRenderer
17:     pRasterLayer.Renderer.Update
18:   End If
      
20:   Set ChangeRendererToUVRenderer = pUVRenderer
21:   Set pRasterRendereer = Nothing

  
  Exit Function
ErrorHandler:
  HandleError True, "ChangeRenderToUVRenderer " & c_sModuleFileName & vbCrLf & GetErrorLineNumberString(Erl), Err.Number, Err.Source, Err.Description, 4
End Function

