VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "ArcSDMExtension"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = True
'+++ This is the ArcSDM extension.

Option Explicit
Implements IExtension
Implements IExtensionConfig

Dim m_pApp As IApplication
Dim WithEvents m_pDoc As MxDocument
Attribute m_pDoc.VB_VarHelpID = -1

Private m_pExtState As esriExtensionState

Private Property Get IExtension_Name() As String
    IExtension_Name = "Spatial Data Modeller"
End Property

Private Sub IExtension_Shutdown()
     Set m_pApp = Nothing
     
End Sub

Private Sub IExtension_Startup(initializationData As Variant)
     Set m_pApp = initializationData
     'Start listening for the MxDocument events.
     Set m_pDoc = m_pApp.Document
End Sub

Private Property Get IExtensionConfig_Description() As String
     IExtensionConfig_Description = "Models spatial data with weights-of-evidence and logistic regression."
End Property

Private Property Get IExtensionConfig_ProductName() As String
     IExtensionConfig_ProductName = "Spatial Data Modeller"
End Property

Private Property Let IExtensionConfig_State(ByVal RHS As esriExtensionState)
    m_pExtState = RHS
End Property

Private Property Get IExtensionConfig_State() As esriExtensionState
  IExtensionConfig_State = m_pExtState
End Property

