VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "ArcSDMToolbar"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = True
Option Explicit

'+++ This code creates a toolbar that holds the Modelling commands dropdown
'+++ menu (CommandsMenu) and the Modelling tools

Implements IToolBarDef

Private m_pExtState As esriExtensionState

' Variables used by the Error handler function - DO NOT REMOVE
Const c_sModuleFileName As String = "C:\MyJava\ARC-SDM\SDMExtension\ArcSDMToolbar.cls"       ' Constant reflect file module name

Private Property Get ITool_Cursor() As esriSystem.OLE_HANDLE

End Property

Private Property Get IToolBarDef_Caption() As String
    IToolBarDef_Caption = "Spatial Data Modeller"
End Property

Private Sub IToolBarDef_GetItemInfo(ByVal pos As Long, ByVal itemDef As IItemDef)

    Select Case pos
    Case 0
      itemDef.Id = "SDMExtension.ArcSDMCommandsMenu"
      itemDef.Group = False
      itemDef.subType = 1
    Case 1
      itemDef.Id = "SDMExtension.ArcSDMHelpTool"
      itemDef.Group = True
      itemDef.subType = 1
    Case 2
      itemDef.Id = "SDMExtension.ArcSDMAboutTool"
      itemDef.Group = True
      itemDef.subType = 1
  End Select

End Sub

Private Property Get IToolBarDef_ItemCount() As Long
    IToolBarDef_ItemCount = 3
End Property

Private Property Get IToolBarDef_Name() As String
    IToolBarDef_Name = "ModellerToolbar"
End Property




