VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "SDMUtils"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = True
Option Explicit
Private dirpath As String
Const c_sModuleFileName As String = "SDMUtils.cls"
Public Property Set setAPP(ByRef app As IApplication)
5:     Set SDMGlobals.SDMApp = app
End Property
Public Property Get isAPP() As Boolean
8:     isAPP = Not (SDMGlobals.SDMApp Is Nothing)
End Property
Function FindLayerByName(sName As String) As ILayer
    On Error GoTo ErrorHandler
12:     If (sName = "") Then
13:         Set FindLayerByName = Nothing
        Exit Function
15:     Else
        
        If Not isAPP Then App_Init
        Dim pDoc As IMxDocument
        Dim pMap As IMap
19:         Set pDoc = SDMGlobals.SDMApp.Document
20:         Set pMap = pDoc.FocusMap
        Dim alayer As ILayer
        Dim layeridx As Integer
23:         For layeridx = 0 To pMap.LayerCount - 1
24:             Set alayer = pMap.Layer(layeridx)
25:             If alayer.Name = sName Then
26:                 Set FindLayerByName = alayer
                Exit Function
28:             End If
29:         Next
        'Need a null value here if not found
31:         'MsgBox "Layer " & sName & " not found!", vbCritical, "SDMUtil.findLayerByName"
32:         Set FindLayerByName = Nothing
33:     End If
    Exit Function
ErrorHandler:
36:     Set FindLayerByName = Nothing
End Function

Public Function getMap() As IMap
  On Error GoTo ErrorHandler

    Dim pApp As IApplication
43:     If Not isAPP Then App_Init
44:     Set pApp = SDMGlobals.SDMApp
    Dim pDoc As IMxDocument
46:     Set pDoc = pApp.Document
47:     Set getMap = pDoc.FocusMap


  Exit Function
ErrorHandler:
  HandleError True, "getMap " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), Err.Number, Err.Source, Err.Description, 4
End Function

Public Function FindStandAloneTableByName(tabName As String) As IStandaloneTable
    On Error GoTo ErrorHandler
57:     If (tabName = "") Then
58:         Set FindStandAloneTableByName = Nothing
        Exit Function
60:     Else
        Dim pApp As IApplication
        Dim pDoc As IMxDocument
        Dim pMap As IMap
64:         If Not isAPP Then App_Init
65:         Set pApp = SDMGlobals.SDMApp
66:         Set pDoc = pApp.Document
67:         Set pMap = Me.getMap
        Dim theMap As Map
69:         Set theMap = pMap
        Dim standAloneTables As IStandaloneTableCollection
71:         Set standAloneTables = theMap
        Dim saTableidx As Long
73:         For saTableidx = 0 To standAloneTables.StandaloneTableCount - 1
            Dim aTable As IStandaloneTable
75:             Set aTable = standAloneTables.StandaloneTable(saTableidx)
            Dim atableName As String
77:             atableName = aTable.Name
78:             If aTable.Name = tabName Then
79:                 Set FindStandAloneTableByName = aTable
                Exit Function
81:             End If
82:         Next
        'Need a null value here if not found
        'MsgBox "Table " & tabName & " not found!", vbCritical, "gParam.FindStandAloneTableByName"
85:         Set FindStandAloneTableByName = Nothing
86:     End If
    Exit Function
ErrorHandler:
89:     MsgBox "Error " & Err.Description & " in SDMUtilFrm.FindStandAloneTableByName", vbCritical, "gParam"
90:     Set FindStandAloneTableByName = Nothing
End Function

Public Function getDir(initDir As String, title As String) As String
94:     getDir = SDMUtilFrm.getDir(initDir, title)
    Exit Function
End Function
Public Function getFile(initDir As String, title As String) As String
98:     getFile = SDMUtilFrm.getFile(initDir, title)
    Exit Function
End Function

Public Function openShapeFileWorkspace(Location As String) As IWorkspace

On Error GoTo ErrorHandler

  Dim pWS As IWorkspace
  Dim pWorkspaceFactory As IWorkspaceFactory
  
109:   Set openShapeFileWorkspace = Nothing
  
111:   Set pWorkspaceFactory = New esriDataSourcesFile.ShapefileWorkspaceFactory
112:   Set pWS = pWorkspaceFactory.OpenFromFile(Location, 0)
113:   Set openShapeFileWorkspace = pWS
  
  Exit Function
ErrorHandler:
117:     MsgBox Err.Description, vbInformation, "openShapeFileWorkspace"
End Function

Public Function getMaskLayer(ByRef Mask As IGeoDataset) As ILayer
    Dim raslyr As IRasterLayer
122:     Set raslyr = New RasterLayer
123:     raslyr.CreateFromDataset Mask
124:     Set getMaskLayer = raslyr
End Function

Public Function getMaskname(ByRef Mask As IGeoDataset) As String
    Dim raslyr As IRasterLayer
129:     Set raslyr = New RasterLayer
130:     raslyr.CreateFromDataset Mask
131:     getMaskname = raslyr.Name
End Function

Public Function getActiveLayer() As ILayer
    Dim mxDoc As IMxDocument
136:     If Not isAPP Then App_Init
137:     Set mxDoc = SDMGlobals.SDMApp.Document
    Dim obj As IUnknown
139:     Set obj = mxDoc.SelectedItem
    Dim lyr As ILayer
    Dim aSet As ISet
142:     If (TypeOf obj Is ILayer) Then
143:         Set getActiveLayer = obj
144:     ElseIf (TypeOf obj Is ISet) Then
145:         Set aSet = obj
        Dim sObj As IUnknown
147:         Set sObj = aSet.Next
148:         While Not sObj Is Nothing
149:             If (TypeOf sObj Is ILayer) Then
150:                 Set getActiveLayer = sObj
                Exit Function
152:             End If
153:             Set sObj = aSet.Next
154:         Wend
155:         Set getActiveLayer = Nothing
156:     Else
157:         Set getActiveLayer = Nothing
158:     End If
End Function

Private Sub App_Init()
One:    On Error GoTo Three
163: Set SDMGlobals.SDMApp = New AppRef   'ArcMap App
Exit Sub
Two:    On Error GoTo errh
'''166: Set SDMGlobals.SDMApp = Application 'VBA App
'''Exit Sub
Three: On Error GoTo Two
169:    Set SDMGlobals.SDMApp = SDMGlobals.SDMDoc.Parent 'StandAlone App
Exit Sub
errh:
172:     MsgBox "SDMUtils can't Initialize Application", , "SDMUtils"
End Sub

