VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "gSDI_CalcWithUC"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = True
Option Explicit
Const c_sModuleFileName As String = "gSDI_CalcWithUC"
Const c_sDLLFileName As String = "CalculateResponse"       ' Constant reflect file module name

Function gSDI_CalcWithUC(ByRef Self As Variant) As SDMUtilities.SDMList
  On Error GoTo ErrorHandler
'MsgBox "entering " & c_sModuleFileName
'PUT THE IMPLEMENTATION HERE >>>>>>>>>>>>>
''gSDI.CalcWithUC
'' Topics:  Spatial Data Modeller
'' Description
'' Requires:
'' Self:
'' Returns:
''==============================================
'thmUC = Self.Get(0)
    Dim thmUC As IRasterLayer
18: Set thmUC = Self(0)
'lstMD = Self.Get(1)
    Dim lstMD As SDMUtilities.SDMList
21: Set lstMD = Self(1)
'lstFlds = Self.Get(2)
'MsgBox ListUtils.ListtoString(lstMD), , "lstMD"
    Dim lstFlds As SDMUtilities.SDMList
25: Set lstFlds = Self(2)
'MsgBox ListUtils.ListtoString(lstFlds), , "lstFlds"
'viewActive = Self.Get(3)
    Dim viewActive As IMap
29: Set viewActive = Self(3)
'tchFlag = Self.Get(4)
    Dim tchFlag As String
32: tchFlag = Self(4)
'expert = Self.Get(5)
    Dim expert As Boolean
35: expert = Self(5)
'''Joined table
    Dim joinTable As ITable
38: Set joinTable = Self(6)
    Dim tmpRastList As SDMList
40: Set tmpRastList = Self(7)
'MsgBox "tmpRastList" & vbCrLf & ListtoString(tmpRastList), , c_sModuleFileName
'Added parameters to permit successive NN calculations on same SDMUC
    Dim TPName As String
44: TPName = Self(8)
    Dim NDTPName As String
46: NDTPName = Self(9)
'' Read and verify analysis parameters
''-------------------------------------------------
'gParam = av.FindDialog("gParam")
    Dim anlParms As AnalysisParameters.AnlParams
51: Set anlParms = New AnalysisParameters.AnlParams
    Dim gParam As Form
53: Set gParam = anlParms.gParamfrm
'unitCell = gParam.findByName("txtUA").GetText
    Dim unitcell As Variant
56: unitcell = gParam.txtUA.Text
'If (unitCell.IsNumber) Then
58: If IsNumeric(unitcell) Then
'  unitCell = unitCell.AsNumber
60:     unitcell = CDbl(unitcell)
'Else
62: Else
'  MsgBox.Error("The unit area must be defined.  Please review analysis parameters.","Parameter Error")
64:     MsgBox "The unit area must be defined.  Please review analysis parameters.", vbCritical, "Parameter Error"
'  return Nil
66:     Set gSDI_CalcWithUC = Nothing
    Exit Function
'End
69: End If
'we = gParam.findByName("chkWofE").IsSelected
    Dim we As Boolean
72: we = gParam.chkwofe.Value = 1
'nnu = gParam.findByName("chkNNUns").IsSelected
    Dim nnu As Boolean
75: nnu = (gParam.chkNN = 1) And (gParam.chkNNUns.Value = 1)
'nns = gParam.findByName("chkNNSup").IsSelected
    Dim nns As Boolean
78: nns = (gParam.chkNN = 1) And (gParam.chkNNSup.Value = 1)
'lr = gParam.findByName("chkLR").IsSelected
    Dim lr As Boolean
81: lr = (gParam.chkLR.Value = 1)
''thmUC = av.getActiveDoc.GetActiveThemes.Get(0)   'self.Get(0)
'' Read the unique conditions table into a series of lists
''-------------------------------------------------
85: ProgressAnimation.Show "Reading UC table..."
'lstsUC = av.Run("gSDI.ReadUC",{thmUC})
    Dim gSDIReadUC As gSDI_ReadUC
88: Set gSDIReadUC = New gSDI_ReadUC
    Dim lstsUC As SDMUtilities.SDMList
90: Set lstsUC = gSDIReadUC.gSDI_ReadUC(Array(thmUC, joinTable))
'if (lstsUC.Is(String)) then
92: If lstsUC.IsEmpty Then
93:     MsgBox "Error in gSDI_ReadUC", vbCritical, c_sModuleFileName
94:     Set gSDI_CalcWithUC = Nothing
        Exit Function
96: ElseIf lstsUC.Count = 1 Then
''  MsgBox.Info(lstsUC,"testing - message returned form gSDI.ReadUC")
98:     MsgBox lstsUC.asString, vbCritical, c_sModuleFileName
99:     Set gSDI_CalcWithUC = Nothing
        Exit Function
'End
102: End If
'lstsVals = lstsUC.Get(0)
    Dim lstsvals As SDMUtilities.SDMList
105: Set lstsvals = lstsUC.getObj(0)
'lstTNames = lstsUC.Get(1)
     Dim lstTNames As SDMUtilities.SDMList
108: Set lstTNames = lstsUC.getObj(1)
'lstAreas = lstsUC.Get(2)
     Dim lstAreas As SDMUtilities.SDMList
111: Set lstAreas = lstsUC.getObj(2)
'lstPnts = lstsUC.Get(3)
     Dim lstPnts As SDMUtilities.SDMList
114: Set lstPnts = lstsUC.getObj(3)
'''MsgBox "lstsUC=" & lstsUC.Count & vbCrLf & _
'''        "lstsvals=" & lstsvals.Count & vbCrLf & _
'''        "lstTNames=" & lstTNames.Count & vbCrLf & _
'''        "lstAreas=" & lstAreas.Count & vbCrLf & _
'''        "lstPnts=" & lstPnts.Count, , c_sModuleFileName

'' Determine which themes have multi-class free data
''-------------------------------------------------
'lstsFreeMC = av.Run("gSDI.GetFreeMCThemes",{lstsUC,lstMD})
124: ProgressAnimation.Show "Finding multi-class themes..."
     Dim gSDIGetFreeMCThemes As gSDI_GetFreeMCThemes
126: Set gSDIGetFreeMCThemes = New gSDI_GetFreeMCThemes
     Dim lstsFreeMC As SDMUtilities.SDMList
128: Set lstsFreeMC = gSDIGetFreeMCThemes.gSDI_GetFreeMCThemes(Array(lstsUC, lstMD))
'If (lstsFreeMC = Nil) Then
130: If lstsFreeMC.IsEmpty Then
'  return Nil   ' error reported in another script
132:     MsgBox "Nothing returned by gSDI_GetFreeMCThemes", vbCritical, c_sModuleFileName
133:     Set gSDI_CalcWithUC = Nothing
         Exit Function
'elseif (lstsFreeMC.Is(String)) then
'End
137: End If
'MsgBox ListUtils.ListtoString(lstsFreeMC), , "lstsFreeMC"


'' Calculate a list of weighted averages to fill areas
'' of missing data
''-------------------------------------------------
144: ProgressAnimation.Show "Fill areas of missing data..."
''listWeightedAvgs = av.Run("gSDI.CalcVals4Msng",{lstsVals,lstAreas,lstMD})
'listWeightedAvgs = av.Run("gSDI.CalcVals4Msng",{lstsVals,lstAreas,lstMD,lstsFreeMC})
Dim gSDICalcVals4Msng As gSDI_CalcVals4Msng
148: Set gSDICalcVals4Msng = New gSDI_CalcVals4Msng
Dim listWeightedAvgs As SDMUtilities.SDMList
150: Set listWeightedAvgs = gSDICalcVals4Msng.gSDI_CalcVals4Msng(Array(lstsvals, lstAreas, lstMD, lstsFreeMC))
'If (listWeightedAvgs = Nil) Then
152: If listWeightedAvgs Is Nothing Then
'  return Nil   ' error reported from another script
154:     Set gSDI_CalcWithUC = Nothing
         Exit Function
'elseif (listWeightedAvgs.Is(String)) then
'  MsgBox.Error(listWeightedAvgs,"Missing Data Error")
'
'End
160: End If
'MsgBox ListUtils.ListtoString(listWeightedAvgs), , "listWeightedAvgs"
'genNTP = ""
     Dim genNTP As String
164: genNTP = ""
''if (tchFlag = "NN") then
''  optNDTP = gParam.FindByName("cbxNTP").GetCurrentValue
''  if (optNDTP <> "Point Theme") then
'''    genNTP = True
''    optSrc = av.FindDialog("gLwPrb").GetControlPanel.GetSelected
''    if (optSrc.GetName = "radW") then
''      we = True
''      genNTP = "we"
''    elseif (optSrc.GetName = "radLR") then
''      lr = True
''      genNTP = "lr"
''    end
''  end
''end
'If ((tchFlag <> "NN") Or ((tchFlag = "NN") And (genNTP <> ""))) Then
180: If (tchFlag <> "NN") Or ((tchFlag = "NN") And (genNTP <> "")) Then
'  If ((we) And (genNTP <> "lr")) Then
182:     If we And (genNTP <> "lr") Then
'    If (genNTP = "we") Then
184:         If genNTP = "we" Then
'      if (MsgBox.YesNo("You have elected to randomly generate non-deposit training" + NL +
'                       "points in areas of low probability as estimated using weights" + NL +
'                       "of evidence. Continue with calculation of weights of evidence?",
'                       "Non-deposit Training Points",True).Not) then
189:                 If MsgBox("You have elected to randomly generate non-deposit training" & vbCrLf & _
                       "points in areas of low probability as estimated using weights" & vbCrLf & _
                       "of evidence. Continue with calculation of weights of evidence?", vbYesNo, _
                       "Non-deposit Training Points", True) = vbNo Then
'        return Nil
194:                     Set gSDI_CalcWithUC = Nothing
                         Exit Function
'      End
197:                 End If
'    End
199:         End If
'    resWofE = av.Run("gSDI.CalcWofEResp",{lstsUC,lstFlds,lstMD,gParam,thmUC,expert})
201:        lstsUC.Add tmpRastList
'MsgBox "lstsUC" & vbCrLf & ListtoString(lstsUC), , c_sModuleFileName
            Dim gSDICalcWofEResp As gSDI_CalcWofEResp
204:        Set gSDICalcWofEResp = New gSDI_CalcWofEResp
            Dim resWofE As Boolean
206:        resWofE = gSDICalcWofEResp.gSDI_CalcWofEResp(Array(lstsUC, lstFlds, lstMD, gParam, thmUC, joinTable, expert))
'    If (resWofE = Nil) Then
208:         If Not resWofE Then
'      MsgBox.Error("An error occurred while calculating weights of evidence.","Weights of Evidence")
210:             MsgBox "An error occurred while calculating weights of evidence.", vbCritical, c_sModuleFileName
'      return Nil
212:             Set gSDI_CalcWithUC = Nothing
                Exit Function
'    End
215:         End If
'  End
217:     End If
'  If ((lr) And (genNTP <> "we")) Then
219:     If lr And (genNTP <> "we") Then
'    If (genNTP = "lr") Then
221:         If genNTP = "lr" Then
'      if (MsgBox.YesNo("You have elected to randomly generate non-deposit training" + NL +
'                       "points in areas of low probability as estimated using logistic" + NL +
'                       "regression. Continue with calculation of logistic regression?",
'                       "Non-deposit Training Points",True).Not) then
226:            If MsgBox("You have elected to randomly generate non-deposit training" & vbCrLf & _
                       "points in areas of low probability as estimated using logistic" & vbCrLf & _
                       "regression. Continue with calculation of logistic regression?", vbYesNo, _
                       "Non-deposit Training Points") = vbNo Then
'        return Nil
231:                Set gSDI_CalcWithUC = Nothing
                    Exit Function
'      End
234:            End If
'    End
236:         End If
'    rspLR = av.Run("gSDI.CalcLR",{lstsUC,lstsFreeMC,lstMD,listWeightedAvgs,unitCell,thmUC})
             Dim gSDICalcLR As gSDI_CalcLR
239:         Set gSDICalcLR = New gSDI_CalcLR
             Dim rspLR As Boolean
241:         rspLR = gSDICalcLR.gSDI_CalcLR(Array(lstsUC, lstsFreeMC, lstMD, listWeightedAvgs, unitcell, thmUC, gL))
'    If (rspLR = Nil) Then
243:         If Not rspLR Then
'      MsgBox.Error("An error occurred while calculating logistic regression.","Logistic Regression")
245:             MsgBox "An error occurred while calculating logistic regression.", vbCritical, "Logistic Regression"
'      return Nil
247:             Set gSDI_CalcWithUC = Nothing
                 Exit Function
'    End
250:         End If
            'MsgBox thmUC.Name & " has joins: " & WOETableUtils.hasJoins(thmUC), , c_sModuleFileName
'  End
'>>>>> remove intermediate raster files
254:        Me.RemoveInterMedRasters thmUC
255:        MsgBox "Logistic Regression complete.", , "Calculate Response"
256:     End If
'End
258: End If
'If (tchFlag = "NN") Then
260: If tchFlag = "NN" Then
'  resNN = av.Run("gSDI.CalcNN",{nnu,nns,thmUC,lstPnts,lstAreas,lstsVals,lstsUC,lstsFreeMC,gParam,lstMD,listWeightedAvgs,unitCell})
         Dim gSDICalcNN As New gSDI_CalcNN
263:     Set gSDICalcNN = New gSDI_CalcNN
         Dim resNN As Boolean
         'Requires list of temp raster names in lstsUC
266:     resNN = gSDICalcNN.gSDI_CalcNN(Array(nnu, nns, thmUC, lstPnts, lstAreas, lstsvals, lstsUC, lstsFreeMC, gParam, lstMD, listWeightedAvgs, unitcell, gL.FMTPfield, gL.FMNTPfield, TPName, NDTPName))
'  If (resNN = Nil) Then
268:     If Not resNN Then
'    MsgBox.Error("An error occurred while calculating a neural network.","Neural Network")
270:         MsgBox "An error occurred while calculating a neural network.", vbCritical, "Neural Network"
'    return Nil
272:         Set gSDI_CalcWithUC = Nothing
             Exit Function
'  End
275:     End If
'
'  viewActive.AddTheme (thmUC)
'255:     viewActive.AddLayer thmUC
'  strThm = av.Run("gSDI.GetNewThemeName",{"Neural Network",viewActive})
'         Dim gSDI_GetNewThemeName As New gSDI_GetNewThemeName
'258:     Set gSDI_GetNewThemeName = New gSDI_GetNewThemeName
'         Dim strThm As String
'260:     strThm = gSDI_GetNewThemeName.gSDI_GetNewThemeName(Array("Neural Network", viewActive))
'  thmUC.SetName (strThm)
'262:     thmUC.Name = strThm
'>>>> cannot symbolize programmatically
'  thmUC = av.Run("gSDI.Symbolize",{viewActive,thmUC})
'>>>>
'>>>>> remove intermediate raster files
290:    Me.RemoveInterMedRasters thmUC
'  viewActive.InvalidateTOC (Nil)
'  MsgBox.Info("Writing neural network input files is complete.","Neural Network")
'  If (thmUC.Is(GTheme)) Then
'    thmUC.setObjectTag (Nil)
295:     Set gL.thmUC_setObjectTag = Nothing
'  End
'  return Nil
298:     Set gSDI_CalcWithUC = Nothing
         Exit Function
'Else
301: Else ' Not tchFlag="NN" WOFE Response theme
'  If (viewActive.FindTheme(thmUC.GetName) = Nil) Then
'280:     If SDMGlobals.SDMUtil.FindLayerByName(thmUC.Name) Is Nothing Then
''    viewActive.AddTheme (thmUC)
'282:         viewActive.AddLayer thmUC
''  End
'284:     End If
'  ' Classify and symbolize the unique conditions theme
'  '-----------------------------------------
'>>>> cannot do programmatically
'  thmUC = av.Run("gSDI.SR1",{thmUC})
'  If (thmUC = Nil) Then
'    return Nil
'  End
'>>>>> Can't modify this list in ArcView 3
'  indx = 0
'  theThemes = viewActive.GetThemes
'  For Each t In theThemes
'    If (t.Is(FTheme)) Then
'      ShapeType = t.GetFTab.FindField("Shape").GetType
'      if (shapetype = #FIELD_SHAPEPOINT) then
'        indx = theThemes.Find(t)
'      End
'    End
'  End
'  theThemes.Shuffle(thmUC,(indx + 1))
'>>>>> Can't modify above list in ArcView 3
'  viewActive.InvalidateTOC (Nil)
'  thmUC.setObjectTag (Nil)
330:     Set gL.thmUC_setObjectTag = Nothing
331:     SDMGlobals.SDMApp.StatusBar.Message(0) = "Calculation of response theme, " & thmUC.Name & " is complete."
'End
333: End If
'MsgBox "Exiting " & c_sModuleFileName
'<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
Exit Function
ErrorHandler:
  HandleError True, c_sModuleFileName & " " & GetErrorLineNumberString(Erl), Err.Number, Err.Source, Err.Description, 4
End Function

Sub RemoveInterMedRasters(thmUC As IRasterLayer)
'>>>>> remove intermediate raster files
    Dim thmUCTbl As ITable
344:     Set thmUCTbl = thmUC
    Dim thmUCtblFldList As SDMUtilities.SDMList
346:     Set thmUCtblFldList = WOETableUtils.getFieldsNames(thmUCTbl)
    Dim fldName As Variant
348:     For Each fldName In thmUCtblFldList.list
349:         If UCase(fldName) Like "SDMTEMP*" Then
                 Dim pLayer As ILayer
351:             Set pLayer = WOETableUtils.FindLayerByName(CStr(fldName))
352:             If Not pLayer Is Nothing Then _
                    SDMGlobals.SDMMap.DeleteLayer pLayer
354:         End If
355:     Next fldName
'>>>>>

End Sub

