VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "gSDI_ChtMenu_Update"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = True
Option Explicit

Private theMap As IMap
Private theTables As IStandaloneTableCollection

Public Property Set setMap(ByRef aMap As IMap)
7:     Set theMap = aMap
8:     Set theTables = aMap
End Property

Function gSDI_ChtMenu_Update() As SDMList

13: Const c_sModuleFileName As String = "gSDI_ChtMenu_Update" ' Constant reflect file module name

On Error GoTo ErrorHandler
    
Dim f As esrigeodatabase.IField
Dim flds As Collection
Dim numFld As Boolean
Dim numTabs As SDMList
Dim t As IStandaloneTable
Dim theVtab As ITable

' Name:  gSDI.ChtMenu.Update
'
'Topics:  Charts; Tables; Spatial Data Modeller
'
'Description:  Updates the Create Charts... menu item
'  Enables the item if there is at least one table with
' at least one numeric field in the current project.
'Requires:
'
' Self:  Create Charts.. menu item
'
'Returns:
'==============================================

38: Set numTabs = New SDMList
'Temporary Return
40: GoTo next1
'theTables = av.GetProject.GetDocsWithGroupGUI(av.FindGUI("Table"))
'If (theTables.Count > 0) Then
43: If (theTables.StandaloneTableCount > 0) Then
44:     Err.Raise vbObjectError, , "StandaloneTables checking not implemented"
'For Each t In theTables
    Dim tidx As Integer
47:     For tidx = 0 To theTables.StandaloneTableCount - 1
'numFld = False
49:         numFld = False
'theVTab = t.GetVTab
51:         Set theVtab = theTables.StandaloneTable(tidx).Table
'If (theVTab = Null) Then
53:         If (theVtab Is Nothing) Then
54:             GoTo next1
55:         End If
' GoTo Next1
'End If
'flds = theVTab.GetFields
59:         Set flds = theVtab.Fields
'For Each f In flds
61:         For Each f In flds
'If (f.IsTypeNumber) Then
63:             If ((f.Type = esriFieldTypeDouble) Or _
                (f.Type = esriFieldTypeInteger) Or _
                (f.Type = esriFieldTypeSmallInteger) Or _
                (f.Type = esriFieldTypeSingle)) Then
'numFld = True
68:                 numFld = True
'Exit For
70:                 Exit For
'End If
72:             End If
'Next
74:         Next
'If (numFld) Then
76:         If (numFld) Then
'numTabs.Add (t)
78:             numTabs.Add t.Table
'Exit For
80:             Exit For
'End If
82:         End If
83: Next

85: End If

next1:
88: Set gSDI_ChtMenu_Update = numTabs
Exit Function

ErrorHandler:
  HandleError True, "gSDI_ChtMenu_Update " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), Err.Number, Err.Source, Err.Description, 4
End Function
