VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "gSDI_FP2Int"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = True
Option Explicit
Const c_sModuleFileName As String = "gSDI_FP2Int"
Const c_sDLLFileName As String = "SDMAccessories"       ' Constant reflect file module name
'Private ObjectTag As Object
'Property Set setObjectTag(anObject As Object)
'    Set ObjectTag = anObject
'End Property
'Property Get getObjectTag() As Object
'    Set getObjectTag = ObjectTag
'End Property

Function gSDI_FP2Int(Self As Variant) As Variant
  On Error GoTo ErrorHandler
'14:     MsgBox "Entering...", , c_sModuleFileName
'PUT THE IMPLEMENTATION HERE >>>>>>>>>>>>>
'' gSDI.FP2Int
'' Topics:  Spatial Data Modeller
''
'' Description:  Convert floating point grid
''          to an integer grid, rounding
''          floating point values to the nearest
''          hundredth.
''
'' Requires:
''
'' Self:    0 -- gThmFP -- the floating point grid theme to proces
''
'' Returns: list: gThmInt -- the integer grid theme
''                fldVal -- the field to which the original floating
''                          values were written
''==============================================
'
Dim gThmFP As IRasterLayer
34: Set gThmFP = Self(0)

    Dim gThmInt As IRasterLayer
37: Set gThmInt = gThmFP
    Dim gSDIGetVTab As AnalysisParameters.gSDI_GetVTab
39: Set gSDIGetVTab = New AnalysisParameters.gSDI_GetVTab
    Dim rTab As ITable
41: Set rTab = gSDIGetVTab.gSDI_GetVTab(gThmFP)
42:     If rTab Is Nothing Then
43:         MsgBox "Rasterlayer does not have a VAT: " & gThmFP.Name, c_sModuleFileName
44:         gSDI_FP2Int = Null
45:     End If
    Dim valIdx As Long
47: valIdx = rTab.FindField("Value")
48: If valIdx = -1 Then
49:     gSDI_FP2Int = Null
50: Else
        Dim tagList As SDMUtilities.SDMList
52:         Set tagList = New SDMUtilities.SDMList
53:     tagList.AddArray Array("fp", gThmFP.Name)
54:     gC.ObjectTag(gThmInt.Name) = tagList
        Dim fldVal As esrigeodatabase.IField
56:     Set fldVal = rTab.Fields.Field(valIdx)
57:     gSDI_FP2Int = Array(gThmInt, fldVal)
58: End If
'>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>
''
'
'gThmFP = Self.Get(0)
'
'grdFP = gThmFP.GetGrid
'
'grdInt = ((grdFP * 100.AsGrid) + 0.5.AsGrid).Int
'
'gThmInt = GTheme.Make(grdInt)
'
'vTb = av.Run("gSDI.GetVTab",{gThmInt})
'
'If (vtb = Nil) Then
'
'  MsgBox.Error("Unable to process grid theme '" + gThmFP.GetName + "'.","Results Comparison")
'
'  return Nil
'
'End
'
'fldSrc = vtb.FindField("Value")
'
'If (fldSrc = Nil) Then
'
'  MsgBox.Error("Unable to process grid theme '" + gThmFP.GetName + "'.","Results Comparison")
'
'  return Nil
'
'End
'
'
'
'fldVal = Field.Make("SourceVal",#FIELD_DOUBLE,6,2)
'
'vtb.SetEditable (True)
'
'If (vtb.IsEditable) Then
'
'  vTb.AddFields({fldVal})
'
'
'
'  For Each r In vtb
'
'    vTb.SetValue(fldVal,r,(vTb.ReturnValue(fldSrc,r) / 100))
'
'  End
'
'Else
'
'  MsgBox.Error("Unable to process grid theme '" + gThmFP.GetName + "'.","Results Comparison")
'
'  return Nil
'
'End
'
'vtb.SetEditable (False)
'
'gThmInt.SetObjectTag({"fp",gThmFP.GetName})
'return {gThmInt,fldVal}
'<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
Exit Function
ErrorHandler:
  HandleError True, c_sModuleFileName & " " & GetErrorLineNumberString(Erl), Err.Number, Err.Source, Err.Description, 4
124:   gSDI_FP2Int = Null
End Function
