VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "gSDI_GenClasses"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = True
Option Explicit
Const c_sModuleFileName As String = "gSDI_GenClasses"
Const c_sDLLFileName As String = "CalculateResponse"       ' Constant reflect file module name
'Private ObjectTag As Object
'Property Set setObjectTag(anObject As Object)
'    Set ObjectTag = anObject
'End Property
'Property Get getObjectTag() As Object
'    Set getObjectTag = ObjectTag
'End Property

Function gSDI_GenClasses() As Boolean
  On Error GoTo ErrorHandler
'PUT THE IMPLEMENTATION HERE >>>>>>>>>>>>>
'' Name:  gSDI.GenClasses
''
''Topics:  Spatial Data Modeller
'
''Description:  Applies the specified generalization
''  from the class to class mapping tool.
''  Adds a new class field, and descriptor field if
''  specified.  Writes new class values in the
''  in the records containing the current class values.
''
''Requires:
''
'' Self:  The Generalize button on the class to class mapping
''   dialog.
''
''Returns:
''==============================================
'grcDiag = Self.GetDialog
'theView = grcDiag.GetActiveDoc
    Dim theView As IMap
35: Set theView = SDMGlobals.SDMMap
'If (theView.Is(View).Not) Then
'  MsgBox.Error("The active document must be a view.","Generalizing Evidential Theme")
'  return Nil
'End
'curListBox = grcDiag.findByName("lbx_Cur")
'oldNewVals = curListBox.getList
'valList = curListBox.getObjectTag
    Dim ValList As SDMUtilities.SDMList
44: Set ValList = gGrc.getObjectTag
'oldVals = List.Make
    Dim oldVals As New SDMUtilities.SDMList
'newVals = List.Make
    Dim newVals As New SDMUtilities.SDMList
'newLabels = List.Make
    Dim newLabels As New SDMUtilities.SDMList
'For Each Reclass In oldNewVals
    Dim Reclass As Long
53: For Reclass = 0 To gGrc.lbx_Cur.Rows - 1
'  oldVals.Add (Reclass.Get(0))
55:     oldVals.Add gGrc.lbx_Cur.TextMatrix(Reclass, 0)
'  newVals.Add (Reclass.Get(2))
57:     newVals.Add gGrc.lbx_Cur.TextMatrix(Reclass, 2)
'  newLabels.Add (Reclass.Get(3))
59:     newLabels.Add gGrc.lbx_Cur.TextMatrix(Reclass, 3)
'End
61: Next Reclass
'newValFld = grcDiag.findByName("txl_Ncfd").GetText
    Dim newValFld As String
64: newValFld = gGrc.txl_Ncfd.Text
'newLblFld = grcDiag.findByName("txl_Nlfd").GetText
    Dim newLblFld As String
67: newLblFld = gGrc.txl_Nlfd.Text
'genDiag = av.FindDialog("gGen")
'eMapName = genDiag.findByName("cbx_Gth").GetCurrentValue
    Dim eMapName As String
71: eMapName = gGen.cbx_Gth.Text
'eMap = theView.FindTheme(eMapName)
    Dim eMap As IRasterLayer
74: Set eMap = SDMGlobals.SDMUtil.FindLayerByName(eMapName)
'If (eMap.Is(GTheme)) Then
'  If (eMap.GetGrid.IsInteger.Not) Then
'    MsgBox.Error("Each evidential theme should have a unique name.",
'    "Generalizing Evidential Theme")
'    return Nil
'  Else
'    emVTab = eMap.GetVTab
    Dim emVTab As ITable
83:     Set emVTab = eMap
'  End
'ElseIf (eMap.Is(ftheme)) Then
'  emVTab = eMap.GetFTab
'  ShapeType = emVTab.FindField("Shape").GetType
'  if ((shapetype = #FIELD_SHAPEPOLY).Not) then
'    MsgBox.Error("Each evidential theme should have a unique name.",
'    "Generalizing Evidential Theme")
'    return Nil
'  End
'Else
'  MsgBox.Error("Each evidential theme should have a unique name.",
'  "Generalizing Evidential Theme")
'  return Nil
'End

'Test for fatal join
276: If WOETableUtils.hasJoins(eMap) Then WOETableUtils.UnJoinAll eMap

'newLabelField = False
     Dim newLabelField As Boolean
105: newLabelField = gGrc.txl_Nlfd <> "<None>"
     Dim strng As Variant
'For Each strng In newLabels
'  If (strng.Trim <> "") Then
'    newLabelField = True
'    Break
'  End
'End
''if (newLblFld.Left(4) = "None") then
''  newLabelField = False
''end
'fieldList = List.Make
     Dim fieldList As New Collection
'''''>>>>>> Must add Value field
     Dim oldValField As Variant
120: oldValField = Array("Value", esriFieldTypeInteger, 10, 0, "", False)
121: fieldList.Add oldValField
'newValField = Field.Make(newValFld,#FIELD_LONG,10,0)
     Dim newValField As Variant
124: newValField = Array(newValFld, esriFieldTypeInteger, 10, 0, "", False)
'fieldList.Add (newValField)
126: fieldList.Add newValField
'If (newLabelField) Then
128: If newLabelField Then
'  newLblField = Field.Make(newLblFld,#FIELD_CHAR,20,0)
         Dim newLblField As Variant
131:     newLblField = Array(newLblFld, esriFieldTypeString, 20, 0, "", False)
'  fieldList.Add (newLblField)
133:     fieldList.Add newLblField
'End
135: End If
'If (emVTab.CanEdit) Then
'   If (emVTab.StartEditingWithRecovery) Then
'    If (emVTab.CanAddFields) Then
'      emVTab.BeginTransaction
'      emVTab.AddFields (fieldList)
     Dim tablename As String
142: tablename = gGen.cbx_Tab2.Text
143: If tablename = "<None>" Or gGen.rad_Uniq Then tablename = eMapName & "_Unique"
     Dim newSATable As IStandaloneTable
     Dim newTbl As ITable
     Dim newName As String
147: newName = "Gen_" & tablename & ".dbf"
     Dim getPrjDir As gSDI_getProjectDir
149: Set getPrjDir = New gSDI_getProjectDir
     Dim prjDir As String
151: prjDir = getPrjDir.gSDI_getProjectDir
     Dim saveFileStuff As Variant
153: saveFileStuff = FileDialog.GetSaveFileName("Select filename for Generalized Table", prjDir, newName)
154: If IsEmpty(saveFileStuff) Then
155:     gSDI_GenClasses = False
         Exit Function
157: End If

159: newName = saveFileStuff(0)
     Dim outWrkSpc As String
161: outWrkSpc = saveFileStuff(1)

163: Set newTbl = WOETableUtils.CreateTable(newName, outWrkSpc, fieldList, CBool(saveFileStuff(2)))
164: If newTbl Is Nothing Then
165:     gSDI_GenClasses = False
         Exit Function
167: End If
168: Set newSATable = New StandaloneTable
169: Set newSATable.Table = newTbl
     Dim saColl As IStandaloneTableCollection
171: Set saColl = theView
172: saColl.AddStandaloneTable newSATable
'      emVTab.EndTransaction
'    Else
'      return "Nofields"
'    End
'    saveEdits = True
'    emVTab.StopEditingWithRecovery (saveEdits)
'  Els
'    MsgBox.Error("Unable to edit attribute table of "+eMapName+"."+NL+
'               "Please check file permissions.","Generalizing Evidence Themes")
'    return Nil
'  End
'Else
'  MsgBox.Error("Unable to edit attribute table of "+eMapName+"."+NL+
'               "Please check file permissions.","Generalizing Evidence Themes")
'  return Nil
'End

'If (valList.Count <> emVTab.GetNumRecords) Then
191: If (Not gGen.rad_Uniq) And (gGrc.lbx_Cur.Rows <> emVTab.RowCount(Nothing)) Then
'  MsgBox.Error("The number of records for reclassification does not"++NL+
'               "match the number of the records in the Evidential Theme's"+NL+
'               "attribute table.  Returning...","Generalizing Evidential Theme")
195:     MsgBox "The number of records for reclassification does not " & vbCrLf & _
               "match the number of the records in the Evidential Theme's" & vbCrLf & _
               "attribute table.  Returning...", vbCritical, c_sModuleFileName
'  return nil
199:     gSDI_GenClasses = False
         Exit Function
'End
202: End If
''n = emVTab.GetNumRecords - 1
Dim i As Long
205: i = 0

'If (emVTab.CanEdit) Then
'  If (emVTab.StartEditingWithRecovery) Then
'    emVTab.BeginTransaction
'    For Each record In emVTab
211:     For i = 0 To ValList.Count - 1
             Dim rw As IRow
213:         Set rw = newTbl.CreateRow
'      oldVal = valList.Get(i)
             Dim oldVal As Long
216:         oldVal = ValList.GetVal(i)
217:         rw.Value(1) = oldVal
'      indx = oldVals.FindByValue(oldVal)
'      If (indx = -1) Then
'        MsgBox.Error("Error reading current class values from dialog.",
'                     "Generalizing Evidential Theme")
'        return Nil
'      End
'      If (indx > (newVals.Count - 1)) Then
'        Continue
'      Else
'        newval = newVals.Get(indx)
             Dim newval As Long
229:         newval = newVals.GetVal(i)
'      End
'      If (indx > (newVals.Count - 1)) Then
'        Continue
'      Else
'        newLabel = newLabels.Get(indx)
'      End
'      emVTab.SetValue(newValField,record,newVal)
237:         rw.Value(2) = newval
'      If (newLabelField) Then
239:         If newLabelField Then
                Dim newLabel As String
241:            newLabel = newLabels.GetVal(i)
'        emVTab.SetValue(newLblField,record,newLabel)
243:            rw.Value(3) = newLabel
'      End
245:         End If
'      i = i + 1
'    End
248:         rw.Store
249: Next i
'    emVTab.EndTransaction
'    saveEdits = True
'    emVTab.StopEditingWithRecovery (saveEdits)
'  Else
'    MsgBox.Error("Unable to edit attribute table of "+eMapName+"."+NL+
'                 "Please check file permissions.","Generalizing Evidential Themes")
'    return nil
'  End
'Else
'  MsgBox.Error("Unable to edit attribute table of "+eMapName+"."+NL+
'               "Please check file permissions.","Generalizing Evidential Themes")
'  return nil
'End

'If (grcDiag.IsOpen) Then
'  grcDiag.Close
265: gGrc.lbx_Cur.Rows = 0
266: 'If gGrc.Visible Then
267:     Unload gGrc
268: '    If Not gGen.tableWin Is Nothing Then gGen.tableWin.Show False
269: 'End If
270: gGen.Visible = True
'End
'MsgBox.Info("Generalization of "+eMap.AsString+" is complete.",
'"Evidential Theme Generalization")
274: MsgBox "Generalization of " & eMap.Name & " is complete.", vbInformation, c_sModuleFileName
'return nil
277: LayerToTableJoin.joinTableToLayer eMap, "Value", newSATable, "Value"
278: gSDI_GenClasses = True

'Refresh Table of Contents
Dim pMxDoc As IMxDocument
282: Set pMxDoc = SDMGlobals.SDMDoc
Dim pContView As IContentsView
284: Set pContView = pMxDoc.CurrentContentsView
285: pContView.Refresh Null

'<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
Exit Function
ErrorHandler:
  HandleError True, c_sModuleFileName & " " & GetErrorLineNumberString(Erl), Err.Number, Err.Source, Err.Description, 4
End Function

