VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "gSDI_GetNewThemeName"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = True
Option Explicit
Const c_sModuleFileName As String = "gSDI_GetNewThemeName"
Const c_sDLLFileName As String = "CalculateResponse"       ' Constant reflect file module name
'Private ObjectTag As Object
'Property Set setObjectTag(anObject As Object)
'    Set ObjectTag = anObject
'End Property
'Property Get getObjectTag() As Object
'    Set getObjectTag = ObjectTag
'End Property

Function gSDI_GetNewThemeName(Self As Variant) As String
  On Error GoTo ErrorHandler
'PUT THE IMPLEMENTATION HERE >>>>>>>>>>>>>
'' Name: gSDI.GetNewThemeName
''
'' Topics:  Spatial Data Modeller
''
'' Description:  Checks theme names in active View
''               for name with same prefix as passed string,
''               plus appended integer.  Determines the
''               lowest available integer, and returns
''               new theme name
'' Requires:
''
'' Self:         0 - Prefix
''               1 - active view
''
'' Returns:      New theme name
''==============================================
'' Evaluate arguments
''----------------------------------------------
'viewActive = Self.Get(1)
Dim viewActive As IMap
35: Set viewActive = Self(1)
'If (viewActive.Is(View).Not) Then
'  MsgBox.Error("The active document must be a View.","Document Error")
'  return Nil
'End
'strPrefix = Self.Get(0)
Dim strPrefix As String
42: strPrefix = Self(0)
'' Get lentgh of name prefix
''----------------------------------------------
'cntP = strPrefix.Count
Dim cntP As Long
47: cntP = Len(strPrefix)
'' Check each theme name to see if it starts
'' with prefix; if it does, check remainder of
'' name and store if numeric
''----------------------------------------------
'lstThms = viewActive.GetThemes
Dim lstThms As IEnumLayer
54: Set lstThms = viewActive.layers
'lstNmbs = List.Make
Dim lstNmbs As New SDMUtilities.SDMList
'For Each t In lstThms
58: lstThms.Reset
Dim t As ILayer
60: Set t = lstThms.Next
61: While (Not t Is Nothing)
62:       If t.Valid Then
'  strT = t.GetName
        Dim strT As String
65:     strT = t.Name
'  If (strT.Left(cntP) = strPrefix) Then
67:     If Left(strT, cntP) = strPrefix Then
'    nmbSuffix = strT.Right(strT.Count - cntP)
        Dim nmbSuffix As String
70:         nmbSuffix = Right(strT, Len(strT) - cntP)
'    If (nmbSuffix.IsNumber) Then
72:         If IsNumeric(nmbSuffix) Then
'      lstNmbs.Add (nmbSuffix.AsNumber)
74:             lstNmbs.Add CLng(nmbSuffix)
'    End
76:         End If
'  End
78:      End If
'End
80:       End If
81:   Set t = lstThms.Next
82: Wend

'' Make new string name by appending
'' the first available integer to the prefix
'''----------------------------------------------
'i = 1
Dim i As Long
89: i = 1
'strName = ""
Dim strName As String
92: strName = ""
'If (strPrefix.Contains(" ")) Then
94: If InStr(strPrefix, " ") > 0 Then
'  strPrefix = strPrefix + " "
96:     strPrefix = strPrefix & " "
'End
98: End If
'If (lstNmbs.IsEmpty.Not) Then
100: If Not lstNmbs.IsEmpty Then
'  lstNmbs.RemoveDuplicates
102:     Set lstNmbs = lstNmbs.RemoveDuplicates
'  lstNmbs.Sort (True)
104:     Set lstNmbs = lstNmbs.Sort(True)
'  For Each n In lstNmbs
    Dim n As Variant
107:     For Each n In lstNmbs.list
'    If (n = i) Then
109:         If n = i Then
'      i = i + 1
111:             i = i + 1
'    Else
113:         Else
'      Break
115:             Exit For
'    End
117:         End If
'  End
119:     Next n
'  If (strName = "") Then
121:     If strName = "" Then
'    strName = strPrefix + i.AsString
123:         strName = strPrefix & i
'  End
125:     End If
'Else
127: Else
'  strName = strPrefix + "1"
129:     strName = strPrefix & "1"
'End
131: End If
'return strName
133: gSDI_GetNewThemeName = strName
'<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
Exit Function
ErrorHandler:
  HandleError True, c_sModuleFileName & " " & GetErrorLineNumberString(Erl), Err.Number, Err.Source, Err.Description, 4
End Function
