VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "gSDI_GetUCswNDTPs"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = True
Option Explicit
Const c_sModuleFileName As String = "gSDI_GetUCswNDTPs"
Const c_sDLLFileName As String = "CalculateResponse"       ' Constant reflect file module name
'Private ObjectTag As Object
'Property Set setObjectTag(anObject As Object)
'    Set ObjectTag = anObject
'End Property
'Property Get getObjectTag() As Object
'    Set getObjectTag = ObjectTag
'End Property

Function gSDI_GetUCswNDTPs(Self As Variant) As SDMUtilities.SDMList
  On Error GoTo ErrorHandler
'14: MsgBox "Entering....", , c_sModuleFileName

'PUT THE IMPLEMENTATION HERE >>>>>>>>>>>>>
'' Name:  gSDI.GetUCswNDTPs
''
'' Topics:  Spatial Data Modeller
''
'' Description:
''
''
''
'' Requires:
''
'' Self:  List, 0 --> unique conditions theme
''
'' Returns:  List of unique condition numbers
''           containing a non-deposit training point with
''           number of times uc is to be used as
''           non-deposit training vector.
''==============================================
'' Get projection of current view
''----------------------------------------------
'viewA = av.GetActiveDoc
'If (viewA.Is(View).Not) Then
'  return "The active document must be a View."
'End
'prjCrnt = viewA.GetProjection
'' Get arguments
''----------------------------------------------
'thmUC = Self.Get(0)           ' unique conditions theme
    Dim thmUC As IRasterLayer
45: Set thmUC = Self(0)
'lstPnts = Self.Get(1)         ' list of # of deposit training points in each uc
    Dim lstPnts As SDMUtilities.SDMList
48: Set lstPnts = Self(1)
'lstAreas = Self.Get(2)        ' list of areas of each uc
    Dim lstAreas As SDMUtilities.SDMList
51: Set lstAreas = Self(2)
''lstsUC = self.Get(3)          ' list of unique conditions numbers with deposit training points
    Dim AnlParms As AnalysisParameters.AnlParams
54: Set AnlParms = New AnalysisParameters.AnlParams
    Dim gParam As Form
56: Set gParam = AnlParms.gParamFrm
'' Get the study area
''----------------------------------------------
'thmSA = av.Run("gSDI.GetMask",{viewA})
    Dim thmSA As IRasterLayer
61: Set thmSA = WOETableUtils.FindLayerByName(gParam.cbxSA.Text)
'If (thmSA = Nil) Then
63: If thmSA Is Nothing Then
'  return "No Study Area theme set for the active View."
65:     MsgBox "No Study Area theme set for the active View.", , c_sModuleFileName
66:     Set gSDI_GetUCswNDTPs = Nothing
    Exit Function
'End
69: End If
'vTabSA = av.Run("gSDI.GetVTab",{thmSA})
    Dim gSDIGetVTab As gSDI_GetVTab
72:     Set gSDIGetVTab = New gSDI_GetVTab
    Dim vTabSA As ITable
74: Set vTabSA = gSDIGetVTab.gSDI_GetVTab(thmSA)
75: If vTabSA Is Nothing Then
76:     Set gSDI_GetUCswNDTPs = Nothing
        Exit Function
78: End If
'grdSA = thmSA.GetGrid
    Dim grdSA As IRaster
81: Set grdSA = thmSA.Raster
    Dim grdSAProps As IRasterProps
83: Set grdSAProps = grdSA
'fldCnt = vTabSA.FindField("Count")
    Dim fldCnt As Long
86: fldCnt = vTabSA.FindField("Count")
'sumCells = 0
    Dim sumcells As Long
Dim pProgbar As IStepProgressor
90: Set pProgbar = SDMGlobals.SDMStatusBar.ProgressBar
91: pProgbar.Position = 0
92: SDMGlobals.SDMStatusBar.ShowProgressBar "Get cell sums...", 0, vTabSA.RowCount(Nothing), 1, True
'For Each r In vTabSA
    Dim curs As ICursor
95: Set curs = vTabSA.Search(Nothing, False)
    Dim rw As IRow
97: Set rw = curs.NextRow
98: While Not rw Is Nothing
'  v = vTabSA.ReturnValue(fldCnt, r)
    Dim v As Long
101:     v = rw.Value(fldCnt)
'  If (v <> Number.MakeNull) Then
103:     If Not IsNull(v) Then
'    sumCells = sumCells + v
105:         sumcells = sumcells + v
'  End
107:     End If
'End
109:     Set rw = curs.NextRow
110: SDMGlobals.SDMStatusBar.StepProgressBar
111: Wend
112: SDMGlobals.SDMStatusBar.HideProgressBar
'nmbUA = av.FindDialog("gParam").findByName("txtUA").GetText
     Dim nmbUA As Variant
115: nmbUA = gParam.txtUA.Text
'110: nmbUA = "1"
'If (nmbUA.IsNumber) Then
118: If IsNumeric(nmbUA) Then
'  nmbUA = nmbUA.AsNumber
120:     nmbUA = CDbl(nmbUA)
'Else
122: Else
'  return "Problem with unit area parameters setting."
124:     MsgBox "Problem with unit area parameters setting.", , c_sModuleFileName
125:     Set gSDI_GetUCswNDTPs = Nothing
    Exit Function
'End
128: End If
'sa = (sumCells * grdSA.GetCellSize * grdSA.GetCellSize) / 1000000 / nmbUA
     Dim sa As Double
131: sa = (sumcells * grdSAProps.MeanCellSize.X * grdSAProps.MeanCellSize.Y) / 1000000 / nmbUA
'
'' Get the source of non-deposit training points
''----------------------------------------------
'gP = av.FindDialog("gParam")
'grdUC = thmUC.GetGrid
     Dim grdUC As IRaster
138: Set grdUC = thmUC.Raster
'nmbNull = Number.MakeNull
     Dim nmbNull As Variant
141: nmbNull = Null
'lstNDTP = List.Make
     Dim lstNDTP As New SDMUtilities.SDMList
'n1 = List.Make
     Dim n1 As New SDMUtilities.SDMList
'n2 = List.Make
     Dim n2 As New SDMUtilities.SDMList
''Get the data set
''---------------------------------------------
'cbxNTP = gP.findByName("cbxNTP")
'strThm = cbxNTP.GetCurrentValue
'If (strThm.Is(FTheme)) Then
'  strThm = strThm.AsString
'elseif (strThm.Is(String).Not) then
'  MsgBox.Error("Error in non-deposit training point theme parameter.","Parameter Error")
'  return Nil
'End
''strThm = cbxNTP.GetSelection
     Dim strThm As String
160: strThm = Self(5)
'thmNDTP = viewA.FindTheme(strThm)
     Dim thmNDTP As IFeatureLayer
163: Set thmNDTP = WOETableUtils.FindLayerByName(strThm)
'If (thmNDTP = Nil) Then
165: If thmNDTP Is Nothing Then
'  MsgBox.Error("The point theme " + strThm + " could not be found in view " + viewA.GetName + ".","Theme not found.")
167:    MsgBox "The point featurelayer " & strThm & " could not be found in map " & SDMGlobals.SDMMap.Name & ".", vbCritical, c_sModuleFileName
'  return Nil
169:    Set gSDI_GetUCswNDTPs = Nothing
        Exit Function
'End
172: End If
'fTabNDTP = thmNDTP.GetFTab
     Dim fTabNDTP As ITable
175: Set fTabNDTP = thmNDTP
'fldShp = fTabNDTP.FindField("Shape")
     Dim fldShp As Long
178: fldShp = thmNDTP.FeatureClass.FindField(thmNDTP.FeatureClass.ShapeFieldName)
'' Make list to hold number of points
'' per each uc
''----------------------------------------------
'vtbUC = av.Run("gSDI.GetVTab",{thmUC})
     Dim vtbUC As ITable
184: Set vtbUC = thmUC
'lstUCPnts = List.Make
     Dim lstUCPnts As New SDMUtilities.SDMList
'for each i in 1..vtbUC.GetNumRecords
     Dim i As Long
189: For i = 0 To vtbUC.RowCount(Nothing) - 1
'  lstUCPnts.Add (0)
191:     lstUCPnts.Add 0
'End
193: Next i
'' Read each point and get the unique condition in which it falls
''----------------------------------------------
'For Each r In fTabNDTP
     Dim rasBuf As IRasterBuffer
198: Set rasBuf = New IRasterBuffer
199: If Not rasBuf.OpenBuffer(thmUC) Then
200:    MsgBox "Illegal integer raster type", , c_sModuleFileName
201:    Set gSDI_GetUCswNDTPs = Nothing
        Exit Function
203: End If
     Dim NDTPfeatSel As IFeatureSelection
205: Set NDTPfeatSel = thmNDTP
     Dim NDTPfeatSelSet As ISelectionSet
207: Set NDTPfeatSelSet = NDTPfeatSel.SelectionSet
208: If NDTPfeatSelSet.Count = 0 Then
209:    MsgBox "No non-deposit training points selected", vbCritical, c_sModuleFileName
210:    Set gSDI_GetUCswNDTPs = Nothing
        Exit Function
212: End If
     Dim NDTPfeatcls As IFeatureClass
214: Set NDTPfeatcls = thmNDTP.FeatureClass
     Dim enumids As IEnumIDs
216: Set enumids = NDTPfeatSelSet.IDs
     Dim foid As Long
218: foid = enumids.Next
219: pProgbar.Position = 0
220: SDMGlobals.SDMStatusBar.ShowProgressBar "Processing non-deposit training points...", 0, NDTPfeatSelSet.Count, 1, True
221: While foid <> -1
        Dim f As IFeature
223:    Set f = NDTPfeatcls.GetFeature(foid)
'  pnt = fTabNDTP.ReturnValue(fldShp, r)
         Dim pnt As IPoint
226:     Set pnt = f.Value(fldShp)
'  uc = grdUC.CellValue(pnt, prjCrnt)
         Dim UC As Variant
229:     UC = rasBuf.CellValue(pnt)
'  If (uc <> nmbNull) Then
231:     If IsNull(UC) Then
232:     ElseIf CStr(UC) = "NoData" Then
233:     Else
'    lstNDTP.Add (uc)
235:         lstNDTP.Add CLng(UC)
'    lstUCPnts.Set((uc - 1),(lstUCPnts.Get(uc-1) + 1))
237:         If IsNull(lstUCPnts.GetVal(CLng(UC) - 1)) Then
                'MsgBox "UC value = " & CStr(uc) & " not found in lstUCPnts." & CStr(uc), vbCritical, c_sModuleFileName
239:         Else
240:            lstUCPnts.SetIt CLng(UC) - 1, CLng(lstUCPnts.GetVal(CLng(UC) - 1)) + 1
241:         End If
'  End
243:     End If
'End
245:     foid = enumids.Next
246: SDMGlobals.SDMStatusBar.StepProgressBar
247: Wend
248: SDMGlobals.SDMStatusBar.HideProgressBar
'' Append number of non-deposit training points to
'' unique conditions table
''----------------------------------------------
'fldNDTP = Field.Make("NDTrngPnts",#FIELD_LONG,3,0)
'fldNDTP.SetAlias ("Non-deposit Trng Points")
     Dim fldNDTP As Variant
255: fldNDTP = Array("NDTrngPnts", esriFieldTypeInteger, 3, 0, "Non-deposit Trng Points", False)
     Dim fldList As New SDMUtilities.SDMList
257: fldList.Add fldNDTP

     Dim vtbUCds As IDataset
260: Set vtbUCds = vtbUC
     Dim saTbl As IStandaloneTable
262: Set saTbl = WOETableUtils.FindStandAloneTableByName(vtbUCds.Name & "_Tbl", SDMGlobals.SDMMap)
263: If saTbl Is Nothing Then
264:     MsgBox vtbUCds.Name & "_Tbl" & " not found", , c_sModuleFileName
265:     Set gSDI_GetUCswNDTPs = Nothing
         Exit Function
267: End If
'vtbUC.SetEditable (True)
'''''        Dim pDataset As IDataset
'''''230:     Set pDataset = saTbl
'''''        Dim wksEdit As IWorkspaceEdit
''''''232:     Set wksEdit = FeatureUtils.startEditing(pDataset.Workspace.PathName)
'If (vtbUC.IsEditable) Then
'  vtbUC.AddFields({fldNDTP})
275:     If saTbl.Table.FindField(fldNDTP(0)) = -1 Then _
             WOETableUtils.AddFields saTbl.Table, fldList
    '  i = 0
278:     i = 0
279:     Set curs = saTbl.Table.Update(Nothing, False)
         Dim r As IRow
281:     Set r = curs.NextRow
    '  For Each r In vtbUC
283: pProgbar.Position = 0
284: SDMGlobals.SDMStatusBar.ShowProgressBar "Processing non-deposit training points...", 0, saTbl.Table.RowCount(Nothing), 1, True
285:     fldNDTP = saTbl.Table.FindField(fldNDTP(0))
286:     Do Until ((r Is Nothing) Or (i = lstUCPnts.Count))
    '    If (i < lstUCPnts.Count) The
    '      vtbUC.SetValue(fldNDTP,r,lstUCPnts.Get(i))
289:             r.Value(fldNDTP) = lstUCPnts.GetVal(i)
290:             curs.UpdateRow r
291:             Set r = curs.NextRow
'    Else
    '      Break
    '    End
    '    i = i + 1
296:         i = i + 1
    '  End
298:     SDMGlobals.SDMStatusBar.StepProgressBar
299:     Loop
300:     SDMGlobals.SDMStatusBar.HideProgressBar
'End
'vtbUC.SetEditable (False)
'''''276: FeatureUtils.stopEditing wksEdit
'vtbUC.Flush
'' Make 2 lists, n1 w/unique list of unique conditions,
'' n2 w/number of instances of the condition
''----------------------------------------------
'NDTPCpy = lstNDTP.Clone
     Dim NDTPCpy As SDMUtilities.SDMList
310: Set NDTPCpy = lstNDTP.Clone
'NDTPCpy.RemoveDuplicates
312: Set NDTPCpy = NDTPCpy.RemoveDuplicates
'If (NDTPCpy.Count < lstNDTP.Count) Then
314: If NDTPCpy.Count < lstNDTP.Count Then
315: pProgbar.Position = 0
316: SDMGlobals.SDMStatusBar.ShowProgressBar "Processing non-deposit training points...", 0, lstNDTP.Count, 1, True
'  For Each n In lstNDTP
         Dim n As Variant
319:     For Each n In lstNDTP.list
'    nIdx = n1.FindByValue(n)
             Dim nIdx As Long
322:         nIdx = n1.FindByValue(CLng(n))
'    If (nIdx > -1) Then
324:         If nIdx > -1 Then
'      n2.Set(nIdx,(n2.Get(nIdx) + 1))
326:             n2.SetIt nIdx, n2.GetVal(nIdx) + 1
'    Else
328:         Else
'      n1.Add (n)
330:             n1.Add n
'      n2.Add (1)
332:             n2.Add 1
'    End
334:         End If
'  End
336: SDMGlobals.SDMStatusBar.StepProgressBar
337:     Next n
338: SDMGlobals.SDMStatusBar.HideProgressBar
'Else
340: Else
'  n1 = lstNDTP
342:     Set n1 = lstNDTP
'  For Each n In n1
344: pProgbar.Position = 0
345: SDMGlobals.SDMStatusBar.ShowProgressBar "Processing non-deposit training points...", 0, n1.Count, 1, True
346:     For Each n In n1.list
'    n2.Add (1)
348:         n2.Add 1
'  End
350: SDMGlobals.SDMStatusBar.StepProgressBar
351:     Next n
352: SDMGlobals.SDMStatusBar.HideProgressBar
'End
354: End If

'
'
'return {n1,n2}
359: Set gSDI_GetUCswNDTPs = New SDMUtilities.SDMList
360: gSDI_GetUCswNDTPs.AddArray Array(n1, n2)
'365: MsgBox "Exiting....", , c_sModuleFileName
'<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
Exit Function
ErrorHandler:
  HandleError True, c_sModuleFileName & " " & GetErrorLineNumberString(Erl), Err.Number, Err.Source, Err.Description, 4
366:     Set gSDI_GetUCswNDTPs = Nothing
End Function

