VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "gSDI_GetValsFrmUC"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = True
Option Explicit
Const c_sModuleFileName As String = "gSDI_GetValsFrmUC"
Const c_sDLLFileName As String = "SDMAccessories"       ' Constant reflect file module name
'Private ObjectTag As Object
'Property Set setObjectTag(anObject As Object)
'    Set ObjectTag = anObject
'End Property
'Property Get getObjectTag() As Object
'    Set getObjectTag = ObjectTag
'End Property

Function gSDI_GetValsFrmUC(Self As Variant) As SDMUtilities.SDMList
  On Error GoTo ErrorHandler

'PUT THE IMPLEMENTATION HERE >>>>>>>>>>>>>
'' Name:    gSDI.GetValsFrmUC
''
'' Topics:  Spatial Data Modeller
''
'' Description:
''
''
''
'' Requires:
''
'' Self:
''
'' Returns:
''==============================================
''
'nmbRanks = 20
    Dim nmbRanks As Long
34: nmbRanks = 5
'thm = Self.Get(0).Get(0)
    Dim thm As IRasterLayer
37: Set thm = Self(0)(0)
'fld0 = Self.Get(0).Get(1)
    Dim fld0 As esrigeodatabase.IField
40: Set fld0 = Self(0)(1)
'fld1 = Self.Get(1).Get(1)
    Dim fld1 As esrigeodatabase.IField
43: Set fld1 = Self(1)(1)
'rounding = 10000     ' factor to use for rounding
45: Const rounding = 4
'lstMapX = {}
    Dim lstMapX As New SDMUtilities.SDMList
'lstMapY = {}
    Dim lstMapY As New SDMUtilities.SDMList
'lstAreas = {}
    Dim lstAreas As New SDMUtilities.SDMList
'If (thm.Is(FTheme)) Then
'  theVTab = thm.GetFTab
'  fldArea = theVTab.FindField("Shape")
'Else
'  theVTab = av.Run("gSDI.GetVTab",{thm})
    Dim dspTbl As IDisplayTable
58: Set dspTbl = thm
    Dim theVTab As ITable
60: Set theVTab = dspTbl.DisplayTable
'  fldArea = theVTab.FindField("Count")
    Dim fldArea As Long
63: fldArea = theVTab.FindField("Count")
'End
    Dim fld0idx As Long
66: fld0idx = theVTab.FindField(fld0.Name)
    Dim fld1idx As Long
68: fld1idx = theVTab.FindField(fld1.Name)
'For Each r In theVTab
    Dim curs As ICursor
71: Set curs = theVTab.Search(Nothing, False)
    Dim r As irow
73: Set r = curs.NextRow
74: While Not r Is Nothing
'  lstMapX.Add (theVTab.ReturnValue(fld0, r))
76:     lstMapX.Add r.Value(fld0idx)
'  lstMapY.Add (theVTab.ReturnValue(fld1, r))
78:     lstMapY.Add r.Value(fld1idx)
'  If (thm.Is(FTheme)) Then
'    lstAreas.Add (theVTab.ReturnValue(fldArea, r).ReturnArea)
'  Else
'    lstAreas.Add (theVTab.ReturnValue(fldArea, r))
83:     lstAreas.Add r.Value(fldArea)
'  End
'End
86:     Set r = curs.NextRow
87: Wend
'lstsVals = {lstMapX,lstmapY}
    Dim lstsVals As New SDMUtilities.SDMList
90: lstsVals.AddArray Array(lstMapX, lstMapY)
'lstClassesAll = List.Make
    Dim lstClassesAll As New SDMUtilities.SDMList
'lstMins = List.Make
    Dim lstMins As New SDMUtilities.SDMList
    Dim mins As SDMUtilities.SDMList
'for each i in 0..1
    Dim i As Long
98: For i = 0 To 1
99:     Dim fldi As esrigeodatabase.IField
100:    Set fldi = Self(i)(1)
        Dim lstClasses As SDMUtilities.SDMList
'  lstClasses = av.Run("gSDI.MakeQuantiles",{thm,self.Get(i).Get(1).GetName,nmbRanks})
103:    Set lstClasses = MakeQuantiles(thm, fldi, nmbRanks)
'  mins = List.Make
105:    Set mins = New SDMUtilities.SDMList
'  For Each Cls In lstClasses
        Dim Cls As Variant
108:    For Each Cls In lstClasses.list
'    If (Cls.GetLabel <> "No Data") Then
'      mins.Add(((cls.ReturnMinimum * rounding).Round) / rounding)
'            The class breaks are like the min value of a classification range
111:         mins.Add Round(CDbl(Cls), rounding)
'    End
'  End
114:     Next Cls
'  lstMins.Add (mins)
116:     lstMins.Add mins
'  lstClassesAll.Add (lstClasses)
118:     lstClassesAll.Add lstClasses
'End
120: Next i

'lstRanksXY = List.Make
     Dim hasNulls As Boolean
     hasNulls = False
     Dim lstRanksXY As New SDMUtilities.SDMList
     Dim lstRanks As New SDMUtilities.SDMList
'for each i in 0..1
126: For i = 0 To 1
'  lstClasses = lstClassesAll.Get(i)
128:     Set lstClasses = lstClassesAll.getObj(i)
'  mins = lstMins.Get(i)
130:     Set mins = lstMins.getObj(i)
'  lstRanks = List.Make
132:     lstRanks.Clear
'  check = 0
         Dim check As Long
135:     check = 0
'  For Each k In lstsVals.Get(i)
         Dim K As Variant
         Dim tmplst As SDMUtilities.SDMList
139:     Set tmplst = lstsVals.getObj(i)
140:     For Each K In tmplst.list
'    rndK = ((k * rounding).Round) / rounding
             Dim rndK As Double
             If IsNull(K) Then
                rndK = 0
                hasNulls = True
             Else
143:            rndK = Round(CDbl(K), rounding)
             End If
'      added = False
             Dim added As Boolean
146:         added = False
'    for each j in (mins.Count - 1)..0
             Dim j As Long
149:         For j = mins.Count - 1 To 0 Step -1
'      minCurrent = mins.Get(j)
                Dim minCurrent As Double
152:             minCurrent = mins.GetVal(j)
'      If (j > 0) Then
154:             If j > 0 Then
'        If (rndK > minCurrent) Then
156:                 If rndK > minCurrent Then
'          lstRanks.Add (j + 1)
158:                     lstRanks.Add j + 1
'          added = True
160:                     added = True
'          Break
162:                     Exit For
'        End
164:                 End If
'      ElseIf (j = 0) Then
166:             ElseIf j = 0 Then
'        If (rndK <= mins.Get(j + 1)) Then
168:                 If rndK <= mins.GetVal(j + 1) Then
'          lstRanks.Add (j + 1)
170:                     lstRanks.Add j + 1
'          added = True
172:                     added = True
'          Break
174:                     Exit For
'        End
176:                 End If
'      End
178:             End If
'    End
180:         Next j
'    check = check + 1
182:         check = check + 1
'    If (added.Not) Then
'    End
'  End
186:     Next K
'  lstRanksXY.Add (lstRanks)
188:     lstRanksXY.Add lstRanks
'End
190: Next i
'''MsgBox ListUtils.ListtoString(lstsVals), , "lstsVals"
'''MsgBox ListUtils.ListtoString(lstRanksXY), , "lstRanksXY"
'''MsgBox ListUtils.ListtoString(lstAreas), , "lstAreas"
'return {lstsVals,lstRanksXY,lstAreas}
194: If hasNulls Then MsgBox "One of the compared fields has NULL values which were SET=0.0.", vbExclamation, "Compare Results"
195: Set gSDI_GetValsFrmUC = New SDMUtilities.SDMList
196: gSDI_GetValsFrmUC.AddArray Array(lstsVals, lstRanksXY, lstAreas)
'<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
Exit Function
ErrorHandler:
  HandleError True, c_sModuleFileName & " " & GetErrorLineNumberString(Erl), Err.Number, Err.Source, Err.Description, 4
201:   Set gSDI_GetValsFrmUC = Nothing
End Function

Private Function MakeQuantiles(thm As IRasterLayer, fldi As esrigeodatabase.IField, nmbRanks As Long) As SDMUtilities.SDMList
  On Error GoTo ErrorHandler
'MsgBox "Entering MakeQuantiles...."
       Dim pTableHist As ITableHistogram
206:   Set pTableHist = New TableHistogram
207:   pTableHist.Field = fldi.Name
       Dim pDispTbl As IDisplayTable
209:   Set pDispTbl = thm
       Dim pTable As ITable
211:   Set pTable = pDispTbl.DisplayTable
212:   Set pTableHist.Table = pTable
    
       Dim pHistogram As IHistogram
215:   Set pHistogram = pTableHist

       Dim varValues As Variant, varCounts As Variant
219:   pHistogram.GetHistogram varValues, varCounts
       Dim pClassify As IClassify
221:   Set pClassify = New Quantile
222:   pClassify.SetHistogramData varValues, varCounts
223:   pClassify.Classify nmbRanks

       Dim pUid As UID
226:   Set pUid = New UID
227:   Set pUid = pClassify.ClassID
    
       Dim pClassDialog As IClassificationDialog
230:   Set pClassDialog = New ClassificationDialog
231:   pClassDialog.Classification = pUid
232:   pClassDialog.SetHistogramData pHistogram
233:   SDMGlobals.SDMStatusBar.Message(0) = "Classifying " & thm.Name & ": " & fldi.Name
234:   pClassDialog.ClassBreaks = pClassify.ClassBreaks
       Dim OK As Boolean
236:   OK = pClassDialog.doModal(0) 'open the dialog
237:   If Not OK Then
238:     Set MakeQuantiles = Nothing
         Exit Function
240:   End If
241:   Set MakeQuantiles = New SDMUtilities.SDMList
242:   MakeQuantiles.AddArray pClassDialog.ClassBreaks
'MsgBox "Exiting MakeQuantiles...."

  Exit Function
ErrorHandler:
        HandleError False, "MakeQuantiles " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), Err.Number, Err.Source, Err.Description, 4
        Set MakeQuantiles = Nothing
End Function
