VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "gSDI_GetValsNAreas"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = True
Option Explicit
Const c_sModuleFileName As String = "gSDI_GetValsNAreas"
Const c_sDLLFileName As String = "SDMAccessories"       ' Constant reflect file module name
'Private ObjectTag As Object
'Property Set setObjectTag(anObject As Object)
'    Set ObjectTag = anObject
'End Property
'Property Get getObjectTag() As Object
'    Set getObjectTag = ObjectTag
'End Property

Function gSDI_GetValsNAreas(Self As Variant) As SDMUtilities.SDMList
  On Error GoTo ErrorHandler
'MsgBox "Entering...", , c_sModuleFileName

'PUT THE IMPLEMENTATION HERE >>>>>>>>>>>>>
'' gSDI.GetValsNAreas
''
'' Topics:  Spatial Data Modeller
''
'' Description:
''
''
''
'' Requires:
''
'' Self:  0,1 -- tfPair0,tfPair1 -- two theme-field pairs
''
''
'' Returns:
''==============================================
''
'tfPair0 = Self.Get(0)
    Dim tfPair0 As Variant
35: tfPair0 = Self(0)
'tfPair1 = Self.Get(1)
    Dim tfPair1 As Variant
38: tfPair1 = Self(1)
''boolKeepUC = self.Get(2
'gThm0 = tfPair0.Get(0)
    Dim gThm0 As IRasterLayer
42: Set gThm0 = tfPair0(0)
'gThm1 = tfPair1.Get(0)
    Dim gThm1 As IRasterLayer
45: Set gThm1 = tfPair1(0)
'If (gThm0.GetGrid.GetSrcName = gThm1.GetGrid.GetSrcName) Then
    Dim lstValsAreas As SDMUtilities.SDMList
    'MsgBox gThm0.FilePath & vbCrLf & gThm1.FilePath, , "File Paths"
48: If gThm0.FilePath = gThm1.FilePath Then
'  lstValsAreas = av.Run("gSDI.GetValsFrmUC",{tfPair0,tfPair1})
        Dim gSDIGetValsFrmUC As gSDI_GetValsFrmUC
51:     Set gSDIGetValsFrmUC = New gSDI_GetValsFrmUC
52:     Set lstValsAreas = gSDIGetValsFrmUC.gSDI_GetValsFrmUC(Array(tfPair0, tfPair1))
53:     If lstValsAreas Is Nothing Then
54:         Set gSDI_GetValsNAreas = Nothing
            Exit Function
56:     End If
'Else
58: Else
'  lstVTabs = List.Make
        Dim lstVTabs As New SDMUtilities.SDMList
'  for each i in 0..1
        Dim i As Long
63:     For i = 0 To 1
'    thm = Self.Get(i).Get(0)
            Dim tmpPair As Variant
66:         tmpPair = Self(i)
            Dim thm As IRasterLayer
68:         Set thm = tmpPair(0)
'    If (thm.Is(GTheme)) Then
'
'      If (thm.GetGrid.IsInteger) Then
'        vTb = av.Run("gSDI.GetVTab",{thm})
                Dim vTb As ITable
74:             Set vTb = thm
'        If (vtb = Nil) Then
'
'          MsgBox.Error("Could not find or create an attribute table for theme '" + thm.GetName + "'.","Results Comparison")
'
'          return Nil
'
'        End
'
'        lstVTabs.Add (thm.GetVTab)
84:             lstVTabs.Add vTb
'      Else
'
'        lstVTabs.Add (Nil)
'
'      End
'
'    ElseIf (thm.Is(FTheme)) Then
'
'      lstVTabs.Add (thm.GetFTab)
'
'    End
'
'  End
98:     Next i

'  i = 0
'  lstListVals = List.Make
'  For Each vt In lstVTabs
'    fld = Self.Get(i).Get(1)
'    lstVals = List.Make
'    For Each r In vt
'      lstVals.Add (vt.ReturnValue(fld, r))
'    End
'    lstListVals.Add (lstVals)
'    i = i + 1
'  End
'  'lstGrdsRclss = av.Run("gSDI.ReclassThemes",{tfPair0,tfPair1})
'    '!!!!!!
'  grdUCTemp = av.Run("gSDI.ReclassThemes",{tfPair0,tfPair1})
        Dim pGeoDS0 As IGeoDataset
        Dim fld0 As esrigeodatabase.IField
138:    Set fld0 = tfPair0(1)
139:    Set pGeoDS0 = ReclassByClassList.ReclassByClassList(gThm0, fld0.Name, True)
140:    If pGeoDS0 Is Nothing Then
141:        Set gSDI_GetValsNAreas = Nothing
            Exit Function
143:    End If
        Dim grd0 As IRasterLayer
145:    Set grd0 = New RasterLayer
146:    grd0.CreateFromRaster pGeoDS0

        Dim fld1 As esrigeodatabase.IField
149:    Set fld1 = tfPair1(1)
        Dim pGeoDS1 As IGeoDataset
151:    Set pGeoDS1 = ReclassByClassList.ReclassByClassList(gThm1, fld1.Name, True, UBound(gC.breaks))
152:    If pGeoDS1 Is Nothing Then
153:        Set gSDI_GetValsNAreas = Nothing
            Exit Function
155:    End If
        Dim grd1 As IRasterLayer
157:    Set grd1 = New RasterLayer
158:    grd1.CreateFromRaster pGeoDS1

'  'grdUCTemp = lstGrdsRclss.Get(0).Combine({lstGrdsRclss.Get(1)})
'grdDiff = grd0.Combine({grd1})
        Dim grdUCTemp As IGeoDataset
163:    Set grdUCTemp = RasterAEUtils.Combine(grd0, grd1)
164:    If grdUCTemp Is Nothing Then
165:        MsgBox "Combine action not valid.", vbCritical, c_sModuleFileName
166:        Set gSDI_GetValsNAreas = Nothing
            Exit Function
168:    End If
'  vTabUCTemp = grdUCTemp.GetVTab
         Dim tmpRaslyr As IRasterLayer
171:     Set tmpRaslyr = New RasterLayer
172:     tmpRaslyr.CreateFromRaster grdUCTemp
         Dim vTabUCTemp As ITable
174:     Set vTabUCTemp = tmpRaslyr
'  fldCount = vTabUCTemp.FindField("Count")
         Dim fldcount As Long
177:     fldcount = vTabUCTemp.FindField("Count")
'  fldX = vTabUCTemp.GetFields.Get(2)
         Dim fldX As Long
180:     fldX = 2
'  fldY = vTabUCTemp.GetFields.Get(3)
         Dim fldy As Long
183:     fldy = 3
'  lstMapX = {}
         Dim lstMapX As New SDMUtilities.SDMList
'  lstMapY = {}
         Dim lstMapY As New SDMUtilities.SDMList
'  lstAreas = {}
         Dim lstAreas As New SDMUtilities.SDMList
'  For Each r In vTabUCTemp
         Dim curs As ICursor
192:     Set curs = vTabUCTemp.Search(Nothing, False)
         Dim r As irow
194:     Set r = curs.NextRow
195:     While Not r Is Nothing
'    lstAreas.Add (vTabUCTemp.ReturnValue(fldCount, r))
197:         lstAreas.Add r.Value(fldcount)
'    lstMapX.Add (vTabUCTemp.ReturnValue(fldX, r))
199:         lstMapX.Add r.Value(fldX)
'    lstMapY.Add (vTabUCTemp.ReturnValue(fldY, r))
201:         lstMapY.Add r.Value(fldy)
'  End
203:         Set r = curs.NextRow
204:     Wend
'
'  lstValsAreas = {lstListVals,{lstMapX,lstMapY},lstAreas}
         Dim tmplist As New SDMUtilities.SDMList
208:     tmplist.AddArray Array(lstMapX, lstMapY)
209:     Set lstValsAreas = New SDMList
210:     lstValsAreas.AddArray Array(New SDMList, tmplist, lstAreas)
'End
212: End If
'return lstValsAreas
214: Set gSDI_GetValsNAreas = lstValsAreas

'<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
Exit Function
ErrorHandler:
  HandleError True, c_sModuleFileName & " " & GetErrorLineNumberString(Erl), Err.Number, Err.Source, Err.Description, 4
220:   gSDI_GetValsNAreas = Nothing
End Function
