VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "gSDI_Help"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = True
Option Explicit
Private theHelpDir As String
Const c_sModuleFileName As String = "C:\MyJava\ARC-SDM\VBScripts\gSDI_Help.cls"


Sub gSDI_Help(ByRef anHTML As String)
  On Error GoTo errorhandler


' Name:  gSDI_Help

'Topics:  Spatial Data Modeller; DDE; Windows API
'Description: Uses DDE links (or Netscape remote procedures
' in UNIX) to activate either Netscape or
'  Internet Explorer, and open a local HTML document to
' provide help.  Prompts user for location of help files
' and writes this path to the Data Types table.
'
' Requires:  A URL to
' Self:  List containing the URL of a local HTML document
' that provides help related to the script from which gSDI_Help
' was called.
'Returns:
'==============================================
25:         If (Me.helpdir = "") Then
26:             MsgBox "Help documentation has not been installed or referenced", vbExclamation, "ArcSDM3 Help"
                 Exit Sub
28:         End If
'29:     Set SDMGlobals.SDMHelp = Me
'        Dim i As Long
'31:     For i = 0 To Forms.Count - 1
'           Dim frm As Form
'33:        Set frm = Forms(i)
'34:        If frm.Name = "frmgSDIHelp" Then
'35:             frm.brwWebBrowser.Navigate Me.helpURL & anHTML
'36:             GoTo Next1
'37:        End If
'38:    Next i
'39:    frmgSDIHelp.brwWebBrowser.Navigate Me.helpURL & anHTML
'Next1:
'41:     If Not frmgSDIHelp.brwWebBrowser.Visible Then frmgSDIHelp.Show vbModeless
        Dim IE As Object
        Set IE = CreateObject("InternetExplorer.Application")
        IE.AddressBar = False
        IE.MenuBar = False
        IE.Resizable = True
        IE.StatusBar = False
        IE.ToolBar = False
        IE.Visible = True
        IE.Navigate Me.helpURL & anHTML
  Exit Sub
errorhandler:
  HandleError True, "gSDI_Help " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), Err.Number, Err.Source, Err.Description, 4
End Sub



Public Property Get helpdir() As Variant
  On Error GoTo errorhandler

52:     helpdir = theHelpDir


  Exit Property
errorhandler:
  HandleError True, "HelpDir " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), Err.Number, Err.Source, Err.Description, 4
End Property

Public Property Get helpURL() As Variant
  On Error GoTo errorhandler

63:     If theHelpDir <> "" Then
64:         helpURL = "file:///" & theHelpDir & "/"
65:     Else
66:         helpURL = ""
67:     End If

  Exit Property
errorhandler:
  HandleError True, "helpURL " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), Err.Number, Err.Source, Err.Description, 4
End Property


Private Sub Class_Initialize()
    On Error GoTo errorhandler
77:         theHelpDir = GetSetting("SDMExtension", "Globals", "HelpFolder", "")
             Dim fs As Object
79:         Set fs = CreateObject("Scripting.FileSystemObject")
80:         If (theHelpDir = "") Then
81:             GetHelpDir
82:         ElseIf Not fs.folderExists(theHelpDir) Then
83:             GetHelpDir
84:         ElseIf Not fs.fileexists(fs.buildpath(theHelpDir, "sdmhelp.htm")) Then
85:             GetHelpDir
86:         End If
Exit Sub
errorhandler:
    HandleError True, "Class_Initialize" & " " & "gSDI_Help" & GetErrorLineNumberString(Erl), Err.Number, Err.Source, Err.Description, 4
End Sub

Private Sub GetHelpDir()
  On Error GoTo errorhandler

95:     If GetSetting("SDMExtension", "Globals", "HelpFolder", "") <> "" Then _
            DeleteSetting "SDMExtension", "Globals", "HelpFolder"
    
        Dim helpdir As String
99:     helpdir = SDMUtilFrm.getDir("", "Find/Select Help Folder")
100:     If (helpdir <> "") Then
                Dim fs As Object
102:         Set fs = CreateObject("Scripting.FileSystemObject")
103:         If fs.fileexists(fs.buildpath(helpdir, "sdmhelp.htm")) Then
104:             theHelpDir = helpdir
105:             SaveSetting "SDMExtension", "Globals", "HelpFolder", theHelpDir
106:         Else
107:             theHelpDir = ""
108:         End If
109:     Else
110:         theHelpDir = ""
111:     End If
'            MsgBox GetSetting("SDMExtension", "Globals", "HelpFolder")

  Exit Sub
errorhandler:
  HandleError False, "GetHelpDir " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), Err.Number, Err.Source, Err.Description, 4
End Sub

Private Sub Class_Terminate()
    'MsgBox "terminating..."
     If helpdir = "" Then Exit Sub
    'MsgBox frmgSDIHelp.brwWebBrowser.ReadyState
123: If frmgSDIHelp.brwWebBrowser.Busy Then frmgSDIHelp.brwWebBrowser.Stop

End Sub
