VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "gSDI_MakeCITab"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = True
Option Explicit
Const c_sModuleFileName As String = "gSDI_MakeCITab"
Const c_sDLLFileName As String = "CalculateResponse"       ' Constant reflect file module name
'Private ObjectTag As Object
'Property Set setObjectTag(anObject As Object)
'    Set ObjectTag = anObject
'End Property
'Property Get getObjectTag() As Object
'    Set getObjectTag = ObjectTag
'End Property

Function gSDI_MakeCITab(Self As Variant) As Variant
  On Error GoTo ErrorHandler

15: ProgressAnimation.Show "Creating CI table..."
'PUT THE IMPLEMENTATION HERE >>>>>>>>>>>>>
Dim thmUC As IRasterLayer
18: Set thmUC = Self(0)
Dim UCTbl As ITable
20: Set UCTbl = thmUC
Dim AreaNumbTbl As ITable
22: Set AreaNumbTbl = Self(1)
Dim WofETbl As ITable
24: Set WofETbl = Self(2)
Dim unitArea As Double
26: unitArea = Self(3)
Dim doMsng As Boolean
28: doMsng = Self(4)

Dim valueidx As Long
31: valueidx = UCTbl.FindField("Value")
Dim areasqmidx As Long
33: areasqmidx = AreaNumbTbl.FindField("Area_sqm")
Dim numptsidx As Long
35: numptsidx = AreaNumbTbl.FindField("TrngPoints")
Dim postProbIdx As Long
37: postProbIdx = WofETbl.FindField("Post_Prob")
Dim UncertIdx As Long
39: UncertIdx = WofETbl.FindField("Uncrty")
Dim totUncertIdx As Long
41: totUncertIdx = WofETbl.FindField("Tot_Uncrty")

Dim valuefld As Variant
44: valuefld = Array("Value", esriFieldTypeInteger, 12, 0, "Value", False)
Dim PredPntFreqfld As Variant
46: PredPntFreqfld = Array("PrdPntFreq", esriFieldTypeDouble, 12, 4, "Predicted Point Freq", False)
Dim fldslist As New SDMUtilities.SDMList
48: fldslist.AddArray Array(valuefld, PredPntFreqfld)
49: If totUncertIdx <> -1 Then
        Dim VarPntFreqfld As Variant
51:     VarPntFreqfld = Array("VarPntFreq", esriFieldTypeDouble, 12, 4, "Variance Point Freq", False)
52:     fldslist.Add VarPntFreqfld
53: End If

'    Dim getPrjDir As sdmutilities.gSDI_getProjectDir
'49: Set getPrjDir = New sdmutilities.gSDI_getProjectDir
'50: SDMGlobals.SDMPrjDir = getPrjDir.gSDI_getProjectDir
'51: Set getPrjDir = Nothing
59: SDMGlobals.SDMPrjDir = FileDialog.GetCWD.path
'>>>> Remove new SATable if exists in Map
Dim saTable As IStandaloneTable
62: Set saTable = WOETableUtils.FindStandAloneTableByName(thmUC.Name & "_CI", SDMGlobals.SDMMap)
63: If Not saTable Is Nothing Then SDMGlobals.SDMTableUtils.RemoveTable saTable, SDMGlobals.SDMApp
'>>>> Delete new SATABLE if exists in folder
Dim saTblFilename As String
66: saTblFilename = SDMGlobals.SDMPrjDir & "\" & thmUC.Name & "_CI.dbf"
67: If FileDialog.ExistsFilename(saTblFilename) Then FileDialog.DeleteFilename (saTblFilename)
'>>>> Create new SATable
Dim aTbl As ITable
70: Set aTbl = WOETableUtils.CreateTable(thmUC.Name & "_CI", SDMGlobals.SDMPrjDir, fldslist.list, False)
71: If aTbl Is Nothing Then
72:     MsgBox "Can't create UC Table; " & saTblFilename, , c_sModuleFileName
73:     gSDI_MakeCITab = Null
        Exit Function
75: End If
    Dim AreaNumRecord As irow
    Dim WofETblRecord As irow
    Dim record As irow
    
    Dim curs As ICursor
81:     Set curs = UCTbl.Search(Nothing, False)
    Dim UCRecord As irow
83:     Set UCRecord = curs.NextRow
    Dim totT As Double
85:     totT = 0
    Dim totVarT As Double
87:     totVarT = 0
88: ProgressAnimation.Hide

Dim progBar As IStepProgressor
91: Set progBar = SDMGlobals.SDMStatusBar.ProgressBar
92: progBar.Position = 0
93: SDMGlobals.SDMStatusBar.ShowProgressBar "Adding rows to CI Table...", 1, UCTbl.RowCount(Nothing), 1, True
94: While Not UCRecord Is Nothing
        Dim rowid As Long
96:     rowid = UCRecord.OID
97:     Set AreaNumRecord = AreaNumbTbl.GetRow(rowid)
98:     Set WofETblRecord = WofETbl.GetRow(rowid)
        Dim numUnitCells As Double
100:     numUnitCells = AreaNumRecord.Value(areasqmidx) / 1000000 / unitArea
101:     Set record = aTbl.CreateRow
102:     record.Value(aTbl.FindField("Value")) = UCRecord.Value(valueidx)
        Dim t As Double
104:     t = numUnitCells * WofETblRecord.Value(postProbIdx)
105:     totT = totT + t
106:     record.Value(aTbl.FindField("PrdPntFreq")) = t
107:     If doMsng Then 'Compute from Total Uncertainty
            Dim varT As Double
109:        varT = (numUnitCells * WofETblRecord.Value(totUncertIdx)) ^ 2
110:        record.Value(aTbl.FindField("VarPntFreq")) = varT
111:    Else 'Compute from Uncertainty
112:        varT = (numUnitCells * WofETblRecord.Value(UncertIdx)) ^ 2
113:    End If
114:    record.Store
115:    totVarT = totVarT + varT
116:    Set UCRecord = curs.NextRow
117:     SDMGlobals.SDMStatusBar.StepProgressBar
118: Wend
119:     SDMGlobals.SDMStatusBar.HideProgressBar

121: gSDI_MakeCITab = Array(totT, totVarT)
'>>>> Add new SATable to map
123: WOETableUtils.AddTable SDMGlobals.SDMPrjDir, thmUC.Name & "_CI", SDMGlobals.SDMApp
124: WOETableUtils.SetAliases thmUC.Name & "_CI", fldslist.list
'<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
Exit Function
ErrorHandler:
  HandleError True, c_sModuleFileName & " " & GetErrorLineNumberString(Erl), Err.Number, Err.Source, Err.Description, 4
End Function
