VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "gSDI_MakeLineChart"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = True
Option Explicit
Const c_sModuleFileName As String = "C:\MyJava\ARC-SDM\VBScripts\gSDI_MakeLineChart.cls"
Const c_sDLLFileName As String = "CreatTable"       ' Constant reflect file module name
'Private ObjectTag As Object
'Property Set setObjectTag(anObject As Object)
'    Set ObjectTag = anObject
'End Property
'Property Get getObjectTag() As Object
'    Set getObjectTag = ObjectTag
'End Property

Sub gSDI_MakeLineChart()
  On Error GoTo ErrorHandler


16:  If (gCht.isShiftdown) Then
    Dim gsdiHelp As SDMUtilities.gSDI_Help
18:     Set gsdiHelp = SDMGlobals.SDMHelp
19:     gsdiHelp.gSDI_Help ("sdmchart.htm")
    Exit Sub
21:  End If
'PUT THE IMPLEMENTATION HERE >>>>>>>>>>>>>
Dim saTblName As String
24: saTblName = gCht.cbx_Tab.Text
Dim saTbl As IStandaloneTable
26: Set saTbl = SDMGlobals.SDMUtil.FindStandAloneTableByName(saTblName)
Dim qryf As IQueryFilter
28: Set qryf = New QueryFilter
29: qryf.WhereClause = """" & gCht.cbx_Cfd.Text & """ > 0"
Dim tblSel As ITableSelection
31: Set tblSel = saTbl
32: tblSel.SelectRows qryf, esriSelectionResultNew, False
33: tblSel.SelectionChanged

Dim datagfx As IDataGraph
36: Set datagfx = New DataGraph
37: With datagfx
38:         Set .Table = saTbl
39:         .name = "Graph of " & saTbl.name
40:         If gCht.lbx_Wtc.SelCount = 1 Then
41:             .FieldSet1 = gCht.lbx_Wtc.Text ' Y field
42:         ElseIf gCht.lbx_Wtc.SelCount > 1 Then
            Dim i As Integer
            Dim fldset As String
45:             For i = 0 To gCht.lbx_Wtc.ListCount - 1
46:                 If gCht.lbx_Wtc.Selected(i) Then
47:                     If fldset = "" Then
48:                         fldset = gCht.lbx_Wtc.List(i)
49:                     Else
50:                         fldset = fldset & "," & gCht.lbx_Wtc.List(i)
51:                     End If
52:                 End If
53:             Next i
54:             .FieldSet1 = fldset
55:         End If
56:     .FieldSet2 = gCht.cbx_Cfd.Text ' X field
57:     .SeriesByRecord = True
58:     .UseSelectedSet = True
59: End With
Dim gfxTix As IDataGraphTicks
61: Set gfxTix = datagfx
62: With gfxTix
63:     .TickEvery = 1
64:     .Ticks = esriDataGraphTicksXY
65:     .TickStyle = esriDataGraphTickStyleThrough
66: End With

Dim XaxisFldName As String
69: XaxisFldName = gCht.cbx_Cfd.Text
Dim XaxisFld As IField
71: Set XaxisFld = saTbl.Table.Fields.Field(saTbl.Table.FindField(XaxisFldName))

Dim YaxisFldName As String
74: YaxisFldName = gCht.lbx_Wtc.Text
Dim YaxisFld As IField
76: Set YaxisFld = saTbl.Table.Fields.Field(saTbl.Table.FindField(YaxisFldName))

Dim gfxProps As IDataGraphProperties
79: Set gfxProps = datagfx
80: With gfxProps
81:     If gCht.lbx_Wtc.SelCount = 1 Then
82:     .title = saTblName & " " & YaxisFld.AliasName
83:     ElseIf gCht.lbx_Wtc.SelCount > 1 Then
        Dim title As String
85:         For i = 0 To gCht.lbx_Wtc.ListCount - 1
86:             If gCht.lbx_Wtc.Selected(i) Then
87:                 If title = "" Then
88:                     title = saTblName & " " & gCht.lbx_Wtc.List(i)
89:                 Else
90:                     title = title & "," & gCht.lbx_Wtc.List(i)
91:                 End If
92:             End If
93:         Next i
94:             .title = title
95:     End If
96:     .SubTitle = XaxisFld.AliasName
97:     If gCht.rbt_Lin Then
98:     .GraphType = esriDataGraphTypeLine
99:     .GraphSubtype = esriDataGraphSubtypeLine2DMarkers
100:     ElseIf gCht.rbt_Bar Then
101:     .GraphType = esriDataGraphTypeBar
102:     .GraphSubtype = esriDataGraphSubtypeColumn2DSimple
103:     End If
104:     .ShowDataLabels = True
105:     .ShowLegend = True
106:     .LegendPosition = esriDataGraphLegendPositionCR
107: End With

'Get "Class" field maximum value
Dim tblHist As ITableHistogram
111: Set tblHist = New TableHistogram
112: Set tblHist.Table = saTbl.Table
113: tblHist.Field = XaxisFldName
Dim istats As IStatisticsResults
115: Set istats = tblHist

Dim gfxAxis As IDataGraphAxis
118: Set gfxAxis = datagfx
119: With gfxAxis
120:     .XAxisMin = 0
121:     .XAxisMax = istats.Maximum ' Maximum class value
122:     .XAxisStyle = esriDataGraphAxisStyleUserDefined
123:     .YAxisStyle = esriDataGraphAxisStyleVariableOrigin
124: End With

Dim mxDoc As IMxDocument
127: Set mxDoc = SDMGlobals.SDMDoc
Dim gfxColl As IDataGraphs
129: Set gfxColl = mxDoc
130: gfxColl.Add datagfx

Dim gfxWin As IDataGraphWindow
133: Set gfxWin = New DataGraphWindow
134: Set gfxWin.DataGraph = datagfx
135: Set gfxWin.Application = SDMGlobals.SDMApp
136: gfxWin.PutPosition 100, 100, 800, 500
137: If Not gfxWin.IsVisible Then gfxWin.Show True
138: gfxWin.Refresh
139: gCht.ZOrder 0

141: For i = 0 To Forms.Count - 1
142:    If Forms(i).name = "gGen" Then
        Dim gGen As Form
144:         Set gGen = Forms(i)
145:         gGen.getEars.Update gGen.cbx_Cht
146:         Exit For
147:     End If
148: Next i


'<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
Exit Sub

ErrorHandler:
  HandleError True, "gSDI_MakeLineChart " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), Err.Number, Err.Source, Err.Description, 4
End Sub

