VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "gSDI_MakeQQPlot"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = True

                                                                                                                                                            Option Explicit
Const c_sModuleFileName As String = "gSDI_MakeQQPlot"
Const c_sDLLFileName As String = "SDMAccessories"       ' Constant reflect file module name
'Private ObjectTag As Object
'Property Set setObjectTag(anObject As Object)
'    Set ObjectTag = anObject
'End Property
'Property Get getObjectTag() As Object
'    Set getObjectTag = ObjectTag
'End Property

Function gSDI_MakeQQPlot(Self As Variant) As String
  On Error GoTo ErrorHandler
'14: MsgBox "Entering...", , c_sModuleFileName
'PUT THE IMPLEMENTATION HERE >>>>>>>>>>>>>
'' Name:  gSDI.MakeQQPlot
''
'' Topics:  Spatial Data Modeller
''
'' Description:  Drafts a quantile-quantile
''        plot in a stripped down view GUI.
''
''
'' Requires:
''
'' Self:  nada
''
'' Returns:  True when complete
''=============================================
'av.UseWaitCursor
'' Get arguments: 2 theme, field pairs, and list of values to plot
''----------------------------------------------
'
'tfPairs = Self.Get(0)
    Dim tfPairs As SDMList
37: Set tfPairs = Self(0)
    Dim tfPairArg As Variant
39: tfPairArg = tfPairs.GetVal(0)
'thm0 = tfPairs.Get(0).Get(0)
    Dim thm0 As IRasterLayer
42: Set thm0 = tfPairArg(0)
'fld0 = tfPairs.Get(0).Get(1)
    Dim fld0 As esrigeodatabase.IField
45: Set fld0 = tfPairArg(1)
46: tfPairArg = tfPairs.GetVal(1)
'thm1 = tfPairs.Get(1).Get(0)
    Dim thm1 As IRasterLayer
49: Set thm1 = tfPairArg(0)
'fld1 = tfPairs.Get(1).Get(1)
    Dim fld1 As esrigeodatabase.IField
52: Set fld1 = tfPairArg(1)
'lstVals0 = Self.Get(1).Get(0)
'lstVals1 = Self.Get(1).Get(1)
    Dim pTbl As ITable
56: Set pTbl = Self(1)
'r0 = (lstVals0.Get(lstVals0.Count - 1) - lstVals0.Get(0)).Abs
'r1 = (lstVals1.Get(lstVals1.Count - 1) - lstVals1.Get(0)).Abs
'n = lstVals0.Count
'' Sort both lists
''----------------------------------------------
'lstVals0.Sort (True)
'lstVals1.Sort (True)
' Get the gui, or create if not found
''----------------------------------------------
'guiQQPlot = av.Run("gSDI.GetQQGUI",{})
    Dim gSDIGetQQGUI As gSDI_GetQQGUI
68: Set gSDIGetQQGUI = New gSDI_GetQQGUI
    Dim guiQQPlot As IDataGraph
70: Set guiQQPlot = gSDIGetQQGUI.gSDI_GetQQGUI
'MsgBox "guiQQPlot is Nothing: " & (guiQQPlot Is Nothing), , c_sModuleFileName
'If (guiQQPlot = Nil) Then
'  guiQQPlot = av.GetProject.FindGUI("View")
'End
'docPlot = View.MakeWithGui(guiQQPlot.GetName)
'strPlot = av.Run("gSDI.GetNewDocName",{"Quantile-quantile Plot",guiQQPlot.GetName})
    Dim strPlot As IDataGraphProperties
78: Set strPlot = guiQQPlot
79: strPlot.GraphType = esriDataGraphTypeLine
80: strPlot.GraphSubtype = esriDataGraphSubtypeLine2DSimple
81: strPlot.ShowDataLabels = True
82: strPlot.ShowXAxisLabels = False
'docPlot.SetName (strPlot)
'docPlot.SetScaleVisible (False)
'docPlot.SetTOCWidth (0)
'docPlot.SetTOCUnResizable (True)
'lstPV0 = List.Make
'lstPV1 = List.Make
'' If number of elements in one list is less than
'' the other, make a new list of interpolated values
''----------------------------------------------
'
'If (lstVals0.Count <> lstVals1.Count) Then
'  If (lstVals0.Count < lstVals1.Count) Then
'    lstBig = lstVals1
'    lstSml = lstVals0
'  Else
'    lstBig = lstVals0
'    lstSml = lstVals1
'  End
'  lstNew = list.Make
'  r = lstBig.Count / lstSml.Count
'  for each i in 0..(lstSml.Count - 1)
'    'if ((v.Truncate < 0) or (v.Truncate > (lstBig.Count - 1))) then
'    If ((v.Truncate < 1) Or (v.Truncate > (lstBig.Count - 1))) Then
'      If (v.Truncate < 0) Then
'        lstSml.Remove (0)
'      ElseIf (v.Truncate > (lstBig.Count - 1)) Then
'        lstSml.Remove (lstSml.Count - 1)
'      End
'      Continue
'    Else
'      If (v.Truncate = v) Then
'        lstNew.Add (lstBig.Get(v))
'      Else
'        j = v.Truncate
'                    Dim j As Long
'        th = v - j
'                    Dim th As Double
'        If (j > -1) Then
'          nmbNew = (th * lstBig.Get(j - 1)) + (th * lstBig.Get(j))
'                         Dim nmbNew As Double
'          lstNew.Add (nmbNew)
'        Else
'          Continue
'        End
'      End
'    End
'  If (lstVals0.Count < lstVals1.Count) Then
'  Else
'  End

'Stretch scale so 1-1 plot has a 45-degree angle.
'
'If (r0 < r1) Then
'  chtShp = "taller"
'  min0 = lstVals0.Get(0) min 0
'  min1 = lstVals1.Get(0) min 0
'  'rangeRatio = (lstVals0.Get(lstVals0.Count - 1) - min0) / (lstVals1.Get(lstVals1.Count - 1) - min1)
'  rangeRatio = 1
'  For Each v In lstVals0
'    lstPV0.Add (v / (lstVals0.Get(lstVals0.Count - 1)))
'  End
'  For Each v In lstVals1
'    lstPV1.Add ((v * rangeRatio) / (lstVals1.Get(lstVals1.Count - 1)))
'  End
'ElseIf (r0 > r1) Then
'  chtShp = "wider"
'  min0 = lstVals0.Get(0) min 0
'  min1 = lstVals1.Get(1) min 1
'  'rangeRatio = (lstVals1.Get(lstVals1.Count - 1) - min0) / (lstVals0.Get(lstVals0.Count - 1) - min1)
'
'  rangeRatio = 1
'  For Each v In lstVals0
'    lstPV0.Add ((v * rangeRatio) / (lstVals0.Get(lstVals0.Count - 1)))
'  End
'  For Each v In lstVals1
'    lstPV1.Add (v / (lstVals1.Get(lstVals1.Count - 1)))
'  End
'Else
'  chtShp = "square"
'  min0 = lstVals0.Get(0) min 0
'  min1 = lstVals1.Get(0) min 0
'  rangeRatio = 1
'  For Each v In lstVals0
'    lstPV0.Add (v / (lstVals0.Get(lstVals0.Count - 1)))
'  End
'  For Each v In lstVals1
'    lstPV1.Add (v / (lstVals1.Get(lstVals1.Count - 1)))
'  End
'End
'' Make list of points to plot
''--------------------------------------------------
'lstPnts = List.Make
'for each i in 0..(lstPV0.Count - 1)
'  If (i < lstPV1.Count) Then
'    pnt = Point.Make(lstPV0.Get(i), lstPV1.Get(i))
'    lstPnts.Add (pnt)
'  End
'End
'MsgBox "pTbl is Nothing: " & (pTbl Is Nothing), , c_sModuleFileName
Dim brks1 As String, brks2 As String, brks3 As String
183: brks1 = pTbl.Fields.Field(pTbl.Fields.FindField("Breaks1")).AliasName
184: brks2 = pTbl.Fields.Field(pTbl.Fields.FindField("Breaks2")).AliasName
185: brks3 = pTbl.Fields.Field(pTbl.Fields.FindField("Breaks3")).AliasName
186: guiQQPlot.FieldSet1 = brks2 & "," & brks1
187: guiQQPlot.FieldSet2 = brks1 & "," & brks3
188: guiQQPlot.MaxDataPoints = pTbl.RowCount(Nothing)
189: guiQQPlot.SeriesByRecord = True
190: Set guiQQPlot.Table = pTbl
'For Each p In lstPnts
'  gPoint = GraphicShape.Make(p)
'  gPoint.GetSymbol.SetSize (4)
'  gPoint.GetSymbol.SetColor (Color.GetRed)
'  theGraphics = docPlot.GetGraphics
'  theGraphics.AddBatch (gPoint)
'End
'mx0 = lstPV0.Get(lstPV0.Count - 1)
'mx1 = lstPV1.Get(lstPV1.Count - 1)
'lblMx0 = lstVals0.Get(lstVals0.Count - 1)
'lblMx1 = lstVals1.Get(lstVals1.Count - 1)
'ratio = (mx0 Max mx1)
'theXAxis = Line.Make(min0@min1,mx0@min1)
204: strPlot.ShowXAxisLabels = True
'gLine = GraphicShape.Make(theXAxis)
'theGraphics.AddBatch (gLine)
'theYAxis = Line.Make(min0@min1,min0@mx1)
208: strPlot.ShowLegend = True
'gLine = GraphicShape.Make(theYAxis)
'theGraphics.AddBatch (gLine)
'xAxis2 = Line.Make(min0@mx1,mx0@mx1)
'gLine = GraphicShape.Make(xAxis2)
'theGraphics.AddBatch (gLine
'yAxis2 = Line.Make(mx0@min1,mx0@mx1)
'gLine = GraphicShape.Make(yAxis2)
'theGraphics.AddBatch (gLine)
'minMax = lblMx0 Min lblMx1
'mm0 = minMax / lblMx0
'mm1 = minMax / lblMx1
'maxMin = min0 Max min1
'linEq = Line.Make(maxMin@maxMin,mm0@mm1
'gLine = GraphicShape.Make(linEq)
'theGraphics.AddBatch (gLine)
'for each i in min0..mx0 by (mx0 / 10)
'  aTicX = Line.Make(i@min1,i@((min1 - 0.01) * ratio))
'  gLine = GraphicShape.Make(aTicX)
'  theGraphics.AddBatch (gLine)
'End
'for each i in min1..mx1 by (mx1 / 10)
'  aTicY = Line.Make(min0@i,((min0 - 0.01) * ratio)@i)
'  gLine = GraphicShape.Make(aTicY)
'  theGraphics.AddBatch (gLine)
'End
Dim guiQQPlotTicks As IDataGraphTicks
235: Set guiQQPlotTicks = guiQQPlot
236: guiQQPlotTicks.TickEvery = 1
237: guiQQPlotTicks.Ticks = esriDataGraphTicksXY
238: guiQQPlotTicks.TickStyle = esriDataGraphTickStyleInside
''tSym = TextSymbol.Make
''tSym.SetFont(Font.Make("Arial","normal"))
''tSym.SetSize(6)
''tSym.SetColor(Color.GetBlack)
''tList = List.Make
''tList.Add(tSym)
'symTxt = TextSymbol.Make
''symTxt.SetFont(Font.Make("Arial","normal"))
'symTxt.SetSize (11)
'symTxt.SetColor (Color.GetBlack)
'txtSet = List.Make
'txtSet.Add (symTxt)
'for each i in min0..mx0 by (mx0 / 5)
'  for each d in {1,10,100,1000,10000,100000,1000000,10000000,100000000,1000000000}
'    If (i = 0) The
'      lblI = 0
'    ElseIf (chtShp <> "wider") Then
'      lblI = (i * lblMx0)       '(i * lblMx0) / mx0
'    Else
'      lblI = (i * lblMx0) / rangeRatio
'    En
'    If (lblMx0 <= d) Then
'      rndI = (lblI * (100 / d)).Round / (100 / d)
'      Break
'    En
'  End
'  gt = GraphicText.Make(rndI.asString, Point.Make((i - (0.02 * ratio)), ((min1 - 0.05) * ratio)))
'  gt.SetSymbols (txtSet)
'  theGraphics.AddBatch (gt)
'End
'for each i in min1..mx1 by (mx1 / 5)
'  for each d in {1,10,100,1000,10000,100000,1000000,10000000,100000000,1000000000}
'    If (i = 0) Then
'      lblI = 0
'    ElseIf (chtShp <> "taller") Then
'      lblI = (i * lblMx1)     '(i * lblMx1) / mx1
'    Else
'      lblI = (i * lblMx1) / rangeRatio                  'i * lblMx1
'    End
'    If (lblMx1 <= d) Then
'      rndI = (lblI * (100 / d)).Round / (100 / d)
'      Brea
'    End
'  End
'  gt = GraphicText.Make(rndI.asString, Point.Make(((min0 - 0.07) * ratio), i - (0.01 * ratio)))
'  gt.SetSymbols (txtSet)
'  theGraphics.AddBatch (gt)
'End
'symLbl = TextSymbol.Make
'symLbl.SetSize (13)
'symLbl.SetColor (Color.GetBlack)
'lblSet = List.Make
'lblSet.Add (symLbl)
'strThm0 = ""
     Dim strThm0 As String
'ot = thm0.getObjectTag
     Dim ot As SDMUtilities.SDMList
296: Set ot = gC.ObjectTag(thm0.Name)
'If (ot.Is(List)) Then
298: If Not ot Is Nothing Then
'  If (ot.Count = 2) Then
300:     If ot.Count = 2 Then
'    If (ot.Get(0) = "fp") Then
302:         If ot.GetVal(0) = "fp" Then
'      strThm0 = ot.Get(1)
304:             strThm0 = CStr(ot.GetVal(1))
'    End
306:         End If
'  End
308:     End If
'End
310: End If
'If (strThm0 = "") Then
312: If strThm0 = "" Then
'  strThm0 = thm0.GetName
314:     strThm0 = thm0.Name
'End
316: End If
'If (fld0.GetName = "SourceVal") Then
318: If fld0.Name = "SourceVal" Then
'  lblXAxis = strThm0
         Dim lblXAxis As String
321:     lblXAxis = strThm0
'Else
323: Else
'  lblXAxis = strThm0 + ", " + fld0.GetAlias
325:     lblXAxis = strThm0 & "(" & fld0.AliasName & ")"
'End
327: End If
328: strPlot.SubTitle = lblXAxis

'lblXSpot = (mx0 + min0) / 2
'Offset = (lblXAxis.Count / 2) * 0.015
'gt = GraphicText.Make(lblXAxis, Point.Make(lblXSpot - (Offset * ratio), ((min1 - 0.15) * ratio)))
'gt.SetSymbols (lblSet)
'gt.SetName ("lbl")
'theGraphics.AddBatch (gt)
'strThm1 = ""
Dim strThm1 As String
'ot = thm1.getObjectTag
339: Set ot = gC.ObjectTag(thm1.Name)
'If (ot.Is(List)) Then
341:     If Not ot Is Nothing Then
'  If (ot.Count = 2) Then
343:         If ot.Count = 2 Then
'    If (ot.Get(0) = "fp") Then
345:             If ot.GetVal(0) = "fp" Then
'      strThm1 = ot.Get(1)
347:                 strThm1 = ot.GetVal(1)
'    End
349:             End If
'  End
351:         End If
'End
353:     End If
'If (strThm1 = "") Then
355: If strThm1 = "" Then
'  strThm1 = thm1.GetName
357:     strThm1 = thm1.Name
'End
359: End If
'If (fld1.GetName = "SourceVal") Then
361: If fld1.Name = "SourceVal" Then
'  lblYAxis = strThm1
         Dim lblYAxis As String
364:     lblYAxis = strThm1
'Else
366: Else
'  lblYAxis = strThm1 + ", " + fld1.GetAlias
368:     lblYAxis = strThm1 & "(" & fld1.AliasName & ")"
'End
370: End If
371: strPlot.Title = lblYAxis
'lblYSpot = (mx1 + min1) / 2
'Offset = (lblYAxis.Count / 2) * 0.015
'gt = GraphicText.Make(lblYAxis, Point.Make(((min0 - 0.15) * ratio), lblYSpot - (Offset * ratio)))
'gt.SetSymbols (lblSet)
'gt.SetAngle (90)
'gt.SetName ("lbl")
'theGraphics.AddBatch (gt)
'theGraphics.EndBatch
'theGraphics.Draw
Dim guiQQPlotAxis As IDataGraphAxis
382: Set guiQQPlotAxis = guiQQPlot
383: guiQQPlotAxis.XAxisStyle = esriDataGraphAxisStyleZeroOrigin
384: guiQQPlotAxis.YAxisStyle = esriDataGraphAxisStyleZeroOrigin
'av.Run("gSDI.ZoomFullExtent",{docPlot})
'theGraphics.Draw
'docPlot.Invalidate
'docPlot.SetOpenScript ("gSDI.QQPlot.Open")
'docPlot.SetUpdateScript ("gSDI.QQPlot.Update")
'docPlot.SetObjectTag({Nil,Nil,mx0,mx1}

'Associate the data graph with a data graph window
Dim pMxDoc As IMxDocument
Dim pDataGraphProperties As IDataGraphProperties
395: Set pDataGraphProperties = guiQQPlot
396: pDataGraphProperties.Title = "Quantile Breaks for Two Models" & vbCrLf & fld1.AliasName & "(Breaks2)"
397: If fld0.Name = "Value" Then
398: pDataGraphProperties.SubTitle = strThm0 & " " & fld0.AliasName & "(Breaks1)"
399: Else
400: pDataGraphProperties.SubTitle = fld0.AliasName & "(Breaks1)"
401: End If
402: pDataGraphProperties.ShowLegend = True
403: pDataGraphProperties.LegendPosition = esriDataGraphLegendPositionUC
404: pDataGraphProperties.ShowDataLabels = False
     Dim pGraphWindow As IDataGraphWindow

407: guiQQPlot.Name = "Quantile-Quantile Plot"
408: Set pGraphWindow = New DataGraphWindow
409: Set pGraphWindow.DataGraph = guiQQPlot
410: Set pGraphWindow.Application = New AppRef
411: pGraphWindow.Show True
412: pGraphWindow.Refresh

'Add the graph to the system
415: Set pMxDoc = SDMGlobals.SDMDoc
     Dim pDataGraphs As IDataGraphs
417: Set pDataGraphs = pMxDoc 'QI
418: pDataGraphs.Add guiQQPlot

'return strPlot
421: gSDI_MakeQQPlot = guiQQPlot.Name
'<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
Exit Function
ErrorHandler:
  HandleError True, c_sModuleFileName & " " & GetErrorLineNumberString(Erl), Err.Number, Err.Source, Err.Description, 4
426:     gSDI_MakeQQPlot = ""
End Function

Private Function min(a As Double, b As Double) As Double
430:     If a <= b Then
431:         min = a
432:     Else
433:         min = b
434:     End If
End Function

Private Function max(ByRef list As SDMList) As Double
438:         max = -1.79769313486231E+308
        Dim v As Variant
440:         For Each v In list.list
            Dim a As Double
442:             a = CDbl(v)
443:             If a >= max Then max = a
444:         Next v
End Function

