VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "gSDI_OnePntPerUa"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = True
Option Explicit
' Variables used by the Error handler function - DO NOT REMOVE
Const c_sModuleFileName As String = "gSDI_OnePntPerUa"       ' Constant reflect file module name
Const c_sDLLFileName As String = "AnalysisParameters"       ' Constant reflect file module name

Sub gSDI_OnePntPerUA(ByRef Self As Variant)

On Error GoTo ErrorHandler

'PUT THE IMPLEMENTATION HERE >>>>>>>>>>>>>
'Function gSDI_OnePntPerUA() As Variant
'' gSDI.OnePntPerUnitArea
''
'' Topics:  Spatial Data Modeller
''
'' Description:  "Thins" a set of points to
''          a density of one point per unit area.
''          Typically required for non-mineral
''          exploration models.
''
'' Requires:  The unit area be set under th
''          Analysis Parameters dialog and a
''          point feature theme to process.
''
'' Self:    'Thin' point theme... menu choice
''
'' Returns:  Nil
''==============================================

'Get Point Theme
Dim thmPnt As IFeatureLayer
'Set thmPnt = SDMGlobals.SDMUtil.FindLayerByName(self(0))
33: Set thmPnt = Self(0)
Dim CallingDlg As Form
35: Set CallingDlg = Self(1)
'' Verify active document is a view
''----------------------------------------------
'' Retrieve and verify the unit area
''----------------------------------------------
Dim ua As Double
41: ua = CDbl(gParam.txtUA.Text)

'If (Not ua.IsNumber) Then
'MsgBox.Error("The unit area parameters is specified incorrectly.","Parameter Error")
'Let gSDI_OnePntPerUA = Null
'Else
'ua = ua.AsNumber
'End If

'' Calculate the minimum allowable distance
'' between two points
''----------------------------------------------
'minDst = ((ua * 1000000) / 3.14) ^ 0.5
Dim minDst As Double
55: minDst = Sqr((ua * 1000000) / 3.14159)
'If (Not TypeOf self Is IAVList) Then
'' Get the list of point themes in the view
'' and if any are active, display the
'' the first active point theme by default
'' Prompt user to "select" theme
''----------------------------------------------
'' Prepare for calculations:
'' Get attribute table, and shape field (containing points)
'' Clear any current selection
'' initialize point list
''----------------------------------------------
Dim vtb As ITable
68: Set vtb = thmPnt
Dim fldShpidx As Long
70: fldShpidx = thmPnt.FeatureClass.FindField(thmPnt.FeatureClass.ShapeFieldName)
Dim bmSel As IFeatureSelection
72: Set bmSel = thmPnt
73: bmSel.Clear
74: Set bmSel.SelectionSet = CallingDlg.NoTPsIn
'lstPnt = Array()
Dim lstPnt As New SDMUtilities.SDMList
'bmSize = bmSel.GetSize
Dim bmSize As Long
79: bmSize = bmSel.SelectionSet.Count
'' Make list of points
'' calc possible maximum iterations
''----------------------------------------------
'sts = 0
'i = 0
Dim i As Long
86: i = 0
Dim gSDIPntDist As gSDI_PointDistance
88: Set gSDIPntDist = New gSDI_PointDistance
Dim oidlist() As Long
ReDim oidlist(bmSize)

Dim pStatusBar As esriSystem.IStatusBar
Dim pProgbar As IStepProgressor
121: Set pStatusBar = SDMGlobals.SDMStatusBar
122: Set pProgbar = pStatusBar.ProgressBar

ProgressAnimation.Show "Creating thinning list...."

'For Each r In vtb
Dim enmIDs As IEnumIDs
93: Set enmIDs = bmSel.SelectionSet.IDs
94: enmIDs.Reset
Dim oid As Long
96: oid = enmIDs.Next

97: While oid <> -1
         Dim row As irow
99:     Set row = vtb.GetRow(oid)
'lstPnt.Add (vtb.ReturnValue(fldShp, r))
         Dim aPnt As IPoint
102:     Set aPnt = row.Value(fldShpidx)
103:     lstPnt.Add aPnt
104:     oidlist(i) = oid
'sts = sts + i
'i = i + 1
107:     i = i + 1
108:     oid = enmIDs.Next
'NEXT
110: Wend
ProgressAnimation.Hide

'MsgBox lstPnt.Count, , "lstPnt"
'bmSel.ClearAll
113: bmSel.Clear
'first = True
Dim first As Boolean
116: first = True
's = 1

123: pProgbar.position = 1
124: pStatusBar.ShowProgressBar "Thinning...", 1, lstPnt.Count, 1, True
  
'i = 0
127: i = 0
'For Each p0 In lstPnt
Dim p0 As IPoint
Dim pidx As Long
131: For pidx = 0 To lstPnt.Count - 1
132:    Set p0 = lstPnt.getObj(pidx)
'av.SetStatus ((s / sts) * 100)
'' whatever, select the first point
''----------------------------------------------
'If (first) Then
137:    If first Then
'bmSel.Set (i)
139:        bmSel.SelectionSet.Add oidlist(i)
'i = i + 1
141:        i = i + 1
'first = False
143:        first = False
' GoTo Next1
145:        GoTo next1
'Else
147: Else
'OK = True
        Dim OK As Boolean
150:     OK = True
'FOR EACH j IN 0 TO (i-1)
        Dim j As Long
153:     For j = 0 To (i - 1)
'p1 = lstPnt.Get(j)
            Dim p1 As IPoint
156:        Set p1 = lstPnt.getObj(j)
's = s + 1
'If (bmSel.Get(j)) Then
159:        If (True) Then
'dst = av.Run("gSDI.PointDistance", Array(p0, p1))
                Dim dst As Double
162:            dst = gSDIPntDist.gSDI_PointDistance(Array(p0, p1))
'If (dst = Null) then
'
'Let gSDI_OnePntPerUA = Null
'
'End If
'
'If (dst < minDst) Then
170:            If (dst < minDst) Then
'OK = False
172:                OK = False
'Exit For
174:                Exit For
'End If
176:            End If
'End If
178:        End If
'Next
next2:  Next j
'If ((OK) And (i < bmSize)) Then
182:     If (OK And (i < bmSize)) Then
'bmSel.Set (i)
184:         bmSel.SelectionSet.Add oidlist(i)
'End If
186:     End If
'End If
188: End If
'i = i + 1
190: i = i + 1
's = s + 1
192:     pStatusBar.StepProgressBar
'NEXT
next1: Next pidx
195:   pStatusBar.HideProgressBar

'vtb.SetSelection (bmSel)
    Dim featSel As IFeatureSelection
199: Set featSel = thmPnt
200: Set featSel.SelectionSet = bmSel.SelectionSet
'vtb.UpdateSelection
202: featSel.SelectionChanged
    Dim mxdoc As IMxDocument
204: Set mxdoc = SDMGlobals.SDMDoc
205: mxdoc.ActiveView.Refresh
'av.ClearStatus
'
'End function
'<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
Exit Sub

ErrorHandler:
  HandleError True, c_sDLLFileName & " " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), Err.Number, Err.Source, Err.Description, 4
End Sub

