VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "gSDI_PRTMenuUpdate"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = True
Option Explicit
Const c_sModuleFileName As String = "gSDI_PRTMenuUpdate.cls"
Const c_sDLLFileName As String = "SDMAccessories"       ' Constant reflect file module name
'Private ObjectTag As Object
'Property Set setObjectTag(anObject As Object)
'    Set ObjectTag = anObject
'End Property
'Property Get getObjectTag() As Object
'    Set getObjectTag = ObjectTag
'End Property

Function gSDI_PRTMenuUpdate() As Boolean
  On Error GoTo ErrorHandler

'PUT THE IMPLEMENTATION HERE >>>>>>>>>>>>>
'' Name:  gSDI.PRTMenuUpdate
''
''Topics:  Spatial Data Modeller
''
''Description:  Updates the Associate Responses with Point Theme
''  menu item.  Enables if there is at least one
''  point theme and at least one response theme in the current
''  view.
''
''Requires:
''
'' Self:  Associate Resposne, etc., menu item
''
''Returns:
''==============================================
'Self.SetEnabled (False)
32: gSDI_PRTMenuUpdate = False
'theView = av.GetActiveDoc
'theThemes = theView.GetThemes
Dim pApp As IApplication
36: Set pApp = New AppRef
Dim pMxDoc As IMxDocument
38: Set pMxDoc = pApp.Document
If pMxDoc.FocusMap.LayerCount = 0 Then Exit Function
Dim theThemes As IEnumLayer
41: Set theThemes = pMxDoc.FocusMap.Layers
'pointFlag = False
Dim pointFlag As Boolean
44: pointFlag = False
'respFlag = False
Dim respFlag As Boolean
47: respFlag = False
'For Each t In theThemes
Dim t As ILayer
50: Set t = theThemes.Next
51: While (Not t Is Nothing)
'  If (t.Is(fTheme)) Then
53:     If t.Valid Then
54:       If TypeOf t Is IFeatureLayer Then
            Dim flayer As IFeatureLayer
56:         Set flayer = t
'    ShapeType = t.GetFTab.FindField("Shape").GetType
'    if (shapeType = #FIELD_SHAPEPOINT) then
59:         If flayer.FeatureClass.ShapeType = esriGeometryPoint Then pointFlag = True
'      pointFlag = True
'    End
'  ElseIf (t.Is(Gtheme)) Then
63:       ElseIf TypeOf t Is IRasterLayer Then
            Dim rlayer As IRasterLayer
65:         Set rlayer = t
'    If (t.GetGrid.IsInteger) Then
            Dim rasprops As IRasterProps
68:         Set rasprops = rlayer.Raster
69:         If rasprops.IsInteger Then
'      lstFldRsp = av.Run("gSDI.GetResponseFields",{t})
'      If (lstFldRsp.Is(List).Not) Then
'        Continue
'      ElseIf (lstFldRsp.IsEmpty) Then
'        Continue
'      Else
77:                     If SDMExtUtils.isJoined(rlayer) Then
'        respFlag = True
79:                     respFlag = True
'      End
81:                 End If
'    End
86:         End If
'  End
88:     End If
'  If ((pointFlag = True) And (respFlag = True)) Then
90:     If pointFlag And respFlag Then
'    Self.SetEnabled (True)
92:         gSDI_PRTMenuUpdate = True
'    Break
            Exit Function
'  End
96:     End If
'End
98:     End If
99:     Set t = theThemes.Next
100: Wend
'
'
'<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
Exit Function
ErrorHandler:
  HandleError True, c_sModuleFileName & " " & GetErrorLineNumberString(Erl), Err.Number, Err.Source, Err.Description, 4
End Function
