VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "gSDI_ReadDataTypes"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = True
Option Explicit
' Variables used by the Error handler function - DO NOT REMOVE
Const c_sModuleFileName As String = "gSDI_ReadDataTypes"       ' Constant reflect file module name
Const c_sDLLFileName As String = "CalcThemeWeights"       ' Constant reflect file module name

Sub gSDI_ReadDataTypes()

On Error GoTo ErrorHandler

'PUT THE IMPLEMENTATION HERE >>>>>>>>>>>>>
'' Name:  gSDI.ReadDataType
''
''Topics:  Spatial Data Modeller; Tables
''
''Description:  Reads from the 'Data Types of Weights Tables'
''  table to a dictionary that is held in a global
''  variable while Spatial Data Modeller is run
''
''Requires:
''
'' Self:  Empty list from gSDI.CalcThemeWts or gSDI.Help scripts
''
''Returns:
''==============================================
'
'strTab = "Data Types of Evidential Themes"
27: If SDMGlobals.SDMdataDict Is Nothing Then
28:     Set SDMGlobals.SDMdataDict = New SDMUtilities.SDMDictionary
29: End If
30: If (SDMGlobals.SDMUtil Is Nothing) Then
31:         Set SDMGlobals.SDMUtil = New SDMUtilities.SDMUtils
32: End If
33: Set SDMGlobals.SDMUtil.setAPP = SDMGlobals.SDMApp
    Dim strTab As String
35: strTab = SDMGlobals.SDMMap.Name & "_Data Types of Evidential Themes"
'woeThmsTab = av.FindDoc(strTab)
    Dim woeThmsTab As IStandaloneTable
38: Set woeThmsTab = SDMGlobals.SDMUtil.FindStandAloneTableByName(strTab)
'If (woeThmsTab = nil) Then
40: If (woeThmsTab Is Nothing) Then
'  _dataDict = Dictionary.Make(25)
42:     SDMGlobals.SDMdataDict.Clear
'  return nil
        Exit Sub
'ElseIf (woeThmsTab.Is(Table).Not) Then
'
'  _dataDict = Dictionary.Make(25)
'
'  return nil
'
'Else
52: Else
'  theVtab = woeThmsTab.GetVTab
        Dim theVTab As ITable
55:     Set theVTab = woeThmsTab.Table
'  emfield = theVtab.FindField("E_Theme")
        Dim emFieldidx As Long
58:     emFieldidx = theVTab.FindField("E_Theme")
'  DataField = theVtab.FindField("Data_Type")
        Dim dataFieldidx As Long
61:     dataFieldidx = theVTab.FindField("Data_Type")
'  If ((emfield = nil) Or (DataField = nil)) Then
63:     If (emFieldidx = -1 Or dataFieldidx = -1) Then
'    return nil
            Exit Sub
'  Else
67:     Else
'    _dataDict = Dictionary.Make(50)
69:         SDMGlobals.SDMdataDict.Clear
'    For Each record In theVtab
            Dim record As Long
72:         For record = 0 To theVTab.RowCount(Nothing) - 1
'      emap = theVtab.ReturnValue(emfield, record)
                Dim eMap As String
75:             eMap = Trim(theVTab.GetRow(record).Value(emFieldidx))
76:             If eMap = "" Then GoTo nextRec
''      theView = av.GetActiveDoc
''      if (theView.FindTheme(eMap) = Nil) then
''        continue
''      else
'        dType = theVtab.ReturnValue(DataField, record)
                Dim dType As String
83:             dType = Trim(theVTab.GetRow(record).Value(dataFieldidx))
84:             If dType = "" Then GoTo nextRec
'        _dataDict.Add(eMap,dType)
86:             If Not SDMGlobals.SDMdataDict.Exists(eMap) Then SDMGlobals.SDMdataDict.Add eMap, dType
''      end
'    End
nextRec:
90:         Next record
'  End
92:     End If
'End
94: End If

'<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
Exit Sub

ErrorHandler:
  HandleError True, c_sDLLFileName & " " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), Err.Number, Err.Source, Err.Description, 4
End Sub

