VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "gSDI_ReadMissingData"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = True
Option Explicit
' Variables used by the Error handler function - DO NOT REMOVE
Const c_sModuleFileName As String = "gSDI_ReadMissingData"       ' Constant reflect file module name
Const c_sDLLFileName As String = "CalcThemeWeights"       ' Constant reflect file module name

Sub gSDI_ReadMissingData()

On Error GoTo ErrorHandler

'PUT THE IMPLEMENTATION HERE >>>>>>>>>>>>>
'' gSDI.ReadMissingData
''
''Topics:  Spatial Data Modeller; Tables
''
''Description:  Reads from the 'Data Types of Weights Tables'
''  table to a dictionary that is held in a global
''  variable while Spatial Data Modeller is run
''
''Requires:
''
'' Self:  Empty list from gSDI.CalcThemeWts or gSDI.Help scripts
''
''Returns:
''==============================================
'
'strTab = "Data Types of Evidential Themes"
27: If (SDMGlobals.SDMUtil Is Nothing) Then
28:     Set SDMGlobals.SDMUtil = New SDMUtilities.SDMUtils
29: End If
30: Set SDMGlobals.SDMUtil.setAPP = SDMGlobals.SDMApp
    Dim strTab As String
32: strTab = SDMGlobals.SDMMap.Name & "_Data Types of Evidential Themes"
'woeThmsTab = av.FindDoc(strTab)
    Dim woeThmsTab As IStandaloneTable
35: Set woeThmsTab = SDMGlobals.SDMUtil.FindStandAloneTableByName(strTab)
'If (woeThmsTab = nil) Then
37: If (woeThmsTab Is Nothing) Then
'  _dataMD = Dictionary.Make(25)
39:     SDMGlobals.SDMdataMD.Clear
'  return nil
        Exit Sub
'ElseIf (woeThmsTab.Is(Table).Not) Then
'  _dataMD = Dictionary.Make(25)
'  return nil
'Else
46: Else
'  theVtab = woeThmsTab.GetVTab
        Dim theVTab As ITable
49:     Set theVTab = woeThmsTab.Table
'  emField = theVtab.FindField("E_Theme")
        Dim emFieldidx As Long
52:     emFieldidx = theVTab.FindField("E_Theme")
'  fldMD = theVtab.FindField("MissngData")
        Dim fldMDidx As Long
55:     fldMDidx = theVTab.FindField("MissngData")
'  If ((emField = nil) Or (fldMD = nil)) Then
57:     If (emFieldidx = -1 Or fldMDidx = -1) Then
'    return nil
            Exit Sub
'  Else
61:     Else
'    _dataMD = Dictionary.Make(50)
63:         SDMGlobals.SDMdataMD.Clear
'    For Each record In theVtab
            Dim iRec As Long
            Dim irow As irow
            Dim eMap As String
68:         For iRec = 0 To theVTab.RowCount(Nothing) - 1
69:             Set irow = theVTab.GetRow(iRec)
'      eMap = theVtab.ReturnValue(emField, record)
71:             eMap = Trim(irow.Value(emFieldidx))
''theView = av.GetActiveDoc
''      if (theView.FindTheme(eMap) = Nil) then
''        continue
'
''      else
'
'        missing = theVtab.ReturnValue(fldMD, record)
                Dim missing As Double
80:             missing = irow.Value(fldMDidx)
'        _dataMD.Add(eMap,missing)
82:             SDMGlobals.SDMdataMD.Add eMap, missing
''      end
'
'    End
86:         Next iRec
'  End
88:     End If
'End
90: End If
'
'<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
Exit Sub

ErrorHandler:
  HandleError True, c_sDLLFileName & " " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), Err.Number, Err.Source, Err.Description, 4
End Sub

