VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "gSDI_ReadNNResults"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = True
Option Explicit
Const c_sModuleFileName As String = "C:\MyJava\ARC-SDM\VBScripts\gSDI_ReadNNResults.cls"
Const c_sDLLFileName As String = "CalculateNeuralNetwork"       ' Constant reflect file module name
'Private ObjectTag As Object
'Property Set setObjectTag(anObject As Object)
'    Set ObjectTag = anObject
'End Property
'Property Get getObjectTag() As Object
'    Set getObjectTag = ObjectTag
'End Property

Sub gSDI_ReadNNResults()
  On Error GoTo ErrorHandler
14:   SDMGlobals.SetGlobals
' If Form1.isShiftdown Then
'    SDMGlobals.SDMHelp.gSDI_Help "sdmpram.htm#LINK"
'    Exit Sub
' End If

'PUT THE IMPLEMENTATION HERE >>>>>>>>>>>>>
'' Name:  gSDI.ReadNNResults
'
'' Topics:  Spatial Data Modeller
''
'' Description:  Reads the text file produced
''       by the logistic regression code and
''       writes a new dBase file in the
''       user specified location.  Adds this
''       dBase file to the project and joins
''       it to the unique conditions table.
''
'' Returns:
''==============================================
'If (System.IsShiftKeyDown) Then
'  docURL = "sdmnn5.htm#Read Results"
'  If (docURL.Count > 0) Then
'    av.Run("gSDI.Help", {docURL})
'  End
'  return Nil
'End
    Dim AnlParms As AnalysisParameters.AnlParams
42: Set AnlParms = New AnalysisParameters.AnlParams
'gP = av.FindDialog("gParam")
    Dim gParam As Form
45: Set gParam = AnlParms.gParamFrm
'rbn = gP.findByName("chkNNSup").IsSelected   ' RBFLN algorithm
    Dim rbn As Boolean
48: rbn = gParam.chkNNSup.Value = 1
'fc = gP.findByName("chkNNUns").IsSelected    ' fuzzy clustering algorithm
    Dim fc As Boolean
51: fc = gParam.chkNNUns.Value = 1
'' Set which values to read from DataXplore output
''------------------------------------------------
'fldP = False
    Dim fldP As Boolean
56: fldP = False
'X = True
    Dim X As Boolean
59: X = True
'fldFC = True
    Dim fldFC As Boolean
62: fldFC = True
'fldFM = True
    Dim fldFM As Boolean
65: fldFM = True
'dTitle = "Reading Neural Network Results"
    Dim dTitle As String
68: dTitle = "Reading Neural Network Results"
'chrSep = av.Run("gSDI.GetSeparatorChar",{})
    Dim chrSep As String
71: chrSep = "\"
'' Get active view and prompt user with lis
'' of potential unique conditions themes
''------------------------------------------------
'
'viewA = av.GetActiveDoc
77: Set SDMGlobals.SDMApp = New AppRef
    Dim pMxDoc As IMxDocument
79: Set pMxDoc = SDMGlobals.SDMApp.Document
    Dim viewA As IMap
81: Set viewA = pMxDoc.FocusMap
82: Set SDMGlobals.SDMMap = viewA
'If (viewA.Is(View).Not) Then
'  MsgBox.Error("The active document must be a view.",dTitle
'  return Nil
'End
'lstThmUC = av.Run("gSDI.GetUCThms",{viewA})
    Dim gSDIGetUCThms As gSDI_GetUCThms
89: Set gSDIGetUCThms = New gSDI_GetUCThms
    Dim lstThmUC As SDMUtilities.SDMList
91: Set lstThmUC = gSDIGetUCThms.gSDI_GetUCThms(viewA)
'92: lstThmUC.Add "sdmuc1"
'if (lstThmUC.Is(String)) then
'  MsgBox.Error(lstThmUC,dTitle)
'  return Nil
'ElseIf (lstThmUC.Is(List).Not) Then
'  return Nil
'ElseIf (lstThmUC.IsEmpty) Then
99: If lstThmUC.IsEmpty Then
'  MsgBox.Error("No unique condition grids were found in the active view.",dTitle)
101:    MsgBox "No unique condition grids were found in the active view.", , c_sModuleFileName
'  return Nil
        Exit Sub
'End
105: End If
'thmUC = MsgBox.List(lstThmUC, "Select a unique conditions theme:", dTitle)
     Dim thmUCName As String
108: thmUCName = ListDlg("Select a unique conditions theme:", lstThmUC)
     Dim thmUC As IRasterLayer
110: Set thmUC = WOETableUtils.FindLayerByName(thmUCName)
'If (thmUC = Nil) Then
     If thmUC Is Nothing Then Exit Sub
'  return Nil
'End
'vTabUC = av.Run("gSDI.GetVTab",{thmUC})
     Dim vTabUC As ITable
117: Set vTabUC = thmUC
'If (vTAbUC = Nil) Then
'  MsgBox.Error("Unable to read unique conditions attribute table.",dTitle)
'  return Nil
'End
'' Depending on NN options (RBFLN, Fuzzy Clustering) selected
'' in analysis parameters, prompt user for file name to read
''------------------------------------------------
''rbn = True; if RBFLN method selected in parameters
'If (rbn) Then
127: If rbn Then
'  fnRBN = FileDialog.Show("*.rbn", "RBFLN Classify result", "Result from RBFLN (Click Cancel to skip reading)")
         Dim fileDlg As CommonDialog
130:     Set fileDlg = FileDialog2.CommonDialog1
131:     fileDlg.DialogTitle = "Result from RBFLN (Click Cancel to skip reading)"
132:     fileDlg.InitDir = WOETableUtils.getProjectDir
133:     fileDlg.DefaultExt = "rbn"
134:     fileDlg.fileName = thmUCName & ".rbn"
135:     fileDlg.Filter = "RBFLN(DataXplore) (*.rbn)|*.rbn"
136:     fileDlg.CancelError = False
137:     fileDlg.Flags = cdlOFNReadOnly Or cdlOFNPathMustExist Or cdlOFNFileMustExist
138:     fileDlg.ShowOpen
         Dim fnRBNDX As String
140:     fnRBNDX = fileDlg.fileName
'  If (fnRBN = Nil) Then
         Dim rbndx As Boolean
143:     If (Len(fnRBNDX) = 0) Or (Not FileDialog.ExistsFilename(fnRBNDX)) Then
'    rbn = False
145:         rbndx = False
146:     Else
147:         rbndx = True
'  End
149:     End If
'End
         'Dim fileDlg As CommonDialog
151:     'Set fileDlg = FileDialog2.CommonDialog1
153:     fileDlg.DialogTitle = "Result from Probabilistic Neural Network(GeoXplore) (Click Cancel to skip reading)"
154:     fileDlg.InitDir = WOETableUtils.getProjectDir
155:     fileDlg.DefaultExt = "pnn"
156:     fileDlg.fileName = thmUCName & ".pnn"
157:     fileDlg.Filter = "RBFLN(GeoXplore) (*.pnn)|*.pnn"
158:     fileDlg.CancelError = False
159:     fileDlg.Flags = cdlOFNReadOnly Or cdlOFNPathMustExist Or cdlOFNFileMustExist
160:     fileDlg.ShowOpen
         Dim fnRBNGX As String
162:     fnRBNGX = fileDlg.fileName
'  If (fnRBN = Nil) Then
141:     Dim rbngx As Boolean
165:     If (Len(fnRBNGX) = 0) Or (Not FileDialog.ExistsFilename(fnRBNGX)) Then
'    rbn = False
167:         rbngx = False
168:     Else
169:         rbngx = True
'  End
171:     End If
'End
173: End If
'
''fc = True; if Fuzzy Clustering method selected in parameters
'If (fc) Then
177: If fc Then
         Dim fnFC As String
'  fnFC = FileDialog.Show("*.fuz", "Fuzzy Classify Result", "Result from Fuzzy Classification (Click Cancel to skip reading)")
180:     Set fileDlg = FileDialog2.CommonDialog1
181:     fileDlg.DialogTitle = "Result from Fuzzy Classification (Click Cancel to skip reading)"
182:     fileDlg.InitDir = WOETableUtils.getProjectDir
183:     fileDlg.fileName = thmUCName & ".fuz"
184:     fileDlg.DefaultExt = "fuz"
185:     fileDlg.Filter = "Fuzzy (*.fuz)|*.fuz"
186:     fileDlg.CancelError = False
187:     fileDlg.Flags = cdlOFNPathMustExist Or cdlOFNFileMustExist Or cdlOFNReadOnly
188:     fileDlg.ShowOpen
189:     fnFC = fileDlg.fileName
'  If (fnFC = Nil) Then
191:     If Len(fnFC) = 0 Or (Not FileDialog.ExistsFilename(fnFC)) Then
'    fc = False
193:         fc = False
'  End
195:     End If
'End
197: End If
'If ((rbn.Not) And (fc.Not)) Then
199: If (Not rbndx) And (Not rbngx) And (Not fc) Then
'  MsgBox.Error("No Neural Network results files to process.",dTitle)
201:     MsgBox "No Neural Network results files to process.", vbInformation, dTitle
'  return Nil
         Exit Sub
'End
205: End If
'' Open specified file(s)
''------------------------------------------------
'fRBN = Nil
'If (rbn) Then
210: If rbndx Then
'  fRBN = LineFile.Make(fnRBN,#FILE_PERM_READ)
         Dim fs As Object
213:     Set fs = CreateObject("Scripting.FilesystemObject")
         Dim fRBNDX As Object
215:     Set fRBNDX = fs.OpenTextFile(fnRBNDX, 1, False, 0)
216:     If fRBNDX Is Nothing Then
217:        MsgBox "Cannot find/open input file: " & fnRBNDX, vbCritical, c_sModuleFileName
            Exit Sub
219:     End If
'End
221: End If
222: If rbngx Then
'  fRBN = LineFile.Make(fnRBN,#FILE_PERM_READ)
         'Dim fs As Object
225:     Set fs = CreateObject("Scripting.FilesystemObject")
         Dim fRBNGX As Object
227:     Set fRBNGX = fs.OpenTextFile(fnRBNGX, 1, False, 0)
228:     If fRBNGX Is Nothing Then
229:        MsgBox "Cannot find/open input file: " & fnRBNGX, vbCritical, c_sModuleFileName
            Exit Sub
231:     End If
'End
233: End If
'fFC = Nil
'If (fc) Then
236: If fc Then
'  fFC = LineFile.Make(fnFC,#FILE_PERM_READ)
238:     Set fs = CreateObject("Scripting.FilesystemObject")
         Dim fFC As Object
240:     Set fFC = fs.OpenTextFile(fnFC, 1, False, 0)
241:     If fFC Is Nothing Then
242:        MsgBox "Cannot find/open input file: " & fnFC, vbCritical, c_sModuleFileName
            Exit Sub
244:     End If
'End
246: End If
'' Prompt user for new dBASE file name, and create for writing
''------------------------------------------------
'strNew = FileName.GetCWD.MakeTmp("nnrsltc", "dbf")
     Dim strNew As String
251: strNew = thmUC.Name & "_nnrsltc.dbf"
'fnNew = FileDialog.Put(strNew, "*.dbf", "Neural Network Output Table")
     Dim fnNew As Variant
254: fnNew = FileDialog.GetSaveFileName("Neural Network Output Table", FileDialog.getProjectDir, strNew)
'If (fnNew = Nil) Then
256: If IsEmpty(fnNew) Then
'  return Nil
        Exit Sub
'End
260: End If
'vTabNN = VTab.MakeNew(fnNew, dBase)
     Dim vTabNN As ITable
'lstFlds = List.Make
     Dim lstFlds As New Collection
'fldID = Field.Make("ID",#FIELD_LONG,6,0)
     Dim fldID As Variant
267: fldID = Array("ID", esriFieldTypeInteger, 6, 0, "", False)
'lstFlds.Add (fldID)
269: lstFlds.Add fldID
'If (rbn) Then
271: If rbn Then
'  If (fldP) Then
273:     If fldP Then
'    fldPtrn = Field.Make("RBFLNPatrn",#FIELD_LONG,4,0)
             Dim fldPtrn As Variant
276:         fldPtrn = Array("RBFLNPatrn", esriFieldTypeInteger, 4, 0, "RBFLN Pattern", False)
'    fldPtrn.SetAlias ("RBFLN Pattern")
'    lstFlds.Add (fldPtrn)
279:         lstFlds.Add fldPtrn
'  End
281:     End If
'  If (X) Then
283:      If rbndx Then
'    fldMshp = Field.Make("RBFLNMmshp",#FIELD_DECIMAL,10,6)
             Dim fldMshp1 As Variant
286:         fldMshp1 = Array("RBFLN", esriFieldTypeDouble, 10, 6, "RBFLN DataXplore Pattern Membership", False)
'    fldMshp.SetAlias ("RBFLN Pattern Membership")
'    lstFlds.Add (fldMshp)
289:         lstFlds.Add fldMshp1
'  End
291:      End If
292:      If rbngx Then
             Dim fldMshp2 As Variant
294:         fldMshp2 = Array("PNN", esriFieldTypeDouble, 10, 6, "RBFLN GeoXplore Pattern Membership", False)
295:         lstFlds.Add fldMshp2
296:     End If
'End
298: End If
'If (fc) Then
300: If fc Then
'  If (fldFC) Then
302:     If fldFC Then
'    fldFClst = Field.Make("FzzyClstr",#FIELD_LONG,4,0)
            Dim fldFClst As Variant
305:         fldFClst = Array("FzzyClstr", esriFieldTypeInteger, 4, 0, "Fuzzy Cluster", False)
'    fldFClst.SetAlias ("Fuzzy Cluster")
'    lstFlds.Add (fldFClst)
308:         lstFlds.Add fldFClst
'  End
310:     End If
'End
312: End If
'vTabNN.AddFields (lstFlds)
314: Set vTabNN = WOETableUtils.CreateTable(CStr(fnNew(0)), CStr(fnNew(1)), lstFlds, CBool(fnNew(2)))
315: WOETableUtils.AddTable CStr(fnNew(1)), CStr(fnNew(0)), SDMGlobals.SDMApp
316: WOETableUtils.SetAliases FileDialog.GetBaseName(CStr(fnNew(0))), lstFlds
317: If Not IsEmpty(fldID) Then fldID = vTabNN.FindField(fldID(0))
318: If Not IsEmpty(fldPtrn) Then fldPtrn = vTabNN.FindField(fldPtrn(0))
319: If Not IsEmpty(fldMshp1) Then fldMshp1 = vTabNN.FindField(fldMshp1(0))
320: If Not IsEmpty(fldMshp2) Then fldMshp2 = vTabNN.FindField(fldMshp2(0))
321: If Not IsEmpty(fldFClst) Then fldFClst = vTabNN.FindField(fldFClst(0))
'' Read each record of the input files and
'' write results to the new dBASE file
''------------------------------------------------
'If (rbn) Then
326: If rbndx Then
'  strLn0 = fRBN.ReadElt
        Dim strLn01 As String
329:     strLn01 = fRBNDX.ReadLine
'Else
331: Else
'  strLn0 = Nil
333:     strLn01 = ""
'End
335: End If
336: If rbngx Then
'  strLn0 = fRBN.ReadElt
        Dim strLn02 As String
339:     strLn02 = fRBNGX.ReadLine
'Else
341: Else
'  strLn0 = Nil
343:     strLn02 = ""
'End
345: End If
'If (fc) Then
347: If fc Then
'  strLn1 = fFC.ReadElt
        Dim strLn1 As String
350:     strLn1 = fFC.ReadLine
'Else
352: Else
'  strLn1 = Nil
354:     strLn1 = ""
'End
356: End If
'ndflds = True
Dim ndflds As Boolean
359: ndflds = True
'kluge to insert fields before CreateRow method is called
361: If fldFM And ndflds Then
         Dim lstLn1 As Variant
363:     lstLn1 = Split(strLn1, ",")
'            nmbFld = lstLn1.Count - 2
         Dim nmbFld As Long
366:     nmbFld = UBound(lstLn1) + 1 - 2
'            lstFld = List.Make
         Dim lstFld As SDMUtilities.SDMList
369:     Set lstFld = New SDMUtilities.SDMList
'            for each i in 1..nmbFld
         Dim i As Long
372:     For i = 1 To nmbFld
'              f = Field.Make("Pat" + i.AsString,#FIELD_DECIMAL,10,6)
            Dim f As Variant
375:        f = Array("Pat" & i, esriFieldTypeDouble, 10, 6, "Pattern " & i, False)
'              f.SetAlias ("Pattern " + i.AsString)
'              lstFld.Add (f)
378:        lstFld.Add f
'            End
380:      Next i
'            vTabNN.AddFields (lstFld)
382:      WOETableUtils.AddFields vTabNN, lstFld
383:      WOETableUtils.SetAliases FileDialog.GetBaseName(CStr(fnNew(0))), lstFld.list
'            ndflds = False
385:      ndflds = False
'          End
387: End If
'av.ShowMsg ("Reading neural network files...")
     Dim pWorkspaceFactory As IWorkspaceFactory
     Dim pWorkspace As IWorkspace
 
392:  Set pWorkspaceFactory = New ShapefileWorkspaceFactory
393:  Set pWorkspace = pWorkspaceFactory.OpenFromFile(CStr(fnNew(1)), 0)

     Dim pWorkspaceEdit As IWorkspaceEdit
396: Set pWorkspaceEdit = pWorkspace

398: pWorkspaceEdit.startEditing False
399: pWorkspaceEdit.StartEditOperation
'ID = 1
     Dim ID As Long
402: ID = 1
'While ((strLn0 <> Nil) Or (strLn1 <> Nil))
     Dim boolfFc As Boolean
405: If Not fFC Is Nothing Then boolfFc = Not fFC.AtEndOfStream Else boolfFc = False
     Dim boolfRBNDX As Boolean
407: If Not fRBNDX Is Nothing Then boolfRBNDX = Not fRBNDX.AtEndOfStream Else boolfRBNDX = False
     Dim boolfRBNGX As Boolean
409: If Not fRBNGX Is Nothing Then boolfRBNGX = Not fRBNGX.AtEndOfStream Else boolfRBNGX = False
410: ProgressAnimation.Show "Processing neural network files..."
411: While boolfRBNDX Or boolfRBNGX Or boolfFc
'  If (strLn1 <> Nil) Then
413:     If strLn1 <> "" Then
            Dim tokens As Variant
415:         tokens = Split(strLn1, ",")
'    If (strLn1.AsTokens(",").Count < 3) Then
417:         If UBound(tokens) < 2 Then
'      strLn1 = Nil
419:             strLn1 = ""
'      Continue
421:             GoTo Wend1
'    End
423:         End If
'  End
425:     End If

'  av.UseWaitCursor
'  r = vTabNN.AddRecord
         Dim r As IRow
430:     Set r = vTabNN.CreateRow
'  'if (strLn0 <> Nil) then
''    lstLine = strLn0.AsTokens(",")
''    id = lstLine.Get(0).Trim
''    if (id.IsNumber.Not) then
''      MsgBox.Error("Error reading file " + fnRBN.AsString + ".",dTitle)
''      fRBN.Close
''      if (fc) then
''        fFC.Close
''      end
''      return Nil
''    else
''      id = id.AsNumber
''      vTabNN.SetValue(fldID,r,id)
''    end
''  elseif (strLn1 <> Nil) the
''    lstLine = strLn1.AsTokens(",")
''
''
''    id = lstLine.Get(0).Trim
''    if (id.IsNumber.Not) then
''      MsgBox.Error("Error reading file " + fnFC.AsString + ".",dTitle)
''      fFC.Close
''      if (rbn) then
''        fRBN.Close
''      end
''      return Nil
''    else
''      id = id.AsNumber
''      vTabNN.SetValue(fldID,r,id)
''    end
''
''  else
''    break
''  end
'  vTabNN.SetValue(fldID,r,id)
466:     r.Value(fldID) = ID
'  If ((rbn) And (strLn0 <> Nil)) Then
468:     If rbndx And (Len(strLn01) <> 0) Then
             Dim lstLn01 As Variant
470:         lstLn01 = Split(strLn01, ",")
471:         If fldP Then
472:             If UBound(lstLn01) < 1 Then
473:             Else
                     Dim ptrn As Variant
475:                 ptrn = Trim(CStr(lstLn01(1)))
476:                 If Not IsNumeric(ptrn) Then
477:                      gSDI_ErrorReadingFile Array(fRBNDX, fnRBNDX, Array(fFC), dTitle)
                          Exit Sub
479:                 Else
480:                     ptrn = CDbl(ptrn)
'          vTabNN.SetValue(fldPtrn,r,ptrn)
482:                     r.Value(fldPtrn) = ptrn
'        End
484:                 End If
'      End
486:             End If
'    End
488:         End If
'    If (X = True) Then
490:         If X Then
'      If (lstLn0.Count < 3) Then
492:             If UBound(lstLn01) < 2 Then
''          av.Run("gSDI.ErrorReadingFile",{fRBN,{fFC},dTitle})
''          return Nil
'      Else
496:             Else
'        mshp = lstLn0.Get(2).Trim
                     Dim mshp As Variant
499:                 mshp = Trim(lstLn01(2))
'        If (mshp.IsNumber.Not) Then
501:                 If Not IsNumeric(mshp) Then
'          av.Run("gSDI.ErrorReadingFile",{fRBN,{fFC},dTitle})
503:                      gSDI_ErrorReadingFile Array(fRBNDX, fnRBNDX, Array(fFC), dTitle)
'          return Nil
                         Exit Sub
'        Else
507:                 Else
'          mshp = mshp.AsNumber
509:                     mshp = CDbl(mshp)
'          vTabNN.SetValue(fldMshp,r,mshp)
511:                     r.Value(fldMshp1) = mshp
'        End
513:                 End If
'      End
515:             End If
'    End
517:         End If
'  End
519:     End If 'rbndx at :462
520:     If rbngx And (Len(strLn02) <> 0) Then
            Dim lstLn02 As Variant
522:        lstLn02 = Split(strLn02, ",")
523:         If fldP Then
'      If (lstLn0.Count < 2) Then
525:             If UBound(lstLn02) < 1 Then
'      Else
527:             Else
'        ptrn = lstLn0.Get(1).Trim
'
                     'Dim ptrn As Variant
531:                 ptrn = Trim(CStr(lstLn02(1)))
'        If (ptrn.IsNumber.Not) Then
533:                 If Not IsNumeric(ptrn) Then
'          av.Run("gSDI.ErrorReadingFile",{fRBN,{fFC},dTitle})
535:                      gSDI_ErrorReadingFile Array(fRBNGX, fnRBNGX, Array(fFC), dTitle)
'          return Nil
                          Exit Sub
'        Else
539:                 Else
'          ptrn = ptrn.AsNumber
541:                     ptrn = CDbl(ptrn)
'          vTabNN.SetValue(fldPtrn,r,ptrn)
543:                     r.Value(fldPtrn) = ptrn
'        End
545:                 End If
'      End
547:             End If
'    End
549:         End If
'    If (X = True) Then
551:         If X Then
'      If (lstLn0.Count < 3) Then
553:             If UBound(lstLn02) < 2 Then
''          av.Run("gSDI.ErrorReadingFile",{fRBN,{fFC},dTitle})
''          return Nil
'      Else
557:             Else
'        mshp = lstLn0.Get(2).Trim
                     Dim mshp2 As Variant
560:                 mshp2 = Trim(lstLn02(2))
'        If (mshp.IsNumber.Not) Then
562:                 If Not IsNumeric(mshp2) Then
'          av.Run("gSDI.ErrorReadingFile",{fRBN,{fFC},dTitle})
564:                      gSDI_ErrorReadingFile Array(fRBNGX, fnRBNGX, Array(fFC), dTitle)
'          return Nil
                          Exit Sub
'        Else
568:                 Else
'          mshp = mshp.AsNumber
570:                     mshp = CDbl(mshp2)
'          vTabNN.SetValue(fldMshp,r,mshp)
572:                     r.Value(fldMshp2) = mshp2
'        End
574:                 End If
'      End
576:             End If
'    End
578:         End If
'  End
580:     End If 'rbngx as :514
'  If ((fc) And (strLn1 <> Nil)) Then
582:     If fc And (strLn1 <> "") Then
'    lstLn1 = strLn1.AsTokens(",")
             'Dim lstLn1 As Variant
585:         lstLn1 = Split(strLn1, ",")
'    If (lstLn1.Count > 2) Then
587:         If UBound(lstLn1) > 1 Then
'      If (fldFC) Then
589:             If fldFC Then
'        If (lstLn1.Count < 2) Then
591:                 If UBound(lstLn1) < 1 Then
'  '          av.Run("gSDI.ErrorReadingFile",{fFC,{fRBN},dTitle})
593:                    gSDI_ErrorReadingFile Array(fFC, fnFC, Array(fRBNDX), dTitle)
'  '          return Nil
                        Exit Sub
'        Else
597:                 Else
'          fcVal = lstLn1.Get(1).Trim
                        Dim fcVal As Variant
600:                     fcVal = Trim(CStr(lstLn1(1)))
'          If (fcVal.IsNumber.Not) Then
602:                     If Not IsNumeric(fcVal) Then
'            av.Run("gSDI.ErrorReadingFile",{fFC,{fRBN},dTitle})
604:                         gSDI_ErrorReadingFile Array(fFC, fnFC, Array(fRBNDX), dTitle)
'            return Nil
                            Exit Sub
'          Else
608:                     Else
'            fcVal = fcVal.AsNumber
610:                         fcVal = CDbl(fcVal)
'            vTabNN.SetValue(fldFClst,r,fcVal)
612:                         r.Value(fldFClst) = fcVal
'          End
614:                     End If
'        End
616:                 End If
'      End
618:             End If
'      If (fldFM) Then
620:             If fldFM Then
'        If (lstLn1.Count < 3) Then
622:                 If UBound(lstLn1) < 2 Then
'  '          av.Run("gSDI.ErrorReadingFile",{fFC,{fRBN},dTitle})
624:                      gSDI_ErrorReadingFile Array(fFC, fnFC, Array(fRBNDX), dTitle)
'  '          return Nil
                          Exit Sub
'        Else
628:                 Else
'>>>>> Cannot work here in the conversion to ArcObjects
'>>>>> Moved to after other fields are created above
'          If (ndflds) Then
'''''510:                    If ndflds Then
''''''            '
''''''            nmbFld = lstLn1.Count - 2
'''''                            Dim nmbFld As Long
'''''484:                         nmbFld = UBound(lstLn1) + 1 - 2
''''''            lstFld = List.Make
'''''                            Dim lstFld As SDMUtilities.SDMList
'''''487:                         Set lstFld = New SDMUtilities.SDMList
''''''            for each i in 1..nmbFld
'''''                            Dim i As Long
'''''490:                         For i = 1 To nmbFld
''''''              f = Field.Make("Pat" + i.AsString,#FIELD_DECIMAL,10,6)
'''''                                 Dim f As Variant
'''''493:                             f = Array("Pat" & i, esriFieldTypeDouble, 10, 6, "Pattern " & i, False)
''''''              f.SetAlias ("Pattern " + i.AsString)
''''''              lstFld.Add (f)
'''''496:                             lstFld.Add f
''''''            End
'''''498:                         Next i
''''''            vTabNN.AddFields (lstFld)
'''''500:                         WOETableUtils.AddFields vTabNN, lstFld
''''''            ndflds = False
'''''502:                         ndflds = False
'''''          End
'''''504:                     End If
'End of Cannot work here...
'
'          for each i in 2..(lstLn1.Count - 1)
660:                     For i = 2 To UBound(lstLn1)
'            fcMshp = lstLn1.Get(i).Trim
                            Dim fcMshp As Variant
663:                         fcMshp = Trim(CStr(lstLn1(i)))
'            If (fcMshp.IsNumber.Not) Then
665:                         If Not IsNumeric(fcMshp) Then
'              av.Run("gSDI.ErrorReadingFile",{fFC,{fRBN},dTitle})
667:                             gSDI_ErrorReadingFile Array(fFC, fnFC, Array(fRBNDX), dTitle)
'              return Nil
                                Exit Sub
'            Else
671:                         Else
'              fcMshp = fcMshp.AsNumber
'              '
'              fldPtn = vTabNN.FindField("Pat" + (i - 1).AsString)
                                 Dim fldPtn As Long
676:                             fldPtn = r.Fields.FindField("Pat" & (i - 1))
'              If (fldPtn <> Nil) Then
678:                             If fldPtn <> -1 Then
'                vTabNN.SetValue(fldPtn,r,fcMshp)
680:                                r.Value(fldPtn) = CDbl(fcMshp)
'              End
682:                             End If
'            End
684:                         End If
'          End
686:                     Next i
'        End
688:                 End If
'      End
690:             End If
'    End
692:         End If
'  End
694:     End If
'
'  If (strLn0 <> Nil) Then
697:     If Not fRBNDX Is Nothing Then boolfRBNDX = Not fRBNDX.AtEndOfStream Else boolfRBNDX = False
698:     If boolfRBNDX Then
'    strLn0 = fRBN.ReadElt
700:         strLn01 = fRBNDX.ReadLine
'    If (strLn0 <> Nil) Then
702:         If strLn01 <> "" Then
'      If (strLn0.AsTokens(",").Count < 2) Then
704:             If UBound(Split(strLn01, ",")) < 1 Then
'        strLn0 = Nil
706:                 strLn01 = ""
'      End
708:             End If
'    End
710:         End If
'  End
712:     End If
'
'  If (strLn0 <> Nil) Then
715:     If Not fRBNGX Is Nothing Then boolfRBNGX = Not fRBNGX.AtEndOfStream Else boolfRBNGX = False
716:     If boolfRBNGX Then
'    strLn0 = fRBN.ReadElt
718:         strLn02 = fRBNGX.ReadLine
'    If (strLn0 <> Nil) Then
720:         If strLn02 <> "" Then
'      If (strLn0.AsTokens(",").Count < 2) Then
722:             If UBound(Split(strLn02, ",")) < 1 Then
'        strLn0 = Nil
724:                 strLn02 = ""
'      End
726:             End If
'    End
728:         End If
'  End
730:     End If
'
'  If (strLn1 <> Nil) Then
733:       If Not fFC Is Nothing Then boolfFc = Not fFC.AtEndOfStream Else boolfFc = False
734:     If boolfFc Then
'  '    strLn1 = fFC.ReadElt
736:         strLn1 = fFC.ReadLine
'    If (strLn1 <> Nil) Then
738:         If strLn1 <> "" Then
'      If (strLn1.AsTokens(",").Count < 2) Then
            'Dim tokens As Variant
741:             tokens = Split(strLn1, ",")
742:             If UBound(tokens) < 1 Then
'        strLn1 = Nil
744:                 strLn1 = ""
'      End
746:             End If
'    End
748:         End If
'  End
750:     End If
'  ID = ID + 1
752:     ID = ID + 1
'End
754:     r.Store
Wend1: Wend
756: ProgressAnimation.Hide
'If (fRBN <> Nil) Then
'
'  fRBN.Close
760:     If Not fRBNDX Is Nothing Then fRBNDX.Close
761:     If Not fRBNGX Is Nothing Then fRBNGX.Close
'End
'
'If (fFC <> Nil) Then
'
'  fFC.Close
767:     If Not fFC Is Nothing Then fFC.Close
'End
'
'vTabNN.SetEditable (False)
771:   pWorkspaceEdit.StopEditOperation
772:   pWorkspaceEdit.stopEditing True
'vTabNN.Flush
'vTabNN.Refresh
'av.ClearMsg
776:   SDMGlobals.SDMStatusBar.Message(0) = ""
'' Make a table document from the dBASE file
'' and join it to the unique conditions table
''------------------------------------------------
'
'Join Area Table to UC layer first
     Dim areaSATbl As IStandaloneTable
783: Set areaSATbl = WOETableUtils.FindStandAloneTableByName(thmUC.Name & "_Tbl", SDMGlobals.SDMMap)
784: If Not areaSATbl Is Nothing Then _
        If Not WOETableUtils.isJoined(thmUC, areaSATbl) Then _
            WOETableUtils.joinTableToLayer thmUC, "Value", areaSATbl, "Value"
            
'tabNN = Table.Make(vTabNN)
Dim pdataSet As IDataset
790: Set pdataSet = vTabNN
Dim tabNN As IStandaloneTable
792: Set tabNN = WOETableUtils.FindStandAloneTableByName(pdataSet.Name, SDMGlobals.SDMMap)
'cmtsNN = "Generated by: Arc-SDM - Read Neural Network Results" + NL +
'         "Source: " + vTabNN.GetBaseTableFilename.GetFullName + NL +
'         NL + "Associated Files: " + NL +
'         "    Unique Conditions Theme: " + thmUC.GetName + " (Source: " + thmUC.GetSrcName.GetFileName.GetFullName + ")" + NL
'tabNN.SetComments (cmtsNN)
'tabNN.SetName(av.Run("gSDI.GetNewDocName",{"Neural Network","Table"}))
'mnuSDM = av.Run("gSDI.GetSDMMEnu",{})
'If (mnuSDM.Is(Menu)) Then
'  Comments = mnuSDM.GetTag
'  comments = comments + NL + "Associated Files: " + NL +
'             "    Neural Network Results" + NL + vTabNN.GetName + " (Source: " + vTabNN.GetBaseTableFilename.GetFullName + ")" + NL
'  mnuSDM.SetTag (Comments)
'End
'vTabUC.Join(vTAbUC.GetFields.Get(0),vTabNN,vTabNN.FindField("ID"))
807: WOETableUtils.joinTableToLayer thmUC, "Value", tabNN, "ID"

'' Classify and symbolize the unique conditions theme
''-----------------------------------------
'thmUC = av.Run("gSDI.SR1",{thmUC})
812: MsgBox "Unique Conditions theme " & thmUC.Name & " can now be symbolized(classify).", vbInformation, c_sModuleFileName
'If (thmUC = Nil) Then
'  return Nil
'End
'indx = 0

'theThemes = viewA.GetThemes
'For Each t In theThemes
'  If (t.Is(FTheme)) Then
'    ShapeType = t.GetFTab.FindField("Shape").GetType
'    if (shapetype = #FIELD_SHAPEPOINT) then
'      indx = theThemes.Find(t)
'    End
'  End
'End
'theThemes.Shuffle(thmUC,(indx + 1))
'viewA.InvalidateTOC (Nil)
'return Nil
'<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
Exit Sub
ErrorHandler:
  HandleError True, c_sModuleFileName & " " & GetErrorLineNumberString(Erl), Err.Number, Err.Source, Err.Description, 4
End Sub
Private Function ListDlg(msg As String, ByRef pList As SDMUtilities.SDMList) As String
  On Error GoTo ErrorHandler

838:    ListDlg = ""
        If pList.IsEmpty Then Exit Function
        Dim pListdlg As IListDialog
841:    Set pListdlg = New ListDialog
        Dim boolOK As Boolean
        Dim var As Variant
844:    For Each var In pList.list
845:     pListdlg.AddString CStr(var)
846:    Next var
847:     boolOK = pListdlg.DoModal(msg, 0, 0)
848:    If boolOK Then
849:     ListDlg = pList.GetVal(pListdlg.Choice)
850:    Else
851:     ListDlg = ""
852:    End If


  Exit Function
ErrorHandler:
  HandleError False, "ListDlg " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), Err.Number, Err.Source, Err.Description, 4
End Function

Private Sub gSDI_ErrorReadingFile(Self As Variant)

'fMain = Self.Get(0)
     Dim fMain As Object
864: fMain = Self(0)
'lstFlOther = Self.Get(1)
     Dim lstFlOther As Variant
867: lstFlOther = Self(2)
'ttl = Self.Get(2)
     Dim ttl As String
870: ttl = Self(3)
'MsgBox.Error("Error reading file " + fMain.GetName + ".",ttl)
872: MsgBox "Error reading file " & Self(1) & ".", vbCritical, ttl
'fMain.Close
874: If Not fMain Is Nothing Then fMain.Close
'For Each f In lstFlOther
    Dim f As Variant
877: For Each f In lstFlOther
'  If (f.Is(File)) Then
879:     If TypeOf f Is Object  Then If Not f Is Nothing Then f.Close
'    f.Close
'  End
'End
883: Next f

End Sub


