VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "gSDI_RestoreParams"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = True
Option Explicit
Const c_sModuleFileName As String = "C:\MyJava\ARC-SDM\VBScripts\gSDI_RestoreParameters.cls"
Const c_sDLLFileName As String = "AnalysisParameters"       ' Constant reflect file module name
'Private ObjectTag As Object
'Property Set setObjectTag(anObject As Object)
'    Set ObjectTag = anObject
'End Property
'Property Get getObjectTag() As Object
'    Set getObjectTag = ObjectTag
'End Property

Sub gSDI_RestoreParameters()

On Error GoTo ErrorHandler

'PUT THE IMPLEMENTATION HERE >>>>>>>>>>>>>
'Get project directory as document folder name
Dim ProjectDir As String
Dim pTemplates As ITemplates
Dim lTempCount As Long
21: Set pTemplates = SDMGlobals.SDMApp.Templates
22: lTempCount = pTemplates.Count
    ' The document is always the last item
24: ProjectDir = pTemplates.Item(lTempCount - 1)
Dim fs As Object
26: Set fs = CreateObject("Scripting.FileSystemObject")
27: ProjectDir = fs.getParentFolderName(ProjectDir)
'Get name of active dataframe
Dim dataFrmName As String
30: dataFrmName = SDMUtil.getMap.Name
'Make Parameters file name
Dim parmsFileName As String
'33: parmsFileName = fs.buildpath(ProjectDir, dataFrmName & "_AnalysisParameters.txt")
34: parmsFileName = GetRestoreName()

Dim textStrm As Object
37: If fs.fileexists(parmsFileName) Then
38:     Set textStrm = fs.openTextFile(parmsFileName, 1)
        Dim parmsDict As SDMUtilities.SDMDictionary
40:     Set parmsDict = SDMGlobals.SDMParmsDict
41:     While Not textStrm.atendofstream
            Dim tokens As Variant
43:         tokens = Split(textStrm.readline, "=")
44:         parmsDict.Add tokens(0), Trim(tokens(1))
45:     Wend
46: Else
'       MsgBox parmsFileName & " not found", , c_sModuleFileName
        Exit Sub
49: End If
'gParam.chkWofE.Value = getSDMSetting("SDMExtension", SDMGlobals.SDMUtil.getMap.Name & "_AnalysisParameters", "chkWofE", 0)
51: gParam.chkWofE.Value = getSDMSetting(parmsDict, "chkWofE", 0)
52: If (gParam.cbxTP.ListCount > 0) Then _
        gParam.cbxTP.ListIndex = getListIndex(parmsDict, gParam.cbxTP, CStr(getSDMSetting(parmsDict, gParam.cbxTP.Name, "")))
54: If (gParam.cbxNTP.ListCount > 0) Then _
        gParam.cbxNTP.ListIndex = getListIndex(parmsDict, gParam.cbxNTP, CStr(getSDMSetting(parmsDict, gParam.cbxNTP.Name, "")))
'gParam.txtMD.text = getSDMSetting("SDMExtension", SDMGlobals.SDMUtil.getMap.Name & "_AnalysisParameters", "txtMD", -99)
57: gParam.txtMD.Text = getSDMSetting(parmsDict, "txtMD", -99)
'gParam.txtUA.text = getSDMSetting("SDMExtension", SDMGlobals.SDMUtil.getMap.Name & "_AnalysisParameters", "txtUA", "")
59: gParam.txtUA.Text = getSDMSetting(parmsDict, "txtUA", "")
'gParam.cbxSA.ListIndex = getSDMSetting("SDMExtension", SDMGlobals.SDMUtil.getMap.Name & "_AnalysisParameters", "cbxSA", 0)
61: If (gParam.cbxSA.ListCount > 0) Then _
        gParam.cbxSA.ListIndex = getListIndex(parmsDict, gParam.cbxSA, getSDMSetting(parmsDict, "cbxSA", 0))
'gParam.chkLR.Value = getSDMSetting("SDMExtension", SDMGlobals.SDMUtil.getMap.Name & "_AnalysisParameters", "chkLR", 0)
64: gParam.chkLR.Value = getSDMSetting(parmsDict, "chkLR", 0)
'gParam.radWEDD.Value = getSDMSetting("SDMExtension", SDMGlobals.SDMUtil.getMap.Name & "_AnalysisParameters", "radWEDD", False)
66: gParam.radWEDD.Value = getSDMSetting(parmsDict, "radWEDD", False)
'gParam.radExpt.Value = getSDMSetting("SDMExtension", SDMGlobals.SDMUtil.getMap.Name & "_AnalysisParameters", "radExpt", False)
68: gParam.radExpt.Value = getSDMSetting(parmsDict, gParam.radExpt.Name, False)
'gParam.chkNNUns.Value = getSDMSetting("SDMExtension", SDMGlobals.SDMUtil.getMap.Name & "_AnalysisParameters", "chkNNUns", 0)
'gParam.chkFL.Value = getSDMSetting("SDMExtension", SDMGlobals.SDMUtil.getMap.Name & "_AnalysisParameters", "chkFL", 0)
71: gParam.chkFL.Value = getSDMSetting(parmsDict, "chkFL", 0)
'gParam.chkNNSup.Value = getSDMSetting("SDMExtension", SDMGlobals.SDMUtil.getMap.Name & "_AnalysisParameters", "chkNNSup", 0)
73: gParam.chkNN.Value = getSDMSetting(parmsDict, "chkNN", 0)
74: If gParam.chkNN.Value = 1 Then
75:     gParam.chkNNSup.Value = getSDMSetting(parmsDict, "chkNNSup", 0)
76:     gParam.chkNNUns.Value = getSDMSetting(parmsDict, "chkNNUns", 0)
77:     Else
78:     gParam.chkNNSup.Value = 0
79:     gParam.chkNNUns.Value = 0
80: End If
81: gParam.getEars.Update gParam.btnOK
82: restoreStudyArea parmsDict
'<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
Exit Sub

ErrorHandler:
  HandleError True, c_sDLLFileName & " " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), Err.Number, Err.Source, Err.Description, 4
End Sub

Sub restoreStudyArea(ByRef parmsDict As SDMUtilities.SDMDictionary)
     On Error GoTo ErrorHandler
     Dim saName As String
 'SAName = getSDMSetting("SDMExtension", SDMGlobals.SDMUtil.getMap.Name & "_AnalysisParameters", "StudyArea", "None")
94:  saName = getSDMSetting(parmsDict, "StudyArea", "None")
95:  If saName <> "None" Then
        Dim raEnv As IRasterAnalysisEnvironment
97:     Set raEnv = New RasterAnalysis
        Dim raMask As IRasterLayer
99:     Set raMask = SDMGlobals.SDMUtil.FindLayerByName(saName)
        If raMask Is Nothing Then Exit Sub
101:        Set raEnv.Mask = raMask.Raster
102:        raEnv.SetCellSize esriRasterEnvMinOf
            Dim raGMask As IGeoDataset
104:        Set raGMask = raMask
105:        raEnv.SetExtent esriRasterEnvValue, raGMask.extent
'  Dim pMxDocument As IMxDocument
'  Dim pMap As IMap
'  Dim pEnumLayer As IEnumLayer
'  Dim pLayer As ILayer
'  Dim pId As New UID
'
'  Set pMxDocument = Application.Document
'  Set pMap = pMxDocument.FocusMap
            Dim outSpatRef As ISpatialReference
            Dim outSpatRefName As String
'    outSpatRefName = getSDMSetting("SDMExtension", SDMGlobals.SDMUtil.getMap.Name & "_AnalysisParameters", "OutRasSpatRef", "None")
    
            Dim outWS As IRasterWorkspace
            Dim outWSName As String
'    outWSName = getSDMSetting("SDMExtension", SDMGlobals.SDMUtil.getMap.Name & "_AnalysisParameters", "OutWrkSpcName", "")
121:        outWSName = getSDMSetting(parmsDict, "OutWrkSpcName", "")
122:        If outWSName <> "" Then
            Dim pWSF As IWorkspaceFactory
124:        Set pWSF = New RasterWorkspaceFactory
            Dim bIsWorkspace As Boolean
126:        bIsWorkspace = pWSF.IsWorkspace(outWSName)
127:        If bIsWorkspace Then
128:             Set outWS = pWSF.OpenFromFile(outWSName, 0)
129:             Set raEnv.OutWorkspace = outWS
130:        End If
131:     End If
132:     raEnv.SetAsNewDefaultEnvironment
133:  End If
  Exit Sub
ErrorHandler:
  HandleError True, "restoreStudyArea " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), Err.Number, Err.Source, Err.Description, 4
End Sub

Private Function getSDMSetting(ByRef parmsDict As SDMUtilities.SDMDictionary, ctlname As String, defValue As Variant) As Variant
  On Error GoTo ErrorHandler
141:     If parmsDict.Exists(ctlname) Then
142:         getSDMSetting = parmsDict.Gett(ctlname)
143:     Else
144:         getSDMSetting = defValue
145:     End If
  Exit Function
ErrorHandler:
  HandleError False, "getSDMSetting " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), Err.Number, Err.Source, Err.Description, 4
End Function

Private Function getListIndex(ByRef parmsDict As SDMUtilities.SDMDictionary, ctl As ComboBox, lstVal As String) As Long
  On Error GoTo ErrorHandler
    Dim i As Long
154:     For i = 0 To ctl.ListCount - 1
155:         If ctl.list(i) = lstVal Then
156:             getListIndex = i
                 Exit Function
158:         End If
159:     Next i
160:     getListIndex = 0

  Exit Function
ErrorHandler:
  HandleError False, "getListIndex " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), Err.Number, Err.Source, Err.Description, 4
End Function

Private Function GetRestoreName() As String
  On Error GoTo ErrorHandler

    Dim pDoc As IDocument
    Dim pMap As IMap
172:     Set pDoc = SDMGlobals.SDMDoc
173:     Set pMap = SDMGlobals.SDMMxDoc.FocusMap
    Dim pTemplates As ITemplates
175:     Set pTemplates = SDMGlobals.SDMApp.Templates
    Dim projPath
177:     projPath = pTemplates.Item(pTemplates.Count - 1)
    Dim fs
179:     Set fs = CreateObject("Scripting.FilesystemObject")
    Dim ProjectDir
181:     ProjectDir = fs.getParentFolderName(projPath)
    Dim title
183:     title = fs.GetBaseName(pDoc.title)
184:     If fs.FolderExists(ProjectDir) Then
        Dim APPath
186:         APPath = fs.buildpath(ProjectDir, title & "_" & pMap.Name & "_AnalysisParameters.txt")
        Dim Old_APPath
188:         Old_APPath = fs.buildpath(ProjectDir, pMap.Name & "_AnalysisParameters.txt")
189:         If fs.fileexists(APPath) Then
190:             GetRestoreName = APPath
191:         ElseIf fs.fileexists(Old_APPath) Then
192:             GetRestoreName = Old_APPath
193:         End If
194:     End If


  Exit Function
ErrorHandler:
  HandleError False, "GetRestoreName " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), Err.Number, Err.Source, Err.Description, 4
End Function

