VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "gSDI_RunNormalize"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = True
Option Explicit
Const c_sModuleFileName As String = "gSDI_RunNormalize.cls"
Const c_sDLLFileName As String = "SDMAccessories"       ' Constant reflect file module name
'Private ObjectTag As Object
'Property Set setObjectTag(anObject As Object)
'    Set ObjectTag = anObject
'End Property
'Property Get getObjectTag() As Object
'    Set getObjectTag = ObjectTag
'End Property

Sub gSDI_RunNormalize()
  On Error GoTo ErrorHandler

' If Form1.isShiftdown Then
'    SDMGlobals.SDMHelp.gSDI_Help "sdmnorm.htm"
'    Exit Sub
' End If

'PUT THE IMPLEMENTATION HERE >>>>>>>>>>>>>
'' gSDI.RunNormalize
'
'If (System.IsShiftKeyDown) Then
'  docURL = "sdmnorm.htm"
'  If (docURL.Count > 0) Then
'    av.Run("gSDI.Help", {docURL})
'  End
'  return Nil
'End
'
'' Get view document and a list of
'' possible input themes
''---------------------------------------
'viewA = av.GetActiveDoc
'If (viewA.Is(View).Not) Then
'  return Nil
'End

39:    If SDMGlobals.SDMApp Is Nothing Then Set SDMGlobals.SDMApp = New AppRef
40:    If SDMGlobals.SDMDoc Is Nothing Then Set SDMGlobals.SDMDoc = SDMGlobals.SDMApp.Document
41:    If SDMGlobals.SDMMap Is Nothing Then
            Dim pMxDoc As IMxDocument
43:         Set pMxDoc = SDMGlobals.SDMDoc
44:         Set SDMGlobals.SDMMap = pMxDoc.FocusMap
45:    End If
'lstThm = viewA.GetThemes
    Dim enumLayer As IEnumLayer
48: Set enumLayer = SDMGlobals.SDMMap.layers
    Dim layer As ILayer
50: Set layer = enumLayer.Next
'If (lstThm.IsEmpty) Then
    If layer Is Nothing Then Exit Sub
'  return Nil
'End

'lstGThm = List.Make
Dim lstGThm As New SDMUtilities.SDMList
58: While (Not layer Is Nothing)
59:     If layer.Valid Then
'For Each t In lstThm
'  If (t.Is(GTheme)) Then
62:         If TypeOf layer Is IRasterLayer Then lstGThm.Add layer
'    lstGThm.Add (t.GetName)
'  End
'End
66:     End If
67:     Set layer = enumLayer.Next
68: Wend
'If (lstGThm.IsEmpty) Then
    If lstGThm.IsEmpty Then Exit Sub
'  return Nil
'End

'' If a valid input theme is currently
'' active, make it the first in list
''---------------------------------------
'lstThmA = viewA.GetActiveThemes
Dim lstThmA As New SDMUtilities.SDMList
Dim thm As Variant
80: For Each thm In lstGThm.list
81:     Set layer = thm
82:     If layer.Visible Then lstThmA.Add layer
83: Next thm
'If (lstThmA.IsEmpty.Not) Then
85: If Not lstThmA.IsEmpty Then
'  thmA = lstThmA.Get(0)
    Dim thmA As ILayer
88:     Set thmA = lstThmA.getObj(0)
'  If (thmA.Is(GTheme)) Then
90:     If TypeOf thmA Is IRasterLayer Then
'    idx = lstGThm.FindByValue(thmA.GetName)
        Dim idx As Long
93:         idx = ListUtils.FindObj(thmA, lstGThm)
'    If (idx > -1) Then
'''         If idx > -1 Then lstGThm.ShuffleObj lstGThm.getObj(idx), 0
'      lstGThm.Shuffle(lstGThm.Get(idx),0)
'    End
98:         End If
'  End
'End
101: End If
'' Prompt user for theme to normalize
''---------------------------------------
'gThm = MsgBox.ChoiceAsString(lstGThm, "Select grid theme to normalize:", "Normalize Grid")
'If (gThm = Nil) Then
'  return Nil
'Else
'  gThm = viewA.FindTheme(gThm)
'' Prompt user for theme to normalize
     Dim gThmName As String
111: gThmName = gNorm.cbx_SelGrd.Text
     If gThmName = "" Then Exit Sub
     Dim gThm As IRasterLayer
114: Set gThm = WOETableUtils.FindLayerByName(gThmName)
'  If (gThm = Nil) Then
     If gThm Is Nothing Then Exit Sub
'    return Ni
'  End
'End
'''Get field to normalize on
    Dim dispTbl As IDisplayTable
122:     Set dispTbl = gThm
    Dim grdTbl As ITable
124:     Set grdTbl = dispTbl.DisplayTable
    Dim gFlds As esrigeodatabase.IFields
126:     Set gFlds = grdTbl.Fields
    Dim gfld As esrigeodatabase.IField
128:     Set gfld = gFlds.Field(gFlds.FindField(gNorm.cbx_SelFld))
'' Run normalize script
''---------------------------------------
'thmN = av.Run("gSDI.NormalizeGrid",{gThm})
     Dim thmN As IRasterLayer
133: Set thmN = gSDI_RunNormalizeGrid(gThm, gfld)
'If (thmN = Nil) Then
     If thmN Is Nothing Then Exit Sub
'  return Nil
'End

'' Add theme to script
''---------------------------------------
'viewA.AddTheme (thmN)
142: thmN.Name = gThmName & " Normalized"
143: SDMGlobals.SDMMap.AddLayer thmN
'cmts = "Generated by: Arc-SDM - Normalize Grid" + NL
'cmts = cmts + gThm.GetName + " normalized." + NL
'cmts = cmts + "Source of " + gThm.GetName + ":  " + gThm.GetGrid.GetSrcName.GetFileName.GetFullName
'thmN.SetComments (cmts)
'av.Run("gSDI.PositionTheme",{viewA,thmN})
'
'<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
Exit Sub
ErrorHandler:
  HandleError True, c_sModuleFileName & " " & GetErrorLineNumberString(Erl), Err.Number, Err.Source, Err.Description, 4
End Sub

Private Function gSDI_RunNormalizeGrid(ByRef rLayer As IRasterLayer, ByRef rFld As esrigeodatabase.IField) As IRasterLayer
  On Error GoTo ErrorHandler

'Set the raster workspace
        Dim WrkSpace As IRasterWorkspace
166:  Set WrkSpace = SDMGlobals.SDMWorkspace
'MsgBox "OutWorkspace: " & SDMGlobals.SDMWorkspace.PathName, , c_sModuleFileName

     Dim rasBandColl As IRasterBandCollection
169: Set rasBandColl = rLayer.Raster
     Dim rasStats As IRasterStatistics
171: Set rasStats = rasBandColl.Item(0).Statistics
     Dim minn As Double
173: minn = rasStats.Minimum
     Dim maxx As Double
175: maxx = rasStats.Maximum
     Dim rastMaker As IRasterMakerOp
177: Set rastMaker = New RasterMakerOp
     Dim rmAE As IRasterAnalysisEnvironment
179: Set rmAE = rastMaker
180: SetAE rmAE, WrkSpace
    
     Dim rastOps As IMathOp
183: Set rastOps = New RasterMathOps
     Dim ropsAE As IRasterAnalysisEnvironment
185: Set ropsAE = rastOps
186: SetAE ropsAE, WrkSpace
    
     Dim grdIn1 As IGeoDataset
     Dim grdIn2 As IGeoDataset
190: Set grdIn1 = rastOps.Minus(rLayer.Raster, rastMaker.MakeConstant(minn, False))
191: Set grdIn2 = rastMaker.MakeConstant(maxx, False)
'MsgBox "rmAE OutWorkspace: " & rmAE.OutWorkspace.PathName, , c_sModuleFileName
     Dim grdN As IRaster
193: Set grdN = rastOps.Divide(grdIn1, grdIn2)
     Dim newRasLayer As IRasterLayer
195: Set newRasLayer = New RasterLayer
196: newRasLayer.CreateFromRaster grdN
197: Set gSDI_RunNormalizeGrid = newRasLayer

  Exit Function
ErrorHandler:
  HandleError False, "gSDI_RunNormalizeGrid " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), Err.Number, Err.Source, Err.Description, 4
202:     Set gSDI_RunNormalizeGrid = Nothing
End Function

Private Sub SetAE(ByRef raEnv As IRasterAnalysisEnvironment, ByRef WrkSpace As IWorkspace)
  On Error GoTo ErrorHandler

'Get the study area mask
    Dim anlParms As AnalysisParameters.AnlParams
210: Set anlParms = New AnalysisParameters.AnlParams
    Dim gParam As Form
212: Set gParam = anlParms.gParamFrm
    Dim maskName As String
214: maskName = gParam.cbxSA.Text
    Dim masklayer As IRasterLayer
216: Set masklayer = WOETableUtils.FindLayerByName(maskName)
    Dim pGeodataSet As IGeoDataset
218: Set pGeodataSet = masklayer
    Dim rasprops As IRasterProps
220: Set rasprops = masklayer.Raster

'set the raster analysis environment
223: raEnv.SetExtent esriRasterEnvValue, pGeodataSet.Extent
224: raEnv.SetCellSize esriRasterEnvValue, rasprops.MeanCellSize.X
225: Set raEnv.mask = masklayer.Raster
226: Set raEnv.OutSpatialReference = SDMGlobals.SDMMap.SpatialReference
227: Set raEnv.OutWorkspace = WrkSpace
    


  Exit Sub
ErrorHandler:
  HandleError False, "SetAE " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), Err.Number, Err.Source, Err.Description, 4
End Sub

