VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "gSDI_SaveParams"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = True
Option Explicit
Const c_sModuleFileName As String = "C:\MyJava\ARC-SDM\VBScripts\gSDI_SaveParameters.cls"
Const c_sDLLFileName As String = "AnalysisParameters"       ' Constant reflect file module name
'Private ObjectTag As Object
'Property Set setObjectTag(anObject As Object)
'    Set ObjectTag = anObject
'End Property
'Property Get getObjectTag() As Object
'    Set getObjectTag = ObjectTag
'End Property

Sub gSDI_SaveParameters()

On Error GoTo ErrorHandler

'PUT THE IMPLEMENTATION HERE
Dim ProjectDir As String
Dim ProjectName As String
Dim pTemplates As ITemplates
Dim lTempCount As Long
'Get project directory as document folder name
22: Set pTemplates = SDMGlobals.SDMApp.Templates
23: lTempCount = pTemplates.Count
    ' The document is always the last item
25: ProjectDir = pTemplates.Item(lTempCount - 1)
26: ProjectName = SDMGlobals.SDMDoc.title
    Dim fs As Object
28: Set fs = CreateObject("Scripting.FileSystemObject")
29: ProjectDir = fs.getParentFolderName(ProjectDir)
'Get name of active dataframe
    Dim dataFrmName As String
32: dataFrmName = SDMUtil.getMap.Name
'Make Parameters file name
    Dim parmsFileName As String
'34: parmsFileName = fs.buildpath(ProjectDir, dataFrmName & "_AnalysisParameters.txt")
36: parmsFileName = GetSaveName()
    Dim textStrm As Object
38: Set textStrm = fs.CreateTextFile(parmsFileName, True)

'Save gParam control values
Dim ctl As Object
Dim ctlname As String
Dim ctlValue As String
'Dim list As New SDMUtilities.SDMList
45: For Each ctl In gParam.Controls
46:     If TypeOf ctl Is CheckBox Then
47:         ctlname = ctl.Name
48:         ctlValue = ctl.Value
49:     ElseIf TypeOf ctl Is OptionButton Then
50:         ctlname = ctl.Name
51:         ctlValue = ctl.Value
52:     ElseIf TypeOf ctl Is TextBox Then
53:         ctlname = ctl.Name
54:         ctlValue = ctl.Text
55:     ElseIf TypeOf ctl Is ComboBox Then
56:         ctlname = ctl.Name
57:         ctlValue = ctl.Text
58:     Else
59:         GoTo next1
60:     End If
    ''list.Add "SDMExtension" & ", " & SDMGlobals.SDMUtil.getMap.Name & "_AnalysisParameters" & ", " & ctlname & ", " & ctlvalue
62:     textStrm.writeline ctlname & "=" & ctlValue
next1: Next ctl
    Dim saName As String
65: saName = gParam.cbxSA.Text
    If saName = "" Then Exit Sub
    'SaveSetting "SDMExtension", SDMGlobals.SDMUtil.getMap.Name & "_AnalysisParameters", "StudyArea", SAName
68: textStrm.writeline "StudyArea=" & saName
    Dim OutWrkSpcName As String
    Dim raEnv As IRasterAnalysisEnvironment
'72: Set raEnv = RasterAEUtils.getRasterAnalysisEnvironment()
'73: OutWrkSpcName = raEnv.OutWorkspace.PathName
'74: If Not raEnv.OutWorkspace Is Nothing Then
        'SaveSetting "SDMExtension", SDMGlobals.SDMUtil.getMap.Name & "_AnalysisParameters", "OutWrkSpcName", OutWrkSpcName
'76:         textStrm.writeline "OutWrkSpcName=" & OutWrkSpcName
'77:     Else
77:         textStrm.writeline "OutWrkSpcName=Nothing"
'79: End If

80: textStrm.Close
    'MsgBox list.AsString, , c_sModuleFileName
'<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
Exit Sub

ErrorHandler:
  HandleError True, c_sDLLFileName & " " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), Err.Number, Err.Source, Err.Description, 4
End Sub

Private Function GetSaveName() As String
  On Error GoTo ErrorHandler

    Dim pDoc As IDocument
    Dim pMap As IMap
94:     Set pDoc = SDMGlobals.SDMDoc
95:     Set pMap = SDMGlobals.SDMMxDoc.FocusMap
    Dim pTemplates As ITemplates
97:     Set pTemplates = SDMGlobals.SDMApp.Templates
    Dim projPath
99:     projPath = pTemplates.Item(pTemplates.Count - 1)
    Dim fs
101:     Set fs = CreateObject("Scripting.FilesystemObject")
    Dim ProjectDir
103:     ProjectDir = fs.getParentFolderName(projPath)
    Dim title
105:     title = fs.GetBaseName(pDoc.title)
106:     If fs.FolderExists(ProjectDir) Then
        Dim APPath
108:         APPath = fs.buildpath(ProjectDir, title & "_" & pMap.Name & "_AnalysisParameters.txt")
109:         GetSaveName = APPath
110:     End If
    Exit Function

  Exit Function
ErrorHandler:
  HandleError False, "GetSaveName " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), Err.Number, Err.Source, Err.Description, 4
End Function

