VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "gSDI_SelectTP"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = True
' Variables used by the Error handler function - DO NOT REMOVE
Const c_sModuleFileName As String = "gSDI_SelectTP"

'' Name:  gSDI.SelectTP
Sub gSDI_SelectTP(CallingDlg As Variant)
  On Error GoTo ErrorHandler
''
''Topics:  Spatial Data Modeller;  DefBitMap
''
''Description:  Allows user to define a query
''  using the query builder, then sets that
''  query as the point theme definition so that
''  a point theme can be reduced to features
''  meeting some definition based on attribute values.
''
''Requires:
''
'' Self:  the Subset by 'Attributes' button on the
''   Set Analysis Parameters dialog
''
''Returns:
''==============================================
'' GET PARAMETERS DIALOG, ACTIVE DOC
'gPTP = self.GetDialog
'gP = av.FindDialog("gParam")
'viewActive = gP.GetActiveDoc
'' GET TRAINING POINT THEME NAME, VERIFY ITS
'' POINT THEME IN ACTIVE VIEW
''------------------------------------------
'strTP = gP.FindByName("cbxTP").GetCurrentValue
Dim strTP As String
32: If CallingDlg Is gPTP Then
33:     strTP = gParam.cbxTP.Text
34: ElseIf CallingDlg Is gPNTP Then
35:     settp = gParam.cbxNTP.Text
36: Else
        Exit Sub
38: End If
'thmTP = Nil
'if (strTP.Is(String)) then
'  thmTP = viewActive.FindTheme(strTP)
Dim thmTP As IFeatureLayer
43: Set thmTP = SDMGlobals.SDMUtil.FindLayerByName(strTP)
'ElseIf (strTP.Is(ftheme)) Then
'  thmTP = strTP
'End
'If (thmTP.Is(ftheme).Not) Then
'  MsgBox.Error("The Training Point Theme must have a unique name.","Setting Parameters")
'  return Nil
'End
'vTabTP = thmTP.GetFTab
'shapetype = vTabTP.FindField("Shape").GetType
'if (shapetype <> #FIELD_SHAPEPOINT) then
'  MsgBox.Error("The Training Point Theme must have a unique name.","Setting Parameters")
'  return Nil
'End

'' PREPARE, THEN GET SELECTION SET
'' FOR TRAINING POINTS
''------------------------------------------
'bmTP = vTabTP.GetDefBitmap
'Dim bmTP As IFeatureSelection
'Set bmTP = thmTP
'bmTP.SetAll
'bmTP.SelectFeaturesnothing , esriSelectionResultNew, False
'vTabTP.SetDefBitmap (bmTP)
'vTabTP.UpdateDefBitmap
'bmTP.SelectionChanged
'strQuery = QueryWin.ReturnQuery(vTabTP, "()")
'Dim query As IQueryFilter
'If (strQuery = Nil) Then
'
'  return nil
'
'End
'
'if (vTabTP.Query(strQuery,vTabTP.GetSelection,#VTAB_SELTYPE_NEW)) then
'Set query.WhereClause = "()"
'bmTP.SelectFeatures query, esriSelectionResultNew, False
'  vTabTP.SetDefinition (strQuery)
'
'Else
'
'  vTabTP.SetDefinition ("")
'
'End
'
'viewActive.Invalidate
'
'self.setObjectTag (strQuery)
'
'self.GetDialog.FindByName("btnRnd").setObjectTag (Nil)
'
'self.GetDialog.FindByName("txtTPs").Update
'
'vTabTP.GetSelection.ClearAll
'
'
Dim qryAttrs As IQueryAttributes
107: Set qryAttrs = New QueryAttributes
108: Set qryAttrs.Application = SDMGlobals.SDMApp
110: Set qryAttrs.layer = thmTP
109: qryAttrs.CombinationMethod = esriSelectionResultNew
111: qryAttrs.SelectFeaturesInLayerOnOK = True
112: qryAttrs.DoModal SDMGlobals.SDMApp.hWnd

Dim TPName As String
115: TPName = CallingDlg.lblTP.Caption
Dim tokens As Variant
117: tokens = Split(TPName, ":")
Dim tblSel As ITableSelection
119: Set tblSel = SDMUtil.FindLayerByName(Trim(tokens(1)))
120: CallingDlg.txtTPsSel.Caption = tblSel.SelectionSet.Count
121: CallingDlg.SetFocus

Exit Sub
ErrorHandler:
  HandleError True, "gSDI_SelectTP " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), Err.Number, Err.Source, Err.Description, 4
End Sub

