VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "gSDI_WriteLRFiles"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = True
Option Explicit
Const c_sModuleFileName As String = "gSDI_WriteLRFiles"
Const c_sDLLFileName As String = "CalculateLogisticRegr"       ' Constant reflect file module name
Const OFF As Long = 0
Const ONN As Long = 1
'Private ObjectTag As Object
'Property Set setObjectTag(anObject As Object)
'    Set ObjectTag = anObject
'End Property
'Property Get getObjectTag() As Object
'    Set getObjectTag = ObjectTag
'End Property

Function gSDI_WriteLRFiles(Self As Variant) As Variant
  On Error GoTo ErrorHandler

'PUT THE IMPLEMENTATION HERE >>>>>>>>>>>>>
'' Topics:  Spatial Data Modeller
''
'' Description:
''
''
'' Requires:
''
'' Self:  List containing
''        0 -- lists of unique conditions values
''        1 -- free, multi-class lists
''        2 -- integer defining missing data
''        3 -- list of weighted averages to replace missing data
''        4 -- unit cell area
''
'' Returns:
''==============================================
'' Get arguments
''----------------------------------------------

'lstsUC = Self.Get(0)
    Dim lstsUC As SDMUtilities.SDMList
39: Set lstsUC = Self(0)
'lstsvals = lstsUC.Get(0)
    Dim lstsvals As SDMUtilities.SDMList
42: Set lstsvals = lstsUC.getObj(0)
'MsgBox lstsvals.asString, "lstsvals", c_sModuleFileName
'lstAreas = lstsUC.Get(2)
    Dim lstAreas As SDMUtilities.SDMList
46: Set lstAreas = lstsUC.getObj(2)
'MsgBox lstAreas.asString, "lstAreas", c_sModuleFileName
'lstPnts = lstsUC.Get(3)
    Dim lstPnts As SDMUtilities.SDMList
50: Set lstPnts = lstsUC.getObj(3)
'MsgBox lstPnts.asString, "lstPnts", c_sModuleFileName
'lstsUC = Nil
'lstsMC = Self.Get(1)
    Dim lstsMC As SDMUtilities.SDMList
55: Set lstsMC = Self(1)
'catMCLists = lstsMC.Get(0)
    Dim catMCLists As SDMUtilities.SDMList
58: Set catMCLists = lstsMC.getObj(0)
'MsgBox catMCLists.asString, "catMCLists", c_sModuleFileName
'mcIndeces = lstsMC.Get(1)
    Dim mcIndeces As SDMUtilities.SDMList
62: Set mcIndeces = lstsMC.getObj(1)
'MsgBox mcIndeces.asString, "mcIndeces", c_sModuleFileName
'lstsMC = Nil
'
'lstMD = Self.Get(2)
    Dim lstMD As SDMUtilities.SDMList
68: Set lstMD = Self(2)
'MsgBox lstMD.asString, "lstMD", c_sModuleFileName
'lstWA = Self.Get(3)
    Dim lstWA As SDMUtilities.SDMList
72: Set lstWA = Self(3)
'MsgBox ListUtils.ListtoString(lstWA), , "lstWA"
'q = 1
'For Each w In lstWA
'  q = q + 1
'End
'unitcell = Self.Get(4)
    Dim unitcell As Double
80: unitcell = Self(4)
'thmUC = Self.Get(5)
    Dim thmUC As IRasterLayer
83: Set thmUC = Self(5)
'ot = thmUC.getObjectTag
    Dim gL As Form
86: Set gL = Self(6)
    Dim ot As SDMUtilities.SDMList
88: Set ot = gL.Thmuc_getObjectTag
'' Set file names, and get or make
'' temporary directory, then files
''----------------------------------------------
'strF1 = "param.dat"
    Dim strF1 As String
94: strF1 = "param.dat"
'strF2 = "case.dat"
    Dim strF2 As String
97: strF2 = "case.dat"
'sepChr = av.Run("gSDI.GetSeparatorChar",{})
'dirTmp = av.Run("gSDI.GetTmpDir",{})
     Dim dirTmp As String
101: dirTmp = WOETableUtils.GetTmpDir
'if (dirTmp.Is(String)) then
'  MsgBox.Error(dirTmp,"Error getting SDI temporary directory.")
'  return Nil
'End
'fnCase = (dirTmp.GetFullName + sepChr + strF2).AsFileName
     Dim fnCase As String
105: fnCase = dirTmp & "\" & strF2
'fCase = LineFile.Make(fnCase, #FILE_PERM_WRITE)
     Dim fCase As Object
106: Set fCase = FileDialog.CreateWriteLineFile(fnCase)
'If (fCase = Nil) Then
108: If fCase Is Nothing Then
''  MsgBox.Error("Can't create 'case.dat'.","testing")
'  return Nil
116:     gSDI_WriteLRFiles = Null
         Exit Function
'End
119: End If
'nmbUC = lstsvals.Get(0).Count
     Dim lst1 As SDMUtilities.SDMList
122: Set lst1 = lstsvals.getObj(0)
     Dim nmbUC As Long
124: nmbUC = lst1.Count
'getNmbET = True
     Dim getNmbET As Boolean
127: getNmbET = True
'nmbET = 0
     Dim nmbET As Long
130: nmbET = 0
'av.ShowMsg ("Writing Logistic Regression files...")
132: ProgressAnimation.Show "Writing Logistic Regression files..."
'for each j in 0..(lstsVals.Count - 1)
     Dim J As Long
135: For J = 0 To (lstsvals.Count - 1)
'  mcIdx = mcIndeces.Get(J).Get(1)
         Dim lst2 As SDMUtilities.SDMList
138:     Set lst2 = mcIndeces.getObj(J)
         Dim mcIdx As Long
140:     mcIdx = lst2.GetVal(1)
'  If (mcIdx > -1) Then
142:     If mcIdx > -1 Then
'    listVals = catMCLists.Get(J)
             Dim listVals As SDMUtilities.SDMList
145:         Set listVals = catMCLists.getObj(J)
'    lstLV = listVals.Clone
             Dim lstLV As SDMUtilities.SDMList
148:         Set lstLV = listVals.Clone
'    lstLV.RemoveDuplicates
150:         Set lstLV = lstLV.RemoveDuplicates
'    elOT = ot.Get(J)
             Dim elOT As SDMList
153:         Set elOT = ot.getObj(J)
'    tknTF = elOT.Get(0).AsTokens(",")
             Dim tknTF As Variant
156:         tknTF = Split(elOT.GetVal(0), ",")
'    strT = tknTF.Get(0).Trim
             Dim strT As String
159:         strT = Trim(tknTF(0))
'    strF = tknTF.Get(1).Trim
             Dim strF As String
162:         strF = Trim(tknTF(1))
'    First = True
             Dim First As Boolean
165:         First = True
'    For Each lv In lstLV
             Dim lv As Variant
168:         For Each lv In lstLV.List
'      If (First) Then
170:             If First Then
'        elOT.Set(0,elOT.Get(0) + " (" + lv.AsString + ")")
172:                 elOT.SetIt 0, elOT.GetVal(0) & " (" & CStr(lv) & ")"
'        First = False
174:                 First = False
'      Else
176:             Else
'        elOT.Add (strT + ", " + strF + " (" + lv.AsString + ")")
178:                 elOT.Add strT & ", " & strF & " (" & CStr(lv) & ")"
'      End
180:             End If
'    End
182:         Next lv
'    ot.Set(j,elOT)
184:         ot.SetIt J, elOT
'  End
186:     End If
'End
188: Next J

'' Loop through the unique conditions, substituting
'' the weighted average of known classes for missing data
'' and 'expanding' multi-class free data themes to
'' a series of binary themes
''----------------------------------------------
Dim progBar As IStepProgressor
197: Set progBar = SDMGlobals.SDMStatusBar.ProgressBar
198: progBar.Position = 0
199: SDMGlobals.SDMStatusBar.ShowProgressBar "Processing unique conditions...", 0, nmbUC, 1, True
'for each i in 0..(nmbUC - 1)
    Dim wLine As String
    Dim i As Long
203: For i = 0 To (nmbUC - 1)
'  av.SetStatus ((i / nmbUC) * 100)
'  wLine = ""
'  wLine = wLine + (i + 1).AsString + "     "
207:     wLine = (i + 1) & "     "
'  J = 0
209:     J = 0
'  For Each lst In lstsvals
         Dim lstvar As Variant
212:     For Each lstvar In lstsvals.List
213:         Set lst1 = lstvar
'    missing = lstMD.Get(J)
             Dim missing As Long
216:         missing = lstMD.GetVal(J)
''    avgWeighted = lstWA.Get(j)
'    theVal = lst.Get(i)
             Dim theVal As Long
220:         theVal = lst1.GetVal(i)
'    mcIdx = mcIndeces.Get(J).Get(1)
222:         Set lst2 = mcIndeces.getObj(J)
223:         mcIdx = lst2.GetVal(1)
'    If (mcIdx < 0) Then
225:         If mcIdx < 0 Then
'      If (getNmbET) Then
227:             If getNmbET Then
'        nmbET = nmbET + 1
229:                 nmbET = nmbET + 1
'      End
231:             End If
'      If (theVal = missing) Then
233:             If theVal = missing Then
'        theVal = lstWA.Get(J).Get(0)      'avgWeighted
                     Dim lst3 As SDMUtilities.SDMList
236:                 Set lst3 = lstWA.getObj(J)
237:                 theVal = lst3.GetVal(0)
'      End
239:             End If
'      wLine = wLine + theVal.SetFormat("d.dddddd").AsString + "         "
241:             wLine = wLine & Format(theVal, "0.######") & "         "
'    Else
243:         Else
'      listVals = catMCLists.Get(J)
245:             Set listVals = catMCLists.getObj(J)
'      'off = listVals.Get(0) - 1
'      OFF = 0
'      ON = 1
'      If (theVal = missing) Then
250:            If theVal = missing Then
'        M = 0
                    Dim M As Long
253:                M = 0
'        For Each v In listVals
                    Dim v As Variant
256:                For Each v In listVals.List
'          If (v = missing) Then
258:                    If CLng(v) = missing Then
'            Continue
260:                        GoTo nextV
'          Else
262:                    Else
'            valWA = lstWA.Get(J).Get(M)
                            Dim lst4 As SDMUtilities.SDMList
265:                        Set lst4 = lstWA.getObj(J)
                            Dim valWA As Long
267:                        valWA = lst4.GetVal(M)
'            wLine = wLine + valWA.SetFormat("d.dddddd").AsString + "         "
269:                        wLine = wLine + Format(valWA, "0.######") & "         "
'            M = M + 1
271:                        M = M + 1
'          End
273:                    End If
'        End
nextV:
276:                Next v
'      Else
278:            Else
'        For Each v In listVals
280:                For Each v In listVals.List
'          If (v = missing) Then
282:                    If CLng(v) = missing Then
'            Continue
284:                        GoTo nextV2
'          ElseIf (getNmbET) Then
286:                    ElseIf getNmbET Then
'            nmbET = nmbET + 1
288:                        nmbET = nmbET + 1
'          End
290:                    End If
'          If (theVal = v) Then
292:                    If theVal = CLng(v) Then
'            wLine = wLine + ON.SetFormat("d.dddddd").AsString + "         "
294:                         wLine = wLine & Format(ONN, "0.######") & "         "
'          Else
296:                    Else
'            wLine = wLine + OFF.SetFormat("d.dddddd").AsString + "         "
298:                         wLine = wLine & Format(OFF, "0.######") & "         "
'          End
300:                    End If
'        End
nextV2:
303:                Next v
'      End
305:            End If
'    End
307:         End If
'    J = J + 1
309:        J = J + 1
'  End
311:     Next lstvar
'  numPoints = lstPnts.Get(i)
         Dim numPoints As Long
314:     numPoints = lstPnts.GetVal(i)
'  wLine = wLine + numPoints.AsString + "     "
316:     wLine = wLine & numPoints & "     "
'  theArea = (lstAreas.Get(i) / 1000000) / unitcell
         Dim theArea As Double
319:     theArea = (lstAreas.GetVal(i) / 1000000) / unitcell
'  wLine = wLine + theArea.SetFormat("d.dddd").AsString + "     "
321:     wLine = wLine & Format(theArea, "0.####") & "     "
'  fCase.WriteElt (wLine)
323:     fCase.writeline wLine
'  getNmbET = False
325:     getNmbET = False
326:     SDMGlobals.SDMStatusBar.StepProgressBar
'End
328: Next i
329: SDMGlobals.SDMStatusBar.HideProgressBar

'fCase.Close
332: fCase.Close
'av.ClearStatus

'' Write a parameter file to the ArcView extension directory
''----------------------------------------------
'fnParam = ("$AVEXT".AsFileName.GetFullName + sepChr + strF1).AsFileName
     Dim fnParam As String
339: fnParam = dirTmp & "\" & strF1
'fParam = LineFile.Make(fnParam,#FILE_PERM_WRITE)
     Dim fParam As Object
342: Set fParam = FileDialog.CreateWriteLineFile(fnParam)
'If (fParam = Nil) Then
344: If fParam Is Nothing Then
'  MsgBox.Error("Error writing logistic regression parameter file.","I/O error")
346:     MsgBox "Error writing logistic regression parameter file.", vbCritical, c_sModuleFileName
'  return Nil
348:     gSDI_WriteLRFiles = Null
         Exit Function
'End
351: End If
'fParam.WriteElt (dirTmp.AsString + sepChr)
353: fParam.writeline dirTmp & "\"
'fParam.WriteElt (strF2)
355: fParam.writeline strF2
'fParam.WriteElt (nmbET.AsString + " " + unitcell.AsString)
357: fParam.writeline nmbET & " " & unitcell
'fParam.Close
359: fParam.Close
'av.ShowMsg ("")
'thmUC.setObjectTag (ot)
362: Set gL.Thmuc_setObjectTag = ot
'return {fCase,nmbET}
364: gSDI_WriteLRFiles = Array(fnCase, nmbET)
365: ProgressAnimation.Hide
'<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
Exit Function
ErrorHandler:
  ProgressAnimation.Hide
  HandleError True, c_sModuleFileName & " " & GetErrorLineNumberString(Erl), Err.Number, Err.Source, Err.Description, 4
370:   gSDI_WriteLRFiles = Array()
End Function
