VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "gSDI_WriteNNFiles"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = True
Option Explicit
Const c_sModuleFileName As String = "gSDI_WriteNNFiles.cls"
Const c_sDLLFileName As String = "CalculateResponse"       ' Constant reflect file module name
'Private ObjectTag As Object
'Property Set setObjectTag(anObject As Object)
'    Set ObjectTag = anObject
'End Property
'Property Get getObjectTag() As Object
'    Set getObjectTag = ObjectTag
'End Property

Function gSDI_WriteNNFiles(Self As Variant) As Object
  On Error GoTo ErrorHandler
'15: MsgBox "Entering....", , c_sModuleFileName
  
      Dim SDMUC As IRasterLayer
17:   Set SDMUC = Self(8)
      Dim TPs As IFeatureLayer
19:   Set TPs = Self(9)
      Dim NDTPs As IFeatureLayer
21:   Set NDTPs = Self(10)
      Dim fld As IField
23:   Set fld = Self(11)
      Dim TPFZMDict As Object
      Dim TPFIDDict As Object
'''25:   If Not fld Is Nothing Then
'MsgBox "TP fz fld: " & fld.Name, , c_sModuleFileName
        Dim TPResult As Variant
29:     TPResult = MaxFZMforUC(SDMUC, TPs, fld, 1)
30:     Set TPFZMDict = TPResult(0)
31:     Set TPFIDDict = TPResult(1)
32:     If TPFZMDict.Count = 0 Then
33:         MsgBox "Can't get Fuzzy Memberships for training points", vbCritical, c_sModuleFileName
34:         Set gSDI_WriteNNFiles = Nothing
            Exit Function
36:   End If
37:   Set fld = Self(12)
      Dim NDTPFZMDict As Object
      Dim NDTPFIDDict As Object
40:   If Not fld Is Nothing Then
'MsgBox "NTP fz fld: " & fld.Name, , c_sModuleFileName
        Dim NDTPResult As Variant
43:     NDTPResult = MaxFZMforUC(SDMUC, NDTPs, fld, 0)
44:     Set NDTPFZMDict = NDTPResult(0)
45:     Set NDTPFIDDict = NDTPResult(1)
46:     If NDTPFZMDict.Count = 0 Then
47:         MsgBox "Can't get Fuzzy Memberships for non-deposit training points", vbCritical, c_sModuleFileName
48:         Set gSDI_WriteNNFiles = Nothing
            Exit Function
50:     End If
51:  Else
52:         Set NDTPFZMDict = Nothing
53:         Set NDTPFIDDict = Nothing
54:      End If
'''DisplayDict "TPFZMDict", TPFZMDict
'''DisplayDict "TPFIDDict", TPFIDDict
'''DisplayDict "NDTPFZMDict", NDTPFZMDict
'''DisplayDict "NDTPFIDDict", NDTPFIDDict

'PUT THE IMPLEMENTATION HERE >>>>>>>>>>>>>
'' Name:  gSDI.WriteNNFiles
''
'' Topics:  Spatial Data Modeller
''
'' Description:
''
''
''
'' Requires:
''
'' Self:  List containing
''        0 -- lists of unique conditions values
''        1 -- free, multi-class lists
''        2 -- list of unique conditions containing non-deposit training points
''        3 -- integer defining missing data
''        4 -- list of weighted averages to replace missing data
''        5 -- unit cell area
'' Returns:
''==============================================
'' Get and parse arguments
''----------------------------------------------
'lstsUC = Self.Get(0)
    Dim lstsUC As SDMUtilities.SDMList
84: Set lstsUC = Self(0)
'lstsvals = lstsUC.Get(0)
    Dim lstsvals As SDMUtilities.SDMList
87: Set lstsvals = lstsUC.getObj(0)
'Dim NNInputLists As String
'89: NNInputLists = NNInputLists & "lstsvals" & vbCrLf & ListUtils.ListtoString(lstsvals) & vbCrLf
'MsgBox ListUtils.ListtoString(lstsvals), , "lstsVals"
'lstAreas = lstsUC.Get(2)
    Dim lstAreas As SDMUtilities.SDMList
93: Set lstAreas = lstsUC.getObj(2)
'94: NNInputLists = NNInputLists & "lstAreas" & vbCrLf & ListUtils.ListtoString(lstAreas) & vbCrLf
'MsgBox ListUtils.ListtoString(lstAreas), , "lstAreas"
'lstPnts = lstsUC.Get(3)
    Dim lstPnts As SDMUtilities.SDMList
98: Set lstPnts = lstsUC.getObj(3)
'99: NNInputLists = NNInputLists & "lstPnts" & vbCrLf & ListUtils.ListtoString(lstPnts) & vbCrLf
'MsgBox ListUtils.ListtoString(lstPnts), , "lstPnts"
    Dim lstFMs As SDMUtilities.SDMList
102: Set lstFMs = lstsUC.getObj(4)
'103: NNInputLists = NNInputLists & "lstFMs" & vbCrLf & ListUtils.ListtoString(lstFMs) & vbCrLf
'MsgBox ListUtils.ListtoString(lstFMs), , "lstFMs"
'lstsUC = Nil
106: Set lstsUC = Nothing
'lstsMC = Self.Get(1)
    Dim lstsMC As SDMUtilities.SDMList
109: Set lstsMC = Self(1)
'110: NNInputLists = NNInputLists & "lstsMC" & vbCrLf & ListUtils.ListtoString(lstsMC) & vbCrLf
'MsgBox ListUtils.ListtoString(lstsMC), , "lstsMC"
'catMCLists = lstsMC.Get(0)
    Dim catMCLists As SDMUtilities.SDMList
114: Set catMCLists = lstsMC.getObj(0)
'115: NNInputLists = NNInputLists & "catMCLists" & vbCrLf & ListUtils.ListtoString(catMCLists) & vbCrLf
'MsgBox ListUtils.ListtoString(catMCLists), , "catMCLists"
''************************** remove expansion ******************************
     Dim pProgbar As IStepProgressor
119: Set pProgbar = SDMGlobals.SDMStatusBar.ProgressBar
120: pProgbar.Position = 0
121: SDMGlobals.SDMStatusBar.ShowProgressBar "Processing catMCLists...", 0, catMCLists.Count, 1, True
'For Each l In catMCLists
     Dim lvar As Variant
124: For Each lvar In catMCLists.list
         Dim l As SDMUtilities.SDMList
126:     Set l = lvar
'  If (l.IsEmpty.Not) Then
128:     If Not l.IsEmpty Then
'    l.Empty
130:         l.Clear
'  End
132:     End If
'End
134:     SDMGlobals.SDMStatusBar.StepProgressBar
135: Next lvar
136: SDMGlobals.SDMStatusBar.HideProgressBar
'mcIndeces = lstsMC.Get(1)
     Dim mcIndeces As SDMUtilities.SDMList
139: Set mcIndeces = lstsMC.getObj(1)
'MsgBox ListUtils.ListtoString(mcIndeces), , "mcIndeces"
'For Each l In mcIndeces
''  l.Set(1,-1)
''End
''************************* end of edits ***************************
'lstsMC = Nil
146: Set lstsMC = Nothing
'lstNDUC = Self.Get(2)
     Dim lstNDUC As SDMUtilities.SDMList
149: If IsNull(Self(2)) Then
150:     Set lstNDUC = Nothing
151: Else
152:     Set lstNDUC = Self(2)
153: End If
'If (lstNDUC <> Nil) Then
155: If Not lstNDUC Is Nothing Then
'  lstN1 = lstNDUC.Get(0)
         Dim lstN1 As SDMUtilities.SDMList
158:     Set lstN1 = lstNDUC.getObj(0)
'168: NNInputLists = NNInputLists & "lstN1" & vbCrLf & ListUtils.ListtoString(lstN1) & vbCrLf
'  lstN2 = lstNDUC.Get(1)
         Dim lstN2 As SDMUtilities.SDMList
162:     Set lstN2 = lstNDUC.getObj(1)
'  cntNDUC = av.Run("gSDI.TotalValsInList",{lstN2})
         Dim cntNDUC As Long
         Dim gSDITotalValsInList As gSDI_TotalValsInList
166:     Set gSDITotalValsInList = New gSDI_TotalValsInList
167:     cntNDUC = gSDITotalValsInList.gSDI_TotalValsInList(Array(lstN2))
'Else
169: Else
'  lstN1 = Nil
171:     Set lstN1 = Nothing
'  lstN2 = Nil
173:     Set lstN2 = Nothing
'End
175: End If
'lstNDUC = Nil
177: Set lstNDUC = Nothing
'lstMD = Self.Get(3)
     Dim lstMD As SDMUtilities.SDMList
180: Set lstMD = Self(3)
'MsgBox ListUtils.ListtoString(lstMD), , "lstMD"
'lstWA = Self.Get(4)
     Dim lstWA As SDMUtilities.SDMList
184: Set lstWA = Self(4)
'MsgBox ListUtils.ListtoString(lstWA), , "lstWA"
'unitcell = Self.Get(5)
     Dim unitcell As Double
188: unitcell = Self(5)
'nnu = Self.Get(6)
     Dim nnu As Boolean
191: nnu = Self(6)
'nns = Self.Get(7)
     Dim nns As Boolean
194: nns = Self(7)
'' Remove duplicate UCs from NDTP list
''----------------------------------------------
'If (nns) Then
198: If nns And (Not lstN1 Is Nothing) And (Not lstN2 Is Nothing) Then
'  uc = 1
        Dim UC As Variant
201:     UC = 1
'  For Each p In lstPnts
203:    pProgbar.Position = 0
204:    SDMGlobals.SDMStatusBar.ShowProgressBar "Processing lstPnts...", 0, lstPnts.Count, 1, True
        Dim pvar As Variant
206:    For Each pvar In lstPnts.list
'    If (p > 0) Then
208:         If CLng(pvar) > 0 Then
'      idxUC = lstN1.FindByValue(uc)
                 Dim idxUC As Long
211:             idxUC = lstN1.FindByValue(UC)
'      If (idxUC > -1) Then
213:             If idxUC > -1 Then
'        lstN1.Remove (idxUC)
215:                 lstN1.Remove idxUC
'        lstN2.Remove (idxUC)
217:                 lstN2.Remove idxUC
'      End
219:             End If
'    End
221:         End If
'    uc = uc + 1
223:         UC = UC + 1
'  End
225:         SDMGlobals.SDMStatusBar.StepProgressBar
226:     Next pvar
227:     SDMGlobals.SDMStatusBar.HideProgressBar
'End
229: End If ' if nns
'sepChr = av.Run("gSDI.GetSeparatorChar",{})
     Dim sepChr As String
232: sepChr = "\"
'inputComponents = 0
     Dim inputComponents As Long
235: inputComponents = mcIndeces.Count
'J = 0
'For Each l In mcIndeces
'  missing = lstMD.Get(J)
'  idx = l.Get(1)
'  If (idx = -1) Then
'    inputComponents = inputComponents + 1
'  Else
'    If (catMCLists.Get(J).FindByValue(missing) > -1) Then
'      inputComponents = inputComponents + (catMCLists.Get(J).Count - 1)
'    Else
'      inputComponents = inputComponents + (catMCLists.Get(J).Count)
'    End
'  End
'  J = J + 1
'End

     Dim J As Long
238: J = 0
     Dim lstModes As SDMUtilities.SDMList
262: Set lstModes = New SDMUtilities.SDMList
     Dim lstvals As SDMUtilities.SDMList
264: For Each lstvals In lstsvals.list
        Dim missing As Long
244:    missing = lstMD.GetVal(J)
265:    lstModes.Add GetModalValue(lstvals, missing)
256:    J = J + 1
266: Next lstvals
'MsgBox ListtoString(lstModes), , "lstModes"

'dirTmp = av.Run("gSDI.GetTmpDir",{})
'if (dirTmp.Is(String)) then
'  MsgBox.Error(dirTmp,"Error getting SDI temporary directory.")
'  return Nil
'End
'If (nnu Or nns) Then
275: If nnu Or nns Then
'  strDef = fileName.GetCWD.MakeTmp("class", "dta")
'  nn1FN = FileDialog.Put(strDef, "*.dta", "Input to Neural Network")
        Dim nn1FN As Variant
279:    nn1FN = FileDialog.GetSaveFileName("Input to Neural Network(Class.dta)", FileDialog.getProjectDir, SDMUC.Name & "_Class.dta")
'  If (nn1FN = Nil) Then
281:     If IsEmpty(nn1FN) Then
'    return Nil
283:         Set gSDI_WriteNNFiles = Nothing
284:             GoTo theExit
'  End
286:     End If
'  'nn1FN = (dirTmp.AsString + sepChr + class.dta").AsFilename
'  nn1File = LineFile.Make(nn1FN,#FILE_PERM_WRITE)
         Dim fs As Object
290:     Set fs = CreateObject("Scripting.FileSystemObject")
         Dim nn1File As Object
292:     Set nn1File = fs.CreateTextFile(CStr(nn1FN(1)) & "\" & CStr(nn1FN(0)), True)
'  If (nn1File = Nil) Then
294:     If nn1File Is Nothing Then
'    MsgBox.Error("Unable to create file "+nn1FN.asString+" for writing.","Output Error")
296:         MsgBox "Unable to create file " & nn1FN(0) & " for writing.", vbCritical, c_sModuleFileName
'    return Nil
298:         Set gSDI_WriteNNFiles = Nothing
299:         GoTo theExit
'  End
301:     End If
'End
303: End If
'If (nns) Then
305: If nns Then
'  strDef = fileName.GetCWD.MakeTmp("train", "dta")
'  nn2FN = FileDialog.Put(strDef, "*.dta", "Training data set for RBFLN Neural Network")
         Dim nn2FN As Variant
309:     nn2FN = FileDialog.GetSaveFileName("Input to Neural Network(Train.dat)", FileDialog.getProjectDir, SDMUC.Name & "_Train.dta")
'  If (nn2FN = Nil) Then
311:     If IsEmpty(nn2FN) Then
'    return Nil
313:         Set gSDI_WriteNNFiles = Nothing
314:         GoTo theExit
'  End
316:     End If
'  'nn2FN = (dirTmp.AsString + sepChr + train.dta").AsFilename
'  nn2File = LineFile.Make(nn2FN,#FILE_PERM_WRITE)
         Dim nn2File As Object
320:     Set nn2File = fs.CreateTextFile(nn2FN(1) & "\" & nn2FN(0), True)
'  If (nn2File = Nil) Then
322:     If nn2File Is Nothing Then
'    MsgBox.Error("Unable to create file "+nn2FN.asString+" for writing.","Output Error")
324:        MsgBox "Unable to create file " & nn2FN(0) & " for writing.", vbCritical, c_sModuleFileName
'    av.Run("gSDI.PurgeFile",{nn1File})
326:        FileDialog.DeleteFilename CStr(nn1FN(1)) & "\" & CStr(nn1FN(0))
'    return Nil
328:        Set gSDI_WriteNNFiles = Nothing
329:        GoTo theExit
'  End
331:     End If
'End
333: End If
'nmbUC = lstsvals.Get(0).Count
     Dim nmbUC As Long
     Dim lst As SDMUtilities.SDMList
336: Set lst = lstsvals.getObj(0)
337: nmbUC = lst.Count
'If (nns) Then
339: If nns Then
'  nmbTrn = 0
         Dim nmbTrn As Long
342:     nmbTrn = 0
'  For Each p In lstPnts
344:     pProgbar.Position = 0
345:     SDMGlobals.SDMStatusBar.ShowProgressBar "Processing lstPnts...", 0, lstPnts.Count, 1, True
346:     For Each pvar In lstPnts.list
'    If (p > 0) Then
348:        If CLng(pvar) > 0 Then
'      nmbTrn = nmbTrn + 1    'p
350:             nmbTrn = nmbTrn + 1
'    End
352:         End If
'  End
354:        SDMGlobals.SDMStatusBar.StepProgressBar
355:     Next pvar
356:    SDMGlobals.SDMStatusBar.HideProgressBar
'  For Each p In lstN2
358:    pProgbar.Position = 0
359:    SDMGlobals.SDMStatusBar.ShowProgressBar "Processing lstN2...", 0, lstN2.Count, 1, True
360:     If Not lstN2 Is Nothing Then
361:        For Each pvar In lstN2.list
'    If (p > 0) Then
363:            If CLng(pvar) > 0 Then
'      nmbTrn = nmbTrn + 1    'p
365:                nmbTrn = nmbTrn + 1
'    End
367:            End If
'  End
369:            SDMGlobals.SDMStatusBar.StepProgressBar
370:        Next pvar
371:        SDMGlobals.SDMStatusBar.HideProgressBar
372:     End If
'End
374: End If
''curSel = theVTab.GetSelection
'If (nnu Or nns) Then
377: If nnu Or nns Then 'Class.dta header
'  nn1File.WriteElt (inputComponents.AsString)
379:     nn1File.writeline CStr(inputComponents)
'  If (nns) Then
381:     If nns Then
'    nn1File.WriteElt (nmbTrn.AsString)
383:         nn1File.writeline CStr(nmbTrn)
'  Else
385:     Else
'    nn1File.WriteElt ("5")
387:         nn1File.writeline "5"
'  End
389:     End If
'  nn1File.WriteElt ("1")
391:     nn1File.writeline "1"
'  nn1File.WriteElt (nmbUC.AsString)
        'Kluge to get correct number of UC used
         Dim nn1FileLines As String
         Dim kc As Long 'number of nn1File lines written
396:     kc = 0
'End
398: End If
'If (nns) Then
400: If nns Then 'Train.dta header
'  nn2File.WriteElt (inputComponents.AsString)
402:     nn2File.writeline CStr(inputComponents)
'  nn2File.WriteElt (nmbTrn.AsString)
404:     nn2File.writeline CStr(nmbTrn)
'  nn2File.WriteElt ("1")
406:     nn2File.writeline "1"
'  nn2File.WriteElt (nmbTrn.AsString)
'------------------- Kluge to get k not nmbUC into train.dta file
'401:     nn2File.writeline CStr(nmbTrn)
'End
411: End If

'av.ShowMsg ("Writing Neural Network files...")
414: pProgbar.Position = 0
415: SDMGlobals.SDMStatusBar.ShowProgressBar "Processing UCs...", 0, nmbUC, 1, True
' MsgBox ListtoString(lstN1), , "lstN1-NoDups"
' MsgBox ListtoString(lstN2), , "lstN2-NoDups"
' MsgBox ListtoString(lstPnts), , "lstPnts"

''********** unique id for training points
     Dim nn2FileLines As String
     Dim lstMinMax As SDMUtilities.SDMList
423: Set lstMinMax = New SDMUtilities.SDMList
424: J = 0
425: For Each lstvals In lstsvals.list
426:    lstMinMax.Add getMinMax(lstvals, lstMD.GetVal(J))
427:    J = J + 1
428: Next lstvals
     'MsgBox ListtoString(lstMinMax), , "lstMinMax"
'k = 1
     Dim k As Long
432: k = 1
'for each i in 0..(nmbUC - 1)
     Dim i As Long
435: For i = 0 To (nmbUC - 1)
436:     UC = i + 1
'  wLine = ""
         Dim wLine As String
439:     wLine = ""
'  wLine = wLine + (i + 1).AsString + ", "
441:     wLine = wLine & CStr(UC) & "," 'Class.dta
'  If (nns) Then
443:     If nns Then
'    strTrn = k.AsString + ","           'wLine
             Dim strTrn As String
446:         strTrn = k & "," 'Train.dta
'  End
448:     End If
'  If (nns) Then 'To set whether TPs or NDTPs are used
450:     If nns Then
'    nmbPoints = lstPnts.Get(i)
             Dim nmbPoints As Long
453:         nmbPoints = CLng(lstPnts.GetVal(i))
'  Else
455:     Else
'    nmbPoints = 0
457:         nmbPoints = 0
'  End
459:     End If
'  wLine = wLine + nmbPoints.AsString + ", "
461:     wLine = wLine & CStr(nmbPoints) & ","
'  If (nns) Then
463:     If nns Then 'To set whether TPs or NDTPs are used
'    If (nmbPoints = 0) Then
             Dim fid As Variant
466:         If nmbPoints = 0 Then
'      strTrn = strTrn + "0, "
468:            If NDTPFIDDict Is Nothing Then
469:                strTrn = strTrn & "1000," 'Train.dta
470:            Else
471:                fid = NDTPFIDDict.item(CStr(UC)) + 1000
472:                strTrn = strTrn & Format(fid, "###0") & "," 'Train.dta
473:            End If
'    Else
475:         Else
'      strTrn = strTrn + "1, "
477:            If TPFIDDict Is Nothing Then
478:                strTrn = strTrn & "1," 'Train.dta
479:            Else
480:                fid = TPFIDDict.item(CStr(UC))
481:                strTrn = strTrn & Format(fid, "###0") & "," 'Train.dta
482:            End If
'    End
484:         End If
'  End
486:     End If
'
'  Area = (lstAreas.Get(i) / 1000000) / unitcell
         Dim Area As Double
490:     Area = (CDbl(lstAreas.GetVal(i)) / 1000000) / unitcell
'  wLine = wLine + Area.SetFormat("d.dddddd").AsString + ", "
492:     wLine = wLine & Format(Area, "0.0#####") & "," 'Class.dta
'
'  If (nns) Then
495:     If nns Then
'    strTrn = strTrn + (i + 1).AsString + ", "
497:         strTrn = strTrn & CStr(UC) & "," 'Train.dta col3: UC value
'  End
499:     End If
'

'>>>> Loop through evidence fields of UC
'  J = 0
         Dim MDVAL As Boolean
505:     MDVAL = False
506:     J = 0
'  For Each lst In lstsvals
         Dim lstvar As Variant
509:     For Each lstvar In lstsvals.list
510:         Set lstvals = lstvar
'    lstCopy = lst.Clone
'    lstCopy.Sort (True)
'
'    minval = lstCopy.Get(0)
             Dim MinMaxVals As Variant
516:         MinMaxVals = lstMinMax.GetVal(J)
             Dim minVal As Double
518:         minVal = MinMaxVals(0)
'
'    rng = lstCopy.Get(lstCopy.Count - 1) - minval
             Dim maxVal As Double
522:         maxVal = MinMaxVals(1)
             Dim minmaxRange As Double
524:         minmaxRange = maxVal - minVal
'
'    missing = lstMD.Get(J)
527:         missing = lstMD.GetVal(J)
'    theVal = lst.Get(i)
             Dim theVal As Long
530:         theVal = lstvals.GetVal(i)
             Dim preVal As Long
532:         preVal = theVal
             Dim dblVal As Double
'
'    mcIdx = mcIndeces.Get(J).Get(1)
536:         Set lst = mcIndeces.getObj(J)
             Dim mcIdx As Variant
538:         mcIdx = lst.GetVal(1)
'    If (mcIdx < 0) Then
540:         If True Then 'Ordered & Free handled same way data
'      If (theVal = missing) Then
542:             If theVal = missing Then
'
'        theVal = lstWA.Get(J).Get(0)       'avgWeighted
546:                 Set lst = lstWA.getObj(J)
547:                 dblVal = lst.GetVal(0)
548:             Else
549:                 dblVal = theVal
'      End
551:             End If
'      '***************** normalizing value *****************
'      theVal = (theVal - minval) / rng
554:             dblVal = (dblVal - minVal) / minmaxRange
555:             If dblVal < 0 Then
556:                If MsgBox("(1) I=" & i & vbCrLf & "J=" & J & vbCrLf & _
                            "mcIdx=" & mcIdx & vbCrLf & "preVal=" & preVal & vbCrLf & _
                            "dblVal=" & dblVal & vbCrLf & "minVal=" & minVal & vbCrLf & _
                            "maxVal=" & maxVal & vbCrLf, vbYesNo, "Ordered,OK/missing") = vbNo Then
557:                    Err.Raise vbObjectError, , "Value out of min/max range"
558:                End If
559:            End If
'      wLine = wLine + theVal.SetFormat("d.dddddd").AsString + ", "
561:             wLine = wLine & Format(dblVal, "0.0#####") & "," 'Class.dta
'      If (nns) Then
563:             If nns Then
'        strTrn = strTrn + theVal.SetFormat("d.dddddd").AsString + ", "
565:                 strTrn = strTrn & Format(dblVal, "0.0#####") & ","    'Train.dta
'      End
567:             End If
'>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>> Free Data Handler >>>>>>>>>>>>>>>>>>>>>>>
'    Else
'
'      listVals = catMCLists.Get(J)
'      OFF = 0
'      ON = 1
'
'      If (theVal = missing) Then
'        M = 0
'        For Each v In lstvals
'          If (v = missing) Then
'            Continue
'          Else
'            valWA = lstWA.Get(J).Get(M)
'            wLine = wLine + valWA.AsString + ", "
'            If (nns) Then
'              strThm = strTrn + valWA.AsString + ", "
'            End
'            M = M + 1
'          End
'        End
'      Else
'        For Each v In listVals
'          If (v = missing) Then
'            Continue
'          End
'
'          If (theVal = v) Then
'            wLine = wLine + ON.AsString + ", "
'            If (nns) Then
'              strTrn = strTrn + ON.AsString + ", "
'          Else
'            wLine = wLine + OFF.AsString + ", "
'            If (nns) Then
'              strTrn = strTrn + OFF.AsString + ", "
'            End
'          End
'        End
'      End 'if var=missing
'    End
664:         End If ' If (mcIdx < 0)
'
'    J = J + 1
667:         J = J + 1
'  End
669:     Next lstvar
'
'>>>>>>>>>>>>>> Add zero to end of Class.dta line
'  wLine1 = wLine + "0"
         Dim wLine1 As String
674:     wLine1 = wLine & "0"
'>>>>>>>>>>>>>>> Add fuzzy membership to Train.dta line
'  If (nns) Then
677:     If nns And (Not lstN1 Is Nothing) Then
'673:        If Not MDVAL Then
'    idxN = lstN1.FindByValue(i + 1)
                Dim idxN As Long
681:            idxN = lstN1.FindByValue(UC) 'Unique Conditions are one-based
'    If (idxN > -1) Then
683:            If idxN > -1 Then 'if UC in non-dep TPs list
'      strTrn = strTrn + "0"
'>>> Fuzzy Memberships of non-deposit Training Site.
                    Dim val As Variant
687:                If NDTPFZMDict Is Nothing Then
688:                    strTrn = strTrn & Format(0#, "0.00000")    '"0"
689:                Else
        'The NDTPFZMDict dictionary key is STRING
691:                    val = CDbl(NDTPFZMDict.item(CStr(UC)))
692:                    strTrn = strTrn & Format(val, "0.00000")
693:                End If
'      nn2File.WriteElt (strTrn)
'649:             nn2File.writeline strTrn
'------------------- Kluge to get k not nmbUC into train.dta file
697:                nn2FileLines = nn2FileLines & strTrn & vbCrLf
'      k = k + 1
699:                k = k + 1
'    ElseIf (lstPnts.Get(i) > 0) Then
'>>> Fuzzy Memberships of Training Site.
702:            ElseIf lstPnts.GetVal(i) > 0 Then
'      strTrn = strTrn + "1"
        'The TPFZMDict dictionary key is STRING
705:                If TPFZMDict Is Nothing Then
706:                    strTrn = strTrn & Format(1#, "0.00000")    '"1"
707:                Else
708:                    val = CDbl(TPFZMDict.item(CStr(UC)))
709:                    strTrn = strTrn & Format(val, "0.00000")
710:                End If
'      nn2File.WriteElt (strTrn)
'664:             nn2File.writeline strTrn
'------------------- Kluge to get k not nmbUC into train.dta file
714:                nn2FileLines = nn2FileLines & strTrn & vbCrLf
'      k = k + 1
716:                k = k + 1
'    End
718:            End If 'if idxN > -1
'714:        End If 'MDVAL
'  End
721:     End If 'if nss & lstN1 not Nothing
'
'  If (nnu Or nns) Then
724:     If nnu Or nns Then
'    nn1File.WriteElt (wLine1)
             'If Not MDVAL Then
727:            nn1FileLines = nn1FileLines & wLine1 & vbCrLf
728:            kc = kc + 1
             'End If
'  End
731:     End If
'
'  aPercent = i / (nmbUC - 1) * 100
'  av.SetStatus (aPercent)
735:      SDMGlobals.SDMStatusBar.StepProgressBar
'End
737: Next i
738:      SDMGlobals.SDMStatusBar.HideProgressBar
'If (nnu Or nns) Then
740: If nnu Or nns Then
'  nn1File.Close
'------------------- Kluge to get k not nmbUC into class.dta file
743:    nn1File.writeline CStr(kc) & vbCrLf & nn1FileLines
744:    nn1File.Close
'End
746: End If
'If (nns) Then
748: If nns Then
'  nn2File.Close
'------------------- Kluge to get k not nmbUC into train.dta file
751:     nn2File.writeline CStr(k - 1) & vbCrLf & nn2FileLines
752:     nn2File.Close
'End
754: End If
'av.ShowMsg ("")
756: SDMGlobals.SDMStatusBar.Message(0) = ""
'If (nnu) Then
758: If nnu Then
'  return nn1File
760:     Set gSDI_WriteNNFiles = nn1File
761:          GoTo theExit
'Else
763: Else
'  return nn2File
765:     Set gSDI_WriteNNFiles = nn2File
766:          GoTo theExit
'End
768: End If
theExit:
770: If Not gSDI_WriteNNFiles Is Nothing Then
771:     If MsgBox("Writing Neural Network input files is complete." & vbCrLf & "View input files?", vbYesNo, "Writing Neural Network Input") = vbYes Then
772:        Load gNNInput
773:        gNNInput.SetInputFiles nn1FN(1) & "\" & nn1FN(0), nn2FN(1) & "\" & nn2FN(0)
774:        gNNInput.Show vbModal
775:     End If
776: End If
'770: Open "C:\TEMP\NNLists.txt" For Output As #1   ' Open file for output.
'771: Write #1, NNInputLists
'772: Close #1
'<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
Exit Function
ErrorHandler:
  HandleError True, c_sModuleFileName & " " & GetErrorLineNumberString(Erl), Err.Number, Err.Source, Err.Description, 4
784:   Set gSDI_WriteNNFiles = Nothing
End Function

Private Function getMinMax(ByRef lst As SDMUtilities.SDMList, missingData As Long) As Variant
788:          ProgressAnimation.Show ("Getting UC mins/maxes...")
         Dim min As Long, max As Long
         Dim sortedLst As SDMUtilities.SDMList
791:          Set sortedLst = lst.RemoveDuplicates.Sort(True)
         'MsgBox sortedLst.asString, , "Sort List"
793:          min = sortedLst.GetVal(0)
794:          If min = missingData Then min = sortedLst.GetVal(1)
795:          max = sortedLst.GetVal(sortedLst.Count - 1)
796:     getMinMax = Array(min, max)
797:          ProgressAnimation.Hide
End Function


Function MaxFZMforUC(SDMUC As IRasterLayer, TPs As IFeatureLayer, FZMbrFld As esrigeodatabase.IField, FZM As Double) As Variant
  On Error GoTo ErrorHandler

         Dim MaxFZMDict As Object
805:     Set MaxFZMDict = CreateObject("Scripting.Dictionary")
         Dim MaxFIDDict As Object
807:     Set MaxFIDDict = CreateObject("Scripting.Dictionary")
         
'   Getting TPs for UCs
         Dim dspTbl As IDisplayTable
811:     Set dspTbl = SDMUC
    
         Dim rasBuf As IRasterBuffer
814:     Set rasBuf = New IRasterBuffer
815:     If Not rasBuf.OpenBuffer(SDMUC) Then
816:         MsgBox "Illegal integer raster type", , c_sModuleFileName
817:         Set MaxFZMforUC = Nothing
            Exit Function
819:     End If
    
         Dim fzmFldidx As Long
822:     If Not FZMbrFld Is Nothing Then fzmFldidx = TPs.FeatureClass.FindField(FZMbrFld.Name)
        
         Dim Dict As Object
825:     Set Dict = CreateObject("Scripting.Dictionary")
    
         Dim featCls As IFeatureClass
828:     Set featCls = TPs.FeatureClass
    
         Dim featSel As IFeatureSelection
831:     Set featSel = TPs
         Dim featSelSet As ISelectionSet
833:     Set featSelSet = featSel.SelectionSet
         Dim fEnumIDs As IEnumIDs
835:     Set fEnumIDs = featSelSet.IDs
         Dim fid As Long
837:     fid = fEnumIDs.Next
         Dim tpsTbl As ITable
839:     Set tpsTbl = TPs
    
         Dim pProgbar As IStepProgressor
842:     Set pProgbar = SDMGlobals.SDMStatusBar.ProgressBar

844:     pProgbar.Position = 0
845:     SDMGlobals.SDMStatusBar.ShowProgressBar "Getting FZMs for UCs...", 1, featSelSet.Count, 1, True
846:     While fid <> -1
             Dim feat As IFeature
848:         Set feat = featCls.GetFeature(fid)
             'Dim ExtrUCVal As Long
             'ExtrUCVal = feat.Value(feat.Fields.FindField("RasterValu"))
             Dim pnt As IPoint
852:         Set pnt = feat.Shape
             Dim cellVal As Variant
854:         cellVal = rasBuf.CellValue(pnt)
855:         If IsNull(cellVal) Then
856:         ElseIf cellVal <> "NoData" Then
857:             If Not Dict.Exists(cellVal) Then Dict.Add cellVal, New SDMUtilities.SDMList
                 Dim list As SDMUtilities.SDMList
859:             Set list = Dict.item(cellVal)
860:             If FZMbrFld Is Nothing Then
861:                list.Add Array(CLng(fid), FZM)
862:             Else
863:                list.Add Array(CLng(fid), CDbl(feat.Value(fzmFldidx))) 'Saving fuzzy membership and FID of TP for key=UC
864:             End If
865:         End If
866:         fid = fEnumIDs.Next
867:         SDMGlobals.SDMStatusBar.StepProgressBar
868:     Wend
869:     SDMGlobals.SDMStatusBar.HideProgressBar
    
871:     ProgressAnimation.Show "Getting FZ Membership maxima..."
         Dim UCKey As Variant
873:     For Each UCKey In Dict.keys
874:         Set list = Dict.item(UCKey)
             Dim maxFZM As Double
             Dim maxFID As Long
877:         maxFZM = -1#
             Dim item As Variant
879:         For Each item In list.list
880:             If CDbl(item(1)) > maxFZM Then
881:                maxFID = CLng(item(0))
882:                maxFZM = CDbl(item(1))
883:             End If
884:         Next item
             'MsgBox ListtoString(list), , TPs.Name & ": " & CStr(UCKey) & ": " & CStr(maxFID) & ": " & CStr(maxFZM)
886:         MaxFZMDict.Add UCKey, maxFZM
887:         MaxFIDDict.Add UCKey, maxFID
888:     Next UCKey
889:     MaxFZMforUC = Array(MaxFZMDict, MaxFIDDict)
890:     ProgressAnimation.Hide


  Exit Function
ErrorHandler:
         HandleError True, "MaxFZMforUC " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), Err.Number, Err.Source, Err.Description, 4
896:     Set MaxFZMforUC = Nothing
         Dim rasprops As IRasterProps
898:     Set rasprops = SDMUC.Raster
899:     MsgBox "Raster type: " & rasprops.PixelType, , c_sModuleFileName
End Function

Function GetModalValue(lstvals As SDMUtilities.SDMList, missing As Long) As Double
903:     ProgressAnimation.Show ("Getting UC modes...")
'Get histogram
    Dim hist As SDMUtilities.SDMDictionary
906:     Set hist = New SDMUtilities.SDMDictionary
    Dim val As Variant
908:     For Each val In lstvals.list
909:         If hist.Exists(val) Then
910:             hist.Add val, hist.Gett(val) + 1
911:         Else
912:             hist.Add val, 1
913:         End If
914:     Next val
    
'Get mode
    Dim mode As Long
918:     mode = missing
    Dim keys As Variant
920:     keys = hist.ReturnKeys
    Dim modeVal As Long
    Dim key As Variant
923:     For Each key In keys
924:         If hist.Exists(key) > mode Then
925:             mode = hist.Gett(key)
926:             modeVal = key
927:         End If
928:     Next key
    
'Return mode
931:     GetModalValue = modeVal
932:     ProgressAnimation.Hide
    
End Function
Function DisplayDict(Name As String, Dict As Object)
  On Error GoTo ErrorHandler


         Dim S As String
940:     S = ""
         Dim key As Variant
942:     For Each key In Dict.keys()
943:         S = S & VarType(key) & ":" & CStr(key) & "=" & Dict.item(key) & vbCrLf
944:     Next key
945:     MsgBox S, vbInformation, Name


  Exit Function
ErrorHandler:
  HandleError True, "DisplayDict " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), Err.Number, Err.Source, Err.Description, 4
End Function


