VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "gSDI_WriteRandom"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = True
Option Explicit
' Variables used by the Error handler function - DO NOT REMOVE
Const c_sModuleFileName As String = "gSDI_WriteRandom"       ' Constant reflect file module name
Const c_sDLLFileName As String = "AnalysisParameters"       ' Constant reflect file module name
Private ObjectTag As Object
Public Property Set setObjectTag(anObject As Object)
7:     Set ObjectTag = anObject
End Property
Public Property Get getObjectTag() As Object
10:     Set getObjectTag = ObjectTag
End Property

Sub gSDI_WriteRandom(ByRef tpFtab As ITable, HasRandom As Boolean)

On Error GoTo ErrorHandler

'PUT THE IMPLEMENTATION HERE >>>>>>>>>>>>>
'Function gSDI_WriteRandom() As Variant
'
'Dim randomField As New IAVField
'Dim randomfield As esrigeodatabase.IField
'Dim record As Variant
'Dim record As Long
'Dim self As Collection
'
'Dim tpFtab As New IAVVTab
'
'' Name:  gSDI.WriteRandom
''Topics:  Spatial Data Modeller
''
''Description:  Checks for a field in
''  the point theme attribute table called 'Random'
''  Prompts user to overwrite if found.
''  Overwrites or creates, and writes a random
''  number between 1 and 1000 in for each record.
''
''Requires:
''
'' Self:  list containing a training point theme attribute table
''
''Returns:
''==============================================
'
'tpFtab = self.Get(0)
'
'If (tpFtab.CanEdit) Then
'
'tpFtab.SetEditable (True)
'
'If (tpFtab.FindField("Random") = Null) Then
'
'If (Not (tpFtab.CanAddFields)) Then
'
'MsgBox.Error("Can't add fields to the table."+NL+"Check write permission."," Can't add randomly generated numbers.")
'
'Let gSDI_WriteRandom = Null
'
'Else
'
'randomField=Field.Make("Random",#FIELD_LONG,10,0)
'
'tpFtab.AddFields (Array(randomField))
'
'End If
'
'End If
67: If (Not HasRandom) Then
    Dim randFld As esrigeodatabase.IField
69:     Set randFld = New esrigeodatabase.Field
    Dim pfldEdit As esrigeodatabase.IFieldEdit
71:     Set pfldEdit = randFld
72:     With pfldEdit
73:         .Name = "Random"
74:         .length = 10
75:         .Type = esriFieldTypeInteger
76:     End With
77:     tpFtab.AddField randFld
78: End If
Dim randfldidx As Long
80: randfldidx = tpFtab.FindField("Random")

'For Each record In tpFtab
'tpFtab.SetValue(tpFTab.FindField("Random"),record,Number.MakeRandom(1,1000))
'NEXT
'Ok to add random values to "Random" field of all records in table
93: Randomize
Dim curs As ICursor
95: Set curs = tpFtab.Update(Nothing, False)
Dim row As irow
97: Set row = curs.NextRow
98: Do Until row Is Nothing
99:     row.Value(randfldidx) = Rnd * 1000
100:     curs.UpdateRow row
101:     Set row = curs.NextRow
102: Loop
'tpFTab.SetEditable (False)
'Else
'
'MsgBox.Error("Can't modify the feature table."+NL+"Check write permission.","Can't add randomly generated numbers.")
'
'Let gSDI_WriteRandom = Null
'
'End If
'
'tpFtab.Flush
'
'tpFtab.Refresh
'
'End Function

'<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
Exit Sub
ErrorHandler:
  HandleError True, c_sDLLFileName & " " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), Err.Number, Err.Source, Err.Description, 4
End Sub

