VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "gTsh_tol_Thrs_Click"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = True
Option Explicit
Const c_sModuleFileName As String = "gTsh_tol_Thrs_Click.cls"

Public Sub gTsh_tol_Thrs_Click()
  On Error GoTo ErrorHandler

        Dim tblWin As ITableWindow
        Dim tbl As ITable
        Dim thrshFrm As Form
        Dim openObj As IUnknown
11:     Set openObj = gTsh.getOpenObject
12:     If openObj Is Nothing Then
            Exit Sub
15:     ElseIf TypeOf openObj Is IDataGraphWindow Then
17:         Set thrshFrm = gTsh
            Dim datTblWin As IDataGraphWindow
19:         Set datTblWin = openObj
            If (datTblWin Is Nothing) Then Exit Sub
21:         Set tbl = datTblWin.DataGraph.Table
22:         Set tblWin = gTsh.getOpenObject2
            Dim srcName As String
24:         srcName = datTblWin.DataGraph.Name
25:     ElseIf TypeOf openObj Is ITableWindow Then
27:         Set thrshFrm = gTsh
28:         Set tblWin = openObj
            If (tblWin Is Nothing) Then Exit Sub
30:         Set tbl = tblWin.Table
            Dim tblDS As IDataset
32:         Set tblDS = tbl
33:         srcName = tblDS.Name
36:     End If
    
        Dim classFldIdx As Long
39:     classFldIdx = tbl.FindField("Class")
40:     If (classFldIdx = -1) Then
41:         MsgBox "Expecting Table with a field named ""Class""", vbCritical, "Generalize Evidence"
            Exit Sub
43:     End If
        Dim selSet As ISelectionSet
45:     Set selSet = tblWin.SelectionSet
46:     If selSet.Count = 0 Then
47:         MsgBox "No table rows selected", vbCritical, "Generalize Evidence"
            Exit Sub
49:     End If
        Dim linesStr As String
51:     If srcName Like "*_CD*" Then
52:         linesStr = MakeSelListCD(tbl, selSet)
53:     ElseIf srcName Like "*_CA*" Then
54:         linesStr = MakeSelListCA(tbl, selSet)
55:     Else
56:         MsgBox srcName & " table cannot be used in this generalization.", vbExclamation, c_sModuleFileName
            Exit Sub
57:     End If
        Dim lines As Variant
59:     lines = Split(linesStr, vbCrLf)
60:     gTsh.lbx_Clss.Clear
        Dim Index As Long
62:         Index = 0
        Dim line As Variant
64:     For Each line In lines
            Dim cells As Variant
66:         cells = Split(line, ",")
            Dim rowStr As String
68:         rowStr = Join(cells, vbTab)
69:         thrshFrm.lbx_Clss.AddItem rowStr, Index
70:         Index = Index + 1
71:     Next line
Exit Sub
ErrorHandler:
  HandleError True, "gTsh_tol_Thrs_Click " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), Err.Number, Err.Source, Err.Description, 4
End Sub

Private Function MakeSelListCD(CDTbl As ITable, cdSel As ISelectionSet) As String
  On Error GoTo ErrorHandler

        Dim clsFldIdx As Long
81:     clsFldIdx = CDTbl.FindField("Class")
        Dim leftOid As Long
83:     leftOid = 0
        Dim ID As Long
85:     ID = cdSel.Count + 1
        Dim OIDs As IEnumIDs
87:     Set OIDs = cdSel.IDs
        Dim OID As Long
89:     OIDs.Reset
90:     OID = OIDs.Next
        Dim s As String
92:     If OID <> -1 Then
93:         s = ID & "," & CDTbl.GetRow(OID).Value(clsFldIdx) & " - " & CDTbl.GetRow(leftOid).Value(clsFldIdx) & "," & "Inside" & vbCrLf
94:         leftOid = OID
95:         ID = ID - 1
96:     End If
97:     OID = OIDs.Next
98:     While OID <> -1
99:         s = ID & "," & CDTbl.GetRow(OID).Value(clsFldIdx) & " - " & CDTbl.GetRow(leftOid + 1).Value(clsFldIdx) & "," & "Inside" & ID & vbCrLf & s
100:         leftOid = OID
101:         ID = ID - 1
102:         OID = OIDs.Next
103:     Wend
        Dim lastOid As Long
105:     lastOid = CDTbl.RowCount(Nothing) - 1
106:     If CDTbl.GetRow(lastOid).Value(clsFldIdx) = -99 Then
107:         s = ID & "," & CDTbl.GetRow(lastOid - 1).Value(clsFldIdx) & " - " & CDTbl.GetRow(leftOid + 1).Value(clsFldIdx) & "," & "Outside" & vbCrLf & s
108:         s = "0,-99,Missing" & vbCrLf & s
109:    Else
110:         s = ID & "," & CDTbl.GetRow(lastOid).Value(clsFldIdx) & " - " & CDTbl.GetRow(leftOid + 1).Value(clsFldIdx) & "," & "Outside" & vbCrLf & s
111:    End If
112:    MakeSelListCD = s

  Exit Function
ErrorHandler:
  HandleError False, "MakeSelListCD " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), Err.Number, Err.Source, Err.Description, 4
End Function
Private Function MakeSelListCA(CATbl As ITable, cdSel As ISelectionSet) As String
  On Error GoTo ErrorHandler

         Dim clsFldIdx As Long
122:     clsFldIdx = CATbl.FindField("Class")
         Dim leftOid As Long
124:     leftOid = 0
         Dim ID As Long
126:     ID = cdSel.Count + 1
         Dim OIDs As IEnumIDs
128:     Set OIDs = cdSel.IDs
         Dim OID As Long
130:     OID = OIDs.Next
         Dim s As String
132:     If CATbl.GetRow(leftOid).Value(clsFldIdx) = -99 Then
133:          s = s & "0,-99,Missing" & vbCrLf
134:          leftOid = leftOid + 1
135:     End If
136:     While OID <> -1
137:         If ID = cdSel.Count + 1 Then
138:            s = s & ID & "," & CATbl.GetRow(leftOid).Value(clsFldIdx) & " - " & CATbl.GetRow(OID).Value(clsFldIdx) & "," & "Inside" & vbCrLf
139:         Else
140:            s = s & ID & "," & CATbl.GetRow(leftOid + 1).Value(clsFldIdx) & " - " & CATbl.GetRow(OID).Value(clsFldIdx) & "," & "Inside" & (cdSel.Count - ID + 2) & vbCrLf
141:         End If
142:         leftOid = OID
143:         ID = ID - 1
144:         OID = OIDs.Next
145:     Wend
         Dim lastOid As Long
147:     lastOid = CATbl.RowCount(Nothing) - 1
148:     s = s & ID & "," & CATbl.GetRow(leftOid + 1).Value(clsFldIdx) & " - " & CATbl.GetRow(lastOid).Value(clsFldIdx) & "," & "Outside" & vbCrLf
149:     MakeSelListCA = s

  Exit Function
ErrorHandler:
  HandleError False, "MakeSelListCA " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), Err.Number, Err.Source, Err.Description, 4
End Function

