VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "gl_btnClc_Click"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = True
Option Explicit
Private anlParms As AnalysisParameters.AnlParams
Private gParam As Form
Const c_sModuleFileName As String = "gL_btnClc_Click"
Const c_sDLLFileName As String = "CalculateResponse"       ' Constant reflect file module name
'Private ObjectTag As Object
'Property Set setObjectTag(anObject As Object)
'    Set ObjectTag = anObject
'End Property
'Property Get getObjectTag() As Object
'    Set getObjectTag = ObjectTag
'End Property

Public Sub gL_btnClc_Click(Self As Object)
  On Error GoTo ErrorHandler
'PUT THE IMPLEMENTATION HERE >>>>>>>>>>>>>
'' Name:    gL.btnClc.Click
'' Topics:  Spatial Data Modeller
'' Description:  Runs the processing of weights of
''      evidence, external modules for logistic
''      regression and neural network.
'' Requires:
'' Self:     gL (list) dialog

'' Returns:  Nil
''==============================================
'Test for Training Points selection
'av.UseWaitCurso
'gL = self.GetDialog
''TEXT FILE POINTER
''------------------------------------------
'statfile = Nil
Dim statfile As Variant
34: statfile = Empty
''CHECK WHETHER WEIGHTS OR EXPERT WEIGHTS BUTTON CALLED SCRIPT
''------------------------------------------
'if ((self = gL.FindByName("lbt_Wt")).Not) then
38: If Not Self Is gL.lbt_Wt Then
'  MsgBox.Error("The gL.btnClc.Click script must be run"+NL+
'               "from within the Spatial Data Modeller extension.","Spatial Data Modeller")
'  return Nil
42:     MsgBox "Invoke ""Expert Weights"" in the Analysis Parameters dialog", vbCritical, "Spatial Data Modeller"
        Exit Sub
'End
45: End If
'gP = av.FindDialog("gParam")
'If (gP.findByName("chkWofE").IsSelected) Then
    Dim gPChkWofE As CheckBox
49: Set gPChkWofE = gParam.chkwofe
50: If gPChkWofE.Value = 1 Then
'  If (gP.findByName("cpTch").GetSelected = gP.findByName("radExpt")) Then
52:     If gParam.radExpt Then
            Dim expert As Boolean
54:         expert = gParam.radExpt
'    expert = True
'  Else
57:     Else
'    expert = False
59:         expert = False
'  End
61:     End If
'Else
63: Else
'  expert = False
65:     expert = False
'End
67: End If
    Dim TPName As String
    Dim featLyr As IFeatureLayer
70: If gParam.chkwofe.Value <> 1 And gParam.chkNN.Value = 1 And gParam.chkNNSup.Value = 1 Then
71:     TPName = gParam.cbxTP.Text
72:     Set featLyr = WOETableUtils.FindLayerByName(TPName)
73:     If Not featLyr Is Nothing Then
        'Training Sites fuzzy memberships
            Dim pFeatureClass As IFeatureClass
76:         Set pFeatureClass = featLyr.FeatureClass
            Dim pfields As IFields
78:         Set pfields = pFeatureClass.Fields
            Dim pField As IField
80:         FuzzyMbrShpDialog.cbx_FMField.Clear
            Dim i As Long
82:         For i = 3 To (pfields.FieldCount - 1)
83:             Set pField = pfields.Field(i)
84:             If pField.Type = esriFieldTypeDouble Or pField.Type = esriFieldTypeSingle Then _
                    FuzzyMbrShpDialog.cbx_FMField.AddItem pField.AliasName
86:         Next i
87:         FuzzyMbrShpDialog.Caption = "Fuzzy Membership for Deposit Training Sites"
88:         FuzzyMbrShpDialog.cbx_FMField.AddItem "<None>"
89:         FuzzyMbrShpDialog.cbx_FMField.ListIndex = FuzzyMbrShpDialog.cbx_FMField.ListCount - 1
            Dim fuzzyMessage As String
91:         fuzzyMessage = "Select <None> for 0 and 1 fuzzy memberships or" & vbCrLf & _
                                           "fuzzy membership attribute for deposit training sites:" & featLyr.Name & vbCrLf & _
                                           "Then click ""Selected attribute"" button" & vbCrLf & _
                                           "Or click ""Cancel"" to quit processing neural network."
95:         FuzzyMbrShpDialog.lblMessage = fuzzyMessage
96:         FuzzyMbrShpDialog.Show vbModal
97:         If FuzzyMbrShpDialog.Tag = FuzzyMbrShpDialog.CancelButton.Tag Then
98:                 Unload FuzzyMbrShpDialog
                    Exit Sub
100:         ElseIf FuzzyMbrShpDialog.Tag = FuzzyMbrShpDialog.OKButton.Tag Then
101:             If FuzzyMbrShpDialog.cbx_FMField.Text = "<None>" Then
102:                 gL.FMTPfield = Array(Nothing, -1)
103:             Else
104:                 gL.FMTPfield = Array(pFeatureClass, pfields.Field(pfields.FindField(FuzzyMbrShpDialog.cbx_FMField.Text)))
105:             End If
106:        End If
107:     End If 'featlayer is nothing
        'Training Sites fuzzy memberships
109:     TPName = gParam.cbxNTP.Text
110:     Set featLyr = WOETableUtils.FindLayerByName(TPName)
111:     If Not featLyr Is Nothing Then
112:         TPName = gParam.cbxNTP.Text
113:         Set featLyr = WOETableUtils.FindLayerByName(TPName)
114:         Set pFeatureClass = featLyr.FeatureClass
115:         Set pfields = pFeatureClass.Fields
116:         FuzzyMbrShpDialog.cbx_FMField.Clear
117:         For i = 3 To (pfields.FieldCount - 1)
118:             Set pField = pfields.Field(i)
119:             If pField.Type = esriFieldTypeDouble Or pField.Type = esriFieldTypeSingle Then _
                    FuzzyMbrShpDialog.cbx_FMField.AddItem pField.AliasName
121:         Next i
122:         FuzzyMbrShpDialog.Caption = "Fuzzy Membership for Non-Deposit Training Sites"
123:         FuzzyMbrShpDialog.cbx_FMField.AddItem "<None>"
124:         FuzzyMbrShpDialog.cbx_FMField.ListIndex = FuzzyMbrShpDialog.cbx_FMField.ListCount - 1
125:         fuzzyMessage = "Select <None> for 0 and 1 fuzzy memberships or" & vbCrLf & _
                                           "fuzzy membership attribute for deposit training sites:" & featLyr.Name & vbCrLf & _
                                           "Then click ""Selected attribute"" button" & vbCrLf & _
                                           "Or click ""Cancel"" to quit processing neural network."
129:         FuzzyMbrShpDialog.lblMessage = fuzzyMessage
130:         FuzzyMbrShpDialog.Show vbModal
131:         If FuzzyMbrShpDialog.Tag = FuzzyMbrShpDialog.CancelButton.Tag Then
132:                Unload FuzzyMbrShpDialog
                    Exit Sub
134:         ElseIf FuzzyMbrShpDialog.Tag = FuzzyMbrShpDialog.OKButton.Tag Then
135:             If FuzzyMbrShpDialog.cbx_FMField.Text = "<None>" Then
136:                 gL.FMNTPfield = Array(Nothing, -1)
137:             Else
138:                 gL.FMNTPfield = Array(pFeatureClass, pfields.Field(pfields.FindField(FuzzyMbrShpDialog.cbx_FMField.Text)))
139:             End If
140:        End If
141:        Unload FuzzyMbrShpDialog
142:        gL.Refresh
143:     End If 'featlayer is nothing
144: End If 'gParam.chkNN = 1
'If (expert) Then
146: If expert And (gParam.chkNN <> 1) Then
'MsgBox "Expert mode of Weights of Evidence is not implemented", vbExclamation, "Calculate Response";Exit Sub

'  MsgBox.Info("You will be prompted to specify expert weights" + NL +
'              "after specifying file names for the unique " + NL +
'              "conditions grid and weights tables.","Weights of Evidence (Expert Option)")
152:   If MsgBox("You will be prompted to specify expert weights" + vbCrLf + _
              "after specifying file names for the weights tables. Continue?" _
              , vbYesNo, "Weights of Evidence (Expert Option)") = vbNo Then Exit Sub
'End
156: End If
'' GET THE CURRENT VIEW'S PROJECTION
''-------------------------------------------------
'viewActive = gL.GetActiveDoc
     Dim viewActive As IMap
161: Set viewActive = SDMGlobals.SDMUtil.getMap
'prjCrnt = viewActive.GetProjection
     Dim prjCrnt As IProjection
'nmbNull = Number.MakeNull
     Dim nmbNull As Variant
166: nmbNull = Empty
'' GET THE LIST OF EVIDENCE MAPS, COUNT THEM
''-------------------------------------------------
'lstTNames = gL.findByName("lbx_Cur").GetList
     Dim lstTNames As SDMUtilities.SDMList
171: Set lstTNames = getLbxList(gL.lbx_Cur)
'cntThms = lstTNames.Count
     Dim cntThms As Long
174: cntThms = lstTNames.Count
'' GET LIST OF VALUE FIELDS CORRESPONDING TO EACH EVIDENCE MAP
''-------------------------------------------------
'lstLists = gL.findByName("lbt_Nw").getObjectTag
     Dim lstLists As New SDMUtilities.SDMList
179: lstLists.AddArray gL.lbt_Nw_getObjectTag
'lstFlds = lstLists.Get(0)
     Dim lstFlds As SDMUtilities.SDMList
182: Set lstFlds = lstLists.getObj(0)
'lstMD = lstLists.Get(1)
     Dim lstMD As SDMUtilities.SDMList
185: Set lstMD = lstLists.getObj(1)
'MsgBox "MD list:" & vbCrLf & lstMD.asString, , c_sModuleFileName
''lstClp = lstLists.Get(2)
'lstClp = {}
     Dim lstClp As New SDMUtilities.SDMList
'lstLists = Nil

'MsgBox "lstFlds: " & vbCrLf & lstFlds.AsString, , c_sModuleFileName
'MsgBox "lstMD: " & vbCrLf & lstMD.AsString, , c_sModuleFileName
'lstThms = List.Make
     Dim lstThms As New SDMUtilities.SDMList
'tIsStr = lstTNames.Get(0).Is(String)
'If (tIsStr) Then
'  For Each tn In lstTNames
     Dim tn As Variant
200: For Each tn In lstTNames.list
'    thm = viewActive.FindTheme(tn)
             Dim thm As ILayer
203:         Set thm = SDMGlobals.SDMUtil.FindLayerByName(CStr(tn))
'    If (thm <> Nil) Then
205:         If Not thm Is Nothing Then
'      lstThms.Add (thm)
207:             lstThms.Add thm
'    Else
209:         Else
'      idx = lstTNames.Find(tn)
            Dim idx As Long
212:             idx = lstTNames.FindByValue(tn)
'      lstFlds.Remove (idx)
214:             lstFlds.Remove idx
'    End
216:         End If
'  End
218:     Next tn
'Else
'  lstThms = lstTNames
'  lstTNames = List.Make
'  For Each t In lstThms
'    lstTNames.Add (t.GetName)
'  End
'End
'MsgBox lstThms.AsString, , "lstThms"
'fIsStr = lstFlds.Get(0).Is(String)
'ot = List.Make
        Dim ot As New SDMUtilities.SDMList
'If ((fIsStr) And (tIsStr)) Then
'  for each i in 0..(lstFlds.Count - 1)
        'Dim i As Long
233:     For i = 0 To lstFlds.Count - 1
'    ot.Add({lstTNames.Get(i) + ", " + lstFlds.Get(i)})
             Dim tmpLst As SDMList
236:         Set tmpLst = New SDMList
237:         tmpLst.Add lstTNames.GetVal(i) & ", " & lstFlds.GetVal(i)
238:         ot.Add tmpLst
'  End
240:     Next i
'ElseIf ((fIsStr) And (tIsStr.Not)) Then
'  lstTNames = List.Make
'  for each i in 0..(lstFlds.Count - 1)
'    ot.Add({lstThms.Get(i).GetName +", " + lstFlds.Get(i)})
'  End
'ElseIf ((fIsStr.Not) And (tIsStr)) Then
'  for each i in 0..(lstFlds.Count - 1)
'    ot.Add({lstTNames.Get(i) + ", " + lstFlds.Get(i).GetName})
'  End
'ElseIf ((fIsStr.Not) And (tIsStr.Not)) Then
'  for each i in 0..(lstFlds.Count -1)
'    ot.Add({lstThms.Get(i).GetName + ", " + lstFlds.Get(i).GetName})
'  End
'End
'
'' make list of poly/grid flags
''-------------------------------------------------
'lstTypes = av.Run("gSDI.MakeListFlags",{lstThms})
     Dim gSDIMakeListFlags As gSDI_MakeListFlags
260: Set gSDIMakeListFlags = New gSDI_MakeListFlags
     Dim lstTypes As SDMUtilities.SDMList
262: Set lstTypes = gSDIMakeListFlags.gSDI_MakeListFlags(lstThms)
'' make the unique conditions grid
''-------------------------------------------------
'listUCBM = av.Run("gSDI.MakeUniqueConditions",{lstThms,lstFlds,lstMD,lstClp,lstTypes,"W"})
     Dim listUCBM As SDMUtilities.SDMList
     Dim gSDIMakeUniqueConditions As gSDI_MakeUniqCondits
268: Set gSDIMakeUniqueConditions = New gSDI_MakeUniqCondits
269: Set listUCBM = gSDIMakeUniqueConditions.gSDI_MakeUniqueConditions(Array(lstThms, lstFlds, lstMD, lstClp, lstTypes, "W"))
'If (listUCBM = Nil) Then
271: If listUCBM Is Nothing Then
272:     MsgBox "Error Creating Unique Conditions: Unknown", , c_sModuleFileName
'  return Nil
         Exit Sub
275: ElseIf listUCBM.IsEmpty Then
276:     MsgBox "Error Creating Unique Conditions: Unknown", , c_sModuleFileName
         Exit Sub
'elseif (listUCBM.Is(String)) then
279: ElseIf listUCBM.Count = 1 Then
'  MsgBox.Error(listUCBM,"Error Creating Unique Conditions")
281:     MsgBox "Error Creating Unique Conditions: " & listUCBM.GetVal(0), , c_sModuleFileName
'  return Nil
         Exit Sub
284: ElseIf listUCBM.Count = 4 Then
'     MsgBox "Continuing normally...", , c_sModuleFileName
286: Else
287:     MsgBox "Error Creating Unique Conditions: Unknown", , c_sModuleFileName
         Exit Sub
'End
290: End If

'grdUC = listUCBM.Get(0)
     Dim thmUC As IRasterLayer
294: Set thmUC = listUCBM.getObj(0)
     Dim grdUC As IRaster
296: Set grdUC = RasterUtils.GetDatasetRaster(thmUC)
'thmSA = listUCBM.Get(1)
'Dim thmSA As IGeoDataset
'192: Set thmSA = listUCBM.GetObj(1)
     Dim joinTable As ITable
301: Set joinTable = listUCBM.getObj(2)
     Dim tmpRastList As SDMList 'List of temp raster objects from evidence layers not needed from here
303: Set tmpRastList = listUCBM.getObj(3)
'MsgBox "tmpRastList" & vbCrLf & ListtoString(tmpRastList), , c_sModuleFileName
'listUCBM = Nil
306: Set listUCBM = Nothing
'thmUC = GTheme.Make(grdUC)
'If (grdUC.HasTempDataSet) Then
'  srcUC = grdUC.GetSrcName
'  If (srcUC <> Nil) Then
'    grdUC.SaveDataSet (srcUC.GetFileName)
'  End
'End
'thmUC.setObjectTag (ot)
'MsgBox "setting thmUC_getObjectTag"
316: Set gL.thmUC_setObjectTag = ot
'MsgBox ListUtils.ListtoString(gL.thmUC_getObjectTag), , "gL.thmUC_setObjectTag"
''viewActive.AddTheme(thmUC)

'>>>>> Save comment in ARCSDM commanditem "Spatial Data Modeller"
''''''' Start comment string to be set temporarily as SDM menu tag
'''''''--------------------------------------------------
''''''Comments = thmUC.GetName + "*"
'''''Dim comments As Variant
'''''235: comments = thmUC.Name & "*"
'If (gL.GetTitle.Contains("Neural")) Then
327: If InStr(gL.Caption, "Neural") <> 0 Then
'  tchFlag = "NN"
        Dim tchFlag As String
330:     tchFlag = "NN"
''''''  Comments = Comments + "Generated by: Arc-SDM - Generate Neural Network Input Files" + NL
'''''242:     comments = comments & "Generated by: Arc-SDM - Generate Neural Network Input Files" & vbCrLf
'Else
334: Else
'  tchFlag = "WLR"
336:     tchFlag = "WLR"
''''''  Comments = Comments + "Generated by: Arc-SDM - Calculate Response Theme" + NL
'''''248:     comments = comments & "Generated by: Arc-SDM - Calculate Response Theme" & vbCrLf
'End
340: End If
''''''comments = comments + "Unique Conditions Theme" + NL +
''''''                      "Source: " + thmUC.GetSrcName.GetFileName.GetFullName + NL
'''''253: comments = comments & "Unique Conditions Theme" & vbCrLf & _
'''''                      "Source: " + thmUC.FilePath
''''''mnuSDM = (av.Run("gSDI.GetSDMMenu",{}))
'''''Dim mnuSDM As ICommandItem
'''''Dim gSDISDMMenu As gSDI_GetSDMMenu
'''''258: Set gSDISDMMenu = New gSDI_GetSDMMenu
'''''259: Set mnuSDM = gSDISDMMenu.gSDI_GetSDMMenu
'''''260: Set gSDISDMMenu = Nothing
''''''If (mnuSDM.Is(Menu)) Then
'''''262: If Not mnuSDM Is Nothing Then
''''''  mnuSDM.SetTag (Comments)
'''''264:     If TypeOf mnuSDM Is ICommandItem Then mnuSDM.Tag = comments
''''''End
'''''266: End If
'

     Dim gSDICalcWithUC As gSDI_CalcWithUC
360: Set gSDICalcWithUC = New gSDI_CalcWithUC
'result = av.Run("gSDI.CalcWithUC",{thmUC,lstMD,lstFlds,viewActive,tchFlag,expert})
     Dim result As SDMUtilities.SDMList
363: Set result = gSDICalcWithUC.gSDI_CalcWithUC(Array(thmUC, lstMD, lstFlds, viewActive, tchFlag, expert, joinTable, tmpRastList, gParam.cbxTP.Text, gParam.cbxNTP.Text))
364: Set gSDICalcWithUC = Nothing
'gL.Close
366: gL.Hide
367: Unload gL
'thmUC.setObjectTag (Nil)
369: Set gL.thmUC_setObjectTag = Nothing

'>>>>> Save comments in rasterlayer thmUC
''''''If (mnuSDM.Is(Menu)) Then
'''''280: If Not mnuSDM Is Nothing Then
''''''  Comments = ""
'''''282:     comments = ""
''''''  cmtsTmp = mnuSDM.GetTag.AsTokens("*")
'''''    Dim cmtsTmp As Variant
'''''285:     cmtsTmp = Split(mnuSDM.Tag, "*")
''''''  If (cmtsTmp.Count = 1) Then
'''''287:     If UBound(cmtsTmp) = 0 Then
''''''    Comments = cmtsTmp.Get(0)
'''''289:         comments = cmtsTmp(0)
''''''  ElseIf (cmtsTmp.Count = 2) Then
'''''291:     ElseIf UBound(cmtsTmp) = 1 Then
''''''    Comments = cmtsTmp.Get(1)
'''''293:         comments = cmtsTmp(1)
''''''  End
'''''295:     End If
''''''  If (Comments <> "") Then
'''''297:     If comments <> "" Then Set gL.thmUC_setComments = comments
''''''    thmUC.SetComments (Comments)
''''''  End
''''''End
'''''301: End If
'
'return Nil
'
'<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
    Exit Sub
ErrorHandler:
  HandleError True, c_sModuleFileName & " " & GetErrorLineNumberString(Erl), Err.Number, Err.Source, Err.Description, 4
End Sub

Private Sub Class_Initialize()
405:     Set anlParms = New AnalysisParameters.AnlParams
406:     Set gParam = anlParms.gParamfrm
End Sub
Private Function getLbxList(ByRef lbx As ListBox) As SDMUtilities.SDMList
409:     Set getLbxList = New SDMUtilities.SDMList
    Dim i As Long
411:     For i = 0 To lbx.ListCount - 1
412:         getLbxList.Add lbx.list(i)
413:     Next i
End Function

