VERSION 5.00
Begin VB.Form SDMUtilFrm 
   BorderStyle     =   3  'Fixed Dialog
   Caption         =   "Dialog Caption"
   ClientHeight    =   5040
   ClientLeft      =   2760
   ClientTop       =   3750
   ClientWidth     =   9075
   LinkTopic       =   "Form1"
   MaxButton       =   0   'False
   MinButton       =   0   'False
   ScaleHeight     =   5040
   ScaleWidth      =   9075
   ShowInTaskbar   =   0   'False
   Begin VB.TextBox FolderNameTxt 
      Height          =   285
      Left            =   3480
      TabIndex        =   11
      ToolTipText     =   "Enter a new folder name for selected folder"
      Top             =   3360
      Width           =   1455
   End
   Begin VB.CommandButton NewFolderCmd 
      Caption         =   "New Folder"
      Height          =   375
      Left            =   3600
      TabIndex        =   9
      ToolTipText     =   "Make a new folder in selected directory"
      Top             =   2880
      Width           =   1215
   End
   Begin VB.OptionButton TempDirOpt 
      Caption         =   "Temp Directory"
      Height          =   255
      Left            =   240
      TabIndex        =   8
      ToolTipText     =   "Select the temporary folder"
      Top             =   4560
      Width           =   1935
   End
   Begin VB.OptionButton HomeDirOpt 
      Caption         =   "Home Directory"
      Height          =   255
      Left            =   240
      TabIndex        =   7
      ToolTipText     =   "Select the user's home folder"
      Top             =   4200
      Width           =   1815
   End
   Begin VB.OptionButton CWDOpt 
      Caption         =   "Current Directory"
      Height          =   255
      Left            =   240
      TabIndex        =   6
      ToolTipText     =   "Select the system current folder"
      Top             =   3840
      Width           =   1695
   End
   Begin VB.OptionButton ProjDirOpt 
      Caption         =   "Project Directory"
      Height          =   255
      Left            =   240
      TabIndex        =   5
      ToolTipText     =   "Select the Project folder"
      Top             =   3480
      Width           =   1815
   End
   Begin VB.DriveListBox DriveListing 
      Height          =   315
      Left            =   120
      TabIndex        =   4
      Top             =   120
      Width           =   2895
   End
   Begin VB.FileListBox FileListing 
      Height          =   4575
      Left            =   5520
      TabIndex        =   3
      Top             =   120
      Width           =   3255
   End
   Begin VB.DirListBox DirListing 
      Height          =   2115
      Left            =   120
      TabIndex        =   2
      Top             =   600
      Width           =   5295
   End
   Begin VB.CommandButton CancelButton 
      Caption         =   "Cancel"
      Height          =   375
      Left            =   1920
      TabIndex        =   1
      ToolTipText     =   "Return nothing"
      Top             =   2880
      Width           =   1215
   End
   Begin VB.CommandButton OKButton 
      Caption         =   "OK"
      Height          =   375
      Left            =   240
      TabIndex        =   0
      ToolTipText     =   "Return selected"
      Top             =   2880
      Width           =   1215
   End
   Begin VB.Frame Frame1 
      Height          =   1575
      Left            =   240
      TabIndex        =   10
      Top             =   3360
      Visible         =   0   'False
      Width           =   1575
   End
   Begin VB.Label SDMLogo 
      Alignment       =   2  'Center
      Appearance      =   0  'Flat
      BackColor       =   &H0000C000&
      BorderStyle     =   1  'Fixed Single
      Caption         =   "ArcSDM3"
      BeginProperty Font 
         Name            =   "Roman"
         Size            =   14.25
         Charset         =   255
         Weight          =   700
         Underline       =   0   'False
         Italic          =   -1  'True
         Strikethrough   =   0   'False
      EndProperty
      ForeColor       =   &H0080FFFF&
      Height          =   375
      Left            =   3600
      TabIndex        =   12
      Top             =   120
      Width           =   1335
   End
End
Attribute VB_Name = "SDMUtilFrm"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False

Option Explicit
Private dir As String
Private file As String

Private Sub CancelButton_Click()
7:     dir = ""
8:     Me.Hide
End Sub

Private Sub CWDOpt_Click()
12:     DirListing.path = CurDir
End Sub

Private Sub DirListing_Change()
16:     dir = DirListing.list(DirListing.ListIndex)
17:     FileListing.path = dir
18:     FileListing.Refresh
19:     If (FileListing.ListCount > 0) Then FileListing.ListIndex = 0
End Sub

Private Sub DirListing_Click()
23:     dir = DirListing.list(DirListing.ListIndex)
24:     FileListing.path = dir
25:     FileListing.Refresh
26:     If (FileListing.ListCount > 0) Then FileListing.ListIndex = 0
End Sub

Private Sub DriveListing_Change()
30:     DirListing.path = DriveListing.Drive
31:     DirListing.Refresh
End Sub

Private Sub FileListing_Click()
35:     file = FileListing.list(FileListing.ListIndex)
End Sub

Private Sub FolderNameTxt_Change()
39:     NewFolderCmd.Enabled = FolderNameTxt.Text <> ""
End Sub

Private Sub Form_Load()
'43:     ProjDirOpt.Value = True
44:     HomeDirOpt.Enabled = Environ("HOME") <> ""
45:     TempDirOpt.Enabled = Environ("TEMP") <> ""
46:     NewFolderCmd.Enabled = False
End Sub

Private Sub HomeDirOpt_Click()
50:     HomeDirOpt.Enabled = Environ("HOME") <> ""
51:     DirListing.path = Environ("HOME")
End Sub

Private Sub NewFolderCmd_Click()
    Dim fs As Object
56:     Set fs = CreateObject("Scripting.filesystemobject")
    Dim folder As String
58:     folder = DirListing.path & "\" & FolderNameTxt.Text
59:     If (fs.folderExists(folder)) Then
60:         MsgBox folder & " exists"
61:     Else
        'MsgBox folder & " does not exist"
63:         fs.CreateFolder (folder)
64:     End If
65:     FolderNameTxt.Text = ""
End Sub


Private Sub OKButton_Click()
70:     dir = DirListing.list(DirListing.ListIndex)
71:     Me.Hide
End Sub

Public Function getDir(initDir As String, title As String) As String
75:     OKButton.ToolTipText = "Return selected folder"
76:     Me.Caption = title
77:     FileListing.Visible = False
78:     Me.Width = FileListing.Left - 2
79:     Me.Show vbModal
80:     getDir = dir
End Function

Public Function getFile(initDir As String, title As String) As String
84:     OKButton.ToolTipText = "Return selected file"
85:     FolderNameTxt.Visible = False
86:     NewFolderCmd.Visible = False
    'DriveListing.Drive = initDir
    'DirListing.Path = initDir
89:     Me.Caption = title
90:     Me.Show vbModal
91:     If (dir = "" Or file = "") Then
92:         getFile = ""
93:     Else
94:         getFile = dir & "\" & file
95:     End If
End Function

Public Sub ProjDirOpt_Click()
        Dim prjDir As gSDI_getProjectDir
100:     Set prjDir = New gSDI_getProjectDir
101:     DirListing.path = prjDir.gSDI_getProjectDir
End Sub

Private Sub TempDirOpt_Click()
105:     TempDirOpt.Enabled = Environ("TEMP") <> ""
106:     DirListing.path = Environ("TEMP")
End Sub
Public Function GetTempFileName() As IFileName
    Dim fs As Object
110:     Set fs = CreateObject("Scripting.FileSystemObject")
111:     Set GetTempFileName = New fileName
112:     GetTempFileName.path = fs.getTempname
113:     Set fs = Nothing
End Function

Public Function ExistsFilename(fileName As String) As Boolean
    Dim fs As Object
118:     Set fs = CreateObject("Scripting.FileSystemObject")
119:     ExistsFilename = fs.FileExists(fileName)
120:     Set fs = Nothing
End Function

Public Function DeleteFilename(fileName As String) As Boolean
    Dim fs As Object
125:     Set fs = CreateObject("Scripting.FileSystemObject")
    On Error Resume Next
127:     Err.Clear
128:     fs.DeleteFile fileName, True
129:     If (Err.Number <> 0) Then
130:         If (Err.Number = 70) Then
131:             MsgBox fileName & " belongs to another map.", vbCritical, "Delete File Name"
132:         End If
133:         DeleteFilename = False
134:     Else
135:         DeleteFilename = True
136:     End If
137:     Set fs = Nothing
End Function

