VERSION 5.00
Begin VB.Form gC 
   Caption         =   "Compare Results..."
   ClientHeight    =   3195
   ClientLeft      =   0
   ClientTop       =   0
   ClientWidth     =   7755
   KeyPreview      =   -1  'True
   LinkTopic       =   "gC1"
   ScaleHeight     =   3195
   ScaleWidth      =   7755
   StartUpPosition =   2  'CenterScreen
   WhatsThisButton =   -1  'True
   WhatsThisHelp   =   -1  'True
   Begin VB.OptionButton rbtnWSA 
      Caption         =   "Area weighted Spearman's rank"
      Height          =   255
      Left            =   4680
      TabIndex        =   6
      Top             =   600
      Width           =   2775
   End
   Begin VB.OptionButton rbtnMap 
      Caption         =   "Map of Rank Differences"
      Height          =   255
      Left            =   4680
      TabIndex        =   5
      Top             =   1080
      Width           =   2175
   End
   Begin VB.ListBox lbxTF 
      Height          =   2010
      Left            =   240
      MultiSelect     =   1  'Simple
      Sorted          =   -1  'True
      TabIndex        =   0
      ToolTipText     =   "List of grid themes with any numeric attributes. "
      Top             =   480
      Width           =   4095
   End
   Begin VB.CommandButton btnOK 
      Caption         =   "OK"
      Height          =   420
      Left            =   480
      TabIndex        =   2
      ToolTipText     =   "Shift-click for help."
      Top             =   2640
      Width           =   1440
   End
   Begin VB.CommandButton btnCan 
      Caption         =   "Cancel"
      Height          =   420
      Left            =   2520
      TabIndex        =   3
      Top             =   2640
      Width           =   1440
   End
   Begin VB.OptionButton rbtnQqp 
      Caption         =   "Quantile-Quantile Plot"
      Height          =   255
      Left            =   4680
      TabIndex        =   4
      ToolTipText     =   "Not yet implemented!"
      Top             =   1560
      Width           =   2055
   End
   Begin VB.Label SDMLogo 
      Alignment       =   2  'Center
      Appearance      =   0  'Flat
      BackColor       =   &H0000C000&
      BorderStyle     =   1  'Fixed Single
      Caption         =   "ArcSDM3"
      BeginProperty Font 
         Name            =   "Roman"
         Size            =   14.25
         Charset         =   255
         Weight          =   700
         Underline       =   0   'False
         Italic          =   -1  'True
         Strikethrough   =   0   'False
      EndProperty
      ForeColor       =   &H0080FFFF&
      Height          =   375
      Left            =   5280
      TabIndex        =   7
      Top             =   2640
      Width           =   1335
   End
   Begin VB.Label lblTF 
      Caption         =   "Select layers:"
      Height          =   255
      Left            =   315
      TabIndex        =   1
      Top             =   120
      Width           =   1440
   End
End
Attribute VB_Name = "gC"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit
Const c_sModuleFileName As String = "C:\MyJava\ARC-SDM\Dialogs\gC.frm"
Const c_sDLLFileName As String = "SDMAccessories"       ' Constant reflect file module name
Private Listeners As SDMUtilities.SDMListeners
Private WithEvents aCtl As SDMUtilities.SDMListeners
Attribute aCtl.VB_VarHelpID = -1

Private shiftDown As Boolean

Private lstObjectTag As SDMUtilities.SDMList
Private myBreaks As Variant

Dim aObjectTag As Object
Public Property Get ObjectTag(key As String) As Variant
    Dim tmp As Variant
15:     If aObjectTag.Exists(key) Then
16:         If IsObject(aObjectTag.item(key)) Then
17:             Set ObjectTag = aObjectTag.item(key)
18:         Else
19:             ObjectTag = aObjectTag.item(key)
20:         End If
21:     Else
22:         Set ObjectTag = Nothing
23:     End If
End Property

Public Property Let ObjectTag(key As String, ByVal item As Variant)
27:     aObjectTag.Add key, item
End Property


Public Function isShiftdown() As Boolean
32:     isShiftdown = shiftDown
33:     shiftDown = False
End Function

Private Sub btnCan_Click()
    If Me.isShiftdown Then Exit Sub
    '' gC.btnCan.Click
    'gC = Self.GetDialog
    'gC.findByName("btnOK").SetTag ("False")
41:     Me.btnOK.Tag = "False"
    'Self.SetTag ("True")
43:     Me.btnCan.Tag = "True"
    'gC.Close
45:     Unload Me
End Sub

Private Sub btnOK_Click()
  On Error GoTo ErrorHandler

'' gC.btnOK.Click
'If (System.IsShiftKeyDown) Then
53: If Me.isShiftdown Then
'  docURL = "sdmcpare.htm#How"
'  If (docURL.Count > 0) Then
'    av.Run("gSDI.Help", {docURL})
57:     SDMGlobals.SDMHelp.gSDI_Help "sdmcpare.htm#How"
'  End
'  return Nil
    Exit Sub
'End
62: End If
'gC = Self.GetDialog
'gC.findByName("btnCan").SetTag ("False")
65: Me.btnCan.Tag = "False"
'Self.SetTag ("True")
67: Me.btnOK.Tag = "True"
    Dim gSDICompareResults As gSDI_CompareResults
69: Set gSDICompareResults = New gSDI_CompareResults
70: gSDICompareResults.gSDI_CompareResults
71: Set gSDICompareResults = Nothing
'gC.Close
73: Me.ZOrder 0



  Exit Sub
ErrorHandler:
  HandleError True, "btnOK_Click " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), Err.Number, Err.Source, Err.Description, 4
End Sub

Private Sub Form_Initialize()
83:     KeyPreview = True
End Sub

Private Sub rbtnMap_Click()
87:     Me.getEars.BroadcastUpdate Me.rbtnMap
End Sub

Private Sub rbtnQqp_Click()
91:     Me.getEars.BroadcastUpdate Me.rbtnQqp
End Sub

Private Sub rbtnWSA_Click()
95:     Me.getEars.BroadcastUpdate Me.rbtnWSA
End Sub


Private Sub Form_KeyDown(KeyCode As Integer, Shift As Integer)
  On Error GoTo ErrorHandler
101:     shiftDown = (Shift And vbShiftMask) > 0
  Exit Sub
ErrorHandler:
  HandleError True, "Form_KeyDown " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), Err.Number, Err.Source, Err.Description, 4
End Sub
Private Sub Form_KeyUp(KeyCode As Integer, Shift As Integer)
  On Error GoTo ErrorHandler
108:     shiftDown = False
  Exit Sub
ErrorHandler:
  HandleError True, "Form_KeyUp " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), Err.Number, Err.Source, Err.Description, 4
End Sub

Public Property Get getEars() As SDMUtilities.SDMListeners
  On Error GoTo ErrorHandler
116:     Set getEars = Listeners
  Exit Property
ErrorHandler:
  HandleError True, "getEars " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), Err.Number, Err.Source, Err.Description, 4
End Property

'Include selections for all controls with an update method
'Method could be local or belong to an instantiated object
Private Sub aCtl_UpdateEvt(ByRef ctl As Object)
    On Error GoTo ErrorHandler
    Select Case (ctl.Name)
        Case Me.btnOK.Name
        '' gC.btnOK.Update
        'gC = Self.GetDialog
        'lbxTF = gC.findByName("lbxTF")
        'nmbSel = lbxTF.GetSelection.Count
             Dim nmbSel As Long
133:         nmbSel = Me.lbxTF.SelCount
        'lstChks = gC.FindByClass(CheckBox)
        'Selected = False
        'For Each chk In lstChks
        '  If (chk.IsSelected) Then
        '    Selected = True
        '    Break
        '  End
        'End
        'Self.SetEnabled (((nmbSel > 1) And (nmbSel < 3)) And (Selected))
143:         Me.btnOK.Enabled = (nmbSel = 2) And (Me.rbtnMap Or Me.rbtnQqp Or Me.rbtnWSA)
        Case Me.lbxTF.Name
            Dim gClbxTFUpdate As gC_lbxTF_Update
146:        Set gClbxTFUpdate = New gC_lbxTF_Update
147:        gClbxTFUpdate.gC_lbxTF_Update
148:        Set gClbxTFUpdate = Nothing
        Case Else
150:             MsgBox "Update not found: " & ctl.Name, vbCritical, "gC.aCtl.Update"
151: End Select
    Exit Sub
ErrorHandler:
  HandleError True, "getEars " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), Err.Number, Err.Source, Err.Description, 4
End Sub

Private Sub Form_Load()
    On Error GoTo ErrorHandler
        'MsgBox "loading gParam..."
160:     Set aObjectTag = CreateObject("Scripting.Dictionary")
161:     Me.Caption = "Compare Results..."
162:     Set Listeners = New SDMUtilities.SDMListeners
163:     Set aCtl = Listeners
164:    If SDMGlobals.SDMApp Is Nothing Then Set SDMGlobals.SDMApp = New AppRef
165:    If SDMGlobals.SDMDoc Is Nothing Then Set SDMGlobals.SDMDoc = SDMGlobals.SDMApp.Document
166:     If SDMGlobals.SDMMap Is Nothing Then
            Dim pMxDoc As IMxDocument
168:         Set pMxDoc = SDMGlobals.SDMDoc
169:         Set SDMGlobals.SDMMap = pMxDoc.FocusMap
170:     End If
171:    If SDMGlobals.SDMUtil Is Nothing Then
172:             Set SDMGlobals.SDMUtil = New SDMUtilities.SDMUtils
173:             Set SDMGlobals.SDMUtil.setAPP = SDMGlobals.SDMApp
174:         End If
175:    If SDMGlobals.SDMStatusBar Is Nothing Then Set SDMGlobals.SDMStatusBar = SDMGlobals.SDMApp.StatusBar
176:    If SDMGlobals.SDMHelp Is Nothing Then Set SDMGlobals.SDMHelp = New SDMUtilities.gSDI_Help
177:    If SDMGlobals.SDMdataDict Is Nothing Then Set SDMGlobals.SDMdataDict = New SDMUtilities.SDMDictionary
178:    If SDMGlobals.SDMWorkspace Is Nothing Then
            Dim cwdPath As String
            Dim lyr As ILayer
181:        Set lyr = SDMGlobals.SDMMap.layers(, True).Next
182:        If Not lyr Is Nothing Then
183:            If Not TypeOf lyr Is IGroupLayer Then
                    Dim lyrds As IDataset
185:                Set lyrds = lyr
186:                cwdPath = lyrds.Workspace.PathName
187:            End If
188:        Else
189:            cwdPath = Environ("TEMP")
190:        End If
191:        Set SDMGlobals.SDMWorkspace = SDMGlobals.SDMUtil.openShapeFileWorkspace(cwdPath)
192:        If SDMGlobals.SDMRAEnvironment Is Nothing Then
193:                 Set SDMGlobals.SDMRAEnvironment = RasterAEUtils.getRasterAnalysisEnvironment
194:        End If
195:    End If
196:    If SDMGlobals.SDMdataMD Is Nothing Then Set SDMGlobals.SDMdataMD = New SDMUtilities.SDMDictionary
        Dim readMissingdata As gSDI_ReadMissingData
198:         Set readMissingdata = New gSDI_ReadMissingData
199:         readMissingdata.gSDI_ReadMissingData
200:         Set readMissingdata = Nothing
201:    shiftDown = False
         Dim gCOpen As gC_Open
203:     Set gCOpen = New gC_Open
204:     gCOpen.gC_Open
205:     Set gCOpen = Nothing
    Exit Sub
ErrorHandler:
  HandleError True, "gFM_Load " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), Err.Number, Err.Source, Err.Description, 4
End Sub


Private Sub lbxTF_Click()
213:     gC.getEars.BroadcastUpdate Me.lbxTF
End Sub


Public Property Get breaks() As Variant
218:     breaks = myBreaks
End Property

Public Property Let breaks(ByVal vNewValue As Variant)
222:     myBreaks = vNewValue
End Property

