VERSION 5.00
Object = "{F9043C88-F6F2-101A-A3C9-08002B2F49FB}#1.2#0"; "Comdlg32.ocx"
Begin VB.Form gCI 
   Caption         =   "Form1"
   ClientHeight    =   6615
   ClientLeft      =   60
   ClientTop       =   405
   ClientWidth     =   9210
   LinkTopic       =   "Form1"
   PaletteMode     =   1  'UseZOrder
   ScaleHeight     =   6615
   ScaleWidth      =   9210
   StartUpPosition =   2  'CenterScreen
   Begin MSComDlg.CommonDialog CommonDialog1 
      Left            =   240
      Top             =   6120
      _ExtentX        =   847
      _ExtentY        =   847
      _Version        =   393216
      FontBold        =   -1  'True
      FontSize        =   10
   End
   Begin VB.TextBox Text1 
      BackColor       =   &H00FFFFFF&
      BeginProperty Font 
         Name            =   "MS Sans Serif"
         Size            =   8.25
         Charset         =   0
         Weight          =   700
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      ForeColor       =   &H00C00000&
      Height          =   5775
      Left            =   240
      MultiLine       =   -1  'True
      ScrollBars      =   3  'Both
      TabIndex        =   3
      Text            =   "gCI.frx":0000
      Top             =   120
      Width           =   8775
   End
   Begin VB.CommandButton cmd_Save 
      Caption         =   "Save"
      Height          =   375
      Left            =   5040
      TabIndex        =   2
      ToolTipText     =   "Save listing of this form to a text file in the project folder"
      Top             =   6120
      Width           =   1335
   End
   Begin VB.CommandButton cmd_Print 
      Caption         =   "Print"
      Height          =   375
      Left            =   3000
      TabIndex        =   1
      ToolTipText     =   "Print listing of this form"
      Top             =   6120
      Width           =   1335
   End
   Begin VB.CommandButton cmd_Done 
      Caption         =   "Done"
      Height          =   375
      Left            =   960
      TabIndex        =   0
      ToolTipText     =   "Done looking at Conditional Independence tests"
      Top             =   6120
      Width           =   1335
   End
   Begin VB.Label SDMLogo 
      Alignment       =   2  'Center
      Appearance      =   0  'Flat
      BackColor       =   &H0000C000&
      BorderStyle     =   1  'Fixed Single
      Caption         =   "ArcSDM3"
      BeginProperty Font 
         Name            =   "Roman"
         Size            =   14.25
         Charset         =   255
         Weight          =   700
         Underline       =   0   'False
         Italic          =   -1  'True
         Strikethrough   =   0   'False
      EndProperty
      ForeColor       =   &H0080FFFF&
      Height          =   375
      Left            =   7080
      TabIndex        =   4
      Top             =   6120
      Width           =   1335
   End
End
Attribute VB_Name = "gCI"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit

Private Sub cmd_Done_Click()
4:     gL.ZOrder 0
5:     Unload Me
End Sub

Private Sub cmd_Print_Click()
9:    Me.cmd_Done.Enabled = False
10:    Me.cmd_Save.Enabled = False
   Dim msg   ' Declare variable.
   On Error GoTo ErrorHandler   ' Set up error handler.
13:    CommonDialog1.PrinterDefault = True
14:    CommonDialog1.ShowPrinter
15:    Printer.FontSize = 10
16:    Printer.Print Me.Text1.Text
17:    Printer.NewPage
18:    Printer.EndDoc
19:     SDMGlobals.SDMStatusBar.Message(0) = "Conditional Independence Test printing..."
20:     Me.ZOrder 0
21:    Me.cmd_Done = True
   'me.cmd_Save = True
   Exit Sub
ErrorHandler:
25:    msg = "The form can't be printed."
26:    MsgBox msg   ' Display message.
End Sub

Private Sub cmd_Save_Click()
30:     Me.cmd_Done.Enabled = False
31:     Me.cmd_Print.Enabled = False
    Dim fs As Object
33:     Set fs = CreateObject("Scripting.FileSystemObject")
    Dim tmpfn As String
35:     tmpfn = Me.cmd_Save.Tag & "_CI_Test.txt"
    Dim FN As Variant
37:     FN = FileDialog.GetSaveFileName("Save Conditional Independence Test", WOETableUtils.getProjectDir, tmpfn)
    If IsEmpty(FN) Then Exit Sub
39:     tmpfn = FN(1) & "\" & FN(0)
    Dim filout As Object
41:     Set filout = fs.CreateTextFile(tmpfn, True)
42:     filout.WriteLine Me.Text1.Text
43:     filout.Close
44:     Me.cmd_Done.Enabled = True
    'Me.cmd_Print.Enabled = True
46:     SDMGlobals.SDMStatusBar.Message(0) = "Conditional Independence Test saved: " & tmpfn
47:     Me.ZOrder 0
End Sub

Public Sub CI_Test(UCName As String, nTPs As Long, Vals As Variant, pRatio As Double, txtFile As Boolean, statfile As Object)
51:     gCI.cmd_Save.Tag = UCName
    
    Dim CITbl As IStandaloneTable
54:     Set CITbl = WOETableUtils.FindStandAloneTableByName(UCName & "_woevar")
55:     If Not CITbl Is Nothing Then
        Dim CITblcurs As ICursor
57:         Set CITblcurs = CITbl.Table.Search(Nothing, False)
        Dim CITblRow As irow
59:         Set CITblRow = CITblcurs.NextRow
        Dim testMsg3 As String
61:         testMsg3 = vbCrLf & "Evidence layers & Generalization tables" & vbCrLf
62:         While Not CITblRow Is Nothing
63:             testMsg3 = testMsg3 + CITblRow.Value(CITblRow.Fields.FindField("Evidence_N")) & " & " & CITblRow.Value(CITblRow.Fields.FindField("Class_Fiel")) & vbCrLf
64:             Set CITblRow = CITblcurs.NextRow
65:         Wend
66:     End If
            Dim STD As Double
68:             STD = Sqr(CDbl(Vals(1)))
            Dim testmsgCIR As String, testmsg1 As String, testmsg2 As String
70:       testmsgCIR = _
              "Conditional Independence Test: " & UCName & vbCrLf & _
              "Observed No. training pts, n = " & nTPs & vbCrLf & _
              "Expected No. of training points, T = " & Format(CDbl(Vals(0)), "#####0.000") & vbCrLf & _
              "Difference, T-n = " & Format(CDbl(Vals(0)) - nTPs, "#####0.000") & vbCrLf & _
              "Standard Deviation of T = " & Format(STD, "#####0.000") & vbCrLf & vbCrLf & _
              "------------------------------------------------" & vbCrLf & _
              "Conditional Independence Ratio: " & Format(pRatio, "0.000") & " <simply the ratio n/T>" & vbCrLf & _
              "Values below 1.00 may indicate conditional dependence" & vbCrLf & _
              "among two or more of your data sets.  <Bonham-Carter(1994,ch.9)" & vbCrLf & _
              "suggest that values <0.85 may indicate a problem>" & vbCrLf & vbCrLf
81:       testmsg1 = _
            "------------------------------------------------" & vbCrLf & _
            "Agterberg & Cheng Conditional Independence Test <See Agterberg and" & vbCrLf & _
            "Cheng, Natural Resources Research 11(4), 249-255, 2002>" & vbCrLf & _
            "This is a one-tailed test of the null hypothesis that T-n=0.  The test" & vbCrLf & _
            "statistic is (T-n)/standard deviation of T. Probability values greater" & vbCrLf & _
            "than 95% or 99% indicate that the hypothesis of CI should be rejected," & vbCrLf & _
            "but any value greater than 50% indicates that some conditional" & vbCrLf & _
            "dependence occurs>" & vbCrLf & vbCrLf & _
            "Probability that this model is not conditionally independent with" & vbCrLf & _
            "T-n/STD = " & Format((CDbl(Vals(0)) - nTPs) / STD, "#####0.000") & " is " & _
            Format(ZToF((CDbl(Vals(0)) - nTPs) / STD), "#0.0%") & vbCrLf

94:             testmsg2 = _
            "------------------------------------------------" & vbCrLf & _
            "See the associated database table """ & UCName & "_CI""" & vbCrLf & _
            "for T values of each unique condition. " & vbCrLf
'  If (txtFile) Then
99:       If txtFile Then
        '    statfile.writeElt ("Overall Test of Conditional Independence:  " + pratioRnd.AsString)
101:           statfile.writeln testmsgCIR & testmsg1 & testmsg2 & testMsg3
        '    statfile.Close
103:           statfile.Close
        '  End
105:       End If
        
107:       Me.Text1.Text = testmsgCIR & testmsg1 & testmsg2 & testMsg3
108:       Me.Caption = "Assessment of Conditional Independence"

End Sub

Function ZToF(Z As Double) As Double
'      SUBROUTINE ZTOF(Z, PZ)
'c
'C ... SUBROUTINE TO COMPUTE FREQUENCY FROM Z.   EQ. 26.2.17   IN
'c
'C      ABRAMOWITZ, M. AND STEGUN, I.A.     (EDITORS)
'c "HANDBOOK OF MATHEMATICAL FUNCTIONS"
'C         WITH FORMULAS, GRAPHS, AND MATHEMATICAL TABLES"
'C      PUB. BY NATIONAL BUREAU OF STANDARDS OF THE
'C         U.S. DEPARTMENT OF COMMERCE,   1964.
'c
'C  CALLED BY SUBROUTINES  COMP, REORD, & WDIST
'c
'      DATA  PI/3.141592654/, CONST6/0.2316419/, B1/0.319381530/,
'     +      B2/-0.356563782/, B3/1.781477937/, B4/-1.821255978/,
'     +      B5/1.330274429/
128: Const PI As Double = 3.141592654
129: Const CONST6 As Double = 0.2316419
130: Const B1 As Double = 0.31938153
131: Const B2 As Double = -0.356563782
132: Const B3 As Double = 1.781477937
133: Const B4 As Double = -1.821255978
134: Const B5 As Double = 1.330274429
'c
'      x = Z
Dim X As Double
138: X = Z
'      IF (Z.LT.0.0) X = -Z
140: If X < 0 Then X = -Z
'      t = 1# / (CONST6 * x + 1#)
Dim t As Double
143: t = 1# / (CONST6 * X + 1#)
'      PID = 2# * PI
Dim PID As Double
146: PID = 2# * PI
'      XX = -x * x / 2#
Dim XX As Double
149: XX = -X * X / 2#
'      XX = Exp(XX) / SQRT(PID)
151: XX = Exp(XX) / Sqr(PID)
'      PZ = (B1 * T) + (B2 * T * T) + (B3 * T**3) + (B4 * T**4) +
'     +     (B5 * T**5)
154: ZToF = (B1 * t) + (B2 * t * t) + (B3 * t ^ 3) + (B4 * t ^ 4) + (B5 * t ^ 5)
'      PZ = 1# - (PZ * XX)
156: ZToF = 1# - (ZToF * XX)
'      IF (Z.LT.0.0) PZ = 1.0 - PZ
158: If (Z < 0#) Then ZToF = 1# - ZToF
'      Return
'      End
End Function

