VERSION 5.00
Begin VB.Form gFld2Ras 
   BorderStyle     =   3  'Fixed Dialog
   Caption         =   "Create a raster from a joined attribute"
   ClientHeight    =   3450
   ClientLeft      =   2760
   ClientTop       =   3750
   ClientWidth     =   6630
   LinkTopic       =   "Form1"
   MaxButton       =   0   'False
   MinButton       =   0   'False
   ScaleHeight     =   3450
   ScaleWidth      =   6630
   Begin VB.ComboBox cbx_Mult 
      Height          =   315
      ItemData        =   "gFld2Ras.frx":0000
      Left            =   4560
      List            =   "gFld2Ras.frx":002E
      TabIndex        =   10
      ToolTipText     =   "Select a multiplier for attribute reclassification to integer"
      Top             =   2160
      Visible         =   0   'False
      Width           =   1815
   End
   Begin VB.CommandButton lbt_Join 
      Caption         =   "Join"
      Height          =   375
      Left            =   4560
      TabIndex        =   8
      ToolTipText     =   "Join a table to selected raster layer"
      Top             =   1320
      Width           =   1575
   End
   Begin VB.Frame Frame3 
      Caption         =   " Select an attribute to convert"
      Height          =   735
      Left            =   120
      TabIndex        =   6
      Top             =   1920
      Width           =   3975
      Begin VB.ComboBox cbx_SelFld 
         Height          =   315
         Left            =   240
         Sorted          =   -1  'True
         TabIndex        =   7
         Text            =   "<None>"
         ToolTipText     =   "Select af floating point attribute from selected joined table"
         Top             =   240
         Width           =   3255
      End
   End
   Begin VB.Frame Frame2 
      Caption         =   "Select a raster layer to convert"
      Height          =   735
      Left            =   120
      TabIndex        =   3
      ToolTipText     =   "Select an integer raster layer to convert"
      Top             =   240
      Width           =   3975
      Begin VB.ComboBox cbx_SelGrd 
         Height          =   315
         Left            =   240
         Sorted          =   -1  'True
         TabIndex        =   4
         Text            =   "<None>"
         ToolTipText     =   "Select an  integer raster layers"
         Top             =   240
         Width           =   3255
      End
   End
   Begin VB.Frame Frame1 
      Caption         =   "Select a joined table"
      Height          =   735
      Left            =   120
      TabIndex        =   2
      ToolTipText     =   "Select a joined table with an attribute for output"
      Top             =   1080
      Width           =   3975
      Begin VB.ComboBox cbx_SelTbl 
         Height          =   315
         Left            =   240
         Sorted          =   -1  'True
         TabIndex        =   5
         Text            =   "<None>"
         ToolTipText     =   "Select from tables joined to selected raster layer"
         Top             =   240
         Width           =   3255
      End
   End
   Begin VB.CommandButton lbt_Can 
      Caption         =   "Done"
      Height          =   375
      Left            =   3120
      TabIndex        =   1
      ToolTipText     =   "Abort this command"
      Top             =   2880
      Width           =   1215
   End
   Begin VB.CommandButton lbt_OK 
      Caption         =   "Create"
      Height          =   375
      Left            =   1560
      TabIndex        =   0
      ToolTipText     =   "Create new raster from selected field"
      Top             =   2880
      Width           =   1215
   End
   Begin VB.Frame Frame4 
      Caption         =   "Multiplier"
      Height          =   735
      Left            =   4440
      TabIndex        =   11
      Top             =   1920
      Visible         =   0   'False
      Width           =   2055
   End
   Begin VB.Label SDMLogo 
      Alignment       =   2  'Center
      Appearance      =   0  'Flat
      BackColor       =   &H0000C000&
      BorderStyle     =   1  'Fixed Single
      Caption         =   "ArcSDM3"
      BeginProperty Font 
         Name            =   "Roman"
         Size            =   14.25
         Charset         =   255
         Weight          =   700
         Underline       =   0   'False
         Italic          =   -1  'True
         Strikethrough   =   0   'False
      EndProperty
      ForeColor       =   &H0080FFFF&
      Height          =   375
      Left            =   4680
      TabIndex        =   9
      ToolTipText     =   "Copyrighted 2003"
      Top             =   480
      Width           =   1335
   End
End
Attribute VB_Name = "gFld2Ras"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit

Const c_sModuleFileName As String = "gFld2Ras.frm"
Const c_sDLLFileName As String = "SDMAccessories"       ' Constant reflect file module name

Private Listeners As SDMUtilities.SDMListeners
Private WithEvents aCtl As SDMUtilities.SDMListeners
Attribute aCtl.VB_VarHelpID = -1

Private shiftDown As Boolean

Private ObjectTag As SDMUtilities.SDMList
Public Function isShiftdown() As Boolean
  On Error GoTo ErrorHandler
14:     isShiftdown = shiftDown
15:     shiftDown = False
  Exit Function
ErrorHandler:
  HandleError True, "isShiftDown " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), Err.Number, Err.Source, Err.Description, 4
End Function
Public Property Set setObjectTag(ByRef anObject As SDMUtilities.SDMList)
  On Error GoTo ErrorHandler
22:     Set ObjectTag = anObject
  Exit Property
ErrorHandler:
  HandleError True, "setObjectTag " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), Err.Number, Err.Source, Err.Description, 4
End Property

Public Property Get getObjectTag() As SDMUtilities.SDMList
  On Error GoTo ErrorHandler

31:     If (ObjectTag Is Nothing) Then
32:         Set getObjectTag = New SDMUtilities.SDMList
33:     Else
34:         Set getObjectTag = ObjectTag
35:     End If
  Exit Property
ErrorHandler:
  HandleError True, "getObjectTag " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), Err.Number, Err.Source, Err.Description, 4
End Property


Private Sub cbx_SelFld_Click()
43:     Me.getEars.BroadcastUpdate Me.cbx_SelFld
End Sub

Private Sub cbx_SelGrd_Click()
47:     Me.getEars.BroadcastUpdate Me.cbx_SelGrd
End Sub

Private Sub cbx_SelTbl_Click()
51:     Me.getEars.BroadcastUpdate Me.cbx_SelTbl
End Sub

Private Sub Combo1_Change()

End Sub

Private Sub Form_Initialize()
    KeyPreview = True

End Sub

Private Sub Form_KeyDown(KeyCode As Integer, Shift As Integer)
  On Error GoTo ErrorHandler
60:     shiftDown = (Shift And vbShiftMask) > 0
  Exit Sub
ErrorHandler:
  HandleError True, "Form_KeyDown " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), Err.Number, Err.Source, Err.Description, 4
End Sub
Private Sub Form_KeyUp(KeyCode As Integer, Shift As Integer)
  On Error GoTo ErrorHandler
67:     shiftDown = False
  Exit Sub
ErrorHandler:
  HandleError True, "Form_KeyUp " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), Err.Number, Err.Source, Err.Description, 4
End Sub

Public Property Get getEars() As SDMUtilities.SDMListeners
  On Error GoTo ErrorHandler
75:     Set getEars = Listeners
  Exit Property
ErrorHandler:
  HandleError True, "getEars " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), Err.Number, Err.Source, Err.Description, 4
End Property

'Include selections for all controls with an update method
'Method could be local or belong to an instantiated object
Private Sub aCtl_UpdateEvt(ByRef ctl As Object)
    On Error GoTo ErrorHandler
    Select Case (ctl.Name)
        Case Me.cbx_SelTbl.Name
87:             If Me.cbx_SelGrd.Text <> "<None>" Then
                    Dim rlyr As IRasterLayer
89:                 Set rlyr = WOETableUtils.FindLayerByName(Me.cbx_SelGrd.Text)
90:                 If rlyr Is Nothing Then
                        Dim projDir As String
92:                     projDir = WOETableUtils.getProjectDir
                        Dim readFile As Variant
94:                     readFile = FileDialog.GetReadFileName("Find joined table", projDir, Me.cbx_SelGrd.Text & ".dbf")
95:                     Set rlyr = New RasterLayer
96:                     rlyr.CreateFromFilePath (readFile(1) & "\" & readFile(0))
97:                     If rlyr Is Nothing Then
98:                         MsgBox "Can't open joined table.", vbCritical, "Join table"
                            Exit Sub
100:                     End If
101:                 End If
102:                 RasterAEUtils.DefineFromList Me.cbx_SelTbl, WOETableUtils.ListJoinsStr(rlyr)
103:                 If Me.cbx_SelTbl.ListCount = 0 Then Me.cbx_SelTbl.AddItem "<None>"
104:                 Me.cbx_SelTbl.ListIndex = 0
105:             Else
106:                 Me.cbx_SelTbl.Clear
107:                 Me.cbx_SelTbl.AddItem "<None>"
108:             End If
109:             Me.cbx_SelTbl.ListIndex = 0
110:             Me.getEars.BroadcastUpdate Me.cbx_SelTbl
        Case Me.cbx_SelFld.Name
112:             GetJoinedTableFieldNames
113:             Me.getEars.BroadcastUpdate Me.cbx_SelFld
        Case Me.lbt_OK.Name
115:             Me.lbt_OK.Enabled = Not ((Me.cbx_SelFld.Text = "<None>") Or (Me.cbx_SelTbl.Text = "<None>"))
        Case Me.lbt_Join.Name
        Case Else
118:             MsgBox "Update not found: " & ctl.Parent.Name, vbCritical, "gL.aCtl.Update"
119:     End Select
    Exit Sub
ErrorHandler:
  HandleError True, "aCtl_UpdateEvt " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), Err.Number, Err.Source, Err.Description, 4
End Sub

Private Sub Form_Load()
    On Error GoTo ErrorHandler
127:     Set Listeners = New SDMUtilities.SDMListeners
128:     Set aCtl = Listeners
129:    If SDMGlobals.SDMApp Is Nothing Then Set SDMGlobals.SDMApp = New AppRef
130:    If SDMGlobals.SDMDoc Is Nothing Then Set SDMGlobals.SDMDoc = SDMGlobals.SDMApp.Document
131:     If SDMGlobals.SDMMap Is Nothing Then
            Dim pMxDoc As IMxDocument
133:         Set pMxDoc = SDMGlobals.SDMDoc
134:         Set SDMGlobals.SDMMap = pMxDoc.FocusMap
135:     End If
136:    If SDMGlobals.SDMUtil Is Nothing Then
137:        Set SDMGlobals.SDMUtil = New SDMUtilities.SDMUtils
138:        Set SDMGlobals.SDMUtil.setAPP = SDMGlobals.SDMApp
139:    End If
140:    If SDMGlobals.SDMStatusBar Is Nothing Then Set SDMGlobals.SDMStatusBar = SDMGlobals.SDMApp.StatusBar
141:    If SDMGlobals.SDMHelp Is Nothing Then Set SDMGlobals.SDMHelp = New SDMUtilities.gSDI_Help
142:    If SDMGlobals.SDMdataDict Is Nothing Then Set SDMGlobals.SDMdataDict = New SDMUtilities.SDMDictionary
143:    If SDMGlobals.SDMWorkspace Is Nothing Then
144:             Set SDMGlobals.SDMWorkspace = SDMGlobals.SDMUtil.openShapeFileWorkspace(WOETableUtils.getProjectDir)
145:    End If
146:    shiftDown = False
        Dim gFld2RasOpen As gFld2Ras_Open
148:     Set gFld2RasOpen = New gFld2Ras_Open
149:     gFld2RasOpen.gFld2Ras_Open
    
    Exit Sub
ErrorHandler:
  HandleError True, "Form_Load" & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), Err.Number, Err.Source, Err.Description, 4
End Sub


Private Sub lbt_Can_Click()
158:     Unload Me
End Sub

Private Sub GetJoinedTableFieldNames()
  On Error GoTo ErrorHandler

164:     If Me.cbx_SelTbl.Text <> "<None>" Then
            Dim saTbl As IStandaloneTable
166:         Set saTbl = WOETableUtils.FindStandAloneTableByName(Me.cbx_SelTbl.Text, SDMGlobals.SDMMap)
167:         If saTbl Is Nothing Then
168:            MsgBox "Joined table not in table of contents", vbExclamation, "Create Raster"
                Exit Sub
170:         End If
             Dim rTbl As ITable
172:         Set rTbl = saTbl.Table
             Dim fldList As SDMUtilities.SDMList
174:         Set fldList = WOETableUtils.getFieldsAliasNamesByType(rTbl, esriFieldTypeDouble)
175:         Set fldList = fldList.merge(WOETableUtils.getFieldsAliasNamesByType(rTbl, esriFieldTypeInteger))
             Dim vfld As Variant
177:         Me.cbx_SelFld.Clear
178:         For Each vfld In fldList.list
179:             If CStr(vfld) Like "Value" Then
180:             ElseIf CStr(vfld) Like "*ID" Then
181:             ElseIf CStr(vfld) Like "*Count" Then
182:             Else
183:                 Me.cbx_SelFld.AddItem CStr(vfld)
184:             End If
185:         Next vfld
186:         If Me.cbx_SelFld.ListCount = 0 Then
187:            Me.cbx_SelFld.Clear
188:            Me.cbx_SelFld.AddItem "<None>"
189:         End If
190:     Else
191:         Me.cbx_SelFld.Clear
192:         Me.cbx_SelFld.AddItem "<None>"
193:     End If
194:     Me.cbx_SelFld.ListIndex = 0

  Exit Sub
ErrorHandler:
  HandleError False, "GetJoinedTableFieldNames " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), Err.Number, Err.Source, Err.Description, 4
End Sub

Private Sub lbt_Join_Click()
         Dim raslyr As IRasterLayer
203:     Set raslyr = WOETableUtils.FindLayerByName(Me.cbx_SelGrd)
         Dim joinDlg As IJoinData
205:     Set joinDlg = New JoinData
206:     Set joinDlg.Application = SDMGlobals.SDMApp
207:     Set joinDlg.layer = raslyr
208:     joinDlg.doModal 0
209:     Me.getEars.BroadcastUpdate Me.cbx_SelGrd
End Sub

Private Sub lbt_OK_Click()
  On Error GoTo ErrorHandler

         Dim raslyr As IRasterLayer
216:     Set raslyr = WOETableUtils.FindLayerByName(Me.cbx_SelGrd)
         Dim rTbl As IDisplayTable
218:     Set rTbl = raslyr
         Dim rFldIdx As Long
220:     rFldIdx = rTbl.DisplayTable.FindField(Me.cbx_SelFld)
         Dim rValIdx As Long
222:     rValIdx = rTbl.DisplayTable.FindField("Value")
         Dim multiplier As Double
224:     multiplier = 1000000 ' CDbl(Me.cbx_Mult.Text)
'>>> Create a new raster by reclassing the values of selected joined attribute field
'>>> of an integer raster to the Value of the new raster
         Dim reMap As INumberRemap
228:     Set reMap = New NumberRemap
         Dim curs As ICursor
230:     Set curs = rTbl.DisplayTable.Search(Nothing, False)
         Dim rw As irow
232:     Set rw = curs.NextRow
         Dim progBar As IStepProgressor
234:     Set progBar = SDMGlobals.SDMStatusBar.ProgressBar
235:     SDMGlobals.SDMStatusBar.ShowProgressBar "Creating remap values...", 0, rTbl.DisplayTable.RowCount(Nothing), 1, True

237:     While Not rw Is Nothing
             Dim lVal As Long
239:         lVal = CLng(CDbl(rw.Value(rFldIdx)) * multiplier)
240:         reMap.MapValue CDbl(rw.Value(rValIdx)), lVal
241:         Set rw = curs.NextRow
242:         SDMGlobals.SDMStatusBar.StepProgressBar
243:     Wend
244:     SDMGlobals.SDMStatusBar.HideProgressBar
245:     If SDMGlobals.SDMRAEnvironment Is Nothing Then _
             Set SDMGlobals.SDMRAEnvironment = RasterAEUtils.getRasterAnalysisEnvironment

248:     ProgressAnimation.Show "Reclassing..."
         Dim reClas As IReclassOp
250:     Set reClas = New RasterReclassOp
         Dim reClasEnv As IRasterAnalysisEnvironment
252:     Set reClasEnv = reClas
253:     ReclassByClassList.setRAEnv reClasEnv, SDMGlobals.SDMRAEnvironment
254:     reClasEnv.SetCellSize esriRasterEnvMinOf
    
         Dim newRas As IGeoDataset
257:     Set newRas = reClas.ReclassByRemap(raslyr.Raster, reMap, False)
    
         Dim rasMath As IMathOp
260:     Set rasMath = New RasterMathOps
         Dim rasMathEnv As IRasterAnalysisEnvironment
262:     Set rasMathEnv = rasMath
263:     ReclassByClassList.setRAEnv rasMathEnv, SDMGlobals.SDMRAEnvironment
264:     rasMathEnv.SetCellSize esriRasterEnvMinOf
    
         Dim rasMakrOp As IRasterMakerOp
267:     Set rasMakrOp = New RasterMakerOp
         Dim rasMakrOpEnv As IRasterAnalysisEnvironment
269:     Set rasMakrOpEnv = rasMakrOp
270:     ReclassByClassList.setRAEnv rasMakrOpEnv, SDMGlobals.SDMRAEnvironment
271:     rasMakrOpEnv.SetCellSize esriRasterEnvMinOf
         Dim newras2 As IGeoDataset
273:     Set newras2 = rasMath.Divide(rasMath.Float(newRas), rasMakrOp.MakeConstant(multiplier, False))
    
         Dim newRasLayer As IRasterLayer
276:     Set newRasLayer = New RasterLayer
277:     newRasLayer.CreateFromRaster newras2
278:     newRasLayer.Name = Me.cbx_SelGrd.Text & "_" & rTbl.DisplayTable.Fields.Field(rFldIdx).AliasName
279:     SDMGlobals.SDMMap.AddLayer newRasLayer
280:     ProgressAnimation.Hide
281:     Me.ZOrder 0
         Exit Sub
ErrorHandler:
         HandleError False, "lbt_OK_Click " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), Err.Number, Err.Source, Err.Description, 4
284:     MsgBox "Probably due to joining incompatible tables to Raster: " & raslyr.Name, vbInformation, c_sModuleFileName
285:     Err.Clear
End Sub

