VERSION 5.00
Object = "{0ECD9B60-23AA-11D0-B351-00A0C9055D8E}#6.0#0"; "MSHFLXGD.OCX"
Begin VB.Form gReclsTbl 
   BorderStyle     =   3  'Fixed Dialog
   Caption         =   "Reclassify String Attribute"
   ClientHeight    =   4275
   ClientLeft      =   2760
   ClientTop       =   3750
   ClientWidth     =   8040
   LinkTopic       =   "Form1"
   MaxButton       =   0   'False
   MinButton       =   0   'False
   ScaleHeight     =   4275
   ScaleWidth      =   8040
   StartUpPosition =   3  'Windows Default
   Begin VB.CommandButton lbt_LdSav 
      Caption         =   "Load table"
      Height          =   375
      Left            =   4800
      TabIndex        =   11
      ToolTipText     =   "Load the fuzzy membership assignment from a table"
      Top             =   3480
      Visible         =   0   'False
      Width           =   1215
   End
   Begin VB.CommandButton lbt_Sav 
      Caption         =   "Save table"
      Enabled         =   0   'False
      Height          =   375
      Left            =   3480
      TabIndex        =   10
      ToolTipText     =   "To Save this fuzzy membership assignment to a table, preview it before clicking OK"
      Top             =   3480
      Width           =   1215
   End
   Begin VB.Frame cpl_Edcell 
      Caption         =   "Edit selected attribute(s)"
      Height          =   2895
      Left            =   5400
      TabIndex        =   3
      Top             =   240
      Width           =   2535
      Begin VB.CommandButton lbt_Interp 
         Caption         =   "Interpolate"
         Height          =   375
         Left            =   480
         TabIndex        =   9
         ToolTipText     =   "Interpolate values among selected cells"
         Top             =   1920
         Width           =   1215
      End
      Begin VB.CommandButton lbt_NoData 
         Caption         =   "Set NoData"
         Height          =   375
         Left            =   480
         TabIndex        =   8
         ToolTipText     =   "Set new values to NoData"
         Top             =   1440
         Width           =   1215
      End
      Begin VB.CommandButton lbt_SetVal 
         Caption         =   "Set value"
         Enabled         =   0   'False
         Height          =   375
         Left            =   480
         TabIndex        =   6
         ToolTipText     =   "Set cell value from new value"
         Top             =   960
         Width           =   1215
      End
      Begin VB.TextBox txt_NewVal 
         Height          =   375
         Left            =   1080
         TabIndex        =   5
         ToolTipText     =   "Enter new value for selected cell"
         Top             =   360
         Width           =   1095
      End
      Begin VB.Label Label1 
         Caption         =   "New value"
         Height          =   255
         Left            =   240
         TabIndex        =   4
         Top             =   480
         Width           =   855
      End
   End
   Begin MSHierarchicalFlexGridLib.MSHFlexGrid MSHFlexGrid1 
      Height          =   2415
      Left            =   240
      TabIndex        =   2
      Top             =   360
      Width           =   5055
      _ExtentX        =   8916
      _ExtentY        =   4260
      _Version        =   393216
      Cols            =   3
      FixedCols       =   0
      BackColorSel    =   16776960
      ForeColorSel    =   0
      FocusRect       =   2
      GridLinesFixed  =   1
      ScrollBars      =   2
      SelectionMode   =   1
      MousePointer    =   3
      _NumberOfBands  =   1
      _Band(0).Cols   =   3
   End
   Begin VB.CommandButton lbt_Can 
      Caption         =   "Cancel"
      Height          =   375
      Left            =   1920
      TabIndex        =   1
      ToolTipText     =   "Exit mapping to fuzzy membership"
      Top             =   3480
      Width           =   1215
   End
   Begin VB.CommandButton lbt_OK 
      Caption         =   "OK"
      Height          =   375
      Left            =   600
      TabIndex        =   0
      ToolTipText     =   "Create a raster from the selected fuzzification function"
      Top             =   3480
      Width           =   1215
   End
   Begin VB.Label SDMLogo 
      Alignment       =   2  'Center
      Appearance      =   0  'Flat
      BackColor       =   &H0000C000&
      BorderStyle     =   1  'Fixed Single
      Caption         =   "ArcSDM3"
      BeginProperty Font 
         Name            =   "Roman"
         Size            =   14.25
         Charset         =   255
         Weight          =   700
         Underline       =   0   'False
         Italic          =   -1  'True
         Strikethrough   =   0   'False
      EndProperty
      ForeColor       =   &H0080FFFF&
      Height          =   375
      Left            =   6120
      TabIndex        =   12
      Top             =   3480
      Width           =   1335
   End
   Begin VB.Label lbl_Msg 
      Height          =   255
      Left            =   240
      TabIndex        =   7
      Top             =   120
      Width           =   4815
   End
End
Attribute VB_Name = "gReclsTbl"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit
Const c_sModuleFileName As String = "gReclsTbl.frm"
Private saveTable As IStandaloneTable
Private aRasterObj As IRasterLayer
Private aFieldName As String
Private theBreaks As IStringRemap

Public Property Get rasterObj() As IRasterLayer
9:     Set rasterObj = aRasterObj
End Property

Public Property Set rasterObj(ByVal NewValue As IRasterLayer)
13:     Set aRasterObj = NewValue
End Property

Public Property Get fieldName() As String
17:     fieldName = aFieldName
End Property

Public Property Let fieldName(ByVal NewValue As String)
21:     fieldName = NewValue
End Property
Public Property Get getSaveTable() As IStandaloneTable
24:     Set getSaveTable = saveTable
End Property

Private Sub lbt_Can_Click()
28:     Unload Me
End Sub

Private Sub lbt_Interp_Click()
    Dim row1 As Long, row2 As Long, row As Long
    If Me.MSHFlexGrid1.rowSel = Me.MSHFlexGrid1.row Then Exit Sub
34:         If Me.MSHFlexGrid1.rowSel > Me.MSHFlexGrid1.row Then
35:         row1 = Me.MSHFlexGrid1.row
36:         row2 = Me.MSHFlexGrid1.rowSel
37:     Else
38:         row1 = Me.MSHFlexGrid1.rowSel
39:         row2 = Me.MSHFlexGrid1.row
40:     End If
        Dim y1 As Double, y0 As Double
42:         y1 = Me.MSHFlexGrid1.TextMatrix(row2, 1)
43:         y0 = Me.MSHFlexGrid1.TextMatrix(row1, 1)
        Dim x1 As Double, x0 As Double
45:         x1 = row2
46:         x0 = row1
        Dim numInts As Double
        Dim m As Double
49:         m = (y1 - y0) / (x1 - x0)
        Dim b As Double
51:         b = y1 - m * x1
52:     For row = row1 To row2
53:         Me.MSHFlexGrid1.TextMatrix(row, 1) = CStr(Int(m * row + b + 0.5))
54:     Next row
End Sub

Private Sub lbt_Sav_Click()
         Dim pdataSet As IDataset
59:     Set pdataSet = Me.getSaveTable
60:     WOETableUtils.AddTable pdataSet.Workspace.PathName, pdataSet.Name, SDMGlobals.SDMApp
End Sub

Private Sub lbt_SetVal_Click()
    Dim row1 As Long, row2 As Long, row As Long
65:     If Me.MSHFlexGrid1.rowSel >= Me.MSHFlexGrid1.row Then
66:         row1 = Me.MSHFlexGrid1.row
67:         row2 = Me.MSHFlexGrid1.rowSel
68:     Else
69:         row1 = Me.MSHFlexGrid1.rowSel
70:         row2 = Me.MSHFlexGrid1.row
71:     End If
72:     For row = row1 To row2
73:         Me.MSHFlexGrid1.TextMatrix(row, 1) = Me.txt_NewVal
74:     Next row
End Sub
Private Sub lbt_NoData_Click()
        Dim row1 As Long, row2 As Long, row As Long
78:     If Me.MSHFlexGrid1.rowSel >= Me.MSHFlexGrid1.row Then
79:         row1 = Me.MSHFlexGrid1.row
80:         row2 = Me.MSHFlexGrid1.rowSel
81:     Else
82:         row1 = Me.MSHFlexGrid1.rowSel
83:         row2 = Me.MSHFlexGrid1.row
84:     End If
85:     For row = row1 To row2
86:         Me.MSHFlexGrid1.TextMatrix(row, 1) = "NoData"
87:     Next row
End Sub

Private Sub lbt_OK_Click()
  On Error GoTo ErrorHandler

        Dim row As Long
94:     For row = 1 To Me.MSHFlexGrid1.Rows - 1
95:         If Me.MSHFlexGrid1.TextMatrix(row, 1) = "" Then
96:             MsgBox "There are blank new values", vbExclamation, Me.Caption
            Exit Sub
98:         End If
99:     Next row
'Load the IStringRemap object with values
        Dim strRmp As IStringRemap
102:         Set strRmp = New StringRemap
103:     For row = 1 To Me.MSHFlexGrid1.Rows - 1
104:         strRmp.MapString Me.MSHFlexGrid1.TextMatrix(row, 0), Me.MSHFlexGrid1.TextMatrix(row, 1)
105:     Next row
106:     Set theBreaks = strRmp
107:    Me.Hide

  Exit Sub
ErrorHandler:
  HandleError False, "lbt_OK_Click " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), Err.Number, Err.Source, Err.Description, 4
End Sub

Private Sub txt_NewVal_Change()
    Dim newval As String
116:     newval = Me.txt_NewVal.Text
117:     Me.lbt_SetVal.Enabled = IsNumeric(newval)
118:     If Me.lbt_SetVal.Enabled Then Me.lbt_SetVal.Enabled = newval >= 1
End Sub

Public Property Get breaks() As INumberRemap
122:     Set breaks = theBreaks
End Property

Public Property Let breaks(ByVal vNewValue As INumberRemap)
126:     Set theBreaks = vNewValue
End Property
