VERSION 5.00
Begin VB.Form gGen 
   Caption         =   "Generalize evidential themes..."
   ClientHeight    =   6330
   ClientLeft      =   0
   ClientTop       =   0
   ClientWidth     =   6180
   KeyPreview      =   -1  'True
   LinkTopic       =   "gGen1"
   ScaleHeight     =   6330
   ScaleWidth      =   6180
   StartUpPosition =   2  'CenterScreen
   Begin VB.ComboBox cbx_Gth 
      Height          =   315
      Left            =   480
      Sorted          =   -1  'True
      TabIndex        =   0
      Text            =   "cbx_Gth"
      ToolTipText     =   "Select evidence theme to generalize."
      Top             =   720
      Width           =   2235
   End
   Begin VB.ComboBox cbx_Cfd 
      Height          =   315
      Left            =   480
      Sorted          =   -1  'True
      TabIndex        =   2
      Text            =   "cbx_Cfd"
      ToolTipText     =   "Select field with classes to generalize."
      Top             =   1320
      Width           =   2235
   End
   Begin VB.ComboBox cbx_Lfd 
      Height          =   315
      Left            =   480
      Sorted          =   -1  'True
      TabIndex        =   3
      Text            =   "cbx_Lfd"
      ToolTipText     =   "Select field containing class descriptions or 'None'."
      Top             =   1920
      Width           =   2235
   End
   Begin VB.Frame cpa_Met 
      Caption         =   "Generalization Method"
      Height          =   3420
      Left            =   480
      TabIndex        =   6
      Top             =   2520
      Width           =   5235
      Begin VB.OptionButton rad_Uniq 
         Caption         =   "Unique"
         Height          =   255
         Left            =   720
         TabIndex        =   19
         ToolTipText     =   "Unique classification of selected Evidential Theme"
         Top             =   1320
         Width           =   1335
      End
      Begin VB.ComboBox cbx_Tab2 
         Height          =   315
         Left            =   2040
         TabIndex        =   17
         Text            =   "cbx_Tab2"
         ToolTipText     =   "Select table to use for specification of thresholds."
         Top             =   533
         Width           =   2775
      End
      Begin VB.OptionButton rad_Rec 
         Caption         =   "Map classes:"
         Height          =   195
         Left            =   720
         TabIndex        =   7
         ToolTipText     =   "Specify generalization by entering reclassifications. (Shift-click for help.)"
         Top             =   585
         Width           =   1230
      End
      Begin VB.OptionButton rad_Cht 
         Caption         =   "Chart"
         Height          =   195
         Left            =   690
         TabIndex        =   8
         ToolTipText     =   "Selected chart will be used to define generalization thresholds. (Shift-click for help.)"
         Top             =   3000
         Width           =   960
      End
      Begin VB.OptionButton rad_Tab 
         Caption         =   "Table:"
         Height          =   300
         Left            =   720
         TabIndex        =   9
         ToolTipText     =   "Specify Generalization by selected records in selected table . (Shift-click for help.)"
         Top             =   2400
         Width           =   960
      End
      Begin VB.ComboBox cbx_Cht 
         Height          =   315
         Left            =   2025
         TabIndex        =   10
         Text            =   "cbx_Cht"
         ToolTipText     =   "Select chart for specification of thresholds."
         Top             =   3000
         Width           =   2790
      End
      Begin VB.ComboBox cbx_Tab 
         Height          =   315
         Left            =   2280
         TabIndex        =   11
         Text            =   "cbx_Tab"
         ToolTipText     =   "Select table to use for specification of thresholds."
         Top             =   2160
         Width           =   2535
      End
      Begin VB.OptionButton rad_Rng 
         Caption         =   "Class cutoffs:"
         Height          =   300
         Left            =   720
         TabIndex        =   12
         ToolTipText     =   "Specify Generalization by defining thresholds by setting values. (Shift-click for help.)"
         Top             =   2040
         Width           =   1320
      End
      Begin VB.OptionButton rad_Grp 
         Caption         =   "Define groups"
         Height          =   255
         Left            =   720
         TabIndex        =   13
         ToolTipText     =   "Specify Generalization by entering groups of classes using attribute queries. (Shift-click for help.)"
         Top             =   960
         Width           =   1710
      End
      Begin VB.Frame Frame1 
         Caption         =   "Define thresholds by:"
         Height          =   975
         Left            =   480
         TabIndex        =   16
         Top             =   1800
         Width           =   4455
         Begin VB.Label Label1 
            Caption         =   "}"
            BeginProperty Font 
               Name            =   "Garamond"
               Size            =   24
               Charset         =   0
               Weight          =   400
               Underline       =   0   'False
               Italic          =   0   'False
               Strikethrough   =   0   'False
            EndProperty
            Height          =   615
            Left            =   1560
            TabIndex        =   18
            Top             =   240
            Width           =   255
         End
      End
      Begin VB.Frame Frame2 
         Caption         =   "Group classifications"
         Height          =   1455
         Left            =   480
         TabIndex        =   20
         Top             =   240
         Width           =   4455
      End
   End
   Begin VB.CommandButton lbt_Gen 
      Caption         =   "Generalize..."
      Height          =   540
      Left            =   3960
      TabIndex        =   14
      ToolTipText     =   "Click to run selected generalization tool. (Shift-click for help.)"
      Top             =   360
      Width           =   1260
   End
   Begin VB.CommandButton lbt_Don 
      Caption         =   "Close"
      Height          =   540
      Left            =   3960
      TabIndex        =   15
      ToolTipText     =   "Click to close 'Generalize Evidence Map' Dialog."
      Top             =   1080
      Width           =   1260
   End
   Begin VB.Label SDMLogo 
      Alignment       =   2  'Center
      Appearance      =   0  'Flat
      BackColor       =   &H0000C000&
      BorderStyle     =   1  'Fixed Single
      Caption         =   "ArcSDM3"
      BeginProperty Font 
         Name            =   "Roman"
         Size            =   14.25
         Charset         =   255
         Weight          =   700
         Underline       =   0   'False
         Italic          =   -1  'True
         Strikethrough   =   0   'False
      EndProperty
      ForeColor       =   &H0080FFFF&
      Height          =   375
      Left            =   3960
      TabIndex        =   21
      Top             =   1800
      Width           =   1335
   End
   Begin VB.Label aTextLabel2 
      Caption         =   "Evidential Theme:"
      Height          =   270
      Left            =   315
      TabIndex        =   1
      Top             =   420
      Width           =   2205
   End
   Begin VB.Label aTextLabel5 
      Caption         =   "Class field:"
      Height          =   270
      Left            =   315
      TabIndex        =   4
      Top             =   1035
      Width           =   2205
   End
   Begin VB.Label aTextLabel6 
      Caption         =   "Class descriptor field:"
      Height          =   270
      Left            =   315
      TabIndex        =   5
      Top             =   1665
      Width           =   2205
   End
End
Attribute VB_Name = "gGen"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit
Private Listeners As SDMListeners
Private WithEvents aCtl As SDMListeners
Attribute aCtl.VB_VarHelpID = -1
Private WithEvents docEvents As DocumentEvents
Attribute docEvents.VB_VarHelpID = -1
Private WithEvents mapEvents As map
Attribute mapEvents.VB_VarHelpID = -1

Private ObjectTag As SDMList
Private shiftDown As Boolean
Private SrcTableWin As ITableWindow
Const c_sModuleFileName As String = "gGen.frm"
Private server As ITable

Public Property Get getServer() As ITable
  On Error GoTo ErrorHandler
15:     Set getServer = server
  Exit Property
ErrorHandler:
  HandleError True, "getServer " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), Err.Number, Err.Source, Err.Description, 4
End Property

Public Property Set setServer(ByRef aServer As ITable)
  On Error GoTo ErrorHandler
23:     Set server = aServer
  Exit Property
ErrorHandler:
  HandleError True, "setServer " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), Err.Number, Err.Source, Err.Description, 4
End Property

Public Property Set setObjectTag(anObject As SDMList)
    On Error GoTo ErrorHandler
31:     Set ObjectTag = anObject
    Exit Property
ErrorHandler:
  HandleError True, "setObjectTag " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), Err.Number, Err.Source, Err.Description, 4
End Property

Public Property Get getObjectTag() As SDMList
    On Error GoTo ErrorHandler
39:     If (ObjectTag Is Nothing) Then
40:     Set getObjectTag = New SDMUtilities.SDMList
41:     Else
42:     Set getObjectTag = ObjectTag
43:     End If
Exit Property
ErrorHandler:
  HandleError True, "getObjectTag " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), Err.Number, Err.Source, Err.Description, 4
End Property

Public Property Get isShiftdown() As Boolean
    On Error GoTo ErrorHandler
51:     isShiftdown = shiftDown
52:     shiftDown = False
    Exit Property
ErrorHandler:
  HandleError True, "isShiftdown " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), Err.Number, Err.Source, Err.Description, 4
End Property

Public Property Get getEars() As SDMListeners
  On Error GoTo ErrorHandler
60:     Set getEars = Listeners
  Exit Property
ErrorHandler:
  HandleError True, "getEars " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), Err.Number, Err.Source, Err.Description, 4
End Property

'Include selections for all controls with an update method
'Method could be local or belong to an instantiated object
Private Sub aCtl_UpdateEvt(ByRef ctl As Object)
  On Error GoTo ErrorHandler
    Select Case (ctl.Parent.Name)
        Case "gGrc"
72:             gGrc.aCtl_UpdateEvt ctl
        Case "gGrp"
74:             gGrp.aCtl_UpdateEvt ctl
        Case "gTrs"
76:             gTrs.aCtl_UpdateEvt ctl
        Case "gTsh"
78:             gTsh.aCtl_UpdateEvt ctl
        Case "gGen"
            Select Case (ctl.Name)
            Case Me.cbx_Cfd.Name
82:             Me.cbx_Cfd.Clear
                Dim intGrids As AnalysisParameters.gSDI_GetIntGThemes
84:             Set intGrids = New AnalysisParameters.gSDI_GetIntGThemes
                Dim intGridThemes As SDMList
86:                 Set intGridThemes = intGrids.gSDI_GetIntGThemes(SDMUtil.getMap)
87:                 If (intGridThemes.Count <> 0) Then
88:                     Me.cbx_Cfd.Enabled = True
                        Dim VTab As ITable
90:                         Set VTab = gGen.getServer
91:                         If (Not VTab Is Nothing) Then
                            Dim fld As IField
                            Dim n As Integer
                             'For n = 0 To VTab.Fields.FieldCount - 1
                             '        Set fld = VTab.Fields.Field(n)
:                            '        If (fld.Name <> VTab.OIDFieldName And fld.Name <> "Count" And fld.Type <> esriFieldTypeString) Then
                             '            Me.cbx_Cfd.AddItem fld.AliasName
                            '        End If
:                            'Next n
100:                        Me.cbx_Cfd.AddItem "Value"
101:                        Me.cbx_Cfd.Text = "Value"
102:                        End If
103:                Else
104:                     Me.cbx_Cfd.Enabled = False
105:                End If
            Case Me.cbx_Cht.Name
                'gGen.cbx_Cht.Update
108:                 gGen.cbx_Cht.Clear
                     Dim mxdoc As IMxDocument
110:                 Set mxdoc = SDMGlobals.SDMDoc
                     Dim datagfs As IDataGraphs
112:                 Set datagfs = mxdoc
113:                 If (datagfs.Count = 0) Then
114:                     Me.cbx_Cht.Clear
115:                     Me.cbx_Cht.AddItem "No Charts Found"
116:                     Me.cbx_Cht.ListIndex = 0
117:                 Else
                        Dim ncht As Integer
119:                     For ncht = 0 To datagfs.Count - 1
120:                         If datagfs.item(ncht).Name Like "*_C[ADT]" Then _
                                Me.cbx_Cht.AddItem datagfs.item(ncht).Name
122:                     Next ncht
123:                     Me.cbx_Cht.AddItem "<Select>", 0
124:                     Me.cbx_Cht.Text = "<Select>"
125:                     Me.cbx_Cht.ListIndex = 0
126:                 End If
127:                 Me.rad_Cht.Enabled = Me.cbx_Cht.ListCount > 0
            Case Me.cbx_Gth.Name
                'gGen.cbx_Gth.Update
                Dim gGencbxGthUpdate As gGen_cbx_Gth_Update
131:            Set gGencbxGthUpdate = New gGen_cbx_Gth_Update
132:            gGencbxGthUpdate.gGen_cbx_Gth_Update
133:            Set gGencbxGthUpdate = Nothing
            Case Me.cbx_Lfd.Name
                'gGen.cbx_Lfd.Update
                Dim gGencbxLfdUpdate As gGen_cbx_Lfd_Update
137:            Set gGencbxLfdUpdate = New gGen_cbx_Lfd_Update
138:            gGencbxLfdUpdate.gGen_cbx_Lfd_Update
139:            Set gGencbxLfdUpdate = Nothing
            Case Me.cbx_Tab.Name, Me.cbx_Tab2.Name
            'gGen.cbx_Tab.Update
142:             gGen.cbx_Tab.Clear
143:             gGen.cbx_Tab2.Clear
                 Dim tblColl As IStandaloneTableCollection
145:             Set tblColl = SDMUtil.getMap
                 Dim tblCollidx As Long
147:             If (tblColl.StandaloneTableCount > 0) Then
148:                 For tblCollidx = 0 To tblColl.StandaloneTableCount - 1
                         Dim aTbl As ITable
150:                     Set aTbl = tblColl.StandaloneTable(tblCollidx).Table
151:                     If Not aTbl Is Nothing Then
152:                        If (aTbl.FindField("Class") <> -1) Then
                              Dim saTblName As String
154:                          saTblName = tblColl.StandaloneTable(tblCollidx).Name
155:                          If saTblName Like (Me.cbx_Gth.Text & "*") Then
156:                            Me.cbx_Tab.AddItem saTblName
157:                            Me.cbx_Tab2.AddItem saTblName
158:                          End If
159:                        End If
160:                     End If
161:                 Next tblCollidx
162:             End If
163:             If Me.cbx_Tab.ListCount = 0 Then
164:                 Me.cbx_Tab.AddItem "<No Tables Found>", 0
165:                 Me.cbx_Tab.ListIndex = 0
166:             Else
167:                 Me.cbx_Tab.AddItem "<Select>", 0
168:                 Me.cbx_Tab.ListIndex = 0
169:             End If
170:             If Me.cbx_Tab.ListCount > 0 Then
171:                      Me.cbx_Tab2.AddItem "<None>"
172:                 Me.cbx_Tab2.AddItem "<Select>", 0
173:                 Me.cbx_Tab2.Text = "<Select>"
174:                 Me.cbx_Tab2.ListIndex = 0
175:             End If
176:             Me.rad_Tab.Enabled = Me.cbx_Tab.ListCount > 0
177:             Me.rad_Rng.Enabled = Me.cbx_Tab.ListCount > 0
178:             Me.rad_Rec.Enabled = Me.cbx_Tab2.ListCount > 0
            Case gGen.rad_Cht
                Dim chart1 As String
181:            chart1 = Me.cbx_Cht.Text
182:            gGen.rad_Cht.Enabled = (chart1 <> "No Charts Found")
            Case gGen.rad_Rec.Name
            'no script
            Case gGen.rad_Rng.Name
            'no script
                Dim tabName As String
188:            tabName = Me.cbx_Tab.list(0)
189:            Me.rad_Rng.Enabled = (tabName <> "No Tables Found")
            Case gGen.rad_Tab.Name
                'gGen.rad_Tab.Update
                'Dim tabName As String
193:            tabName = Me.cbx_Tab.list(0)
194:            Me.rad_Tab.Enabled = (tabName <> "No Tables Found")
            Case gGen.lbt_Gen.Name
196:                  Me.lbt_Gen.Enabled = _
                    (Me.rad_Rec And (Me.cbx_Tab2 <> "<Select>")) Or _
                     Me.rad_Grp Or _
                     Me.rad_Uniq Or _
                   ((Me.rad_Rng Or Me.rad_Tab) And (Me.cbx_Tab <> "<Select>")) Or _
                    (Me.rad_Cht And (Me.cbx_Cht.Text <> "<No Charts Found>"))
            Case Else
203:     End Select
    Case Else
205:     End Select
  Exit Sub
ErrorHandler:
  HandleError True, "aCtl_UpdateEvt " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), Err.Number, Err.Source, Err.Description, 4
End Sub
    

Private Sub cbx_Cfd_Click()
    'gGen.cbx_Cfd.Select
End Sub

Private Sub cbx_Cht_Click()
'gGen.cbx_Cht.Select
218:     Me.rad_Cht.Enabled = Me.cbx_Cht.Text <> "<Select>"
219:     Me.getEars.Update Me.lbt_Gen
End Sub

Private Sub cbx_Gth_Click()
  On Error GoTo ErrorHandler

    'gGen.cbx_Gth.Select
        Dim aThemeName As String
227:     aThemeName = Me.cbx_Gth.Text
        Dim aTheme As ILayer
229:     Set aTheme = SDMUtil.FindLayerByName(aThemeName)
        If (aTheme Is Nothing) Then Exit Sub
    'theme must be an integer grid or polygon shapefile
'''228:     If (TypeOf aTheme Is IRasterLayer) Then
'''            Dim rtheme As IRasterLayer
'''230:         Set rtheme = aTheme
'''            Dim rprops As IRasterProps
'''232:         Set rprops = rtheme.Raster
'''            If (Not rprops.IsInteger) Then Exit Sub
'''234:     ElseIf (TypeOf aTheme Is IFeatureLayer) Then
'''            Dim ftheme As IFeatureLayer
'''236:         Set ftheme = aTheme
'''            If (ftheme.FeatureClass.ShapeType <> esriGeometryPolygon) Then Exit Sub
'''238:     Else
'''            Exit Sub
'''240:     End If
         Dim gVTab As gSDI_GetVTab
246:     Set gVTab = New gSDI_GetVTab
         Dim VTab As ITable
248:     Set VTab = gVTab.gSDI_GetVTab(aTheme)
         If VTab Is Nothing Then Exit Sub
250:     If TypeOf VTab Is IRelQueryTable Then LayerToTableJoin.RemoveAllJoins aTheme
251:     Set Me.setServer = VTab
252:     Me.getEars.BroadcastUpdate Me.cbx_Gth
253:     Me.cbx_Cht.Text = "<Select>"
254:     Me.cbx_Tab.Text = "<Select>"
255:     Me.cbx_Tab2.Text = "<Select>"
256:     Me.rad_Cht.Enabled = False
257:     Me.rad_Rec.Enabled = False
258:     Me.rad_Tab.Enabled = False
259:     Me.rad_Rng.Enabled = False
260:     Me.ZOrder 0

  Exit Sub
ErrorHandler:
  HandleError True, "cbx_Gth_Click " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), Err.Number, Err.Source, Err.Description, 4
End Sub

Private Sub cbx_Lfd_Click()
'gGen.cbx_Lfd.Select
End Sub

Private Sub cbx_Tab_Click()
'gGen.cbx_Tab.Select
273:     Me.rad_Tab.Enabled = Me.cbx_Tab.Text <> "<Select>"
274:     Me.rad_Rng.Enabled = Me.cbx_Tab.Text <> "<Select>"
275:     Me.getEars.Update Me.lbt_Gen
End Sub

Private Sub cbx_Tab2_Click()
279:     Me.rad_Rec.Enabled = Me.cbx_Tab2.Text <> "<Select>"
280:     Me.getEars.Update Me.lbt_Gen
End Sub

Private Sub docEvents_ActiveViewChanged()
284:     Unload Me
End Sub

Private Sub docEvents_CloseDocument()
288:     Unload Me
End Sub

Private Sub docEvents_MapsChanged()
292:     Unload Me
End Sub

Private Sub docEvents_NewDocument()
296:     Unload Me
End Sub

Private Sub docEvents_OpenDocument()
300:     Unload Me
End Sub

Private Sub Form_Initialize()
304:     Me.KeyPreview = True
End Sub

Private Sub Form_KeyDown(KeyCode As Integer, Shift As Integer)
  On Error GoTo ErrorHandler
309:     shiftDown = (Shift And vbShiftMask) > 0
  Exit Sub
ErrorHandler:
  HandleError True, "Form_KeyDown " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), Err.Number, Err.Source, Err.Description, 4
End Sub

Private Sub Form_KeyUp(KeyCode As Integer, Shift As Integer)
316:     shiftDown = False
End Sub

Private Sub Form_Load()
    On Error GoTo ErrorHandler
321:     Set Listeners = New SDMListeners
322:     Set aCtl = Listeners
323:     If SDMGlobals.SDMApp Is Nothing Then Set SDMGlobals.SDMApp = New esriFramework.AppRef
324:     If SDMGlobals.SDMDoc Is Nothing Then Set SDMGlobals.SDMDoc = SDMGlobals.SDMApp.Document
325:     If SDMGlobals.SDMUtil Is Nothing Then Set SDMGlobals.SDMUtil = New SDMUtilities.SDMUtils
326:     If SDMGlobals.SDMStatusBar Is Nothing Then Set SDMGlobals.SDMStatusBar = SDMGlobals.SDMApp.StatusBar
327:     If SDMGlobals.SDMHelp Is Nothing Then Set SDMGlobals.SDMHelp = New SDMUtilities.gSDI_Help
328:     If SDMGlobals.SDMWorkspace Is Nothing Then _
                Set SDMGlobals.SDMWorkspace = SDMGlobals.SDMUtil.openShapeFileWorkspace( _
                GetSetting("SDMExtension", "AnalysisParameters", "WorkSpace", Environ("TEMP")))
331:     If SDMGlobals.SDMMap Is Nothing Then
             Dim pMxDoc As IMxDocument
333:         Set pMxDoc = SDMGlobals.SDMApp.Document
334:         Set SDMGlobals.SDMMap = pMxDoc.FocusMap
335:     End If
336:     If SDMGlobals.SDMSpatialReference Is Nothing Then _
                Set SDMGlobals.SDMSpatialReference = SDMGlobals.SDMMap.SpatialReference
338:     If SDMGlobals.SDMRAEnvironment Is Nothing Then
               Dim SAUtil As SpatialAnalystUtil
340:          Set SAUtil = New SpatialAnalystUtil
                Dim spatAnl As IRasterAnalysisEnvironment
342:         Set spatAnl = RasterAEUtils.getRasterAnalysisEnvironment
343:         Set SDMGlobals.SDMRAEnvironment = spatAnl
344:     End If
345:     SDMGlobals.SDMPrjDir = FileDialog.getProjectDir
346:     shiftDown = False
         Dim gGenOpen As gGen_Open
348:     Set gGenOpen = New gGen_Open
349:     gGenOpen.gGen_Open
350:     Set gGenOpen = Nothing
351: Me.rad_Cht.Enabled = False
352: Me.rad_Tab.Enabled = False
353: Me.rad_Rng.Enabled = False
354: Me.rad_Rec.Enabled = False
    Exit Sub
ErrorHandler:
  HandleError True, "Form_Load " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), Err.Number, Err.Source, Err.Description, 4
End Sub

Private Sub Form_Unload(Cancel As Integer)
  On Error GoTo ErrorHandler
362:     Set Listeners = Nothing
363:     Set ObjectTag = Nothing
364:     Set setServer = Nothing
  Exit Sub
ErrorHandler:
  HandleError True, "Form_Unload " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), Err.Number, Err.Source, Err.Description, 4
End Sub


Private Sub rad_Rec_Click()
372: If (Me.isShiftdown) Then
373:     SDMHelp.gSDI_Help ("sdmgen.htm#Mapping")
        Exit Sub
375: End If
'gGen.rad_Rec.Click
377: Me.getEars.Update Me.lbt_Gen
End Sub
Private Sub rad_Cht_Click()
380: If (Me.isShiftdown) Then
381:     SDMHelp.gSDI_Help ("sdmgen.htm#Thresholds")
        Exit Sub
383: End If
 'gGen.rad_Cht.Click
 'no script
386: Me.getEars.Update Me.lbt_Gen
End Sub
Private Sub rad_Tab_Click()
389: If (Me.isShiftdown) Then
390:     SDMHelp.gSDI_Help ("sdmgen.htm#Thresholds")
        Exit Sub
392: End If
 'gGen.rad_Tab.Click
394: Me.getEars.Update Me.lbt_Gen
End Sub
Private Sub rad_Rng_Click()
397: If (Me.isShiftdown) Then
398:     SDMHelp.gSDI_Help ("sdmgen.htm#Thresholds")
        Exit Sub
400: End If
 'gGen.rad_Rng.Click
402:   Me.Refresh
403: Me.getEars.Update Me.lbt_Gen
End Sub
Private Sub rad_Grp_Click()
406: If (Me.isShiftdown) Then
407:     SDMHelp.gSDI_Help ("sdmgen.htm#Grouping")
        Exit Sub
409: End If
 'gGen.rad_Grp.Click
411: Me.getEars.Update Me.lbt_Gen
End Sub
Private Sub lbt_Gen_Click()
 'gGen.lbt_Gen.Click
415: If (Me.isShiftdown) Then
416:     SDMHelp.gSDI_Help ("sdmgen.htm")
417:     Me.ZOrder 0
         Exit Sub
419: End If
         Dim gGenlbtGenClick As gGen_lbt_Gen_Click
421:     Set gGenlbtGenClick = New gGen_lbt_Gen_Click
422:     gGenlbtGenClick.gGen_lbt_Gen_Click
423:     Set gGenlbtGenClick = Nothing
         Dim mxdoc As IMxDocument
425:     Set mxdoc = SDMGlobals.SDMDoc
426:     mxdoc.ActiveView.Refresh
427:     Me.ZOrder 0
End Sub
Private Sub lbt_Don_Click()
'gGen.lbt_Don.Click
'Function gGen.lbt_Don.Click() AS VARIANT
'Dim docURL As String
'Gen.lbt_Don.Click
'IF ( System . IsShiftKeyDown ) THEN
'docURL = "sdmgen.htm"
'IF ( docURL . Count > 0 ) THEN
'av . Run ( "gSDI.Help" , { docURL } )
438: If (Me.isShiftdown) Then
439:     SDMHelp.gSDI_Help ("sdmgen.htm")
        Exit Sub
'End If
442: End If
'self . GetDialog . Close
444: Unload Me
End Sub


Public Property Get tableWin() As ITableWindow
449:     If SrcTableWin Is Nothing Then Set SrcTableWin = New TableWindow
450:     Set tableWin = SrcTableWin
End Property

Public Property Set tableWin(ByVal vNewValue As ITableWindow)
454:     Set SrcTableWin = vNewValue
End Property

Public Property Get missingDataValue() As Long
    Dim AnlParms As AnalysisParameters.AnlParams
459:     Set AnlParms = New AnalysisParameters.AnlParams
460:     missingDataValue = CLng(AnlParms.gParamFrm.txtMD)
End Property

Private Sub rad_Uniq_Click()
464:     Me.getEars.Update Me.lbt_Gen
     
End Sub




