VERSION 5.00
Begin VB.Form gL 
   ClientHeight    =   5640
   ClientLeft      =   0
   ClientTop       =   0
   ClientWidth     =   7320
   KeyPreview      =   -1  'True
   LinkTopic       =   "gL1"
   ScaleHeight     =   5640
   ScaleWidth      =   7320
   StartUpPosition =   2  'CenterScreen
   Begin VB.CommandButton lbt_Add 
      Caption         =   "Add ->"
      Height          =   465
      Left            =   2805
      TabIndex        =   0
      ToolTipText     =   "Add the top or selected themes to the 'Selected' list."
      Top             =   1245
      Width           =   1635
   End
   Begin VB.ListBox lbx_All 
      Height          =   3570
      Left            =   570
      MultiSelect     =   2  'Extended
      Sorted          =   -1  'True
      TabIndex        =   1
      ToolTipText     =   "Possible evidential themes in active view. "
      Top             =   720
      Width           =   2040
   End
   Begin VB.CommandButton lbt_Can 
      Caption         =   "Close"
      Height          =   465
      Left            =   5640
      TabIndex        =   2
      Top             =   5040
      Width           =   1290
   End
   Begin VB.ListBox lbx_Cur 
      Height          =   3570
      Left            =   4650
      MultiSelect     =   2  'Extended
      Sorted          =   -1  'True
      TabIndex        =   4
      ToolTipText     =   "Evidential themes selected for response theme."
      Top             =   720
      Width           =   2040
   End
   Begin VB.CommandButton lbt_Aal 
      Caption         =   "Add All ->>"
      Height          =   465
      Left            =   2805
      TabIndex        =   6
      ToolTipText     =   "Add all themes to the 'Selected' list."
      Top             =   1815
      Width           =   1635
   End
   Begin VB.CommandButton lbt_Rem 
      Caption         =   "<- Remove"
      Height          =   465
      Left            =   2805
      TabIndex        =   7
      ToolTipText     =   "Remove the top or selected themes from the 'Selected' list."
      Top             =   2865
      Width           =   1635
   End
   Begin VB.CommandButton lbt_Ral 
      Caption         =   "<<- Remove All"
      Height          =   465
      Left            =   2805
      TabIndex        =   8
      ToolTipText     =   "Remove all themes from the 'Selected' list."
      Top             =   3435
      Width           =   1635
   End
   Begin VB.CommandButton lbt_Nw 
      Caption         =   "Specify Table..."
      Enabled         =   0   'False
      Height          =   465
      Left            =   3870
      TabIndex        =   9
      ToolTipText     =   "Specify the table, missing data integer and data type for the selected evidential themes. (Shift-click for help.)"
      Top             =   5040
      Width           =   1290
   End
   Begin VB.CommandButton lbt_Exp 
      Caption         =   "Expert Weights..."
      Enabled         =   0   'False
      Height          =   465
      Left            =   330
      TabIndex        =   10
      Top             =   5040
      Width           =   1290
   End
   Begin VB.CommandButton lbt_Wt 
      Caption         =   "Calculate Weights..."
      Enabled         =   0   'False
      Height          =   465
      Left            =   2100
      TabIndex        =   11
      ToolTipText     =   "Calculate weights from selected tables and save to new table"
      Top             =   5040
      Width           =   1290
   End
   Begin VB.Label lbl_Status 
      Height          =   255
      Left            =   600
      TabIndex        =   13
      Top             =   4560
      Width           =   6135
   End
   Begin VB.Label SDMLogo 
      Alignment       =   2  'Center
      Appearance      =   0  'Flat
      BackColor       =   &H0000C000&
      BorderStyle     =   1  'Fixed Single
      Caption         =   "ArcSDM3"
      BeginProperty Font 
         Name            =   "Roman"
         Size            =   14.25
         Charset         =   255
         Weight          =   700
         Underline       =   0   'False
         Italic          =   -1  'True
         Strikethrough   =   0   'False
      EndProperty
      ForeColor       =   &H0080FFFF&
      Height          =   375
      Left            =   3000
      TabIndex        =   12
      Top             =   120
      Width           =   1335
   End
   Begin VB.Label txt_T1 
      Caption         =   "Available evidential themes:"
      Height          =   300
      Left            =   570
      TabIndex        =   3
      Top             =   465
      Width           =   2205
   End
   Begin VB.Label txt_T2 
      Caption         =   "Selected evidential themes:"
      Height          =   300
      Left            =   4650
      TabIndex        =   5
      Top             =   465
      Width           =   2280
   End
End
Attribute VB_Name = "gL"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit
Const c_sModuleFileName As String = "gL.frm"
Private Listeners As SDMUtilities.SDMListeners
Private WithEvents aCtl As SDMUtilities.SDMListeners
Attribute aCtl.VB_VarHelpID = -1
Private WithEvents docEvents As DocumentEvents
Attribute docEvents.VB_VarHelpID = -1
Private WithEvents mapEvents As map
Attribute mapEvents.VB_VarHelpID = -1

Private ObjectTag As SDMUtilities.SDMList
Private lbt_Nw_ObjectTag As Variant
Private thmUC_ObjectTag As SDMUtilities.SDMList
Private thmUC_Comments As String
Private lbt_Wt_ClickSet As Variant
Private shiftDown As Boolean
Private tabWComments As String
Private tabVComments As String
Private thmGenTblDict As SDMUtilities.SDMDictionary
Private anlprms As AnalysisParameters.AnlParams
Private SelectedFMTPfield As Variant
Private SelectedFMNTPfield As Variant
Private RasterSourceDict As SDMUtilities.SDMDictionary

Public Property Let SetTabWComments(comments As String)
23:     tabWComments = comments
End Property
Public Property Let SetTabVComments(comments As String)
26:     tabVComments = comments
End Property
Public Property Get GetTabWComments() As String
29:     GetTabWComments = tabWComments
End Property
Public Property Get GetTabVComments() As String
32:     GetTabVComments = tabVComments
End Property
Public Property Set setObjectTag(ByRef anObject As SDMUtilities.SDMList)
  On Error GoTo ErrorHandler
36:     Set ObjectTag = anObject
  Exit Property
ErrorHandler:
  HandleError True, "setObjectTag " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), Err.Number, Err.Source, Err.Description, 4
End Property

Public Property Get getObjectTag() As SDMUtilities.SDMList
  On Error GoTo ErrorHandler

45:     If (ObjectTag Is Nothing) Then
46:         Set getObjectTag = New SDMUtilities.SDMList
47:     Else
48:         Set getObjectTag = ObjectTag
49:     End If
  Exit Property
ErrorHandler:
  HandleError True, "getObjectTag " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), Err.Number, Err.Source, Err.Description, 4
End Property
Public Property Set lbt_Nw_setObjectTag(anObject As Variant)
  On Error GoTo ErrorHandler
56:     lbt_Nw_ObjectTag = anObject
  Exit Property
ErrorHandler:
  HandleError True, "lbt_Nw_setObjectTag " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), Err.Number, Err.Source, Err.Description, 4
End Property

Public Property Get lbt_Nw_getObjectTag() As Variant
  On Error GoTo ErrorHandler
64:         lbt_Nw_getObjectTag = lbt_Nw_ObjectTag
  Exit Property
ErrorHandler:
  HandleError True, "lbt_Nw_getObjectTag " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), Err.Number, Err.Source, Err.Description, 4
End Property
Public Property Set thmUC_setObjectTag(anObject As SDMUtilities.SDMList)
  On Error GoTo ErrorHandler
71:     Set thmUC_ObjectTag = anObject
  Exit Property
ErrorHandler:
  HandleError True, "thmUC_setObjectTag " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), Err.Number, Err.Source, Err.Description, 4
End Property

Public Property Get thmUC_getObjectTag() As SDMUtilities.SDMList
  On Error GoTo ErrorHandler
79:         Set thmUC_getObjectTag = thmUC_ObjectTag
  Exit Property
ErrorHandler:
  HandleError True, "thmUC_getObjectTag " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), Err.Number, Err.Source, Err.Description, 4
End Property

Public Property Set thmUC_setComments(anObject As Variant)
  On Error GoTo ErrorHandler
87:     thmUC_Comments = anObject
  Exit Property
ErrorHandler:
  HandleError True, "thmUC_setComments " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), Err.Number, Err.Source, Err.Description, 4
End Property

Public Property Get thmUC_getComments() As Variant
  On Error GoTo ErrorHandler
95:         thmUC_getComments = thmUC_Comments
  Exit Property
ErrorHandler:
  HandleError True, "thmUC_getComments " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), Err.Number, Err.Source, Err.Description, 4
End Property

Public Property Set lbt_Wt_SetClik(anObject As Variant)
  On Error GoTo ErrorHandler
103:     lbt_Wt_ClickSet = anObject
  Exit Property
ErrorHandler:
  HandleError True, "lbt_Wt_SetClick " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), Err.Number, Err.Source, Err.Description, 4
End Property
Public Property Get lbt_Wt_GetClik() As String
  On Error GoTo ErrorHandler
110:         lbt_Wt_GetClik = lbt_Wt_ClickSet
  Exit Property
ErrorHandler:
  HandleError True, "lbt_Wt_getClick " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), Err.Number, Err.Source, Err.Description, 4
End Property

Public Property Get isShiftdown() As Boolean
  On Error GoTo ErrorHandler
118:     isShiftdown = shiftDown
119:     shiftDown = False
  Exit Property
ErrorHandler:
  HandleError True, "isShiftdown " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), Err.Number, Err.Source, Err.Description, 4
End Property

Public Property Get getEars() As SDMUtilities.SDMListeners
  On Error GoTo ErrorHandler
127:     Set getEars = Listeners
  Exit Property
ErrorHandler:
  HandleError True, "getEars " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), Err.Number, Err.Source, Err.Description, 4
End Property

'Include selections for all controls with an update method
'Method could be local or belong to an instantiated object
Private Sub aCtl_UpdateEvt(ByRef ctl As Object)
    On Error GoTo ErrorHandler
    Select Case (ctl.Name)
        Case Me.lbt_Wt.Name
139:             Me.lbt_Wt.Enabled = Not IsEmpty(lbt_Nw_ObjectTag)
        Case Me.lbt_Exp.Name
141:             Me.lbt_Exp.Enabled = Not IsEmpty(lbt_Nw_ObjectTag)
        Case Me.lbt_Nw.Name
143:             Me.lbt_Nw.Enabled = Me.lbx_Cur.ListCount > 0
        Case Me.lbt_Ral.Name
145:             Me.lbt_Ral.Enabled = Me.lbx_Cur.ListCount > 0
        Case Me.lbt_Rem.Name
147:             Me.lbt_Rem.Enabled = Me.lbx_Cur.SelCount > 0
        Case Me.lbt_Aal.Name
149:             Me.lbt_Aal.Enabled = Me.lbx_All.ListCount > 0
        Case Me.lbt_Add.Name
151:             Me.lbt_Add.Enabled = Me.lbx_All.SelCount > 0
        Case Me.lbx_Cur.Name
153:             If Me.lbx_All.SelCount > 0 Then
154:                 Me.lbx_Cur.TopIndex = 0
155:                 Me.lbx_Cur.ListIndex = -1
156:             End If
        Case Me.lbx_All.Name
158:             If Me.lbx_Cur.SelCount > 0 Then
159:                 Me.lbx_All.TopIndex = 0
160:                 Me.lbx_All.ListIndex = -1
161:             End If
        Case Else
163:             MsgBox "Update not found: " & ctl.Parent.Name, vbCritical, "gL.aCtl.Update"
164:     End Select
    Exit Sub
ErrorHandler:
  HandleError True, "getEars " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), Err.Number, Err.Source, Err.Description, 4
End Sub

Private Sub docEvents_ActiveViewChanged()
171:     Unload Me
    End Sub

Private Sub docEvents_CloseDocument()
175:     Unload Me
    
End Sub

Private Sub docEvents_MapsChanged()
180:     Me.getEars.Update Me.lbx_All
End Sub

Private Sub docEvents_NewDocument()
184:     Unload Me

End Sub

Private Sub docEvents_OpenDocument()
189:     Unload Me

End Sub

Private Sub Form_Initialize()
194:     lbt_Nw_ObjectTag = Empty
195:     lbt_Wt_ClickSet = ""
196:     Set thmUC_ObjectTag = Nothing 'New SDMUtilities.SDMList
197:     Set thmGenTblDict = New SDMUtilities.SDMDictionary
End Sub

Private Sub Form_Load()
    On Error GoTo ErrorHandler
        'MsgBox "loading gParam..."
203:     Set anlprms = New AnalysisParameters.AnlParams
             Dim gParamfrm As Variant
205:         Set gParamfrm = anlprms.gParamfrm
206:         Me.Caption = "Calculate Response Theme"
207:     Set Listeners = New SDMUtilities.SDMListeners
208:     Set aCtl = Listeners
209:    If SDMGlobals.SDMApp Is Nothing Then Set SDMGlobals.SDMApp = New AppRef
210:    If SDMGlobals.SDMDoc Is Nothing Then Set SDMGlobals.SDMDoc = SDMGlobals.SDMApp.Document
211:        If SDMGlobals.SDMMap Is Nothing Then
                Dim pMxDoc As IMxDocument
213:            Set pMxDoc = SDMGlobals.SDMDoc
214:            Set SDMGlobals.SDMMap = pMxDoc.FocusMap
215:        End If
216:    If SDMGlobals.SDMUtil Is Nothing Then
217:            Set SDMGlobals.SDMUtil = New SDMUtilities.SDMUtils
218:            Set SDMGlobals.SDMUtil.setAPP = SDMGlobals.SDMApp
219:    End If
220:    If SDMGlobals.SDMStatusBar Is Nothing Then Set SDMGlobals.SDMStatusBar = SDMGlobals.SDMApp.StatusBar
221:    If SDMGlobals.SDMHelp Is Nothing Then Set SDMGlobals.SDMHelp = New SDMUtilities.gSDI_Help
222:    If SDMGlobals.SDMdataDict Is Nothing Then Set SDMGlobals.SDMdataDict = New SDMUtilities.SDMDictionary
223:    If SDMGlobals.SDMWorkspace Is Nothing Then
224:        Set SDMGlobals.SDMWorkspace = SDMGlobals.SDMUtil.openShapeFileWorkspace(WOETableUtils.getProjectDir)
225:    End If
226:    If SDMGlobals.SDMRAEnvironment Is Nothing Then
227:        Set SDMGlobals.SDMRAEnvironment = RasterAEUtils.getRasterAnalysisEnvironment
228:    End If
229:    shiftDown = False
        Dim gLOpen As gL_Open
231:    Set gLOpen = New gL_Open
232:    gLOpen.gL_Open
233:    Set gLOpen = Nothing
234:    gParamfrm.TrainingPointsSelected
  Exit Sub
ErrorHandler:
  HandleError True, "Form_Load " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), Err.Number, Err.Source, Err.Description, 4
End Sub
Private Sub Form_KeyDown(KeyCode As Integer, Shift As Integer)
  On Error GoTo ErrorHandler
241:     shiftDown = (Shift And vbShiftMask) > 0
  Exit Sub
ErrorHandler:
  HandleError True, "Form_KeyDown " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), Err.Number, Err.Source, Err.Description, 4
End Sub
Private Sub Form_KeyUp(KeyCode As Integer, Shift As Integer)
  On Error GoTo ErrorHandler
248:     shiftDown = False
  Exit Sub
ErrorHandler:
  HandleError True, "Form_KeyUp " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), Err.Number, Err.Source, Err.Description, 4
End Sub

Private Sub lbt_Add_Click()
  On Error GoTo ErrorHandler
256:     If isShiftdown Then
257:         SDMGlobals.SDMHelp.gSDI_Help "sdmrspns.htm#Themes"
        Exit Sub
259:     End If
 'gL.lbt_Add.Click
261:     If Me.lbx_All.SelCount > 0 Then
             Dim i As Long
263:         For i = Me.lbx_All.ListCount - 1 To 0 Step -1
264:             If Me.lbx_All.Selected(i) Then
265:                 Me.lbx_Cur.AddItem Me.lbx_All.list(i)
266:                 Me.lbx_All.RemoveItem i
267:             End If
268:         Next i
269:     End If
270:     Set lbt_Nw_setObjectTag = Empty
271:     Me.getEars.BroadcastUpdate Me.lbt_Add
  Exit Sub
ErrorHandler:
  HandleError False, "lbt_Add_Click " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), Err.Number, Err.Source, Err.Description, 4
End Sub


Private Sub lbt_Exp_Click()
'gL.btnClc.Click
      Dim gLbtnClcClick As gL_btnClc_Click
281:  Set gLbtnClcClick = New gL_btnClc_Click
282:  gLbtnClcClick.gL_btnClc_Click Me.lbt_Exp
283:  Set gLbtnClcClick = Nothing
    
End Sub

Private Sub lbx_All_Click()
  On Error GoTo ErrorHandler

 'gL.lbx_All.Apply
291: gL.getEars.BroadcastUpdate gL.lbx_All

  Exit Sub
ErrorHandler:
  HandleError False, "lbx_All_Click " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), Err.Number, Err.Source, Err.Description, 4
End Sub
Private Sub lbt_Can_Click()
  On Error GoTo ErrorHandler
299:     If isShiftdown Then
300:         SDMGlobals.SDMHelp.gSDI_Help "sdmrspns.htm#Calculate"
            Exit Sub
302:     End If
 'gL.lbt_Can.Click
304:  Set lbt_Nw_setObjectTag = Empty
305:  Unload Me
  Exit Sub
ErrorHandler:
  HandleError False, "lbt_Can_Click " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), Err.Number, Err.Source, Err.Description, 4
End Sub
Private Sub lbt_Aal_Click()
  On Error GoTo ErrorHandler

313:     If isShiftdown Then
314:         SDMGlobals.SDMHelp.gSDI_Help "sdmrspns.htm#Themes"
             Exit Sub
316:     End If
' gL.lbt_Aal.Click
318:     If Me.lbx_All.ListCount > 0 Then
             Dim i As Long
320:         While Me.lbx_All.ListCount > 0
321:             Me.lbx_Cur.AddItem Me.lbx_All.list(0)
322:             Me.lbx_All.RemoveItem 0
323:         Wend
324:     End If
    
326:     Me.getEars.BroadcastUpdate Me.lbt_Aal
327:     Set lbt_Nw_setObjectTag = Empty
328:     Me.getEars.Update Me.lbt_Wt
  Exit Sub
ErrorHandler:
  HandleError False, "lbt_Aal_Click " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), Err.Number, Err.Source, Err.Description, 4
End Sub
Private Sub lbt_Rem_Click()
  On Error GoTo ErrorHandler

336:     If isShiftdown Then
337:         SDMGlobals.SDMHelp.gSDI_Help "sdmrspns.htm#Themes"
        Exit Sub
339:     End If
 'gL.lbt_Rem.Click
341:     If Me.lbx_Cur.SelCount > 0 Then
        Dim i As Long
343:         For i = Me.lbx_Cur.ListCount - 1 To 0 Step -1
344:             If Me.lbx_Cur.Selected(i) Then
345:                 Me.lbx_All.AddItem Me.lbx_Cur.list(i)
346:                 Me.lbx_Cur.RemoveItem i
347:             End If
348:         Next i
349:     End If
350:     Set lbt_Nw_setObjectTag = Empty
351:     Me.getEars.BroadcastUpdate Me.lbt_Rem
  Exit Sub
ErrorHandler:
  HandleError False, "lbt_Rem_Click " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), Err.Number, Err.Source, Err.Description, 4
End Sub
Private Sub lbt_Ral_Click()
  On Error GoTo ErrorHandler

359:     If isShiftdown Then
360:         SDMGlobals.SDMHelp.gSDI_Help "sdmrspns.htm#Themes"
        Exit Sub
362:     End If
 'gL.lbt_Ral.Click
364:     If Me.lbx_Cur.ListCount > 0 Then
        Dim i As Long
366:         While Me.lbx_Cur.ListCount > 0
367:             Me.lbx_All.AddItem Me.lbx_Cur.list(0)
368:             Me.lbx_Cur.RemoveItem 0
369:         Wend
370:     End If
371:     Me.getEars.BroadcastUpdate Me.lbt_Ral
372:     Set lbt_Nw_setObjectTag = Empty
373:     Me.getEars.Update Me.lbt_Wt


  Exit Sub
ErrorHandler:
  HandleError False, "lbt_Ral_Click " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), Err.Number, Err.Source, Err.Description, 4
End Sub
Private Sub lbt_Nw_Click()
  On Error GoTo ErrorHandler
 'gCmb.Run
383:     If (isShiftdown) Then
384:         SDMGlobals.SDMHelp.gSDI_Help "sdmrspns.htm#Classes"
        Exit Sub
386:     End If
    'The Open goes here because the form must be updated every time
    'it is SHOWn.
         Dim gCMBOpen As gCmb_Open
390:     Set gCMBOpen = New gCmb_Open
391:     gCMBOpen.gCmb_Open
392:     Set gCMBOpen = Nothing
393:     gCmb.Show vbModal
  Exit Sub
ErrorHandler:
  HandleError False, "lbt_Nw_Click " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), Err.Number, Err.Source, Err.Description, 4
End Sub
Public Sub lbt_Wt_Click()
  On Error GoTo ErrorHandler
        Dim gLbtnClcClick As gL_btnClc_Click
        Dim gSDIMakeCITab As gSDI_MakeCITab
        Select Case Me.lbt_Wt_GetClik
            Case "gL_BtnClc_Click"
404:             If isShiftdown Then
405:                SDMGlobals.SDMHelp.gSDI_Help "sdmrspns.htm#Calculate"
                    Exit Sub
407:             End If
        'gL.btnClc.Click
409:             Me.Enabled = False
410:             Set gLbtnClcClick = New gL_btnClc_Click
411:             gLbtnClcClick.gL_btnClc_Click Me.lbt_Wt
412:             Set gLbtnClcClick = Nothing
413:             Me.Enabled = True
            Case "gSDI_MakeCITab"
        'gSDI_MakeCITab
416:             Set gSDIMakeCITab = New gSDI_MakeCITab
417:             gSDIMakeCITab.gSDI_MakeCITab Array()
418:             Set gSDIMakeCITab = Nothing
            Case Else
420:             MsgBox "Bad value in lbt_Wt_Click: " & Me.lbt_Wt_GetClik, , "gL"
421:    End Select
  Exit Sub
ErrorHandler:
  HandleError False, "lbt_Wt_Click " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), Err.Number, Err.Source, Err.Description, 4
End Sub

Private Sub lbx_Cur_Click()
428:     Me.getEars.BroadcastUpdate Me.lbx_Cur
End Sub

Public Property Get GenTblDict() As SDMUtilities.SDMDictionary
432:     Set GenTblDict = thmGenTblDict
End Property

Public Property Set GenTblDict(ByVal vNewValue As SDMUtilities.SDMDictionary)
436:     Set thmGenTblDict = vNewValue
End Property

Public Property Get FMTPfield() As Variant
440:     FMTPfield = SelectedFMTPfield
End Property

Public Property Let FMTPfield(ByVal vFldValue As Variant)
444:     SelectedFMTPfield = vFldValue
End Property
Public Property Get FMNTPfield() As Variant
447:     FMNTPfield = SelectedFMNTPfield
End Property

Public Property Let FMNTPfield(ByVal vFldValue As Variant)
451:     SelectedFMNTPfield = vFldValue
End Property


Public Property Get RasterSrcDict() As SDMUtilities.SDMDictionary
456:     If RasterSourceDict Is Nothing Then Set RasterSourceDict = New SDMUtilities.SDMDictionary
457:     Set RasterSrcDict = RasterSourceDict
End Property

Private Sub mapEvents_ContentsChanged()
461:     Me.getEars.Update Me.lbx_All

End Sub

Private Sub mapEvents_FocusMapChanged()
466:     Me.getEars.Update Me.lbx_All
End Sub

Private Sub mapEvents_ItemAdded(ByVal item As Variant)
470:     Me.getEars.Update Me.lbx_All

End Sub

Private Sub mapEvents_ItemDeleted(ByVal item As Variant)
475:     Me.getEars.Update Me.lbx_All

End Sub

Private Sub mapEvents_ItemReordered(ByVal item As Variant, ByVal toIndex As Long)
480:     Me.getEars.Update Me.lbx_All

End Sub

Private Sub mapEvents_ViewRefreshed(ByVal View As esriCarto.IActiveView, ByVal phase As esriCarto.esriViewDrawPhase, ByVal data As Variant, ByVal Envelope As esriGeometry.IEnvelope)
485:     Me.getEars.Update Me.lbx_All

End Sub


Public Property Get Status() As Variant
    Status = Me.lbl_Status.Caption
End Property

Public Property Let Status(ByVal vNewValue As Variant)
    Me.lbl_Status.Caption = vNewValue
End Property
