VERSION 5.00
Begin VB.Form gNorm 
   BorderStyle     =   3  'Fixed Dialog
   Caption         =   "Raster Normalization"
   ClientHeight    =   2415
   ClientLeft      =   2760
   ClientTop       =   3750
   ClientWidth     =   6030
   LinkTopic       =   "Form1"
   MaxButton       =   0   'False
   MinButton       =   0   'False
   ScaleHeight     =   2415
   ScaleWidth      =   6030
   ShowInTaskbar   =   0   'False
   Begin VB.Frame Frame2 
      Caption         =   "Raster attribute to normalize on"
      Height          =   735
      Left            =   240
      TabIndex        =   4
      Top             =   960
      Width           =   5535
      Begin VB.ComboBox cbx_SelFld 
         Height          =   315
         Left            =   120
         TabIndex        =   5
         Text            =   "None"
         ToolTipText     =   "Select raster attribute to normalize on"
         Top             =   240
         Width           =   5295
      End
   End
   Begin VB.Frame Frame1 
      Caption         =   "Raster to normalize"
      Height          =   735
      Left            =   240
      TabIndex        =   2
      ToolTipText     =   "Select raster layer to normalize"
      Top             =   120
      Width           =   5535
      Begin VB.ComboBox cbx_SelGrd 
         Height          =   315
         Left            =   120
         TabIndex        =   3
         Text            =   "None"
         ToolTipText     =   "Select raster layer to normalize"
         Top             =   240
         Width           =   5295
      End
   End
   Begin VB.CommandButton lbt_Can 
      Caption         =   "Done"
      Height          =   375
      Left            =   2400
      TabIndex        =   1
      ToolTipText     =   "Cancel normalization"
      Top             =   1800
      Width           =   1215
   End
   Begin VB.CommandButton lbt_OK 
      Caption         =   "Create"
      Height          =   375
      Left            =   840
      TabIndex        =   0
      ToolTipText     =   "Create new normalized raster"
      Top             =   1800
      Width           =   1215
   End
   Begin VB.Label SDMLogo 
      Alignment       =   2  'Center
      Appearance      =   0  'Flat
      BackColor       =   &H0000C000&
      BorderStyle     =   1  'Fixed Single
      Caption         =   "ArcSDM3"
      BeginProperty Font 
         Name            =   "Roman"
         Size            =   14.25
         Charset         =   255
         Weight          =   700
         Underline       =   0   'False
         Italic          =   -1  'True
         Strikethrough   =   0   'False
      EndProperty
      ForeColor       =   &H0080FFFF&
      Height          =   375
      Left            =   3960
      TabIndex        =   6
      Top             =   1800
      Width           =   1335
   End
End
Attribute VB_Name = "gNorm"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit

Const c_sModuleFileName As String = "gNorm.frm"
Const c_sDLLFileName As String = "SDMAccessories"       ' Constant reflect file module name

Private Listeners As SDMUtilities.SDMListeners
Private WithEvents aCtl As SDMUtilities.SDMListeners
Attribute aCtl.VB_VarHelpID = -1

Private shiftDown As Boolean

Private ObjectTag As SDMUtilities.SDMList
Public Function isShiftdown() As Boolean
  On Error GoTo ErrorHandler

15:     isShiftdown = shiftDown
16:     shiftDown = False

  Exit Function
ErrorHandler:
  HandleError True, "isShiftDown " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), Err.Number, Err.Source, Err.Description, 4
End Function
Public Property Set setObjectTag(ByRef anObject As SDMUtilities.SDMList)
  On Error GoTo ErrorHandler
24:     Set ObjectTag = anObject
  Exit Property
ErrorHandler:
  HandleError True, "setObjectTag " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), Err.Number, Err.Source, Err.Description, 4
End Property

Public Property Get getObjectTag() As SDMUtilities.SDMList
  On Error GoTo ErrorHandler

33:     If (ObjectTag Is Nothing) Then
34:         Set getObjectTag = New SDMUtilities.SDMList
35:     Else
36:         Set getObjectTag = ObjectTag
37:     End If
  Exit Property
ErrorHandler:
  HandleError True, "getObjectTag " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), Err.Number, Err.Source, Err.Description, 4
End Property


Private Sub cbx_SelFld_Click()
45:     Me.getEars.BroadcastUpdate Me.cbx_SelFld
End Sub

Private Sub cbx_SelGrd_Click()
49:     Me.getEars.BroadcastUpdate Me.cbx_SelGrd
End Sub


Private Sub Form_Initialize()
    KeyPreview = True

End Sub

Private Sub Form_KeyDown(KeyCode As Integer, Shift As Integer)
  On Error GoTo ErrorHandler
55:     shiftDown = (Shift And vbShiftMask) > 0
  Exit Sub
ErrorHandler:
  HandleError True, "Form_KeyDown " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), Err.Number, Err.Source, Err.Description, 4
End Sub
Private Sub Form_KeyUp(KeyCode As Integer, Shift As Integer)
  On Error GoTo ErrorHandler
62:     shiftDown = False
  Exit Sub
ErrorHandler:
  HandleError True, "Form_KeyUp " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), Err.Number, Err.Source, Err.Description, 4
End Sub

Public Property Get getEars() As SDMUtilities.SDMListeners
  On Error GoTo ErrorHandler
70:     Set getEars = Listeners
  Exit Property
ErrorHandler:
  HandleError True, "getEars " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), Err.Number, Err.Source, Err.Description, 4
End Property

'Include selections for all controls with an update method
'Method could be local or belong to an instantiated object
Private Sub aCtl_UpdateEvt(ByRef ctl As Object)
    On Error GoTo ErrorHandler
    Select Case (ctl.Name)
        Case Me.cbx_SelFld.Name
82:             GetJoinedTableFieldNames
83:             Me.getEars.BroadcastUpdate Me.cbx_SelFld
        Case Me.lbt_OK.Name
85:             Me.lbt_OK.Enabled = Not (Me.cbx_SelFld.Text = "<None>")
        Case Else
87:             MsgBox "Update not found: " & ctl.Parent.Name, vbCritical, "gL.aCtl.Update"
88:     End Select
    Exit Sub
ErrorHandler:
  HandleError True, "aCtl_UpdateEvt " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), Err.Number, Err.Source, Err.Description, 4
End Sub

Private Sub Form_Load()
    On Error GoTo ErrorHandler
96:     Set Listeners = New SDMUtilities.SDMListeners
97:     Set aCtl = Listeners
98:    If SDMGlobals.SDMApp Is Nothing Then Set SDMGlobals.SDMApp = New AppRef
99:    If SDMGlobals.SDMDoc Is Nothing Then Set SDMGlobals.SDMDoc = SDMGlobals.SDMApp.Document
100:     If SDMGlobals.SDMMap Is Nothing Then
            Dim pMxDoc As IMxDocument
102:         Set pMxDoc = SDMGlobals.SDMDoc
103:         Set SDMGlobals.SDMMap = pMxDoc.FocusMap
104:     End If
105:    If SDMGlobals.SDMUtil Is Nothing Then
106:        Set SDMGlobals.SDMUtil = New SDMUtilities.SDMUtils
107:        Set SDMGlobals.SDMUtil.setAPP = SDMGlobals.SDMApp
108:    End If
109:    If SDMGlobals.SDMStatusBar Is Nothing Then Set SDMGlobals.SDMStatusBar = SDMGlobals.SDMApp.StatusBar
110:    If SDMGlobals.SDMHelp Is Nothing Then Set SDMGlobals.SDMHelp = New SDMUtilities.gSDI_Help
111:    If SDMGlobals.SDMdataDict Is Nothing Then Set SDMGlobals.SDMdataDict = New SDMUtilities.SDMDictionary
112:    If SDMGlobals.SDMWorkspace Is Nothing Then
113:             SDMGlobals.SDMUtil.openShapeFileWorkspace WOETableUtils.getProjectDir
114:    End If
115:    shiftDown = False
        Dim gNormOpen As gNorm_Open
117:     Set gNormOpen = New gNorm_Open
118:     gNormOpen.gNorm_Open
    
    Exit Sub
ErrorHandler:
  HandleError True, "Form_Load" & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), Err.Number, Err.Source, Err.Description, 4
End Sub


Private Sub lbt_Can_Click()
127:     Unload Me
End Sub

Private Sub GetJoinedTableFieldNames()
  On Error GoTo ErrorHandler
Dim rlyr As IRasterLayer
133: Set rlyr = WOETableUtils.FindLayerByName(gNorm.cbx_SelGrd.Text)
     Dim dispTbl As IDisplayTable
135: Set dispTbl = rlyr
     Dim rTbl As ITable
137: Set rTbl = dispTbl.DisplayTable
     Dim fldList As SDMUtilities.SDMList
139: Set fldList = WOETableUtils.getFieldsAliasNamesByType(rTbl, esriFieldTypeDouble)
     Dim vfld As Variant
141: Me.cbx_SelFld.Clear
'142: Me.cbx_SelFld.AddItem "Value"
143: For Each vfld In fldList.list
144: If CStr(vfld) Like "*Post*Prob*" Then
145:    Me.cbx_SelFld.AddItem CStr(vfld)
146: End If
147: Next vfld
148: If Me.cbx_SelFld.ListCount = 0 Then
149:    Me.cbx_SelFld.Clear
150:    Me.cbx_SelFld.AddItem "<None>"
151: End If
152: Me.cbx_SelFld.ListIndex = 0
  Exit Sub
ErrorHandler:
  HandleError False, "GetJoinedTableFieldNames " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), Err.Number, Err.Source, Err.Description, 4
End Sub



Private Sub lbt_OK_Click()
  On Error GoTo ErrorHandler

         Dim raslyr As IRasterLayer
164:     Set raslyr = WOETableUtils.FindLayerByName(Me.cbx_SelGrd.Text)
        Dim dispTbl As IDisplayTable
        Set dispTbl = raslyr
         Dim rTbl As ITable
166:     Set rTbl = dispTbl.DisplayTable
         Dim rFldIdx As Long
168:     rFldIdx = rTbl.FindField(Me.cbx_SelFld.Text)
         Dim rValIdx As Long
170:     rValIdx = rTbl.FindField("Value")
         Dim reMap As INumberRemap
172:     Set reMap = New NumberRemap
         Dim curs As ICursor
174:     Set curs = rTbl.Search(Nothing, False)
         Dim rw As irow
176:     Set rw = curs.NextRow
         Dim progBar As IStepProgressor
178:     Set progBar = SDMGlobals.SDMStatusBar.ProgressBar
179:     SDMGlobals.SDMStatusBar.ShowProgressBar "Creating remap values...", 0, rTbl.RowCount(Nothing), 1, True
180:     While Not rw Is Nothing
            Dim lVal As Long
182:         lVal = rw.Value(rFldIdx) * 1000000
183:         reMap.MapValue rw.Value(rValIdx), lVal
184:         Set rw = curs.NextRow
185:     SDMGlobals.SDMStatusBar.StepProgressBar
186:     Wend
187:     SDMGlobals.SDMStatusBar.HideProgressBar
188:     Set SDMGlobals.SDMWorkspace = SDMGlobals.SDMUtil.openShapeFileWorkspace(WOETableUtils.getProjectDir)
189:     If SDMGlobals.SDMRAEnvironment Is Nothing Then _
             Set SDMGlobals.SDMRAEnvironment = RasterAEUtils.getRasterAnalysisEnvironment

191:     ProgressAnimation.Show "Reclassing..."
         Dim reClas As IReclassOp
193:     Set reClas = New RasterReclassOp
         Dim reClasEnv As IRasterAnalysisEnvironment
195:     Set reClasEnv = reClas
196:     ReclassByClassList.setRAEnv reClasEnv, SDMGlobals.SDMRAEnvironment
197:     reClasEnv.SetCellSize esriRasterEnvMinOf
198:     Set reClasEnv.OutWorkspace = SDMGlobals.SDMWorkspace
         Dim newRas As IGeoDataset
200:     Set newRas = reClas.ReclassByRemap(raslyr.Raster, reMap, False)
   
         Dim rasMath As IMathOp
203:     Set rasMath = New RasterMathOps
         Dim rasMathEnv As IRasterAnalysisEnvironment
205:     Set rasMathEnv = rasMath
206:     ReclassByClassList.setRAEnv rasMathEnv, SDMGlobals.SDMRAEnvironment
207:     rasMathEnv.SetCellSize esriRasterEnvMinOf
208:     Set rasMathEnv.OutWorkspace = SDMGlobals.SDMWorkspace
    
         Dim rasMakrOp As IRasterMakerOp
210:     Set rasMakrOp = New RasterMakerOp
         Dim rasMakrOpEnv As IRasterAnalysisEnvironment
212:     Set rasMakrOpEnv = rasMakrOp
213:     ReclassByClassList.setRAEnv rasMakrOpEnv, SDMGlobals.SDMRAEnvironment
214:     rasMakrOpEnv.SetCellSize esriRasterEnvMinOf
         Dim newras2 As IGeoDataset
216:     Set newras2 = rasMath.Times(rasMath.Float(newRas), rasMakrOp.MakeConstant(0.000001, False))
         Dim newRasLayer As IRasterLayer
219:     Set newRasLayer = New RasterLayer
220:     newRasLayer.CreateFromRaster newras2
221:     newRasLayer.Name = Me.cbx_SelGrd.Text & "_" & rTbl.Fields.Field(rFldIdx).AliasName
222:     SDMGlobals.SDMMap.AddLayer newRasLayer
223:     ProgressAnimation.Hide
  Exit Sub
ErrorHandler:
  HandleError False, "lbt_OK_Click " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), Err.Number, Err.Source, Err.Description, 4
End Sub


