VERSION 5.00
Begin VB.Form gPRT 
   Caption         =   "Associate Responses with Point Theme..."
   ClientHeight    =   3045
   ClientLeft      =   0
   ClientTop       =   0
   ClientWidth     =   6390
   LinkTopic       =   "gPRT1"
   ScaleHeight     =   3045
   ScaleWidth      =   6390
   StartUpPosition =   2  'CenterScreen
   Begin VB.CommandButton lbt_Cls 
      Caption         =   "Close"
      Height          =   510
      Left            =   2520
      TabIndex        =   5
      Top             =   2400
      Width           =   1200
   End
   Begin VB.CommandButton lbt_OK 
      Caption         =   "OK"
      Height          =   510
      Left            =   840
      TabIndex        =   4
      ToolTipText     =   "Generates table of points with responses at corresponding locations. (Shift-click for help.)"
      Top             =   2415
      Width           =   1200
   End
   Begin VB.ComboBox cbx_Prb 
      Height          =   315
      Left            =   2160
      Sorted          =   -1  'True
      TabIndex        =   3
      ToolTipText     =   "Select a response theme."
      Top             =   1560
      Width           =   3000
   End
   Begin VB.ComboBox cbx_Pt 
      Height          =   315
      Left            =   2160
      Sorted          =   -1  'True
      TabIndex        =   2
      ToolTipText     =   "Select a point feature theme."
      Top             =   840
      Width           =   3000
   End
   Begin VB.Label SDMLogo 
      Alignment       =   2  'Center
      Appearance      =   0  'Flat
      BackColor       =   &H0000C000&
      BorderStyle     =   1  'Fixed Single
      Caption         =   "ArcSDM3"
      BeginProperty Font 
         Name            =   "Roman"
         Size            =   14.25
         Charset         =   255
         Weight          =   700
         Underline       =   0   'False
         Italic          =   -1  'True
         Strikethrough   =   0   'False
      EndProperty
      ForeColor       =   &H0080FFFF&
      Height          =   375
      Left            =   4200
      TabIndex        =   6
      Top             =   2400
      Width           =   1335
   End
   Begin VB.Label txt_Pt 
      Alignment       =   1  'Right Justify
      Caption         =   "Point Theme"
      Height          =   375
      Left            =   720
      TabIndex        =   0
      Top             =   840
      Width           =   1290
   End
   Begin VB.Label txt_Prb 
      Alignment       =   1  'Right Justify
      Caption         =   "Response Theme"
      Height          =   255
      Left            =   720
      TabIndex        =   1
      Top             =   1560
      Width           =   1290
   End
End
Attribute VB_Name = "gPRT"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit

Const c_sModuleFileName As String = "gPRT"
Const c_sDLLFileName As String = "SDMAccessories"       ' Constant reflect file module name
Private Listeners As SDMUtilities.SDMListeners
Private WithEvents aCtl As SDMUtilities.SDMListeners
Attribute aCtl.VB_VarHelpID = -1

Private shiftDown As Boolean
Private ObjectTag As SDMUtilities.SDMList

Public Function isShiftdown() As Boolean
12:     isShiftdown = shiftDown
13:     shiftDown = False
End Function
Public Property Set setObjectTag(ByRef anObject As SDMUtilities.SDMList)
  On Error GoTo ErrorHandler
17:     Set ObjectTag = anObject
        Exit Property
ErrorHandler:
  HandleError True, "setObjectTag " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), Err.Number, Err.Source, Err.Description, 4
End Property

Public Property Get getObjectTag() As SDMUtilities.SDMList
  On Error GoTo ErrorHandler

26:     If (ObjectTag Is Nothing) Then
27:         Set getObjectTag = New SDMUtilities.SDMList
28:     Else
29:         Set getObjectTag = ObjectTag
30:     End If
  Exit Property
ErrorHandler:
  HandleError True, "getObjectTag " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), Err.Number, Err.Source, Err.Description, 4
End Property

Private Sub Form_Initialize()
41:     KeyPreview = True
End Sub

Private Sub Form_KeyDown(KeyCode As Integer, Shift As Integer)
  On Error GoTo ErrorHandler
42:     shiftDown = (Shift And vbShiftMask) > 0
        Exit Sub
ErrorHandler:
  HandleError True, "Form_KeyDown " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), Err.Number, Err.Source, Err.Description, 4
End Sub
Private Sub Form_KeyUp(KeyCode As Integer, Shift As Integer)
  On Error GoTo ErrorHandler
49:     shiftDown = False
  Exit Sub
ErrorHandler:
  HandleError True, "Form_KeyUp " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), Err.Number, Err.Source, Err.Description, 4
End Sub

Public Property Get getEars() As SDMUtilities.SDMListeners
  On Error GoTo ErrorHandler
57:     Set getEars = Listeners
  Exit Property
ErrorHandler:
  HandleError True, "getEars " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), Err.Number, Err.Source, Err.Description, 4
End Property

'Include selections for all controls with an update method
'Method could be local or belong to an instantiated object
Private Sub aCtl_UpdateEvt(ByRef ctl As Object)
    On Error GoTo ErrorHandler
    Select Case (ctl.Name)
        Case Me.cbx_Prb.Name
                Dim gPRTcbxPrb As gPRT_cbx_Prb_Update
70:             Set gPRTcbxPrb = New gPRT_cbx_Prb_Update
71:             gPRTcbxPrb.gPRT_cbx_Prb_Update
72:             Set gPRTcbxPrb = Nothing
        Case Me.cbx_Pt.Name
                Dim gPRTcbxPt As gPRT_cbx_Pt_Update
75:             Set gPRTcbxPt = New gPRT_cbx_Pt_Update
76:             gPRTcbxPt.gPRT_cbx_Pt_Update
77:             Set gPRTcbxPt = Nothing
        Case Me.lbt_Cls.Name
        Case Me.lbt_OK.Name
80:             Me.lbt_OK.Enabled = gPRT.cbx_Prb.ListCount <> 0 And gPRT.cbx_Pt.ListCount <> 0
        Case Else
82:             MsgBox "Update not found: " & ctl.Parent.Name, vbCritical, "gL.aCtl.Update"
83:     End Select
    Exit Sub
ErrorHandler:
  HandleError True, "getEars " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), Err.Number, Err.Source, Err.Description, 4
End Sub

Private Sub Form_Load()
    On Error GoTo ErrorHandler
        'MsgBox "loading gParam..."
93:     Set Listeners = New SDMUtilities.SDMListeners
94:     Set aCtl = Listeners
95:    If SDMGlobals.SDMApp Is Nothing Then Set SDMGlobals.SDMApp = New AppRef
96:    If SDMGlobals.SDMDoc Is Nothing Then Set SDMGlobals.SDMDoc = SDMGlobals.SDMApp.Document
97:     If SDMGlobals.SDMMap Is Nothing Then
            Dim pMxDoc As IMxDocument
99:         Set pMxDoc = SDMGlobals.SDMDoc
100:         Set SDMGlobals.SDMMap = pMxDoc.FocusMap
101:     End If
102:    If SDMGlobals.SDMUtil Is Nothing Then
103:             Set SDMGlobals.SDMUtil = New SDMUtilities.SDMUtils
104:             Set SDMGlobals.SDMUtil.setAPP = SDMGlobals.SDMApp
105:         End If
106:    If SDMGlobals.SDMStatusBar Is Nothing Then Set SDMGlobals.SDMStatusBar = SDMGlobals.SDMApp.StatusBar
107:    If SDMGlobals.SDMHelp Is Nothing Then Set SDMGlobals.SDMHelp = New SDMUtilities.gSDI_Help
108:    If SDMGlobals.SDMdataDict Is Nothing Then Set SDMGlobals.SDMdataDict = New SDMUtilities.SDMDictionary
109:    If SDMGlobals.SDMWorkspace Is Nothing Then
            Dim cwdPath As String
            Dim lyr As IDataset
112:        Set lyr = SDMGlobals.SDMMap.layers.Next
113:        If Not lyr Is Nothing Then
114:            cwdPath = lyr.Workspace.PathName
115:        Else
116:            cwdPath = Environ("TEMP")
117:        End If
118:        Set SDMGlobals.SDMWorkspace = SDMGlobals.SDMUtil.openShapeFileWorkspace(cwdPath)
119:    End If
120:    shiftDown = False
    Exit Sub
ErrorHandler:
  HandleError True, "gPRT_Load " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), Err.Number, Err.Source, Err.Description, 4
End Sub

Private Sub lbt_OK_Click()
127:    If (isShiftdown) Then
128:        SDMHelp.gSDI_Help "sdmassoc.htm"
            Exit Sub
130:    End If
 'gSDI.ResponseAtPoints
        Dim gSDIResponseAtPoints As gSDI_RespAtPoints
133:    Set gSDIResponseAtPoints = New gSDI_RespAtPoints
134:    gSDIResponseAtPoints.gSDI_ResponseAtPoints Me.lbt_OK
135:    Set gSDIResponseAtPoints = Nothing
End Sub
Private Sub lbt_Cls_Click()
138:  If (isShiftdown) Then
139:     SDMHelp.gSDI_Help "sdmassoc.htm"
         Exit Sub
141:  End If
 'gPRT.lbt_Cls.Click
 'Self.GetDialog.Close
144:     Unload Me
End Sub
Private Sub lbt_Cls_KeyDown(KeyCode As Integer, Shift As Integer)
147:     shiftDown = Shift And vbShiftMask
End Sub

Private Sub lbt_Cls_KeyUp(KeyCode As Integer, Shift As Integer)
151:     shiftDown = False
End Sub

Private Sub lbt_OK_KeyDown(KeyCode As Integer, Shift As Integer)
155:     shiftDown = Shift And vbShiftMask
End Sub

Private Sub lbt_OK_KeyUp(KeyCode As Integer, Shift As Integer)
159:     shiftDown = False
End Sub
