VERSION 5.00
Object = "{831FDD16-0C5C-11D2-A9FC-0000F8754DA1}#2.0#0"; "MSCOMCTL.OCX"
Object = "{0ECD9B60-23AA-11D0-B351-00A0C9055D8E}#6.0#0"; "mshflxgd.ocx"
Begin VB.Form gTrs 
   Caption         =   "Generalize"
   ClientHeight    =   6285
   ClientLeft      =   0
   ClientTop       =   0
   ClientWidth     =   4215
   KeyPreview      =   -1  'True
   LinkTopic       =   "gTrs1"
   ScaleHeight     =   6285
   ScaleWidth      =   4215
   StartUpPosition =   2  'CenterScreen
   Begin VB.CommandButton lbt_Rset 
      Caption         =   "Reset"
      Height          =   375
      Left            =   1560
      TabIndex        =   13
      ToolTipText     =   "Reset table or Initialize/Enable slider"
      Top             =   3720
      Width           =   1215
   End
   Begin MSHierarchicalFlexGridLib.MSHFlexGrid lbx_clss 
      Height          =   2055
      Left            =   240
      TabIndex        =   12
      Top             =   480
      Width           =   3735
      _ExtentX        =   6588
      _ExtentY        =   3625
      _Version        =   393216
      Cols            =   3
      BeginProperty Font {0BE35203-8F91-11CE-9DE3-00AA004BB851} 
         Name            =   "MS Sans Serif"
         Size            =   8.25
         Charset         =   0
         Weight          =   700
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      _NumberOfBands  =   1
      _Band(0).Cols   =   3
   End
   Begin VB.TextBox txl_Trs 
      Alignment       =   2  'Center
      Height          =   285
      Left            =   1560
      TabIndex        =   11
      Text            =   "Text1"
      ToolTipText     =   "Slider value"
      Top             =   3240
      Width           =   1215
   End
   Begin MSComctlLib.Slider sld_Trs 
      Height          =   495
      Left            =   600
      TabIndex        =   10
      ToolTipText     =   "Select threshold value"
      Top             =   2640
      Width           =   3015
      _ExtentX        =   5318
      _ExtentY        =   873
      _Version        =   393216
      Min             =   1
      SelectRange     =   -1  'True
      SelStart        =   1
      Value           =   1
   End
   Begin VB.CommandButton lbt_Del 
      Caption         =   "Combine"
      Height          =   360
      Left            =   1560
      TabIndex        =   0
      ToolTipText     =   "Combine the selected class ranges"
      Top             =   5010
      Width           =   1230
   End
   Begin VB.CommandButton lbt_Gen 
      Caption         =   "Generalize"
      Height          =   360
      Left            =   1560
      TabIndex        =   1
      ToolTipText     =   "Generalize the evidence map."
      Top             =   5415
      Width           =   1230
   End
   Begin VB.CommandButton lbt_Cle 
      Caption         =   "Close"
      Height          =   360
      Left            =   1560
      TabIndex        =   2
      ToolTipText     =   "Close the dialog, quit generalizing."
      Top             =   5820
      Width           =   1230
   End
   Begin VB.TextBox txl_Cfd 
      Alignment       =   1  'Right Justify
      Enabled         =   0   'False
      Height          =   300
      Left            =   210
      TabIndex        =   3
      Text            =   "Value2"
      Top             =   120
      Width           =   1200
   End
   Begin VB.TextBox txl_Lfd 
      Height          =   300
      Left            =   2520
      TabIndex        =   4
      Text            =   "S_Value2"
      Top             =   120
      Width           =   1395
   End
   Begin VB.CommandButton lbt_Trs 
      Caption         =   "Threshold"
      Height          =   360
      Left            =   1560
      TabIndex        =   8
      ToolTipText     =   "Split the selected class range."
      Top             =   4605
      Width           =   1230
   End
   Begin VB.CommandButton lbtHlp 
      Caption         =   "Help"
      Height          =   360
      Left            =   1560
      TabIndex        =   9
      ToolTipText     =   "Get help for Thresholding"
      Top             =   4200
      Width           =   1230
   End
   Begin VB.Label SDMLogo 
      Alignment       =   2  'Center
      Appearance      =   0  'Flat
      BackColor       =   &H0000C000&
      BorderStyle     =   1  'Fixed Single
      Caption         =   "ArcSDM3"
      BeginProperty Font 
         Name            =   "Roman"
         Size            =   14.25
         Charset         =   255
         Weight          =   700
         Underline       =   0   'False
         Italic          =   -1  'True
         Strikethrough   =   0   'False
      EndProperty
      ForeColor       =   &H0080FFFF&
      Height          =   375
      Left            =   2880
      TabIndex        =   14
      Top             =   5820
      Width           =   1335
   End
   Begin VB.Label txt_Cls 
      Alignment       =   2  'Center
      Caption         =   "Old Class"
      Height          =   225
      Left            =   1440
      TabIndex        =   5
      Top             =   240
      Width           =   1095
   End
   Begin VB.Label txt_Lwr 
      Alignment       =   2  'Center
      Caption         =   "1"
      Height          =   255
      Left            =   720
      TabIndex        =   6
      Top             =   3240
      Width           =   210
   End
   Begin VB.Label txt_Upr 
      Alignment       =   2  'Center
      Caption         =   "10"
      Height          =   255
      Left            =   3240
      TabIndex        =   7
      Top             =   3240
      Width           =   345
   End
End
Attribute VB_Name = "gTrs"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit
Private Listeners As SDMListeners
Private WithEvents aCtl As SDMListeners
Attribute aCtl.VB_VarHelpID = -1
Private ObjectTag As SDMUtilities.SDMList
Private shiftDown As Boolean
Const c_sModuleFileName As String = "C:\MyJava\ARC-SDM\Dialogs\gTrs.frm"

Public Property Set setObjectTag(anObject As SDMUtilities.SDMList)
    On Error GoTo ErrorHandler
10:     Set ObjectTag = anObject
    Exit Property
ErrorHandler:
  HandleError True, "setObjectTag " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), Err.Number, Err.Source, Err.Description, 4
End Property

Public Property Get getObjectTag() As SDMUtilities.SDMList
    On Error GoTo ErrorHandler
18:     If (ObjectTag Is Nothing) Then
19:         Set getObjectTag = New SDMUtilities.SDMList
20:     Else
21:     Set getObjectTag = ObjectTag
22:     End If
Exit Property
ErrorHandler:
  HandleError True, "getObjectTag " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), Err.Number, Err.Source, Err.Description, 4
End Property

Public Property Get isShiftdown() As Boolean
    On Error GoTo ErrorHandler
30:     isShiftdown = shiftDown
31:     shiftDown = False
    Exit Property
ErrorHandler:
  HandleError True, "isShiftdown " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), Err.Number, Err.Source, Err.Description, 4
End Property

Public Property Get getEars() As SDMListeners
38:     Set getEars = Listeners
End Property

'Include selections for all controls with an update method
'Method could be local or belong to an instantiated object
Public Sub aCtl_UpdateEvt(ByRef ctl As Object)
    Select Case (ctl.Name)
    Case Me.lbt_Trs.Name
        Dim selected As SDMList
47:     Set selected = FlexGridUtils.GetSelection(Me.lbx_clss)
48:     Me.lbt_Trs.Enabled = (Me.sld_Trs.Value < Me.sld_Trs.Max) And _
                             (Me.sld_Trs.Value > Me.sld_Trs.Min) And _
                             (selected.Count = 1) And _
                             ((Me.lbx_clss.Col Mod 3) = 1)
    Case Me.txt_Upr.Name
53:         Me.txt_Upr.Caption = CStr(Me.sld_Trs.Max)
    Case Me.txt_Lwr.Name
            Dim curLbl As String
56:         curLbl = Me.txt_Lwr.Caption
57:         If (curLbl <> "Lower") Then
            Dim cursize As Double
59:             cursize = (CDbl(curLbl) / 10)
60:         Else
61:             cursize = Null
62:         End If
63:         Me.txt_Lwr.Caption = CStr(Me.sld_Trs.Min)
        Dim newSize As Double
65:         newSize = CDbl(Me.txt_Lwr.Caption) / 10
66:         If (cursize <> Null) Then
67:             If (newSize > cursize) Then
68:                 Me.txt_Lwr.Move -3, 0
69:             ElseIf (newSize < cursize) Then
70:                 Me.txt_Lwr.Move 3, 0
71:             End If
72:         End If
    Case Me.txl_Trs.Name
74:     Me.txl_Trs.Text = CStr(Me.sld_Trs.Value)
    Case Me.sld_Trs.Name
        'gTsh.sld_Trs.Update
        Dim gTshsldTrsUpdate As gTsh_sld_Trs_Update
78:     Set gTshsldTrsUpdate = New gTsh_sld_Trs_Update
79:     gTshsldTrsUpdate.gTsh_sld_Trs_Update Me.sld_Trs
80:     Set gTshsldTrsUpdate = Nothing
    Case Me.lbt_Del.Name
        'gTsh.lbt_Del.Update
        Dim gTshlbtDelUpdate As gTsh_lbt_Del_Update
84:         Set gTshlbtDelUpdate = New gTsh_lbt_Del_Update
85:         gTshlbtDelUpdate.gTsh_lbt_Del_Update Me.lbt_Del
86:         Set gTshlbtDelUpdate = Nothing
    Case Me.lbt_Gen.Name
        'no script
        Dim bool As Boolean
90:         Me.lbt_Gen.Enabled = Me.lbx_clss.Rows > 1
    Case Me.txl_Cfd.Name
        'gTsh.txl_Cfd.Update
        Dim gTshtxlCfdUpdate As gTsh_txl_Cfd_Update
94:         Set gTshtxlCfdUpdate = New gTsh_txl_Cfd_Update
95:         gTshtxlCfdUpdate.gTsh_txl_Cfd_Update Me.txl_Cfd
96:         Set gTshtxlCfdUpdate = Nothing
    Case Me.txl_Lfd.Name
        'gTsh.txl_Lfd.Update
        Dim gTshtxlLfdUpdate As gTsh_txl_Lfd_Update
100:         Set gTshtxlLfdUpdate = New gTsh_txl_Lfd_Update
101:         gTshtxlLfdUpdate.gTsh_txl_Lfd_Update Me.txl_Lfd
102:         Set gTshtxlLfdUpdate = Nothing
    Case Me.lbx_clss.Name
        Dim gTshlbxClssUpdate As gTsh_lbx_Clss_Update
105:         Set gTshlbxClssUpdate = New gTsh_lbx_Clss_Update
106:         gTshlbxClssUpdate.gTsh_lbx_Clss_Update Me.lbx_clss
107:         Set gTshlbxClssUpdate = Nothing
    Case Else
109:     End Select
    Exit Sub
ErrorHandler:
 HandleError True, "aCtl_UpdateEvt" & " " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), Err.Number, Err.Source, Err.Description, 4
    End Sub
Private Sub Form_Initialize()
  On Error GoTo ErrorHandler
116:   Me.ZOrder 0
  Exit Sub
ErrorHandler:
  HandleError True, "Form_Initialize " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), Err.Number, Err.Source, Err.Description, 4
End Sub

Private Sub Form_KeyDown(KeyCode As Integer, Shift As Integer)
  On Error GoTo ErrorHandler
124:     shiftDown = (Shift And vbShiftMask) > 0
  Exit Sub
ErrorHandler:
  HandleError True, "Form_KeyDown " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), Err.Number, Err.Source, Err.Description, 4
End Sub

Private Sub Form_KeyUp(KeyCode As Integer, Shift As Integer)
131:     shiftDown = False
End Sub

Private Sub Form_Load()
    On Error GoTo ErrorHandler
136:     Me.KeyPreview = True
137:     Set Listeners = gGen.getEars
138:     Set aCtl = Listeners
139:     If SDMGlobals.SDMApp Is Nothing Then Set SDMGlobals.SDMApp = New AppRef
140:     If SDMGlobals.SDMUtil Is Nothing Then Set SDMGlobals.SDMUtil = New SDMUtilities.SDMUtils
141:     If SDMGlobals.SDMStatusBar Is Nothing Then Set SDMGlobals.SDMStatusBar = SDMGlobals.SDMApp.StatusBar
142:     If SDMGlobals.SDMHelp Is Nothing Then Set SDMGlobals.SDMHelp = New gSDI_Help
143:     If SDMGlobals.SDMWorkspace Is Nothing Then
144:     Set SDMGlobals.SDMWorkspace = SDMGlobals.SDMUtil.openShapeFileWorkspace("C:\TEMP")
145:     End If
146:     shiftDown = False
'Set up mshflexgrid
163:     gTrs.sld_Trs.ToolTipText = "Select threshold value for splitting"
168:     lbt_Rset_Click
169:     gTrs.getEars.Update gTrs.sld_Trs
    Exit Sub
ErrorHandler:
  HandleError True, "Form_Load " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), Err.Number, Err.Source, Err.Description, 4
End Sub

Private Sub Form_Unload(Cancel As Integer)
  On Error GoTo ErrorHandler
176:     Set Listeners = Nothing
177:     Set ObjectTag = Nothing
    Dim gTshClose As gTsh_Close
179:     Set gTshClose = New gTsh_Close
180:     gTshClose.gTsh_Close Array(gTrs)
181:     Set gTshClose = Nothing
  Exit Sub
ErrorHandler:
  HandleError True, "Form_Unload " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), Err.Number, Err.Source, Err.Description, 4
End Sub

Private Sub lbt_Del_Click()
    Dim gTshlbtDelClick As gTsh_lbt_Del_Click
189:     Set gTshlbtDelClick = New gTsh_lbt_Del_Click
190:     gTshlbtDelClick.gTsh_lbt_Del_Click Me.lbt_Del
191:     Set gTshlbtDelClick = Nothing
End Sub

Private Sub lbt_Rset_Click()
195:     Me.lbx_clss.Clear
'Set up mshflexgrid
197:     With Me.lbx_clss
198:             .Rows = 0
199:             .Cols = 3
200:             .ScrollBars = flexScrollBarBoth
201:             .ForeColorSel = vbWhite
202:             .BackColorSel = vbBlue
203:             .BackColorBkg = vbWhite
204:             .FixedCols = 0
205:             .FixedRows = 0
206:             .FormatString = ">|^|<"
207:             .ColWidth(0) = 1440 / 2
208:             .ColWidth(1) = 1440
209:             .ColWidth(2) = 1440 * 3 / 2
'set Font = MSSanSerif.Bold
211:     End With
         Dim gTrsOpen As gTrs_Open
213:     Set gTrsOpen = New gTrs_Open
214:     gTrsOpen.gTrs_Open
215:     Set gTrsOpen = Nothing
216:     gTrs.sld_Trs.Enabled = True
    
End Sub

Private Sub lbx_Clss_Click()
 'gGen.lbxApply
     If Me.lbx_clss.Text = "" Or Me.lbx_clss.Col = 1 Then Exit Sub
     Dim strdlg As IGetStringDialog
223: Set strdlg = New GetStringDialog
     Dim label As String
225:  If Me.lbx_clss.Col = 0 Then
226:     label = Me.txl_Cfd.Text
227:  ElseIf Me.lbx_clss.Col = 2 Then
228:     label = Me.txl_Lfd.Text
229:  End If
230:  If (strdlg.DoModal("Enter new value", label, Me.lbx_clss.Text, 0)) Then Me.lbx_clss.Text = strdlg.Value
231:     Set strdlg = Nothing
232:  Me.ZOrder 0
End Sub
Private Sub lbt_Gen_Click()
 'gTsh.lbt_Gen.Click
      Dim gTshlbtGenClick As gTsh_lbt_Gen_Click
236:  Set gTshlbtGenClick = New gTsh_lbt_Gen_Click
237:  gTshlbtGenClick.gTsh_lbt_Gen_Click Me
238:  Set gTshlbtGenClick = Nothing
239:  gGen.ZOrder 0
End Sub
Private Sub lbt_Cle_Click()
 'gTsh.lbt_Cle.Click
242:  If (gTrs.isShiftdown) Then
         Dim gsdiHelp As SDMUtilities.gSDI_Help
244:     Set gsdiHelp = SDMGlobals.SDMHelp
245:     gsdiHelp.gSDI_Help ("sdmgen.htm#Thresholds")
         Exit Sub
247:  End If
'Self.SetTag ("True")
249: Me.lbt_Cle.Tag = "True"
'Self.GetDialog.Close
164: Dim gTshClose As gTsh_Close
252: Set gTshClose = New gTsh_Close
253: gTshClose.gTsh_Close Array(gTrs)
254: Set gTshClose = Nothing
255: Unload Me
256: If Not gGen.tableWin Is Nothing Then
257:     gGen.tableWin.Show False
258:     Set gGen.tableWin = Nothing
259: End If
260: If Not gGen.Visible Then gGen.Visible = True
261: gGen.ZOrder 0
End Sub
Private Sub lbt_Trs_Click()
  On Error GoTo ErrorHandler
 'gTsh.tol_Trs.Apply
 Dim rowlist As SDMList
267:  Set rowlist = FlexGridUtils.getList(gTrs.lbx_clss)
268: If rowlist.Count = 0 Then MsgBox "Row count = 0", , c_sModuleFileName
    If rowlist.Count = 0 Then Exit Sub
Dim arow As SDMList
271: Set arow = rowlist.getObj(0)
 Dim nrows As Long
273:  nrows = rowlist.Count
 Dim rowSel As Long
275:  rowSel = gTrs.lbx_clss.row
276: If (rowSel > nrows - 1) Then MsgBox "(rowSel > nrows - 1)", , c_sModuleFileName
 If (rowSel > nrows - 1) Then Exit Sub
' Dim colSel As Long
'243:  colSel = gTrs.lbx_clss.Col
 Dim rowno As Long
 Dim row As SDMList
 Dim newlist As New SDMList
 Dim newRow As SDMList
 Dim newrowno As Long
285:  newrowno = 1
286:  For rowno = 0 To nrows - 1
287:     Set row = rowlist.getObj(rowno)
288:     Set newRow = New SDMList
289:     If rowno <> rowSel Then
290:         newRow.AddArray Array(newrowno, row.GetVal(1), row.GetVal(2))
291:         newlist.Add newRow
292:     Else
            Dim tokens As Variant
294:         tokens = Split(row.GetVal(1), " - ")
            Dim newthrsh As String
296:         newthrsh = gTrs.sld_Trs.Value
            Dim newrange As String
298:         newrange = Trim(tokens(0)) & " - " & CStr(CLng(newthrsh) - 1)
            Dim newdesc As String
300:         newdesc = "Value" & newrowno
301:         newRow.AddArray Array(newrowno, newrange, newdesc)
302:         newlist.Add newRow
303:         Set newRow = New SDMList
304:         newrowno = newrowno + 1
305:         newrange = newthrsh & " - " & Trim(tokens(1))
306:         newdesc = "Value" & newrowno
307:         newRow.AddArray Array(newrowno, newrange, newdesc)
308:         newlist.Add newRow
309:     End If
310:     newrowno = newrowno + 1
311:  Next rowno
312:  gTrs.lbx_clss.Rows = 0
313:  For rowno = 0 To newlist.Count - 1
314:     Set newRow = newlist.getObj(rowno)
        Dim rowStr As String
316:     rowStr = newRow.GetVal(0) & vbTab & newRow.GetVal(1) & vbTab & newRow.GetVal(2)
317:     gTrs.lbx_clss.AddItem rowStr, rowno
318:  Next rowno
319:     gTrs.getEars.Update Me.lbt_Gen
  Exit Sub
ErrorHandler:
  HandleError False, "lbt_Trs_Click " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), Err.Number, Err.Source, Err.Description, 4
End Sub
Private Sub lbtHlp_Click()
 'gTrs.lbtHlp.Click
Dim instructions As String
327: instructions = "To split a classification: " & vbCrLf & _
               "1.  Click the center column of the classfication (row) to be split." & vbCrLf & _
               "2.  Define the threshold value for splitting by moving the slider bar or entering a value in the text input window." & vbCrLf & _
               "3.  Click the 'Threshold' button." & vbCrLf & _
                vbCrLf & _
               "To recombine two classifications:" & vbCrLf & _
               "1.  Click and drag in the center column to select contiguous classifications (rows)." & vbCrLf & _
               "2.  Click the 'Combine' button." & vbCrLf & _
                vbCrLf & _
               "To edit a class identifier (first column):" & vbCrLf & _
               "1.  Double-click the current value." & vbCrLf & _
               "2.  Enter a new value in the edit dialog." & vbCrLf & _
               "3.  Click 'OK' or press Enter." & vbCrLf & _
                vbCrLf & _
               "To add or edit descriptive text for a classification:" & vbCrLf & _
               "1.  Double-click the current value (right column)." & vbCrLf & _
               "2.  Enter or edit text in the edit dialog." & vbCrLf & _
               "3.  Click 'OK' or press Enter." & vbCrLf & _
                vbCrLf & _
               "To apply the generalization:  " & vbCrLf & _
               "1.  Click the 'Generalize' button." & vbCrLf & _
               "The generalized class values, plus any text descriptions, will be written to the theme attribute table." & vbCrLf & _
               "NOTE:  You must have write permissions for the data set you are generalizing."
350: MsgBox instructions, , "How to use the thresholding dialog"

End Sub

Private Sub lbx_Clss_GotFocus()
355:     If Me.lbx_clss.Col = 1 Then
356:         Me.lbx_clss.ToolTipText = "Select and click range to split or two ranges to combine"
357:     ElseIf Me.lbx_clss.Col = 0 Then
358:         Me.lbx_clss.ToolTipText = "Select and click " & Me.txl_Cfd & " to change"
359:     ElseIf Me.lbx_clss.Col = 2 Then
360:         Me.lbx_clss.ToolTipText = "Select and click " & Me.txl_Lfd & " to change"
361:     End If
End Sub

Private Sub lbx_Clss_SelChange()
365:     Me.getEars.BroadcastUpdate Me.lbx_clss
366:     Me.getEars.Update Me.lbt_Trs
367:         Me.getEars.Update Me.lbt_Del
End Sub

Private Sub sld_Trs_Change()
371:     gTrs.getEars.BroadcastUpdate Me.sld_Trs
372:     gTrs.getEars.Update Me.lbt_Trs
End Sub

Private Sub txl_Trs_Change()
        If (Me.txl_Trs.Text = "") Then Exit Sub
377:     If (CInt(Me.txl_Trs.Text) >= Me.sld_Trs.Min) And _
            (CInt(Me.txl_Trs.Text) <= Me.sld_Trs.Max) Then _
        Me.sld_Trs.Value = Me.txl_Trs.Text
End Sub
