Attribute VB_Name = "ProgressAnimation"
Option Explicit
Dim pStatusBar As esriSystem.IStatusBar
Const c_sModuleFileName As String = "ProgressAnimation.bas"


Sub Show(Message As String)
  On Error GoTo ErrorHandler

10: Set pStatusBar = SDMGlobals.SDMStatusBar
11: If Not pStatusBar Is Nothing Then
13:     pStatusBar.ProgressAnimation.Show
14:     pStatusBar.PlayProgressAnimation True
15:     pStatusBar.Message(0) = Message
16: End If

  Exit Sub
ErrorHandler:
  HandleError True, "Show " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), Err.Number, Err.Source, Err.Description, 4
End Sub

Sub Hide()
  On Error GoTo ErrorHandler

26:     Set pStatusBar = SDMGlobals.SDMStatusBar
27:     If Not pStatusBar Is Nothing Then
28:         pStatusBar.PlayProgressAnimation False
            pStatusBar.ProgressAnimation.Hide
31:         pStatusBar.Message(0) = ""
32:         Set pStatusBar = Nothing
33:     End If

  Exit Sub
ErrorHandler:
  HandleError True, "Hide " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), Err.Number, Err.Source, Err.Description, 4
End Sub












