VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "ArcSDMCommandsMenu"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = True
'+++ This class module contains the code to create a dropdown menu of the
'+++ ARCSDM commands (see the SDMCommands class module)


Option Explicit

Implements IMenuDef


Private Property Get IMenuDef_Caption() As String

  IMenuDef_Caption = "Spatial Data Modeller"
  Exit Property

End Property

Private Sub IMenuDef_GetItemInfo(ByVal pos As Long, ByVal itemDef As IItemDef)
    Select Case pos + 1
    Case 1
      itemDef.Id = "SDMExtension.SDMPreprocCmds"
      itemDef.Group = False
      itemDef.subType = 1
    Case 2
      itemDef.Id = "SDMExtension.SDMModellingCmds"
      itemDef.Group = False
      itemDef.subType = 2
    Case 3
      itemDef.Id = "SDMExtension.SDMFuzzyLogicCmds"
      itemDef.Group = False
      itemDef.subType = 3
    Case 4
      itemDef.Id = "SDMExtension.SDMNeuralNetsCmds"
      itemDef.Group = False
      itemDef.subType = 4
    Case 5
      itemDef.Id = "SDMExtension.SDMPostprocCmds"
      itemDef.Group = False
      itemDef.subType = 5
    Case 6
      itemDef.Id = "SDMExtension.SDMCommands"
      itemDef.Group = False
      itemDef.subType = 23
    Case 7
      itemDef.Id = "SDMExtension.SDMToolsMenu"
      itemDef.Group = False
      itemDef.subType = 3
  End Select
End Sub

Private Property Get IMenuDef_ItemCount() As Long
  IMenuDef_ItemCount = 5
End Property

Private Property Get IMenuDef_Name() As String
  IMenuDef_Name = "ArcSDMCommands"
End Property
