VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "ArrayCollection"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = True
Option Explicit
Option Base 1

Dim items() As Variant
Dim numItems As Long
Dim capacitee As Long
Dim capacityIncrement As Long
Const capacityIncrFactor = 1.5
' Variables used by the Error handler function - DO NOT REMOVE
Const c_sModuleFileName As String = "ArrayCollection.cls"

Sub Add(item As Variant)
  On Error GoTo errorhandler

15:     If numItems = capacitee Then
16:         capacityIncrement = capacityIncrement * capacityIncrFactor
            ReDim Preserve items(numItems + capacityIncrement)
18:         capacitee = numItems + capacityIncrement
19:     End If
20:     If IsObject(item) Then
21:         Set items(numItems + 1) = item
22:     ElseIf IsArray(item) Then
23:         items(numItems + 1) = item
24:     Else
25:         items(numItems + 1) = item
26:     End If
27:     numItems = numItems + 1


  Exit Sub
errorhandler:
  HandleError True, "add " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), Err.Number, Err.Source, Err.Description, 4
End Sub
Sub AddDbl(item As Double)
  On Error GoTo errorhandler

37:     If numItems = capacitee Then
38:         capacityIncrement = capacityIncrement * capacityIncrFactor
            ReDim Preserve items(numItems + capacityIncrement)
40:         capacitee = numItems + capacityIncrement
41:     End If
42:     items(numItems + 1) = item
43:     numItems = numItems + 1


  Exit Sub
errorhandler:
  HandleError True, "addDbl " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), Err.Number, Err.Source, Err.Description, 4
End Sub
Sub AddInt(item As Integer)
  On Error GoTo errorhandler

53:     If numItems = capacitee Then
54:         capacityIncrement = capacityIncrement * capacityIncrFactor
            ReDim Preserve items(numItems + capacityIncrement)
56:         capacitee = numItems + capacityIncrement
57:     End If
58:     items(numItems + 1) = item
59:     numItems = numItems + 1


  Exit Sub
errorhandler:
  HandleError True, "addInt " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), Err.Number, Err.Source, Err.Description, 4
End Sub
Sub AddStr(item As String)
  On Error GoTo errorhandler

69:     If numItems = capacitee Then
70:         capacityIncrement = capacityIncrement * capacityIncrFactor
            ReDim Preserve items(numItems + capacityIncrement)
72:         capacitee = numItems + capacityIncrement
73:     End If
74:     items(numItems + 1) = item
75:     numItems = numItems + 1


  Exit Sub
errorhandler:
  HandleError True, "addStr " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), Err.Number, Err.Source, Err.Description, 4
End Sub


Function item(idx As Long) As Variant
  On Error GoTo errorhandler

87:     If idx < 1 Or idx > numItems Then
88:         item = Null
        Exit Function
90:     End If
91:     If IsObject(items(idx)) Then
92:         Set item = items(idx)
93:     ElseIf IsArray(item) Then
94:         items(numItems + 1) = item
95:     Else
96:         item = items(idx)
97:     End If
    
  Exit Function
errorhandler:
  HandleError True, "item " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), Err.Number, Err.Source, Err.Description, 4
End Function
Function ValItem(idx As Long) As Variant
  On Error GoTo errorhandler
105:         ValItem = items(idx)
  Exit Function
errorhandler:
  HandleError True, "item " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), Err.Number, Err.Source, Err.Description, 4
End Function
Function DblItem(idx As Long) As Double
  On Error GoTo errorhandler
112:         DblItem = items(idx)
  Exit Function
errorhandler:
  HandleError True, "item " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), Err.Number, Err.Source, Err.Description, 4
End Function
Function IntItem(idx As Long) As Integer
  On Error GoTo errorhandler
119:         IntItem = items(idx)
  Exit Function
errorhandler:
  HandleError True, "item " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), Err.Number, Err.Source, Err.Description, 4
End Function
Function StrItem(idx As Long) As String
  On Error GoTo errorhandler
126:         StrItem = items(idx)
  Exit Function
errorhandler:
  HandleError True, "item " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), Err.Number, Err.Source, Err.Description, 4
End Function
Sub Remove(idx As Long)
  On Error GoTo errorhandler

    If idx < 1 Or idx > numItems Then Exit Sub
    Dim i As Long
136:     For i = idx To numItems - 1
137:         If IsObject(items(i)) Or IsArray(items(i)) Then
138:             Set items(i) = items(i + 1)
139:         Else
140:             items(i) = items(i + 1)
141:         End If
142:     Next i
143:     numItems = numItems - 1

  Exit Sub
errorhandler:
  HandleError True, "remove " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), Err.Number, Err.Source, Err.Description, 4
End Sub

Sub Sett(indx As Long, item As Variant)
  On Error GoTo errorhandler

153:     If IsObject(item) Or IsArray(item) Then
154:         Set items(indx + 1) = item
155:     Else
156:         items(indx + 1) = item
157:     End If


  Exit Sub
errorhandler:
  HandleError True, "Sett " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), Err.Number, Err.Source, Err.Description, 4
End Sub

Private Sub Class_Initialize()
  On Error GoTo errorhandler

168:     numItems = 0
169:     capacitee = 100
170:     capacityIncrement = 100
         ReDim items(capacitee)

  Exit Sub
errorhandler:
  HandleError True, "Class_Initialize " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), Err.Number, Err.Source, Err.Description, 4
End Sub

Public Property Get Count() As Long
  On Error GoTo errorhandler

181:     Count = numItems

  Exit Property
errorhandler:
  HandleError True, "Count " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), Err.Number, Err.Source, Err.Description, 4
End Property

Public Property Get increment() As Long
  On Error GoTo errorhandler

191:     increment = capacityIncrement

  Exit Property
errorhandler:
  HandleError True, "Increment " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), Err.Number, Err.Source, Err.Description, 4
End Property

Public Property Let increment(ByVal vNewValue As Long)
  On Error GoTo errorhandler

201:     If vNewValue > capacityIncrement Then capacityIncrement = vNewValue

  Exit Property
errorhandler:
  HandleError True, "Increment " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), Err.Number, Err.Source, Err.Description, 4
End Property

Public Property Get itemList() As Variant()
    ReDim Preserve items(numItems)
210:     capacitee = numItems
211:     itemList = items
End Property

Sub InsertBefore(item As Variant, idx As Long)
  On Error GoTo errorhandler

    If idx < 1 Or idx > numItems Then Exit Sub
218:     Me.Add Null
        Dim i As Long
220:     For i = numItems - 1 To idx Step -1
221:         If IsObject(items(i)) Or IsArray(items(i)) Then
222:             Set items(i + 1) = items(i)
223:         Else
224:             items(i + 1) = items(i)
225:         End If
226:     Next i
227:     items(idx) = item

  Exit Sub
errorhandler:
  HandleError True, "insertBefore " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), Err.Number, Err.Source, Err.Description, 4
End Sub

Sub InsertAfter(item As Variant, idx As Long)
  On Error GoTo errorhandler

    If idx < 1 Or idx > numItems Then Exit Sub
238:     Me.Add Null
        Dim i As Long
240:     For i = numItems - 1 To idx + 1 Step -1
241:         If IsObject(items(i)) Or IsArray(items(i)) Then
242:             Set items(i + 1) = items(i)
243:         Else
244:             items(i + 1) = items(i)
245:         End If
246:     Next i
247:     items(idx) = item


  Exit Sub
errorhandler:
  HandleError True, "insertAfter " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), Err.Number, Err.Source, Err.Description, 4
End Sub

Sub Clear()
256:     numItems = 0
257:     capacitee = 100
258:     capacityIncrement = 100
         ReDim items(capacitee)

End Sub

Public Property Get capacity() As Variant
264:     capacity = capacitee
End Property

