VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "gFL_btnClc_Click"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = True
Option Explicit
Const c_sModuleFileName As String = "gFL_btnClc_Click"
Const c_sDLLFileName As String = "CalculateFuzzyLogic"       ' Constant reflect file module name
'Private ObjectTag As Object
'Property Set setObjectTag(anObject As Object)
'    Set ObjectTag = anObject
'End Property
'Property Get getObjectTag() As Object
'    Set getObjectTag = ObjectTag
'End Property

Sub gFL_btnClc_Click()
  On Error GoTo ErrorHandler

15:  If gFL.isShiftDown Then
16:     SDMGlobals.SDMHelp.gSDI_Help "sdmfl3.htm#Select"
        Exit Sub
18:  End If

'PUT THE IMPLEMENTATION HERE >>>>>>>>>>>>>
'' Name:    gFL.btnClc.Click
''
'' Topics:  Spatial Data Modeller
''
'' Description: Runs an fuzzy logic operation
''          from the calculate button on
''          the fuzzy logic calculator.
''
'' Requires
''
'' Self:    Calculate button on the fuzzy logic dialog
''
'' Returns:  Nil
''==============================================
'If (System.IsShiftKeyDown) Then
'  docURL = "sdmfl3.htm#Select"
'  If (docURL.Count > 0) Then
'    av.Run("gSDI.Help", {docURL})
'  End
'  return Nil
'End

'' Get the active view document, the dialog and
'' verify that at least two evidential themes
'' have been selected
''----------------------------------------------
'viewCrnt = av.GetActiveDoc
'If (viewCrnt.Is(View).Not) Then
'  return Nil
'End
'gFL = self.GetDialog
'lbxTF = gFL.findByName("lbxTF")
'selTF = lbxTF.GetSelection
'If (selTF.Count < 2) Then
'  return Nil
'End

'' Parse selected theme-field combinations
'' to make a list of each
''----------------------------------------------
'lstGThemes = List.Make
'lstStrFlds = List.Make
'for each i in 0..(selTF.Count - 1)
'  strTF = selTF.Get(i).BasicTrim("[", "]")
'  strTF = strTF.AsTokens(".")
'  strTName = strTF.Get(0).Trim
'  thm = viewCrnt.FindTheme(strTName)
'  If (thm = Nil) Then
'    return Nil
'  End
'  lstGThemes.Add (thm)
'  strFName = strTF.Get(1).Trim
'  If ((thm.HasTable.Not) Or (strFName = "Value")) Then
'    lstStrFlds.Add (Nil)
'  Else
'    theVTab = av.Run("gSDI.GetVTab",{thm})
'    If (theVTab = Nil) Then
'      return Nil
'    End
'    fld = theVTab.FindField(strFName)
'    If (fld = Nil) Then
'      return Nil
'    End
'    lstStrFlds.Add (strFName)
'  End
'End

'' Get the selected fuzzy operator and call the
'' associated script
''----------------------------------------------
'operator = self.GetDialog.findByName("cpFO").GetSelected
'If (operator.GetName = "radAND") Then
93: If gFL.radAND Then
        Dim gThmNew As IRasterLayer
'  gThmNew = av.Run("gSDI.FuzzyAND",{lstGThemes,lstStrFlds})
96:     Set gThmNew = gSDI_Stats.gSDI_Stats(esriGeoAnalysisStatsMinimum)
'ElseIf (operator.GetName = "radOR") Then
98: ElseIf gFL.radOR Then
'  gThmNew = av.Run("gSDI.FuzzyOR",{lstGThemes,lstStrFlds})
100:     Set gThmNew = gSDI_Stats.gSDI_Stats(esriGeoAnalysisStatsMaximum)
'ElseIf (operator.GetName = "radSUM") Then
102: ElseIf gFL.radSUM Then
'  gThmNew = av.Run("gSDI.FuzzySUM",{lstGThemes,lstStrFlds})
104:     Set gThmNew = gSDI_Stats.gSDI_Stats(esriGeoAnalysisStatsSum)
'ElseIf (operator.GetName = "radPRD") Then
106: ElseIf gFL.radPRD Then
'  gThmNew = av.Run("gSDI.FuzzyPRD",{lstGThemes,lstStrFlds})
108:     Set gThmNew = gSDI_Stats.gSDI_Stats(esriGeoAnalysisStatsStd)
'ElseIf (operator.GetName = "radGAM") Then
110: ElseIf gFL.radGAM Then
'  opGamma = "0.9"
        Dim opGamma As String
113:     opGamma = "0.9"
'  opGamma = MsgBox.Input("Specify a gamma operator between 0 and 1:", "Gamma Operator", opGamma)
        Dim getStr As IGetStringDialog
116:     Set getStr = New GetStringDialog
        If Not getStr.doModal("Gamma Operator", "Specify a gamma operator between 0 and 1:", opGamma, 0) Then Exit Sub
118:        opGamma = getStr.Value
'  If (opGamma = Nil) Then
        If Not IsNumeric(opGamma) Then Exit Sub
'    return Nil
'  Else
'    while (av.Run("gSDI.CheckGammaOperator",{opGamma}).Not)
124:     While Not (CDbl(opGamma) > 0 And CDbl(opGamma) < 1)
'      opGamma = MsgBox.Input("Specify a gamma operator between 0 and 1:", "Gamma Operator", opGamma)
            If Not getStr.doModal("Gamma Operator", "Specify a gamma operator between 0 and 1:", opGamma, 0) Then Exit Sub
'      If (opGamma = Nil) Then
            If Not IsNumeric(opGamma) Then Exit Sub
'        return Nil
'      End
'    End
132:      Wend
'  End
'  gThmNew = av.Run("gSDI.FuzzyGAM",{lstGThemes,lstStrFlds,opGamma.AsNumber})
135:     Set gThmNew = gSDI_Stats.gSDI_Stats(esriGeoAnalysisStatsVariety, CDbl(opGamma))
'Else
137: Else
'  return Nil
        Exit Sub
'End
141: End If
142: If gThmNew Is Nothing Then
143:     MsgBox "Fuzzy Function aborted.", vbExclamation, c_sModuleFileName
         Exit Sub
145: End If

'' Add the newly generated theme to
'' the list of possible inputs
''----------------------------------------------
'lstTF = lbxTF.GetList
151: gFL.lbxTF.AddItem gThmNew.Name
'lstTF.Insert ("[" + gThmNew.GetName + " . Value]")
'lbxTF.DefineFromList (lstTF)
'lbxTF.BroadcastUpdate
155: gFL.getEars.BroadcastUpdate gFL.lbxTF
'<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
Exit Sub
ErrorHandler:
  HandleError True, c_sModuleFileName & " " & GetErrorLineNumberString(Erl), Err.Number, Err.Source, Err.Description, 4
End Sub

