VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "gPNTP_btnLook_Click"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = True
Option Explicit
' Variables used by the Error handler function - DO NOT REMOVE
Const c_sModuleFileName As String = "gPNTP_btnLook_Click"


Sub gPNTP_btnLook_Click()
  On Error GoTo ErrorHandler
'Get HELP
9:  If (gPNTP.isShiftdown) Then
    Dim gsdiHelp As gSDI_Help
11:     Set gsdiHelp = New gSDI_Help
12:     gsdiHelp.gSDI_Help ("sdmpram.htm#Training")
    Exit Sub
14:  End If
 
'Get Map Projection

'Set Selected Study Area Grid as AE Mask and extents
Dim bMapName As String
20: bMapName = gParam.cbxSA.Text
Dim baseMap As IRasterLayer
22: Set baseMap = SDMGlobals.SDMUtil.FindLayerByName(bMapName)

'Get Training Point Theme and Verify
Dim minName As String
26: minName = gParam.cbxNTP
Dim minTheme As IFeatureLayer
28: Set minTheme = SDMGlobals.SDMUtil.FindLayerByName(minName)

'Check Parameters
Dim bmVTab As ITable
32: Set bmVTab = baseMap

Dim totArea As Double
Dim cntFldidx As Long
36: cntFldidx = bmVTab.FindField("Count")

Dim oid As Long
39: For oid = 0 To bmVTab.RowCount(Nothing) - 1
    Dim row As irow
41:     Set row = bmVTab.GetRow(oid)
42:     totArea = totArea + row.Value(cntFldidx)
43: Next oid

Dim asymptote As Boolean
46: asymptote = gPUA.radAsy.Value
Dim bmapProps As IRasterProps
48: Set bmapProps = baseMap.Raster
49: If (asymptote) Then
50:     totArea = totArea * (bmapProps.MeanCellSize.x ^ 2) / 1000000
51: Else
    Dim uArea As Double
53:     uArea = CDbl(gParam.txtUA.Text)
54:     totArea = totArea * (bmapProps.MeanCellSize.x ^ 2) / uArea / 1000000
55: End If
Dim numsel As String
57: numsel = gPNTP.txtTPsIn.Caption
'IF TRAINING POINT AND EXPERT WEIGHTS ONLY NOT SELECTED
'CHECK LOCATION OF EACH TRAINING POINT AND REPORT TO USER

61: If (gPNTP.chkExp <> 1) Then
        Dim totDeposits As Long
63:     totDeposits = 0
    'GET ALL POINT DEPOSITS OBJECTS AND ADD THEM TO A LIST
    'FIND THE PIXEL THAT POINT FALLS IN AND ADD ITS
    'CLASS TO A SECOND LIST
    '-----------------------------------------------------
68:     SDMGlobals.SDMStatusBar.Message(0) = "Checking Train Point Locations..."

         Dim studyArea As IRasterLayer
71:      Set studyArea = WOETableUtils.FindLayerByName(gParam.cbxSA.Text)
         Dim TPLayer As IFeatureLayer
73:      Set TPLayer = WOETableUtils.FindLayerByName(gParam.cbxNTP.Text)
74:     Set gPNTP.NoTPsIn = RasterUtils.GetTPsInRasterDataArea(TPLayer, studyArea)
        If gPNTP.NoTPsIn Is Nothing Then Exit Sub
76:     gParam.getEars.Update gPNTP.txtTPsIn
77:     gParam.getEars.Update gPNTP.txtTPsSel
78:     gParam.getEars.Update gPNTP.txtTPsAll
79:         totDeposits = CStr(gPNTP.txtTPsSel.Caption)
'>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>
        Dim tpLabel As String
82:     If (totDeposits = 0) Then
83:         tpLabel = numsel
84:     Else
85:         tpLabel = totDeposits & " of " & numsel & " selected." & vbCrLf & _
                    "The prior probability is " & Round(totDeposits / totArea, 5)
87:     End If
88:     MsgBox "The number of Training Points is " & tpLabel & ".", vbInformation, "Training Points"
89:     gPNTP.btnLook.Tag = totDeposits
90: Else
91:     gPNTP.btnLook.Tag = Null
92: End If
93: gParam.getEars.Update gPNTP.txtTPsSel
  Exit Sub
ErrorHandler:
  HandleError True, "gPNTP_btnLook_Click " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), Err.Number, Err.Source, Err.Description, 4
End Sub

