VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "gSDI_Add2UCTab"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = True
Option Explicit
Const c_sModuleFileName As String = "gSDI_Add2UCTab"
Const c_sDLLFileName As String = "CalculateResponse"       ' Constant reflect file module name
'Private ObjectTag As Object
'Property Set setObjectTag(anObject As Object)
'    Set ObjectTag = anObject
'End Property
'Property Get getObjectTag() As Object
'    Set getObjectTag = ObjectTag
'End Property

Function gSDI_Add2UCTab(Self As Variant) As ITable
  On Error GoTo ErrorHandler
'MsgBox "entering " & c_sModuleFileName
'PUT THE IMPLEMENTATION HERE >>>>>>>>>>>>>
'' gSDI.Add2UCTab
'' Topics:  Spatial Data Modeller
'' Description:
'' Requires:
'' Self:
'' Returns:
''==============================================

'thmUC = Self.Get(0)
    Dim thmUC As IRasterLayer
26: Set thmUC = Self(0)
'vTabTP = Self.Get(1)
    Dim tpThm As IFeatureLayer
29: Set tpThm = Self(1)
    Dim vTabTP As ITable
31: Set vTabTP = tpThm
'prjCrnt = Self.Get(2)
    Dim prjCrnt As IProjectedCoordinateSystem
34: Set prjCrnt = Self(2)
'' EDIT UNIQUE CONDITIONS GRID'S ATTRIBUTE TABLE TO ADD
'' THE NUMBER OF MINERAL OCCURENCES THAT FALL WITHIN
'' THE AREA OF EACH UNIQUE CONDITION
''-------------------------------------------------
'vTabUC = av.Run("gSDI.GetVTab",{thmUC})
    Dim vTabUC As ITable
41: Set vTabUC = RasterUtils.GetTable(thmUC)
'If (vTabUC = Nil) Then
'  MsgBox.Error("Error accessing attributes of unique conditions grid.","Unique Conditions")
'  return Nil
'End
'grdUC = thmUC.GetGrid
    Dim grdUC As IRaster
48: Set grdUC = RasterUtils.GetDatasetRaster(thmUC)
''MAKE A LIST TO HOLD DEPOSIT POINTS AND
''THEIR ASSOCIATED CLASSES
''-----------------------------------------
    Dim pProgbar As IStepProgressor
53: Set pProgbar = SDMGlobals.SDMStatusBar.ProgressBar
''lstPnts = List.Make
'lstClssPnt = List.Make
Dim lstClssPnt As SDMUtilities.SDMList
57: Set lstClssPnt = New SDMUtilities.SDMList
'If (vTabTP <> Nil) Then
59: If Not tpThm Is Nothing Then
'  'GET ALL POINT DEPOSIT OBJECTS AND ADD THEM TO A LIST
'  'FIND THE PIXEL THAT THE POINT FALLS IN AND ADD ITS
'  'CLASS TO A SECOND LIST
'  '-----------------------------------------
        Dim record As irow
'  For Each record In vTabTP
        Dim shapeFieldName As String
67:     shapeFieldName = tpThm.FeatureClass.shapeFieldName
        Dim shapeFieldIdx As Long
69:     shapeFieldIdx = tpThm.FeatureClass.FindField(shapeFieldName)
        
        Dim rasBuf As IRasterBuffer
72:     Set rasBuf = New IRasterBuffer
73:     If Not rasBuf.OpenBuffer(thmUC) Then
74:         MsgBox "Error opening rasterbuffer: " & thmUC.Name, vbCritical, c_sModuleFileName
            Dim rasprops As IRasterProps
76:         Set rasprops = RasterUtils.GetDatasetRaster(thmUC)
77:         MsgBox "Raster type: " & rasprops.PixelType, , c_sModuleFileName
78:         Set gSDI_Add2UCTab = Nothing
            Exit Function
80:     End If
        Dim pntSelection As IFeatureSelection
82:     Set pntSelection = tpThm
        Dim tpOIDs As IEnumIDs
84:     Set tpOIDs = pntSelection.SelectionSet.IDs
'MsgBox pntSelection.SelectionSet.Count, , "TPs selected"
        Dim tpOID As Long
87:     tpOID = tpOIDs.Next
88:     pProgbar.Position = 0
89:     SDMGlobals.SDMStatusBar.ShowProgressBar "Processing training points...", 1, pntSelection.SelectionSet.Count, 1, True
'MsgBox "processing TPs...", , "Neural Network"
91:     While tpOID <> -1
92:         Set record = vTabTP.GetRow(tpOID)
'    pnt = vTabTP.ReturnValue(vTabTP.FindField("Shape"), record)
            Dim pnt As IPoint
95:         Set pnt = record.Value(shapeFieldIdx)
'  '  lstPnts.Add(pnt)
'    pntCls = grdUC.CellValue(pnt, prjCrnt)
            Dim pntCls As Variant
99:         pntCls = rasBuf.CellValue(pnt)
'    If (pntCls.IsNull.Not) Then
101:         If (Not IsNull(pntCls)) Then
'      lstClssPnt.Add (pntCls)
103:             If (CStr(pntCls) <> "NoData") Then lstClssPnt.Add CLng(pntCls)
104:         End If
'    End
'  End
107:         tpOID = tpOIDs.Next
108:         SDMGlobals.SDMStatusBar.StepProgressBar
109:     Wend
110:     SDMGlobals.SDMStatusBar.HideProgressBar
'End
112: End If 'End of tpThm is not nothing
113: If Not tpThm Is Nothing Then
114:    If lstClssPnt.IsEmpty Then
115:        Set gSDI_Add2UCTab = Nothing
116:         MsgBox "Cell Values Error" & vbCrLf & "Data Frame needs a Coordinate System!", vbCritical, c_sModuleFileName
            Exit Function
118:    End If
119: End If
''MAKE AND INITIALIZE A LIST OF POINT-CLASS COUNTS
''-----------------------------------------
'If (vTabTP <> Nil) Then
123: If Not tpThm Is Nothing Then
'  pntCountList = List.Make
        Dim pntCountList As SDMUtilities.SDMList
126:    Set pntCountList = New SDMUtilities.SDMList
'End
128: End If
'classList = List.Make
     Dim classlist As New SDMUtilities.SDMList
'lstAreas = List.Make
     Dim lstAreas As New SDMUtilities.SDMList
     Dim validx As Long
134: validx = vTabUC.FindField("Value")
     Dim cntidx As Long
136: cntidx = vTabUC.FindField("Count")
'For Each record In vTabUC
'MsgBox "processing UC records...", , "Neural Network"
139: pProgbar.Position = 0
140: SDMGlobals.SDMStatusBar.ShowProgressBar "Processing UC records...", 1, vTabUC.RowCount(Nothing), 1, True
     Dim curs As ICursor
142: Set curs = vTabUC.Search(Nothing, False)
'Dim record As irow
144: Set record = curs.NextRow
145: While Not record Is Nothing
'  If (vTabTP <> Nil) Then
147:     If Not tpThm Is Nothing Then
'    pntCountList.Add (0)
149:         pntCountList.Add 0
'  End
151:     End If
'  classList.Add (vTabUC.ReturnValue(vTabUC.FindField("Value"), record))
153:     classlist.Add record.Value(validx)
'  lstAreas.Add (vTabUC.ReturnValue(vTabUC.FindField("Count"), record))
155:     lstAreas.Add record.Value(cntidx)
'End
157:     Set record = curs.NextRow
158:     SDMGlobals.SDMStatusBar.StepProgressBar
159: Wend
160: SDMGlobals.SDMStatusBar.HideProgressBar
'MsgBox "classlist:" & vbCrLf & classlist.asString, , c_sModuleFileName
'MsgBox "lstAreas:" & vbCrLf & lstAreas.asString, , c_sModuleFileName
''FIND THE CLASS IN classList THAT EQUALS
''EACH POINT CLASS, AND INCREMENT THE COUNTER
''IN THE CORRESPONDING LOCATION OF THE
''pntCountList
''-----------------------------------------
'nclass = classList.Count - 1
Dim nclass As Long
170: nclass = classlist.Count - 1
'If (vTabTP <> Nil) Then
172: If Not tpThm Is Nothing Then
'  For Each pntCls In lstClssPnt
'MsgBox "processing UC classes...", , "Neural Network"
175:   pProgbar.Position = 0
176:   SDMGlobals.SDMStatusBar.ShowProgressBar "Processing UC classes...", 1, lstClssPnt.Count, 1, True
177:     For Each pntCls In lstClssPnt.list
'    for each n in 0 .. nclass
            Dim n As Long
180:         For n = 0 To nclass
'      Cls = classList.Get(n)
                Dim Cls As Long
183:             Cls = classlist.GetVal(n)
'      If (pntCls = Cls) Then
185:             If CLng(pntCls) = CLng(Cls) Then
'        pntCountList.Set(n,pntCountList.Get(n) + 1)
187:                 pntCountList.SetIt n, pntCountList.GetVal(n) + 1
'        Break
189:                 Exit For
'      End
191:             End If
'    End
193:         Next n
'  End
195:         SDMGlobals.SDMStatusBar.StepProgressBar
196:     Next pntCls
197:     SDMGlobals.SDMStatusBar.HideProgressBar
'End
199: End If
'>>>>>>>>>>>>>> Test Purposes
'MsgBox pntCountList.asString, , "pntCountList"
'Set gSDI_Add2UCTab = Nothing
'Exit Function
'>>>>>>>>>>>>>>>>>>>>>>
'i = 0
     Dim i As Long
207: i = 0
     Dim grdUCProps As IRasterProps
209: Set grdUCProps = grdUC
'For Each n In lstAreas.Clone
'MsgBox "processing Areas...", , "Neural Network"
212: pProgbar.Position = 0
213: SDMGlobals.SDMStatusBar.ShowProgressBar "Processing Areas...", 1, lstAreas.Count, 1, True
     Dim nv As Variant
215: For Each nv In lstAreas.Clone.list
'  lstAreas.Set(i,n * grdUC.GetCellSize * grdUC.GetCellSize)
217:     lstAreas.SetIt i, CDbl(nv * grdUCProps.MeanCellSize.X * grdUCProps.MeanCellSize.Y)
'  i = i + 1
219:     i = i + 1
'End
221:   SDMGlobals.SDMStatusBar.StepProgressBar
222: Next nv
223: SDMGlobals.SDMStatusBar.HideProgressBar
'MsgBox ListtoString(lstAreas), , "lstAreas(Redone)"
'MsgBox "Ready to create/update old _Tbl", , "Neural Network"
'Set gSDI_Add2UCTab = Nothing
'Exit Function
'>>>> Can't add field to RasterLayer
'>>>> Instead make a StandAlone table to Join
'lstFldNew = List.Make
     Dim lstFldNew As New Collection
     Dim fldValue As Variant
233: fldValue = Array("Value", esriFieldTypeInteger, 12, 0, "", False)
234: lstFldNew.Add fldValue
'fldArea = Field.Make("Area_sqm",#FIELD_DECIMAL,16,2)
'fldArea.SetAlias ("Area (sq. m)")
     Dim fldarea As Variant
238: fldarea = Array("Area_sqm", esriFieldTypeDouble, 16, 2, "Area (sq. m)", False)
'lstFldNew.Add (fldArea)
240: lstFldNew.Add fldarea
'If (vTabTP <> Nil) Then
242: If Not tpThm Is Nothing Then
'  minField = Field.Make("TrngPoints",#FIELD_LONG,3,0)
'  minField.SetAlias ("Training Points")
         Dim minfield As Variant
246:     minfield = Array("TrngPoints", esriFieldTypeInteger, 12, 0, "Training Points", False)
'  lstFldNew.Add (minField)
248:     lstFldNew.Add minfield
'End
250: End If
'If (vTabUC.CanEdit) Then
'  vTabUC.setEditable (True)
'  If (vTabUC.CanAddFields) Then
'    vTabUC.AddFields (lstFldNew)

256: If SDMGlobals.SDMTableUtils Is Nothing Then Set SDMGlobals.SDMTableUtils = New SDMUtilities.SDMTableUtils
257: If SDMGlobals.SDMApp Is Nothing Then SDMGlobals.SDMApp = New AppRef
     Dim getPrjDir As SDMUtilities.gSDI_getProjectDir
259: Set getPrjDir = New SDMUtilities.gSDI_getProjectDir
260: SDMGlobals.SDMPrjDir = getPrjDir.gSDI_getProjectDir
261: Set getPrjDir = Nothing
    
'>>>> Create if SATABLE not exists in folder
     Dim saTblFilename As String
265: saTblFilename = thmUC.Name & "_Tbl.dbf"
'First check if SATable is in TOC
     Dim saTblName As String
268: saTblName = Split(saTblFilename, ".")(0)
     Dim saTable As IStandaloneTable
270: Set saTable = WOETableUtils.FindStandAloneTableByName(saTblName, SDMGlobals.SDMMap)
271: If Not saTable Is Nothing Then
'If so, then Check if is compatible with SDMUC
        Dim SDMUCTbl As ITable
274:    Set SDMUCTbl = thmUC
275:    If SDMUCTbl.RowCount(Nothing) = saTable.Table.RowCount(Nothing) Then

277:    Else
278:        MsgBox saTblName & " in TOC not compatible with " & thmUC.Name
279:        Set gSDI_Add2UCTab = Nothing
            Exit Function
281:    End If
'274:    MsgBox "Compatible _Tbl is in TOC. So can reuse it....", vbInformation, "Neural Network"
283:    If WOETableUtils.hasJoins(thmUC) Then WOETableUtils.UnJoinAll thmUC
'289:    MsgBox "All unjoined", , "Neural Network"
285:    Set saTable = WOETableUtils.FindStandAloneTableByName(saTblName, SDMGlobals.SDMMap)
        Dim aTbl As ITable
287:    Set aTbl = saTable.Table
288:    validx = aTbl.FindField("Value")
        Dim tpsidx As Long
290:    tpsidx = aTbl.FindField("TrngPoints")
        Dim areaidx As Long
292:    areaidx = aTbl.FindField("Area_sqm")

294:    pProgbar.Position = 0
295:    SDMGlobals.SDMStatusBar.ShowProgressBar "Updating UC table...", 1, vTabUC.RowCount(Nothing), 1, True

'Dim saDS As IDataset
'Set saDS = saTable
'Dim editWkSpc As IWorkspaceEdit
'Set editWkSpc = FeatureUtils.startEditing(saDS.Workspace.PathName)
301:    n = 0
        Dim updCurs As ICursor
303:    Set updCurs = saTable.Table.Update(Nothing, False)
        Dim updRecord As irow
305:    Set updRecord = updCurs.NextRow
306:    While Not updRecord Is Nothing
307:        updRecord.Value(validx) = n + 1
'    If (vTabTP <> Nil) Then
309:        If Not tpThm Is Nothing Then
'      vTabUC.SetValue(minField,record,pntCountList.Get(n))
311:            updRecord.Value(tpsidx) = pntCountList.GetVal(n)
'    End
313:        End If
'    vTabUC.SetValue(fldArea,record,lstAreas.Get(n))
315:        updRecord.Value(areaidx) = lstAreas.GetVal(n)
316:        updCurs.UpdateRow updRecord
'    n = n + 1
318:        n = n + 1
'  End
320:        Set updRecord = updCurs.NextRow
321:        SDMGlobals.SDMStatusBar.StepProgressBar
322:    Wend
'FeatureUtils.stopEditing editWkSpc
324:    SDMGlobals.SDMStatusBar.HideProgressBar
'310:    MsgBox "done updating", , "Neural Network"
'312:    MsgBox "Done. quitting...."
'313:    Set gSDI_Add2UCTab = Nothing
'        Exit Function
329: Else 'Not in TOC
'Else check if in project workspace
331:    If FileDialog.ExistsFilename(SDMGlobals.SDMPrjDir & "\" & saTblFilename) Then
            Dim tblDS As IDataset
333:        Set tblDS = WOETableUtils.OpenTable(SDMGlobals.SDMPrjDir, saTblFilename)
334:        If Not tblDS Is Nothing Then
'If exists in proj wkspce, attempt to delete it
336:            If tblDS.CanDelete Then
337:                tblDS.Delete
338:            Else
339:                MsgBox "Can't create UC Table; " & vbCrLf & SDMGlobals.SDMPrjDir & "\" & saTblFilename & _
                       ". exists and cannot be deleted", , c_sModuleFileName
341:                Set gSDI_Add2UCTab = Nothing
                    Exit Function
343:            End If
344:         End If
345:    End If
'>>>> Create new SATable
347:    Set aTbl = WOETableUtils.CreateTable(saTblFilename, SDMGlobals.SDMPrjDir, lstFldNew, False)
348:    If aTbl Is Nothing Then
349:        MsgBox "Can't create UC Table; " & SDMGlobals.SDMPrjDir & "\" & saTblFilename, , c_sModuleFileName
350:        Set gSDI_Add2UCTab = Nothing
            Exit Function
352:    End If
'>>>> Add new SATable to map
        'Dim saTblName As String
355:    saTblName = Split(saTblFilename, ".")(0)
356:    WOETableUtils.AddTable SDMGlobals.SDMPrjDir, saTblName, SDMGlobals.SDMApp
357:    If Not WOETableUtils.SetAliases(saTblName, lstFldNew) Then
358:            Set gSDI_Add2UCTab = Nothing
                Exit Function
360:    End If

362:    Set saTable = WOETableUtils.FindStandAloneTableByName(saTblName, SDMGlobals.SDMMap)
'  End 'End of edit loop
'  For Each record In vTabUC
        'Dim validx As Long
366:    validx = aTbl.FindField("Value")
        'Dim tpsidx As Long
368:    tpsidx = aTbl.FindField("TrngPoints")
        'Dim areaidx As Long
370:    areaidx = aTbl.FindField("Area_sqm")

372:    pProgbar.Position = 0
373:    SDMGlobals.SDMStatusBar.ShowProgressBar "Creating UC table...", 1, vTabUC.RowCount(Nothing), 1, True

375:    For n = 0 To vTabUC.RowCount(Nothing) - 1
376:        Set record = aTbl.CreateRow
377:        record.Value(validx) = n + 1
'    If (vTabTP <> Nil) Then
379:        If Not tpThm Is Nothing Then
'      vTabUC.SetValue(minField,record,pntCountList.Get(n))
381:                record.Value(tpsidx) = pntCountList.GetVal(n)
'    End
383:        End If
'    vTabUC.SetValue(fldArea,record,lstAreas.Get(n))
385:        record.Value(areaidx) = lstAreas.GetVal(n)
386:        record.Store
'    n = n + 1
'  End
389:        SDMGlobals.SDMStatusBar.StepProgressBar
390:    Next n
391:    SDMGlobals.SDMStatusBar.HideProgressBar
392: End If
'  vTabUC.setEditable (False)
'
'End
'Unjoin old standalone table in case of repeated NN processing
397: If WOETableUtils.hasJoins(thmUC) Then
398:    WOETableUtils.UnJoinAll thmUC
399: End If
'>>>>> Must join new SA table to source layer
'return True
402: Set gSDI_Add2UCTab = WOETableUtils.JoinTables(vTabUC, "Value", saTable.Table, "Value")
    '<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
     Exit Function
ErrorHandler:
        HandleError True, c_sModuleFileName & " " & GetErrorLineNumberString(Erl), Err.Number, Err.Source, Err.Description, 4
407:    Set gSDI_Add2UCTab = Nothing
        Exit Function
End Function


