VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "gSDI_BearingUpdate"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = True
Option Explicit
Const c_sModuleFileName As String = "gSDI_BearingUpdate"
Const c_sDLLFileName As String = "SDMExtension"       ' Constant reflect file module name
'Private ObjectTag As Object
'Property Set setObjectTag(anObject As Object)
'    Set ObjectTag = anObject
'End Property
'Property Get getObjectTag() As Object
'    Set getObjectTag = ObjectTag
'End Property

Function gSDI_BearingUpdate() As Boolean
  On Error GoTo ErrorHandler

'PUT THE IMPLEMENTATION HERE >>>>>>>>>>>>>
'' Name:  gSDI.BearingUpdate
''
''
''Topics:  Spatial Data Modeller
''
''Description:  Updates the Add Bearing... menu item
''              Enables menu item when there is at
''            least one polyline theme in the view
''
''Requires:
''
'' Self:  Add Bearing... menu item
''
''Returns:
''==============================================
'
'self.SetEnabled (False)
33: gSDI_BearingUpdate = False
'theView = av.GetActiveDoc
'If (theView.Is(View).Not) Then
'  return Nil
'End
38: If SDMGlobals.SDMMap Is Nothing Then
        Dim pMxDoc As IMxDocument
40:     Set SDMApp = New AppRef
41:     Set pMxDoc = SDMApp.Document
42:     Set SDMGlobals.SDMMap = pMxDoc.FocusMap
43: End If
'theThemes = theView.GetThemes
If SDMGlobals.SDMMap.LayerCount = 0 Then Exit Function
Dim theThemes As IEnumLayer
47: Set theThemes = SDMGlobals.SDMMap.Layers
Dim t As ILayer
49: Set t = theThemes.Next
'For Each t In theThemes
51: Do While (Not t Is Nothing)
'  If (t.Is(FTheme)) Then
53:     If t.Valid And (TypeOf t Is IFeatureLayer) Then
'    ShapeType = t.GetFTab.FindField("Shape").GetType
            Dim tfeat As IFeatureLayer
56:         Set tfeat = t
'    if (shapetype = #FIELD_SHAPELINE) then
58:         If tfeat.FeatureClass.ShapeType = esriGeometryLine Or _
            tfeat.FeatureClass.ShapeType = esriGeometryMultipoint Or _
            tfeat.FeatureClass.ShapeType = esriGeometryPolyline Then _
'      self.SetEnabled (True)
62:             gSDI_BearingUpdate = True
'      Break
64:             Exit Do
'    End
66:         End If
'  End
68:     End If
'End
70:     Set t = theThemes.Next
71: Loop
'<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
Exit Function
ErrorHandler:
  HandleError True, c_sModuleFileName & " " & GetErrorLineNumberString(Erl), Err.Number, Err.Source, Err.Description, 4
End Function
