VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "gSDI_CalcNN"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = True
Option Explicit
Const c_sModuleFileName As String = "gSDI_CalcNN"
Const c_sDLLFileName As String = "CalculateResponse"       ' Constant reflect file module name
'Private ObjectTag As Object
'Property Set setObjectTag(anObject As Object)
'    Set ObjectTag = anObject
'End Property
'Property Get getObjectTag() As Object
'    Set getObjectTag = ObjectTag
'End Property

Function gSDI_CalcNN(Self As Variant) As Boolean
'13: MsgBox "Entering....", , c_sModuleFileName
  On Error GoTo ErrorHandler
'PUT THE IMPLEMENTATION HERE >>>>>>>>>>>>>
'' gSDI.CalcNN
'' Topics:  Spatial Data Modeller
''
'' Description:  Calls script that determines
''          which unique conditions contain non-deposit
''          training points and then calls
''          the script that write the input files for
''          DataXplore.
''
'' Requires:
''
'' Self:
''
'' Returns:
''==============================================
31: SDMGlobals.SetGlobals 'Initialize SDMGlobals
'nnu = self.Get(0)
    Dim nnu As Boolean
34: nnu = Self(0)
'nns = self.Get(1)
    Dim nns As Boolean
37: nns = Self(1)
'thmUC = self.Get(2)
    Dim thmUC As IRasterLayer
40: Set thmUC = Self(2)
'lstPnts = self.Get(3)
    Dim lstPnts As SDMUtilities.SDMList
43: Set lstPnts = Self(3)
'45: MsgBox lstPnts.AsString, , "lstPnts"
'lstAreas = self.Get(4)
    Dim lstAreas As SDMUtilities.SDMList
47: Set lstAreas = Self(4)
'49: MsgBox lstAreas.AsString, , "lstAreas"
'lstsvals = self.Get(5)
    Dim lstsvals As SDMUtilities.SDMList
51: Set lstsvals = Self(5)
'53: MsgBox lstsVals.AsString, , "lstsVals"
'lstsUC = self.Get(6)
    Dim lstsUC As SDMUtilities.SDMList
55: Set lstsUC = Self(6)
'57: MsgBox lstsUC.AsString, , "lstsUC"
'lstsFreeMC = self.Get(7)
    Dim lstsFreeMC As SDMUtilities.SDMList
59: Set lstsFreeMC = Self(7)
'61: MsgBox lstsFreeMC.AsString, , "lstsFreeMC"
'prmtrs = self.Get(8)
    Dim prmtrs As Form
63: Set prmtrs = Self(8)
'lstMD = self.Get(9)
    Dim lstMD As SDMUtilities.SDMList
66: Set lstMD = Self(9)
'68: MsgBox lstMD.AsString, , "lstMD"
'listWeightedAvgs = self.Get(10)
    Dim listWeightedAvgs As SDMUtilities.SDMList
70: Set listWeightedAvgs = Self(10)
'72: MsgBox listWeightedAvgs.AsString, , "listWeightedAvgs"
'unitcell = self.Get(11)
    Dim unitcell As Double
74: unitcell = Self(11)
'' Do neural network stuff
''-------------------------------------------------
    Dim anArray As Variant
78: anArray = Self(12)
    Dim DepsFZMbrShpFld As IField
80: If anArray(0) Is Nothing Then
81:     Set DepsFZMbrShpFld = Nothing
82: Else
83:     Set DepsFZMbrShpFld = anArray(1)
84: End If
85: anArray = Self(13)
    Dim NonDepsFZMbrShpFld As IField
87: If anArray(0) Is Nothing Then
88:     Set NonDepsFZMbrShpFld = Nothing
89: Else
90:     Set NonDepsFZMbrShpFld = anArray(1)
91: End If
'Added to permit successive NN calculations for same SDMUC
    Dim TPName As String
94: TPName = Self(14)
    Dim NDTPName As String
96: NDTPName = Self(15)

'If (nns) Then
     Dim lstNDUC As SDMUtilities.SDMList
100: If nns Then
'  lstNDUC = av.Run("gSDI.GetUCswNDTPs",{thmUC,lstPnts,lstAreas,lstsVals})
         Dim gSDIGetUCswNDTPs As gSDI_GetUCswNDTPs
103:     Set gSDIGetUCswNDTPs = New gSDI_GetUCswNDTPs
104:     Set lstNDUC = gSDIGetUCswNDTPs.gSDI_GetUCswNDTPs(Array(thmUC, lstPnts, lstAreas, lstsvals, prmtrs, NDTPName))
'  if (lstNDUC.Is(String)) then
'    MsgBox.Error(lstNDUC,"Parameter Error")
'  End
'  If (lstNDUC.Is(List).Not) Then
109:     If lstNDUC Is Nothing Then
'    return Nil
111:         gSDI_CalcNN = False
            Exit Function
'  End
114:     End If
'Else
116: Else
'  lstNDUC = Nil
118:     Set lstNDUC = Nothing
'End
120: End If
'102: MsgBox lstNDUC.AsString, , "lstNDUC"
'If (nnu Or nns) Then
123: If nnu Or nns Then
''''         Dim AP As AnalysisParameters.AnlParams
''''124:     Set AP = New AnalysisParameters.AnlParams
''''         Dim gParam As Variant
''''126:     Set gParam = AP.gParamFrm
''''         Dim TPName As String
''''128:     TPName = gParam.cbxTP.Text
        Dim TPs As IFeatureLayer
131:    Set TPs = WOETableUtils.FindLayerByName(TPName)
        Dim NDTPs As IFeatureLayer
133:    Set NDTPs = WOETableUtils.FindLayerByName(NDTPName)
    
    'MsgBox lstNDUC.AsString, , "lstNDUC-CalcNN"
    '  f1 = av.Run("gSDI.WriteNNFiles",{lstsUC,lstsFreeMC,lstNDUC,lstMD,listWeightedAvgs,unitCell,nnu,nns})
         Dim gSDIWriteNNFiles As gSDI_WriteNNFiles
138:     Set gSDIWriteNNFiles = New gSDI_WriteNNFiles
         Dim f1 As Object
140:     Set f1 = gSDIWriteNNFiles.gSDI_WriteNNFiles(Array(lstsUC, lstsFreeMC, lstNDUC, lstMD, listWeightedAvgs, unitcell, nnu, nns, thmUC, TPs, NDTPs, DepsFZMbrShpFld, NonDepsFZMbrShpFld))
141:     If f1 Is Nothing Then
142:     gSDI_CalcNN = False
    Exit Function
144:     End If
'End
146: End If
'return True
148: gSDI_CalcNN = True
'<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
Exit Function
ErrorHandler:
  HandleError True, c_sModuleFileName & " " & GetErrorLineNumberString(Erl), Err.Number, Err.Source, Err.Description, 4
End Function
