VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "gSDI_ExtractUpdate"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = True
Option Explicit
Const c_sModuleFileName As String = "gSDI_ExtractUpdate"
Const c_sDLLFileName As String = "SDMExtension"       ' Constant reflect file module name
'Private ObjectTag As Object
'Property Set setObjectTag(anObject As Object)
'    Set ObjectTag = anObject
'End Property
'Property Get getObjectTag() As Object
'    Set getObjectTag = ObjectTag
'End Property

Function gSDI_ExtractUpdate() As Boolean
  On Error GoTo ErrorHandler


'PUT THE IMPLEMENTATION HERE >>>>>>>>>>>>>

'gSDI_ExtractUpdate()
' Name:  gSDI.ExtractUpdate
'
'Topics:  Spatial Data Modeller
'
'Description:  Updates the Extact Contacts... menu item
' enables item when there is at least one polygon feature
' theme or a grid theme in the view
'
'Requires:
'
' Self:  Extract Contacts... menu item
'
'Returns:
'==============================================
33: gSDI_ExtractUpdate = False
Dim pApp As IApplication
35: Set pApp = New AppRef
Dim pMxDoc As IMxDocument
37: Set pMxDoc = pApp.Document
If pMxDoc.FocusMap.LayerCount = 0 Then Exit Function
Dim themes As IEnumLayer
40: Set themes = pMxDoc.FocusMap.Layers
Dim pLayer As ILayer
42: Set pLayer = themes.Next
43: While (Not pLayer Is Nothing)
44: If pLayer.Valid Then
45:     If TypeOf pLayer Is IRasterLayer Then
            Dim rlayer As IRasterLayer
47:         Set rlayer = pLayer
            Dim rasprops As IRasterProps
49:         Set rasprops = rlayer.Raster
50:         If rasprops.IsInteger Then
51:             gSDI_ExtractUpdate = True
                Exit Function
53:         End If
54:     ElseIf TypeOf pLayer Is IFeatureLayer Then
            Dim flayer As IFeatureLayer
56:         Set flayer = pLayer
57:         If flayer.FeatureClass.ShapeType = esriGeometryPolygon Then
58:            gSDI_ExtractUpdate = True
                Exit Function
60:         End If
61:     End If
62: End If
63: Set pLayer = themes.Next
64: Wend
'<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
Exit Function
ErrorHandler:
  HandleError True, c_sModuleFileName & " " & GetErrorLineNumberString(Erl), Err.Number, Err.Source, Err.Description, 4
End Function
