VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "gSDI_Final"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = True
Option Explicit
Const c_sModuleFileName As String = "gSDI_Final.cls"
Const c_sDLLFileName As String = "CalculateResponse"       ' Constant reflect file module name
'Private ObjectTag As Object
'Property Set setObjectTag(anObject As Object)
'    Set ObjectTag = anObject
'End Property
'Property Get getObjectTag() As Object
'    Set getObjectTag = ObjectTag
'End Property

Function gSDI_Final(Self As Variant) As Variant
  On Error GoTo ErrorHandler
    'MsgBox "Entering gSDI_Final...."
'PUT THE IMPLEMENTATION HERE >>>>>>>>>>>>>
'' Name:  gSDI.Final
''
''Topics:  Spatial Data Modeller; Spatial Analyst
''
''Description:  Reads previously calculated weights
''  tables, combines the input set of evidential themes
''  and calculates posterior probability, posterior logits
''  sum of weights, uncertainty due to weights, uncertainty
''  due to missing data and total uncertainty and writes
'' them to the attribute table of a unqiue conditions grid.
''
''Requires:
''
'' Self:  List from gSDI.CalcWeights script or
''   Use Existing Weights/Variances Tables menu item
''
''Returns:
''==============================================
'
    Dim anlParms As AnalysisParameters.AnlParams
36: Set anlParms = New AnalysisParameters.AnlParams
    Dim gPTP As Form
38: Set gPTP = anlParms.gPTPFrm
    Dim nTPs As Long
40: nTPs = CLng(gPTP.txtTPsSel)

'If (self.Is(List)) Then
43: If Not IsEmpty(Self) Then
'  If (self.Count = 6) Then
45:     If UBound(Self) = 6 Then
    '    ucGridTheme = self.Get(0)
            Dim ucGridTheme As IRasterLayer
48:         Set ucGridTheme = Self(0)
            Dim destTab As ITable
50:         Set destTab = Self(1)
    '    woeVTab = self.Get(1)
            Dim woeVTab As ITable
53:         Set woeVTab = Self(2)
'    Dim pDataset As IDataset
'    Set pDataset = woeVTab
'    MsgBox pDataset.Name
    '    varVTab = self.Get(2)
            Dim varVTab As ITable
59:         Set varVTab = Self(3)
'    Set pDataset = varVTab
'    MsgBox pDataset.Name
    '    lstMD = self.Get(3)
            Dim lstMD As SDMUtilities.SDMList
64:         Set lstMD = Self(4)
    '    txtFile = self.Get(4) 'text file flag
            Dim txtFile As Boolean
67:         txtFile = Self(5)
    '    statfile = self.Get(5) 'line (text) file pointer  (nil if txtFile = False)
            Dim statfile As Object
70:         If txtFile Then
71:             Set statfile = Self(6)
72:         Else
73:             Set statfile = Nothing
74:         End If
    '  End
76:     End If
'---------------------------------------------------------
'Else
79: Else
80:     MsgBox "Alternate non-List option not implemented", vbCritical, c_sModuleFileName
81:     gSDI_Final = "Error"
        Exit Function
'  ' SOURCE OF INFORMATION FROM EXTRA MENU OPTION
'  ' 'Use Existing Weights/Variances Tables'
'  ' MAY NOT APPEAR IN FINAL VERSION OF SDI EXTENSION
'  finalDiag = self.GetDialog
'  woeTable = finalDiag.findByName("cbx_Woe").GetCurrentValue
'  If (woeTable.Is(Table).Not) Then
'    return Nil
'  Else
'    woeVTab = woeTable.GetVTab
'  End
'  varTable = finalDiag.findByName("cbx_Var").GetCurrentValue
'  If (varTable.Is(Table).Not) Then
'    return Nil
'  Else
'    varVTab = varTable.GetVTab
'  End
''  parameters = av.FindDialog("gParam")
''  missing = parameters.FindByName("txl_Mis").GetText
''  if (missing.IsNumber) then
''    missing = missing.AsNumber
''  else
''    return Nil
''  end
'  txtFile = False
'  statfile = Nil
'End
109: End If
'-----------------------------------------------------------

'106: Set anlParms = New AnalysisParameters.AnlParams
'gP = av.FindDialog("gParam")
     Dim gP As Form
115: Set gP = anlParms.gParamfrm
'exprt = gP.findByName("chkWofE").IsSelected And gP.findByName("radExpt").IsSelected
     Dim exprt As Boolean
118: exprt = (gP.chkwofe.Value = 1) And gP.radExpt.Value
'ucGrid = ucGridTheme.GetGrid
     Dim ucGrid As IRaster
121: Set ucGrid = RasterUtils.GetDatasetRaster(ucGridTheme)
'theView = av.GetActiveDoc
     Dim theView As IMap
124: Set theView = SDMGlobals.SDMMap
'curPrj = theView.GetProjection
'strDef = fileName.GetCWD.MakeTmp("wofe", "dbf")
     Dim strDef As IFileName
128: Set strDef = New fileName
129: strDef.path = FileDialog.getProjectDir & "\" & ucGridTheme.Name & "_wofe.dbf"
'fnW = FileDialog.Put(strDef, "*.dbf", "WofE Probability Table")
     Dim fnw As Variant
132: fnw = FileDialog.GetSaveFileName("WofE Probability Table", FileDialog.getDir(strDef.path), FileDialog.GetFileName(strDef.path))
'If (fnW = Nil) Then
134: If IsNull(fnw) Then
'  return Nil
         Exit Function
'End
138: End If
'vTabW = VTab.MakeNew(fnW, dBase)
     Dim vTabw As ITable
'>>>>> create VTab below
''ucGridTheme = Nil
'themeField = woeVTab.FindField("Evidence_T")     'field containing evidence theme names
     Dim themeField As Long
145: themeField = woeVTab.FindField("Evidence_T")
'fieldField = woeVTab.FindField("Class_Fiel")     'field containing name of fields with evidence classes
     Dim fieldField As Long
148: fieldField = woeVTab.FindField("Class_Fiel")
'w0Field = woeVTab.GetFields.Get(2)               'field containing number of training points in last record
     Dim w0Field As Long
151: w0Field = 4
'w1Field = woeVTab.GetFields.Get(3)               'field containing total study area
     Dim w1Field As Long
154: w1Field = 5
'vthemeField = varVTab.FindField("Evidence_T")    'field containing evidence theme names
     Dim vthemeField As Long
157: vthemeField = varVTab.FindField("Evidence_T")
'vfieldField = varVTab.FindField("Class_Fiel")    'field containing name of fields with evidence classes
     Dim vfieldField As Long
160: vfieldField = varVTab.FindField("Class_Fiel")

''READ IN THE WEIGHTS FROM THE TABLE
''---------------------------------------------
'i = 0                           'counter
     Dim i As Long
166: i = 0
'tList = List.Make             'theme list
     Dim tList As New SDMUtilities.SDMList
'ttypeList = List.Make         'theme type list (polygon or grid)
     Dim ttypeList As New SDMUtilities.SDMList
'fieldlist = List.Make         'field containing the classes weights are based on
     Dim fieldList As New SDMUtilities.SDMList
'vfieldList = List.Make
     Dim vfieldList As New SDMUtilities.SDMList
'weightsList = List.Make       'list to hold lists of weights
     Dim weightsList As New SDMUtilities.SDMList
'variancesList = List.Make     'list to hold list of variances
     Dim variancesList As New SDMUtilities.SDMList
'n = woeVTab.GetNumRecords
     Dim n As Long
181: n = woeVTab.RowCount(Nothing)
'nv = varVTab.GetNumRecords
     Dim nv As Long
184: nv = varVTab.RowCount(Nothing)
'n1 = n - 1
     Dim n1 As Long
187: n1 = n - 1
'nv1 = nv - 1
     Dim nv1 As Long
190: nv1 = nv - 1

''LOOP THROUGH EACH RECORD IN THE WEIGHTS TABLE
''------------------------------------------
'For Each r In woeVTab
     Dim curs As ICursor
196: Set curs = woeVTab.Search(Nothing, False)
     Dim r As irow
198: Set r = curs.NextRow
     Dim pProgbar As IStepProgressor
200: Set pProgbar = SDMGlobals.SDMStatusBar.ProgressBar
201: pProgbar.Position = 0
'MsgBox "WoeVTab count= " & woeVTab.RowCount(Nothing), , c_sModuleFileName
203: SDMGlobals.SDMStatusBar.ShowProgressBar "Processing Wgts table...", 1, woeVTab.RowCount(Nothing), 1, True
204: While Not r Is Nothing
'  i = i + 1
206:     i = i + 1
'  If (i = n) Then           'record n is the last in weights table
208:     If i = n Then
'    If (exprt) Then
210:         If exprt Then
'      np = 100
212:            'MsgBox "I=n: Expert no. training points = " & gExprt.lbl_Ttp, vbInformation, c_sModuleFileName
                 Dim np As Long
214:             np = CLng(gExprt.lbl_Ttp.Caption)
'    Else
216:         Else 'Not Expert
'      np = woeVTab.ReturnValueNumber(w0Field, r)        'get total # training points
218:             np = r.Value(w0Field)
'    End
220:         End If
'    totArea = woeVTab.ReturnValueNumber(w1Field, r)   'get total area
             Dim totArea As Double
223:         totArea = r.Value(w1Field)
'  Else
225:     Else
'    nextThemeName = woeVTab.ReturnValueString(themeField, r)  'get evidential theme name
            Dim nextThemeName As String
228:        nextThemeName = ucGridTheme.Name
'    nextFieldName = woeVTab.ReturnValueString(fieldField, r)  'get evidential field name
            Dim nextFieldName As String
231:        nextFieldName = CStr(r.Value(themeField))
'''MsgBox "themeField=" & themeField & vbCrLf & _
'''         "nextFieldName=" & nextFieldName, , c_sModuleFileName
'    nextWeights = List.Make
            Dim nextWeights As SDMUtilities.SDMList
'
'    'GET FIELDS, THEN LOOP THROUGH
'    '------------------------------------------
'    woeFields2 = woeVTab.GetFields
            Dim woeFields2 As New SDMList
241:        Set woeFields2 = WOETableUtils.getFieldsNames(woeVTab)
'    woeFields = woeFields2.Clone
'    woeFields.Remove (0)
'    woeFields.Remove (0)
'    woeFields.Remove (woeFields.Count - 1)
'    allVals = List.Make
             Dim allVals As SDMUtilities.SDMList
'    For Each fld In woeFields
249:         Set nextWeights = New SDMUtilities.SDMList
250:         Set allVals = New SDMUtilities.SDMList
             Dim fldIdx As Long
252:         For fldIdx = 5 To woeVTab.Fields.FieldCount - 3 'all "W"n fields
'      If (fld.GetName <> "TrngPoints") Then
                 Dim fld As IField
255:             Set fld = woeVTab.Fields.Field(fldIdx)
                 Dim fldName As String
257:             fldName = fld.Name
258:             If fldName <> "TrngPoints" Then
'        Val = fld.GetName.BasicTrim("W", "")
                     Dim val As Variant
261:                 val = BasicTrim(fldName, "W", "")
'        If (Val.IsNumber) Then
263:                 If IsNumeric(val) Then
'          Val = Val.AsNumber
265:                     val = CLng(val)
'          allVals.Add (Val)
267:                     allVals.Add val
'        Else
269:                 Else
'          Val = Val.BasicTrim("_", "")
271:                     val = BasicTrim(CStr(val), "_", "")
'          If (Val.IsNumber) Then
273:                     If IsNumeric(val) Then
'            val = ("-"+val).AsNumber
275:                         val = -CLng(val)
'            allVals.Add (Val)
277:                         allVals.Add val
'          End
279:                     End If
'        End
281:                 End If
'      End
283:             End If
'      nextWeight = woeVTab.ReturnValueNumber(fld, r)
                 Dim nextWeight As Variant
286:             nextWeight = r.Value(fldIdx)
'      nextWeights.Add (nextWeight)
288:             nextWeights.Add nextWeight
'    End
290:         Next fldIdx
'278:     MsgBox "Count=" & allVals.Count & vbCrLf & allVals.AsString, , "AllVals"
'279:     MsgBox "Count=" & nextWeights.Count & vbCrLf & nextWeights.AsString, , "nextWeights"
'280:     MsgBox fldName & vbCrLf & nextThemeName, , "nextThemeName"
'    weightsList.Add (nextWeights)
295:         weightsList.Add nextWeights
'    nextTheme = theView.FindTheme(nextThemeName)
             Dim nextTheme As ILayer
298:         Set nextTheme = FindLayerByName(nextThemeName)
'   ' CHECK TO SEE THEMES AND FIELDS EXIST
'   '------------------------------------------
'    If (nextTheme = Nil) Then
302:         If nextTheme Is Nothing Then
'      MsgBox.Error("Can't find Evidential Theme"++nextThemeName+".",
'      "Calculating Response Theme")
305:             MsgBox "Can't find Evidential Theme " + nextThemeName + ".", vbCritical, _
                    "Calculating Response Theme"
'      return "noTheme"
308:             gSDI_Final = "noTheme"
                 Exit Function
'    End
311:         End If
'    If (nextTheme.Is(FTheme)) Then
'      nextVTab = nextTheme.GetFTab
'   Else
'      'nextVTab = nextTheme.GetVTab
'      nextVTab = av.Run("gSDI.GetVTab",{nextTheme})
            Dim pDispTbl As IDisplayTable
318:        Set pDispTbl = nextTheme
            Dim nextVTab As ITable
320:        Set nextVTab = pDispTbl.DisplayTable
'''      If (nextVTab = Nil) Then
322:        If nextVTab Is Nothing Then
323:             MsgBox "Can't get table: " & nextThemeName & ".", vbCritical, "Calculating Response Theme"
'        return Nil
325:             gSDI_Final = "noTable"
                 Exit Function
'      End
328:        End If
'''MsgBox "nextTheme=" & nextTheme.Name & ", No. fields=" & nextVTab.Fields.FieldCount & vbCrLf & _
'''        ListUtils.ListtoString(WOETableUtils.getFieldsNames(nextVTab)), , c_sModuleFileName
'   End
'   nextField = nextVTab.FindField(nextFieldName)
            Dim nextField As Long
334:        nextField = nextVTab.FindField(nextFieldName)
'    If (nextField = Nil) Then
336:        If nextField = -1 Then
'      MsgBox.Error("Can't find field"++nextFieldName+".","Calculating Response Theme")
338:             MsgBox "1) Can't find field: " & nextFieldName & ".", vbCritical, "Calculating Response Theme"
'      return "noField"
340:             gSDI_Final = "noField"
                 Exit Function
'    End
343:         End If
'    tList.Add (nextTheme)
345:         tList.Add nextFieldName
'
'    'CHECK TYPE AND ADD TO TYPE LIST
'    '------------------------------------------
'    If (nextTheme.Is(GTheme)) Then
350:         If TypeOf nextTheme Is IRasterLayer Then
'      ttype = "G"
                 Dim ttype As String
353:             ttype = "G"
'    ElseIf (nextTheme.Is(FTheme)) Then
355:         ElseIf TypeOf nextTheme Is IFeatureLayer Then
'      ttype = "P"
357:             ttype = "P"
'    End
359:         End If
'    If (ttype = "polygon") Then
361:         If ttype = "polygon" Then
'      ttypeList.Add (ttype)
363:             ttypeList.Add ttype
'    Else
365:         Else
'      ttypeList.Add (ttype)
367:             ttypeList.Add ttype
'    End
369:         End If
'    fieldlist.Add (nextField)
371:         fieldList.Add nextField
'  End
373:     End If
'End   'for each r in woeVTab
375:     Set r = curs.NextRow
376:    SDMGlobals.SDMStatusBar.StepProgressBar
377: Wend
378: SDMGlobals.SDMStatusBar.HideProgressBar
'355: MsgBox weightsList.Count
'' REPEAT MOST OF THE ABOVE FOR THE VARIANCE TABLE
''------------------------------------------
Dim nextVariances As SDMUtilities.SDMList
383: Set curs = varVTab.Search(Nothing, False)
384: Set r = curs.NextRow
'For Each r In varVTab
386:   pProgbar.Position = 0
387:   SDMGlobals.SDMStatusBar.ShowProgressBar "Processing Variance table...", 1, varVTab.RowCount(Nothing), 1, True
388: While Not r Is Nothing
'  nextThemeName = varVTab.ReturnValueString(vthemeField, r)
390:     nextThemeName = ucGridTheme.Name
'  nextFieldName = varVTab.ReturnValueString(vfieldField, r)
392:     nextFieldName = r.Value(vthemeField)
'  nextVariances = List.Make
394:     Set nextVariances = New SDMUtilities.SDMList
'  varFields2 = varVTab.GetFields
'  varFields = varFields2.Clone
'  varFields.Remove (0)
'  varFields.Remove (0)
'  For Each fld In varFields
400:     For fldIdx = 5 To varVTab.Fields.FieldCount - 1
'    nextVariance = varVTab.ReturnValueNumber(fld, r)
             Dim nextVariance As Double
403:         nextVariance = r.Value(fldIdx)
'    nextVariances.Add (nextVariance)
405:         nextVariances.Add nextVariance
'  End
407:     Next fldIdx
'382:     MsgBox fldName & vbCrLf & nextVariances.AsString, , "nextVariances"
'383:     MsgBox fldName & vbCrLf & nextThemeName, , "nextThemeName"
'  variancesList.Add (nextVariances)
411:     variancesList.Add nextVariances
'  nextTheme = theView.FindTheme(nextThemeName)
413:     Set nextTheme = FindLayerByName(nextThemeName)
'  If (nextTheme = Nil) Then
415:     If nextTheme Is Nothing Then
'    MsgBox.Error("Can't find Evidential Theme"++nextThemeName+".",
'    "Calculating Response Theme")
418:         MsgBox "Can't find Evidential Theme " + nextThemeName + ".", vbCritical, _
        "Calculating Response Theme"
'    return "noTheme"
421:         gSDI_Final = "noTheme"
             Exit Function
'  End
424:     End If
'  If (nextTheme.Is(FTheme)) Then
'    nextVTab = nextTheme.GetFTab
'  ElseIf (nextTheme.Is(GTheme)) Then
'    nextVTab = av.Run("gSDI.GetVTab",{nextTheme})
429: Set nextVTab = RasterUtils.GetTable(nextTheme)
430:    Set nextVTab = nextTheme
'    If (nextVTab = Nil) Then
'      return Nil
'    End
'    'nextVTab = nextTheme.GetVTab
'  End
'  nextField = nextVTab.FindField(nextFieldName)
437:     nextField = nextVTab.FindField(nextFieldName)
'  If (nextField = Nil) Then
439:     If nextField = -1 Then
'    MsgBox.Error("Can't find field"++nextFieldName+".","Calculating Response Theme")
441:        MsgBox "2) Can't find field: " & nextFieldName & ".", vbCritical, "Calculating Response Theme"
'    return "noField"
443:         gSDI_Final = "noField"
             Exit Function
'  End
446:     End If
'  vfieldList.Add (nextField)
448:     vfieldList.Add nextField
449:     Set r = curs.NextRow
450: SDMGlobals.SDMStatusBar.StepProgressBar
'End  'for each r in varVTab
452: Wend
453: SDMGlobals.SDMStatusBar.HideProgressBar
'If (txtFile) Then
455: If txtFile Then
'  statfile.writeElt (NL + NL + "Response Theme")
457:     statfile.WriteLine vbCrLf & vbCrLf & "Response Theme"
'  statfile.writeElt ("--------------" + NL)
459:     statfile.WriteLine "--------------" & vbCrLf
'  statfile.writeElt ("Source File:  " + ucGrid.GetSrcName.GetFileName.GetFullName)
461:     statfile.WriteLine "Source File:  " & ucGridTheme.FilePath
'End
463: End If
''ucVTab = ucGrid.GetVTab
'ucVTab = av.Run("gSDI.GetVTab",{ucGrid})
Dim ucVTab As ITable
467: Set ucVTab = WOETableUtils.JoinTables(ucGridTheme, "Value", destTab, "Value")
468: If (Not TypeOf ucVTab Is IRelQueryTable Or ucVTab Is Nothing) Then
469:     gSDI_Final = "Cannot join ucGridTheme and destTab"
          Exit Function
471: End If
'fieldlist = ucVTab.GetFields

'' CONVERT FIELD OBJECTS TO FIELD NAMES (STRING OBJECTS)
''------------------------------------------
'fieldNameList = List.Make
Dim fieldNameList As New SDMUtilities.SDMList
'For Each f In fieldlist
Dim fidx As Long
480: For fidx = 3 To ucVTab.Fields.FieldCount - 1
         Dim f As IField
482:     Set f = ucVTab.Fields.Field(fidx)
'  fieldNameList.Add (f.AsString)
484:     If UCase(f.Name) Like "SDMTEMP*" Then
485:         fieldNameList.Add f.Name
486:     End If
'End
488: Next fidx
'fieldNameList.Remove (0)    'value field
'fieldNameList.Remove (0)    'count field

''CHECK WHETHER LIMITING VALUE OF UNIT AREA USED
''------------------------------------------
''asymptote = av.FindDialog("gParam").FindByName("rad_Asy").IsSelected
'asymptote = False
Dim asymptote As Boolean
497: asymptote = False
'doPostP = True
Dim doPostP As Boolean
500: doPostP = True
'doPostL = True
Dim doPostL As Boolean
503: doPostL = True
'doSumWt = True
Dim doSumWt As Boolean
506: doSumWt = True
'doUncert = True
Dim doUncert As Boolean
509: doUncert = True
'af = ucVTab.FindField("Area_sqm")
Dim af As Long
512: af = ucVTab.FindField("Area_sqm")

'' MAKE NEW FIELDS AND ADD TO LIST
'
''------------------------------------------
'newFldList = List.Make     'list to hold new field objects
Dim newFldList As New SDMUtilities.SDMList
'addNewFields = False       'flag that there are new fields to be added
Dim addNewFields As Boolean
521: addNewFields = False
'fldID = Field.Make("ID",#FIELD_LONG,8,0)
Dim fldID As Variant
524: fldID = Array("ID", esriFieldTypeInteger, 8, 0, "", False)
'newFldList.Add (fldID)
526: newFldList.Add fldID
'If (doPostP) Then
528: If doPostP Then
'  postpFld = Field.Make("Post_Prob",#FIELD_FLOAT,16,8)
         Dim postpFld As Variant
531:     postpFld = Array("Post_Prob", esriFieldTypeDouble, 16, 8, "WofE Posterior Probability", False)
'  postpFld.SetAlias ("WofE Posterior Probability")
'  newFldList.Add (postpFld)
534:     newFldList.Add postpFld
'  addNewFields = True
536:     addNewFields = True
'  fldPPNrm = Field.Make("PstPrbNrm",#FIELD_FLOAT,16,8)
''    Dim fldPPNrm As Variant
''506:     fldPPNrm = Array("PstPrbNrm", esriFieldTypeDouble, 16, 8, "WofE Normalized Probability", False)
'''  fldPPNrm.SetAlias ("WofE Normalized Probability")
'''  newFldList.Add (fldPPNrm)
''509:     newFldList.Add fldPPNrm
'End
544: End If
'If (doPostL) Then
546: If doPostL Then
'  postLogit = Field.Make("Post_Logit",#FIELD_FLOAT,16,8)
         Dim postLogit As Variant
549:     postLogit = Array("Post_Logit", esriFieldTypeDouble, 16, 8, "WofE Posterior Logit", False)
'  postLogit.SetAlias ("WofE Posterior Logit")
'  newFldList.Add (postLogit)
552:     newFldList.Add postLogit
'  addNewFields = True
554:     addNewFields = True
'End
556: End If
'If (doSumWt) Then
558: If doSumWt Then
'  sumWts = Field.Make("Sum_Weights",#FIELD_FLOAT,16,8)
         Dim sumWts As Variant
561:     sumWts = Array("Sum_Wts", esriFieldTypeDouble, 16, 8, "WofE Sum of Weights", False)
'  sumWts.SetAlias ("WofE Sum of Weights")
'  newFldList.Add (sumWts)
564:     newFldList.Add sumWts
'  addNewFields = True
566:     addNewFields = True
'End
568: End If
'If (doUncert) Then
570: If doUncert Then
'  uncertainty = Field.Make("Uncertainty",#FIELD_FLOAT,16,8)
         Dim uncertainty As Variant
573:     uncertainty = Array("Uncrty", esriFieldTypeDouble, 16, 8, "WofE Uncertainty", False)
'  uncertainty.SetAlias ("WofE Uncertainty")
'  newFldList.Add (uncertainty)
576:     newFldList.Add uncertainty
'  addNewFields = True
578:     addNewFields = True
'End
580: End If

''ASSESS TIME NEEDED TO CALCULATE UNCERTAINTY DUE TO MISSING DATA
''------------------------------------------
'misngQuery = ""
'For Each fldN In fieldNameList
'  If ((fldN = "TrngPoints") Or (fldN = "Area_sqm")) Then
'    Continue
'  End
'  idx = fieldNameList.FindByValue(fldN)
'  missing = lstMD.Get(idx)
'  theField = ucVTab.FindField(fldN)
'  If (theField <> Nil) Then
'    If (fieldNameList.Find(fldN) <> (fieldNameList.Count - 1)) Then
'      misngQuery = misngQuery + "([" + fldN + "] = " + missing.AsString + ") or "
'    Else
'      misngQuery = misngQuery + "([" + fldN + "] = " + missing.AsString + ")"
'    End
'  End
'End
'misngQuery = "(" + misngQuery + ")"
'ucSel = ucVTab.GetSelection
'ucSel.ClearAll
'ucVTab.Query(misngQuery,ucSel,#VTAB_SELTYPE_NEW)
'Time = ucSel.Count * 3#
'If (Time < 60) Then
'  doMsng = True
'Else
'  time = (((time / 60) * 10).Round)/10
'  If (Time = 1#) Then
'    tWord = "minute"
'  Else
'    tWord = "minutes"
'  End
Dim doMsng As Boolean
'  doMsng = MsgBox.YesNo("The estimated time required to calculate "+NL+
'                        "uncertainty due to missing data is "+time.AsString++tWord+"."+NL+
'                        "c?","Missing Data",False)
'598: doMsng = (MsgBox("Calculate uncertainty due to missing data?", vbYesNo, "Missing Data") = vbYes)
619: doMsng = True
'End
'If (doMsng) Then
622: If doMsng Then
'  missingD = ucVTab.FindField("Msng_Data")
         Dim missingDFld As Long
625:     missingDFld = ucVTab.FindField("Msng_Data")
'  If ((missingD = Nil)) Then
627:     If missingDFld = -1 Then
'    missingD = Field.Make("Msng_Data",#FIELD_FLOAT,16,8)
             Dim missingD As Variant
630:         missingD = Array("Msng_Data", esriFieldTypeDouble, 16, 8, "WofE Missing Data", False)
'    newFldList.Add (missingD)
632:         newFldList.Add missingD
'    addNewFields = True
634:         addNewFields = True
'  End
636:     End If
'  totalUnc = ucVTab.FindField("Tot_Uncrty")
         Dim totalUncFld As Long
639:     totalUncFld = ucVTab.FindField("Tot_Uncrty")
'  If ((totalUnc = Nil)) Then
641:     If totalUncFld = -1 Then
'    totalUnc = Field.Make("Tot_Uncrty",#FIELD_FLOAT,16,8)
             Dim totalUnc As Variant
644:         totalUnc = Array("Tot_Uncrty", esriFieldTypeDouble, 16, 8, "WofE Total Uncertainty", False)
'    newFldList.Add (totalUnc)
646:         newFldList.Add totalUnc
'    addNewFields = True
648:         addNewFields = True
'  End
650:     End If
'End
652: End If ' End of DoMsg if

'' IF FLAGGED, ADD NEW FIELDS
''------------------------------------------
'If (addNewFields) Then
657: If addNewFields Then
'  vTabW.AddFields (newFldList)
659:     Set vTabw = WOETableUtils.CreateTable(CStr(fnw(0)), CStr(fnw(1)), newFldList.list, CBool(fnw(2)))
    '>>>> Add new SATable to map
661:     WOETableUtils.AddTable CStr(fnw(1)), CStr(fnw(0)), SDMGlobals.SDMApp
662:     WOETableUtils.SetAliases FileDialog.GetBaseName(CStr(fnw(0))), newFldList.list
663:     missingDFld = vTabw.FindField("Msng_Data")
664:     totalUncFld = vTabw.FindField("Tot_Uncrty")
'End
666: End If

'>>>> Following has been done in gSDI_Add2UCTab
'cellsize = ucGrid.GetCellSize
'ucVTab.Calculate("[Count] * "+cellsize.AsString+" * "+cellsize.AsString,af)
''ucVTab.SetEditable(false)
'ucGridTheme.EditTable     'adds/opens attribute table, but doesn't display due to modal dialog
'ucTable = av.GetProject.FindDoc("Attributes Of " + ucGridTheme.GetName)
''CALCULATE PRIOR PROBABILITY AND LOGIT
'
''------------------------------------------
'If (asymptote) Then
    'MsgBox "Asymptote: no. training points = " & gExprt.lbl_Ttp, vbInformation, c_sModuleFileName
679: If asymptote Then
'  areaFrPrior = totArea / 0.00001
         Dim areaFrPrior As Double
682:     areaFrPrior = totArea / 0.000001
'  priorp = np / areaFrPrior                    ' PRIOR PROBABILITY
         Dim priorp As Double
685:     priorp = np / areaFrPrior
'Else
687: Else
'  priorp = np / totArea                    ' PRIOR PROBABILITY
689:     priorp = np / totArea
'End
691: End If
'lprioro = (priorp / (1-priorp)).Ln       ' PRIOR LOGIT
Dim lprioro As Double
694: lprioro = Log(priorp / (1 - priorp))

'' SORT UNIQUE CONDITIONS TABLE ON AREA
''-------------------------------------------------
698: ProgressAnimation.Show "Sorting Unique Conditions table..."
'thmStrList = List.Make
Dim thmStrList As New SDMUtilities.SDMList
'For Each thm In tList
     Dim thmVar As Variant
703: For Each thmVar In tList.list
'  thmStrList.Add (thm.GetName)
         'Dim thm As ILayer
         'Set thm = thmVar
707:     thmStrList.Add UCase(thmVar)
'Delete temporary raster from map
        'SDMGlobals.SDMMap.DeleteLayer thm
'End
711: Next thmVar

'ucTable.Sort(af,true)
'Dim ucGridTbl As ITable
     Dim pTableSort As ITableSort
716: Set pTableSort = New TableSort
717: With pTableSort
718:   .Fields = "Area_sqm"
719:   .Ascending("Area_sqm") = True
720:   Set .Table = destTab
721: End With
722: pTableSort.Sort Nothing
723: ProgressAnimation.Hide
'numUniqueConditions = ucVTab.GetNumRecords - 1
     Dim numUniqueConditions As Long
726: numUniqueConditions = ucVTab.RowCount(Nothing)

''ucVTab.SetEditable(true)
     Dim pWrkSpcEdit As IWorkspaceEdit
730: Set pWrkSpcEdit = FeatureUtils.startEditing(CStr(fnw(1)))
731: If pWrkSpcEdit Is Nothing Then
732:    MsgBox "Problem trying to edit: " & CStr(fnw(0)) & vbCrLf & _
                "Check that it is not already being edited or other use", vbCritical, "Calculate Response"
734:         gSDI_Final = "Table Error"
        Exit Function
736: End If
 'doneDictionary = Dictionary.Make(30)
     Dim doneDictionary As Object
739: Set doneDictionary = CreateObject("Scripting.Dictionary")

     Dim ucVTabcurs As ICursor
742: Set ucVTabcurs = ucVTab.Search(Nothing, False)

Dim ucValList As New SDMUtilities.SDMList
745:   pProgbar.Position = 0
746:   SDMGlobals.SDMStatusBar.ShowProgressBar "Processing UCs ...", 1, numUniqueConditions, 1, True

'for each i in 0 .. numUniqueConditions
749: fldIdx = vTabw.FindField("ID")
750: For i = 0 To numUniqueConditions - 1
    '  rW = vTabW.AddRecord
         Dim rW As irow
753:     Set rW = vTabw.CreateRow
''  vTabW.SetValue(fldID,rW,(i + 1))
'  Progress = (i / (numUniqueConditions - 1)) * 100
'  av.SetStatus (Progress)
'  record = ucTable.ConvertRowToRecord(i)
'because otherwise VTab record # won't match table row #
         Dim record As Long
760:     record = rW.OID
'  vTabW.SetValue(fldID,rW,(record + 1))
762:     rW.Value(fldIdx) = record + 1
'  ucValList = List.Make  'list to hold bin vals for data/missing data
764:     ucValList.Clear
'  IsMissing = False      'initialize flag for missing data
         Dim IsMissing As Boolean
767:     IsMissing = False
'  total = 0              'initialize total weights (Sum of Weights)
         Dim total As Double
770:     total = 0
'  totalv = 0
         Dim totalv As Double
773:     totalv = 0
'
'  For Each fldN In fieldNameList
        Dim ucGridTbl As ITable
777:    Set ucGridTbl = ucGridTheme
        Dim ucVTabRow As irow
779:    Set ucVTabRow = ucVTabcurs.NextRow
        Dim fldN As Variant
781:    For Each fldN In fieldNameList.list

'    If ((fldN = "TrngPoints") Or (fldN = "Area_sqm")) Then
784:        If EndsWith(CStr(fldN), "TrngPoints") Or EndsWith(CStr(fldN), "Area_sqm") Then
'      Continue
786:            GoTo nextfldn2
'    End
788:        End If
'    indx = thmStrList.FindByValue(fldN)
            Dim indx As Long
791:        indx = thmStrList.FindByValue(UCase(CStr(fldN)))
'    If (indx = -1) Then
793:        If indx = -1 Then
'      MsgBox.Error("Could not find weights for Evidential Theme, "+NL+
'                   fldN+" in specified weights table.  Quitting...","Calculating Response Theme")
796:            MsgBox "Could not find weights for Evidential Theme, " & vbCrLf & _
                   CStr(fldN) & " in specified weights table." & vbCrLf & _
                   "Quitting Calculating Response Theme", _
                    vbCritical, c_sModuleFileName
'
'      return nil
802:            gSDI_Final = "Error"
                Exit Function
'    End
805:        End If
        'SDMGlobals.SDMStatusBar.message(0) = "Find Thm Name..." & indx
'    If (indx < lstMD.Count) Then
808:        If indx < lstMD.Count Then
'      missing = lstMD.Get(indx)
                Dim missing As Long
811:            missing = lstMD.GetVal(indx)
'    End
813:        End If
'    curField = ucVTab.FindField(fldN)
            Dim curFieldName As String
816:        curFieldName = CStr(fldN)
            Dim curField As Long
818:        curField = ucVTab.FindField(curFieldName)
'    Val = ucVTab.ReturnValueNumber(curField, record)
            Dim UCVal As Double
821:        UCVal = ucVTabRow.Value(curField)
'    If (doMsng) Then
823:        If doMsng Then
'      ' CHECK FOR MISSING DATA
'      '------------------------
'  '    av.ShowMsg("Processing missing data areas...")
'      If (Val = missing) Then
828:             If UCVal = missing Then
    '        ucValList.Add (0)
830:                 ucValList.Add 0
    '        IsMissing = True
832:                 IsMissing = True
    '        termList = List.Make
                     Dim termList As New SDMUtilities.SDMList
    '        areaTermList = List.Make
                     Dim areaTermList As New SDMUtilities.SDMList
    '        cmbList = doneDictionary.Get(curField.GetName)
                     Dim cmbList As SDMUtilities.SDMList
839:                 If Not doneDictionary.Exists(curFieldName) Then
840:                    Set cmbList = Nothing
841:                 Else
                        Dim dictResult As Object
843:                    Set dictResult = doneDictionary.item(curFieldName)
844:                    Set cmbList = dictResult
845:                 End If
    '        If (cmbList = Nil) Then
847:                 If cmbList Is Nothing Then
    '          thmClsList = List.Make
                        Dim thmClsList As New SDMUtilities.SDMList
    '          thmAreaList = List.Make
                        Dim thmAreaList As New SDMUtilities.SDMList
    '          aggWeightsList = List.Make
                        Dim aggWeightsList As New SDMUtilities.SDMList
    '          For Each rcd In ucVTab
855:                     Set curs = ucVTab.Search(Nothing, False)
                         Dim rcd As irow
857:                     Set rcd = curs.NextRow
858:                     While Not rcd Is Nothing
    '            thmCls = ucVTab.ReturnValue(curField, rcd)
                             Dim thmCls As Long
861:                         thmCls = rcd.Value(curField)
    '            thmClsList.Add (thmCls)
863:                         thmClsList.Add thmCls
    '            thmArea = ucVTab.ReturnValue(af, rcd)
                             Dim thmArea As Double
866:                         thmArea = rcd.Value(af)
    '            thmAreaList.Add (thmArea)
868:                         thmAreaList.Add thmArea
    '          End
870:                         Set rcd = curs.NextRow
871:                     Wend
'          aggClsList = thmClsList.Clone
                        Dim aggClsList As SDMUtilities.SDMList
874:                    Set aggClsList = thmClsList.Clone
'          aggClsList.RemoveDuplicates
876:                    Set aggClsList = aggClsList.RemoveDuplicates
'          mIndx = aggClsList.FindByValue(missing)
                        Dim mIndx As Long
879:                    mIndx = aggClsList.FindByValue(missing)
'          If (mIndx = -1) Then
881:                    If mIndx = -1 Then
'            MsgBox.Error("Class (mIndx, missing is "+missing.AsString+") not found.  Exiting",
'            "Calculating Response Theme")
884:                        MsgBox "Class (mIndx, missing is " & missing & ") not found.  Exiting", vbCritical, _
                                "Calculating Response Theme"
'            return "Error"
887:                        gSDI_Final = "Error"
                            Exit Function
'          End
890:                    End If
                'SDMGlobals.SDMStatusBar.message(0) = "Find Missing Value..." & mIndx
'          aggClsList.Remove (mIndx)
893:                    aggClsList.Remove mIndx
'          aggAreaList = List.Make
                        Dim aggAreaList As New SDMUtilities.SDMList
'          For Each Cls In aggClsList
                        Dim Cls As Variant
        'SDMGlobals.SDMStatusBar.message(0) = "Initing aggregate list..."
899:                    For Each Cls In aggClsList.list
'            aggAreaList.Add (0)
901:                        aggAreaList.Add 0
'          End
903:                    Next Cls
'          For Each Cls In thmClsList
905:                    For Each Cls In thmClsList.list
'            If (Cls = missing) Then
907:                        If CLng(Cls) = missing Then GoTo nextCls
'              Continue
'            End
'                   end if
'            fullIdx = thmClsList.Find(Cls)
                            Dim fullIdx As Long
913:                        fullIdx = thmClsList.FindByValue(CLng(Cls))
'            If (fullIdx = -1) Then
915:                        If fullIdx = -1 Then
'              MsgBox.Error("Class (fullIdx, cls is "+cls.AsString+") not found.  Exiting",
'              "Calculating Response Theme")
918:                            MsgBox "Class (fullIdx, cls is " & Cls & ") not found.  Exiting", vbCritical, _
                                "Calculating Response Theme"
'              return "Error"
921:                            gSDI_Final = "Error"
                                Exit Function
'            End
924:                        End If
        'SDMGlobals.SDMStatusBar.message(0) = "Find Thm Class..." & fullIdx
'            aggIndx = aggClsList.FindByValue(Cls)
                            Dim aggIndx As Long
928:                        aggIndx = aggClsList.FindByValue(CLng(Cls))
'            If (aggIndx = -1) Then
930:                        If aggIndx = -1 Then
'              MsgBox.Error("Class (aggIndx, cls is "+cls.AsString+") not found.  Exiting",
'              "Calculating Response Theme")
933:                                MsgBox "Class (aggIndx, cls is " & Cls & ") not found.  Exiting", vbCritical, _
                                        "Calculating Response Theme"
'              return "Error"
936:                            gSDI_Final = "Error"
                                Exit Function
'            End
939:                        End If
        'SDMGlobals.SDMStatusBar.message(0) = "Find Agg Class..." & aggIndx
'            Area = thmAreaList.Get(fullIdx)
                            Dim Area As Double
943:                        Area = thmAreaList.GetVal(fullIdx)
'            aggAreaList.Set(aggIndx,(aggAreaList.Get(aggIndx) + area))
945:                        aggAreaList.SetIt aggIndx, (aggAreaList.GetVal(aggIndx) + Area)
'          End
nextCls:                Next Cls

'          For Each Cls In aggClsList
950:                    For Each Cls In aggClsList.list
'            clsIndx = allVals.FindByValue(Cls)
                            Dim clsindx As Long
953:                        clsindx = allVals.FindByValue(CLng(Cls))
'            If (clsIndx = -1) Then
955:                        If clsindx = -1 Then
'              MsgBox.Error("Class (clsindx, cls is "+cls.AsString+") not found.  Exiting",
'              "Calculating Response Theme")
958:                            MsgBox "Class (clsindx, cls is " & Cls & ") not found.  Exiting", vbCritical, _
                                "Calculating Response Theme"
'              return "Error"
961:                            gSDI_Final = "Error"
                                Exit Function
'            End
964:                        End If
        'SDMGlobals.SDMStatusBar.message(0) = "Find All Value..." & clsindx
'            emWeights = weightsList.Get(indx)
                            Dim emWeights As SDMUtilities.SDMList
968:                        Set emWeights = weightsList.getObj(indx)
'            emVars = variancesList.Get(indx)
                            Dim emVars As SDMUtilities.SDMList
971:                        Set emVars = variancesList.getObj(indx)
'            Weight = emWeights.Get(clsIndx)
                            Dim Weight As Double
974:                        Weight = emWeights.GetVal(clsindx)
'            If (Weight.IsNull) Then
'              Weight = 0
'            End
'            aggWeightsList.Add (Weight)
979:                        aggWeightsList.Add Weight
'          End
981:                    Next Cls

'          cmbList = {aggClsList,aggWeightsList,aggAreaList}
984:                    Set cmbList = New SDMUtilities.SDMList
985:                    cmbList.AddArray Array(aggClsList, aggWeightsList, aggAreaList)
'          doneDictionary.Add(fldN,cmbList)
987:                    doneDictionary.Add CStr(fldN), cmbList
'        End
989:                 End If ' If (cmbList = Nil)
'      Else
991:            Else
'        ucValList.Add (1)
993:                ucValList.Add 1
'      End  'if (ucVal = missing)
995:            End If
'    End
997:        End If 'if (doMsg)

''
''    '-------------------------------
''    av.ShowMsg("Sum weights...")
'    weightCheckList = List.Make
         Dim weightCheckList As New SDMUtilities.SDMList
'    If (Val <> missing) Then
1005:     If UCVal <> missing Then
'      valindx = allVals.FindByValue(Val)
             Dim valindx As Long
1008:         valindx = allVals.FindByValue(UCVal)
'1001: MsgBox "valindx=" & valindx & ", UCVal=" & UCVal
'      If (valindx = -1) Then
1011:         If valindx = -1 Then
'        MsgBox.Error("Class (valindx, val is "+val.AsString+") not found.  Exiting",
'        "Calculating Response Theme")
1014:             MsgBox "Class (valindx, val is " & UCVal & ") not found.  Exiting", vbCritical, _
            "Calculating Response Theme"
'        return "Error"
1017:             gSDI_Final = "Error"
                 Exit Function
'      End
1020:         End If
        'SDMGlobals.SDMStatusBar.message(0) = "Find All Value..." & valindx
'      emWeights = weightsList.Get(indx)
1023:         Set emWeights = weightsList.getObj(indx)
'      emVars = variancesList.Get(indx)
1025:         Set emVars = variancesList.getObj(indx)
'      Weight = emWeights.Get(valindx)
'1017: MsgBox emWeights.AsString, , "emWeights"
1028:         Weight = emWeights.GetVal(valindx)
'      If (Weight.IsNull) Then
1030:         If IsNull(Weight) Then Weight = 0
'        Weight = 0
'      End
'      variance = emVars.Get(valindx)
              Dim Variance As Double
1035:         Variance = emVars.GetVal(valindx)
'      If (variance.IsNull) Then
1037:         If IsNull(Variance) Then Variance = 0
'        variance = 0
'      End
'      weightCheckList.Add (Weight)
1041:         weightCheckList.Add Weight
'      total = total + Weight          ' sum of weights
1043:         total = total + Weight
'      totalv = totalv + variance      ' sum of variances
1045:         totalv = totalv + Variance
'    End  ' if val <> missing
1047:         End If
'  End ' for each fldN
nextfldn2:
1050:     Next fldN
'
''  av.ShowMsg("Writing values...")
'  ' CALCULATE POSTERIOR LOGIT...
'  lposto = lprioro + total             'posterior logits
          Dim lposto As Double
1056:     lposto = lprioro + total
'  'if (total = 0) then
'  If (lposto = 0) Then
1059:     If lposto = 0 Then
'    posto = 0
             Dim posto As Double
1062:        posto = 0
'  Else
1064:     Else
'    posto = (Number.GetEuler) ^ lposto
1066:         posto = Exp(lposto)
'  End
1068:     End If
'  postp = posto / (1 + posto)
          Dim postP As Double
1071:     postP = posto / (1 + posto)
'>>>>>>>>>> Code corrected to correct algorithm
'  prp1 = (priorp * (1 - priorp))   'posterior probability
'  vprip = prp1 / totArea   'variance of prior probability
          Dim vprip As Double
1076:     vprip = priorp / totArea
'  sprip = vprip.Sqrt
'  sprilo = 1.0/((prp1 * totArea).Sqrt) '''''Error in original code
'  vprilo = sprilo * sprilo
          Dim vprilo As Double
1081:     vprilo = vprip / (priorp * priorp)
'>>>>>>>>>> End of code correction
'  spostp = ((vprilo + totalv).Sqrt * postp * (1.0 - postp)) 'standard deviation of posterior probability
          Dim spostp As Double
1085:           If vprilo + totalv < 0 Then
1086:             spostp = 0
1087:           Else
1088:       spostp = Sqr(vprilo + totalv) * postP * (1# - postP)
1089:           End If
'  If (doPostP) Then
1091:     If doPostP Then rW.Value(vTabw.FindField(postpFld(0))) = postP
'    vTabW.SetValueNumber(postpFld,rW,postp)
'  End

'  If (doPostL) Then
1096:     If doPostL Then rW.Value(vTabw.FindField(postLogit(0))) = lposto
'    vTabW.SetValueNumber(postLogit,rW,lposto)
'  End

'  If (doSumWt) Then
1101:     If doSumWt Then rW.Value(vTabw.FindField(sumWts(0))) = total
'    vTabW.SetValueNumber(sumWts,rW,total)
'  End

'  If (doUncert) Then
1106:     If doUncert Then rW.Value(vTabw.FindField(uncertainty(0))) = spostp
'    vTabW.SetValueNumber(uncertainty,rW,spostp)      'uncertainty due to weights
'  End
'
'  If (doMsng) Then
1111:    If doMsng Then
'    ' CALCULATE UNCERTAINTY DUE TO MISSING DATA
'    ' --------------------------------------
'    numerator = 0
            Dim numerator As Double
1116:       numerator = 0
'    areaDenom = 0
            Dim areaDenom As Double
1119:       areaDenom = 0
''  av.ShowMsg("Calculating uncertainty due to missing data ("+i.AsString+")...")
'    If (IsMissing) Then
1122:       If IsMissing Then
'      For Each binNum In ucValList
                Dim binNum As Variant
1125:           For Each binNum In ucValList.list
'        If (binNum = 0) Then
1127:               If CLng(binNum) = 0 Then
'          bindx = ucValList.Find(binNum)
                        Dim bindx As Long
1130:                   bindx = ucValList.FindByValue(CLng(binNum))
'          If (bindx = -1) Then
1132:                   If bindx = -1 Then
'                MsgBox.Error("Class (bindx) not found.  Exiting","Calculating Response Theme")
1134:                         MsgBox "Class (bindx) not found.  Exiting", vbCritical, "Calculating Response Theme"
'                return "Error"
1136:                         gSDI_Final = "Error"
                              Exit Function
'              End
1139:                   End If
        'SDMGlobals.SDMStatusBar.message(0) = "Find UC Value..." & bindx
'
'          fldN = fieldNameList.Get(bindx)
1143:                   fldN = fieldNameList.GetVal(bindx)
'          cmbList = doneDictionary.Get(fldN)
1145:                   Set dictResult = doneDictionary.item(CStr(fldN))
1146:                   Set cmbList = dictResult
'          aggClsList = cmbList.Get(0)
1148:                   Set aggClsList = cmbList.getObj(0)
'          aggWeightsList = cmbList.Get(1)
1150:                   Set aggWeightsList = cmbList.getObj(1)
'          aggAreaList = cmbList.Get(2)
1152:                   Set aggAreaList = cmbList.getObj(2)
'          For Each Cls In aggClsList
1154:                   For Each Cls In aggClsList.list
'  '          av.ShowMsg("Class "+cls.AsString)
'            clsIndx = aggClsList.Find(Cls)
1157:                       clsindx = aggClsList.FindByValue(Cls)
'            If (clsIndx = -1) Then
1159:                       If clsindx = -1 Then
'                MsgBox.Error("Class (clsIndx) not found.  Exiting","Calculating Response Theme")
1161:                           MsgBox "Class (clsIndx) not found.  Exiting", vbCritical, "Calculating Response Theme"
'                return "Error"
1163:                           gSDI_Final = "Error"
                                Exit Function
'              End
1166:                       End If
        'SDMGlobals.SDMStatusBar.message(0) = "Find AggCls Value..." & clsindx
'            curWeight = aggWeightsList.Get(clsIndx)
                            Dim curWeight As Double
1170:                       curWeight = aggWeightsList.GetVal(clsindx)
'            curArea = aggAreaList.Get(clsIndx)
                            Dim curArea As Double
1173:                       curArea = aggAreaList.GetVal(clsindx)
'            curTerm = (postp - (av.Run("gSDI.L2P",{lposto + curWeight}))^2) * curArea
                            Dim curTerm As Double
1176:                       curTerm = (postP - gSDI_L2P(lposto + curWeight) ^ 2) * curArea
'            numerator = numerator + curTerm
1178:                       numerator = numerator + curTerm
'            areaDenom = areaDenom + curArea
1180:                       areaDenom = areaDenom + curArea
'          End  ' for each cls
1182:                   Next Cls
'        End  ' if binNum = 0
1184:               End If
'      End ' for each binNum
1186:           Next binNum
'
'      ucD2M = (numerator/areaDenom).Sqrt
1189:           If numerator < 0 Then numerator = 0
                Dim ucD2M As Double
1191:           ucD2M = Sqr(numerator / areaDenom)
'      vTabW.SetValueNumber(missingD,rW,ucD2M)
1193:           rW.Value(missingDFld) = ucD2M
'    Else   'if not (isMissing)
1195:         Else
'      ucD2M = 0
1197:           ucD2M = 0#
'      vTabW.SetValueNumber(missingD,rW,ucD2M)
1199:           rW.Value(missingDFld) = ucD2M
'    End  '(isMissing)
1201:         End If
'
'    ' --------------------------------------
'    ' CALCULATE TOTAL UNCERTAINTY
'    '------------------------------------
'    cmbStdDev = ((spostp^2) + (ucD2M^2)).Sqrt
            Dim cmbStdDev As Double
1208:       cmbStdDev = Sqr((spostp ^ 2) + (ucD2M ^ 2))
'    vTabW.SetValueNumber(totalUnc,rW,cmbStdDev)
1210:       rW.Value(totalUncFld) = cmbStdDev
'  End ' if (doMsng)
1212:     End If 'doMsng
'End
1214:     rW.Store
1215:    SDMGlobals.SDMStatusBar.StepProgressBar
1216: Next i 'uniqueconditions
1217: SDMGlobals.SDMStatusBar.HideProgressBar


'vTabW.SetEditable (False)
1221: FeatureUtils.StopEditing pWrkSpcEdit
'vTabW.Flush
'vTabW.Refresh
'tabW = Table.Make(vTabW)
'strTabW = av.Run("gSDI.GetNewDocName",{"Weights of Evidence","Table"})
'if (strTabW.Is(String)) then
'  tabW.SetName (strTabW)
'Else
'  strTabW = vTabW.GetBaseTableFilename.GetBaseName
'  tabW.SetName (strTabW)
'End

'>>>> vTabW joined to ucVTab below
'ucVTab.Join(ucVtab.FindField("Value"),vTabW,fldID)
'>>>>> Save comments in table tabW
''''''If (self.Is(List)) Then
'''''1200: If TypeOf Self Is SDMUtilities.sdmlist Then
''''''  cmtsW = "Generated by: Arc-SDM - Calculate Response Theme" + NL
'''''    Dim cmtsW As String
'''''1203:     cmtsW = "Generated by: Arc-SDM - Calculate Response Theme" & vbCrLf
''''''Else
'''''1205: Else
''''''  cmtsW = "Generated by: Arc-SDM - Use Existing Weights/Variances Tables" + NL
'''''1207:     cmtsW = "Generated by: Arc-SDM - Use Existing Weights/Variances Tables" & vbCrLf
''''''End
'''''1209: End If
''''''cmtsW = cmtsW + "Weights of Evidence Table" + NL +
''''''        "Source: " + vTabW.GetBaseTableFilename.GetFullName + NL +
''''''        NL + "Associated files: " + NL +
''''''        "    Unique Conditions Theme: " + ucGridTheme.GetName + " (Source: " + ucGridTheme.GetSrcName.GetFileName.GetFullName + ")" + NL
'''''1214: cmtsW = cmtsW & "Weights of Evidence Table" & vbCrLf & _
'''''        "Source: " & tabW.Name & vbCrLf & _
'''''        vbCrLf & "Associated files: " & vbCrLf & _
'''''        "    Unique Conditions Theme: " & ucGridTheme.Name & _
'''''        " (Source: " & ucGridTheme.FilePath + ")" & vbCrLf
''''''mnuSDM = av.Run("gSDI.GetSDMMenu",{})
'''''Dim gSDIGetSDMMenu As gSDI_GetSDMMenu
'''''1221: Set gSDIGetSDMMenu = New gSDI_GetSDMMenu
'''''Dim mnuSDM As ICommandItem
'''''1223: Set mnuSDM = gSDIGetSDMMenu.gSDI_GetSDMMenu
''''''If (self.Is(List)) Then
'''''1225: If Not IsEmpty(Self) Then
''''''  If (mnuSDM.Is(Menu) Then
'''''1227:     If TypeOf mnuSDM Is ICommandItem Then
'''''1228:        If mnuSDM.Tag <> "" Then
''''''    Comments = mnuSDM.GetTag
'''''                Dim comments As String
'''''1231:           comments = mnuSDM.Tag
''''''    lstCmts = Comments.AsTokens("*")
'''''                Dim lstCmts As Variant
'''''1234:           lstCmts = Split(comments, "*")
''''''    If (lstCmts.Count = 2) Then
'''''1236:           If UBound(lstCmts) = 1 Then
''''''      rest = lstCmts.Get(1)
'''''                    Dim rest As String
'''''1239:               rest = lstCmts(1)
''''''    Else
'''''1241:           Else
''''''      rest = Comments
'''''1243:               rest = comments
''''''    End
'''''1245:           End If
''''''    woeTabName = rest.Extract(16)
'''''                Dim restTokens As Variant
'''''1248:           restTokens = Split(rest)
'''''1249:           If Len(restTokens(0)) > 0 Then
'''''                    Dim woeTabName As String
'''''1251:               woeTabName = restTokens(16)
''''''    varTabName = rest.Extract(19)
'''''                    Dim varTabName As String
'''''1254:               varTabName = restTokens(19)
'''''1255:           End If
''''''  Else
'''''1257:       Else
''''''    woeTabName = ""
'''''1259:           woeTabName = ""
''''''    varTabName = ""
'''''1261:           varTabName = ""
''''''  End
'''''1263:       End If
''''''  If (woeTabName = Nil) Then
''''''    woeTabName = ""
''''''  End
''''''  If (varTabName = Nil) Then
''''''    varTabName = ""
''''''  End
'''''            Dim woeVTabDS As IDataset
'''''1271:       Set woeVTabDS = woeVTab
'''''            Dim varVTabDS As IDataset
'''''1273:       Set varVTabDS = varVTab
''''''  cmtsW = "    Weights Table: " + woeTabName + " (Source: " + woeVTab.GetBaseTableFilename.GetFullName + ")" + NL +
''''''          "    Variances Table: " + varTabName + " (Source: " + varVTab.GetBaseTableFilename.GetFullName + ")" + NL
'''''1276:       cmtsW = "    Weights Table: " & woeTabName & " (Source: " & woeVTabDS.FullName.NameString & ")" & vbCrLf & _
'''''                "    Variances Table: " & varTabName & " (Source: " & varVTabDS.FullName.NameString & ")" & vbCrLf
''''''Else
'''''1279:   Else
''''''  cmtsW = "    Weights Table: " + woeTable.GetName + " (Source: " + woeVTab.GetBaseTableFilename.GetFullName + ")" + NL +
''''''          "    Variances Table: " + varTable.GetName + " (Source: " + varVTab.GetBaseTableFilename.GetFullName + ")" + NL
''''''End
'''''1283:   End If
''''''tabW.SetComments (cmtsW)

'>>>>> Save comments in ARCSDM commanditem "Spatial Data Modeller"
''''''If (mnuSDM.Is(Menu)) Then
'''''        If TypeOf mnuSDM Is ICommandItem Then
''''''  Comments = Comments + "    Weights of Evidence Table:  " + tabW.GetName + " (Source: " + vTabW.GetBaseTableFilename.GetFullName + ")" + NL
'''''            Dim vTabWDS As IDataset
'''''1289:       Set vTabWDS = vTabw
'''''1290:       comments = comments & "    Weights of Evidence Table:  " & tabW.Name & " (Source: " & vTabWDS.FullName.NameString & ")" & vbCrLf
''''''  mnuSDM.SetTag (Comments)
'''''1292:       mnuSDM.Tag = comments
''''''End
'''''        End If

'If (av.FindDialog("gCmb").IsOpen) Then
1336: If gCmb.Visible Then gCmb.Hide
'  av.FindDialog("gCmb").Close
'End
'If (av.FindDialog("gL").IsOpen) Then
1340: If gL.Visible Then gL.Hide
'  av.FindDialog("gL").findByName("lbt_Can").Click
'End
'ucGridTheme.SetVisible (True)
1344: ucGridTheme.Visible = True
'ucTable = av.GetActiveDoc
'If (ucTable.Is(Table)) Then
'  ucTabWin = ucTable.GetWin
'  If (ucTabWin.IsOpen) Then
'    ucTabWin.Close
'  End
'End

'totalPoints = woeVTab.ReturnValue(woeVTab.GetFields.Get(2), (woeVTab.GetNumRecords - 1))
Dim nrw As Long
1355: nrw = woeVTab.RowCount(Nothing) - 1
1356: Set rW = woeVTab.GetRow(nrw)
Dim totalPoints As Long
1358: totalPoints = rW.Value(4)
'If (asymptote) Then
1360: If asymptote Then
'  unitArea = 1
         Dim unitArea As Double
1363:    unitArea = 1
'Else
1365: Else
'  unitArea = av.FindDialog("gParam").findByName("txtUA").GetText.AsNumber
1367:    unitArea = CDbl(gP.txtUA.Text)
'End
1369: End If
'predicted = 0
Dim predicted As Double
1372: predicted = 0
'areaFld = ucVTab.FindField("Area_sqm")
Dim areaFld As Long
1375: areaFld = ucVTab.FindField("Area_sqm")
1376: Set curs = ucVTab.Search(Nothing, False)
1377: Set rW = curs.NextRow
'For Each record In ucVTab
1379:   pProgbar.Position = 0
1380:   SDMGlobals.SDMStatusBar.ShowProgressBar "Processing WOE table...", 1, ucVTab.RowCount(Nothing), 1, True
1381: While Not rW Is Nothing
'  ar = ucVTab.ReturnValue(areaFld, record)
        Dim ar As Double
1384:   ar = rW.Value(areaFld)
'  ar = (ar / 1000000) / unitArea
1386:    ar = ar / 1000000 / unitArea
'  postProb = ucVTab.ReturnValue(ucvtab.FindField("Post_prob"), record)
        Dim rwVTabw As irow
1389:   Set rwVTabw = vTabw.GetRow(rW.OID)
        Dim postProb As Double
1391:   postProb = rwVTabw.Value(vTabw.FindField("Post_prob"))
'  predicted = predicted + (ar * postProb)
1393:   predicted = predicted + (ar * postProb)
'End
1395:   Set rW = curs.NextRow
1396: SDMGlobals.SDMStatusBar.StepProgressBar
1397: Wend
1398: SDMGlobals.SDMStatusBar.HideProgressBar
'
'pratio = totalPoints / predicted
Dim pRatio As Double
1402: pRatio = totalPoints / predicted
'pratioRnd = ((pratio * 100).Round) / 100

'' 'Normalized' posterior probability to
'' adjust for conditional independence
''--------------------------------------
''''vTabW.SetEditable (True)
''''If (vTabW.IsEditable) Then
'''1442:     Set curs = vTabw.Update(Nothing, False)
'''1443:     Set rW = curs.NextRow
''''  For Each r In ucVTab
'''1445:     While Not rW Is Nothing
''''    vTabW.SetValue(vTabW.FindField("PstPrbNrm"),r,vTabW.ReturnValue(vTabW.FindField("Post_prob"),r) * pratio)
'''1447:         rW.Value(vTabw.FindField("PstPrbNrm")) = _
'''                rW.Value(vTabw.FindField("Post_prob")) * pratio
'  End
'''1450:         Set rW = curs.NextRow
'''1451:     Wend
''''End

'If (exprt.Not) Then
1423: If Not exprt Then
'  calcCI = MsgBox.YesNo("Do you want to create a table of probabilities"+NL+
'                        "to assess Conditional Independence now?","Check Conditional Independence",True)
            Dim calcCI As Integer
1427:       calcCI = MsgBox("Do you want to create a table of probabilities" & vbCrLf & _
                  "to assess Conditional Independence now?", vbYesNo, "Check Conditional Independence")
'  If (calcCI) Then
1430:     If calcCI = vbYes Then
'    av.Run("gSDI.MakeCITab",{ucGrid,theView,pratioRnd,lstMD})
              Dim gSDIMakeCITab As gSDI_MakeCITab
1433:         Set gSDIMakeCITab = New gSDI_MakeCITab
              Dim Vals As Variant
1435:         Vals = gSDIMakeCITab.gSDI_MakeCITab(Array(ucGridTheme, destTab, vTabw, unitArea, doMsng))
        'Add summary information to CI table
              Dim wksEdt As IWorkspaceEdit
1438:         Set wksEdt = FeatureUtils.startEditing(SDMGlobals.SDMPrjDir)
              Dim saTbl As IStandaloneTable
1440:         Set saTbl = WOETableUtils.FindStandAloneTableByName(ucGridTheme.Name & "_CI", SDMGlobals.SDMMap)
1441:         Set rW = saTbl.Table.CreateRow
1442:         rW.Value(rW.Fields.FindField("PrdPntFreq")) = pRatio
1443:         rW.Value(rW.Fields.FindField("VarPntFreq")) = (CDbl(Vals(0)) - nTPs) / Sqr(CDbl(Vals(1)))
1444:         rW.Store
1445:         FeatureUtils.StopEditing wksEdt
1446:     End If
'End
1448: End If

''associate = MsgBox.YesNo("Do you want to associate the conditional probabilities"+NL+
''                         "in the response theme with your training points?",
''                         "Probability at Points",True)
'Dim associate As VbMsgBoxResult
'1439: associate = MsgBox("Do you want to associate the conditional probabilities" & vbCrLf & _
'                         "in the response theme with your training points?", vbYesNo, _
'                         "Probability at Points")
''If (associate) Then
'1443: If associate = vbYes Then
''
''  ' GET TRAINING POINT THEME NAME FROM PARAMETERS DIALOG BOX
''  '-------------------------------------------------
''  Parameters = av.FindDialog("gParam")
''Dim anlParms As AnalysisParameters.AnlParams
'1449: Set anlParms = New AnalysisParameters.AnlParams
'Dim Parameters As Form
'1451: Set Parameters = anlParms.gParamFrm
''  minName = Parameters.findByName("cbxTP").GetCurrentValue
'Dim cbxTP As ComboBox
'1454: Set cbxTP = Parameters.cbxTP
'Dim minName As String
'1456: minName = cbxTP.Text
''  if (minName.Is(String)) then
''    minMap = theView.FindTheme(minName)
'          Dim minMap As IFeatureLayer
'1460:     Set minMap = FindLayerByName(minName)
''    If (minMap.Is(FTheme).Not) Then
'1462:     If minMap Is Nothing Then
''      MsgBox.Error("The Training Point Theme must have a unique name.","Setting Parameters")
'1464:         MsgBox "The training point theme was not found.", vbCritical, c_sModuleFileName
''      return Nil
'1466:         gSDI_Final = "Error"
'        Exit Function
''    End
'1469:     End If
''    minVTab = minMap.GetFTab
'          Dim minVTab As ITable
'1472:     Set minVTab = minMap
''    ShapeType = minVTab.FindField("Shape").GetType
'          Dim ShapeType As esriGeometryType
'1475:     ShapeType = minMap.FeatureClass.ShapeType
''    if (shapetype <> #FIELD_SHAPEPOINT) then
'1477:     If ShapeType <> esriGeometryPoint Then
''      MsgBox.Error("The Training Point Theme must have a unique name.","Setting Parameters")
'1479:         MsgBox "Training Point theme is not a Point FeatureLayer", vbCritical, c_sModuleFileName
''      return Nil
'1481:         gSDI_Final = "Error"
'              Exit Function
''    End
'1484:     End If
''  Else
''    minMap = Nil
''  End
''
''  av.Run("gSDI.ResponseAtPoints",{minMap,ucGridTheme})
'          Dim gSDIResponseAtPoints As gSDI_RespAtPoints
'1491:     Set gSDIResponseAtPoints = New gSDI_RespAtPoints
'1492:     gSDIResponseAtPoints.gSDI_ResponseAtPoints Array(minMap, ucGridTheme)
'1493:     Set gSDIResponseAtPoints = Nothing
''End
'1495: End If

'If (exprt.Not) Then
'  MsgBox.Info("Conditional Independence Ratio:   "+ pratioRnd.AsString+NL+
'              "Values below 1.00 may indicate conditional dependence "+NL+
'              "among two or more of your data sets.","Assessment of Conditional Independence")
'End
1517: If (Not exprt) And (calcCI = vbYes) Then
1518:       Load gCI
1519:       gCI.CI_Test ucGridTheme.Name, nTPs, Vals, pRatio, False, Nothing
1520:       gCI.Show vbModal
1521: End If

'Join Area Table to UC layer first
Dim areaSATbl As IStandaloneTable
1525: Set areaSATbl = WOETableUtils.FindStandAloneTableByName(ucGridTheme.Name & "_Tbl", SDMGlobals.SDMMap)
1526: WOETableUtils.joinTableToLayer ucGridTheme, "Value", areaSATbl, "Value"
'Join and resymbolize UC layer
'Dim saTbl As IStandaloneTable
1529: Set saTbl = SDMGlobals.SDMUtil.FindStandAloneTableByName(FileDialog.GetBaseName(CStr(fnw(0))))
1530: WOETableUtils.joinTableToLayer ucGridTheme, "Value", saTbl, "ID"
1531:     MsgBox "Unique Conditions Grid " & ucGridTheme.Name & " and " & saTbl.Name & " are joined." & vbCrLf & _
        "The U.C. grid is ready to be symbolized at the ArcMap interface.", vbInformation, "Calculate Response"

1534: gSDI_Final = "OK"
1535: If exprt Then Unload gExprt
1536: gL.RasterSrcDict.Clear
'MsgBox "Exiting gSDI_Final"
'<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
Exit Function
ErrorHandler:
1541:  Unload gL
1542:  If exprt Then Unload gExprt
  HandleError True, "gSDI_Final " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), Err.Number, Err.Source, Err.Description, 4
1544: gSDI_Final = "Error"
End Function

Private Function BasicTrim(s As String, lTrim As String, rTrim As String) As String
  On Error GoTo ErrorHandler


1551:     If (Not IsEmpty(lTrim)) And (Left(s, 1) = lTrim) Then s = Right(s, Len(s) - 1)
1552:     If (Not IsEmpty(rTrim)) And (Right(s, 1) = rTrim) Then s = Left(s, Len(s) - 1)
1553:     BasicTrim = s

  Exit Function
ErrorHandler:
  HandleError False, "BasicTrim " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), Err.Number, Err.Source, Err.Description, 4
End Function

Private Function gSDI_L2P(logit As Double) As Double
  On Error GoTo ErrorHandler

'logit = self.Get(0)
'odds = (Number.GetEuler) ^ logit
Dim odds As Double
1566: odds = Exp(logit)
'postP = odds / (1 + odds)
1568: gSDI_L2P = odds / (1 + odds)
'return postP


  Exit Function
ErrorHandler:
  HandleError False, "gSDI_L2P " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), Err.Number, Err.Source, Err.Description, 4
End Function

Private Function FindLayerByName(lName As String) As ILayer
Dim nl As Long
1579: For nl = 0 To SDMMap.LayerCount - 1
1580:     If UCase(SDMMap.Layer(nl).Name) = UCase(lName) Then
1581:         Set FindLayerByName = SDMMap.Layer(nl)
        Exit Function
1583:     End If
1584: Next nl
1585: Set FindLayerByName = Nothing
End Function
Private Function EndsWith(s As String, subs As String) As Boolean
  On Error GoTo ErrorHandler

1590:     EndsWith = (Right(s, Len(subs)) = subs)


  Exit Function
ErrorHandler:
  HandleError False, "EndsWith " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), Err.Number, Err.Source, Err.Description, 4
End Function

Public Function asString(ByRef dict As SDMUtilities.SDMDictionary) As String
  On Error GoTo ErrorHandler

1601:     asString = ""
    Dim item As Variant
    Dim aKeyIdx As Integer
    Dim myKeys As Variant
1605:     myKeys = dict.ReturnKeys
1606:     For aKeyIdx = 0 To dict.Count - 1
        Dim aKey As Variant
1608:         aKey = myKeys(aKeyIdx)
1609:         item = dict.Gett(aKey)
1610:         If (TypeOf item Is SDMUtilities.SDMList) Then
1611:             asString = asString & item.asString & vbCrLf
1612:         ElseIf (TypeOf item Is Object ) Then
1613:             asString = asString & myKeys(aKeyIdx) & ": An object" & vbCrLf
1614:         ElseIf (VarType(item) = vbArray) Then
1615:             asString = asString & myKeys(aKeyIdx) & ": An array" & vbCrLf
1616:         Else
1617:             asString = asString & myKeys(aKeyIdx) & " " & item & vbCrLf
1618:         End If
1619:     Next aKeyIdx


  Exit Function
ErrorHandler:
  HandleError True, "asString " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), Err.Number, Err.Source, Err.Description, 4
End Function


