VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "gSDI_FindContacts"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = True
Option Explicit
Const c_sModuleFileName As String = "gSDI_FindContacts"
Const c_sDLLFileName As String = "SDMAccessories"       ' Constant reflect file module name
'Private ObjectTag As Object
'Property Set setObjectTag(anObject As Object)
'    Set ObjectTag = anObject
'End Property
'Property Get getObjectTag() As Object
'    Set getObjectTag = ObjectTag
'End Property

Sub gSDI_FindContacts()
  On Error GoTo ErrorHandler
'PUT THE IMPLEMENTATION HERE >>>>>>>>>>>>>
'' Name: gSDI.FindContacts
''
''
''Topics:
''
''Description:  Finds the bounding line features (contacts) betwee
'' two sets of user defined polygons and writes them to a new data set.
''  For polygon feature theme, writes copies of the bounding arcs to
'' to a line feature theme (shapefile).  For a raster input theme, defines
'' the lines b
''
''Requires:  An input data set with polygons.
''
'' Self:  'Extract Contacts...' menu item.
''
''Returns:
''
'' Vector code:  Robyn Gallagher
'' Raster code:  Laura Kemp
''
''==============================================
'' GET THE ACTIVE DOC, CHECK THAT IT'S VIEW
''------------------------------------------
'theView = av.GetActiveDoc
'If (theView.Is(View).Not) Then
'  MsgBox.Error("The active document must be a View.","Extracting Contacts")
'  return Nil
'End
43: ProgressAnimation.Show "Generating contacts...."
'' GET THE EXTRACTION DIALOG, GET THEME WITH CONTACTS TO EXTRACT
''------------------------------------------
'extDiag = av.FindDialog("gExt")
'theThemeName = extDiag.findByName("cbx_Ftr").GetCurrentValue
Dim theThemeName As String
49: theThemeName = gExt.cbx_Ftr.Text
'theTheme = theView.FindTheme(theThemeName)
Dim theTheme As ILayer
52: Set theTheme = WOETableUtils.FindLayerByName(theThemeName)
'If (theTheme = nil) Then
54: If theTheme Is Nothing Then
'  return Nil
        Exit Sub
'End
58: End If
''CHECK WHETHER THEME IS FEATURE THEME OR GRID THEME AND PROCEED...
''------------------------------------------
Dim theAE As IRasterAnalysisEnvironment
'260: Set theAE = RasterAEUtils.getRasterAnalysisEnvironment
'>>>>> Temporary RAE
        Dim anlParms As AnalysisParameters.AnlParams
65:         Set anlParms = New AnalysisParameters.AnlParams
        Dim gParamcbxSA As ComboBox
67:         Set gParamcbxSA = anlParms.gParamFrm.cbxSA
        Dim studyarea As IRasterLayer
69:     Set studyarea = WOETableUtils.FindLayerByName(gParamcbxSA.Text)
        Dim rasprops As IRasterProps
71:     Set rasprops = studyarea.Raster
        Dim geoDataSet As IGeoDataset
73:     Set geoDataSet = studyarea
74:     Set theAE = New RasterAnalysis
75:     theAE.SetCellSize esriRasterEnvValue, rasprops.MeanCellSize.X
76:     theAE.SetExtent esriRasterEnvValue, geoDataSet.Extent
77:     Set theAE.mask = studyarea.Raster
78:     Set theAE.OutSpatialReference = geoDataSet.SpatialReference
        Dim dataSet As IDataset
80:     Set dataSet = studyarea
81:     Set theAE.OutWorkspace = SDMGlobals.SDMWorkspace
'>>>>> ENd of temp RAE
'If (theTheme.Is(Ftheme)) Then
84: If TypeOf theTheme Is IFeatureLayer Then
''  'Check if polyline theme
''  themeVTab = theTheme.GetFTab
''  themeVTab.RememberSelection
''  shapeField = themeVTab.FindField("Shape")
''  themetype = shapeField.GetType
''  if (themeType <> #FIELD_SHAPEPOLY) then
''    MsgBox.Error("Active theme must be polygon theme","")
''    return nil
''  End
''  ' Specify the output shapefile...
''  outFName = av.GetProject.MakeFileName("Ctact", "shp")
''  outFName = FileDialog.Put(outFName, "*.shp", "Output Contact Shapefile")
''  If (outFName = nil) Then
''    return Nil
''  End
''  outClass = Polyline
''  outputFTab = FTab.MakeNew(outFName, outClass)
''  sField = outputFTab.FindField("shape")
''  ' ADD LENGTH FIELD AND WRITE LENGTH OF EACH FEATURE
''  f2=Field.Make("Length",#FIELD_DECIMAL,15,3)
''  outputFTab.AddFields({f2})
''  themeBM = themeVTab.GetSelection
''  theQuery = extDiag.findByName("lbt_Q1").getObjectTag
''  If (theQuery = nil) Then
''    return Nil
''  End
''  themeVTab.Query(theQuery,themeBM,#VTAB_SELTYPE_NEW)
''  themeBM2 = themeBM.Clone
''  theQuery = extDiag.findByName("lbt_Q2").getObjectTag
''  If (theQuery = nil) Then
''    return Nil
''  End
''  themeVTab.Query(theQuery,themeBM2,#VTAB_SELTYPE_NEW)
''  For Each r In themeBM
''   poly1 = themeVTab.ReturnValue(shapeField, r)
''    For Each r1 In themeBM2
''      poly2 = themeVTab.ReturnValue(shapeField, r1)
''      pl = poly1.LineIntersection(poly2)
''        r2 = outputFTab.AddRecord
''        outputFTab.SetValue(sField,r2,pl)
''      End
''    End
''  End
''  outputFTab.Calculate("[Shape].ReturnLength",f2)
''  lastSelection = themeVTab.GetLastSelection
''   ' Restore the saved selection bitmap
''  themeVTab.SetSelection (lastSelection.Clone)
''  themeVTab.UpdateSelection
''  outputFTab.Flush
''  outputFTab.SetEditable (False)
''  contTheme = Ftheme.Make(outputFTab)
''    theView.AddTheme (contTheme)
''   themes = theView.GetThemes
''   For Each t In themes
''     If (t.Is(Ftheme)) Then
''       ShapeType = t.GetFTab.FindField("Shape").GetType
''       if ((shapetype = #FIELD_SHAPEPOINT) or (shapetype = #FIELD_SHAPEPOLY)) then
''        plIndx = themes.Find(t)
''      End
''    End
''  End
''
''  If (plIndx <> nil) Then
''
''    themes.Shuffle(contTheme,(plIndx + 1))
''
''  End
Dim qryFilt As IQueryFilter
153: Set qryFilt = New QueryFilter
Dim flayer As IFeatureLayer
155: Set flayer = theTheme
Dim featClass As IFeatureClass
157: Set featClass = flayer.FeatureClass
Dim pdataSet As IDataset
159: Set pdataSet = flayer
Dim featSel As ISelectionSet
Dim whereclause As Variant
Dim geomBags() As IGeometryCollection
ReDim geomBags(2)
Dim igbag As Long
165: igbag = 0
Dim cellsize As Double
167: theAE.GetCellSize esriRasterEnvValue, cellsize
168: cellsize = cellsize / 2
Dim whichArray As New Collection
170: whichArray.Add gExt.lbt_Q1.Tag
171: whichArray.Add gExt.lbt_Q2.Tag
172: For Each whereclause In whichArray
173:     Set geomBags(igbag) = New GeometryBag
174:     qryFilt.whereclause = CStr(whereclause)
175:     Set featSel = featClass.Select(qryFilt, esriSelectionTypeIDSet, esriSelectionOptionNormal, pdataSet.Workspace)
         Dim pEnumBind As IEnumGeometryBind
177:     Set pEnumBind = New EnumFeatureGeometry
178:     pEnumBind.BindGeometrySource Nothing, featSel
         Dim pEnumGeom As IEnumGeometry
180:     Set pEnumGeom = pEnumBind
         Dim pNewGeom1 As ITopologicalOperator
         Dim pNewGeom As ITopologicalOperator
183:     Set pNewGeom = pEnumGeom.Next
184:     Do While Not pNewGeom Is Nothing
            Dim newgeom As IPolygon2
186:             If CStr(whereclause) = gExt.lbt_Q2.Tag Then
                Dim newgeomrev As IPolygon2
188:                 Set newgeomrev = pNewGeom
189:                 newgeomrev.ReverseOrientation
190:                 Set pNewGeom = newgeomrev
191:             End If
192:        Set newgeom = pNewGeom.Buffer(cellsize)
193:        If Not newgeom.IsEmpty Then geomBags(igbag).AddGeometry newgeom
194:        Set pNewGeom = pEnumGeom.Next
195:     Loop
196:    igbag = igbag + 1
197: Next whereclause

'INtersect the two bags
200: Set geomBags(2) = New GeometryBag
Dim pEnum As IEnumGeometry
202: Set pEnum = geomBags(0)
Dim pNewGeomTopo As ITopologicalOperator
204: Set pNewGeomTopo = pEnum.Next
205: While Not pNewGeomTopo Is Nothing
        Dim intGeom As IPolygon
        Dim i As Long
208:    For i = 0 To geomBags(1).GeometryCount - 1
            Dim nextPoly As IPolygon
210:        Set nextPoly = geomBags(1).Geometry(i)
211:        Set intGeom = pNewGeomTopo.Intersect(nextPoly, esriGeometry2Dimension)
212:        If Not intGeom.IsEmpty Then geomBags(2).AddGeometry intGeom
213:    Next i
214:    Set pNewGeomTopo = pEnum.Next
215: Wend

217: If geomBags(2).GeometryCount = 0 Then
218:     MsgBox "No contacts found. Stopping", vbExclamation, "Extracting Contacts"
         Exit Sub
220: End If

     Dim featclasName As IFeatureClassName
     Dim featclas As IFeatureClass
     Dim pDir As String
225: pDir = WOETableUtils.getProjectDir
     Dim pName As String
227: pName = theTheme.Name & "_Contacts"
     Dim contgridnamevar As Variant
229: contgridnamevar = FileDialog2.GetSaveFileName("Contacts Filename", pDir, pName)
     If IsEmpty(contgridnamevar) Then Exit Sub
     Dim contGridname As IFileName
232: Set contGridname = New fileName
233: contGridname.path = CStr(contgridnamevar(1)) & "\" & CStr(contgridnamevar(0))
234: If contGridname.path = "" Then
        Exit Sub
236: End If
237: pName = FileDialog.GetBaseName(contGridname.path)
238: pDir = FileDialog.getDir(contGridname.path)
239: Set featclas = CreateShapefile(pDir, pName)

241: For i = 0 To geomBags(2).GeometryCount - 1
        Dim feat As IFeature
243:    Set feat = featclas.CreateFeature
        Dim pPolygon As IPolygon
245:    Set pPolygon = geomBags(2).Geometry(i)
246:    Set feat.Shape = pPolygon
        Dim area As IArea
248:    Set area = pPolygon
249:    feat.Value(feat.Fields.FindField("Area")) = area.area
250:    feat.Store
251: Next i

Dim rastConv As IConversionOp
254: Set rastConv = New RasterConversionOp
Dim rmAE As IRasterAnalysisEnvironment
256: Set rmAE = rastConv
257: rmAE.SetCellSize esriRasterEnvValue, cellsize
258: Set rmAE.OutWorkspace = SDMGlobals.SDMWorkspace
Dim extRM As IEnvelope
260: theAE.GetExtent esriRasterEnvValue, extRM
261: rmAE.SetExtent esriRasterEnvValue, extRM
262: Set rmAE.mask = theAE.mask
263: Set rmAE.OutWorkspace = SDMGlobals.SDMWorkspace
264: Set rmAE.OutSpatialReference = theAE.OutSpatialReference
265: rmAE.DefaultOutputRasterPrefix = "contacts"
' Declare the output dataset
Dim pWSFact As IWorkspaceFactory
268: Set pWSFact = New RasterWorkspaceFactory
Dim pWrkSpace As IWorkspace
270: Set pWrkSpace = pWSFact.OpenFromFile(pDir, 0)
Dim pOutputDataset As IRasterDataset
272: Set pOutputDataset = rastConv.ToRasterDataset(featclas, "GRID", pWrkSpace, pName)

Dim ndClass As INumberRemap
275: Set ndClass = New NumberRemap
276: ndClass.MapRange 0, geomBags(2).GeometryCount - 1, 1

'  contGRID = ndGRID.ReclassByClassList("Value",{ndClass},True)
Dim reclasGrid As IRaster
Dim reclasOp As IReclassOp
281: Set reclasOp = New RasterReclassOp
Dim reclasOpENV As IRasterAnalysisEnvironment
283: Set reclasOpENV = reclasOp
284: RasterAEUtils.SetToSDMRAEnv reclasOpENV
285: Set reclasOpENV.OutWorkspace = SDMGlobals.SDMWorkspace
286: Set reclasGrid = reclasOp.ReclassByRemap(pOutputDataset, ndClass, False)

Dim rplayer As IRasterLayer
289: Set rplayer = New RasterLayer
290: rplayer.CreateFromRaster reclasGrid
291: Set rplayer.SpatialReference = theAE.OutSpatialReference
292: rplayer.Name = FileDialog.GetBaseName(contGridname.path)
293: SDMGlobals.SDMMap.AddLayer rplayer

Dim pUVRenderer As IRasterUniqueValueRenderer
296: Set pUVRenderer = UVSymbolizeRaster.ChangeRendererToUVRenderer(rplayer, "Value")
Dim pSymb As IColorSymbol
298: Set pSymb = New ColorSymbol
Dim pcolor As IRgbColor
300: Set pcolor = New RgbColor
301: pcolor.RGB = 0
302: pSymb.Color = pcolor
303: pUVRenderer.Symbol(0, 0) = pSymb


'ElseIf (theTheme.Is(GTheme)) Then
307: ElseIf TypeOf theTheme Is IRasterLayer Then
         Dim geoGRID As IRasterLayer
309:     Set geoGRID = theTheme
'  'GET GRID, MAKE SURE ITS INTEGER
'  geoGRID = theTheme.GetGrid
         'Dim rasProps As IRasterProps
313:     Set rasprops = geoGRID.Raster
'  If (geoGRID.IsInteger.Not) Then
315:     If Not rasprops.IsInteger Then
'    MsgBox.Error("The GRID data set must be type integer.","Extracting Contacts")
317:         MsgBox "The GRID data set must be type integer.", vbCritical, "Extracting Contacts"
'    return Nil
             Exit Sub
'  End
321:     End If
'
'  theAE = theView.GetExtension(AnalysisEnvironment)
'  aBox = Rect.Make(0@0,1@1)
'  cellSize = 1
'  theAE.GetExtent (aBox)
'  theAE.GetCellSize (cellSize)
''  if ((theAE.GetExtent(aBox) <> #ANALYSISENV_VALUE) or (theAE.GetCellSize(cellSize) <> #ANALYSISENV_VALUE)) then
''    ce = AnalysisPropertiesDialog.Show(theView,TRUE,"Output Grid Specification")
''    if (ce = Nil) then
''      return Ni
''    end
''    theView.SetExtension(ce)
''    ce.Activate
''  end
'
'  'STORE CURRENT MASK, AND SET MASK TO THEME
'
'  '------------------------------------------
''  curMask = theAE.GetMask
''  theAE.SetMask(theTheme)
''  theAE.Activate

'  curMask = theAE.GetMask
        Dim curMask As IGeoDataset
346:    Set curMask = theAE.mask
''  if (curMask <> Nil) then
'    extAE = Rect.Make(1@1,1@1)
         Dim extAE As IEnvelope
350:     Set extAE = New Envelope
'    extType = theAE.GetExtent(extAE)
         Dim exType As esriRasterEnvSettingEnum
353:     theAE.GetExtent exType, extAE
'    csAE = 1
    Dim csAE As Double
356:     csAE = 1
'    csType = theAE.GetCellSize(csAE)
    Dim cstype As esriRasterEnvSettingEnum
359:     theAE.GetCellSize cstype, csAE
'    GRID.Reset
'    theAE.SetExtent(#ANALYSISENV_VALUE,geoGRID.GetExtent)
362:     Set rasprops = geoGRID.Raster
363:     theAE.SetExtent esriRasterEnvValue, rasprops.Extent
'    theAE.SetCellSize(csType,csAE)
365:     theAE.SetCellSize cstype, csAE
'    resetAE = True
''  end
'
'  ' STORE CURRENT SELECTION OF THEME
'  '------------------------------------------
'  'themeVTab = theTheme.GetVTab
'  themeVTab = av.Run("gSDI.GetVTab",{theTheme})
        Dim themeVTab As ITable
374:     Set themeVTab = theTheme
'  If (themeVTab = nil) Then
'    return Nil
'  End
'  themeBM = themeVTab.GetSelection
'  themeBM.ClearAll
'
'  ' GET THE USERS' QUERIES, COMBINE AND USE TO EXTRACT THE POLYGON SETS
'  '------------------------------------------
'  query1 = extDiag.findByName("lbt_Q1").getObjectTag
    Dim query1 As String
385:     query1 = gExt.lbt_Q1.Tag
'  If (query1 = nil) Then
    If query1 = "" Then Exit Sub
'    return Nil
'  End
'  query2 = extDiag.findByName("lbt_Q2").getObjectTag
    Dim query2 As String
392:     query2 = gExt.lbt_Q2.Tag
'  If (query2 = nil) Then
    If query2 = "" Then Exit Sub
'    return Nil
'  End
'  totQuery = ("(" + query1 + " OR " + query2 + ")")
        Dim totQuery As String
399:     totQuery = query1 & " OR " & query2
        'Dim qryFilt As IQueryFilter
401:     Set qryFilt = New QueryFilter
402:     qryFilt.whereclause = totQuery
'  subsetGRID = geoGRID.ExtractByAttributes(totQuery)
404:        Set dataSet = geoGRID
            Dim dispTbl As ITable
406:        Set dispTbl = geoGRID
            Dim selset As ISelectionSet
408:        Set selset = dispTbl.Select(qryFilt, esriSelectionTypeHybrid, esriSelectionOptionNormal, dataSet.Workspace)
'  If (subsetGRID.HasError) Then
'    MsgBox.Error("Error encountered when subsetting "+theTheme.GetName+" GRID.","Extracting Contacts")
'    theAE.SetCellSize(#ANALYSISENV_VALUE,cellSize)
'    If (curMask.Is(GTheme)) Then
'      theAE.SetMask (curMask)
'    End
'    return Nil
'  End
'
'  ' SET THE CELL SIZE TO HALF THE CURRENT SIZE
'  '------------------------------------------
'  theAE.SetCellSize(#ANALYSISENV_VALUE,(geoGRID.GetCellSize / 2))
        'Dim cellsize As Double
422:     cellsize = rasprops.MeanCellSize.X / 2
423:     theAE.SetCellSize esriRasterEnvValue, cellsize
'  theAE.Activate
'  aFilter = NbrHood.MakeIrregular({{0,1,0},{1,1,1},{0,1,0}})
' Create the RasterNeighborhoodOp object
Dim pNbrOp As INeighborhoodOp
428: Set pNbrOp = New RasterNeighborhoodOp
'>>>>> Set RasterAnalysis Environment
Dim pNbrOpRAE As IRasterAnalysisEnvironment
431: Set pNbrOpRAE = pNbrOp
432: pNbrOpRAE.SetCellSize esriRasterEnvValue, cellsize
433: pNbrOpRAE.SetExtent esriRasterEnvValue, extAE
434: Set pNbrOpRAE.mask = theAE.mask
435: Set pNbrOpRAE.OutWorkspace = SDMGlobals.SDMWorkspace
436: Set pNbrOpRAE.OutSpatialReference = theAE.OutSpatialReference
' Create the neighborhood object
Dim aFilter As IRasterNeighborhood
439: Set aFilter = New RasterNeighborhood
440: aFilter.SetRectangle 3#, 3#, esriUnitsCells
'  intGRID = subsetGRID.FocalStats(#GRID_STATYPE_VARIETY,aFilter,True)
Dim pTable As ITable
443: Set pTable = geoGRID
Dim pInputDataset As IRasterDescriptor
445: Set pInputDataset = New RasterDescriptor
446: pInputDataset.Create geoGRID.Raster, qryFilt, "Value"
Dim intGRID As IRaster
448: Set intGRID = pNbrOp.FocalStatistics(pInputDataset, esriGeoAnalysisStatsVariety, aFilter, False)
'  If (intGRID.HasError) Then
'    MsgBox.Error("Error encountered while filtering contacts.","Extracting Contacts")
'    If (curMask.Is(GTheme)) Then
'      theAE.SetMask (curMask)
'    End
'    theAE.SetCellSize(#ANALYSISENV_VALUE,cellSize)
'    theAE.Activate
'    return Nil
'  End
'  'intVTab = intGRID.GetVTab
'  intVTab = av.Run("gSDI.GetVTab",{intGrid})
'  If (intVTab = nil) Then
'    return Nil
'  End
'  qString = ("[Value] > 1")
'  ndGRID = intGRID.Test(qString)
'  If (ndGRID.HasError) Then
'    MsgBox.Error("Error encountered while filtering contacts.","Extracting Contacts")
'    If (curMask.Is(GTheme)) Then
'      theAE.SetMask (curMask)
'    End
'    theAE.SetCellSize(#ANALYSISENV_VALUE,cellSize)
'    theAE.Activate
'    return Nil
'  End
'  ndClass = Classification.Make(1, 1)
'Dim ndClass As INumberRemap
476: Set ndClass = New NumberRemap
477: ndClass.MapValueToNoData 1
478: ndClass.MapValue 2, 1

'  contGRID = ndGRID.ReclassByClassList("Value",{ndClass},True)
'Dim reclasOp As IReclassOp
482: Set reclasOp = New RasterReclassOp
483: Set reclasOpENV = reclasOp
484: RasterAEUtils.SetToSDMRAEnv reclasOpENV
485: Set reclasOpENV.OutWorkspace = SDMGlobals.SDMWorkspace
     Dim contGrid As IRaster
487: Set contGrid = reclasOp.ReclassByRemap(intGRID, ndClass, False)

     Dim rasBndColl As IRasterBandCollection
490: Set rasBndColl = contGrid
     Dim rasBnd As IRasterBand
492: Set rasBnd = rasBndColl.Item(0)
     Dim rasTbl As ITable
494: Set rasTbl = rasBnd
495: If rasTbl.RowCount(Nothing) = 0 Then
496:     MsgBox "No contacts found. Stopping", vbExclamation, "Extracting Contacts"
           Exit Sub
498: End If

'
'  If (contGRID.HasError) Then
'    MsgBox.Error("Error encountered making GRID of contacts.","Extracting Contacts")
'    If (curMask.Is(GTheme)) Then
'      theAE.SetMask (curMask)
'    End
'    theAE.SetCellSize(#ANALYSISENV_VALUE,cellSize)
'    theAE.Activate
'    return Nil
'  End
'  defname = fileName.GetCWD.MakeTmp("Ctact", "")
'  contGridName = SourceManager.PutDataSet(GRID, "Contacts Grid", defname, True)
512: pDir = WOETableUtils.getProjectDir
513: pName = theTheme.Name & "_Contacts"
514: contgridnamevar = FileDialog.GetSaveFileName("Contacts Filename", pDir, pName)
     If IsEmpty(contgridnamevar) Then Exit Sub
517: Set contGridname = New fileName
518: contGridname.path = CStr(contgridnamevar(1)) & "\" & CStr(contgridnamevar(0))
519: If contGridname.path = "" Then
        Exit Sub
521: End If
'  If (contGridName = nil) Then
'    If (curMask.Is(GTheme)) Then
'      theAE.SetMask (curMask)
'    End
'    theAE.SetCellSize(#ANALYSISENV_VALUE,cellSize
'    return nil
'  End
'  If (contGridName.GetBaseName.Count > 11) Then
'    contbName = contGridName.GetBaseName.Left(11)
'    contGridName = (contGridName.ReturnDir.AsString+contbName).AsFileName
'  End
'  contGRID.Rename (contGridName)
'  nber = contGridName.asString.Right(1)
'  contGTheme = GTheme.Make(contGRID)
         Dim rLayer As IRasterLayer
539:     Set rLayer = New RasterLayer
540:     rLayer.CreateFromRaster contGrid
541:     Set rLayer.SpatialReference = theAE.OutSpatialReference
'  contGTheme.SetName ("Contacts" + nber)
543:     rLayer.Name = FileDialog.GetBaseName(contGridname.path)
'  contLegend = contGTheme.GetLegend
'  contLegend.DisplayNoDataClass (True)
'  contSymbols = contLegend.GetSymbols
'  contSymbols.Get(contSymbols.Count - 1).GetColor.SetTransparent (True)
'  contLegend.DisplayNoDataClass (False)
    'Dim pUVRenderer As IRasterUniqueValueRenderer
'528:    Set pUVRenderer = UVSymbolizeRaster.ChangeRendererToUVRenderer(rLayer, "Value")
'    'Dim pSymb As IColorSymbol
'530:     Set pSymb = New ColorSymbol
'    'Dim pcolor As IRgbColor
'532:     Set pcolor = New RgbColor
'533:     pcolor.RGB = 0
'534:     pSymb.Color = pcolor
'535:     pUVRenderer.Symbol(0, 0) = pSymb
'  theView.AddTheme (contGTheme)
         Dim pApp As IApplication
560:     Set pApp = New AppRef
         Dim pMxDoc As IMxDocument
562:     Set pMxDoc = pApp.Document
         Dim pMap As IMap
564:     Set pMap = pMxDoc.FocusMap
565:     pMap.AddLayer rLayer
566: ProgressAnimation.Hide
'
'  themes = theView.GetThemes
'  For Each t In themes
'    If (t.Is(Ftheme)) Then
'      ShapeType = t.GetFTab.FindField("Shape").GetType
'      if ((shapetype = #FIELD_SHAPEPOINT) or (shapetype = #FIELD_SHAPEPOLY)) then
'        plIndx = themes.Find(t)
'      End
'    End
'  End
'
'
'  If (plIndx <> nil) Then
'    themes.Shuffle(contGTheme,(plIndx + 1))
'  End
'  ' RESTORE ANALYSIS ENVIRONMENT
'  '------------------------------------------
'  If (resetAE) Then
'    theAE.SetExtent(extType,extAE)
'    theAE.SetCellSize(csType,csAE)
'  '  theAE.SetMask(curMask)
'  End
'  If (curMask.Is(GTheme)) Then
'    theAE.SetMask (curMask)
'  End
'  theAE.Activate
'End
594: End If 'end of rasterlayer type
'extDiag.findByName("lbt_Q1").setObjectTag (nil)
596: gExt.lbt_Q1.Tag = Empty
'extDiag.findByName("lbt_Q2").setObjectTag (nil)
598: gExt.lbt_Q2.Tag = Empty
'extDiag.Close
'505: Unload gExt
'theView.InvalidateTOC (nil)
Dim theView As IActiveView
603: Set theView = SDMGlobals.SDMMap
604: theView.Refresh
  '
  ' Refresh the contents view.
  '
608: If pMxDoc Is Nothing Then Set pMxDoc = SDMGlobals.SDMDoc
Dim pContView As IContentsView
610: Set pContView = pMxDoc.CurrentContentsView
611: pContView.Refresh Null
612: MsgBox "done extracting contacts"
'<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
Exit Sub
ErrorHandler:
  HandleError True, c_sModuleFileName & " " & GetErrorLineNumberString(Erl), Err.Number, Err.Source, Err.Description, 4
End Sub
Public Function CreateShapefile(strFolder As String, strName As String) As IFeatureClass

620:   Const strShapeFieldName As String = "Shape"
  
  ' Open the folder to contain the shapefile as a workspace
  Dim pFWS As IFeatureWorkspace
  Dim pWorkspaceFactory As IWorkspaceFactory
625:   Set pWorkspaceFactory = New ShapefileWorkspaceFactory
626:   Set pFWS = pWorkspaceFactory.OpenFromFile(strFolder, 0)
  
  ' Set up a simple fields collection
  Dim pfields As esrigeodatabase.IFields
  Dim pFieldsEdit As esrigeodatabase.IFieldsEdit
631:   Set pfields = New esrigeodatabase.Fields
632:   Set pFieldsEdit = pfields
  
  Dim pField As IField
  Dim pFieldEdit As IFieldEdit
  
  ' Make the shape field
  ' it will need a geometry definition, with a spatial reference
639:   Set pField = New esrigeodatabase.Field
640:   Set pFieldEdit = pField
641:   pFieldEdit.Name = strShapeFieldName
642:   pFieldEdit.Type = esriFieldTypeGeometry
  
  Dim pGeomDef As IGeometryDef
  Dim pGeomDefEdit As IGeometryDefEdit
646:   Set pGeomDef = New GeometryDef
647:   Set pGeomDefEdit = pGeomDef
648:   With pGeomDefEdit
649:     .GeometryType = esriGeometryPolygon
650:     Set .SpatialReference = New UnknownCoordinateSystem
651:   End With
652:   Set pFieldEdit.GeometryDef = pGeomDef
653:   pFieldsEdit.AddField pField

  ' Add another miscellaneous text field
656:   Set pField = New esrigeodatabase.Field
657:   Set pFieldEdit = pField
658:   With pFieldEdit
659:       .Length = 12
660:       .Name = "Area"
661:       .Type = esriFieldTypeDouble
662:   End With
663:   pFieldsEdit.AddField pField
  
  ' Create the shapefile
  ' (some parameters apply to geodatabase options and can be defaulted as Nothing)
  Dim pFeatClass As IFeatureClass
668:   Set pFeatClass = pFWS.CreateFeatureClass(strName, pfields, Nothing, _
                                           Nothing, esriFTSimple, strShapeFieldName, "")
670:   Set CreateShapefile = pFeatClass
End Function



