VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "gSDI_GetNewDocName"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = True
Option Explicit
Const c_sModuleFileName As String = "gSDI_GetNewDocName"
Const c_sDLLFileName As String = "CalculateLogisticRegr"       ' Constant reflect file module name
'Private ObjectTag As Object
'Property Set setObjectTag(anObject As Object)
'    Set ObjectTag = anObject
'End Property
'Property Get getObjectTag() As Object
'    Set getObjectTag = ObjectTag
'End Property

Function gSDI_GetNewDocNameLayer(Self As Variant) As String
  On Error GoTo ErrorHandler

'PUT THE IMPLEMENTATION HERE >>>>>>>>>>>>>
'' Name: gSDI.GetNewDocName
''
'' Topics:  Spatial Data Modeller
''
'' Description:  Checks theme names in active View
''               for name with same prefix as passed string,
''               plus appended integer.  Determines the
''               lowest available integer, and returns
''               new theme name
'' Requires:
''
'' Self:         0 - Prefix
''               1 - active view
''
'' Returns:      New theme name
''==============================================
'' Evaluate arguments
''----------------------------------------------
'strPrefix = Self.Get(0)
Dim strPrefix As String
36: strPrefix = Self(0)
'guiType = Self.Get(1)
Dim guiType As String
39:  guiType = Self(1)
'' Get length of name prefix
''----------------------------------------------
'cntP = strPrefix.Count
Dim cntP As Long
44: cntP = Len(strPrefix)
'' Check each theme name to see if it starts
'' with prefix; if it does, check remainder of
'' name and store if numeric
''----------------------------------------------
'lstDocs = av.GetProject.GetDocsWithGroupGUI(av.FindGUI(guiType))
'lstNmbs = List.Make
Dim lstNmbs As New SDMUtilities.SDMList
'For Each t In lstDocs
53: If SDMGlobals.SDMMap.LayerCount = 0 Then
54:     gSDI_GetNewDocNameLayer = ""
    Exit Function
56: End If
Dim lstDocs As IEnumLayer
58: Set lstDocs = SDMGlobals.SDMMap.layers
Dim t As ILayer
60: Set t = lstDocs.Next
61: While (Not t Is Nothing)
62:   If t.Valid Then
'  strT = t.GetName
        Dim strT As String
65:     strT = t.Name
'  If (strT.Left(cntP) = strPrefix) Then
67:     If Left(strT, cntP) = strPrefix Then
'    nmbSuffix = strT.Right(strT.Count - cntP)
            Dim nmbSuffix As String
70:         nmbSuffix = Right(strT, Len(strT) - cntP)
'    If (nmbSuffix.IsNumber) Then
72:         If IsNumeric(nmbSuffix) Then lstNmbs.Add CLng(nmbSuffix)
'      lstNmbs.Add (nmbSuffix.AsNumber)'
'    End
'  End
76:     End If
'End
78:   End If
79:   Set t = lstDocs.Next
80: Wend


'' Make new string name by appending
'' the first available integer to the prefix
'''----------------------------------------------
'i = 1
Dim i As Long
88: i = 1
'strName = ""
Dim strName As String
91: strName = ""
'If (strPrefix.Contains(" ")) Then
93: If InStr(strPrefix, " ") <> 0 Then
'  strPrefix = strPrefix + " "
95:     strPrefix = strPrefix & " "
'End
97: End If
'If (lstNmbs.IsEmpty.Not) Then
99: If Not lstNmbs.IsEmpty Then
'  lstNmbs.RemoveDuplicates
101:     Set lstNmbs = lstNmbs.RemoveDuplicates
'  lstNmbs.Sort (True)
103:     Set lstNmbs = lstNmbs.Sort(True)
'  For Each n In lstNmbs
    Dim n As Variant
106:     For Each n In lstNmbs.list
'    If (n = i) Then
108:         If n = i Then
'      i = i + 1
110:             i = i + 1
'    Else
112:         Else
'      Break
114:             Exit For
'    End
116:         End If
'  End
118:     Next n
'  If (strName = "") Then
120:     If strName = "" Then strName = strPrefix & i
'    strName = strPrefix + i.AsString
'  End
'Else
124: Else
'  strName = strPrefix + "1"
126:     strName = strPrefix & "1"
'End
128: End If
'return strName
130: gSDI_GetNewDocNameLayer = strName
'<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
Exit Function
ErrorHandler:
  HandleError True, c_sModuleFileName & " " & GetErrorLineNumberString(Erl), Err.Number, Err.Source, Err.Description, 4
135:     gSDI_GetNewDocNameLayer = ""
End Function
Function gSDI_GetNewDocNameTable(Self As Variant) As String
  On Error GoTo ErrorHandler
''==============================================
'' Evaluate arguments
''----------------------------------------------
'strPrefix = Self.Get(0)
Dim strPrefix As String
144: strPrefix = Self(0)
'guiType = Self.Get(1)
Dim guiType As String
147:  guiType = Self(1)
'' Get length of name prefix
''----------------------------------------------
'cntP = strPrefix.Count
Dim cntP As Long
152: cntP = Len(strPrefix)
'' Check each theme name to see if it starts
'' with prefix; if it does, check remainder of
'' name and store if numeric
''----------------------------------------------
'lstDocs = av.GetProject.GetDocsWithGroupGUI(av.FindGUI(guiType))
'lstNmbs = List.Make
Dim lstNmbs As New SDMUtilities.SDMList
'For Each t In lstDocs
Dim tblColl As IStandaloneTableCollection
162: Set tblColl = SDMGlobals.SDMMap
163: If tblColl.StandaloneTableCount = 0 Then
164:     gSDI_GetNewDocNameTable = ""
    Exit Function
166: End If
Dim nt As Long
168: For nt = 0 To tblColl.StandaloneTableCount - 1
    Dim t As IStandaloneTable
170:     Set t = tblColl.StandaloneTable(nt)
'  strT = t.GetName
        Dim strT As String
173:     strT = t.Name
'  If (strT.Left(cntP) = strPrefix) Then
175:     If Left(strT, cntP) = strPrefix Then
'    nmbSuffix = strT.Right(strT.Count - cntP)
            Dim nmbSuffix As String
178:         nmbSuffix = Right(strT, Len(strT) - cntP)
'    If (nmbSuffix.IsNumber) Then
180:         If IsNumeric(nmbSuffix) Then lstNmbs.Add CLng(nmbSuffix)
'      lstNmbs.Add (nmbSuffix.AsNumber)'
'    End
'  End
184:     End If
'End
186: Next nt


'' Make new string name by appending
'' the first available integer to the prefix
'''----------------------------------------------
'i = 1
Dim i As Long
194: i = 1
'strName = ""
Dim strName As String
197: strName = ""
'If (strPrefix.Contains(" ")) Then
199: If InStr(strPrefix, " ") <> 0 Then
'  strPrefix = strPrefix + " "
201:     strPrefix = strPrefix & " "
'End
203: End If
'If (lstNmbs.IsEmpty.Not) Then
205: If Not lstNmbs.IsEmpty Then
'  lstNmbs.RemoveDuplicates
207:     Set lstNmbs = lstNmbs.RemoveDuplicates
'  lstNmbs.Sort (True)
209:     Set lstNmbs = lstNmbs.Sort(True)
'  For Each n In lstNmbs
    Dim n As Variant
212:     For Each n In lstNmbs.list
'    If (n = i) Then
214:         If n = i Then
'      i = i + 1
216:             i = i + 1
'    Else
218:         Else
'      Break
220:             Exit For
'    End
222:         End If
'  End
224:     Next n
'  If (strName = "") Then
226:     If strName = "" Then strName = strPrefix & i
'    strName = strPrefix + i.AsString
'  End
'Else
230: Else
'  strName = strPrefix + "1"
232:     strName = strPrefix & "1"
'End
234: End If
'return strName
236: gSDI_GetNewDocNameTable = strName
'<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
Exit Function
ErrorHandler:
  HandleError True, c_sModuleFileName & " " & GetErrorLineNumberString(Erl), Err.Number, Err.Source, Err.Description, 4
241:   gSDI_GetNewDocNameTable = ""
End Function

