VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "gSDI_GetRespFields"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = True
Option Explicit
Option Compare Text

Const c_sModuleFileName As String = "gSDI_GetRespFields"
Const c_sDLLFileName As String = "CalculateResponse"       ' Constant reflect file module name
'Private ObjectTag As Object
'Property Set setObjectTag(anObject As Object)
'    Set ObjectTag = anObject
'End Property
'Property Get getObjectTag() As Object
'    Set getObjectTag = ObjectTag
'End Property

Function gSDI_GetResponseFields(Self As Variant) As SDMUtilities.SDMList
  On Error GoTo ErrorHandler

'PUT THE IMPLEMENTATION HERE >>>>>>>>>>>>>
'' Topics:  Spatial Data Modeller
''
'' Description:  Looks for fields with a set list of
''            names (as created in SDI), and returns
''            a corresponding list of fields.
''
'' Requires:
''
'' Self:      0 -- ucGridTheme -- a unique conditions grid theme
''
'' Returns:   List of response fields, or Nil if none found
''==============================================
'
'' Get unique conditions theme and its attribute table
'
''------------------------------------------
'
'ucGridTheme = Self.Get(0)
    Dim pLayer As IRasterLayer
37: Set pLayer = Self(0)
38: If pLayer Is Nothing Then
39:     Set gSDI_GetResponseFields = Nothing
        Exit Function
41: End If
'theVTab = av.Run("gSDI.GetVTab",{ucGridTheme})
    Dim theVtab As ITable
    Dim dispTbl As IDisplayTable
58: Set dispTbl = pLayer
59: Set theVtab = dispTbl.DisplayTable
'If (theVTab = Nil) Then
'  return Nil
'End
'' MAKE LIST OF RESPONSE FIELDS
''------------------------------------------
'ucFldList = {"Post_Prob","PstPrbNrm","Post_Logit","Sum_Weight","Uncertaint","Msng_Data","Tot_Uncrty","LRPostProb","LRTValue","LR_Std_Dev","RBFLNMmshp","FzzyClstr"}
    Dim ucFldList2 As New SDMUtilities.SDMList
67: ucFldList2.AddArray Array("*Post_Prob", "*Post_Logit", "*Sum_Wts", "*Uncrty", "*Msng_Data", "*Tot_Uncrty")
68: ucFldList2.AddArray Array("*LRPostProb", "*LR_Std_Dev", "*LRTValue")
69: ucFldList2.AddArray Array("*RBFLN*", "*FzzyClstr", "*PAT*", "*PNN")
'i = 1
'''    Dim i As Long
'''53: i = 1
''''strFldP = theVTab.FindField("Pat" + i.AsString)
'''    Dim strFldP As Long
'''56: strFldP = theVTab.FindField("Pat" & CStr(i))
''''While (strFldP <> Nil)
'''58: While strFldP <> -1
''''  ucFldList.Add (strFldP.GetAlias)
'''60:     ucFldList.Add theVTab.Fields.Field(strFldP).AliasName
''''  i = i + 1
'''62:     i = i + 1
''''  strFldP = theVTab.FindField("Pat" + i.AsString)
'''64:     strFldP = theVTab.FindField("Pat" & CStr(i))
''''End
'''66: Wend
'ucFldListToo = ucFldList.Clone
    Dim ucFldList As New SDMUtilities.SDMList
'' Check which fields are acutally found in the
'' the attribute table and update a copy of the list
''------------------------------------------
    Dim fldNames As SDMUtilities.SDMList
92: Set fldNames = WOETableUtils.getFieldsNamesByType(theVtab, esriFieldTypeDouble)
93: fldNames.merge WOETableUtils.getFieldsNamesByType(theVtab, esriFieldTypeInteger)
'For Each fldName In ucFldListToo
    Dim fldName As Variant
96: For Each fldName In ucFldList2.list
'  aField = theVTab.FindField(fldName)
        Dim actualFldName As Variant
99:     For Each actualFldName In fldNames.list
100:         If CStr(actualFldName) Like CStr(fldName) Then
101:             ucFldList.Add actualFldName
102:             Exit For
103:         End If
104:     Next actualFldName
'  If (aField = Nil) Then
'    ucFldList.RemoveObj (fldName)
'  Else
'    ucFldList.Set(ucFldList.FindByValue(fldName),aField.GetAlias)
'  End
'End
111: Next fldName
'' CHECK FOR FIELD NAMES, DROPPING ANY THAT AREN'T THERE
''------------------------------------------
'ucFieldName = ucGridTheme.GetLegend.GetFieldNames.Get(0)
'If (ucFieldName <> Nil) Then
'  fldIndx = ucFldList.FindByValue(ucFieldName)
'  If (fldIndx <> -1) Then
'    ucFldList.Remove (fldIndx)
'  End
'End
'
'' QUIT IF NO FIELDS FOUND, OR RETURN THE LIST
''------------------------------------------
'If (ucFldList.IsEmpty) Then
125: If ucFldList.IsEmpty Then
'  'MsgBox.Error("No response fields found.","Symbolizing Response Theme")
'  return Nil
128:     Set gSDI_GetResponseFields = Nothing
'Else
130: Else
'  return ucFldList     'gSDI.GetResponseFields
132:     Set gSDI_GetResponseFields = ucFldList
'End
134: End If
'<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
Exit Function
ErrorHandler:
  HandleError True, c_sModuleFileName & " " & GetErrorLineNumberString(Erl), Err.Number, Err.Source, Err.Description, 4
End Function
