VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "gSDI_GetTotalPoints"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = True
Option Explicit
Const c_sModuleFileName As String = "gSDI_GetTotalPoints"
Const c_sDLLFileName As String = "CalculateResponse"       ' Constant reflect file module name
'Private ObjectTag As Object
'Property Set setObjectTag(anObject As Object)
'    Set ObjectTag = anObject
'End Property
'Property Get getObjectTag() As Object
'    Set getObjectTag = ObjectTag
'End Property

Function gSDI_GetTotalPoints(Self As Variant) As Long
  On Error GoTo ErrorHandler
'PUT THE IMPLEMENTATION HERE >>>>>>>>>>>>>
'' gSDI.GetTotalPoints
'Gets total points of training set within study area
'vTabTP = Self.Get(0)
    Dim thmTP As IFeatureLayer
19: Set thmTP = Self(0)
    Dim vTabTP As ITable
21: Set vTabTP = thmTP
'grdSA = Self.Get(1)
    Dim grdSA As IRasterLayer
24: Set grdSA = Self(1) 'This the clipped version of Study Area theme

    Dim ae As IRasterAnalysisEnvironment
27: Set ae = SDMGlobals.SDMRAEnvironment
28: Set ae.Mask = RasterUtils.GetDatasetRaster(grdSA)
29: ae.SetExtent esriRasterEnvValue, RasterUtils.GetDatasetRaster(grdSA)
30: ae.SetCellSize esriRasterEnvMinOf
31: ae.SetAsNewDefaultEnvironment
    Dim ext As IEnvelope
33: ae.GetExtent esriRasterEnvValue, ext

'If (grdSA.Is(GTheme)) Then
'  grdSA = grdSA.GetGrid
'End
'viewActive = Self.Get(2)
    Dim viewActive As IMap
40: Set viewActive = Self(2)
'prjCrnt = viewActive.GetProjection
'fldS = vTabTP.FindField("Shape")
    Dim fldS As IFields
44: Set fldS = vTabTP.Fields
'nmbNull = Number.MakeNull
'sumPnts = 0
    Dim sumPnts As Long
48: sumPnts = 0
'Must get selected training points only
Dim pFeatureSelection As IFeatureSelection
51: Set pFeatureSelection = thmTP 'QI
Dim pSelectionSet As ISelectionSet
53: Set pSelectionSet = pFeatureSelection.SelectionSet
54: If pSelectionSet.Count = 0 Then
55:     Set pSelectionSet = Me.SelectByLocation(thmTP, grdSA)
56: Else
57:     gSDI_GetTotalPoints = pSelectionSet.Count
        Exit Function
59: End If
'MsgBox "Selection Count = " & pSelectionSet.Count, , c_sModuleFileName
    Dim featIDs As IEnumIDs
62: Set featIDs = pSelectionSet.IDs
63: featIDs.Reset
    Dim featID As Long
65: featID = featIDs.Next
'For Each r In vTabTP
    Dim rasprops As IRasterProps
68: Set rasprops = RasterUtils.GetDatasetRaster(grdSA)
    Dim rasBuf As IRasterBuffer
70:     Set rasBuf = New IRasterBuffer
71:     If Not rasBuf.OpenBuffer(grdSA) Then
72:         gSDI_GetTotalPoints = -1
        Exit Function
74:     End If
    Dim progBar As IStepProgressor
76:     Set progBar = SDMGlobals.SDMStatusBar.ProgressBar
    Dim featSel As IFeatureSelection
78:     Set featSel = thmTP
    
80:     progBar.Position = 0
81:     SDMGlobals.SDMStatusBar.ShowProgressBar "Getting total points...", 1, featSel.SelectionSet.Count, 1, True
82: While featID > -1
        Dim pFeature As IFeature
84:     Set pFeature = thmTP.FeatureClass.GetFeature(featID)
'  pnt = vTabTP.ReturnValue(fldS, r)
        Dim pnt As IPoint
87:     Set pnt = pFeature.Shape
'  If (pnt.Is(Point)) Then
'    nmb = grdSA.CellValue(pnt, prjCrnt)
        Dim nmb As Variant
91:     nmb = rasBuf.CellValue(pnt)
'    If (nmb <> nmbNull) Then
93:     If (Not IsNull(nmb)) Then
94:         If (CStr(nmb) <> "NoData") Then
'      sumPnts = sumPnts + 1
96:             sumPnts = sumPnts + 1
97:         End If
'    End
99:     End If
'  End
'End
        Dim n As Long
103:         n = n + 1
104:     featID = featIDs.Next
105:     SDMGlobals.SDMStatusBar.StepProgressBar
106: Wend
107: SDMGlobals.SDMStatusBar.HideProgressBar
108: gSDI_GetTotalPoints = sumPnts
'<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
Exit Function
ErrorHandler:
  HandleError True, c_sModuleFileName & " " & GetErrorLineNumberString(Erl), Err.Number, Err.Source, Err.Description, 4
End Function

Function SelectByLocation(ByRef pLayer As IFeatureLayer, ByRef rLayer As IRasterLayer) As ISelectionSet
     Dim rasprops As IRasterProps
117:     Set rasprops = RasterUtils.GetDatasetRaster(rLayer)
     Dim pGeometry As IEnvelope
119:     Set pGeometry = rasprops.Extent
     Dim pSpatialFilter As ISpatialFilter
121:     Set pSpatialFilter = New SpatialFilter
122:     With pSpatialFilter
123:         Set .Geometry = pGeometry
124:         .GeometryField = pLayer.FeatureClass.shapeFieldName
125:         .SpatialRel = esriSpatialRelContains
126:     End With
    
     Dim pfeatSel As IFeatureSelection
129:     Set pfeatSel = pLayer
130:     pfeatSel.SelectFeatures pSpatialFilter, esriSelectionResultNew, False
131:     Set SelectByLocation = pfeatSel.SelectionSet
End Function
