VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "gSDI_GetVTab"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = True
Option Explicit
' Variables used by the Error handler function - DO NOT REMOVE
Const c_sModuleFileName As String = "gSDI_GetVTab"       ' Constant reflect file module name
Const c_sDLLFileName As String = "AnalysisParameters"       ' Constant reflect file module name
'Private ObjectTag As Object
'Property Set setObjectTag(anObject As Object)
'    Set ObjectTag = anObject
'End Property
'Property Get getObjectTag() As Object
'    Set getObjectTag = ObjectTag
'End Property

Function gSDI_GetVTab(ByRef Self As ILayer) As ITable

On Error GoTo ErrorHandler

'PUT THE IMPLEMENTATION HERE >>>>>>>>>>>>>
'Function gSDI_GetVTab() As Variant
'
'Dim built As Boolean
Dim built As Boolean
'Dim self As Collection
'
'Dim theGrid As New IAVGTheme
Dim theGrid As IRaster
'Dim theTheme As New IAVGTheme
Dim theGTheme As IRasterLayer
Dim theFTheme As IFeatureLayer
'Dim theVTab As New IAVVTab
Dim theVtab As ITable

'' Name:  gSDI.GetVTab
''
''Topics:  Weighs of Evidence; Grid Themes
''
''Description:  Verifies whether an integer grid theme
''  has an attribute table.  If not, attempts to build
''  one and checks again.
''
''Requires:
''
'' Self:  List containing the integer grid theme
''
''Returns:  The Grid themes VTab (Nil if no VTab)
''==============================================

'theTheme = self.Get(0)
    Dim aLayer As ILayer
49: Set aLayer = Self
50: If aLayer Is Nothing Then
51:     Set gSDI_GetVTab = Nothing
        Exit Function
53: End If
''grid theme or grid itself
'
56: If Not aLayer.Valid Then
57:     Set gSDI_GetVTab = Nothing
        Exit Function
59: End If

61: If (TypeOf aLayer Is IRasterLayer Or TypeOf aLayer Is Raster) Then
        Dim raslayer As IRasterLayer
63:     Set raslayer = aLayer
'theVTab = theTheme.GetVTab
'''65:     Set theGTheme = aLayer
'''        Dim pRasterCol As IRasterBandCollection
'''67:     Set pRasterCol = theGTheme.Raster
'''        Dim pBand As IRasterBand
'''69:     Set pBand = pRasterCol.item(0)
70:     Set theVtab = RasterUtils.GetTable(raslayer)
71: Else
'72:     MsgBox "Layer is not of raster or rasterlayer: " & aLayer.Name, vbCritical, c_sModuleFileName
73:     Set gSDI_GetVTab = Nothing
        Exit Function
75: End If 'rasterlayer of raster

'If (theVTab = Null) Then
78: If theVtab Is Nothing Then
'79:     MsgBox "Raster does not have an attribute table: " & raslayer.Name, vbCritical, c_sModuleFileName
80:     Set gSDI_GetVTab = Nothing
        Exit Function
'If (TypeOf theTheme Is IAVGrid) Then
'theGrid = theTheme
'Else
'theGrid = theTheme.GetGrid
'End If
'built = theGrid.BuildVAT
'If (Not built) Then
'MsgBox.Error("An attribute table for grid, "+theTheme.GetName+", could"+NL+"could not be found or built.","Extracting Study Area")
'Let gSDI_GetVTab = Null
'Else
'theVTab = theTheme.GetVTab
'If (theVTab = Null) Then
'MsgBox.Error("An attribute table for grid, "+theTheme.GetName+", could"+NL+"could not be found or built.","Extracting Study Area")
'Let gSDI_GetVTab = Null
'End If
'End If
'End If
99: End If 'VTab = Nothing
'Let gSDI_GetVTab = theVTab
101: Set gSDI_GetVTab = theVtab
'End Function
'
'<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
Exit Function

ErrorHandler:
  HandleError True, c_sDLLFileName & " " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), Err.Number, Err.Source, Err.Description, 4
109:     Set gSDI_GetVTab = Nothing
End Function

