VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "gSDI_L2P"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = True
Option Explicit
Const c_sModuleFileName As String = "gSDI_L2P.cls"
Const c_sDLLFileName As String = "CalculateResponse"       ' Constant reflect file module name
'Private ObjectTag As Object
'Property Set setObjectTag(anObject As Object)
'    Set ObjectTag = anObject
'End Property
'Property Get getObjectTag() As Object
'    Set getObjectTag = ObjectTag
'End Property

Function gSDI_L2P(logit As Double) As Double
  On Error GoTo ErrorHandler

'PUT THE IMPLEMENTATION HERE >>>>>>>>>>>>>
'' Name:  gSDI.L2
''
''Topics:  Spatial Data Modeller
''
''Description:  Converts a logit to a probability
''
''Requires:
'
'' Self:  List from calling script containing logit
''
''Returns:  postP (posterior probability)
''==============================================
'
'logit = self.Get(0)
'odds = (Number.GetEuler) ^ logit
Dim odds As Double
32: odds = Exp(logit)
'postP = odds / (1 + odds)
Dim postP As Double
35: postP = odds / (1 + odds)
'return postP
37: gSDI_L2P = postP
'<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
Exit Function
ErrorHandler:
  HandleError True, c_sModuleFileName & " " & GetErrorLineNumberString(Erl), Err.Number, Err.Source, Err.Description, 4
42:   gSDI_L2P = Null
End Function
