VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "gSDI_ListSetup"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = True
Option Explicit
Option Compare Text

Private anlParms As AnalysisParameters.AnlParams
Private gParam As Variant

Const c_sModuleFileName As String = "gSDI_ListSetup.cls"
Const c_sDLLFileName As String = "CalculateNeuralNetwork"       ' Constant reflect file module name
'Private ObjectTag As Object
'Property Set setObjectTag(anObject As Object)
'    Set ObjectTag = anObject
'End Property
'Property Get getObjectTag() As Object
'    Set getObjectTag = ObjectTag
'End Property

Public Sub gSDI_ListSetup(Self As ICommand)
  On Error GoTo ErrorHandler
'17: If gL.isShiftdown Then
'        Dim prfx As String
'19:     prfx = Left(Self.Caption, 5)
'20:     If prfx = "Check" Then
'            Dim docURL As String
'22:         docURL = "sdmci.htm"
'23:     ElseIf prfx = "Calcu" Then
'24:         docURL = "sdmrspns.htm"
'25:     ElseIf prfx = "Gener" Then
'26:         docURL = "sdmnn3.htm#Input Files"
'27:     Else
'28:         docURL = ""
'29:     End If
'30:     If docURL <> "" Then SDMGlobals.SDMHelp.gSDI_Help docURL
'        Exit Sub
'31: End If

'PUT THE IMPLEMENTATION HERE >>>>>>>>>>>>>
'SET THE WORKING DIRECTORY TO THE PROJECT'S HOME DIRECTORY
'DLS: working directory should already be set
'GET THE LIST AND CMB (FIELD) DIALOG BOXES
40: If Left(Self.Caption, 5) = "Check" Then
    'SET DIALOG TITLES
42:     gL.Caption = "Inputs to Conditional Independence Test - Themes"
43:     gCmb.Caption = "Inputs to Conditional Independence Test - Classes"
'FIND THE WEIGHTS/CI BUTTON...SET CLICK SCRIPT, LABEL AND MAKE VISIBLE
'set gl.lbt_Wt.setClick = gsdi.makeCITab
        Dim ClickVal As Variant
47:     ClickVal = "gSDI_MakeCITab"
48:     Set gL.lbt_Wt_SetClik = ClickVal
49:     gL.lbt_Wt.Caption = "Conditional" & vbCrLf & "Independence"
50:     gL.lbt_Wt.ToolTipText = "Check Conditional Independence"
51:     gL.lbt_Wt.Visible = True
'SET "EXPERT" BUTTON INVISIBLE
53:     gL.lbt_Exp.Visible = False
    
        Dim gSDICI As gSDI_CI
56:     Set gSDICI = New gSDI_CI
57:     gSDICI.gSDI_CI
58:     Set gSDICI = Nothing
    
'>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>
61: ElseIf Left(Self.Caption, 5) = "Calcu" Then
    'SET DIALOG TITLES
        Dim lstChkBx As SDMUtilities.SDMList
64:     Set lstChkBx = returnCheckBoxes(gParam)
        Dim i As Variant
        Dim strTtl As String
67:     strTtl = ""
68:     For Each i In lstChkBx.list
            Dim C As CheckBox
70:         Set C = i
71:         If InStr(C.Name, "NN") > 0 Or C.Name = "chkFL" Then
72:             GoTo NextC
73:         ElseIf C.Value = 1 Then
74:             If InStr(C.Name, "LR") > 0 Then
75:                 strTtl = strTtl & C.Tag & ", "
76:             ElseIf InStr(C.Name, "WofE") > 0 Then
77:                 strTtl = strTtl & C.Tag & ", "
78:             End If
79:         End If
NextC:
81:     Next i
82:     strTtl = Trim(strTtl)
83:     If (Right(strTtl, 1) = ",") Then strTtl = Left(strTtl, Len(strTtl) - 1)
84:     gL.Caption = "Inputs to " & strTtl & " - Themes"
85:     gCmb.Caption = "Inputs to " & strTtl & " - Classes"
    'FIND THE "EXPERT" BUTTON AND THE WEIGHTS/CI BUTTON...
    'theBtn = gL.lbt_Wt
    'IF USER HAS SPECIFIED WEIGHTS ONLY,
    'MAKE THE WEIGHTS/CI BUTTON INVISIBLE
    '
    'OTHERWISE MAKE IT VISIBLE, SET CLICK SCRIPT AND LABEL
92:     gL.lbt_Wt.Visible = True
93:     ClickVal = "gL_BtnClc_Click"
94:     Set gL.lbt_Wt_SetClik = ClickVal
95:     gL.lbt_Wt.Caption = "Calculate" & vbCrLf & "Responses..."
96:     gL.lbt_Wt.ToolTipText = "Calculate weights from selected tables and save to new table"
    'MAKE THE EXPERT BUTTON INVISIBLE
98:     gL.lbt_Exp.Visible = False
    
        Dim gLRun As gL_Run
101:     Set gLRun = New gL_Run
102:     gLRun.gL_Run
103:     Set gLRun = Nothing
104: ElseIf Left(Self.Caption, 5) = "Gener" Or Left(Self.Caption, 5) = "Run N" Then
'Check for Non-deposits themes
         Dim gPcbxNTP As ComboBox
107:     Set gPcbxNTP = gParam.cbxNTP
108:     If Not gPcbxNTP.Enabled Or gPcbxNTP.ListCount = 0 Then
109:        MsgBox "No non-deposit themes selected.", vbCritical, c_sModuleFileName
            Exit Sub
111:     End If
    'SET DIALOG TITLES
113:     gL.Caption = "Inputs to Neural Network - Themes"
114:     gCmb.Caption = "Inputs to Neural Network - Classes"
    
    'FIND THE "EXPERT" BUTTON AND THE WEIGHTS/CI BUTTON...
    'theBtn = gL.lbt_Wt
    'IF USER HAS SPECIFIED WEIGHTS ONLY,
    'MAKE THE WEIGHTS/CI BUTTON INVISIBLE
    '
    'OTHERWISE MAKE IT VISIBLE, SET CLICK SCRIPT AND LABEL
122:     gL.lbt_Wt.Visible = True
123:     ClickVal = "gL_BtnClc_Click"
124:     Set gL.lbt_Wt_SetClik = ClickVal
125:     If Left(Self.Caption, 5) = "Gener" Then
126:         gL.lbt_Wt.Caption = "Generate" & vbCrLf & "Input Files..."
127:         gL.lbt_Wt.ToolTipText = "Generate Input Files for Neural Network module"
128:     Else
129:         gL.lbt_Wt.Caption = "Run Neural" & vbCrLf & "Network Module..."
130:         gL.lbt_Wt.ToolTipText = "Run Neural Network module on input files"
131:     End If
    'MAKE THE EXPERT BUTTON INVISIBLE
133:     gL.lbt_Exp.Visible = False
134:     Set gLRun = New gL_Run
135:     gLRun.gL_Run
136:     Set gLRun = Nothing

'<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
'Added code to allow Neural Network calculation from existing SDMUC layer (8/2005)
'<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
141: ElseIf Self.Caption Like "Neural Network*" Then
142:     NNRetrain.Show vbModal
143:     If NNRetrain.cbx_UCs.Text = "<None>" Then
144:         MsgBox "No Unique Conditions layers with associated SDMUCnn_Tables.", vbExclamation, "Neural Network"
145:     End If
146:     If Not NNRetrain.Continue Then
147:        MsgBox "Cancelling Neural Network retraining!", vbExclamation, "Neural Network"
148:        Unload NNRetrain
            Exit Sub
150:     End If
         Dim respTheme As String
152:     respTheme = NNRetrain.cbx_UCs.Text
         Dim ucTheme As IRasterLayer
154:     Set ucTheme = WOETableUtils.FindLayerByName(respTheme)
155:     If WOETableUtils.hasJoins(ucTheme) Then WOETableUtils.UnJoinAll ucTheme
         Dim joinTable As ITable
157:     Set joinTable = WOETableUtils.FindStandAloneTableByName(ucTheme.Name & "_Tbl").Table
'lstLists = gL.findByName("lbt_Nw").getObjectTag
'lstFlds = lstLists.Get(0)
         Dim lstFlds As SDMUtilities.SDMList
161:     Set lstFlds = WOETableUtils.getFieldsNames(joinTable)
'lstMD = lstLists.Get(1)
         Dim lyrRastListNames As New SDMUtilities.SDMList 'List of evidence raster names
164:     Set lyrRastListNames = GetLayerNamesForTempNames(ucTheme)
165:          If lyrRastListNames Is Nothing Then
166:             MsgBox "No Evidence Layer Names for Temp UC rasters", , c_sModuleFileName
            Exit Sub
168:          End If
169:          MsgBox "Layer Names" & vbCrLf & ListtoString(lyrRastListNames), , c_sModuleFileName
170:     If SDMGlobals.SDMdataMD Is Nothing Then _
             Set SDMGlobals.SDMdataMD = New SDMUtilities.SDMDictionary
         Dim readMsgData As gSDI_ReadMissingData
173:     Set readMsgData = New gSDI_ReadMissingData
174:     readMsgData.gSDI_ReadMissingData
         Dim lstMD As New SDMUtilities.SDMList
         Dim lyrName
177:        For Each lyrName In lyrRastListNames.list
178:             If SDMGlobals.SDMdataMD.Exists(lyrName) Then lstMD.Add SDMGlobals.SDMdataMD.Gett(lyrName)
179:        Next lyrName
180:        If lstMD.IsEmpty Then
181:            MsgBox "No missing data values found for layers: " & vbCrLf & lyrRastListNames.asString, vbExclamation, "Neural Network"
            Exit Sub
183:        End If
         'Get evidence grid name from names in WOE table.
         Dim tmpRastListNames As SDMUtilities.SDMList 'List of temp raster names for evidence layers
186:     Set tmpRastListNames = GetTempNamesForLayerNames(ucTheme)

         'This Option may be called from a fresh start of ArcSDM3 and not only after
         'CalcResponse has been called for Neural Networks. So some attributes must become viable
         'gl.RasterSrcDict might be empty
         
192:     If gL.RasterSrcDict.Count < 1 Then
             Dim nNam As Long
194:         nNam = 0
             Dim lyrnam As Variant
196:         For Each lyrnam In lyrRastListNames.list
197:             gL.RasterSrcDict.Add tmpRastListNames.GetVal(nNam), lyrnam
198:             nNam = nNam + 1
199:         Next lyrnam
200:     End If
'added = av.Run("gSDI.Add2UCTab",{thmUC,vTabTP,curPrj})
         Dim TPName As String
203:     TPName = NNRetrain.cbx_dtp.Text
         Dim thmTP As IFeatureLayer
205:     Set thmTP = WOETableUtils.FindLayerByName(TPName)
206:     If thmTP Is Nothing Then
207:         MsgBox "Deposit training points layer not found.", vbExclamation, "Neural Network"
             Exit Sub
209:     End If
         Dim NDTPName As String
211:     NDTPName = NNRetrain.cbx_ndtp.Text
         Dim thmNDTP As IFeatureLayer
213:     Set thmNDTP = WOETableUtils.FindLayerByName(NDTPName)
214:     If thmNDTP Is Nothing Then
215:         MsgBox "Non-deposit training points layer not found.", vbExclamation, "Neural Network"
             Exit Sub
217:     End If
'''211: MsgBox "TP=" & TPName & ", NDTP=" & NDTPName, vbInformation, "Neural Network"
         Dim gSDIAdd2UCTab As gSDI_Add2UCTab
220:     Set gSDIAdd2UCTab = New gSDI_Add2UCTab
         Dim newJoinTable As ITable
222:     Set newJoinTable = gSDIAdd2UCTab.gSDI_Add2UCTab(Array(ucTheme, thmTP, Nothing))
'if (added.Is(String)) then
224:     If newJoinTable Is Nothing Then
'  MsgBox.Error(added,"Error appending to grid attribute table.")
226:         MsgBox "Error creating Unique Conditions Join table.", vbCritical, c_sModuleFileName
'  return Nil
             Exit Sub
'End
230:     End If
         'Fuzzy values may not be set
232:     If NNRetrain.cbx_DTPFlds.Text = "<None>" Then
233:         gL.FMTPfield = Array(Nothing, -1)
234:     Else
235:         gL.FMTPfield = Array(thmTP, thmTP.FeatureClass.Fields.Field(thmTP.FeatureClass.FindField(NNRetrain.cbx_DTPFlds.Text)))
236:     End If
237:     If NNRetrain.cbx_NDTPFlds.Text = "<None>" Then
238:        gL.FMNTPfield = Array(Nothing, -1)
239:     Else
240:        gL.FMNTPfield = Array(thmNDTP, thmNDTP.FeatureClass.Fields.Field(thmNDTP.FeatureClass.FindField(NNRetrain.cbx_NDTPFlds.Text)))
241:     End If
'lstClp = {}
'result = av.Run("gSDI.CalcWithUC",{thmUC,lstMD,lstFlds,viewActive,tchFlag,expert})
         'Get evidence grid name from names in WOE table.
         Dim gSDICalcWithUC As gSDI_CalcWithUC
246:     Set gSDICalcWithUC = New gSDI_CalcWithUC
         Dim result As SDMUtilities.SDMList
248:     Set result = gSDICalcWithUC.gSDI_CalcWithUC(Array(ucTheme, lstMD, lstFlds, SDMGlobals.SDMMap, "NN", False, newJoinTable, tmpRastListNames, TPName, NDTPName))
249:     Set gSDICalcWithUC = Nothing
250: End If
     Exit Sub
'<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
ErrorHandler:
  HandleError True, c_sModuleFileName & " " & GetErrorLineNumberString(Erl), Err.Number, Err.Source, Err.Description, 4
End Sub

Private Sub Class_Initialize()
  On Error GoTo ErrorHandler

260:     Set anlParms = New AnalysisParameters.AnlParams
261:     Set gParam = anlParms.gParamfrm

  Exit Sub
ErrorHandler:
  HandleError True, "Class_Initialize " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), Err.Number, Err.Source, Err.Description, 4
End Sub

Private Function returnCheckBoxes(frm As Variant) As SDMUtilities.SDMList
  On Error GoTo ErrorHandler

271:     Set returnCheckBoxes = New SDMUtilities.SDMList
         Dim ctl As Control
273:     For Each ctl In frm.Controls
274:         If TypeOf ctl Is CheckBox Then returnCheckBoxes.Add ctl
275:     Next ctl

     Exit Function
ErrorHandler:
  HandleError False, "returnCheckBoxes " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), Err.Number, Err.Source, Err.Description, 4
End Function


