VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "gSDI_MakeTempDir"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = True
Option Explicit
Public Function gSDI_MakeTempDir(ByRef argArray As Variant) As String
'' Name:  gSDI.MakeTempDir
''
'' Topics:  Spatial Data Modeller
''
'' Description:  Creates a directory named ~sdmtemp for
''      writing temporary files in the background
''      Located in the project directory
''
'' Requires:
''
'' Self:  0 -- project directory in which new directory
''             is to be created
''
'' Returns:  dirNewName -- full pathname of new directory (string)
''==============================================
'dirTmp = self.Get(0)
Dim dirTmp As String
20: dirTmp = argArray(0)
'chrSep = av.Run("gSDI.GetSeparatorChar",{})
Dim getSepChar As SDMUtilities.gSDI_GetSepChar
23: Set getSepChar = New SDMUtilities.gSDI_GetSepChar
Dim chrSep As String
25: chrSep = getSepChar.gSDI_GetSeparatorChar
'os = System.GetOS
'if (os = #SYSTEM_OS_MSW) then
'  ' If is windows operating system, make DLL procedure
'  ' to create new directory
'  '-----------------------------------
'  fnK32 = FileName.FindInSystemSearchPath("kernel32.dll")
'  dllk32 = DLL.Make(fnK32)
'  procCD = DLLProc.Make(dllk32,"CreateDirectoryA",#DLLPROC_TYPE_INT32,{#DLLPROC_TYPE_STR,#DLLPROC_TYPE_POINTER})
'  strDirNew = dirTmp.asString + chrSep + "~sdmtemp"
Dim strDirNew As String
36: strDirNew = dirTmp + chrSep + "~sdmtemp"
'  strAtt = ""
Dim strAtt As String
39: strAtt = ""
'  dirNew = procCD.Call({strDirNew,strAtt}
Dim dirNew As String
Dim fs As Object
43: Set fs = CreateObject("Scripting.FileSystemObject")
44: If (Not fs.folderExists(strDirNew)) Then
45:     fs.CreateFolder (strDirNew)
46:     dirNew = strDirNew
47: Else
'  If (dirNew = 0) Then
'    MsgBox.Error("Unable to create directory " + strDirNew + "." +NL+
'                 "Please check write permissions.","Make Directory")
'    return Nil
'  End
'elseif (os = #SYSTEM_OS_UNIX) then
'  ' elseif UNIX, use command line to create new directory
'  '-----------------------------------
'  dirNew = dirTmp.asString + chrSep + "~sdmtemp"
'  System.Execute ("mkdir " + dirNew)
'End
59:     dirNew = strDirNew
60: End If
'av.Run("Project.Save",{})
''Clean up
''---------------
'dllk32 = Nil
'procCD = Nil
'av.PurgeObjects
'return dirNew
68: gSDI_MakeTempDir = dirNew
'
End Function

