VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "gSDI_MakeThmWgtTab"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = True
Option Explicit
Const c_sModuleFileName As String = "gSDI_MakeThmWgtTab.cls"
Const c_sDLLFileName As String = "AnalysisParameters"       ' Constant reflect file module name
'Private ObjectTag As Object
'Property Set setObjectTag(anObject As Object)
'    Set ObjectTag = anObject
'End Property
'Property Get getObjectTag() As Object
'    Set getObjectTag = ObjectTag
'End Property

Function gSDI_MakeThmWgtTab(ByRef argList As SDMList) As Collection

On Error GoTo ErrorHandler
15: Set gSDI_MakeThmWgtTab = New Collection
'PUT THE IMPLEMENTATION HERE >>>>>>>>>>>>>
'' Name:  gSDI.MakeThmWgtTab
''        makethmw.ave
''
'' Title:
''
'' Topics:  Spatial Data Modeller; Tables; dBase format
''
'' Description:  Creates the individual evidential theme
''               weights table
''
'' Requires:  a type of weights table
''            the name of a theme to be used as evidence table
''            both required elements are strings used to create default
''            table/.dbf file name
''
'' Self
''
'' Returns:  a vtab with predefined fields and no dat
''======================================================================
''MAKE A TABLE TO HOLD CALULCATIONS
''----------------------------------
''MAKE THE FILE NAME FOR THE DBF FILE
''----------------------------------
'tabType = self.Get(0)        'type of weights table
Dim tabtype As String
'Dim tabtypes As SDMList
'Set tabtypes = argList.Gett(0)
44: tabtype = argList.GetVal(0)
'If (tabType = "Cat") Then
46: If (tabtype = "Cat") Then
'  tT = "CT"
        Dim tT As String
49:     tT = "CT"
'  tTitle = "Categorical"
        Dim tTitle As String
52:     tTitle = "Categorical"
'ElseIf (tabType = "CuD") Then
54: ElseIf (tabtype = "CuD") Then
'  tT = "CA"
56:     tT = "CA"
'  tTitle = "Cumulative (Ascending)"
58:     tTitle = "Cumulative (Ascending)"
'ElseIf (tabType = "CuU") Then
60: ElseIf (tabtype = "CuU") Then
'  tT = "CD"
62:    tT = "CD"
'  tTitle = "Cumulative (Descending)"
64:     tTitle = "Cumulative (Descending)"
'End
66: End If
'eMapName = self.Get(1)        'name of theme to be used as evidence map
    Dim emapname As String
69: emapname = argList.GetVal(1)
'If (eMapName.Right(4) = ".shp") Then
'  eMapName = eMapName.Left(eMapName.Count - 4)
'End
'badCharList = {" ","\","/","|","?","<",">",":","*"}
'Dim badCharList As Variant
'badCharList = Array(" ", "\", "/", "|", "?", "<", ">", ":", "*")
'eMapName = eMapName.substitute(ch, "_")
'Dim ch As Variant
'Dim i As Integer
'Dim j As Integer
'Dim newstr As String
'newstr = ""
'For j = 0 To Len(eMapName) - 1
'    Dim char As String
'    char = Mid(eMapName, j, 1)
'    For i = 0 To 8
'        If (char = badCharList(i)) Then
'            newstr = newstr & badCharList(i)
'            Exit For
'        End If
'        newstr = newstr & char
'    Next i
'Next j
'eMapName = newstr

'emField = self.Get(2)
    Dim emField As IField
97: Set emField = argList.getObj(2)
'descField = self.Get(3)
    Dim descField As IField
'Desc = self.Get(4)
101: Set descField = argList.getObj(3) 'Different args sequence
     Dim Desc As Boolean
103: Desc = (Not descField Is Nothing)

'Dim theWorkspace As IWorkspace
'106: Set theWorkspace = SDMGlobals.SDMWorkspace
'tabFileName = FileDialog.Put((eMapName+"-"+tT+".dbf").AsFileName,"*.dbf","Save "+tTitle+" Weights Table")
'Dim flbx As FileListBox
'Set flbx = SDMUtil.FileListing
'flbx.Parent.Caption = "Save " + tTitle + " Weights Table"
'flbx.FileName = eMapName + "-" + tT + ".dbf"
'flbx.Visible = True
'If evidence map is joined get destination table name
     Dim genfilename As String
     Dim eMap As IRasterLayer
116: Set eMap = SDMGlobals.SDMUtil.FindLayerByName(emapname)
     Dim dispTbl As IDisplayTable
118: Set dispTbl = eMap
     Dim emVTab As ITable
120: Set emVTab = dispTbl.DisplayTable
121: If TypeOf emVTab Is IRelQueryTable Then
122:     genfilename = "_GenTable"
123: Else
124:     genfilename = ""
125: End If
     Dim tabFilename As String
127: tabFilename = emapname & genfilename & "_" & tT & ".dbf"
'If (tabFileName = nil) Then
'  return "Cancel"
'End

     Dim theVTab As ITable
     Dim anSATable As IStandaloneTable

135: Set anSATable = SDMUtil.FindStandAloneTableByName(emapname & "_" & tT)
     Dim TableUtils As SDMTableUtils
137: Set TableUtils = New SDMTableUtils
138: If (Not anSATable Is Nothing) Then
139:     TableUtils.RemoveTable anSATable, SDMApp
140: End If

'MAKE A VTAB WITH SPECIFIED FILE NAME
' IF CAN'T ADD FIELDS, RETURN
'----------------------------------
'theVtab = VTab.MakeNew(tabFileName, dBASE)
'if (theVTab.CanAddFields.Not) then
'  return "Nofields"
'end

''MAKE FIELDS
''----------------------------------
'fieldList = list.Make
     Dim fieldList As New Collection
'ClassField = Field.Make("Class", emField.GetType, emField.GetWidth, emField.GetPrecision)
     Dim ClassField As Variant
156: ClassField = Array("Class", esriFieldTypeInteger, 4, 0, "", False)
'fieldList.Add (ClassField)
158: fieldList.Add ClassField
'If (Desc) Then
160: If (Desc) Then

'  dField = Field.Make(descField.GetName, descField.GetType, descField.GetWidth, descField.GetPrecision)
     Dim tokens As Variant
     Dim descFieldName As String
165:     tokens = Split(descField.Name, ".", -1)
166:     descFieldName = tokens(UBound(tokens))
     Dim dField As Variant
168:     dField = Array(descFieldName, esriFieldTypeString, 12, 0, descField.AliasName, False)
'  dField.SetAlias (descField.GetAlias)
'  fieldList.Add (dField)
171:     fieldList.Add dField
'End
173: End If
'areaField = Field.Make("Area Sq km)",#FIELD_DECIMAL,10,4)
     Dim AreaField As Variant
176: AreaField = Array("Area Sq km", esriFieldTypeDouble, 12, 4, "Area (Sq km)", False)
'AreaField.SetAlias ("Area (Sq. km)")
'fieldList.Add (AreaField)
179: fieldList.Add AreaField
'ucAreaField = Field.Make("Area Units",#FIELD_DECIMAL,10,4)
     Dim ucAreaField As Variant
182: ucAreaField = Array("Area Units", esriFieldTypeInteger, 12, 0, "Area (Units)", False)
'ucAreaField.SetAlias ("Area (Units)")
'fieldList.Add (ucAreaField)
185: fieldList.Add ucAreaField
'pointField = Field.Make("No Points",#FIELD_LONG,4,0)
     Dim pointField As Variant
188: pointField = Array("#Points", esriFieldTypeInteger, 4, 0, "No. Points", False)
'pointField.SetAlias ("#Points")
'fieldList.Add (pointField)
191: fieldList.Add pointField
'weightPField = Field.Make("Wplus",#FIELD_DECIMAL,10,4)
     Dim weightPField As Variant
194: weightPField = Array("W+", esriFieldTypeDouble, 8, 4, "Weight +", True)
'weightPField.SetAlias ("W+")
'fieldList.Add (weightPField)
197: fieldList.Add weightPField
'sdWtPField = Field.Make("s Wplus",#FIELD_DECIMAL,10,4)
     Dim sdWtPField As Variant
200: sdWtPField = Array("s(W+)", esriFieldTypeDouble, 8, 4, "s Weight +", True)
'sdWtPField.SetAlias ("s(W+)")
'fieldList.Add (sdWtPField)
203: fieldList.Add sdWtPField
'weightMField = Field.Make("Wminus",#FIELD_DECIMAL,10,4)
     Dim weightMField As Variant
206: weightMField = Array("W-", esriFieldTypeDouble, 8, 4, "Weight -", True)
'weightMField.SetAlias ("W-")
'fieldList.Add (weightMField)
209: fieldList.Add weightMField
'sdWtMField = Field.Make("s Wminus",#FIELD_DECIMAL,10,4)
     Dim sdWtMField As Variant
212: sdWtMField = Array("s(W-)", esriFieldTypeDouble, 8, 4, "s Weight -", True)
'sdWtMField.SetAlias ("s(W-)")
'fieldList.Add (sdWtMField)
215: fieldList.Add sdWtMField
'contrastField = Field.Make("Contrast",#FIELD_DECIMAL,10,4)
     Dim contrastField As Variant
218: contrastField = Array("C", esriFieldTypeDouble, 8, 4, "Contrast", True)
'fieldList.Add (contrastField)
220: fieldList.Add contrastField
'sdCField = Field.Make("s Contrast",#FIELD_DECIMAL,10,4)
     Dim sdCField As Variant
223: sdCField = Array("s(C)", esriFieldTypeDouble, 8, 4, "s Contrast", True)
'sdCField.SetAlias ("s(C)")
'fieldList.Add (sdCField)
226: fieldList.Add sdCField
'sdCtField = Field.Make("stud Cnt",#FIELD_DECIMAL,10,4)
     Dim sdCtField As Variant
229: sdCtField = Array("stud(C)", esriFieldTypeDouble, 8, 4, "stud Cnt", True)
'sdCtField.SetAlias ("stud(C)")
'fieldList.Add (sdCtField)
232: fieldList.Add sdCtField

     Dim getPrjDir As gSDI_getProjectDir
235: Set getPrjDir = New gSDI_getProjectDir
     Dim prjDir As String
237: prjDir = getPrjDir.gSDI_getProjectDir
     Dim output As Variant
239: output = FileDialog.GetSaveFileName("Select a path for " & tTitle & " Table", prjDir, tabFilename)
240: If IsEmpty(output) Then
241:    gSDI_MakeThmWgtTab.Add "Cancel"
        Exit Function
243: End If
244: tabFilename = output(0)
     Dim outputDir As String
246: outputDir = output(1)
247: Set theVTab = WOETableUtils.CreateTable(tabFilename, outputDir, fieldList, CBool(output(2)))
248: If (theVTab Is Nothing) Then
249:    gSDI_MakeThmWgtTab.Add "Nofields"
        Exit Function
251: End If

'Add table to Document
'tableUtils.AddTable outputDir & "\" & tabfilename, emapname & "-" & tT, SDMApp
     Dim tblColl As ITableCollection
256: Set tblColl = SDMUtil.getMap
257: tblColl.AddTable theVTab
258: WOETableUtils.SetAliases FileDialog.GetBaseName(tabFilename), fieldList

'Save args and exit
267: gSDI_MakeThmWgtTab.Add "OK"
268: gSDI_MakeThmWgtTab.Add theVTab

'<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
Exit Function

ErrorHandler:
  HandleError True, "gSDI_MakeThmWgtTab " & c_sModuleFileName & vbCrLf & GetErrorLineNumberString(Erl), Err.Number, Err.Source, Err.Description, 4
275:   gSDI_MakeThmWgtTab.Add "Cancel"
End Function
