VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "gSDI_Param_Update"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = True
Option Explicit

' Variables used by the Error handler function - DO NOT REMOVE

Const c_sModuleFileName As String = "gSDI_Param_Update"       ' Constant reflect file module name

Function gSDI_Param_Update() As Boolean

On Error GoTo ErrorHandler

'Dim ae As IAVAnalysisEnvironment
'Dim spAnlystUtil As SpatialAnalystUtil
'Dim ae As IRasterAnalysisEnvironment
Dim are2ET As Boolean
'Dim av As New IAVApplication
'Dim gP As New IAVDialog
Dim isET As Boolean
Dim isNTP As Boolean
Dim isSA As Boolean
Dim isTab As Boolean
Dim isTP As Boolean
Dim isUA As Boolean
Dim isWV As Boolean
Dim lstET As SDMList
Dim msk As IGeoDataset
Dim nmbTabs As SDMList
Dim otp As SDMList
Dim thmNTPname As String
Dim thmNTP As ILayer 'New IAVFTheme
Dim thmSA As ILayer
Dim thmSAName As String
Dim thmTPName As String
Dim thmTP As ILayer 'New IAVFTheme
Dim txtUA As String
'Dim viewA As New IAVView
'Dim args As Variant
Dim idx As Integer
Dim pMxApp As IApplication
Dim pMxDoc As IMxDocument
Dim pMap As IMap
Dim pLayer As IGeoDataset
Dim gSDIGetEThemes As gSDI_GetEThemes

44: Set pMxApp = SDMGlobals.SDMApp
45: Set pMxDoc = pMxApp.Document
46: Set pMap = pMxDoc.FocusMap

'Dim self As Variant

' gSDI_Param_Update
' And the parameters in the object tag are: (drum roll please...)
' 0 -- list -- string: name of active view document
'              boolean: is chkWofE (weights of evidence check box) selected
'              boolean: is radWEDD (data driven weights of evidence radio button) selected
'              boolean: is radExpt (expert weights of evidence radio button) selected
'              boolean: is chkLR (logistic regression check box) selected
'              boolean: is chkNNSup (RBFLN (supervised) neural network checkbox) selected
'              boolean: is chkNNUns (fuzzy clustering (unsupervised) neural network checkbox) selected
'              boolean: is chkFL (fuzzy logic checkbox) selected
' 1 --
' Set analysis parameters... is always enabled
'-------------------------------------------

'self.SetEnabled (True)
65: gSDI_Param_Update = True
' Script checks parameter requirements of
' all other menu items and stores in object tag list
'-------------------------------------------

'Set gP = av.FindDialog(gParam)

'Set otP = gP.GetObjectTag
73: Set otp = gParam.getObjectTag 'Collection Only
74: If (Not TypeOf otp Is SDMList) Then
    Exit Function
76: End If

' isSA -- an analysis mask is set that matches the SA grid theme
'-------------------------------------------
'Set ae = viewA.Super.GetExtension(AnalysisEnvironment)
'
'MsgBox "doing set isSA..."
'Set msk = ae.GetMask
Dim getMask As gSDI_GetMask
85: Set getMask = New gSDI_GetMask
86:  Set msk = getMask.gSDI_GetMask
87: If (msk Is Nothing) Then
88:     isSA = False
89: Else
'thmSA = gP.FindByName("cbxSA").GetCurrentValue
91:     thmSAName = gParam.cbxSA.List(gParam.cbxSA.ListIndex)
92:     If (thmSAName = "") Then
93:         isSA = False
94:     Else
'    'If (TypeOf thmSA Is IAVString) Then
'        'Set thmSA = viewA.FindTheme("thmSA")
97:         Set thmSA = SDMUtil.FindLayerByName(thmSAName)
'    'End If
99:         If (Not thmSA Is Nothing) Then
'    'If (TypeOf thmSA Is IAVGTheme) Then
101:             If (TypeOf thmSA Is IRasterLayer) Then
102:                 If (thmSA Is msk) Then
103:                     isSA = True
104:                 Else
105:                     isSA = False
106:                 End If
107:             Else
108:                 isSA = False
109:             End If
110:         End If
111:     End If
112: End If
'
114: If (otp.Count < 7) Then
115:     otp.Add isSA
116: Else
117:     otp.SetIt 6, isSA
118: End If
'
'' isTP -- is there a training point theme that can be found in the active view
''-------------------------------------------
'MsgBox "doing set isTP..."
''thmTP = gP.FindByName("cbxTP").GetCurrentValue
124: If (gParam.cbxTP.text = "") Then
125:     isTP = False
126: Else
127:     thmTPName = gParam.cbxTP.List(gParam.cbxTP.ListIndex)
''If (TypeOf thmTP Is IAVString) Then
''    Set thmTP = viewA.FindTheme("thmTP")
''End If
131:     Set thmTP = SDMUtil.FindLayerByName(thmTPName)
132:     If (Not thmTP Is Nothing) Then
''isTP = TypeOf thmTP Is IAVFTheme
134:         isTP = TypeOf thmTP Is IFeatureLayer
135:     Else
136:         isTP = False
137:     End If
'
139: End If
140: If (otp.Count < 8) Then
141:     otp.Add isTP
142: Else
143:     otp.SetIt 7, isTP
144: End If
'
'isUA -- is there a valid unit area set
'-------------------------------------------
'MsgBox "doing set isUA..."
'txtUA = gP.FindByName("txtUA").GetText
150: txtUA = gParam.txtUA.text
151: If (Not IsNumeric(txtUA)) Then
152:     isUA = False
153: Else
154:     If (CInt(txtUA) > 0) Then
155:         isUA = True
156:     Else
157:         isUA = False
158:     End If
159: End If
160: If (otp.Count < 9) Then
161:     otp.Add isUA
162: Else
163:     otp.SetIt 8, isUA
164: End If

'' isET -- is at least one evidential theme in the active view
''-------------------------------------------
'MsgBox "doing set isET..."
'Set lstET = av.Run("gSDI.GetEThemes", Array(viewA))
'MsgBox "Doing getETheme"
171: Set gSDIGetEThemes = New gSDI_GetEThemes
172: Set lstET = gSDIGetEThemes.gSDI_GetEThemes
'Set lstET = New Collection 'temp assignment
'
175: If (Not TypeOf lstET Is SDMList) Then
176:     isET = False
177: ElseIf (lstET.Count = 0) Then
178:     isET = False
179: Else
180:     isET = True
181: End If
'
183: If (otp.Count < 10) Then
184:     otp.Add isET
185: Else
186:     otp.SetIt 9, isET
187: End If

'
' nmbTabs --
'MsgBox "doing set isTab..."
'Set nmbTabs = av.Run("gSDI.ChtMenu.Update", Array())
Dim gSDIChtMenuUpdate As gSDI_ChtMenu_Update
194: Set gSDIChtMenuUpdate = New gSDI_ChtMenu_Update
195: Set gSDIChtMenuUpdate.setMap = pMap
196: Set nmbTabs = gSDIChtMenuUpdate.gSDI_ChtMenu_Update

198: If (Not TypeOf nmbTabs Is SDMList) Then
199:     isTab = False
200: Else
201:     If (Not nmbTabs.Count = 0) Then
202:         isTab = True
203:     Else
204:         isTab = False
205:     End If
206: End If

208: If (otp.Count < 11) Then
209:     otp.Add isTab
210: Else
211:     otp.SetIt 10, isTab
212: End If
'
' are2ET -- At least 2 evidential themes
'-------------------------------------------
'MsgBox "doing set are2ET..."
217: If (lstET.Count > 1) Then
218:     are2ET = True
219: Else
220:     are2ET = False
221: End If
222: If (otp.Count < 12) Then
223:     otp.Add (are2ET)
224: Else
225:     otp.SetIt 11, are2ET
226: End If


'' isWV -- at least one each of woe table and variance table
''-------------------------------------------
'MsgBox "doing set isWV..."
'isWV = av.Run("gSDI.AreWoeVarTabs", Array())
Dim gSDIAreWoeVarTabs As gSDI_AreWoeVarTabs
234: Set gSDIAreWoeVarTabs = New gSDI_AreWoeVarTabs
235: isWV = gSDIAreWoeVarTabs.gSDI_AreWoeVarTabs(pMap)

237: If (otp.Count < 13) Then
238:     otp.Add isWV
239: Else
240:     otp.SetIt 12, isWV
241: End If

''isNTP -- requirements for non-deposit training theme met
''-------------------------------------------
'MsgBox "doing set isNTP..."
'thmNTP = gP.FindByName("cbxNTP").GetCurrentValue
247: If (gParam.cbxNTP.text = "") Then
248:     isNTP = False
249: Else
'If (TypeOf thmNTP Is IAVString) Then
'    thmNTP = viewA.FindTheme("thmNTP")
'End If
253:     thmNTPname = gParam.cbxNTP.List(gParam.cbxNTP.ListIndex)
254:     Set thmNTP = SDMUtil.FindLayerByName(thmNTPname)
255:     If (Not thmNTP Is Nothing) Then
256:     If (TypeOf thmNTP Is IFeatureLayer) Then
257:         isNTP = True
258:     Else
259:         isNTP = False
260:     End If
261:     End If
262: End If
'
264: If (otp.Count < 14) Then
265:     otp.Add isNTP
266: Else
267:     otp.SetIt 13, isNTP
268: End If

''>>>>>>>>>>>>>> Not implemented in AVENUE Script
''isClst -- valid number of clusters
''nmbClst = gP.FindByName("txtClst").GetText
'if (nmbClst.IsNumber.Not) then
'  isClst = False
'else
'  isClst = nmbClst.AsNumber > 0
'end
'
'if (otP.Count < 15) then
'  otP.Add(isClst)
'else
'  otP.Set(14,isClst)
'end
'>>>>>>>>>>>>>>>>>>>>>>

'Save object tab
287: Set gParam.setObjectTag = otp

'Clean up
290: Set pMxApp = Nothing
291: Set lstET = Nothing
292: Set gSDIGetEThemes = Nothing
293: Set gSDIAreWoeVarTabs = Nothing
294: Set gSDIChtMenuUpdate = Nothing

Exit Function

ErrorHandler:
  HandleError True, "AnalysisParameters " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), Err.Number, Err.Source, Err.Description, 4
End Function

