VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "gSDI_ReadLRresults"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = True
Option Explicit
Const c_sModuleFileName As String = "gSDI_ReadLRResults"
Const c_sDLLFileName As String = "CalculateLogisticRegr"       ' Constant reflect file module name
'''''Private Declare Function CloseHandle Lib "kernel32" (ByVal hObject As Long) As Long
'''''Private Declare Function CreateFile Lib "kernel32" Alias "CreateFileA" _
'''''    (ByVal lpFileName As String, ByVal dwDesiredAccess As Long, _
'''''     ByVal dwShareMode As Long, lpSecurityAttributes As Long, _
'''''     ByVal dwCreationDisposition As Long, ByVal dwFlagsAndAttributes As Long, _
'''''     ByVal hTemplateFile As Long) As Long

Function gSDI_ReadLRResults(Self As Variant) As Boolean
  On Error GoTo ErrorHandler
'PUT THE IMPLEMENTATION HERE >>>>>>>>>>>>>
'' Name:  gSDI.ReadLRresults
''
'' Topics:  Spatial Data Modeller
''
'' Description:  Reads the text file produced
''       by the logistic regression code and
''       writes a new dBase file in the
''       user specified location.  Adds this
''       dBase file to the project and joins
''       it to the unique conditions table.
''
'' Requires:
''
'' Self:    0 -- dirTmp -- the temporary directory
''          1 -- vTabUC -- unique condition table vtab
''          2 -- ot -- list of theme, field, value names saved as
''                     object tag of the unique conditions theme
'' Returns:
''==============================================

''dirTmp = self.Get(0)
'vTabUC = Self.Get(1)
Dim vTabUC As ITable
37: Set vTabUC = Self(1)
'ot = Self.Get(2)
Dim thmUC As IRasterLayer
40: Set thmUC = Self(3)
Dim ot As SDMUtilities.SDMList
42: Set ot = Self(2)
'strFN = "logpol.tba"
Dim strFN As String
45: strFN = "logpol.tba"
'strFN2 = "logco.dat"
Dim strFN2 As String
48: strFN2 = "logco.dat"

'' Make table to hold logistic regression results
''----------------------------------------------
'strNew = fileName.GetCWD.MakeTmp("logpol", "dbf")
Dim strFileName As IFileName
54: Set strFileName = WOETableUtils.MakeTmp(WOETableUtils.getProjectDir, thmUC.Name & "_logpol", "dbf")
Dim strNew As String
56: strNew = FileDialog.GetFileName(strFileName.path)
'fnNew = FileDialog.Put(strNew, "*.dbf", "Logistic Regression Output Table")
Dim fnNew As Variant
59: fnNew = FileDialog.GetSaveFileName("Logistic Regression Output Table", _
                FileDialog.getDir(strFileName.path), strNew)
'If (fnNew = Nil) Then
62: If IsEmpty(fnNew) Then
'  return Nil
64:     gSDI_ReadLRResults = False
        Exit Function
'End
67: End If
'sepChr = av.Run("gSDI.GetSeparatorChar",{})
'dirTmp = av.Run("gSDI.GetTmpDir",{})
Dim dirTmp As String
71: dirTmp = WOETableUtils.GetTmpDir
'' Get text file that contains LR results, and open for reading
''----------------------------------------------

'strFnLR = (dirTmp.AsString + sepChr + strFN)
'fnK32 = fileName.FindInSystemSearchPath("kernel32.dll")
'k32DLL = DLL.Make(fnK32)
'crteF = DLLProc.Make(k32DLL,"CreateFileA",#DLLPROC_TYPE_INT32,{#DLLPROC_TYPE_STR, #DLLPROC_TYPE_INT32,
'                                         #DLLPROC_TYPE_INT32,#DLLPROC_TYPE_INT32 ,#DLLPROC_TYPE_INT32,
'                                         #DLLPROC_TYPE_INT32,#DLLPROC_TYPE_INT32})
'x = crteF.Call({strFnLR,0,2,0,3,14,0})
'While (X = -1)
'  x = crteF.Call({strFnLR,0,2,0,3,14,0})
'End
'If (X <> -1) Then
'  clsH = DLLProc.Make(k32DLL,"CloseHandle",#DLLPROC_TYPE_INT32,{#DLLPROC_TYPE_INT32})
'  reslt = clsH.Call({x})
'End
'clsH = Nil
'crteF = Nil
'k32DLL = Nil
'av.PurgeObjects
'fnLR = strFnLR.AsFileName
'If (file.Exists(fnLR).Not) Then
    Dim FnLR As String
96: FnLR = dirTmp & "\" & strFN
97: If Not FileDialog.ExistsFilename(FnLR) Then
'  MsgBox.Error("Could not find file " + fnLR.AsString + ".","Reading Logistic Regression Results")
99:     MsgBox "Could not find file " & FnLR & ".", vbCritical, "Reading Logistic Regression Results"
'  return Nil
101:     gSDI_ReadLRResults = False
        Exit Function
'End
104: End If
'fLR = LineFile.Make(fnLR,#FILE_PERM_READ)
'''''Dim fLR As Object
'''''Set fLR = FileDialog.CreateReadLineFile(fnLR)
     Dim fLR As Integer
109: fLR = FreeFile
110: Open FnLR For Input Access Read As #fLR
'i = 0
'av.UseWaitCursor
'While (fLR = Nil)
'  fLR = LineFile.Make(fnLR,#FILE_PERM_READ)
'  i = i + 1
'  If (i = 50000) Then
'    MsgBox.Error("Unable to open the file " + fnLR.AsString + " for reading.","Input Error")
'    return Nil
'  End
'End
'If flr Is Nothing Then
'         MsgBox "Unable to open the file " & fnLR & " for reading.", vbCritical, "Input Error"
'        Exit Function
'End If

'Read = False
Dim Read As Boolean
128: Read = False
'' Make the new vtab
''----------------------------------------------
'
'vTabLR = VTab.MakeNew(fnNew, dBase)
Dim vTabLR As ITable
'fldID = Field.Make("ID",#FIELD_LONG,6,0)
Dim fldsDesc As New Collection
136: fldsDesc.Add Array("ID", esriFieldTypeInteger, 6, 0, "", False)
'fldPP = Field.Make("LRPostProb",#FIELD_DECIMAL,16,8)
'fldPP.SetAlias ("LR Posterior Probability")
139: fldsDesc.Add Array("LRPostProb", esriFieldTypeDouble, 16, 8, "LR Posterior Probability", False)
'fldSD = Field.Make("LR_Std_Dev",#FIELD_DECIMAL,16,8)
'fldSD.SetAlias ("LR Standard Deviation")
142: fldsDesc.Add Array("LR_Std_Dev", esriFieldTypeDouble, 16, 8, "LR Standard Deviation", False)
'fldTB = Field.Make("LRTValue",#FIELD_DECIMAL,16,8)
'fldTB.SetAlias ("LR TValue")
145: fldsDesc.Add Array("LRTValue", esriFieldTypeDouble, 16, 8, "LR TValue", False)
'vTabLR.AddFields({fldID,fldPP,fldTB,fldSD})
147: Set vTabLR = WOETableUtils.CreateTable(FileDialog.GetBaseName(CStr(fnNew(0))), CStr(fnNew(1)), fldsDesc, CBool(fnNew(2)))
148: WOETableUtils.AddTable CStr(fnNew(1)), CStr(fnNew(0)), SDMGlobals.SDMApp
149: WOETableUtils.SetAliases FileDialog.GetBaseName(CStr(fnNew(0))), fldsDesc
Dim fldID As Long
151: fldID = vTabLR.FindField("ID")
Dim fldPP As Long
153: fldPP = vTabLR.FindField("LRPostProb")
Dim fldTB As Long
155: fldTB = vTabLR.FindField("LRTValue")
Dim fldSD As Long
157: fldSD = vTabLR.FindField("LR_Std_Dev")
'strLine = fLR.ReadElt
'ttl = vTabUC.GetNumRecords
'i = 1
'Percent = (i / ttl) * 100
'av.SetStatus (Percent)
        Dim pProgbar As IStepProgressor
164:   Set pProgbar = SDMGlobals.SDMStatusBar.ProgressBar
165:   pProgbar.Position = 0
166:   SDMGlobals.SDMStatusBar.ShowProgressBar "Reading LR logpol...", 1, LOF(fLR), 1, True

'' Start reading text file after "DATA" string
''----------------------------------------------

Dim pWks As IWorkspace
Dim pWksEdit As IWorkspaceEdit
173: Set pWksEdit = FeatureUtils.startEditing(FileDialog.getProjectDir)
'While (strLine <> Nil)
175:     Do While Not EOF(fLR)
        Dim strLine As String
177:         Line Input #fLR, strLine
'  If (strLine.Trim = "DATA") Then
179:     If Trim(strLine) = "DATA" Then
180:         If (strLine Like "*NaN*") Or (strLine Like "*Inf*") Then
181:             gSDI_ReadLRResults = False
182:             MsgBox "Results from SDMLR.EXE:" & FnLR & " contains overflow calculation errors" & vbCrLf & _
                        "Aborting Logistic Regression calculations", vbCritical, "Reading LR Results"
                    Exit Function
185:         End If
'    Read = True
187:         Read = True
'  ElseIf (Read) Then
189:     ElseIf Read Then
'    r = vTabLR.AddRecord
             Dim r As IRow
192:         Set r = vTabLR.CreateRow
'    lstLine = strLine.AsTokens(" ")
             Dim lstLine As Variant
195:              lstLine = Tokenize(strLine, " ")
'    If (lstLine.Count > 5) Then
197:         If UBound(lstLine) > 4 Then
'      vTabLR.SetValue(fldID,r,lstLine.Get(1).Trim.AsNumber)
199:             r.Value(fldID) = CLng(Trim(lstLine(1)))
'      vTabLR.SetValue(fldPP,r,lstLine.Get(3).Trim.AsNumber)
201:             r.Value(fldPP) = CDbl(Trim(lstLine(3)))
'      vTabLR.SetValue(fldTB,r,lstLine.Get(4).Trim.AsNumber)
203:             r.Value(fldTB) = CDbl(Trim(lstLine(4)))
'      vTabLR.SetValue(fldSD,r,lstLine.Get(5).Trim.AsNumber)
205:             r.Value(fldSD) = CDbl(Trim(lstLine(5)))
'    End
207:         End If
208:          r.Store
'  End
210:     End If
'  strLine = fLR.ReadElt
'  i = i + 1
'  av.SetStatus ((i / ttl) * 100)
214:     SDMGlobals.SDMStatusBar.StepProgressBar
'End
216: Loop
217: SDMGlobals.SDMStatusBar.HideProgressBar

'fLR.Close
220: Close fLR
'vTabLR.SetEditable (False)
222: FeatureUtils.StopEditing pWksEdit
'vTabLR.Flush
'vTabLR.Refresh
'av.ClearStatus
'' Make table document, add to project and join to unique conditions grid.
''----------------------------------------------
'tabLR = Table.Make(vTabLR)
Dim tabLR As IStandaloneTable
230: Set tabLR = New StandaloneTable
231: Set tabLR.Table = vTabLR
Dim pDSet As IDataset
233: Set pDSet = vTabLR
'tabLR.SetName(av.Run("gSDI.GetNewDocName",{"Logistic Regression","Table"}))
Dim gSDIGetNewDocName As gSDI_GetNewDocName
236: Set gSDIGetNewDocName = New gSDI_GetNewDocName
'''Don't rename because Post processing needs to see joined table in TOC
'''231: tabLR.Name = gSDIGetNewDocName.gSDI_GetNewDocNameTable(Array("Logistic Regression", "Table"))
'''        Dim saTblColl As IStandaloneTableCollection
'''233:    Set saTblColl = SDMGlobals.SDMMap
'''234:    saTblColl.AddStandaloneTable tabLR

'>>>>> Comments cmts0 stored in tables tablR
'>>>>> Comments cmts1 stored in tabLR2
'>>>>> Comments comments stored in ARCSDM commanditem "Spatial Data Modeller"
'cmts0 = "Generated by: Arc-SDM - Calculate Response Theme" + NL +
'        "Logistic Regression Table" + NL +
'        "Source: " + vTabLR.GetBaseTableFilename.GetFullName & vbcrlf &
'        nl "Associated Files: " + nl
''Dim cmts0 As String
''236: cmts0 = "Generated by: Arc-SDM - Calculate Response Theme" & vbCrLf & _
''        "Logistic Regression Table" & vbCrLf & _
''        "Source: " + pDSet.Name & vbCrLf & _
''        "Associated Files: " & vbCrLf
''
'''mnuSDM = av.Run("gSDI.GetSDMMenu",{})
''    Dim gSDIGetSDMMenu As gSDI_GetSDMMenu
''243: Set gSDIGetSDMMenu = New gSDI_GetSDMMenu
''    Dim mnuSDM As ICommandItem
''245: Set mnuSDM = gSDIGetSDMMenu.gSDI_GetSDMMenu
'''If (mnuSDM.Is(Menu)) Then
''247: If Not mnuSDM Is Nothing Then
'''  comments = mnuSDM.GetTag
''        Dim comments As String
''250:     comments = mnuSDM.Tag
'''  lstCmts = comments.AsTokens("*")
''         Dim lstCmts As Variant
''253:     Set lstCmts = Split(comments, "*")
'''  If (lstCmts.Count = 2) Then
''255:     If UBound(lstCmts) = 1 Then
'''    nmThmUC = lstCmts.Get(0)
''        Dim nmThmUC As String
''258:         nmThmUC = lstCmts(0)
'''    rest = lstCmts.Get(1)
''        Dim rest As String
''261:         rest = lstCmts(1)
'''    srcThmUC = rest.Extract(11)
''        Dim extract As Variant
''264:         extract = Split(rest)
''        Dim srcThmUC As String
''266:         If UBound(extract) > 11 Then srcThmUC = extract(11)
'''    cmts0 = cmts0 + "    Unique Conditions Theme:  " + nmThmUC + " (Source: " + srcThmUC + ")" + nl
''268:         cmts0 = cmts0 & "    Unique Conditions Theme:  " & nmThmUC & " (Source: " & srcThmUC & ")" & vbCrLf
'''  Else
''270:     Else
'''    nmThmUC = ""
''272:         nmThmUC = ""
'''    srcThmUC = ""
''274:         srcThmUC = ""
'''  End
''276:     End If
'''End
''278: End If

'vTabUC.Join(vTAbUC.GetFields.Get(0),vTabLR,vTabLR.FindField("ID"))
296:    WOETableUtils.joinTableToLayer thmUC, "Value", tabLR, "ID"
        'MsgBox thmUC.Name & " has joins: " & WOETableUtils.hasJoins(thmUC), , c_sModuleFileName
298:    ProgressAnimation.Show "Processing coefficients table..."
'' Get the coefficients file
''----------------------------------------------
'fnNew2 = fileName.GetCWD.MakeTmp("lrcoefnt", "dbf")
     Dim fnNew2Fn As IFileName
303:      Set fnNew2Fn = WOETableUtils.MakeTmp(WOETableUtils.getProjectDir, thmUC.Name & "_lrcoefnt", "dbf")
'fnNew2 = FileDialog.Put(fnNew2, "*.dbf", "Logistic Regression Coefficients Table")
     Dim fnNew2 As Variant
306: fnNew2 = FileDialog.GetSaveFileName("Logistic Regression Coefficients Table", _
        FileDialog.getDir(fnNew2Fn.path), FileDialog.GetFileName(fnNew2Fn.path))
'If (fnNew2 <> Nil) Then
309: If Not IsEmpty(fnNew2) Then
'  'av.Run("gSDI.WriteLRCoefficients",{dirTmp,sepChr,strFN2,ot,fnNew2,fldSD
'  fnLR2 = (dirTmp.AsString + sepChr + strFN2.AsString).AsFileName
         Dim fnLR2 As String
313:     fnLR2 = dirTmp & "\" & strFN2
'  If (file.Exists(fnLR2).Not) Then
315:     If Not FileDialog.ExistsFilename(fnLR2) Then
'    MsgBox.Error("Could not find file " + fnLR2.AsString + ".","Reading Logistic Regression Results")
317:         MsgBox "Could not find file " & fnLR2 & ".", vbCritical, "Reading Logistic Regression Results"
'    return Nil
319:         gSDI_ReadLRResults = False
             Exit Function
'  End
322:     End If
    
'  ' Open file for reading
'  '----------------------------------------------
'  fLR2 = LineFile.Make(fnLR2,#FILE_PERM_READ)
         Dim flr2 As Integer
328:     flr2 = FreeFile
329:     Open fnLR2 For Input Access Read As #flr2
330:     If EOF(flr2) Then
331:         MsgBox "Logistic Regression file is Empty: " & fnLR2, vbCritical, "Reading Logistic Regression Results"
332:         gSDI_ReadLRResults = False
             Exit Function
334:     End If

'  i = 0
'  av.UseWaitCursor
'  While (fLR2 = Nil)
'318:     If flr2 Is Nothing Then
'    fLR2 = LineFile.Make(fnLR2,#FILE_PERM_READ)
'    i = i + 1
'    If (i = 50000) Then
'      MsgBox.Error("Unable to open the file " + fnLR2.AsString + " for reading.","Input Error")
'      return Nil
''''324:         gSDI_ReadLRResults = False
''''            Exit Function
'    End
''''327:     End If
'  End
'
351:   Read = False
'
'  ' Expand object tag list of theme, field, value combos
'  '----------------------------------------------
'  lstLabels = List.Make
         Dim lstlabels As New SDMUtilities.SDMList
'  For Each el In ot
         Dim elvar As Variant
359:     For Each elvar In ot.list
            Dim el As SDMList
361:        Set el = elvar
'    For Each e In el
             Dim e As Variant
364:         For Each e In el.list
'      lstLabels.Add (e)
366:             lstlabels.Add CStr(e)
'    End
368:         Next e
'  End
370:     Next elvar

'  ' Make vtab to hold theme coefficients
'  '----------------------------------------------
'  vTabLR2 = VTab.MakeNew(fnNew2, dBase)
         Dim vTabLR2 As ITable
376:     Set fldsDesc = New Collection
'  fldID2 = Field.Make("Theme_ID",#FIELD_LONG,6,0)
'  fldID2.SetAlias ("Theme ID")
379:     fldsDesc.Add Array("Theme_ID", esriFieldTypeInteger, 6, 0, "Theme ID", False)
'  fldThm = Field.Make("Theme",#FIELD_CHAR,30,0)
'  fldThm.SetAlias ("Evidential Theme")
382:     fldsDesc.Add Array("Theme", esriFieldTypeString, 48, 0, "Evidential Theme", False)
'  fldC = Field.Make("Coefficient",#FIELD_DECIMAL,14,6)
384:     fldsDesc.Add Array("Coefficien", esriFieldTypeDouble, 14, 6, "Coefficient", False)
'  fldSD2 = Field.Make("LR_Std_Dev",#FIELD_DECIMAL,14,6)
'  fldSD2.SetAlias ("LR Standard Deviation")
387:     fldsDesc.Add Array("LR_Std_Dev", esriFieldTypeDouble, 14, 6, "LR Standard Deviation", False)
'  vTabLR2.AddFields({fldID2,fldThm,fldC,fldSD2})
389:     Set vTabLR2 = WOETableUtils.CreateTable(FileDialog.GetBaseName(CStr(fnNew2(0))), CStr(fnNew2(1)), fldsDesc, CBool(fnNew2(2)))
390:     WOETableUtils.AddTable CStr(fnNew2(1)), FileDialog.GetBaseName(CStr(fnNew2(0))), SDMGlobals.SDMApp
391:     WOETableUtils.SetAliases FileDialog.GetBaseName(CStr(fnNew2(0))), fldsDesc
        Dim fldID2 As Long
393:     fldID2 = vTabLR2.FindField("Theme_ID")
        Dim fldThm As Long
395:     fldThm = vTabLR2.FindField("Theme")
        Dim fldC As Long
397:     fldC = vTabLR2.FindField("Coefficien")
        Dim fldSD2 As Long
399:     fldSD2 = vTabLR2.FindField("LR_Std_Dev")

401: ProgressAnimation.Hide
'>>>> Read table and parse after "pattern" line
'  strLine = fLR2.ReadElt
404:     Line Input #flr2, strLine 'Table of logistic....
'  i = 0
         Dim i As Long
407:     i = 0
'  First = True
         Dim First As Boolean
410:     First = True
411:     Set pWksEdit = FeatureUtils.startEditing(CStr(fnNew2(1)))
'  While (strLine <> Nil)
413:     pProgbar.Position = 0
414:     SDMGlobals.SDMStatusBar.ShowProgressBar "Reading LR logcoef Results...", 1, LOF(flr2), 1, True

416:     Do While Not EOF(flr2)
'    If (strLine.AsTokens(" ").Count > 1) Then
            Dim tokens As Variant
419:         tokens = Tokenize(strLine, " ")
420:         If UBound(tokens) > 0 Then
'      If (strLine.AsTokens(" ").Get(0).Trim = "pattern") Then
422:             If Trim(tokens(0)) = "pattern" Then
'        Read = True
424:                 Read = True
'        strLine = fLR2.ReadElt
426:                 Line Input #flr2, strLine
'        Continue
428:                 GoTo nextLoop
'      End
430:             End If
'    End
432:         End If
'    If (Read) Then
434:         If Read Then
'      lstLine = strLine.AsTokens(" ")
436:             lstLine = Tokenize(strLine, " ")
'      If (lstLine.Count > 2) Then
438:             If UBound(lstLine) > 1 Then
'        r = vTabLR2.AddRecord
440:                 Set r = vTabLR2.CreateRow
'        vTabLR2.SetValue(fldID2,r,lstLine.Get(0).Trim.AsNumber + 1)
442:                 r.Value(fldID2) = CLng(Trim(lstLine(0))) + 1
'        If (First.Not) Then
444:                 If Not First Then
'          vTabLR2.SetValue(fldThm,r,lstLabels.Get(i))
446:                     r.Value(fldThm) = lstlabels.GetVal(i)
'          i = i + 1
448:                     i = i + 1
'        Else
450:                 Else
'          vTabLR2.SetValue(fldThm,r,"Constant Value")
452:                     r.Value(fldThm) = "Constant Value"
'          First = False
454:                     First = False
'        End
456:                 End If
'        vTabLR2.SetValue(fldC,r,lstLine.Get(1).Trim.AsNumber)
458:                 r.Value(fldC) = CDbl(Trim(lstLine(1)))
'        vTabLR2.SetValue(fldSD2,r,lstLine.Get(2).Trim.AsNumber)
460:                 r.Value(fldSD2) = CDbl(Trim(lstLine(2)))
461:                 r.Store
'      Else
463:             Else
'        Break
465:                 Exit Do
'      End
467:             End If
'    End
469:         End If
'    strLine = fLR2.ReadElt
471:         Line Input #flr2, strLine
472:        SDMGlobals.SDMStatusBar.StepProgressBar
'  End
nextLoop:
475:     Loop
476:    SDMGlobals.SDMStatusBar.HideProgressBar
'  fLR2.Close
478:     Close flr2
'
'  vTabLR2.SetEditable (False)
481:    FeatureUtils.StopEditing pWksEdit
'  vTabLR2.Flush
'  vTabLR2.Refresh
'  tabLR2 = Table.Make(vTabLR2)
''        Dim tabLR2 As IStandaloneTable
''472:    Set tabLR2 = New StandaloneTable
''473:    Set tabLR2.Table = vTabLR2
'  tabLR2.SetName(av.Run("gSDI.GetNewDocName",{"LR Table of Coefficients","Table"}))
''475:    tabLR2.Name = gSDIGetNewDocName.gSDI_GetNewDocNameTable(Array("LR Table of Coefficients", "Table"))
        'Dim saTblColl As IStandaloneTableCollection
''477:    Set saTblColl = SDMGlobals.SDMMap
''478:    saTblColl.AddStandaloneTable tabLR2
'  cmts1 = "Generated by: Arc-SDM - Calculate Response Theme" + NL +
'          "Logistic Regression Table of Coefficients" + NL +
'          "Source: " + vTabLR2.GetBaseTableFilename.GetFullName + NL +
'          nl "Associated Files: " + nl
''        Dim cmtS1 As String
''474:    cmtS1 = "Generated by: Arc-SDM - Calculate Response Theme" & vbCrLf & _
''          "Logistic Regression Table of Coefficients" & vbCrLf & _
''          "Source: " + tabLR2.Name & vbCrLf & _
''          "Associated Files: " & vbCrLf
'''
'''  If (mnuSDM.Is(Menu)) Then
''480:    If Not mnuSDM Is Nothing Then
'''    If (nmThmUC <> "") Then
''482:        If nmThmUC <> "" Then
'''      cmts1 = cmts1 + "    Unique Conditions Theme: " + nmThmUC + " (Source: " + srcThmUC + ")" + nl
''484:            cmtS1 = cmtS1 & "    Unique Conditions Theme: " & nmThmUC & " (Source: " & srcThmUC & ")" & vbCrLf
'''    End
''486:        End If
'''  End
''488:    End If
'''  cmts1 = cmts1 + "    Logistic Regression Table: " + tabLR.GetName + " (Source: " + vTabLR.GetBaseTableFilename.GetFullName + ")" + nl
''490:    cmtS1 = cmtS1 & "    Logistic Regression Table: " & tabLR.Name & " (Source: " & pDSet.Name & ")" & vbCrLf
'''  tabLR2.SetComments (cmts1)
'''  cmts0 = cmts0 + "    Table of Coefficients: " + tabLR2.GetName + " (Source: " + vTabLR2.GetBaseTableFilename.GetFullName + ")" + nl
''493:    cmts0 = cmts0 & "    Table of Coefficients: " & tabLR2.Name & " (Source: " & pDSet.Name & ")" & vbCrLf
'''  tabLR.SetComments (cmts0)
'''  If (mnuSDM.Is(Menu)) Then
''496:    If Not mnuSDM Is Nothing Then
'''    comments = comments + "    Logistic Regression Table:  " + tabLR.GetName + " (Source: " + vTabLR.GetBaseTableFilename.GetFullName + ")" + NL +
'''               "    LR Table of Coefficients:  " + tabLR2.GetName + " (Source: " + vTabLR2.GetBaseTableFilename.GetFullName + ")" + NL
''499:        comments = comments & "    Logistic Regression Table:  " & tabLR.Name + " (Source: " + pDSet.Name & ")" & vbCrLf & _
''               "    LR Table of Coefficients:  " & tabLR2.Name & " (Source: " & pDSet.Name & ")" & vbCrLf
'''    mnuSDM.SetTag (comments)
''502:         mnuSDM.Tag = comments
'''  End
''504:    End If
'End
530: End If
531: gSDI_ReadLRResults = True
'<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
Exit Function
ErrorHandler:
  HandleError True, c_sModuleFileName & " " & GetErrorLineNumberString(Erl), Err.Number, Err.Source, Err.Description, 4
536:   gSDI_ReadLRResults = False
End Function

Private Function extract(src As String, n As Long) As String
    Dim tokens As Variant
541:     tokens = Split(src)
542:     If n <= UBound(tokens) Then
543:         extract = tokens(n)
544:     Else
545:         extract = ""
546:     End If
End Function
Private Function Tokenize(S As String, delim As String) As Variant
    Dim tokens As String
    Dim i As Long
551:     S = Trim(S)
552:     For i = 1 To Len(S)
553:         If Mid(S, i, 2) <> delim & delim Then
554:             tokens = tokens & Mid(S, i, 1)
555:         End If
556:     Next i
557:     Tokenize = Split(tokens, delim)
End Function

