VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "gSDI_RemoveUCThms"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = True
Option Explicit
Const c_sModuleFileName As String = "gSDI_RemoveUCThms"
Const c_sDLLFileName As String = "CalculateResponse"       ' Constant reflect file module name
'Private ObjectTag As Object
'Property Set setObjectTag(anObject As Object)
'    Set ObjectTag = anObject
'End Property
'Property Get getObjectTag() As Object
'    Set getObjectTag = ObjectTag
'End Property

Function gSDI_RemoveUCThms(ByRef Self As Variant) As SDMUtilities.SDMList
  On Error GoTo ErrorHandler

'PUT THE IMPLEMENTATION HERE >>>>>>>>>>>>>
'' gSDI.RemoveUCThms
'' Topics:  Spatial Data Modeller
'' Description:  Removes any apparent unique
''         condition themes from a list of
''         integer grid themes.
''
'' Requires:
'' Self:  0 -- lstGThm -- list of integer grid themes
'' Returns:  lstGThm -- modified list of int grid thms
''==============================================
'lstGThm = self.Get(0)
Dim lstGThm As SDMUtilities.SDMList
28: Set lstGThm = Self(0)
'lstGThm2 = lstGThm.Clone
Dim lstGThm2 As SDMUtilities.SDMList
31: Set lstGThm2 = lstGThm.Clone
'For Each t In lstGThm2
Dim i As Long
34: For i = 0 To lstGThm2.Count - 1
        Dim t As IRasterLayer
36:     Set t = lstGThm2.getObj(i)
'  If (t.GetGrid.IsInteger) Then
        Dim tProps As IRasterProps
39:     Set tProps = RasterUtils.GetDatasetRaster(t)
40:     If tProps.IsInteger Then
41:         If UCase(t.Name) Like "SDM*" Then
42:             ListUtils.RemoveObj t, lstGThm
43:         Else
                Dim vTabG As ITable
45:             Set vTabG = RasterUtils.GetTable(t)
                Dim fldRAST As Long
47:             fldRAST = vTabG.FindField("Count") + 1
48:             If fldRAST < vTabG.Fields.FieldCount Then
                    Dim fldName As String
50:                 fldName = vTabG.Fields.Field(fldRAST).Name
51:             End If
52:         End If
53:     End If
54: Next i
'    vTabG = av.Run("gSDI.GetVTab",{t})
'    If (vTabG = Nil) Then
'      Continue
'    End
'    fldTP = vTabG.FindField("Area_sqm")
'    If (fldTP = Nil) Then
'      Continue
'    Else
'      fldVal = vTabG.FindField("Value")
'      If (fldVal <> Nil) Then
'        fldCnt = vTabG.FindField("Count")
'        If (fldCnt <> Nil) Then
'          lstFldUC = vTabG.GetFields
'          lstFldUC2 = lstFldUC.Clone
'          lstFldUC2.RemoveObj (fldVal)
'MsgBox lstFldUC2.list.Count
'MsgBox lstFldUC2.list.Count
'          lstFldUC2.RemoveObj (fldCnt)
'MsgBox lstFldUC2.list.Count
'          idx = lstFldUC2.Find(fldTP)
'          If (idx <> -1) Then
'            for each n in idx..(lstFldUC2.Count - 1)
'              lstFldUC2.Remove (idx)
'            End
'          End
'          For Each fld In lstFldUC2
'            viewA = av.GetActiveDoc
'            thm = viewA.FindTheme(fld.GetName.BasicTrim("", "_"))
'            If (thm <> -1) Then
'              lstGThm.RemoveObj (t)
'              Break
'            End
'          End
'        End
'      End
'    End
'  End
'End
'return lstGThm
94: Set gSDI_RemoveUCThms = lstGThm
'<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
Exit Function
ErrorHandler:
  HandleError True, c_sModuleFileName & " " & GetErrorLineNumberString(Erl), Err.Number, Err.Source, Err.Description, 4
End Function

Private Function BasicTrim(sIn As String, l As String, r As String)
    Dim s As String
103:     s = Trim(sIn)
104:     While Left(s, 1) = l
105:         s = Right(s, Len(s) - 1)
106:     Wend
107:     While Right(s, 1) = r
108:         s = Left(s, Len(s) - 1)
109:     Wend
110:     BasicTrim = s
End Function
