VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "gSDI_RunGeoXplorCode"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = True
Option Explicit
Const c_sModuleFileName As String = "gSDI_RunGeoXplorCode"
Const c_sDLLFileName As String = "CalculateNeuralNetwork"       ' Constant reflect file module name
'Private ObjectTag As Object
'Property Set setObjectTag(anObject As Object)
'    Set ObjectTag = anObject
'End Property
'Property Get getObjectTag() As Object
'    Set getObjectTag = ObjectTag
'End Property

Function gSDI_RunGeoXplorCode(Self As Variant) As Boolean
  On Error GoTo ErrorHandler

' If Form1.isShiftdown Then
'    SDMGlobals.SDMHelp.gSDI_Help "sdmpram.htm#LINK"
'    Exit Sub
' End If

'PUT THE IMPLEMENTATION HERE >>>>>>>>>>>>>
'' Name:  gSDI.RunGeoXplorCode
'
'' Topics:  Spatial Data Modeller
''
'' Description:  Launches the GeoXplore program
''          from the SDM interface.
''
'' Requires:
''
'' Self:    0 -- dirTmp -- directory for batch file
''          1 -- dirTmp -- directory for lr program
''
'' Returns:
''==============================================
'
'If (System.IsShiftKeyDown) Then
'  docURL = "sdmnn4.htm#Run"
'  If (docURL.Count > 0) Then
'    av.Run("gSDI.Help", {docURL})
'  End
'  return Nil
'End
'chrSep = av.Run("gSDI.GetSeparatorChar",{})
'strProgFN = "$AVEXT".AsFileName.GetFullName + chrSep + "GeoXplore.exe"

Dim dxpHome As String
47: dxpHome = GetSetting("SDMExtension", "Globals", "GeoXploreHome", "")
48: If dxpHome = "" Then
49:     If FileDialog.ExistsFilename("C:\Program Files\ArcSDMExtension\GeoXplore12.exe") Then
50:         dxpHome = "C:\Program Files\ArcSDMExtension"
51:         SaveSetting "SDMExtension", "Globals", "DataXploreHome", dxpHome
52:     End If
53: End If
            
55: If dxpHome = "" Then
56:     dxpHome = Environ("DXPHOME")
57:     If Len(dxpHome) = 0 Then
58:         dxpHome = returnFolderName("Find folder with GeoXplore12.exe", "C:\Program Files", "GeoXplore12.exe")
59:         If dxpHome = "" Then
60:             MsgBox "GeoXplore12.exe not found." & vbCrLf & "Running Neural Network is cancelled.", vbExclamation, c_sModuleFileName
61:             gSDI_RunGeoXplorCode = False
                Exit Function
63:         Else
64:             SaveSetting "SDMExtension", "Globals", "GeoXploreHome", dxpHome
65:         End If

67:     End If
68: End If
    Dim strProgFN As String
70:     strProgFN = dxpHome & "\GeoXplore12.exe"
'If (File.Exists(strProgFN.AsFileName).Not) Then
72:     If Not FileDialog.ExistsFilename(strProgFN) Then
'  MsgBox.Error("The file " + strProgFN + " could not be found.","File Not Found")
74:         MsgBox "GeoXplore program ='' " & strProgFN & "'' could not be found."", vbCritical, c_sModuleFileName"
75:         DeleteSetting "SDMExtension", "Globals", "GeoXploreHome"
'  return Nil
77:         gSDI_RunGeoXplorCode = False
        Exit Function
'End
80:     End If

'System.Execute (strProgFN)
Dim RetVal
84: RetVal = Shell(strProgFN, 1)   ' Run GeoXplore
'return True
86: gSDI_RunGeoXplorCode = RetVal = 0
'<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
Exit Function
ErrorHandler:
  HandleError True, c_sModuleFileName & " " & GetErrorLineNumberString(Erl), Err.Number, Err.Source, Err.Description, 4
End Function
Public Function returnFolderName(tTitle As String, prjDir As String, tabFilename As String) As String
  On Error GoTo ErrorHandler

    Dim fileDlg As CommonDialog
96:     Set fileDlg = FileDialog2.CommonDialog1
97:     fileDlg.DialogTitle = tTitle
98:     fileDlg.InitDir = prjDir
99:     fileDlg.fileName = tabFilename
100:     fileDlg.DefaultExt = "exe"
101:     fileDlg.Filter = "Executable (*.exe)|*.exe"
102:     fileDlg.CancelError = True
103:     fileDlg.Flags = cdlOFNPathMustExist
104:     fileDlg.ShowSave
105:         If IsEmpty(fileDlg.fileName) Then
106:             returnFolderName = ""
                Exit Function
108:         End If
        Dim fs As Object
110:     Set fs = CreateObject("Scripting.FileSystemObject")
        Dim aDir As String
112:     aDir = fs.getParentFolderName(fileDlg.fileName)
113:     returnFolderName = aDir
  Exit Function
ErrorHandler:
116:     If Err.Number = cdlCancel Then
117:         returnFolderName = Empty
        Exit Function
119:     End If
  HandleError True, "returnFolderName " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), Err.Number, Err.Source, Err.Description, 4
121:   returnFolderName = ""
End Function

