VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "gSDI_RunNNCode"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = True
Option Explicit
Const c_sModuleFileName As String = "gSDI_RunNNCode"
Const c_sDLLFileName As String = "CalculateNeuralNetwork"       ' Constant reflect file module name
'Private ObjectTag As Object
'Property Set setObjectTag(anObject As Object)
'    Set ObjectTag = anObject
'End Property
'Property Get getObjectTag() As Object
'    Set getObjectTag = ObjectTag
'End Property

Function gSDI_RunNNCode(Self As Variant) As Boolean
  On Error GoTo ErrorHandler

' If Form1.isShiftdown Then
'    SDMGlobals.SDMHelp.gSDI_Help "sdmpram.htm#LINK"
'    Exit Sub
' End If

'PUT THE IMPLEMENTATION HERE >>>>>>>>>>>>>
'' Name:  gSDI.RunNNCode
'
'' Topics:  Spatial Data Modeller
''
'' Description:  Launches the DataXplore program
''          from the SDM interface.
''
'' Requires:
''
'' Self:    0 -- dirTmp -- directory for batch file
''          1 -- dirTmp -- directory for lr program
''
'' Returns:
''==============================================
'
'If (System.IsShiftKeyDown) Then
'  docURL = "sdmnn4.htm#Run"
'  If (docURL.Count > 0) Then
'    av.Run("gSDI.Help", {docURL})
'  End
'  return Nil
'End
'chrSep = av.Run("gSDI.GetSeparatorChar",{})
'strProgFN = "$AVEXT".AsFileName.GetFullName + chrSep + "DataXplore.exe"

Dim dxpHome As String
47: dxpHome = GetSetting("SDMExtension", "Globals", "DataXploreHome", "")
48: If dxpHome = "" Then
49:     If FileDialog.ExistsFilename("C:\Program Files\ArcSDMExtension\DataXplore.exe") Then
50:         dxpHome = "C:\Program Files\ArcSDMExtension"
51:         SaveSetting "SDMExtension", "Globals", "DataXploreHome", dxpHome
52:     End If
53: End If
            
55: If dxpHome = "" Then
56:     dxpHome = Environ("DXPHOME")
57:     If Len(dxpHome) = 0 Then
58:         dxpHome = returnFolderName("Find folder with DataXplore.exe", "C:\Program Files", "DataXplore.exe")
59:         If dxpHome = "" Then
60:             MsgBox "DataXplore.exe not found." & vbCrLf & "Running Neural Network is cancelled.", vbExclamation, c_sModuleFileName
61:             gSDI_RunNNCode = False
            Exit Function
63:         Else
64:             SaveSetting "SDMExtension", "Globals", "DataXploreHome", dxpHome
65:         End If
66:     End If
67: End If
    Dim strProgFN As String
69:     strProgFN = dxpHome & "\DataXplore.exe"
'If (File.Exists(strProgFN.AsFileName).Not) Then
71:     If Not FileDialog.ExistsFilename(strProgFN) Then
'  MsgBox.Error("The file " + strProgFN + " could not be found.","File Not Found")
73:         MsgBox "DataXplore program ='' " & strProgFN & "'' could not be found."", vbCritical, c_sModuleFileName"
74:         DeleteSetting "SDMExtension", "Globals", "DataXploreHome"
'  return Nil
76:         gSDI_RunNNCode = False
        Exit Function
'End
79:     End If

'System.Execute (strProgFN)
Dim RetVal
83: RetVal = Shell(strProgFN, 1)   ' Run DataXplore
'return True
85: gSDI_RunNNCode = RetVal = 0
'<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
Exit Function
ErrorHandler:
  HandleError True, c_sModuleFileName & " " & GetErrorLineNumberString(Erl), Err.Number, Err.Source, Err.Description, 4
End Function
Public Function returnFolderName(tTitle As String, prjDir As String, tabFilename As String) As String
  On Error GoTo ErrorHandler

    Dim fileDlg As CommonDialog
95:     Set fileDlg = FileDialog2.CommonDialog1
96:     fileDlg.DialogTitle = tTitle
97:     fileDlg.InitDir = prjDir
98:     fileDlg.fileName = tabFilename
99:     fileDlg.DefaultExt = "exe"
100:     fileDlg.Filter = "Executable (*.exe)|*.exe"
101:     fileDlg.CancelError = True
102:     fileDlg.Flags = cdlOFNPathMustExist
103:     fileDlg.ShowSave
104:         If IsEmpty(fileDlg.fileName) Then
105:             returnFolderName = ""
                Exit Function
107:         End If
        Dim fs As Object
109:     Set fs = CreateObject("Scripting.FileSystemObject")
        Dim aDir As String
111:     aDir = fs.getParentFolderName(fileDlg.fileName)
112:     returnFolderName = aDir
  Exit Function
ErrorHandler:
115:     If Err.Number = cdlCancel Then
116:         returnFolderName = Empty
        Exit Function
118:     End If
  HandleError True, "returnFolderName " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), Err.Number, Err.Source, Err.Description, 4
120:   returnFolderName = ""
End Function

