VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "gSDI_getMask"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = True
Option Explicit
' Variables used by the Error handler function - DO NOT REMOVE

Const c_sModuleFileName As String = "gSDI_getMask"       ' Constant reflect file module name

Function gSDI_GetMask() As IGeoDataset
    On Error GoTo ErrorHandler

'Dim ae As New IAVDocumentExtension
'Dim self As Collection
'Dim thmSA As New IAVGTheme
'Dim viewA As New IAVView
'
'' gSDI.GetMask
'viewA = self.Get(0)
'ae = viewA.GetExtension(AnalysisEnvironment)
'If (ae = Null) Then
'Let gSDI_GetMask = Null
'End If
'ae.Activate

'>>>>>>>>>>>> ArcSDM does not use Spatial Analysis Options to set
'>>>>>>>>>>>> its AnalysisEnvironment.  Uses study area grid mask,
'>>>>>>>>>>>> cellsize, and extent.

Dim saName As String
27: saName = gParam.cbxSA.text
28: If saName = "" Then
29:     Set gSDI_GetMask = Nothing
    Exit Function
31: End If
    Dim saMask As IRasterLayer
33: Set saMask = WOETableUtils.FindLayerByName(saName)
34: If saMask Is Nothing Then
35:     Set gSDI_GetMask = Nothing
36: Else
37:     Set gSDI_GetMask = saMask
38: End If
Exit Function

ErrorHandler:
  HandleError True, "AnalysisParameters-" & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), Err.Number, Err.Source, Err.Description, 4
43:     Set gSDI_GetMask = Nothing
End Function

